# WARNING ABOUT GENERATED CODE
#
# This file is generated. See the contributing guide for more information:
# https://github.com/aws/aws-sdk-ruby/blob/master/CONTRIBUTING.md
#
# WARNING ABOUT GENERATED CODE

module Aws::EC2
  module Types

    # Contains the parameters for accepting the quote.
    #
    # @note When making an API call, you may pass AcceptReservedInstancesExchangeQuoteRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         reserved_instance_ids: ["ReservationId"], # required
    #         target_configurations: [
    #           {
    #             instance_count: 1,
    #             offering_id: "ReservedInstancesOfferingId", # required
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] reserved_instance_ids
    #   The IDs of the Convertible Reserved Instances to exchange for
    #   another Convertible Reserved Instance of the same or higher value.
    #   @return [Array<String>]
    #
    # @!attribute [rw] target_configurations
    #   The configuration of the target Convertible Reserved Instance to
    #   exchange for your current Convertible Reserved Instances.
    #   @return [Array<Types::TargetConfigurationRequest>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AcceptReservedInstancesExchangeQuoteRequest AWS API Documentation
    #
    class AcceptReservedInstancesExchangeQuoteRequest < Struct.new(
      :dry_run,
      :reserved_instance_ids,
      :target_configurations)
      include Aws::Structure
    end

    # The result of the exchange and whether it was `successful`.
    #
    # @!attribute [rw] exchange_id
    #   The ID of the successful exchange.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AcceptReservedInstancesExchangeQuoteResult AWS API Documentation
    #
    class AcceptReservedInstancesExchangeQuoteResult < Struct.new(
      :exchange_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AcceptTransitGatewayPeeringAttachmentRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_attachment_id: "TransitGatewayAttachmentId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the transit gateway attachment.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AcceptTransitGatewayPeeringAttachmentRequest AWS API Documentation
    #
    class AcceptTransitGatewayPeeringAttachmentRequest < Struct.new(
      :transit_gateway_attachment_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_peering_attachment
    #   The transit gateway peering attachment.
    #   @return [Types::TransitGatewayPeeringAttachment]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AcceptTransitGatewayPeeringAttachmentResult AWS API Documentation
    #
    class AcceptTransitGatewayPeeringAttachmentResult < Struct.new(
      :transit_gateway_peering_attachment)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AcceptTransitGatewayVpcAttachmentRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_attachment_id: "TransitGatewayAttachmentId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AcceptTransitGatewayVpcAttachmentRequest AWS API Documentation
    #
    class AcceptTransitGatewayVpcAttachmentRequest < Struct.new(
      :transit_gateway_attachment_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_vpc_attachment
    #   The VPC attachment.
    #   @return [Types::TransitGatewayVpcAttachment]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AcceptTransitGatewayVpcAttachmentResult AWS API Documentation
    #
    class AcceptTransitGatewayVpcAttachmentResult < Struct.new(
      :transit_gateway_vpc_attachment)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AcceptVpcEndpointConnectionsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         service_id: "VpcEndpointServiceId", # required
    #         vpc_endpoint_ids: ["VpcEndpointId"], # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] service_id
    #   The ID of the VPC endpoint service.
    #   @return [String]
    #
    # @!attribute [rw] vpc_endpoint_ids
    #   The IDs of one or more interface VPC endpoints.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AcceptVpcEndpointConnectionsRequest AWS API Documentation
    #
    class AcceptVpcEndpointConnectionsRequest < Struct.new(
      :dry_run,
      :service_id,
      :vpc_endpoint_ids)
      include Aws::Structure
    end

    # @!attribute [rw] unsuccessful
    #   Information about the interface endpoints that were not accepted, if
    #   applicable.
    #   @return [Array<Types::UnsuccessfulItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AcceptVpcEndpointConnectionsResult AWS API Documentation
    #
    class AcceptVpcEndpointConnectionsResult < Struct.new(
      :unsuccessful)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AcceptVpcPeeringConnectionRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         vpc_peering_connection_id: "VpcPeeringConnectionId",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] vpc_peering_connection_id
    #   The ID of the VPC peering connection. You must specify this
    #   parameter in the request.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AcceptVpcPeeringConnectionRequest AWS API Documentation
    #
    class AcceptVpcPeeringConnectionRequest < Struct.new(
      :dry_run,
      :vpc_peering_connection_id)
      include Aws::Structure
    end

    # @!attribute [rw] vpc_peering_connection
    #   Information about the VPC peering connection.
    #   @return [Types::VpcPeeringConnection]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AcceptVpcPeeringConnectionResult AWS API Documentation
    #
    class AcceptVpcPeeringConnectionResult < Struct.new(
      :vpc_peering_connection)
      include Aws::Structure
    end

    # Describes an account attribute.
    #
    # @!attribute [rw] attribute_name
    #   The name of the account attribute.
    #   @return [String]
    #
    # @!attribute [rw] attribute_values
    #   The values for the account attribute.
    #   @return [Array<Types::AccountAttributeValue>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AccountAttribute AWS API Documentation
    #
    class AccountAttribute < Struct.new(
      :attribute_name,
      :attribute_values)
      include Aws::Structure
    end

    # Describes a value of an account attribute.
    #
    # @!attribute [rw] attribute_value
    #   The value of the attribute.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AccountAttributeValue AWS API Documentation
    #
    class AccountAttributeValue < Struct.new(
      :attribute_value)
      include Aws::Structure
    end

    # Describes a running instance in a Spot Fleet.
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   The instance type.
    #   @return [String]
    #
    # @!attribute [rw] spot_instance_request_id
    #   The ID of the Spot Instance request.
    #   @return [String]
    #
    # @!attribute [rw] instance_health
    #   The health status of the instance. If the status of either the
    #   instance status check or the system status check is `impaired`, the
    #   health status of the instance is `unhealthy`. Otherwise, the health
    #   status is `healthy`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ActiveInstance AWS API Documentation
    #
    class ActiveInstance < Struct.new(
      :instance_id,
      :instance_type,
      :spot_instance_request_id,
      :instance_health)
      include Aws::Structure
    end

    # Describes an Elastic IP address.
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance that the address is associated with (if any).
    #   @return [String]
    #
    # @!attribute [rw] public_ip
    #   The Elastic IP address.
    #   @return [String]
    #
    # @!attribute [rw] allocation_id
    #   The ID representing the allocation of the address for use with
    #   EC2-VPC.
    #   @return [String]
    #
    # @!attribute [rw] association_id
    #   The ID representing the association of the address with an instance
    #   in a VPC.
    #   @return [String]
    #
    # @!attribute [rw] domain
    #   Indicates whether this Elastic IP address is for use with instances
    #   in EC2-Classic (`standard`) or instances in a VPC (`vpc`).
    #   @return [String]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] network_interface_owner_id
    #   The ID of the AWS account that owns the network interface.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_address
    #   The private IP address associated with the Elastic IP address.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the Elastic IP address.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] public_ipv_4_pool
    #   The ID of an address pool.
    #   @return [String]
    #
    # @!attribute [rw] network_border_group
    #   The name of the location from which the IP address is advertised.
    #   @return [String]
    #
    # @!attribute [rw] customer_owned_ip
    #   The customer-owned IP address.
    #   @return [String]
    #
    # @!attribute [rw] customer_owned_ipv_4_pool
    #   The ID of the customer-owned address pool.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Address AWS API Documentation
    #
    class Address < Struct.new(
      :instance_id,
      :public_ip,
      :allocation_id,
      :association_id,
      :domain,
      :network_interface_id,
      :network_interface_owner_id,
      :private_ip_address,
      :tags,
      :public_ipv_4_pool,
      :network_border_group,
      :customer_owned_ip,
      :customer_owned_ipv_4_pool)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AdvertiseByoipCidrRequest
    #   data as a hash:
    #
    #       {
    #         cidr: "String", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] cidr
    #   The address range, in CIDR notation. This must be the exact range
    #   that you provisioned. You can't advertise only a portion of the
    #   provisioned range.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AdvertiseByoipCidrRequest AWS API Documentation
    #
    class AdvertiseByoipCidrRequest < Struct.new(
      :cidr,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] byoip_cidr
    #   Information about the address range.
    #   @return [Types::ByoipCidr]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AdvertiseByoipCidrResult AWS API Documentation
    #
    class AdvertiseByoipCidrResult < Struct.new(
      :byoip_cidr)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AllocateAddressRequest
    #   data as a hash:
    #
    #       {
    #         domain: "vpc", # accepts vpc, standard
    #         address: "String",
    #         public_ipv_4_pool: "String",
    #         network_border_group: "String",
    #         customer_owned_ipv_4_pool: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] domain
    #   Set to `vpc` to allocate the address for use with instances in a
    #   VPC.
    #
    #   Default: The address is for use with instances in EC2-Classic.
    #   @return [String]
    #
    # @!attribute [rw] address
    #   \[EC2-VPC\] The Elastic IP address to recover or an IPv4 address
    #   from an address pool.
    #   @return [String]
    #
    # @!attribute [rw] public_ipv_4_pool
    #   The ID of an address pool that you own. Use this parameter to let
    #   Amazon EC2 select an address from the address pool. To specify a
    #   specific address from the address pool, use the `Address` parameter
    #   instead.
    #   @return [String]
    #
    # @!attribute [rw] network_border_group
    #   The location from which the IP address is advertised. Use this
    #   parameter to limit the address to this location.
    #
    #   A network border group is a unique set of Availability Zones or
    #   Local Zones from where AWS advertises IP addresses and limits the
    #   addresses to the group. IP addresses cannot move between network
    #   border groups.
    #
    #   Use [DescribeAvailabilityZones][1] to view the network border
    #   groups.
    #
    #   <note markdown="1"> You cannot use a network border group with EC2 Classic. If you
    #   attempt this operation on EC2 classic, you will receive an
    #   `InvalidParameterCombination` error. For more information, see
    #   [Error Codes][2].
    #
    #    </note>
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_DescribeAvailabilityZones.html
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html
    #   @return [String]
    #
    # @!attribute [rw] customer_owned_ipv_4_pool
    #   The ID of a customer-owned address pool. Use this parameter to let
    #   Amazon EC2 select an address from the address pool. Alternatively,
    #   specify a specific address from the address pool.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AllocateAddressRequest AWS API Documentation
    #
    class AllocateAddressRequest < Struct.new(
      :domain,
      :address,
      :public_ipv_4_pool,
      :network_border_group,
      :customer_owned_ipv_4_pool,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] public_ip
    #   The Elastic IP address.
    #   @return [String]
    #
    # @!attribute [rw] allocation_id
    #   \[EC2-VPC\] The ID that AWS assigns to represent the allocation of
    #   the Elastic IP address for use with instances in a VPC.
    #   @return [String]
    #
    # @!attribute [rw] public_ipv_4_pool
    #   The ID of an address pool.
    #   @return [String]
    #
    # @!attribute [rw] network_border_group
    #   The location from which the IP address is advertised.
    #   @return [String]
    #
    # @!attribute [rw] domain
    #   Indicates whether this Elastic IP address is for use with instances
    #   in EC2-Classic (`standard`) or instances in a VPC (`vpc`).
    #   @return [String]
    #
    # @!attribute [rw] customer_owned_ip
    #   The customer-owned IP address.
    #   @return [String]
    #
    # @!attribute [rw] customer_owned_ipv_4_pool
    #   The ID of the customer-owned address pool.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AllocateAddressResult AWS API Documentation
    #
    class AllocateAddressResult < Struct.new(
      :public_ip,
      :allocation_id,
      :public_ipv_4_pool,
      :network_border_group,
      :domain,
      :customer_owned_ip,
      :customer_owned_ipv_4_pool)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AllocateHostsRequest
    #   data as a hash:
    #
    #       {
    #         auto_placement: "on", # accepts on, off
    #         availability_zone: "String", # required
    #         client_token: "String",
    #         instance_type: "String",
    #         instance_family: "String",
    #         quantity: 1, # required
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         host_recovery: "on", # accepts on, off
    #       }
    #
    # @!attribute [rw] auto_placement
    #   Indicates whether the host accepts any untargeted instance launches
    #   that match its instance type configuration, or if it only accepts
    #   Host tenancy instance launches that specify its unique host ID. For
    #   more information, see [ Understanding Instance Placement and Host
    #   Affinity][1] in the *Amazon EC2 User Guide for Linux Instances*.
    #
    #   Default: `on`
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/how-dedicated-hosts-work.html#dedicated-hosts-understanding
    #   @return [String]
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone in which to allocate the Dedicated Host.
    #   @return [String]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   Specifies the instance type to be supported by the Dedicated Hosts.
    #   If you specify an instance type, the Dedicated Hosts support
    #   instances of the specified instance type only.
    #
    #   If you want the Dedicated Hosts to support multiple instance types
    #   in a specific instance family, omit this parameter and specify
    #   **InstanceFamily** instead. You cannot specify **InstanceType** and
    #   **InstanceFamily** in the same request.
    #   @return [String]
    #
    # @!attribute [rw] instance_family
    #   Specifies the instance family to be supported by the Dedicated
    #   Hosts. If you specify an instance family, the Dedicated Hosts
    #   support multiple instance types within that instance family.
    #
    #   If you want the Dedicated Hosts to support a specific instance type
    #   only, omit this parameter and specify **InstanceType** instead. You
    #   cannot specify **InstanceFamily** and **InstanceType** in the same
    #   request.
    #   @return [String]
    #
    # @!attribute [rw] quantity
    #   The number of Dedicated Hosts to allocate to your account with these
    #   parameters.
    #   @return [Integer]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the Dedicated Host during creation.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] host_recovery
    #   Indicates whether to enable or disable host recovery for the
    #   Dedicated Host. Host recovery is disabled by default. For more
    #   information, see [ Host Recovery][1] in the *Amazon Elastic Compute
    #   Cloud User Guide*.
    #
    #   Default: `off`
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/dedicated-hosts-recovery.html
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AllocateHostsRequest AWS API Documentation
    #
    class AllocateHostsRequest < Struct.new(
      :auto_placement,
      :availability_zone,
      :client_token,
      :instance_type,
      :instance_family,
      :quantity,
      :tag_specifications,
      :host_recovery)
      include Aws::Structure
    end

    # Contains the output of AllocateHosts.
    #
    # @!attribute [rw] host_ids
    #   The ID of the allocated Dedicated Host. This is used to launch an
    #   instance onto a specific host.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AllocateHostsResult AWS API Documentation
    #
    class AllocateHostsResult < Struct.new(
      :host_ids)
      include Aws::Structure
    end

    # Describes a principal.
    #
    # @!attribute [rw] principal_type
    #   The type of principal.
    #   @return [String]
    #
    # @!attribute [rw] principal
    #   The Amazon Resource Name (ARN) of the principal.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AllowedPrincipal AWS API Documentation
    #
    class AllowedPrincipal < Struct.new(
      :principal_type,
      :principal)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ApplySecurityGroupsToClientVpnTargetNetworkRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         vpc_id: "VpcId", # required
    #         security_group_ids: ["SecurityGroupId"], # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC in which the associated target network is located.
    #   @return [String]
    #
    # @!attribute [rw] security_group_ids
    #   The IDs of the security groups to apply to the associated target
    #   network. Up to 5 security groups can be applied to an associated
    #   target network.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ApplySecurityGroupsToClientVpnTargetNetworkRequest AWS API Documentation
    #
    class ApplySecurityGroupsToClientVpnTargetNetworkRequest < Struct.new(
      :client_vpn_endpoint_id,
      :vpc_id,
      :security_group_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] security_group_ids
    #   The IDs of the applied security groups.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ApplySecurityGroupsToClientVpnTargetNetworkResult AWS API Documentation
    #
    class ApplySecurityGroupsToClientVpnTargetNetworkResult < Struct.new(
      :security_group_ids)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AssignIpv6AddressesRequest
    #   data as a hash:
    #
    #       {
    #         ipv_6_address_count: 1,
    #         ipv_6_addresses: ["String"],
    #         network_interface_id: "NetworkInterfaceId", # required
    #       }
    #
    # @!attribute [rw] ipv_6_address_count
    #   The number of IPv6 addresses to assign to the network interface.
    #   Amazon EC2 automatically selects the IPv6 addresses from the subnet
    #   range. You can't use this option if specifying specific IPv6
    #   addresses.
    #   @return [Integer]
    #
    # @!attribute [rw] ipv_6_addresses
    #   One or more specific IPv6 addresses to be assigned to the network
    #   interface. You can't use this option if you're specifying a number
    #   of IPv6 addresses.
    #   @return [Array<String>]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssignIpv6AddressesRequest AWS API Documentation
    #
    class AssignIpv6AddressesRequest < Struct.new(
      :ipv_6_address_count,
      :ipv_6_addresses,
      :network_interface_id)
      include Aws::Structure
    end

    # @!attribute [rw] assigned_ipv_6_addresses
    #   The IPv6 addresses assigned to the network interface.
    #   @return [Array<String>]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssignIpv6AddressesResult AWS API Documentation
    #
    class AssignIpv6AddressesResult < Struct.new(
      :assigned_ipv_6_addresses,
      :network_interface_id)
      include Aws::Structure
    end

    # Contains the parameters for AssignPrivateIpAddresses.
    #
    # @note When making an API call, you may pass AssignPrivateIpAddressesRequest
    #   data as a hash:
    #
    #       {
    #         allow_reassignment: false,
    #         network_interface_id: "NetworkInterfaceId", # required
    #         private_ip_addresses: ["String"],
    #         secondary_private_ip_address_count: 1,
    #       }
    #
    # @!attribute [rw] allow_reassignment
    #   Indicates whether to allow an IP address that is already assigned to
    #   another network interface or instance to be reassigned to the
    #   specified network interface.
    #   @return [Boolean]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_addresses
    #   One or more IP addresses to be assigned as a secondary private IP
    #   address to the network interface. You can't specify this parameter
    #   when also specifying a number of secondary IP addresses.
    #
    #   If you don't specify an IP address, Amazon EC2 automatically
    #   selects an IP address within the subnet range.
    #   @return [Array<String>]
    #
    # @!attribute [rw] secondary_private_ip_address_count
    #   The number of secondary IP addresses to assign to the network
    #   interface. You can't specify this parameter when also specifying
    #   private IP addresses.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssignPrivateIpAddressesRequest AWS API Documentation
    #
    class AssignPrivateIpAddressesRequest < Struct.new(
      :allow_reassignment,
      :network_interface_id,
      :private_ip_addresses,
      :secondary_private_ip_address_count)
      include Aws::Structure
    end

    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] assigned_private_ip_addresses
    #   The private IP addresses assigned to the network interface.
    #   @return [Array<Types::AssignedPrivateIpAddress>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssignPrivateIpAddressesResult AWS API Documentation
    #
    class AssignPrivateIpAddressesResult < Struct.new(
      :network_interface_id,
      :assigned_private_ip_addresses)
      include Aws::Structure
    end

    # Describes the private IP addresses assigned to a network interface.
    #
    # @!attribute [rw] private_ip_address
    #   The private IP address assigned to the network interface.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssignedPrivateIpAddress AWS API Documentation
    #
    class AssignedPrivateIpAddress < Struct.new(
      :private_ip_address)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AssociateAddressRequest
    #   data as a hash:
    #
    #       {
    #         allocation_id: "AllocationId",
    #         instance_id: "InstanceId",
    #         public_ip: "String",
    #         allow_reassociation: false,
    #         dry_run: false,
    #         network_interface_id: "NetworkInterfaceId",
    #         private_ip_address: "String",
    #       }
    #
    # @!attribute [rw] allocation_id
    #   \[EC2-VPC\] The allocation ID. This is required for EC2-VPC.
    #   @return [String]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance. This is required for EC2-Classic. For
    #   EC2-VPC, you can specify either the instance ID or the network
    #   interface ID, but not both. The operation fails if you specify an
    #   instance ID unless exactly one network interface is attached.
    #   @return [String]
    #
    # @!attribute [rw] public_ip
    #   The Elastic IP address to associate with the instance. This is
    #   required for EC2-Classic.
    #   @return [String]
    #
    # @!attribute [rw] allow_reassociation
    #   \[EC2-VPC\] For a VPC in an EC2-Classic account, specify true to
    #   allow an Elastic IP address that is already associated with an
    #   instance or network interface to be reassociated with the specified
    #   instance or network interface. Otherwise, the operation fails. In a
    #   VPC in an EC2-VPC-only account, reassociation is automatic,
    #   therefore you can specify false to ensure the operation fails if the
    #   Elastic IP address is already associated with another resource.
    #   @return [Boolean]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] network_interface_id
    #   \[EC2-VPC\] The ID of the network interface. If the instance has
    #   more than one network interface, you must specify a network
    #   interface ID.
    #
    #   For EC2-VPC, you can specify either the instance ID or the network
    #   interface ID, but not both.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_address
    #   \[EC2-VPC\] The primary or secondary private IP address to associate
    #   with the Elastic IP address. If no private IP address is specified,
    #   the Elastic IP address is associated with the primary private IP
    #   address.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateAddressRequest AWS API Documentation
    #
    class AssociateAddressRequest < Struct.new(
      :allocation_id,
      :instance_id,
      :public_ip,
      :allow_reassociation,
      :dry_run,
      :network_interface_id,
      :private_ip_address)
      include Aws::Structure
    end

    # @!attribute [rw] association_id
    #   \[EC2-VPC\] The ID that represents the association of the Elastic IP
    #   address with an instance.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateAddressResult AWS API Documentation
    #
    class AssociateAddressResult < Struct.new(
      :association_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AssociateClientVpnTargetNetworkRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         subnet_id: "SubnetId", # required
    #         client_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet to associate with the Client VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #   **A suitable default value is auto-generated.** You should normally
    #   not need to pass this option.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateClientVpnTargetNetworkRequest AWS API Documentation
    #
    class AssociateClientVpnTargetNetworkRequest < Struct.new(
      :client_vpn_endpoint_id,
      :subnet_id,
      :client_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] association_id
    #   The unique ID of the target network association.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The current state of the target network association.
    #   @return [Types::AssociationStatus]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateClientVpnTargetNetworkResult AWS API Documentation
    #
    class AssociateClientVpnTargetNetworkResult < Struct.new(
      :association_id,
      :status)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AssociateDhcpOptionsRequest
    #   data as a hash:
    #
    #       {
    #         dhcp_options_id: "DefaultingDhcpOptionsId", # required
    #         vpc_id: "VpcId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] dhcp_options_id
    #   The ID of the DHCP options set, or `default` to associate no DHCP
    #   options with the VPC.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateDhcpOptionsRequest AWS API Documentation
    #
    class AssociateDhcpOptionsRequest < Struct.new(
      :dhcp_options_id,
      :vpc_id,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AssociateIamInstanceProfileRequest
    #   data as a hash:
    #
    #       {
    #         iam_instance_profile: { # required
    #           arn: "String",
    #           name: "String",
    #         },
    #         instance_id: "InstanceId", # required
    #       }
    #
    # @!attribute [rw] iam_instance_profile
    #   The IAM instance profile.
    #   @return [Types::IamInstanceProfileSpecification]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateIamInstanceProfileRequest AWS API Documentation
    #
    class AssociateIamInstanceProfileRequest < Struct.new(
      :iam_instance_profile,
      :instance_id)
      include Aws::Structure
    end

    # @!attribute [rw] iam_instance_profile_association
    #   Information about the IAM instance profile association.
    #   @return [Types::IamInstanceProfileAssociation]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateIamInstanceProfileResult AWS API Documentation
    #
    class AssociateIamInstanceProfileResult < Struct.new(
      :iam_instance_profile_association)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AssociateRouteTableRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         route_table_id: "RouteTableId", # required
    #         subnet_id: "SubnetId",
    #         gateway_id: "RouteGatewayId",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] route_table_id
    #   The ID of the route table.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet.
    #   @return [String]
    #
    # @!attribute [rw] gateway_id
    #   The ID of the internet gateway or virtual private gateway.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateRouteTableRequest AWS API Documentation
    #
    class AssociateRouteTableRequest < Struct.new(
      :dry_run,
      :route_table_id,
      :subnet_id,
      :gateway_id)
      include Aws::Structure
    end

    # @!attribute [rw] association_id
    #   The route table association ID. This ID is required for
    #   disassociating the route table.
    #   @return [String]
    #
    # @!attribute [rw] association_state
    #   The state of the association.
    #   @return [Types::RouteTableAssociationState]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateRouteTableResult AWS API Documentation
    #
    class AssociateRouteTableResult < Struct.new(
      :association_id,
      :association_state)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AssociateSubnetCidrBlockRequest
    #   data as a hash:
    #
    #       {
    #         ipv_6_cidr_block: "String", # required
    #         subnet_id: "SubnetId", # required
    #       }
    #
    # @!attribute [rw] ipv_6_cidr_block
    #   The IPv6 CIDR block for your subnet. The subnet must have a /64
    #   prefix length.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The ID of your subnet.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateSubnetCidrBlockRequest AWS API Documentation
    #
    class AssociateSubnetCidrBlockRequest < Struct.new(
      :ipv_6_cidr_block,
      :subnet_id)
      include Aws::Structure
    end

    # @!attribute [rw] ipv_6_cidr_block_association
    #   Information about the IPv6 CIDR block association.
    #   @return [Types::SubnetIpv6CidrBlockAssociation]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateSubnetCidrBlockResult AWS API Documentation
    #
    class AssociateSubnetCidrBlockResult < Struct.new(
      :ipv_6_cidr_block_association,
      :subnet_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AssociateTransitGatewayMulticastDomainRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_multicast_domain_id: "TransitGatewayMulticastDomainId",
    #         transit_gateway_attachment_id: "TransitGatewayAttachmentId",
    #         subnet_ids: ["String"],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_multicast_domain_id
    #   The ID of the transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the transit gateway attachment to associate with the
    #   transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] subnet_ids
    #   The IDs of the subnets to associate with the transit gateway
    #   multicast domain.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateTransitGatewayMulticastDomainRequest AWS API Documentation
    #
    class AssociateTransitGatewayMulticastDomainRequest < Struct.new(
      :transit_gateway_multicast_domain_id,
      :transit_gateway_attachment_id,
      :subnet_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] associations
    #   Information about the transit gateway multicast domain associations.
    #   @return [Types::TransitGatewayMulticastDomainAssociations]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateTransitGatewayMulticastDomainResult AWS API Documentation
    #
    class AssociateTransitGatewayMulticastDomainResult < Struct.new(
      :associations)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AssociateTransitGatewayRouteTableRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_route_table_id: "TransitGatewayRouteTableId", # required
    #         transit_gateway_attachment_id: "TransitGatewayAttachmentId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the transit gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateTransitGatewayRouteTableRequest AWS API Documentation
    #
    class AssociateTransitGatewayRouteTableRequest < Struct.new(
      :transit_gateway_route_table_id,
      :transit_gateway_attachment_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] association
    #   The ID of the association.
    #   @return [Types::TransitGatewayAssociation]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateTransitGatewayRouteTableResult AWS API Documentation
    #
    class AssociateTransitGatewayRouteTableResult < Struct.new(
      :association)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AssociateVpcCidrBlockRequest
    #   data as a hash:
    #
    #       {
    #         amazon_provided_ipv_6_cidr_block: false,
    #         cidr_block: "String",
    #         vpc_id: "VpcId", # required
    #         ipv_6_cidr_block_network_border_group: "String",
    #         ipv_6_pool: "Ipv6PoolEc2Id",
    #         ipv_6_cidr_block: "String",
    #       }
    #
    # @!attribute [rw] amazon_provided_ipv_6_cidr_block
    #   Requests an Amazon-provided IPv6 CIDR block with a /56 prefix length
    #   for the VPC. You cannot specify the range of IPv6 addresses, or the
    #   size of the CIDR block.
    #   @return [Boolean]
    #
    # @!attribute [rw] cidr_block
    #   An IPv4 CIDR block to associate with the VPC.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_cidr_block_network_border_group
    #   The name of the location from which we advertise the IPV6 CIDR
    #   block. Use this parameter to limit the CiDR block to this location.
    #
    #   You must set `AmazonProvidedIpv6CidrBlock` to `true` to use this
    #   parameter.
    #
    #   You can have one IPv6 CIDR block association per network border
    #   group.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_pool
    #   The ID of an IPv6 address pool from which to allocate the IPv6 CIDR
    #   block.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_cidr_block
    #   An IPv6 CIDR block from the IPv6 address pool. You must also specify
    #   `Ipv6Pool` in the request.
    #
    #   To let Amazon choose the IPv6 CIDR block for you, omit this
    #   parameter.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateVpcCidrBlockRequest AWS API Documentation
    #
    class AssociateVpcCidrBlockRequest < Struct.new(
      :amazon_provided_ipv_6_cidr_block,
      :cidr_block,
      :vpc_id,
      :ipv_6_cidr_block_network_border_group,
      :ipv_6_pool,
      :ipv_6_cidr_block)
      include Aws::Structure
    end

    # @!attribute [rw] ipv_6_cidr_block_association
    #   Information about the IPv6 CIDR block association.
    #   @return [Types::VpcIpv6CidrBlockAssociation]
    #
    # @!attribute [rw] cidr_block_association
    #   Information about the IPv4 CIDR block association.
    #   @return [Types::VpcCidrBlockAssociation]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociateVpcCidrBlockResult AWS API Documentation
    #
    class AssociateVpcCidrBlockResult < Struct.new(
      :ipv_6_cidr_block_association,
      :cidr_block_association,
      :vpc_id)
      include Aws::Structure
    end

    # Describes a target network that is associated with a Client VPN
    # endpoint. A target network is a subnet in a VPC.
    #
    # @!attribute [rw] network_id
    #   The ID of the subnet.
    #   @return [String]
    #
    # @!attribute [rw] network_type
    #   The target network type.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociatedTargetNetwork AWS API Documentation
    #
    class AssociatedTargetNetwork < Struct.new(
      :network_id,
      :network_type)
      include Aws::Structure
    end

    # Describes the state of a target network association.
    #
    # @!attribute [rw] code
    #   The state of the target network association.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   A message about the status of the target network association, if
    #   applicable.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AssociationStatus AWS API Documentation
    #
    class AssociationStatus < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AttachClassicLinkVpcRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         groups: ["String"], # required
    #         instance_id: "InstanceId", # required
    #         vpc_id: "VpcId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] groups
    #   The ID of one or more of the VPC's security groups. You cannot
    #   specify security groups from a different VPC.
    #   @return [Array<String>]
    #
    # @!attribute [rw] instance_id
    #   The ID of an EC2-Classic instance to link to the ClassicLink-enabled
    #   VPC.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of a ClassicLink-enabled VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AttachClassicLinkVpcRequest AWS API Documentation
    #
    class AttachClassicLinkVpcRequest < Struct.new(
      :dry_run,
      :groups,
      :instance_id,
      :vpc_id)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AttachClassicLinkVpcResult AWS API Documentation
    #
    class AttachClassicLinkVpcResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AttachInternetGatewayRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         internet_gateway_id: "InternetGatewayId", # required
    #         vpc_id: "VpcId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] internet_gateway_id
    #   The ID of the internet gateway.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AttachInternetGatewayRequest AWS API Documentation
    #
    class AttachInternetGatewayRequest < Struct.new(
      :dry_run,
      :internet_gateway_id,
      :vpc_id)
      include Aws::Structure
    end

    # Contains the parameters for AttachNetworkInterface.
    #
    # @note When making an API call, you may pass AttachNetworkInterfaceRequest
    #   data as a hash:
    #
    #       {
    #         device_index: 1, # required
    #         dry_run: false,
    #         instance_id: "InstanceId", # required
    #         network_interface_id: "NetworkInterfaceId", # required
    #       }
    #
    # @!attribute [rw] device_index
    #   The index of the device for the network interface attachment.
    #   @return [Integer]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AttachNetworkInterfaceRequest AWS API Documentation
    #
    class AttachNetworkInterfaceRequest < Struct.new(
      :device_index,
      :dry_run,
      :instance_id,
      :network_interface_id)
      include Aws::Structure
    end

    # Contains the output of AttachNetworkInterface.
    #
    # @!attribute [rw] attachment_id
    #   The ID of the network interface attachment.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AttachNetworkInterfaceResult AWS API Documentation
    #
    class AttachNetworkInterfaceResult < Struct.new(
      :attachment_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AttachVolumeRequest
    #   data as a hash:
    #
    #       {
    #         device: "String", # required
    #         instance_id: "InstanceId", # required
    #         volume_id: "VolumeId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] device
    #   The device name (for example, `/dev/sdh` or `xvdh`).
    #   @return [String]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] volume_id
    #   The ID of the EBS volume. The volume and instance must be within the
    #   same Availability Zone.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AttachVolumeRequest AWS API Documentation
    #
    class AttachVolumeRequest < Struct.new(
      :device,
      :instance_id,
      :volume_id,
      :dry_run)
      include Aws::Structure
    end

    # Contains the parameters for AttachVpnGateway.
    #
    # @note When making an API call, you may pass AttachVpnGatewayRequest
    #   data as a hash:
    #
    #       {
    #         vpc_id: "VpcId", # required
    #         vpn_gateway_id: "VpnGatewayId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] vpn_gateway_id
    #   The ID of the virtual private gateway.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AttachVpnGatewayRequest AWS API Documentation
    #
    class AttachVpnGatewayRequest < Struct.new(
      :vpc_id,
      :vpn_gateway_id,
      :dry_run)
      include Aws::Structure
    end

    # Contains the output of AttachVpnGateway.
    #
    # @!attribute [rw] vpc_attachment
    #   Information about the attachment.
    #   @return [Types::VpcAttachment]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AttachVpnGatewayResult AWS API Documentation
    #
    class AttachVpnGatewayResult < Struct.new(
      :vpc_attachment)
      include Aws::Structure
    end

    # Describes a value for a resource attribute that is a Boolean value.
    #
    # @note When making an API call, you may pass AttributeBooleanValue
    #   data as a hash:
    #
    #       {
    #         value: false,
    #       }
    #
    # @!attribute [rw] value
    #   The attribute value. The valid values are `true` or `false`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AttributeBooleanValue AWS API Documentation
    #
    class AttributeBooleanValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # Describes a value for a resource attribute that is a String.
    #
    # @note When making an API call, you may pass AttributeValue
    #   data as a hash:
    #
    #       {
    #         value: "String",
    #       }
    #
    # @!attribute [rw] value
    #   The attribute value. The value is case-sensitive.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AttributeValue AWS API Documentation
    #
    class AttributeValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # Information about an authorization rule.
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint with which the authorization rule
    #   is associated.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   A brief description of the authorization rule.
    #   @return [String]
    #
    # @!attribute [rw] group_id
    #   The ID of the Active Directory group to which the authorization rule
    #   grants access.
    #   @return [String]
    #
    # @!attribute [rw] access_all
    #   Indicates whether the authorization rule grants access to all
    #   clients.
    #   @return [Boolean]
    #
    # @!attribute [rw] destination_cidr
    #   The IPv4 address range, in CIDR notation, of the network to which
    #   the authorization rule applies.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The current state of the authorization rule.
    #   @return [Types::ClientVpnAuthorizationRuleStatus]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AuthorizationRule AWS API Documentation
    #
    class AuthorizationRule < Struct.new(
      :client_vpn_endpoint_id,
      :description,
      :group_id,
      :access_all,
      :destination_cidr,
      :status)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AuthorizeClientVpnIngressRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         target_network_cidr: "String", # required
    #         access_group_id: "String",
    #         authorize_all_groups: false,
    #         description: "String",
    #         client_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] target_network_cidr
    #   The IPv4 address range, in CIDR notation, of the network for which
    #   access is being authorized.
    #   @return [String]
    #
    # @!attribute [rw] access_group_id
    #   The ID of the group to grant access to, for example, the Active
    #   Directory group or identity provider (IdP) group.
    #   @return [String]
    #
    # @!attribute [rw] authorize_all_groups
    #   Indicates whether to grant access to all clients. Use `true` to
    #   grant all clients who successfully establish a VPN connection access
    #   to the network.
    #   @return [Boolean]
    #
    # @!attribute [rw] description
    #   A brief description of the authorization rule.
    #   @return [String]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #   **A suitable default value is auto-generated.** You should normally
    #   not need to pass this option.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AuthorizeClientVpnIngressRequest AWS API Documentation
    #
    class AuthorizeClientVpnIngressRequest < Struct.new(
      :client_vpn_endpoint_id,
      :target_network_cidr,
      :access_group_id,
      :authorize_all_groups,
      :description,
      :client_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] status
    #   The current state of the authorization rule.
    #   @return [Types::ClientVpnAuthorizationRuleStatus]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AuthorizeClientVpnIngressResult AWS API Documentation
    #
    class AuthorizeClientVpnIngressResult < Struct.new(
      :status)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AuthorizeSecurityGroupEgressRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         group_id: "SecurityGroupId", # required
    #         ip_permissions: [
    #           {
    #             from_port: 1,
    #             ip_protocol: "String",
    #             ip_ranges: [
    #               {
    #                 cidr_ip: "String",
    #                 description: "String",
    #               },
    #             ],
    #             ipv_6_ranges: [
    #               {
    #                 cidr_ipv_6: "String",
    #                 description: "String",
    #               },
    #             ],
    #             prefix_list_ids: [
    #               {
    #                 description: "String",
    #                 prefix_list_id: "String",
    #               },
    #             ],
    #             to_port: 1,
    #             user_id_group_pairs: [
    #               {
    #                 description: "String",
    #                 group_id: "String",
    #                 group_name: "String",
    #                 peering_status: "String",
    #                 user_id: "String",
    #                 vpc_id: "String",
    #                 vpc_peering_connection_id: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         cidr_ip: "String",
    #         from_port: 1,
    #         ip_protocol: "String",
    #         to_port: 1,
    #         source_security_group_name: "String",
    #         source_security_group_owner_id: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] group_id
    #   The ID of the security group.
    #   @return [String]
    #
    # @!attribute [rw] ip_permissions
    #   The sets of IP permissions. You can't specify a destination
    #   security group and a CIDR IP address range in the same set of
    #   permissions.
    #   @return [Array<Types::IpPermission>]
    #
    # @!attribute [rw] cidr_ip
    #   Not supported. Use a set of IP permissions to specify the CIDR.
    #   @return [String]
    #
    # @!attribute [rw] from_port
    #   Not supported. Use a set of IP permissions to specify the port.
    #   @return [Integer]
    #
    # @!attribute [rw] ip_protocol
    #   Not supported. Use a set of IP permissions to specify the protocol
    #   name or number.
    #   @return [String]
    #
    # @!attribute [rw] to_port
    #   Not supported. Use a set of IP permissions to specify the port.
    #   @return [Integer]
    #
    # @!attribute [rw] source_security_group_name
    #   Not supported. Use a set of IP permissions to specify a destination
    #   security group.
    #   @return [String]
    #
    # @!attribute [rw] source_security_group_owner_id
    #   Not supported. Use a set of IP permissions to specify a destination
    #   security group.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AuthorizeSecurityGroupEgressRequest AWS API Documentation
    #
    class AuthorizeSecurityGroupEgressRequest < Struct.new(
      :dry_run,
      :group_id,
      :ip_permissions,
      :cidr_ip,
      :from_port,
      :ip_protocol,
      :to_port,
      :source_security_group_name,
      :source_security_group_owner_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass AuthorizeSecurityGroupIngressRequest
    #   data as a hash:
    #
    #       {
    #         cidr_ip: "String",
    #         from_port: 1,
    #         group_id: "SecurityGroupId",
    #         group_name: "SecurityGroupName",
    #         ip_permissions: [
    #           {
    #             from_port: 1,
    #             ip_protocol: "String",
    #             ip_ranges: [
    #               {
    #                 cidr_ip: "String",
    #                 description: "String",
    #               },
    #             ],
    #             ipv_6_ranges: [
    #               {
    #                 cidr_ipv_6: "String",
    #                 description: "String",
    #               },
    #             ],
    #             prefix_list_ids: [
    #               {
    #                 description: "String",
    #                 prefix_list_id: "String",
    #               },
    #             ],
    #             to_port: 1,
    #             user_id_group_pairs: [
    #               {
    #                 description: "String",
    #                 group_id: "String",
    #                 group_name: "String",
    #                 peering_status: "String",
    #                 user_id: "String",
    #                 vpc_id: "String",
    #                 vpc_peering_connection_id: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         ip_protocol: "String",
    #         source_security_group_name: "String",
    #         source_security_group_owner_id: "String",
    #         to_port: 1,
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] cidr_ip
    #   The IPv4 address range, in CIDR format. You can't specify this
    #   parameter when specifying a source security group. To specify an
    #   IPv6 address range, use a set of IP permissions.
    #
    #   Alternatively, use a set of IP permissions to specify multiple rules
    #   and a description for the rule.
    #   @return [String]
    #
    # @!attribute [rw] from_port
    #   The start of port range for the TCP and UDP protocols, or an ICMP
    #   type number. For the ICMP type number, use `-1` to specify all
    #   types. If you specify all ICMP types, you must specify all codes.
    #
    #   Alternatively, use a set of IP permissions to specify multiple rules
    #   and a description for the rule.
    #   @return [Integer]
    #
    # @!attribute [rw] group_id
    #   The ID of the security group. You must specify either the security
    #   group ID or the security group name in the request. For security
    #   groups in a nondefault VPC, you must specify the security group ID.
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   \[EC2-Classic, default VPC\] The name of the security group. You
    #   must specify either the security group ID or the security group name
    #   in the request.
    #   @return [String]
    #
    # @!attribute [rw] ip_permissions
    #   The sets of IP permissions.
    #   @return [Array<Types::IpPermission>]
    #
    # @!attribute [rw] ip_protocol
    #   The IP protocol name (`tcp`, `udp`, `icmp`) or number (see [Protocol
    #   Numbers][1]). To specify `icmpv6`, use a set of IP permissions.
    #
    #   \[VPC only\] Use `-1` to specify all protocols. If you specify `-1`
    #   or a protocol other than `tcp`, `udp`, or `icmp`, traffic on all
    #   ports is allowed, regardless of any ports you specify.
    #
    #   Alternatively, use a set of IP permissions to specify multiple rules
    #   and a description for the rule.
    #
    #
    #
    #   [1]: http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml
    #   @return [String]
    #
    # @!attribute [rw] source_security_group_name
    #   \[EC2-Classic, default VPC\] The name of the source security group.
    #   You can't specify this parameter in combination with the following
    #   parameters: the CIDR IP address range, the start of the port range,
    #   the IP protocol, and the end of the port range. Creates rules that
    #   grant full ICMP, UDP, and TCP access. To create a rule with a
    #   specific IP protocol and port range, use a set of IP permissions
    #   instead. For EC2-VPC, the source security group must be in the same
    #   VPC.
    #   @return [String]
    #
    # @!attribute [rw] source_security_group_owner_id
    #   \[nondefault VPC\] The AWS account ID for the source security group,
    #   if the source security group is in a different account. You can't
    #   specify this parameter in combination with the following parameters:
    #   the CIDR IP address range, the IP protocol, the start of the port
    #   range, and the end of the port range. Creates rules that grant full
    #   ICMP, UDP, and TCP access. To create a rule with a specific IP
    #   protocol and port range, use a set of IP permissions instead.
    #   @return [String]
    #
    # @!attribute [rw] to_port
    #   The end of port range for the TCP and UDP protocols, or an ICMP code
    #   number. For the ICMP code number, use `-1` to specify all codes. If
    #   you specify all ICMP types, you must specify all codes.
    #
    #   Alternatively, use a set of IP permissions to specify multiple rules
    #   and a description for the rule.
    #   @return [Integer]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AuthorizeSecurityGroupIngressRequest AWS API Documentation
    #
    class AuthorizeSecurityGroupIngressRequest < Struct.new(
      :cidr_ip,
      :from_port,
      :group_id,
      :group_name,
      :ip_permissions,
      :ip_protocol,
      :source_security_group_name,
      :source_security_group_owner_id,
      :to_port,
      :dry_run)
      include Aws::Structure
    end

    # Describes an Availability Zone or Local Zone.
    #
    # @!attribute [rw] state
    #   The state of the Availability Zone or Local Zone.
    #   @return [String]
    #
    # @!attribute [rw] opt_in_status
    #   For Availability Zones, this parameter always has the value of
    #   `opt-in-not-required`.
    #
    #   For Local Zones, this parameter is the opt in status. The possible
    #   values are `opted-in`, and `not-opted-in`.
    #   @return [String]
    #
    # @!attribute [rw] messages
    #   Any messages about the Availability Zone or Local Zone.
    #   @return [Array<Types::AvailabilityZoneMessage>]
    #
    # @!attribute [rw] region_name
    #   The name of the Region.
    #   @return [String]
    #
    # @!attribute [rw] zone_name
    #   The name of the Availability Zone or Local Zone.
    #   @return [String]
    #
    # @!attribute [rw] zone_id
    #   The ID of the Availability Zone or Local Zone.
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   For Availability Zones, this parameter has the same value as the
    #   Region name.
    #
    #   For Local Zones, the name of the associated group, for example
    #   `us-west-2-lax-1`.
    #   @return [String]
    #
    # @!attribute [rw] network_border_group
    #   The name of the location from which the address is advertised.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AvailabilityZone AWS API Documentation
    #
    class AvailabilityZone < Struct.new(
      :state,
      :opt_in_status,
      :messages,
      :region_name,
      :zone_name,
      :zone_id,
      :group_name,
      :network_border_group)
      include Aws::Structure
    end

    # Describes a message about an Availability Zone or Local Zone.
    #
    # @!attribute [rw] message
    #   The message about the Availability Zone or Local Zone.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AvailabilityZoneMessage AWS API Documentation
    #
    class AvailabilityZoneMessage < Struct.new(
      :message)
      include Aws::Structure
    end

    # The capacity information for instances that can be launched onto the
    # Dedicated Host.
    #
    # @!attribute [rw] available_instance_capacity
    #   The number of instances that can be launched onto the Dedicated Host
    #   depending on the host's available capacity. For Dedicated Hosts
    #   that support multiple instance types, this parameter represents the
    #   number of instances for each instance size that is supported on the
    #   host.
    #   @return [Array<Types::InstanceCapacity>]
    #
    # @!attribute [rw] available_v_cpus
    #   The number of vCPUs available for launching instances onto the
    #   Dedicated Host.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/AvailableCapacity AWS API Documentation
    #
    class AvailableCapacity < Struct.new(
      :available_instance_capacity,
      :available_v_cpus)
      include Aws::Structure
    end

    # @note When making an API call, you may pass BlobAttributeValue
    #   data as a hash:
    #
    #       {
    #         value: "data",
    #       }
    #
    # @!attribute [rw] value
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/BlobAttributeValue AWS API Documentation
    #
    class BlobAttributeValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # Describes a block device mapping.
    #
    # @note When making an API call, you may pass BlockDeviceMapping
    #   data as a hash:
    #
    #       {
    #         device_name: "String",
    #         virtual_name: "String",
    #         ebs: {
    #           delete_on_termination: false,
    #           iops: 1,
    #           snapshot_id: "String",
    #           volume_size: 1,
    #           volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #           kms_key_id: "String",
    #           encrypted: false,
    #         },
    #         no_device: "String",
    #       }
    #
    # @!attribute [rw] device_name
    #   The device name (for example, `/dev/sdh` or `xvdh`).
    #   @return [String]
    #
    # @!attribute [rw] virtual_name
    #   The virtual device name (`ephemeral`N). Instance store volumes are
    #   numbered starting from 0. An instance type with 2 available instance
    #   store volumes can specify mappings for `ephemeral0` and
    #   `ephemeral1`. The number of available instance store volumes depends
    #   on the instance type. After you connect to the instance, you must
    #   mount the volume.
    #
    #   NVMe instance store volumes are automatically enumerated and
    #   assigned a device name. Including them in your block device mapping
    #   has no effect.
    #
    #   Constraints: For M3 instances, you must specify instance store
    #   volumes in the block device mapping for the instance. When you
    #   launch an M3 instance, we ignore any instance store volumes
    #   specified in the block device mapping for the AMI.
    #   @return [String]
    #
    # @!attribute [rw] ebs
    #   Parameters used to automatically set up EBS volumes when the
    #   instance is launched.
    #   @return [Types::EbsBlockDevice]
    #
    # @!attribute [rw] no_device
    #   Suppresses the specified device included in the block device mapping
    #   of the AMI.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/BlockDeviceMapping AWS API Documentation
    #
    class BlockDeviceMapping < Struct.new(
      :device_name,
      :virtual_name,
      :ebs,
      :no_device)
      include Aws::Structure
    end

    # Contains the parameters for BundleInstance.
    #
    # @note When making an API call, you may pass BundleInstanceRequest
    #   data as a hash:
    #
    #       {
    #         instance_id: "InstanceId", # required
    #         storage: { # required
    #           s3: {
    #             aws_access_key_id: "String",
    #             bucket: "String",
    #             prefix: "String",
    #             upload_policy: "data",
    #             upload_policy_signature: "String",
    #           },
    #         },
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance to bundle.
    #
    #   Type: String
    #
    #   Default: None
    #
    #   Required: Yes
    #   @return [String]
    #
    # @!attribute [rw] storage
    #   The bucket in which to store the AMI. You can specify a bucket that
    #   you already own or a new bucket that Amazon EC2 creates on your
    #   behalf. If you specify a bucket that belongs to someone else, Amazon
    #   EC2 returns an error.
    #   @return [Types::Storage]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/BundleInstanceRequest AWS API Documentation
    #
    class BundleInstanceRequest < Struct.new(
      :instance_id,
      :storage,
      :dry_run)
      include Aws::Structure
    end

    # Contains the output of BundleInstance.
    #
    # @!attribute [rw] bundle_task
    #   Information about the bundle task.
    #   @return [Types::BundleTask]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/BundleInstanceResult AWS API Documentation
    #
    class BundleInstanceResult < Struct.new(
      :bundle_task)
      include Aws::Structure
    end

    # Describes a bundle task.
    #
    # @!attribute [rw] bundle_id
    #   The ID of the bundle task.
    #   @return [String]
    #
    # @!attribute [rw] bundle_task_error
    #   If the task fails, a description of the error.
    #   @return [Types::BundleTaskError]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance associated with this bundle task.
    #   @return [String]
    #
    # @!attribute [rw] progress
    #   The level of task completion, as a percent (for example, 20%).
    #   @return [String]
    #
    # @!attribute [rw] start_time
    #   The time this task started.
    #   @return [Time]
    #
    # @!attribute [rw] state
    #   The state of the task.
    #   @return [String]
    #
    # @!attribute [rw] storage
    #   The Amazon S3 storage locations.
    #   @return [Types::Storage]
    #
    # @!attribute [rw] update_time
    #   The time of the most recent update for the task.
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/BundleTask AWS API Documentation
    #
    class BundleTask < Struct.new(
      :bundle_id,
      :bundle_task_error,
      :instance_id,
      :progress,
      :start_time,
      :state,
      :storage,
      :update_time)
      include Aws::Structure
    end

    # Describes an error for BundleInstance.
    #
    # @!attribute [rw] code
    #   The error code.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   The error message.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/BundleTaskError AWS API Documentation
    #
    class BundleTaskError < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # Information about an address range that is provisioned for use with
    # your AWS resources through bring your own IP addresses (BYOIP).
    #
    # @!attribute [rw] cidr
    #   The address range, in CIDR notation.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   The description of the address range.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   Upon success, contains the ID of the address pool. Otherwise,
    #   contains an error message.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the address pool.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ByoipCidr AWS API Documentation
    #
    class ByoipCidr < Struct.new(
      :cidr,
      :description,
      :status_message,
      :state)
      include Aws::Structure
    end

    # Contains the parameters for CancelBundleTask.
    #
    # @note When making an API call, you may pass CancelBundleTaskRequest
    #   data as a hash:
    #
    #       {
    #         bundle_id: "BundleId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] bundle_id
    #   The ID of the bundle task.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelBundleTaskRequest AWS API Documentation
    #
    class CancelBundleTaskRequest < Struct.new(
      :bundle_id,
      :dry_run)
      include Aws::Structure
    end

    # Contains the output of CancelBundleTask.
    #
    # @!attribute [rw] bundle_task
    #   Information about the bundle task.
    #   @return [Types::BundleTask]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelBundleTaskResult AWS API Documentation
    #
    class CancelBundleTaskResult < Struct.new(
      :bundle_task)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CancelCapacityReservationRequest
    #   data as a hash:
    #
    #       {
    #         capacity_reservation_id: "CapacityReservationId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] capacity_reservation_id
    #   The ID of the Capacity Reservation to be cancelled.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelCapacityReservationRequest AWS API Documentation
    #
    class CancelCapacityReservationRequest < Struct.new(
      :capacity_reservation_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelCapacityReservationResult AWS API Documentation
    #
    class CancelCapacityReservationResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CancelConversionRequest
    #   data as a hash:
    #
    #       {
    #         conversion_task_id: "ConversionTaskId", # required
    #         dry_run: false,
    #         reason_message: "String",
    #       }
    #
    # @!attribute [rw] conversion_task_id
    #   The ID of the conversion task.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] reason_message
    #   The reason for canceling the conversion task.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelConversionRequest AWS API Documentation
    #
    class CancelConversionRequest < Struct.new(
      :conversion_task_id,
      :dry_run,
      :reason_message)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CancelExportTaskRequest
    #   data as a hash:
    #
    #       {
    #         export_task_id: "ExportVmTaskId", # required
    #       }
    #
    # @!attribute [rw] export_task_id
    #   The ID of the export task. This is the ID returned by
    #   `CreateInstanceExportTask`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelExportTaskRequest AWS API Documentation
    #
    class CancelExportTaskRequest < Struct.new(
      :export_task_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CancelImportTaskRequest
    #   data as a hash:
    #
    #       {
    #         cancel_reason: "String",
    #         dry_run: false,
    #         import_task_id: "ImportTaskId",
    #       }
    #
    # @!attribute [rw] cancel_reason
    #   The reason for canceling the task.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] import_task_id
    #   The ID of the import image or import snapshot task to be canceled.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelImportTaskRequest AWS API Documentation
    #
    class CancelImportTaskRequest < Struct.new(
      :cancel_reason,
      :dry_run,
      :import_task_id)
      include Aws::Structure
    end

    # @!attribute [rw] import_task_id
    #   The ID of the task being canceled.
    #   @return [String]
    #
    # @!attribute [rw] previous_state
    #   The current state of the task being canceled.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The current state of the task being canceled.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelImportTaskResult AWS API Documentation
    #
    class CancelImportTaskResult < Struct.new(
      :import_task_id,
      :previous_state,
      :state)
      include Aws::Structure
    end

    # Contains the parameters for CancelReservedInstancesListing.
    #
    # @note When making an API call, you may pass CancelReservedInstancesListingRequest
    #   data as a hash:
    #
    #       {
    #         reserved_instances_listing_id: "ReservedInstancesListingId", # required
    #       }
    #
    # @!attribute [rw] reserved_instances_listing_id
    #   The ID of the Reserved Instance listing.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelReservedInstancesListingRequest AWS API Documentation
    #
    class CancelReservedInstancesListingRequest < Struct.new(
      :reserved_instances_listing_id)
      include Aws::Structure
    end

    # Contains the output of CancelReservedInstancesListing.
    #
    # @!attribute [rw] reserved_instances_listings
    #   The Reserved Instance listing.
    #   @return [Array<Types::ReservedInstancesListing>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelReservedInstancesListingResult AWS API Documentation
    #
    class CancelReservedInstancesListingResult < Struct.new(
      :reserved_instances_listings)
      include Aws::Structure
    end

    # Describes a Spot Fleet error.
    #
    # @!attribute [rw] code
    #   The error code.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   The description for the error code.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelSpotFleetRequestsError AWS API Documentation
    #
    class CancelSpotFleetRequestsError < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # Describes a Spot Fleet request that was not successfully canceled.
    #
    # @!attribute [rw] error
    #   The error.
    #   @return [Types::CancelSpotFleetRequestsError]
    #
    # @!attribute [rw] spot_fleet_request_id
    #   The ID of the Spot Fleet request.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelSpotFleetRequestsErrorItem AWS API Documentation
    #
    class CancelSpotFleetRequestsErrorItem < Struct.new(
      :error,
      :spot_fleet_request_id)
      include Aws::Structure
    end

    # Contains the parameters for CancelSpotFleetRequests.
    #
    # @note When making an API call, you may pass CancelSpotFleetRequestsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         spot_fleet_request_ids: ["SpotFleetRequestId"], # required
    #         terminate_instances: false, # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] spot_fleet_request_ids
    #   The IDs of the Spot Fleet requests.
    #   @return [Array<String>]
    #
    # @!attribute [rw] terminate_instances
    #   Indicates whether to terminate instances for a Spot Fleet request if
    #   it is canceled successfully.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelSpotFleetRequestsRequest AWS API Documentation
    #
    class CancelSpotFleetRequestsRequest < Struct.new(
      :dry_run,
      :spot_fleet_request_ids,
      :terminate_instances)
      include Aws::Structure
    end

    # Contains the output of CancelSpotFleetRequests.
    #
    # @!attribute [rw] successful_fleet_requests
    #   Information about the Spot Fleet requests that are successfully
    #   canceled.
    #   @return [Array<Types::CancelSpotFleetRequestsSuccessItem>]
    #
    # @!attribute [rw] unsuccessful_fleet_requests
    #   Information about the Spot Fleet requests that are not successfully
    #   canceled.
    #   @return [Array<Types::CancelSpotFleetRequestsErrorItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelSpotFleetRequestsResponse AWS API Documentation
    #
    class CancelSpotFleetRequestsResponse < Struct.new(
      :successful_fleet_requests,
      :unsuccessful_fleet_requests)
      include Aws::Structure
    end

    # Describes a Spot Fleet request that was successfully canceled.
    #
    # @!attribute [rw] current_spot_fleet_request_state
    #   The current state of the Spot Fleet request.
    #   @return [String]
    #
    # @!attribute [rw] previous_spot_fleet_request_state
    #   The previous state of the Spot Fleet request.
    #   @return [String]
    #
    # @!attribute [rw] spot_fleet_request_id
    #   The ID of the Spot Fleet request.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelSpotFleetRequestsSuccessItem AWS API Documentation
    #
    class CancelSpotFleetRequestsSuccessItem < Struct.new(
      :current_spot_fleet_request_state,
      :previous_spot_fleet_request_state,
      :spot_fleet_request_id)
      include Aws::Structure
    end

    # Contains the parameters for CancelSpotInstanceRequests.
    #
    # @note When making an API call, you may pass CancelSpotInstanceRequestsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         spot_instance_request_ids: ["SpotInstanceRequestId"], # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] spot_instance_request_ids
    #   One or more Spot Instance request IDs.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelSpotInstanceRequestsRequest AWS API Documentation
    #
    class CancelSpotInstanceRequestsRequest < Struct.new(
      :dry_run,
      :spot_instance_request_ids)
      include Aws::Structure
    end

    # Contains the output of CancelSpotInstanceRequests.
    #
    # @!attribute [rw] cancelled_spot_instance_requests
    #   One or more Spot Instance requests.
    #   @return [Array<Types::CancelledSpotInstanceRequest>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelSpotInstanceRequestsResult AWS API Documentation
    #
    class CancelSpotInstanceRequestsResult < Struct.new(
      :cancelled_spot_instance_requests)
      include Aws::Structure
    end

    # Describes a request to cancel a Spot Instance.
    #
    # @!attribute [rw] spot_instance_request_id
    #   The ID of the Spot Instance request.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the Spot Instance request.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CancelledSpotInstanceRequest AWS API Documentation
    #
    class CancelledSpotInstanceRequest < Struct.new(
      :spot_instance_request_id,
      :state)
      include Aws::Structure
    end

    # Describes a Capacity Reservation.
    #
    # @!attribute [rw] capacity_reservation_id
    #   The ID of the Capacity Reservation.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account that owns the Capacity Reservation.
    #   @return [String]
    #
    # @!attribute [rw] capacity_reservation_arn
    #   The Amazon Resource Name (ARN) of the Capacity Reservation.
    #   @return [String]
    #
    # @!attribute [rw] availability_zone_id
    #   The Availability Zone ID of the Capacity Reservation.
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   The type of instance for which the Capacity Reservation reserves
    #   capacity.
    #   @return [String]
    #
    # @!attribute [rw] instance_platform
    #   The type of operating system for which the Capacity Reservation
    #   reserves capacity.
    #   @return [String]
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone in which the capacity is reserved.
    #   @return [String]
    #
    # @!attribute [rw] tenancy
    #   Indicates the tenancy of the Capacity Reservation. A Capacity
    #   Reservation can have one of the following tenancy settings:
    #
    #   * `default` - The Capacity Reservation is created on hardware that
    #     is shared with other AWS accounts.
    #
    #   * `dedicated` - The Capacity Reservation is created on single-tenant
    #     hardware that is dedicated to a single AWS account.
    #   @return [String]
    #
    # @!attribute [rw] total_instance_count
    #   The total number of instances for which the Capacity Reservation
    #   reserves capacity.
    #   @return [Integer]
    #
    # @!attribute [rw] available_instance_count
    #   The remaining capacity. Indicates the number of instances that can
    #   be launched in the Capacity Reservation.
    #   @return [Integer]
    #
    # @!attribute [rw] ebs_optimized
    #   Indicates whether the Capacity Reservation supports EBS-optimized
    #   instances. This optimization provides dedicated throughput to Amazon
    #   EBS and an optimized configuration stack to provide optimal I/O
    #   performance. This optimization isn't available with all instance
    #   types. Additional usage charges apply when using an EBS- optimized
    #   instance.
    #   @return [Boolean]
    #
    # @!attribute [rw] ephemeral_storage
    #   Indicates whether the Capacity Reservation supports instances with
    #   temporary, block-level storage.
    #   @return [Boolean]
    #
    # @!attribute [rw] state
    #   The current state of the Capacity Reservation. A Capacity
    #   Reservation can be in one of the following states:
    #
    #   * `active` - The Capacity Reservation is active and the capacity is
    #     available for your use.
    #
    #   * `expired` - The Capacity Reservation expired automatically at the
    #     date and time specified in your request. The reserved capacity is
    #     no longer available for your use.
    #
    #   * `cancelled` - The Capacity Reservation was manually cancelled. The
    #     reserved capacity is no longer available for your use.
    #
    #   * `pending` - The Capacity Reservation request was successful but
    #     the capacity provisioning is still pending.
    #
    #   * `failed` - The Capacity Reservation request has failed. A request
    #     might fail due to invalid request parameters, capacity
    #     constraints, or instance limit constraints. Failed requests are
    #     retained for 60 minutes.
    #   @return [String]
    #
    # @!attribute [rw] end_date
    #   The date and time at which the Capacity Reservation expires. When a
    #   Capacity Reservation expires, the reserved capacity is released and
    #   you can no longer launch instances into it. The Capacity
    #   Reservation's state changes to `expired` when it reaches its end
    #   date and time.
    #   @return [Time]
    #
    # @!attribute [rw] end_date_type
    #   Indicates the way in which the Capacity Reservation ends. A Capacity
    #   Reservation can have one of the following end types:
    #
    #   * `unlimited` - The Capacity Reservation remains active until you
    #     explicitly cancel it.
    #
    #   * `limited` - The Capacity Reservation expires automatically at a
    #     specified date and time.
    #   @return [String]
    #
    # @!attribute [rw] instance_match_criteria
    #   Indicates the type of instance launches that the Capacity
    #   Reservation accepts. The options include:
    #
    #   * `open` - The Capacity Reservation accepts all instances that have
    #     matching attributes (instance type, platform, and Availability
    #     Zone). Instances that have matching attributes launch into the
    #     Capacity Reservation automatically without specifying any
    #     additional parameters.
    #
    #   * `targeted` - The Capacity Reservation only accepts instances that
    #     have matching attributes (instance type, platform, and
    #     Availability Zone), and explicitly target the Capacity
    #     Reservation. This ensures that only permitted instances can use
    #     the reserved capacity.
    #   @return [String]
    #
    # @!attribute [rw] create_date
    #   The date and time at which the Capacity Reservation was created.
    #   @return [Time]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the Capacity Reservation.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CapacityReservation AWS API Documentation
    #
    class CapacityReservation < Struct.new(
      :capacity_reservation_id,
      :owner_id,
      :capacity_reservation_arn,
      :availability_zone_id,
      :instance_type,
      :instance_platform,
      :availability_zone,
      :tenancy,
      :total_instance_count,
      :available_instance_count,
      :ebs_optimized,
      :ephemeral_storage,
      :state,
      :end_date,
      :end_date_type,
      :instance_match_criteria,
      :create_date,
      :tags)
      include Aws::Structure
    end

    # Describes the strategy for using unused Capacity Reservations for
    # fulfilling On-Demand capacity.
    #
    # <note markdown="1"> This strategy can only be used if the EC2 Fleet is of type `instant`.
    #
    #  </note>
    #
    # For more information about Capacity Reservations, see [On-Demand
    # Capacity Reservations][1] in the *Amazon Elastic Compute Cloud User
    # Guide*. For examples of using Capacity Reservations in an EC2 Fleet,
    # see [EC2 Fleet Example Configurations][2] in the *Amazon Elastic
    # Compute Cloud User Guide*.
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-capacity-reservations.html
    # [2]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-fleet-examples.html
    #
    # @!attribute [rw] usage_strategy
    #   Indicates whether to use unused Capacity Reservations for fulfilling
    #   On-Demand capacity.
    #
    #   If you specify `use-capacity-reservations-first`, the fleet uses
    #   unused Capacity Reservations to fulfill On-Demand capacity up to the
    #   target On-Demand capacity. If multiple instance pools have unused
    #   Capacity Reservations, the On-Demand allocation strategy
    #   (`lowest-price` or `prioritized`) is applied. If the number of
    #   unused Capacity Reservations is less than the On-Demand target
    #   capacity, the remaining On-Demand target capacity is launched
    #   according to the On-Demand allocation strategy (`lowest-price` or
    #   `prioritized`).
    #
    #   If you do not specify a value, the fleet fulfils the On-Demand
    #   capacity according to the chosen On-Demand allocation strategy.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CapacityReservationOptions AWS API Documentation
    #
    class CapacityReservationOptions < Struct.new(
      :usage_strategy)
      include Aws::Structure
    end

    # Describes the strategy for using unused Capacity Reservations for
    # fulfilling On-Demand capacity.
    #
    # <note markdown="1"> This strategy can only be used if the EC2 Fleet is of type `instant`.
    #
    #  </note>
    #
    # For more information about Capacity Reservations, see [On-Demand
    # Capacity Reservations][1] in the *Amazon Elastic Compute Cloud User
    # Guide*. For examples of using Capacity Reservations in an EC2 Fleet,
    # see [EC2 Fleet Example Configurations][2] in the *Amazon Elastic
    # Compute Cloud User Guide*.
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-capacity-reservations.html
    # [2]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-fleet-examples.html
    #
    # @note When making an API call, you may pass CapacityReservationOptionsRequest
    #   data as a hash:
    #
    #       {
    #         usage_strategy: "use-capacity-reservations-first", # accepts use-capacity-reservations-first
    #       }
    #
    # @!attribute [rw] usage_strategy
    #   Indicates whether to use unused Capacity Reservations for fulfilling
    #   On-Demand capacity.
    #
    #   If you specify `use-capacity-reservations-first`, the fleet uses
    #   unused Capacity Reservations to fulfill On-Demand capacity up to the
    #   target On-Demand capacity. If multiple instance pools have unused
    #   Capacity Reservations, the On-Demand allocation strategy
    #   (`lowest-price` or `prioritized`) is applied. If the number of
    #   unused Capacity Reservations is less than the On-Demand target
    #   capacity, the remaining On-Demand target capacity is launched
    #   according to the On-Demand allocation strategy (`lowest-price` or
    #   `prioritized`).
    #
    #   If you do not specify a value, the fleet fulfils the On-Demand
    #   capacity according to the chosen On-Demand allocation strategy.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CapacityReservationOptionsRequest AWS API Documentation
    #
    class CapacityReservationOptionsRequest < Struct.new(
      :usage_strategy)
      include Aws::Structure
    end

    # Describes an instance's Capacity Reservation targeting option. You
    # can specify only one parameter at a time. If you specify
    # `CapacityReservationPreference` and `CapacityReservationTarget`, the
    # request fails.
    #
    # Use the `CapacityReservationPreference` parameter to configure the
    # instance to run as an On-Demand Instance or to run in any `open`
    # Capacity Reservation that has matching attributes (instance type,
    # platform, Availability Zone). Use the `CapacityReservationTarget`
    # parameter to explicitly target a specific Capacity Reservation.
    #
    # @note When making an API call, you may pass CapacityReservationSpecification
    #   data as a hash:
    #
    #       {
    #         capacity_reservation_preference: "open", # accepts open, none
    #         capacity_reservation_target: {
    #           capacity_reservation_id: "CapacityReservationId",
    #         },
    #       }
    #
    # @!attribute [rw] capacity_reservation_preference
    #   Indicates the instance's Capacity Reservation preferences. Possible
    #   preferences include:
    #
    #   * `open` - The instance can run in any `open` Capacity Reservation
    #     that has matching attributes (instance type, platform,
    #     Availability Zone).
    #
    #   * `none` - The instance avoids running in a Capacity Reservation
    #     even if one is available. The instance runs as an On-Demand
    #     Instance.
    #   @return [String]
    #
    # @!attribute [rw] capacity_reservation_target
    #   Information about the target Capacity Reservation.
    #   @return [Types::CapacityReservationTarget]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CapacityReservationSpecification AWS API Documentation
    #
    class CapacityReservationSpecification < Struct.new(
      :capacity_reservation_preference,
      :capacity_reservation_target)
      include Aws::Structure
    end

    # Describes the instance's Capacity Reservation targeting preferences.
    # The action returns the `capacityReservationPreference` response
    # element if the instance is configured to run in On-Demand capacity, or
    # if it is configured in run in any `open` Capacity Reservation that has
    # matching attributes (instance type, platform, Availability Zone). The
    # action returns the `capacityReservationTarget` response element if the
    # instance explicily targets a specific Capacity Reservation.
    #
    # @!attribute [rw] capacity_reservation_preference
    #   Describes the instance's Capacity Reservation preferences. Possible
    #   preferences include:
    #
    #   * `open` - The instance can run in any `open` Capacity Reservation
    #     that has matching attributes (instance type, platform,
    #     Availability Zone).
    #
    #   * `none` - The instance avoids running in a Capacity Reservation
    #     even if one is available. The instance runs in On-Demand capacity.
    #   @return [String]
    #
    # @!attribute [rw] capacity_reservation_target
    #   Information about the targeted Capacity Reservation.
    #   @return [Types::CapacityReservationTargetResponse]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CapacityReservationSpecificationResponse AWS API Documentation
    #
    class CapacityReservationSpecificationResponse < Struct.new(
      :capacity_reservation_preference,
      :capacity_reservation_target)
      include Aws::Structure
    end

    # Describes a target Capacity Reservation.
    #
    # @note When making an API call, you may pass CapacityReservationTarget
    #   data as a hash:
    #
    #       {
    #         capacity_reservation_id: "CapacityReservationId",
    #       }
    #
    # @!attribute [rw] capacity_reservation_id
    #   The ID of the Capacity Reservation.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CapacityReservationTarget AWS API Documentation
    #
    class CapacityReservationTarget < Struct.new(
      :capacity_reservation_id)
      include Aws::Structure
    end

    # Describes a target Capacity Reservation.
    #
    # @!attribute [rw] capacity_reservation_id
    #   The ID of the Capacity Reservation.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CapacityReservationTargetResponse AWS API Documentation
    #
    class CapacityReservationTargetResponse < Struct.new(
      :capacity_reservation_id)
      include Aws::Structure
    end

    # Information about the client certificate used for authentication.
    #
    # @!attribute [rw] client_root_certificate_chain
    #   The ARN of the client certificate.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CertificateAuthentication AWS API Documentation
    #
    class CertificateAuthentication < Struct.new(
      :client_root_certificate_chain)
      include Aws::Structure
    end

    # Information about the client certificate to be used for
    # authentication.
    #
    # @note When making an API call, you may pass CertificateAuthenticationRequest
    #   data as a hash:
    #
    #       {
    #         client_root_certificate_chain_arn: "String",
    #       }
    #
    # @!attribute [rw] client_root_certificate_chain_arn
    #   The ARN of the client certificate. The certificate must be signed by
    #   a certificate authority (CA) and it must be provisioned in AWS
    #   Certificate Manager (ACM).
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CertificateAuthenticationRequest AWS API Documentation
    #
    class CertificateAuthenticationRequest < Struct.new(
      :client_root_certificate_chain_arn)
      include Aws::Structure
    end

    # Provides authorization for Amazon to bring a specific IP address range
    # to a specific AWS account using bring your own IP addresses (BYOIP).
    # For more information, see [Prepare to Bring Your Address Range to Your
    # AWS Account][1] in the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-byoip.html#prepare-for-byoip
    #
    # @note When making an API call, you may pass CidrAuthorizationContext
    #   data as a hash:
    #
    #       {
    #         message: "String", # required
    #         signature: "String", # required
    #       }
    #
    # @!attribute [rw] message
    #   The plain-text authorization message for the prefix and account.
    #   @return [String]
    #
    # @!attribute [rw] signature
    #   The signed authorization message for the prefix and account.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CidrAuthorizationContext AWS API Documentation
    #
    class CidrAuthorizationContext < Struct.new(
      :message,
      :signature)
      include Aws::Structure
    end

    # Describes an IPv4 CIDR block.
    #
    # @!attribute [rw] cidr_block
    #   The IPv4 CIDR block.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CidrBlock AWS API Documentation
    #
    class CidrBlock < Struct.new(
      :cidr_block)
      include Aws::Structure
    end

    # Describes the ClassicLink DNS support status of a VPC.
    #
    # @!attribute [rw] classic_link_dns_supported
    #   Indicates whether ClassicLink DNS support is enabled for the VPC.
    #   @return [Boolean]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ClassicLinkDnsSupport AWS API Documentation
    #
    class ClassicLinkDnsSupport < Struct.new(
      :classic_link_dns_supported,
      :vpc_id)
      include Aws::Structure
    end

    # Describes a linked EC2-Classic instance.
    #
    # @!attribute [rw] groups
    #   A list of security groups.
    #   @return [Array<Types::GroupIdentifier>]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the instance.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ClassicLinkInstance AWS API Documentation
    #
    class ClassicLinkInstance < Struct.new(
      :groups,
      :instance_id,
      :tags,
      :vpc_id)
      include Aws::Structure
    end

    # Describes a Classic Load Balancer.
    #
    # @note When making an API call, you may pass ClassicLoadBalancer
    #   data as a hash:
    #
    #       {
    #         name: "String",
    #       }
    #
    # @!attribute [rw] name
    #   The name of the load balancer.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ClassicLoadBalancer AWS API Documentation
    #
    class ClassicLoadBalancer < Struct.new(
      :name)
      include Aws::Structure
    end

    # Describes the Classic Load Balancers to attach to a Spot Fleet. Spot
    # Fleet registers the running Spot Instances with these Classic Load
    # Balancers.
    #
    # @note When making an API call, you may pass ClassicLoadBalancersConfig
    #   data as a hash:
    #
    #       {
    #         classic_load_balancers: [
    #           {
    #             name: "String",
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] classic_load_balancers
    #   One or more Classic Load Balancers.
    #   @return [Array<Types::ClassicLoadBalancer>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ClassicLoadBalancersConfig AWS API Documentation
    #
    class ClassicLoadBalancersConfig < Struct.new(
      :classic_load_balancers)
      include Aws::Structure
    end

    # Describes the state of a client certificate revocation list.
    #
    # @!attribute [rw] code
    #   The state of the client certificate revocation list.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   A message about the status of the client certificate revocation
    #   list, if applicable.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ClientCertificateRevocationListStatus AWS API Documentation
    #
    class ClientCertificateRevocationListStatus < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # Describes the client-specific data.
    #
    # @note When making an API call, you may pass ClientData
    #   data as a hash:
    #
    #       {
    #         comment: "String",
    #         upload_end: Time.now,
    #         upload_size: 1.0,
    #         upload_start: Time.now,
    #       }
    #
    # @!attribute [rw] comment
    #   A user-defined comment about the disk upload.
    #   @return [String]
    #
    # @!attribute [rw] upload_end
    #   The time that the disk upload ends.
    #   @return [Time]
    #
    # @!attribute [rw] upload_size
    #   The size of the uploaded disk image, in GiB.
    #   @return [Float]
    #
    # @!attribute [rw] upload_start
    #   The time that the disk upload starts.
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ClientData AWS API Documentation
    #
    class ClientData < Struct.new(
      :comment,
      :upload_end,
      :upload_size,
      :upload_start)
      include Aws::Structure
    end

    # Describes the authentication methods used by a Client VPN endpoint.
    # For more information, see [Authentication][1] in the *AWS Client VPN
    # Administrator Guide*.
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/authentication-authrization.html#client-authentication
    #
    # @!attribute [rw] type
    #   The authentication type used.
    #   @return [String]
    #
    # @!attribute [rw] active_directory
    #   Information about the Active Directory, if applicable.
    #   @return [Types::DirectoryServiceAuthentication]
    #
    # @!attribute [rw] mutual_authentication
    #   Information about the authentication certificates, if applicable.
    #   @return [Types::CertificateAuthentication]
    #
    # @!attribute [rw] federated_authentication
    #   Information about the IAM SAML identity provider, if applicable.
    #   @return [Types::FederatedAuthentication]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ClientVpnAuthentication AWS API Documentation
    #
    class ClientVpnAuthentication < Struct.new(
      :type,
      :active_directory,
      :mutual_authentication,
      :federated_authentication)
      include Aws::Structure
    end

    # Describes the authentication method to be used by a Client VPN
    # endpoint. For more information, see [Authentication][1] in the *AWS
    # Client VPN Administrator Guide*.
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/authentication-authrization.html#client-authentication
    #
    # @note When making an API call, you may pass ClientVpnAuthenticationRequest
    #   data as a hash:
    #
    #       {
    #         type: "certificate-authentication", # accepts certificate-authentication, directory-service-authentication, federated-authentication
    #         active_directory: {
    #           directory_id: "String",
    #         },
    #         mutual_authentication: {
    #           client_root_certificate_chain_arn: "String",
    #         },
    #         federated_authentication: {
    #           saml_provider_arn: "String",
    #         },
    #       }
    #
    # @!attribute [rw] type
    #   The type of client authentication to be used.
    #   @return [String]
    #
    # @!attribute [rw] active_directory
    #   Information about the Active Directory to be used, if applicable.
    #   You must provide this information if **Type** is
    #   `directory-service-authentication`.
    #   @return [Types::DirectoryServiceAuthenticationRequest]
    #
    # @!attribute [rw] mutual_authentication
    #   Information about the authentication certificates to be used, if
    #   applicable. You must provide this information if **Type** is
    #   `certificate-authentication`.
    #   @return [Types::CertificateAuthenticationRequest]
    #
    # @!attribute [rw] federated_authentication
    #   Information about the IAM SAML identity provider to be used, if
    #   applicable. You must provide this information if **Type** is
    #   `federated-authentication`.
    #   @return [Types::FederatedAuthenticationRequest]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ClientVpnAuthenticationRequest AWS API Documentation
    #
    class ClientVpnAuthenticationRequest < Struct.new(
      :type,
      :active_directory,
      :mutual_authentication,
      :federated_authentication)
      include Aws::Structure
    end

    # Describes the state of an authorization rule.
    #
    # @!attribute [rw] code
    #   The state of the authorization rule.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   A message about the status of the authorization rule, if applicable.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ClientVpnAuthorizationRuleStatus AWS API Documentation
    #
    class ClientVpnAuthorizationRuleStatus < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # Describes a client connection.
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint to which the client is connected.
    #   @return [String]
    #
    # @!attribute [rw] timestamp
    #   The current date and time.
    #   @return [String]
    #
    # @!attribute [rw] connection_id
    #   The ID of the client connection.
    #   @return [String]
    #
    # @!attribute [rw] username
    #   The username of the client who established the client connection.
    #   This information is only provided if Active Directory client
    #   authentication is used.
    #   @return [String]
    #
    # @!attribute [rw] connection_established_time
    #   The date and time the client connection was established.
    #   @return [String]
    #
    # @!attribute [rw] ingress_bytes
    #   The number of bytes sent by the client.
    #   @return [String]
    #
    # @!attribute [rw] egress_bytes
    #   The number of bytes received by the client.
    #   @return [String]
    #
    # @!attribute [rw] ingress_packets
    #   The number of packets sent by the client.
    #   @return [String]
    #
    # @!attribute [rw] egress_packets
    #   The number of packets received by the client.
    #   @return [String]
    #
    # @!attribute [rw] client_ip
    #   The IP address of the client.
    #   @return [String]
    #
    # @!attribute [rw] common_name
    #   The common name associated with the client. This is either the name
    #   of the client certificate, or the Active Directory user name.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The current state of the client connection.
    #   @return [Types::ClientVpnConnectionStatus]
    #
    # @!attribute [rw] connection_end_time
    #   The date and time the client connection was terminated.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ClientVpnConnection AWS API Documentation
    #
    class ClientVpnConnection < Struct.new(
      :client_vpn_endpoint_id,
      :timestamp,
      :connection_id,
      :username,
      :connection_established_time,
      :ingress_bytes,
      :egress_bytes,
      :ingress_packets,
      :egress_packets,
      :client_ip,
      :common_name,
      :status,
      :connection_end_time)
      include Aws::Structure
    end

    # Describes the status of a client connection.
    #
    # @!attribute [rw] code
    #   The state of the client connection.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   A message about the status of the client connection, if applicable.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ClientVpnConnectionStatus AWS API Documentation
    #
    class ClientVpnConnectionStatus < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # Describes a Client VPN endpoint.
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   A brief description of the endpoint.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The current state of the Client VPN endpoint.
    #   @return [Types::ClientVpnEndpointStatus]
    #
    # @!attribute [rw] creation_time
    #   The date and time the Client VPN endpoint was created.
    #   @return [String]
    #
    # @!attribute [rw] deletion_time
    #   The date and time the Client VPN endpoint was deleted, if
    #   applicable.
    #   @return [String]
    #
    # @!attribute [rw] dns_name
    #   The DNS name to be used by clients when connecting to the Client VPN
    #   endpoint.
    #   @return [String]
    #
    # @!attribute [rw] client_cidr_block
    #   The IPv4 address range, in CIDR notation, from which client IP
    #   addresses are assigned.
    #   @return [String]
    #
    # @!attribute [rw] dns_servers
    #   Information about the DNS servers to be used for DNS resolution.
    #   @return [Array<String>]
    #
    # @!attribute [rw] split_tunnel
    #   Indicates whether split-tunnel is enabled in the AWS Client VPN
    #   endpoint.
    #
    #   For information about split-tunnel VPN endpoints, see [Split-Tunnel
    #   AWS Client VPN Endpoint][1] in the *AWS Client VPN Administrator
    #   Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/split-tunnel-vpn.html
    #   @return [Boolean]
    #
    # @!attribute [rw] vpn_protocol
    #   The protocol used by the VPN session.
    #   @return [String]
    #
    # @!attribute [rw] transport_protocol
    #   The transport protocol used by the Client VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] vpn_port
    #   The port number for the Client VPN endpoint.
    #   @return [Integer]
    #
    # @!attribute [rw] associated_target_networks
    #   Information about the associated target networks. A target network
    #   is a subnet in a VPC.
    #   @return [Array<Types::AssociatedTargetNetwork>]
    #
    # @!attribute [rw] server_certificate_arn
    #   The ARN of the server certificate.
    #   @return [String]
    #
    # @!attribute [rw] authentication_options
    #   Information about the authentication method used by the Client VPN
    #   endpoint.
    #   @return [Array<Types::ClientVpnAuthentication>]
    #
    # @!attribute [rw] connection_log_options
    #   Information about the client connection logging options for the
    #   Client VPN endpoint.
    #   @return [Types::ConnectionLogResponseOptions]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the Client VPN endpoint.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] security_group_ids
    #   The IDs of the security groups for the target network.
    #   @return [Array<String>]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ClientVpnEndpoint AWS API Documentation
    #
    class ClientVpnEndpoint < Struct.new(
      :client_vpn_endpoint_id,
      :description,
      :status,
      :creation_time,
      :deletion_time,
      :dns_name,
      :client_cidr_block,
      :dns_servers,
      :split_tunnel,
      :vpn_protocol,
      :transport_protocol,
      :vpn_port,
      :associated_target_networks,
      :server_certificate_arn,
      :authentication_options,
      :connection_log_options,
      :tags,
      :security_group_ids,
      :vpc_id)
      include Aws::Structure
    end

    # Describes the state of a Client VPN endpoint.
    #
    # @!attribute [rw] code
    #   The state of the Client VPN endpoint. Possible states include:
    #
    #   * `pending-associate` - The Client VPN endpoint has been created but
    #     no target networks have been associated. The Client VPN endpoint
    #     cannot accept connections.
    #
    #   * `available` - The Client VPN endpoint has been created and a
    #     target network has been associated. The Client VPN endpoint can
    #     accept connections.
    #
    #   * `deleting` - The Client VPN endpoint is being deleted. The Client
    #     VPN endpoint cannot accept connections.
    #
    #   * `deleted` - The Client VPN endpoint has been deleted. The Client
    #     VPN endpoint cannot accept connections.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   A message about the status of the Client VPN endpoint.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ClientVpnEndpointStatus AWS API Documentation
    #
    class ClientVpnEndpointStatus < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # Information about a Client VPN endpoint route.
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint with which the route is
    #   associated.
    #   @return [String]
    #
    # @!attribute [rw] destination_cidr
    #   The IPv4 address range, in CIDR notation, of the route destination.
    #   @return [String]
    #
    # @!attribute [rw] target_subnet
    #   The ID of the subnet through which traffic is routed.
    #   @return [String]
    #
    # @!attribute [rw] type
    #   The route type.
    #   @return [String]
    #
    # @!attribute [rw] origin
    #   Indicates how the route was associated with the Client VPN endpoint.
    #   `associate` indicates that the route was automatically added when
    #   the target network was associated with the Client VPN endpoint.
    #   `add-route` indicates that the route was manually added using the
    #   **CreateClientVpnRoute** action.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The current state of the route.
    #   @return [Types::ClientVpnRouteStatus]
    #
    # @!attribute [rw] description
    #   A brief description of the route.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ClientVpnRoute AWS API Documentation
    #
    class ClientVpnRoute < Struct.new(
      :client_vpn_endpoint_id,
      :destination_cidr,
      :target_subnet,
      :type,
      :origin,
      :status,
      :description)
      include Aws::Structure
    end

    # Describes the state of a Client VPN endpoint route.
    #
    # @!attribute [rw] code
    #   The state of the Client VPN endpoint route.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   A message about the status of the Client VPN endpoint route, if
    #   applicable.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ClientVpnRouteStatus AWS API Documentation
    #
    class ClientVpnRouteStatus < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # Describes address usage for a customer-owned address pool.
    #
    # @!attribute [rw] allocation_id
    #   The allocation ID of the address.
    #   @return [String]
    #
    # @!attribute [rw] aws_account_id
    #   The AWS account ID.
    #   @return [String]
    #
    # @!attribute [rw] aws_service
    #   The AWS service.
    #   @return [String]
    #
    # @!attribute [rw] co_ip
    #   The customer-owned IP address.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CoipAddressUsage AWS API Documentation
    #
    class CoipAddressUsage < Struct.new(
      :allocation_id,
      :aws_account_id,
      :aws_service,
      :co_ip)
      include Aws::Structure
    end

    # Describes a customer-owned address pool.
    #
    # @!attribute [rw] pool_id
    #   The ID of the address pool.
    #   @return [String]
    #
    # @!attribute [rw] pool_cidrs
    #   The address ranges of the address pool.
    #   @return [Array<String>]
    #
    # @!attribute [rw] local_gateway_route_table_id
    #   The ID of the local gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CoipPool AWS API Documentation
    #
    class CoipPool < Struct.new(
      :pool_id,
      :pool_cidrs,
      :local_gateway_route_table_id,
      :tags)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ConfirmProductInstanceRequest
    #   data as a hash:
    #
    #       {
    #         instance_id: "InstanceId", # required
    #         product_code: "String", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] product_code
    #   The product code. This must be a product code that you own.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ConfirmProductInstanceRequest AWS API Documentation
    #
    class ConfirmProductInstanceRequest < Struct.new(
      :instance_id,
      :product_code,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] owner_id
    #   The AWS account ID of the instance owner. This is only present if
    #   the product code is attached to the instance.
    #   @return [String]
    #
    # @!attribute [rw] return
    #   The return value of the request. Returns `true` if the specified
    #   product code is owned by the requester and associated with the
    #   specified instance.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ConfirmProductInstanceResult AWS API Documentation
    #
    class ConfirmProductInstanceResult < Struct.new(
      :owner_id,
      :return)
      include Aws::Structure
    end

    # Describes the client connection logging options for the Client VPN
    # endpoint.
    #
    # @note When making an API call, you may pass ConnectionLogOptions
    #   data as a hash:
    #
    #       {
    #         enabled: false,
    #         cloudwatch_log_group: "String",
    #         cloudwatch_log_stream: "String",
    #       }
    #
    # @!attribute [rw] enabled
    #   Indicates whether connection logging is enabled.
    #   @return [Boolean]
    #
    # @!attribute [rw] cloudwatch_log_group
    #   The name of the CloudWatch Logs log group.
    #   @return [String]
    #
    # @!attribute [rw] cloudwatch_log_stream
    #   The name of the CloudWatch Logs log stream to which the connection
    #   data is published.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ConnectionLogOptions AWS API Documentation
    #
    class ConnectionLogOptions < Struct.new(
      :enabled,
      :cloudwatch_log_group,
      :cloudwatch_log_stream)
      include Aws::Structure
    end

    # Information about the client connection logging options for a Client
    # VPN endpoint.
    #
    # @!attribute [rw] enabled
    #   Indicates whether client connection logging is enabled for the
    #   Client VPN endpoint.
    #   @return [Boolean]
    #
    # @!attribute [rw] cloudwatch_log_group
    #   The name of the Amazon CloudWatch Logs log group to which connection
    #   logging data is published.
    #   @return [String]
    #
    # @!attribute [rw] cloudwatch_log_stream
    #   The name of the Amazon CloudWatch Logs log stream to which
    #   connection logging data is published.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ConnectionLogResponseOptions AWS API Documentation
    #
    class ConnectionLogResponseOptions < Struct.new(
      :enabled,
      :cloudwatch_log_group,
      :cloudwatch_log_stream)
      include Aws::Structure
    end

    # Describes a connection notification for a VPC endpoint or VPC endpoint
    # service.
    #
    # @!attribute [rw] connection_notification_id
    #   The ID of the notification.
    #   @return [String]
    #
    # @!attribute [rw] service_id
    #   The ID of the endpoint service.
    #   @return [String]
    #
    # @!attribute [rw] vpc_endpoint_id
    #   The ID of the VPC endpoint.
    #   @return [String]
    #
    # @!attribute [rw] connection_notification_type
    #   The type of notification.
    #   @return [String]
    #
    # @!attribute [rw] connection_notification_arn
    #   The ARN of the SNS topic for the notification.
    #   @return [String]
    #
    # @!attribute [rw] connection_events
    #   The events for the notification. Valid values are `Accept`,
    #   `Connect`, `Delete`, and `Reject`.
    #   @return [Array<String>]
    #
    # @!attribute [rw] connection_notification_state
    #   The state of the notification.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ConnectionNotification AWS API Documentation
    #
    class ConnectionNotification < Struct.new(
      :connection_notification_id,
      :service_id,
      :vpc_endpoint_id,
      :connection_notification_type,
      :connection_notification_arn,
      :connection_events,
      :connection_notification_state)
      include Aws::Structure
    end

    # Describes a conversion task.
    #
    # @!attribute [rw] conversion_task_id
    #   The ID of the conversion task.
    #   @return [String]
    #
    # @!attribute [rw] expiration_time
    #   The time when the task expires. If the upload isn't complete before
    #   the expiration time, we automatically cancel the task.
    #   @return [String]
    #
    # @!attribute [rw] import_instance
    #   If the task is for importing an instance, this contains information
    #   about the import instance task.
    #   @return [Types::ImportInstanceTaskDetails]
    #
    # @!attribute [rw] import_volume
    #   If the task is for importing a volume, this contains information
    #   about the import volume task.
    #   @return [Types::ImportVolumeTaskDetails]
    #
    # @!attribute [rw] state
    #   The state of the conversion task.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   The status message related to the conversion task.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the task.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ConversionTask AWS API Documentation
    #
    class ConversionTask < Struct.new(
      :conversion_task_id,
      :expiration_time,
      :import_instance,
      :import_volume,
      :state,
      :status_message,
      :tags)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CopyFpgaImageRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         source_fpga_image_id: "FpgaImageId", # required
    #         description: "String",
    #         name: "String",
    #         source_region: "String", # required
    #         client_token: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] source_fpga_image_id
    #   The ID of the source AFI.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   The description for the new AFI.
    #   @return [String]
    #
    # @!attribute [rw] name
    #   The name for the new AFI. The default is the name of the source AFI.
    #   @return [String]
    #
    # @!attribute [rw] source_region
    #   The Region that contains the source AFI.
    #   @return [String]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [Ensuring
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CopyFpgaImageRequest AWS API Documentation
    #
    class CopyFpgaImageRequest < Struct.new(
      :dry_run,
      :source_fpga_image_id,
      :description,
      :name,
      :source_region,
      :client_token)
      include Aws::Structure
    end

    # @!attribute [rw] fpga_image_id
    #   The ID of the new AFI.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CopyFpgaImageResult AWS API Documentation
    #
    class CopyFpgaImageResult < Struct.new(
      :fpga_image_id)
      include Aws::Structure
    end

    # Contains the parameters for CopyImage.
    #
    # @note When making an API call, you may pass CopyImageRequest
    #   data as a hash:
    #
    #       {
    #         client_token: "String",
    #         description: "String",
    #         encrypted: false,
    #         kms_key_id: "KmsKeyId",
    #         name: "String", # required
    #         source_image_id: "String", # required
    #         source_region: "String", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier you provide to ensure idempotency
    #   of the request. For more information, see [How to Ensure
    #   Idempotency][1] in the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] description
    #   A description for the new AMI in the destination Region.
    #   @return [String]
    #
    # @!attribute [rw] encrypted
    #   Specifies whether the destination snapshots of the copied image
    #   should be encrypted. You can encrypt a copy of an unencrypted
    #   snapshot, but you cannot create an unencrypted copy of an encrypted
    #   snapshot. The default CMK for EBS is used unless you specify a
    #   non-default AWS Key Management Service (AWS KMS) CMK using
    #   `KmsKeyId`. For more information, see [Amazon EBS Encryption][1] in
    #   the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html
    #   @return [Boolean]
    #
    # @!attribute [rw] kms_key_id
    #   An identifier for the symmetric AWS Key Management Service (AWS KMS)
    #   customer master key (CMK) to use when creating the encrypted volume.
    #   This parameter is only required if you want to use a non-default
    #   CMK; if this parameter is not specified, the default CMK for EBS is
    #   used. If a `KmsKeyId` is specified, the `Encrypted` flag must also
    #   be set.
    #
    #   To specify a CMK, use its key ID, Amazon Resource Name (ARN), alias
    #   name, or alias ARN. When using an alias name, prefix it with
    #   "alias/". For example:
    #
    #   * Key ID: `1234abcd-12ab-34cd-56ef-1234567890ab`
    #
    #   * Key ARN:
    #     `arn:aws:kms:us-east-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab`
    #
    #   * Alias name: `alias/ExampleAlias`
    #
    #   * Alias ARN: `arn:aws:kms:us-east-2:111122223333:alias/ExampleAlias`
    #
    #   AWS parses `KmsKeyId` asynchronously, meaning that the action you
    #   call may appear to complete even though you provided an invalid
    #   identifier. This action will eventually report failure.
    #
    #   The specified CMK must exist in the Region that the snapshot is
    #   being copied to.
    #
    #   Amazon EBS does not support asymmetric CMKs.
    #   @return [String]
    #
    # @!attribute [rw] name
    #   The name of the new AMI in the destination Region.
    #   @return [String]
    #
    # @!attribute [rw] source_image_id
    #   The ID of the AMI to copy.
    #   @return [String]
    #
    # @!attribute [rw] source_region
    #   The name of the Region that contains the AMI to copy.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CopyImageRequest AWS API Documentation
    #
    class CopyImageRequest < Struct.new(
      :client_token,
      :description,
      :encrypted,
      :kms_key_id,
      :name,
      :source_image_id,
      :source_region,
      :dry_run)
      include Aws::Structure
    end

    # Contains the output of CopyImage.
    #
    # @!attribute [rw] image_id
    #   The ID of the new AMI.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CopyImageResult AWS API Documentation
    #
    class CopyImageResult < Struct.new(
      :image_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CopySnapshotRequest
    #   data as a hash:
    #
    #       {
    #         description: "String",
    #         destination_region: "String",
    #         encrypted: false,
    #         kms_key_id: "KmsKeyId",
    #         presigned_url: "String",
    #         source_region: "String", # required
    #         source_snapshot_id: "String", # required
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] description
    #   A description for the EBS snapshot.
    #   @return [String]
    #
    # @!attribute [rw] destination_region
    #   The destination Region to use in the `PresignedUrl` parameter of a
    #   snapshot copy operation. This parameter is only valid for specifying
    #   the destination Region in a `PresignedUrl` parameter, where it is
    #   required.
    #
    #   The snapshot copy is sent to the regional endpoint that you sent the
    #   HTTP request to (for example, `ec2.us-east-1.amazonaws.com`). With
    #   the AWS CLI, this is specified using the `--region` parameter or the
    #   default Region in your AWS configuration file.
    #   @return [String]
    #
    # @!attribute [rw] encrypted
    #   To encrypt a copy of an unencrypted snapshot if encryption by
    #   default is not enabled, enable encryption using this parameter.
    #   Otherwise, omit this parameter. Encrypted snapshots are encrypted,
    #   even if you omit this parameter and encryption by default is not
    #   enabled. You cannot set this parameter to false. For more
    #   information, see [Amazon EBS Encryption][1] in the *Amazon Elastic
    #   Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html
    #   @return [Boolean]
    #
    # @!attribute [rw] kms_key_id
    #   The identifier of the AWS Key Management Service (AWS KMS) customer
    #   master key (CMK) to use for Amazon EBS encryption. If this parameter
    #   is not specified, your AWS managed CMK for EBS is used. If
    #   `KmsKeyId` is specified, the encrypted state must be `true`.
    #
    #   You can specify the CMK using any of the following:
    #
    #   * Key ID. For example, key/1234abcd-12ab-34cd-56ef-1234567890ab.
    #
    #   * Key alias. For example, alias/ExampleAlias.
    #
    #   * Key ARN. For example,
    #     arn:aws:kms:*us-east-1*\:*012345678910*\:key/*abcd1234-a123-456a-a12b-a123b4cd56ef*.
    #
    #   * Alias ARN. For example,
    #     arn:aws:kms:*us-east-1*\:*012345678910*\:alias/*ExampleAlias*.
    #
    #   AWS authenticates the CMK asynchronously. Therefore, if you specify
    #   an ID, alias, or ARN that is not valid, the action can appear to
    #   complete, but eventually fails.
    #   @return [String]
    #
    # @!attribute [rw] presigned_url
    #   When you copy an encrypted source snapshot using the Amazon EC2
    #   Query API, you must supply a pre-signed URL. This parameter is
    #   optional for unencrypted snapshots. For more information, see [Query
    #   Requests][1].
    #
    #   The `PresignedUrl` should use the snapshot source endpoint, the
    #   `CopySnapshot` action, and include the `SourceRegion`,
    #   `SourceSnapshotId`, and `DestinationRegion` parameters. The
    #   `PresignedUrl` must be signed using AWS Signature Version 4. Because
    #   EBS snapshots are stored in Amazon S3, the signing algorithm for
    #   this parameter uses the same logic that is described in
    #   [Authenticating Requests by Using Query Parameters (AWS Signature
    #   Version 4)][2] in the *Amazon Simple Storage Service API Reference*.
    #   An invalid or improperly signed `PresignedUrl` will cause the copy
    #   operation to fail asynchronously, and the snapshot will move to an
    #   `error` state.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Query-Requests.html
    #   [2]: https://docs.aws.amazon.com/AmazonS3/latest/API/sigv4-query-string-auth.html
    #   @return [String]
    #
    # @!attribute [rw] source_region
    #   The ID of the Region that contains the snapshot to be copied.
    #   @return [String]
    #
    # @!attribute [rw] source_snapshot_id
    #   The ID of the EBS snapshot to copy.
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the new snapshot.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CopySnapshotRequest AWS API Documentation
    #
    class CopySnapshotRequest < Struct.new(
      :description,
      :destination_region,
      :encrypted,
      :kms_key_id,
      :presigned_url,
      :source_region,
      :source_snapshot_id,
      :tag_specifications,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] snapshot_id
    #   The ID of the new snapshot.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Any tags applied to the new snapshot.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CopySnapshotResult AWS API Documentation
    #
    class CopySnapshotResult < Struct.new(
      :snapshot_id,
      :tags)
      include Aws::Structure
    end

    # The CPU options for the instance.
    #
    # @!attribute [rw] core_count
    #   The number of CPU cores for the instance.
    #   @return [Integer]
    #
    # @!attribute [rw] threads_per_core
    #   The number of threads per CPU core.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CpuOptions AWS API Documentation
    #
    class CpuOptions < Struct.new(
      :core_count,
      :threads_per_core)
      include Aws::Structure
    end

    # The CPU options for the instance. Both the core count and threads per
    # core must be specified in the request.
    #
    # @note When making an API call, you may pass CpuOptionsRequest
    #   data as a hash:
    #
    #       {
    #         core_count: 1,
    #         threads_per_core: 1,
    #       }
    #
    # @!attribute [rw] core_count
    #   The number of CPU cores for the instance.
    #   @return [Integer]
    #
    # @!attribute [rw] threads_per_core
    #   The number of threads per CPU core. To disable multithreading for
    #   the instance, specify a value of `1`. Otherwise, specify the default
    #   value of `2`.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CpuOptionsRequest AWS API Documentation
    #
    class CpuOptionsRequest < Struct.new(
      :core_count,
      :threads_per_core)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateCapacityReservationRequest
    #   data as a hash:
    #
    #       {
    #         client_token: "String",
    #         instance_type: "String", # required
    #         instance_platform: "Linux/UNIX", # required, accepts Linux/UNIX, Red Hat Enterprise Linux, SUSE Linux, Windows, Windows with SQL Server, Windows with SQL Server Enterprise, Windows with SQL Server Standard, Windows with SQL Server Web, Linux with SQL Server Standard, Linux with SQL Server Web, Linux with SQL Server Enterprise
    #         availability_zone: "String",
    #         availability_zone_id: "String",
    #         tenancy: "default", # accepts default, dedicated
    #         instance_count: 1, # required
    #         ebs_optimized: false,
    #         ephemeral_storage: false,
    #         end_date: Time.now,
    #         end_date_type: "unlimited", # accepts unlimited, limited
    #         instance_match_criteria: "open", # accepts open, targeted
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #   Constraint: Maximum 64 ASCII characters.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   The instance type for which to reserve capacity. For more
    #   information, see [Instance Types][1] in the *Amazon Elastic Compute
    #   Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html
    #   @return [String]
    #
    # @!attribute [rw] instance_platform
    #   The type of operating system for which to reserve capacity.
    #   @return [String]
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone in which to create the Capacity Reservation.
    #   @return [String]
    #
    # @!attribute [rw] availability_zone_id
    #   The ID of the Availability Zone in which to create the Capacity
    #   Reservation.
    #   @return [String]
    #
    # @!attribute [rw] tenancy
    #   Indicates the tenancy of the Capacity Reservation. A Capacity
    #   Reservation can have one of the following tenancy settings:
    #
    #   * `default` - The Capacity Reservation is created on hardware that
    #     is shared with other AWS accounts.
    #
    #   * `dedicated` - The Capacity Reservation is created on single-tenant
    #     hardware that is dedicated to a single AWS account.
    #   @return [String]
    #
    # @!attribute [rw] instance_count
    #   The number of instances for which to reserve capacity.
    #   @return [Integer]
    #
    # @!attribute [rw] ebs_optimized
    #   Indicates whether the Capacity Reservation supports EBS-optimized
    #   instances. This optimization provides dedicated throughput to Amazon
    #   EBS and an optimized configuration stack to provide optimal I/O
    #   performance. This optimization isn't available with all instance
    #   types. Additional usage charges apply when using an EBS- optimized
    #   instance.
    #   @return [Boolean]
    #
    # @!attribute [rw] ephemeral_storage
    #   Indicates whether the Capacity Reservation supports instances with
    #   temporary, block-level storage.
    #   @return [Boolean]
    #
    # @!attribute [rw] end_date
    #   The date and time at which the Capacity Reservation expires. When a
    #   Capacity Reservation expires, the reserved capacity is released and
    #   you can no longer launch instances into it. The Capacity
    #   Reservation's state changes to `expired` when it reaches its end
    #   date and time.
    #
    #   You must provide an `EndDate` value if `EndDateType` is `limited`.
    #   Omit `EndDate` if `EndDateType` is `unlimited`.
    #
    #   If the `EndDateType` is `limited`, the Capacity Reservation is
    #   cancelled within an hour from the specified time. For example, if
    #   you specify 5/31/2019, 13:30:55, the Capacity Reservation is
    #   guaranteed to end between 13:30:55 and 14:30:55 on 5/31/2019.
    #   @return [Time]
    #
    # @!attribute [rw] end_date_type
    #   Indicates the way in which the Capacity Reservation ends. A Capacity
    #   Reservation can have one of the following end types:
    #
    #   * `unlimited` - The Capacity Reservation remains active until you
    #     explicitly cancel it. Do not provide an `EndDate` if the
    #     `EndDateType` is `unlimited`.
    #
    #   * `limited` - The Capacity Reservation expires automatically at a
    #     specified date and time. You must provide an `EndDate` value if
    #     the `EndDateType` value is `limited`.
    #   @return [String]
    #
    # @!attribute [rw] instance_match_criteria
    #   Indicates the type of instance launches that the Capacity
    #   Reservation accepts. The options include:
    #
    #   * `open` - The Capacity Reservation automatically matches all
    #     instances that have matching attributes (instance type, platform,
    #     and Availability Zone). Instances that have matching attributes
    #     run in the Capacity Reservation automatically without specifying
    #     any additional parameters.
    #
    #   * `targeted` - The Capacity Reservation only accepts instances that
    #     have matching attributes (instance type, platform, and
    #     Availability Zone), and explicitly target the Capacity
    #     Reservation. This ensures that only permitted instances can use
    #     the reserved capacity.
    #
    #   Default: `open`
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the Capacity Reservation during launch.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateCapacityReservationRequest AWS API Documentation
    #
    class CreateCapacityReservationRequest < Struct.new(
      :client_token,
      :instance_type,
      :instance_platform,
      :availability_zone,
      :availability_zone_id,
      :tenancy,
      :instance_count,
      :ebs_optimized,
      :ephemeral_storage,
      :end_date,
      :end_date_type,
      :instance_match_criteria,
      :tag_specifications,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] capacity_reservation
    #   Information about the Capacity Reservation.
    #   @return [Types::CapacityReservation]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateCapacityReservationResult AWS API Documentation
    #
    class CreateCapacityReservationResult < Struct.new(
      :capacity_reservation)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateClientVpnEndpointRequest
    #   data as a hash:
    #
    #       {
    #         client_cidr_block: "String", # required
    #         server_certificate_arn: "String", # required
    #         authentication_options: [ # required
    #           {
    #             type: "certificate-authentication", # accepts certificate-authentication, directory-service-authentication, federated-authentication
    #             active_directory: {
    #               directory_id: "String",
    #             },
    #             mutual_authentication: {
    #               client_root_certificate_chain_arn: "String",
    #             },
    #             federated_authentication: {
    #               saml_provider_arn: "String",
    #             },
    #           },
    #         ],
    #         connection_log_options: { # required
    #           enabled: false,
    #           cloudwatch_log_group: "String",
    #           cloudwatch_log_stream: "String",
    #         },
    #         dns_servers: ["String"],
    #         transport_protocol: "tcp", # accepts tcp, udp
    #         vpn_port: 1,
    #         description: "String",
    #         split_tunnel: false,
    #         dry_run: false,
    #         client_token: "String",
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         security_group_ids: ["SecurityGroupId"],
    #         vpc_id: "VpcId",
    #       }
    #
    # @!attribute [rw] client_cidr_block
    #   The IPv4 address range, in CIDR notation, from which to assign
    #   client IP addresses. The address range cannot overlap with the local
    #   CIDR of the VPC in which the associated subnet is located, or the
    #   routes that you add manually. The address range cannot be changed
    #   after the Client VPN endpoint has been created. The CIDR block
    #   should be /22 or greater.
    #   @return [String]
    #
    # @!attribute [rw] server_certificate_arn
    #   The ARN of the server certificate. For more information, see the
    #   [AWS Certificate Manager User Guide][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/acm/latest/userguide/
    #   @return [String]
    #
    # @!attribute [rw] authentication_options
    #   Information about the authentication method to be used to
    #   authenticate clients.
    #   @return [Array<Types::ClientVpnAuthenticationRequest>]
    #
    # @!attribute [rw] connection_log_options
    #   Information about the client connection logging options.
    #
    #   If you enable client connection logging, data about client
    #   connections is sent to a Cloudwatch Logs log stream. The following
    #   information is logged:
    #
    #   * Client connection requests
    #
    #   * Client connection results (successful and unsuccessful)
    #
    #   * Reasons for unsuccessful client connection requests
    #
    #   * Client connection termination time
    #   @return [Types::ConnectionLogOptions]
    #
    # @!attribute [rw] dns_servers
    #   Information about the DNS servers to be used for DNS resolution. A
    #   Client VPN endpoint can have up to two DNS servers. If no DNS server
    #   is specified, the DNS address configured on the device is used for
    #   the DNS server.
    #   @return [Array<String>]
    #
    # @!attribute [rw] transport_protocol
    #   The transport protocol to be used by the VPN session.
    #
    #   Default value: `udp`
    #   @return [String]
    #
    # @!attribute [rw] vpn_port
    #   The port number to assign to the Client VPN endpoint for TCP and UDP
    #   traffic.
    #
    #   Valid Values: `443` \| `1194`
    #
    #   Default Value: `443`
    #   @return [Integer]
    #
    # @!attribute [rw] description
    #   A brief description of the Client VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] split_tunnel
    #   Indicates whether split-tunnel is enabled on the AWS Client VPN
    #   endpoint.
    #
    #   By default, split-tunnel on a VPN endpoint is disabled.
    #
    #   For information about split-tunnel VPN endpoints, see [Split-Tunnel
    #   AWS Client VPN Endpoint][1] in the *AWS Client VPN Administrator
    #   Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/split-tunnel-vpn.html
    #   @return [Boolean]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #   **A suitable default value is auto-generated.** You should normally
    #   not need to pass this option.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the Client VPN endpoint during creation.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] security_group_ids
    #   The IDs of one or more security groups to apply to the target
    #   network. You must also specify the ID of the VPC that contains the
    #   security groups.
    #   @return [Array<String>]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC to associate with the Client VPN endpoint. If no
    #   security group IDs are specified in the request, the default
    #   security group for the VPC is applied.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateClientVpnEndpointRequest AWS API Documentation
    #
    class CreateClientVpnEndpointRequest < Struct.new(
      :client_cidr_block,
      :server_certificate_arn,
      :authentication_options,
      :connection_log_options,
      :dns_servers,
      :transport_protocol,
      :vpn_port,
      :description,
      :split_tunnel,
      :dry_run,
      :client_token,
      :tag_specifications,
      :security_group_ids,
      :vpc_id)
      include Aws::Structure
    end

    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The current state of the Client VPN endpoint.
    #   @return [Types::ClientVpnEndpointStatus]
    #
    # @!attribute [rw] dns_name
    #   The DNS name to be used by clients when establishing their VPN
    #   session.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateClientVpnEndpointResult AWS API Documentation
    #
    class CreateClientVpnEndpointResult < Struct.new(
      :client_vpn_endpoint_id,
      :status,
      :dns_name)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateClientVpnRouteRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         destination_cidr_block: "String", # required
    #         target_vpc_subnet_id: "SubnetId", # required
    #         description: "String",
    #         client_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint to which to add the route.
    #   @return [String]
    #
    # @!attribute [rw] destination_cidr_block
    #   The IPv4 address range, in CIDR notation, of the route destination.
    #   For example:
    #
    #   * To add a route for Internet access, enter `0.0.0.0/0`
    #
    #   * To add a route for a peered VPC, enter the peered VPC's IPv4 CIDR
    #     range
    #
    #   * To add a route for an on-premises network, enter the AWS
    #     Site-to-Site VPN connection's IPv4 CIDR range
    #
    #   Route address ranges cannot overlap with the CIDR range specified
    #   for client allocation.
    #   @return [String]
    #
    # @!attribute [rw] target_vpc_subnet_id
    #   The ID of the subnet through which you want to route traffic. The
    #   specified subnet must be an existing target network of the Client
    #   VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   A brief description of the route.
    #   @return [String]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #   **A suitable default value is auto-generated.** You should normally
    #   not need to pass this option.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateClientVpnRouteRequest AWS API Documentation
    #
    class CreateClientVpnRouteRequest < Struct.new(
      :client_vpn_endpoint_id,
      :destination_cidr_block,
      :target_vpc_subnet_id,
      :description,
      :client_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] status
    #   The current state of the route.
    #   @return [Types::ClientVpnRouteStatus]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateClientVpnRouteResult AWS API Documentation
    #
    class CreateClientVpnRouteResult < Struct.new(
      :status)
      include Aws::Structure
    end

    # Contains the parameters for CreateCustomerGateway.
    #
    # @note When making an API call, you may pass CreateCustomerGatewayRequest
    #   data as a hash:
    #
    #       {
    #         bgp_asn: 1, # required
    #         public_ip: "String",
    #         certificate_arn: "String",
    #         type: "ipsec.1", # required, accepts ipsec.1
    #         device_name: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] bgp_asn
    #   For devices that support BGP, the customer gateway's BGP ASN.
    #
    #   Default: 65000
    #   @return [Integer]
    #
    # @!attribute [rw] public_ip
    #   The Internet-routable IP address for the customer gateway's outside
    #   interface. The address must be static.
    #   @return [String]
    #
    # @!attribute [rw] certificate_arn
    #   The Amazon Resource Name (ARN) for the customer gateway certificate.
    #   @return [String]
    #
    # @!attribute [rw] type
    #   The type of VPN connection that this customer gateway supports
    #   (`ipsec.1`).
    #   @return [String]
    #
    # @!attribute [rw] device_name
    #   A name for the customer gateway device.
    #
    #   Length Constraints: Up to 255 characters.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateCustomerGatewayRequest AWS API Documentation
    #
    class CreateCustomerGatewayRequest < Struct.new(
      :bgp_asn,
      :public_ip,
      :certificate_arn,
      :type,
      :device_name,
      :dry_run)
      include Aws::Structure
    end

    # Contains the output of CreateCustomerGateway.
    #
    # @!attribute [rw] customer_gateway
    #   Information about the customer gateway.
    #   @return [Types::CustomerGateway]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateCustomerGatewayResult AWS API Documentation
    #
    class CreateCustomerGatewayResult < Struct.new(
      :customer_gateway)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateDefaultSubnetRequest
    #   data as a hash:
    #
    #       {
    #         availability_zone: "String", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone in which to create the default subnet.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateDefaultSubnetRequest AWS API Documentation
    #
    class CreateDefaultSubnetRequest < Struct.new(
      :availability_zone,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] subnet
    #   Information about the subnet.
    #   @return [Types::Subnet]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateDefaultSubnetResult AWS API Documentation
    #
    class CreateDefaultSubnetResult < Struct.new(
      :subnet)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateDefaultVpcRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateDefaultVpcRequest AWS API Documentation
    #
    class CreateDefaultVpcRequest < Struct.new(
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] vpc
    #   Information about the VPC.
    #   @return [Types::Vpc]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateDefaultVpcResult AWS API Documentation
    #
    class CreateDefaultVpcResult < Struct.new(
      :vpc)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateDhcpOptionsRequest
    #   data as a hash:
    #
    #       {
    #         dhcp_configurations: [ # required
    #           {
    #             key: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] dhcp_configurations
    #   A DHCP configuration option.
    #   @return [Array<Types::NewDhcpConfiguration>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateDhcpOptionsRequest AWS API Documentation
    #
    class CreateDhcpOptionsRequest < Struct.new(
      :dhcp_configurations,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] dhcp_options
    #   A set of DHCP options.
    #   @return [Types::DhcpOptions]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateDhcpOptionsResult AWS API Documentation
    #
    class CreateDhcpOptionsResult < Struct.new(
      :dhcp_options)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateEgressOnlyInternetGatewayRequest
    #   data as a hash:
    #
    #       {
    #         client_token: "String",
    #         dry_run: false,
    #         vpc_id: "VpcId", # required
    #       }
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC for which to create the egress-only internet
    #   gateway.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateEgressOnlyInternetGatewayRequest AWS API Documentation
    #
    class CreateEgressOnlyInternetGatewayRequest < Struct.new(
      :client_token,
      :dry_run,
      :vpc_id)
      include Aws::Structure
    end

    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request.
    #   @return [String]
    #
    # @!attribute [rw] egress_only_internet_gateway
    #   Information about the egress-only internet gateway.
    #   @return [Types::EgressOnlyInternetGateway]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateEgressOnlyInternetGatewayResult AWS API Documentation
    #
    class CreateEgressOnlyInternetGatewayResult < Struct.new(
      :client_token,
      :egress_only_internet_gateway)
      include Aws::Structure
    end

    # Describes the instances that could not be launched by the fleet.
    #
    # @!attribute [rw] launch_template_and_overrides
    #   The launch templates and overrides that were used for launching the
    #   instances. The values that you specify in the Overrides replace the
    #   values in the launch template.
    #   @return [Types::LaunchTemplateAndOverridesResponse]
    #
    # @!attribute [rw] lifecycle
    #   Indicates if the instance that could not be launched was a Spot
    #   Instance or On-Demand Instance.
    #   @return [String]
    #
    # @!attribute [rw] error_code
    #   The error code that indicates why the instance could not be
    #   launched. For more information about error codes, see [Error
    #   Codes][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html
    #   @return [String]
    #
    # @!attribute [rw] error_message
    #   The error message that describes why the instance could not be
    #   launched. For more information about error messages, see [Error
    #   Codes][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateFleetError AWS API Documentation
    #
    class CreateFleetError < Struct.new(
      :launch_template_and_overrides,
      :lifecycle,
      :error_code,
      :error_message)
      include Aws::Structure
    end

    # Describes the instances that were launched by the fleet.
    #
    # @!attribute [rw] launch_template_and_overrides
    #   The launch templates and overrides that were used for launching the
    #   instances. The values that you specify in the Overrides replace the
    #   values in the launch template.
    #   @return [Types::LaunchTemplateAndOverridesResponse]
    #
    # @!attribute [rw] lifecycle
    #   Indicates if the instance that was launched is a Spot Instance or
    #   On-Demand Instance.
    #   @return [String]
    #
    # @!attribute [rw] instance_ids
    #   The IDs of the instances.
    #   @return [Array<String>]
    #
    # @!attribute [rw] instance_type
    #   The instance type.
    #   @return [String]
    #
    # @!attribute [rw] platform
    #   The value is `Windows` for Windows instances. Otherwise, the value
    #   is blank.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateFleetInstance AWS API Documentation
    #
    class CreateFleetInstance < Struct.new(
      :launch_template_and_overrides,
      :lifecycle,
      :instance_ids,
      :instance_type,
      :platform)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateFleetRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         client_token: "String",
    #         spot_options: {
    #           allocation_strategy: "lowest-price", # accepts lowest-price, diversified, capacity-optimized
    #           instance_interruption_behavior: "hibernate", # accepts hibernate, stop, terminate
    #           instance_pools_to_use_count: 1,
    #           single_instance_type: false,
    #           single_availability_zone: false,
    #           min_target_capacity: 1,
    #           max_total_price: "String",
    #         },
    #         on_demand_options: {
    #           allocation_strategy: "lowest-price", # accepts lowest-price, prioritized
    #           capacity_reservation_options: {
    #             usage_strategy: "use-capacity-reservations-first", # accepts use-capacity-reservations-first
    #           },
    #           single_instance_type: false,
    #           single_availability_zone: false,
    #           min_target_capacity: 1,
    #           max_total_price: "String",
    #         },
    #         excess_capacity_termination_policy: "no-termination", # accepts no-termination, termination
    #         launch_template_configs: [ # required
    #           {
    #             launch_template_specification: {
    #               launch_template_id: "LaunchTemplateId",
    #               launch_template_name: "LaunchTemplateName",
    #               version: "String",
    #             },
    #             overrides: [
    #               {
    #                 instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #                 max_price: "String",
    #                 subnet_id: "SubnetId",
    #                 availability_zone: "String",
    #                 weighted_capacity: 1.0,
    #                 priority: 1.0,
    #                 placement: {
    #                   availability_zone: "String",
    #                   affinity: "String",
    #                   group_name: "String",
    #                   partition_number: 1,
    #                   host_id: "String",
    #                   tenancy: "default", # accepts default, dedicated, host
    #                   spread_domain: "String",
    #                   host_resource_group_arn: "String",
    #                 },
    #               },
    #             ],
    #           },
    #         ],
    #         target_capacity_specification: { # required
    #           total_target_capacity: 1, # required
    #           on_demand_target_capacity: 1,
    #           spot_target_capacity: 1,
    #           default_target_capacity_type: "spot", # accepts spot, on-demand
    #         },
    #         terminate_instances_with_expiration: false,
    #         type: "request", # accepts request, maintain, instant
    #         valid_from: Time.now,
    #         valid_until: Time.now,
    #         replace_unhealthy_instances: false,
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [Ensuring
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] spot_options
    #   Describes the configuration of Spot Instances in an EC2 Fleet.
    #   @return [Types::SpotOptionsRequest]
    #
    # @!attribute [rw] on_demand_options
    #   Describes the configuration of On-Demand Instances in an EC2 Fleet.
    #   @return [Types::OnDemandOptionsRequest]
    #
    # @!attribute [rw] excess_capacity_termination_policy
    #   Indicates whether running instances should be terminated if the
    #   total target capacity of the EC2 Fleet is decreased below the
    #   current size of the EC2 Fleet.
    #   @return [String]
    #
    # @!attribute [rw] launch_template_configs
    #   The configuration for the EC2 Fleet.
    #   @return [Array<Types::FleetLaunchTemplateConfigRequest>]
    #
    # @!attribute [rw] target_capacity_specification
    #   The number of units to request.
    #   @return [Types::TargetCapacitySpecificationRequest]
    #
    # @!attribute [rw] terminate_instances_with_expiration
    #   Indicates whether running instances should be terminated when the
    #   EC2 Fleet expires.
    #   @return [Boolean]
    #
    # @!attribute [rw] type
    #   The type of the request. By default, the EC2 Fleet places an
    #   asynchronous request for your desired capacity, and maintains it by
    #   replenishing interrupted Spot Instances (`maintain`). A value of
    #   `instant` places a synchronous one-time request, and returns errors
    #   for any instances that could not be launched. A value of `request`
    #   places an asynchronous one-time request without maintaining capacity
    #   or submitting requests in alternative capacity pools if capacity is
    #   unavailable. For more information, see [EC2 Fleet Request Types][1]
    #   in the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-fleet-configuration-strategies.html#ec2-fleet-request-type
    #   @return [String]
    #
    # @!attribute [rw] valid_from
    #   The start date and time of the request, in UTC format (for example,
    #   *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z). The default is to start
    #   fulfilling the request immediately.
    #   @return [Time]
    #
    # @!attribute [rw] valid_until
    #   The end date and time of the request, in UTC format (for example,
    #   *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z). At this point, no new EC2 Fleet
    #   requests are placed or able to fulfill the request. If no value is
    #   specified, the request remains until you cancel it.
    #   @return [Time]
    #
    # @!attribute [rw] replace_unhealthy_instances
    #   Indicates whether EC2 Fleet should replace unhealthy instances.
    #   @return [Boolean]
    #
    # @!attribute [rw] tag_specifications
    #   The key-value pair for tagging the EC2 Fleet request on creation.
    #   The value for `ResourceType` must be `fleet`, otherwise the fleet
    #   request fails. To tag instances at launch, specify the tags in the
    #   [launch template][1]. For information about tagging after launch,
    #   see [Tagging Your Resources][2].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-launch-templates.html#create-launch-template
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Using_Tags.html#tag-resources
    #   @return [Array<Types::TagSpecification>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateFleetRequest AWS API Documentation
    #
    class CreateFleetRequest < Struct.new(
      :dry_run,
      :client_token,
      :spot_options,
      :on_demand_options,
      :excess_capacity_termination_policy,
      :launch_template_configs,
      :target_capacity_specification,
      :terminate_instances_with_expiration,
      :type,
      :valid_from,
      :valid_until,
      :replace_unhealthy_instances,
      :tag_specifications)
      include Aws::Structure
    end

    # @!attribute [rw] fleet_id
    #   The ID of the EC2 Fleet.
    #   @return [String]
    #
    # @!attribute [rw] errors
    #   Information about the instances that could not be launched by the
    #   fleet. Valid only when **Type** is set to `instant`.
    #   @return [Array<Types::CreateFleetError>]
    #
    # @!attribute [rw] instances
    #   Information about the instances that were launched by the fleet.
    #   Valid only when **Type** is set to `instant`.
    #   @return [Array<Types::CreateFleetInstance>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateFleetResult AWS API Documentation
    #
    class CreateFleetResult < Struct.new(
      :fleet_id,
      :errors,
      :instances)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateFlowLogsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         client_token: "String",
    #         deliver_logs_permission_arn: "String",
    #         log_group_name: "String",
    #         resource_ids: ["FlowLogResourceId"], # required
    #         resource_type: "VPC", # required, accepts VPC, Subnet, NetworkInterface
    #         traffic_type: "ACCEPT", # required, accepts ACCEPT, REJECT, ALL
    #         log_destination_type: "cloud-watch-logs", # accepts cloud-watch-logs, s3
    #         log_destination: "String",
    #         log_format: "String",
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         max_aggregation_interval: 1,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] deliver_logs_permission_arn
    #   The ARN for the IAM role that permits Amazon EC2 to publish flow
    #   logs to a CloudWatch Logs log group in your account.
    #
    #   If you specify `LogDestinationType` as `s3`, do not specify
    #   `DeliverLogsPermissionArn` or `LogGroupName`.
    #   @return [String]
    #
    # @!attribute [rw] log_group_name
    #   The name of a new or existing CloudWatch Logs log group where Amazon
    #   EC2 publishes your flow logs.
    #
    #   If you specify `LogDestinationType` as `s3`, do not specify
    #   `DeliverLogsPermissionArn` or `LogGroupName`.
    #   @return [String]
    #
    # @!attribute [rw] resource_ids
    #   The ID of the subnet, network interface, or VPC for which you want
    #   to create a flow log.
    #
    #   Constraints: Maximum of 1000 resources
    #   @return [Array<String>]
    #
    # @!attribute [rw] resource_type
    #   The type of resource for which to create the flow log. For example,
    #   if you specified a VPC ID for the `ResourceId` property, specify
    #   `VPC` for this property.
    #   @return [String]
    #
    # @!attribute [rw] traffic_type
    #   The type of traffic to log. You can log traffic that the resource
    #   accepts or rejects, or all traffic.
    #   @return [String]
    #
    # @!attribute [rw] log_destination_type
    #   Specifies the type of destination to which the flow log data is to
    #   be published. Flow log data can be published to CloudWatch Logs or
    #   Amazon S3. To publish flow log data to CloudWatch Logs, specify
    #   `cloud-watch-logs`. To publish flow log data to Amazon S3, specify
    #   `s3`.
    #
    #   If you specify `LogDestinationType` as `s3`, do not specify
    #   `DeliverLogsPermissionArn` or `LogGroupName`.
    #
    #   Default: `cloud-watch-logs`
    #   @return [String]
    #
    # @!attribute [rw] log_destination
    #   Specifies the destination to which the flow log data is to be
    #   published. Flow log data can be published to a CloudWatch Logs log
    #   group or an Amazon S3 bucket. The value specified for this parameter
    #   depends on the value specified for `LogDestinationType`.
    #
    #   If `LogDestinationType` is not specified or `cloud-watch-logs`,
    #   specify the Amazon Resource Name (ARN) of the CloudWatch Logs log
    #   group. For example, to publish to a log group called `my-logs`,
    #   specify `arn:aws:logs:us-east-1:123456789012:log-group:my-logs`.
    #   Alternatively, use `LogGroupName` instead.
    #
    #   If LogDestinationType is `s3`, specify the ARN of the Amazon S3
    #   bucket. You can also specify a subfolder in the bucket. To specify a
    #   subfolder in the bucket, use the following ARN format:
    #   `bucket_ARN/subfolder_name/`. For example, to specify a subfolder
    #   named `my-logs` in a bucket named `my-bucket`, use the following
    #   ARN: `arn:aws:s3:::my-bucket/my-logs/`. You cannot use `AWSLogs` as
    #   a subfolder name. This is a reserved term.
    #   @return [String]
    #
    # @!attribute [rw] log_format
    #   The fields to include in the flow log record, in the order in which
    #   they should appear. For a list of available fields, see [Flow Log
    #   Records][1]. If you omit this parameter, the flow log is created
    #   using the default format. If you specify this parameter, you must
    #   specify at least one field.
    #
    #   Specify the fields using the `$\{field-id\}` format, separated by
    #   spaces. For the AWS CLI, use single quotation marks (' ') to
    #   surround the parameter value.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/vpc/latest/userguide/flow-logs.html#flow-log-records
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the flow logs.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] max_aggregation_interval
    #   The maximum interval of time during which a flow of packets is
    #   captured and aggregated into a flow log record. You can specify 60
    #   seconds (1 minute) or 600 seconds (10 minutes).
    #
    #   When a network interface is attached to a [Nitro-based instance][1],
    #   the aggregation interval is always 60 seconds or less, regardless of
    #   the value that you specify.
    #
    #   Default: 600
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateFlowLogsRequest AWS API Documentation
    #
    class CreateFlowLogsRequest < Struct.new(
      :dry_run,
      :client_token,
      :deliver_logs_permission_arn,
      :log_group_name,
      :resource_ids,
      :resource_type,
      :traffic_type,
      :log_destination_type,
      :log_destination,
      :log_format,
      :tag_specifications,
      :max_aggregation_interval)
      include Aws::Structure
    end

    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request.
    #   @return [String]
    #
    # @!attribute [rw] flow_log_ids
    #   The IDs of the flow logs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] unsuccessful
    #   Information about the flow logs that could not be created
    #   successfully.
    #   @return [Array<Types::UnsuccessfulItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateFlowLogsResult AWS API Documentation
    #
    class CreateFlowLogsResult < Struct.new(
      :client_token,
      :flow_log_ids,
      :unsuccessful)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateFpgaImageRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         input_storage_location: { # required
    #           bucket: "String",
    #           key: "String",
    #         },
    #         logs_storage_location: {
    #           bucket: "String",
    #           key: "String",
    #         },
    #         description: "String",
    #         name: "String",
    #         client_token: "String",
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] input_storage_location
    #   The location of the encrypted design checkpoint in Amazon S3. The
    #   input must be a tarball.
    #   @return [Types::StorageLocation]
    #
    # @!attribute [rw] logs_storage_location
    #   The location in Amazon S3 for the output logs.
    #   @return [Types::StorageLocation]
    #
    # @!attribute [rw] description
    #   A description for the AFI.
    #   @return [String]
    #
    # @!attribute [rw] name
    #   A name for the AFI.
    #   @return [String]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [Ensuring
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the FPGA image during creation.
    #   @return [Array<Types::TagSpecification>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateFpgaImageRequest AWS API Documentation
    #
    class CreateFpgaImageRequest < Struct.new(
      :dry_run,
      :input_storage_location,
      :logs_storage_location,
      :description,
      :name,
      :client_token,
      :tag_specifications)
      include Aws::Structure
    end

    # @!attribute [rw] fpga_image_id
    #   The FPGA image identifier (AFI ID).
    #   @return [String]
    #
    # @!attribute [rw] fpga_image_global_id
    #   The global FPGA image identifier (AGFI ID).
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateFpgaImageResult AWS API Documentation
    #
    class CreateFpgaImageResult < Struct.new(
      :fpga_image_id,
      :fpga_image_global_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateImageRequest
    #   data as a hash:
    #
    #       {
    #         block_device_mappings: [
    #           {
    #             device_name: "String",
    #             virtual_name: "String",
    #             ebs: {
    #               delete_on_termination: false,
    #               iops: 1,
    #               snapshot_id: "String",
    #               volume_size: 1,
    #               volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #               kms_key_id: "String",
    #               encrypted: false,
    #             },
    #             no_device: "String",
    #           },
    #         ],
    #         description: "String",
    #         dry_run: false,
    #         instance_id: "InstanceId", # required
    #         name: "String", # required
    #         no_reboot: false,
    #       }
    #
    # @!attribute [rw] block_device_mappings
    #   The block device mappings. This parameter cannot be used to modify
    #   the encryption status of existing volumes or snapshots. To create an
    #   AMI with encrypted snapshots, use the CopyImage action.
    #   @return [Array<Types::BlockDeviceMapping>]
    #
    # @!attribute [rw] description
    #   A description for the new image.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] name
    #   A name for the new image.
    #
    #   Constraints: 3-128 alphanumeric characters, parentheses (()), square
    #   brackets (\[\]), spaces ( ), periods (.), slashes (/), dashes (-),
    #   single quotes ('), at-signs (@), or underscores(\_)
    #   @return [String]
    #
    # @!attribute [rw] no_reboot
    #   By default, Amazon EC2 attempts to shut down and reboot the instance
    #   before creating the image. If the 'No Reboot' option is set,
    #   Amazon EC2 doesn't shut down the instance before creating the
    #   image. When this option is used, file system integrity on the
    #   created image can't be guaranteed.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateImageRequest AWS API Documentation
    #
    class CreateImageRequest < Struct.new(
      :block_device_mappings,
      :description,
      :dry_run,
      :instance_id,
      :name,
      :no_reboot)
      include Aws::Structure
    end

    # @!attribute [rw] image_id
    #   The ID of the new AMI.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateImageResult AWS API Documentation
    #
    class CreateImageResult < Struct.new(
      :image_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateInstanceExportTaskRequest
    #   data as a hash:
    #
    #       {
    #         description: "String",
    #         export_to_s3_task: {
    #           container_format: "ova", # accepts ova
    #           disk_image_format: "VMDK", # accepts VMDK, RAW, VHD
    #           s3_bucket: "String",
    #           s3_prefix: "String",
    #         },
    #         instance_id: "InstanceId", # required
    #         target_environment: "citrix", # accepts citrix, vmware, microsoft
    #       }
    #
    # @!attribute [rw] description
    #   A description for the conversion task or the resource being
    #   exported. The maximum length is 255 bytes.
    #   @return [String]
    #
    # @!attribute [rw] export_to_s3_task
    #   The format and location for an instance export task.
    #   @return [Types::ExportToS3TaskSpecification]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] target_environment
    #   The target virtualization environment.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateInstanceExportTaskRequest AWS API Documentation
    #
    class CreateInstanceExportTaskRequest < Struct.new(
      :description,
      :export_to_s3_task,
      :instance_id,
      :target_environment)
      include Aws::Structure
    end

    # @!attribute [rw] export_task
    #   Information about the instance export task.
    #   @return [Types::ExportTask]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateInstanceExportTaskResult AWS API Documentation
    #
    class CreateInstanceExportTaskResult < Struct.new(
      :export_task)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateInternetGatewayRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateInternetGatewayRequest AWS API Documentation
    #
    class CreateInternetGatewayRequest < Struct.new(
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] internet_gateway
    #   Information about the internet gateway.
    #   @return [Types::InternetGateway]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateInternetGatewayResult AWS API Documentation
    #
    class CreateInternetGatewayResult < Struct.new(
      :internet_gateway)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateKeyPairRequest
    #   data as a hash:
    #
    #       {
    #         key_name: "String", # required
    #         dry_run: false,
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] key_name
    #   A unique name for the key pair.
    #
    #   Constraints: Up to 255 ASCII characters
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the new key pair.
    #   @return [Array<Types::TagSpecification>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateKeyPairRequest AWS API Documentation
    #
    class CreateKeyPairRequest < Struct.new(
      :key_name,
      :dry_run,
      :tag_specifications)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateLaunchTemplateRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         client_token: "String",
    #         launch_template_name: "LaunchTemplateName", # required
    #         version_description: "VersionDescription",
    #         launch_template_data: { # required
    #           kernel_id: "KernelId",
    #           ebs_optimized: false,
    #           iam_instance_profile: {
    #             arn: "String",
    #             name: "String",
    #           },
    #           block_device_mappings: [
    #             {
    #               device_name: "String",
    #               virtual_name: "String",
    #               ebs: {
    #                 encrypted: false,
    #                 delete_on_termination: false,
    #                 iops: 1,
    #                 kms_key_id: "KmsKeyId",
    #                 snapshot_id: "SnapshotId",
    #                 volume_size: 1,
    #                 volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #               },
    #               no_device: "String",
    #             },
    #           ],
    #           network_interfaces: [
    #             {
    #               associate_public_ip_address: false,
    #               delete_on_termination: false,
    #               description: "String",
    #               device_index: 1,
    #               groups: ["SecurityGroupId"],
    #               interface_type: "String",
    #               ipv_6_address_count: 1,
    #               ipv_6_addresses: [
    #                 {
    #                   ipv_6_address: "String",
    #                 },
    #               ],
    #               network_interface_id: "NetworkInterfaceId",
    #               private_ip_address: "String",
    #               private_ip_addresses: [
    #                 {
    #                   primary: false,
    #                   private_ip_address: "String",
    #                 },
    #               ],
    #               secondary_private_ip_address_count: 1,
    #               subnet_id: "SubnetId",
    #             },
    #           ],
    #           image_id: "ImageId",
    #           instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #           key_name: "KeyPairName",
    #           monitoring: {
    #             enabled: false,
    #           },
    #           placement: {
    #             availability_zone: "String",
    #             affinity: "String",
    #             group_name: "PlacementGroupName",
    #             host_id: "DedicatedHostId",
    #             tenancy: "default", # accepts default, dedicated, host
    #             spread_domain: "String",
    #             host_resource_group_arn: "String",
    #             partition_number: 1,
    #           },
    #           ram_disk_id: "RamdiskId",
    #           disable_api_termination: false,
    #           instance_initiated_shutdown_behavior: "stop", # accepts stop, terminate
    #           user_data: "String",
    #           tag_specifications: [
    #             {
    #               resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #               tags: [
    #                 {
    #                   key: "String",
    #                   value: "String",
    #                 },
    #               ],
    #             },
    #           ],
    #           elastic_gpu_specifications: [
    #             {
    #               type: "String", # required
    #             },
    #           ],
    #           elastic_inference_accelerators: [
    #             {
    #               type: "String", # required
    #               count: 1,
    #             },
    #           ],
    #           security_group_ids: ["SecurityGroupId"],
    #           security_groups: ["SecurityGroupName"],
    #           instance_market_options: {
    #             market_type: "spot", # accepts spot
    #             spot_options: {
    #               max_price: "String",
    #               spot_instance_type: "one-time", # accepts one-time, persistent
    #               block_duration_minutes: 1,
    #               valid_until: Time.now,
    #               instance_interruption_behavior: "hibernate", # accepts hibernate, stop, terminate
    #             },
    #           },
    #           credit_specification: {
    #             cpu_credits: "String", # required
    #           },
    #           cpu_options: {
    #             core_count: 1,
    #             threads_per_core: 1,
    #           },
    #           capacity_reservation_specification: {
    #             capacity_reservation_preference: "open", # accepts open, none
    #             capacity_reservation_target: {
    #               capacity_reservation_id: "CapacityReservationId",
    #             },
    #           },
    #           license_specifications: [
    #             {
    #               license_configuration_arn: "String",
    #             },
    #           ],
    #           hibernation_options: {
    #             configured: false,
    #           },
    #           metadata_options: {
    #             http_tokens: "optional", # accepts optional, required
    #             http_put_response_hop_limit: 1,
    #             http_endpoint: "disabled", # accepts disabled, enabled
    #           },
    #         },
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier you provide to ensure the
    #   idempotency of the request. For more information, see [Ensuring
    #   Idempotency][1].
    #
    #   Constraint: Maximum 128 ASCII characters.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] launch_template_name
    #   A name for the launch template.
    #   @return [String]
    #
    # @!attribute [rw] version_description
    #   A description for the first version of the launch template.
    #   @return [String]
    #
    # @!attribute [rw] launch_template_data
    #   The information for the launch template.
    #   @return [Types::RequestLaunchTemplateData]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the launch template during creation.
    #   @return [Array<Types::TagSpecification>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateLaunchTemplateRequest AWS API Documentation
    #
    class CreateLaunchTemplateRequest < Struct.new(
      :dry_run,
      :client_token,
      :launch_template_name,
      :version_description,
      :launch_template_data,
      :tag_specifications)
      include Aws::Structure
    end

    # @!attribute [rw] launch_template
    #   Information about the launch template.
    #   @return [Types::LaunchTemplate]
    #
    # @!attribute [rw] warning
    #   If the launch template contains parameters or parameter combinations
    #   that are not valid, an error code and an error message are returned
    #   for each issue that's found.
    #   @return [Types::ValidationWarning]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateLaunchTemplateResult AWS API Documentation
    #
    class CreateLaunchTemplateResult < Struct.new(
      :launch_template,
      :warning)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateLaunchTemplateVersionRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         client_token: "String",
    #         launch_template_id: "LaunchTemplateId",
    #         launch_template_name: "LaunchTemplateName",
    #         source_version: "String",
    #         version_description: "VersionDescription",
    #         launch_template_data: { # required
    #           kernel_id: "KernelId",
    #           ebs_optimized: false,
    #           iam_instance_profile: {
    #             arn: "String",
    #             name: "String",
    #           },
    #           block_device_mappings: [
    #             {
    #               device_name: "String",
    #               virtual_name: "String",
    #               ebs: {
    #                 encrypted: false,
    #                 delete_on_termination: false,
    #                 iops: 1,
    #                 kms_key_id: "KmsKeyId",
    #                 snapshot_id: "SnapshotId",
    #                 volume_size: 1,
    #                 volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #               },
    #               no_device: "String",
    #             },
    #           ],
    #           network_interfaces: [
    #             {
    #               associate_public_ip_address: false,
    #               delete_on_termination: false,
    #               description: "String",
    #               device_index: 1,
    #               groups: ["SecurityGroupId"],
    #               interface_type: "String",
    #               ipv_6_address_count: 1,
    #               ipv_6_addresses: [
    #                 {
    #                   ipv_6_address: "String",
    #                 },
    #               ],
    #               network_interface_id: "NetworkInterfaceId",
    #               private_ip_address: "String",
    #               private_ip_addresses: [
    #                 {
    #                   primary: false,
    #                   private_ip_address: "String",
    #                 },
    #               ],
    #               secondary_private_ip_address_count: 1,
    #               subnet_id: "SubnetId",
    #             },
    #           ],
    #           image_id: "ImageId",
    #           instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #           key_name: "KeyPairName",
    #           monitoring: {
    #             enabled: false,
    #           },
    #           placement: {
    #             availability_zone: "String",
    #             affinity: "String",
    #             group_name: "PlacementGroupName",
    #             host_id: "DedicatedHostId",
    #             tenancy: "default", # accepts default, dedicated, host
    #             spread_domain: "String",
    #             host_resource_group_arn: "String",
    #             partition_number: 1,
    #           },
    #           ram_disk_id: "RamdiskId",
    #           disable_api_termination: false,
    #           instance_initiated_shutdown_behavior: "stop", # accepts stop, terminate
    #           user_data: "String",
    #           tag_specifications: [
    #             {
    #               resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #               tags: [
    #                 {
    #                   key: "String",
    #                   value: "String",
    #                 },
    #               ],
    #             },
    #           ],
    #           elastic_gpu_specifications: [
    #             {
    #               type: "String", # required
    #             },
    #           ],
    #           elastic_inference_accelerators: [
    #             {
    #               type: "String", # required
    #               count: 1,
    #             },
    #           ],
    #           security_group_ids: ["SecurityGroupId"],
    #           security_groups: ["SecurityGroupName"],
    #           instance_market_options: {
    #             market_type: "spot", # accepts spot
    #             spot_options: {
    #               max_price: "String",
    #               spot_instance_type: "one-time", # accepts one-time, persistent
    #               block_duration_minutes: 1,
    #               valid_until: Time.now,
    #               instance_interruption_behavior: "hibernate", # accepts hibernate, stop, terminate
    #             },
    #           },
    #           credit_specification: {
    #             cpu_credits: "String", # required
    #           },
    #           cpu_options: {
    #             core_count: 1,
    #             threads_per_core: 1,
    #           },
    #           capacity_reservation_specification: {
    #             capacity_reservation_preference: "open", # accepts open, none
    #             capacity_reservation_target: {
    #               capacity_reservation_id: "CapacityReservationId",
    #             },
    #           },
    #           license_specifications: [
    #             {
    #               license_configuration_arn: "String",
    #             },
    #           ],
    #           hibernation_options: {
    #             configured: false,
    #           },
    #           metadata_options: {
    #             http_tokens: "optional", # accepts optional, required
    #             http_put_response_hop_limit: 1,
    #             http_endpoint: "disabled", # accepts disabled, enabled
    #           },
    #         },
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier you provide to ensure the
    #   idempotency of the request. For more information, see [Ensuring
    #   Idempotency][1].
    #
    #   Constraint: Maximum 128 ASCII characters.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] launch_template_id
    #   The ID of the launch template. You must specify either the launch
    #   template ID or launch template name in the request.
    #   @return [String]
    #
    # @!attribute [rw] launch_template_name
    #   The name of the launch template. You must specify either the launch
    #   template ID or launch template name in the request.
    #   @return [String]
    #
    # @!attribute [rw] source_version
    #   The version number of the launch template version on which to base
    #   the new version. The new version inherits the same launch parameters
    #   as the source version, except for parameters that you specify in
    #   `LaunchTemplateData`. Snapshots applied to the block device mapping
    #   are ignored when creating a new version unless they are explicitly
    #   included.
    #   @return [String]
    #
    # @!attribute [rw] version_description
    #   A description for the version of the launch template.
    #   @return [String]
    #
    # @!attribute [rw] launch_template_data
    #   The information for the launch template.
    #   @return [Types::RequestLaunchTemplateData]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateLaunchTemplateVersionRequest AWS API Documentation
    #
    class CreateLaunchTemplateVersionRequest < Struct.new(
      :dry_run,
      :client_token,
      :launch_template_id,
      :launch_template_name,
      :source_version,
      :version_description,
      :launch_template_data)
      include Aws::Structure
    end

    # @!attribute [rw] launch_template_version
    #   Information about the launch template version.
    #   @return [Types::LaunchTemplateVersion]
    #
    # @!attribute [rw] warning
    #   If the new version of the launch template contains parameters or
    #   parameter combinations that are not valid, an error code and an
    #   error message are returned for each issue that's found.
    #   @return [Types::ValidationWarning]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateLaunchTemplateVersionResult AWS API Documentation
    #
    class CreateLaunchTemplateVersionResult < Struct.new(
      :launch_template_version,
      :warning)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateLocalGatewayRouteRequest
    #   data as a hash:
    #
    #       {
    #         destination_cidr_block: "String", # required
    #         local_gateway_route_table_id: "LocalGatewayRoutetableId", # required
    #         local_gateway_virtual_interface_group_id: "LocalGatewayVirtualInterfaceGroupId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] destination_cidr_block
    #   The CIDR range used for destination matches. Routing decisions are
    #   based on the most specific match.
    #   @return [String]
    #
    # @!attribute [rw] local_gateway_route_table_id
    #   The ID of the local gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] local_gateway_virtual_interface_group_id
    #   The ID of the virtual interface group.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateLocalGatewayRouteRequest AWS API Documentation
    #
    class CreateLocalGatewayRouteRequest < Struct.new(
      :destination_cidr_block,
      :local_gateway_route_table_id,
      :local_gateway_virtual_interface_group_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] route
    #   Information about the route.
    #   @return [Types::LocalGatewayRoute]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateLocalGatewayRouteResult AWS API Documentation
    #
    class CreateLocalGatewayRouteResult < Struct.new(
      :route)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateLocalGatewayRouteTableVpcAssociationRequest
    #   data as a hash:
    #
    #       {
    #         local_gateway_route_table_id: "LocalGatewayRoutetableId", # required
    #         vpc_id: "VpcId", # required
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] local_gateway_route_table_id
    #   The ID of the local gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to assign to the local gateway route table VPC association.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateLocalGatewayRouteTableVpcAssociationRequest AWS API Documentation
    #
    class CreateLocalGatewayRouteTableVpcAssociationRequest < Struct.new(
      :local_gateway_route_table_id,
      :vpc_id,
      :tag_specifications,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] local_gateway_route_table_vpc_association
    #   Information about the association.
    #   @return [Types::LocalGatewayRouteTableVpcAssociation]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateLocalGatewayRouteTableVpcAssociationResult AWS API Documentation
    #
    class CreateLocalGatewayRouteTableVpcAssociationResult < Struct.new(
      :local_gateway_route_table_vpc_association)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateNatGatewayRequest
    #   data as a hash:
    #
    #       {
    #         allocation_id: "AllocationId", # required
    #         client_token: "String",
    #         dry_run: false,
    #         subnet_id: "SubnetId", # required
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] allocation_id
    #   The allocation ID of an Elastic IP address to associate with the NAT
    #   gateway. If the Elastic IP address is associated with another
    #   resource, you must first disassociate it.
    #   @return [String]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #   Constraint: Maximum 64 ASCII characters.
    #
    #   **A suitable default value is auto-generated.** You should normally
    #   not need to pass this option.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] subnet_id
    #   The subnet in which to create the NAT gateway.
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to assign to the NAT gateway.
    #   @return [Array<Types::TagSpecification>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateNatGatewayRequest AWS API Documentation
    #
    class CreateNatGatewayRequest < Struct.new(
      :allocation_id,
      :client_token,
      :dry_run,
      :subnet_id,
      :tag_specifications)
      include Aws::Structure
    end

    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier to ensure the idempotency of the
    #   request. Only returned if a client token was provided in the
    #   request.
    #   @return [String]
    #
    # @!attribute [rw] nat_gateway
    #   Information about the NAT gateway.
    #   @return [Types::NatGateway]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateNatGatewayResult AWS API Documentation
    #
    class CreateNatGatewayResult < Struct.new(
      :client_token,
      :nat_gateway)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateNetworkAclEntryRequest
    #   data as a hash:
    #
    #       {
    #         cidr_block: "String",
    #         dry_run: false,
    #         egress: false, # required
    #         icmp_type_code: {
    #           code: 1,
    #           type: 1,
    #         },
    #         ipv_6_cidr_block: "String",
    #         network_acl_id: "NetworkAclId", # required
    #         port_range: {
    #           from: 1,
    #           to: 1,
    #         },
    #         protocol: "String", # required
    #         rule_action: "allow", # required, accepts allow, deny
    #         rule_number: 1, # required
    #       }
    #
    # @!attribute [rw] cidr_block
    #   The IPv4 network range to allow or deny, in CIDR notation (for
    #   example `172.16.0.0/24`).
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] egress
    #   Indicates whether this is an egress rule (rule is applied to traffic
    #   leaving the subnet).
    #   @return [Boolean]
    #
    # @!attribute [rw] icmp_type_code
    #   ICMP protocol: The ICMP or ICMPv6 type and code. Required if
    #   specifying protocol 1 (ICMP) or protocol 58 (ICMPv6) with an IPv6
    #   CIDR block.
    #   @return [Types::IcmpTypeCode]
    #
    # @!attribute [rw] ipv_6_cidr_block
    #   The IPv6 network range to allow or deny, in CIDR notation (for
    #   example `2001:db8:1234:1a00::/64`).
    #   @return [String]
    #
    # @!attribute [rw] network_acl_id
    #   The ID of the network ACL.
    #   @return [String]
    #
    # @!attribute [rw] port_range
    #   TCP or UDP protocols: The range of ports the rule applies to.
    #   Required if specifying protocol 6 (TCP) or 17 (UDP).
    #   @return [Types::PortRange]
    #
    # @!attribute [rw] protocol
    #   The protocol number. A value of "-1" means all protocols. If you
    #   specify "-1" or a protocol number other than "6" (TCP), "17"
    #   (UDP), or "1" (ICMP), traffic on all ports is allowed, regardless
    #   of any ports or ICMP types or codes that you specify. If you specify
    #   protocol "58" (ICMPv6) and specify an IPv4 CIDR block, traffic for
    #   all ICMP types and codes allowed, regardless of any that you
    #   specify. If you specify protocol "58" (ICMPv6) and specify an IPv6
    #   CIDR block, you must specify an ICMP type and code.
    #   @return [String]
    #
    # @!attribute [rw] rule_action
    #   Indicates whether to allow or deny the traffic that matches the
    #   rule.
    #   @return [String]
    #
    # @!attribute [rw] rule_number
    #   The rule number for the entry (for example, 100). ACL entries are
    #   processed in ascending order by rule number.
    #
    #   Constraints: Positive integer from 1 to 32766. The range 32767 to
    #   65535 is reserved for internal use.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateNetworkAclEntryRequest AWS API Documentation
    #
    class CreateNetworkAclEntryRequest < Struct.new(
      :cidr_block,
      :dry_run,
      :egress,
      :icmp_type_code,
      :ipv_6_cidr_block,
      :network_acl_id,
      :port_range,
      :protocol,
      :rule_action,
      :rule_number)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateNetworkAclRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         vpc_id: "VpcId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateNetworkAclRequest AWS API Documentation
    #
    class CreateNetworkAclRequest < Struct.new(
      :dry_run,
      :vpc_id)
      include Aws::Structure
    end

    # @!attribute [rw] network_acl
    #   Information about the network ACL.
    #   @return [Types::NetworkAcl]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateNetworkAclResult AWS API Documentation
    #
    class CreateNetworkAclResult < Struct.new(
      :network_acl)
      include Aws::Structure
    end

    # Contains the parameters for CreateNetworkInterfacePermission.
    #
    # @note When making an API call, you may pass CreateNetworkInterfacePermissionRequest
    #   data as a hash:
    #
    #       {
    #         network_interface_id: "NetworkInterfaceId", # required
    #         aws_account_id: "String",
    #         aws_service: "String",
    #         permission: "INSTANCE-ATTACH", # required, accepts INSTANCE-ATTACH, EIP-ASSOCIATE
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] aws_account_id
    #   The AWS account ID.
    #   @return [String]
    #
    # @!attribute [rw] aws_service
    #   The AWS service. Currently not supported.
    #   @return [String]
    #
    # @!attribute [rw] permission
    #   The type of permission to grant.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateNetworkInterfacePermissionRequest AWS API Documentation
    #
    class CreateNetworkInterfacePermissionRequest < Struct.new(
      :network_interface_id,
      :aws_account_id,
      :aws_service,
      :permission,
      :dry_run)
      include Aws::Structure
    end

    # Contains the output of CreateNetworkInterfacePermission.
    #
    # @!attribute [rw] interface_permission
    #   Information about the permission for the network interface.
    #   @return [Types::NetworkInterfacePermission]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateNetworkInterfacePermissionResult AWS API Documentation
    #
    class CreateNetworkInterfacePermissionResult < Struct.new(
      :interface_permission)
      include Aws::Structure
    end

    # Contains the parameters for CreateNetworkInterface.
    #
    # @note When making an API call, you may pass CreateNetworkInterfaceRequest
    #   data as a hash:
    #
    #       {
    #         description: "String",
    #         dry_run: false,
    #         groups: ["SecurityGroupId"],
    #         ipv_6_address_count: 1,
    #         ipv_6_addresses: [
    #           {
    #             ipv_6_address: "String",
    #           },
    #         ],
    #         private_ip_address: "String",
    #         private_ip_addresses: [
    #           {
    #             primary: false,
    #             private_ip_address: "String",
    #           },
    #         ],
    #         secondary_private_ip_address_count: 1,
    #         interface_type: "efa", # accepts efa
    #         subnet_id: "SubnetId", # required
    #       }
    #
    # @!attribute [rw] description
    #   A description for the network interface.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] groups
    #   The IDs of one or more security groups.
    #   @return [Array<String>]
    #
    # @!attribute [rw] ipv_6_address_count
    #   The number of IPv6 addresses to assign to a network interface.
    #   Amazon EC2 automatically selects the IPv6 addresses from the subnet
    #   range. You can't use this option if specifying specific IPv6
    #   addresses. If your subnet has the `AssignIpv6AddressOnCreation`
    #   attribute set to `true`, you can specify `0` to override this
    #   setting.
    #   @return [Integer]
    #
    # @!attribute [rw] ipv_6_addresses
    #   One or more specific IPv6 addresses from the IPv6 CIDR block range
    #   of your subnet. You can't use this option if you're specifying a
    #   number of IPv6 addresses.
    #   @return [Array<Types::InstanceIpv6Address>]
    #
    # @!attribute [rw] private_ip_address
    #   The primary private IPv4 address of the network interface. If you
    #   don't specify an IPv4 address, Amazon EC2 selects one for you from
    #   the subnet's IPv4 CIDR range. If you specify an IP address, you
    #   cannot indicate any IP addresses specified in `privateIpAddresses`
    #   as primary (only one IP address can be designated as primary).
    #   @return [String]
    #
    # @!attribute [rw] private_ip_addresses
    #   One or more private IPv4 addresses.
    #   @return [Array<Types::PrivateIpAddressSpecification>]
    #
    # @!attribute [rw] secondary_private_ip_address_count
    #   The number of secondary private IPv4 addresses to assign to a
    #   network interface. When you specify a number of secondary IPv4
    #   addresses, Amazon EC2 selects these IP addresses within the
    #   subnet's IPv4 CIDR range. You can't specify this option and
    #   specify more than one private IP address using `privateIpAddresses`.
    #
    #   The number of IP addresses you can assign to a network interface
    #   varies by instance type. For more information, see [IP Addresses Per
    #   ENI Per Instance Type][1] in the *Amazon Virtual Private Cloud User
    #   Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/using-eni.html#AvailableIpPerENI
    #   @return [Integer]
    #
    # @!attribute [rw] interface_type
    #   Indicates the type of network interface. To create an Elastic Fabric
    #   Adapter (EFA), specify `efa`. For more information, see [ Elastic
    #   Fabric Adapter][1] in the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet to associate with the network interface.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateNetworkInterfaceRequest AWS API Documentation
    #
    class CreateNetworkInterfaceRequest < Struct.new(
      :description,
      :dry_run,
      :groups,
      :ipv_6_address_count,
      :ipv_6_addresses,
      :private_ip_address,
      :private_ip_addresses,
      :secondary_private_ip_address_count,
      :interface_type,
      :subnet_id)
      include Aws::Structure
    end

    # Contains the output of CreateNetworkInterface.
    #
    # @!attribute [rw] network_interface
    #   Information about the network interface.
    #   @return [Types::NetworkInterface]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateNetworkInterfaceResult AWS API Documentation
    #
    class CreateNetworkInterfaceResult < Struct.new(
      :network_interface)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreatePlacementGroupRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         group_name: "String",
    #         strategy: "cluster", # accepts cluster, spread, partition
    #         partition_count: 1,
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] group_name
    #   A name for the placement group. Must be unique within the scope of
    #   your account for the Region.
    #
    #   Constraints: Up to 255 ASCII characters
    #   @return [String]
    #
    # @!attribute [rw] strategy
    #   The placement strategy.
    #   @return [String]
    #
    # @!attribute [rw] partition_count
    #   The number of partitions. Valid only when **Strategy** is set to
    #   `partition`.
    #   @return [Integer]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the new placement group.
    #   @return [Array<Types::TagSpecification>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreatePlacementGroupRequest AWS API Documentation
    #
    class CreatePlacementGroupRequest < Struct.new(
      :dry_run,
      :group_name,
      :strategy,
      :partition_count,
      :tag_specifications)
      include Aws::Structure
    end

    # @!attribute [rw] placement_group
    #   Describes a placement group.
    #   @return [Types::PlacementGroup]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreatePlacementGroupResult AWS API Documentation
    #
    class CreatePlacementGroupResult < Struct.new(
      :placement_group)
      include Aws::Structure
    end

    # Contains the parameters for CreateReservedInstancesListing.
    #
    # @note When making an API call, you may pass CreateReservedInstancesListingRequest
    #   data as a hash:
    #
    #       {
    #         client_token: "String", # required
    #         instance_count: 1, # required
    #         price_schedules: [ # required
    #           {
    #             currency_code: "USD", # accepts USD
    #             price: 1.0,
    #             term: 1,
    #           },
    #         ],
    #         reserved_instances_id: "ReservationId", # required
    #       }
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier you provide to ensure idempotency
    #   of your listings. This helps avoid duplicate listings. For more
    #   information, see [Ensuring Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] instance_count
    #   The number of instances that are a part of a Reserved Instance
    #   account to be listed in the Reserved Instance Marketplace. This
    #   number should be less than or equal to the instance count associated
    #   with the Reserved Instance ID specified in this call.
    #   @return [Integer]
    #
    # @!attribute [rw] price_schedules
    #   A list specifying the price of the Standard Reserved Instance for
    #   each month remaining in the Reserved Instance term.
    #   @return [Array<Types::PriceScheduleSpecification>]
    #
    # @!attribute [rw] reserved_instances_id
    #   The ID of the active Standard Reserved Instance.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateReservedInstancesListingRequest AWS API Documentation
    #
    class CreateReservedInstancesListingRequest < Struct.new(
      :client_token,
      :instance_count,
      :price_schedules,
      :reserved_instances_id)
      include Aws::Structure
    end

    # Contains the output of CreateReservedInstancesListing.
    #
    # @!attribute [rw] reserved_instances_listings
    #   Information about the Standard Reserved Instance listing.
    #   @return [Array<Types::ReservedInstancesListing>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateReservedInstancesListingResult AWS API Documentation
    #
    class CreateReservedInstancesListingResult < Struct.new(
      :reserved_instances_listings)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateRouteRequest
    #   data as a hash:
    #
    #       {
    #         destination_cidr_block: "String",
    #         destination_ipv_6_cidr_block: "String",
    #         dry_run: false,
    #         egress_only_internet_gateway_id: "EgressOnlyInternetGatewayId",
    #         gateway_id: "RouteGatewayId",
    #         instance_id: "InstanceId",
    #         nat_gateway_id: "NatGatewayId",
    #         transit_gateway_id: "TransitGatewayId",
    #         local_gateway_id: "LocalGatewayId",
    #         network_interface_id: "NetworkInterfaceId",
    #         route_table_id: "RouteTableId", # required
    #         vpc_peering_connection_id: "VpcPeeringConnectionId",
    #       }
    #
    # @!attribute [rw] destination_cidr_block
    #   The IPv4 CIDR address block used for the destination match. Routing
    #   decisions are based on the most specific match.
    #   @return [String]
    #
    # @!attribute [rw] destination_ipv_6_cidr_block
    #   The IPv6 CIDR block used for the destination match. Routing
    #   decisions are based on the most specific match.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] egress_only_internet_gateway_id
    #   \[IPv6 traffic only\] The ID of an egress-only internet gateway.
    #   @return [String]
    #
    # @!attribute [rw] gateway_id
    #   The ID of an internet gateway or virtual private gateway attached to
    #   your VPC.
    #   @return [String]
    #
    # @!attribute [rw] instance_id
    #   The ID of a NAT instance in your VPC. The operation fails if you
    #   specify an instance ID unless exactly one network interface is
    #   attached.
    #   @return [String]
    #
    # @!attribute [rw] nat_gateway_id
    #   \[IPv4 traffic only\] The ID of a NAT gateway.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of a transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] local_gateway_id
    #   The ID of the local gateway.
    #   @return [String]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of a network interface.
    #   @return [String]
    #
    # @!attribute [rw] route_table_id
    #   The ID of the route table for the route.
    #   @return [String]
    #
    # @!attribute [rw] vpc_peering_connection_id
    #   The ID of a VPC peering connection.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateRouteRequest AWS API Documentation
    #
    class CreateRouteRequest < Struct.new(
      :destination_cidr_block,
      :destination_ipv_6_cidr_block,
      :dry_run,
      :egress_only_internet_gateway_id,
      :gateway_id,
      :instance_id,
      :nat_gateway_id,
      :transit_gateway_id,
      :local_gateway_id,
      :network_interface_id,
      :route_table_id,
      :vpc_peering_connection_id)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateRouteResult AWS API Documentation
    #
    class CreateRouteResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateRouteTableRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         vpc_id: "VpcId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateRouteTableRequest AWS API Documentation
    #
    class CreateRouteTableRequest < Struct.new(
      :dry_run,
      :vpc_id)
      include Aws::Structure
    end

    # @!attribute [rw] route_table
    #   Information about the route table.
    #   @return [Types::RouteTable]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateRouteTableResult AWS API Documentation
    #
    class CreateRouteTableResult < Struct.new(
      :route_table)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateSecurityGroupRequest
    #   data as a hash:
    #
    #       {
    #         description: "String", # required
    #         group_name: "String", # required
    #         vpc_id: "VpcId",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] description
    #   A description for the security group. This is informational only.
    #
    #   Constraints: Up to 255 characters in length
    #
    #   Constraints for EC2-Classic: ASCII characters
    #
    #   Constraints for EC2-VPC: a-z, A-Z, 0-9, spaces, and
    #   .\_-:/()#,@\[\]+=&amp;;\\\{\\}!$*
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   The name of the security group.
    #
    #   Constraints: Up to 255 characters in length. Cannot start with
    #   `sg-`.
    #
    #   Constraints for EC2-Classic: ASCII characters
    #
    #   Constraints for EC2-VPC: a-z, A-Z, 0-9, spaces, and
    #   .\_-:/()#,@\[\]+=&amp;;\\\{\\}!$*
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   \[EC2-VPC\] The ID of the VPC. Required for EC2-VPC.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateSecurityGroupRequest AWS API Documentation
    #
    class CreateSecurityGroupRequest < Struct.new(
      :description,
      :group_name,
      :vpc_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] group_id
    #   The ID of the security group.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateSecurityGroupResult AWS API Documentation
    #
    class CreateSecurityGroupResult < Struct.new(
      :group_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateSnapshotRequest
    #   data as a hash:
    #
    #       {
    #         description: "String",
    #         volume_id: "VolumeId", # required
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] description
    #   A description for the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] volume_id
    #   The ID of the EBS volume.
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the snapshot during creation.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateSnapshotRequest AWS API Documentation
    #
    class CreateSnapshotRequest < Struct.new(
      :description,
      :volume_id,
      :tag_specifications,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateSnapshotsRequest
    #   data as a hash:
    #
    #       {
    #         description: "String",
    #         instance_specification: { # required
    #           instance_id: "InstanceId",
    #           exclude_boot_volume: false,
    #         },
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         dry_run: false,
    #         copy_tags_from_source: "volume", # accepts volume
    #       }
    #
    # @!attribute [rw] description
    #   A description propagated to every snapshot specified by the
    #   instance.
    #   @return [String]
    #
    # @!attribute [rw] instance_specification
    #   The instance to specify which volumes should be included in the
    #   snapshots.
    #   @return [Types::InstanceSpecification]
    #
    # @!attribute [rw] tag_specifications
    #   Tags to apply to every snapshot specified by the instance.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] copy_tags_from_source
    #   Copies the tags from the specified volume to corresponding snapshot.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateSnapshotsRequest AWS API Documentation
    #
    class CreateSnapshotsRequest < Struct.new(
      :description,
      :instance_specification,
      :tag_specifications,
      :dry_run,
      :copy_tags_from_source)
      include Aws::Structure
    end

    # @!attribute [rw] snapshots
    #   List of snapshots.
    #   @return [Array<Types::SnapshotInfo>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateSnapshotsResult AWS API Documentation
    #
    class CreateSnapshotsResult < Struct.new(
      :snapshots)
      include Aws::Structure
    end

    # Contains the parameters for CreateSpotDatafeedSubscription.
    #
    # @note When making an API call, you may pass CreateSpotDatafeedSubscriptionRequest
    #   data as a hash:
    #
    #       {
    #         bucket: "String", # required
    #         dry_run: false,
    #         prefix: "String",
    #       }
    #
    # @!attribute [rw] bucket
    #   The Amazon S3 bucket in which to store the Spot Instance data feed.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] prefix
    #   A prefix for the data feed file names.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateSpotDatafeedSubscriptionRequest AWS API Documentation
    #
    class CreateSpotDatafeedSubscriptionRequest < Struct.new(
      :bucket,
      :dry_run,
      :prefix)
      include Aws::Structure
    end

    # Contains the output of CreateSpotDatafeedSubscription.
    #
    # @!attribute [rw] spot_datafeed_subscription
    #   The Spot Instance data feed subscription.
    #   @return [Types::SpotDatafeedSubscription]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateSpotDatafeedSubscriptionResult AWS API Documentation
    #
    class CreateSpotDatafeedSubscriptionResult < Struct.new(
      :spot_datafeed_subscription)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateSubnetRequest
    #   data as a hash:
    #
    #       {
    #         availability_zone: "String",
    #         availability_zone_id: "String",
    #         cidr_block: "String", # required
    #         ipv_6_cidr_block: "String",
    #         outpost_arn: "String",
    #         vpc_id: "VpcId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone or Local Zone for the subnet.
    #
    #   Default: AWS selects one for you. If you create more than one subnet
    #   in your VPC, we do not necessarily select a different zone for each
    #   subnet.
    #
    #   To create a subnet in a Local Zone, set this value to the Local Zone
    #   ID, for example `us-west-2-lax-1a`. For information about the
    #   Regions that support Local Zones, see [Available Regions][1] in the
    #   *Amazon Elastic Compute Cloud User Guide*.
    #
    #   To create a subnet in an Outpost, set this value to the Availability
    #   Zone for the Outpost and specify the Outpost ARN.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/using-regions-availability-zones.html#concepts-available-regions
    #   @return [String]
    #
    # @!attribute [rw] availability_zone_id
    #   The AZ ID or the Local Zone ID of the subnet.
    #   @return [String]
    #
    # @!attribute [rw] cidr_block
    #   The IPv4 network range for the subnet, in CIDR notation. For
    #   example, `10.0.0.0/24`.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_cidr_block
    #   The IPv6 network range for the subnet, in CIDR notation. The subnet
    #   size must use a /64 prefix length.
    #   @return [String]
    #
    # @!attribute [rw] outpost_arn
    #   The Amazon Resource Name (ARN) of the Outpost. If you specify an
    #   Outpost ARN, you must also specify the Availability Zone of the
    #   Outpost subnet.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateSubnetRequest AWS API Documentation
    #
    class CreateSubnetRequest < Struct.new(
      :availability_zone,
      :availability_zone_id,
      :cidr_block,
      :ipv_6_cidr_block,
      :outpost_arn,
      :vpc_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] subnet
    #   Information about the subnet.
    #   @return [Types::Subnet]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateSubnetResult AWS API Documentation
    #
    class CreateSubnetResult < Struct.new(
      :subnet)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateTagsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         resources: ["TaggableResourceId"], # required
    #         tags: [ # required
    #           {
    #             key: "String",
    #             value: "String",
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] resources
    #   The IDs of the resources, separated by spaces.
    #
    #   Constraints: Up to 1000 resource IDs. We recommend breaking up this
    #   request into smaller batches.
    #   @return [Array<String>]
    #
    # @!attribute [rw] tags
    #   The tags. The `value` parameter is required, but if you don't want
    #   the tag to have a value, specify the parameter with no value, and we
    #   set the value to an empty string.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTagsRequest AWS API Documentation
    #
    class CreateTagsRequest < Struct.new(
      :dry_run,
      :resources,
      :tags)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateTrafficMirrorFilterRequest
    #   data as a hash:
    #
    #       {
    #         description: "String",
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         dry_run: false,
    #         client_token: "String",
    #       }
    #
    # @!attribute [rw] description
    #   The description of the Traffic Mirror filter.
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to assign to a Traffic Mirror filter.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #   **A suitable default value is auto-generated.** You should normally
    #   not need to pass this option.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTrafficMirrorFilterRequest AWS API Documentation
    #
    class CreateTrafficMirrorFilterRequest < Struct.new(
      :description,
      :tag_specifications,
      :dry_run,
      :client_token)
      include Aws::Structure
    end

    # @!attribute [rw] traffic_mirror_filter
    #   Information about the Traffic Mirror filter.
    #   @return [Types::TrafficMirrorFilter]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTrafficMirrorFilterResult AWS API Documentation
    #
    class CreateTrafficMirrorFilterResult < Struct.new(
      :traffic_mirror_filter,
      :client_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateTrafficMirrorFilterRuleRequest
    #   data as a hash:
    #
    #       {
    #         traffic_mirror_filter_id: "TrafficMirrorFilterId", # required
    #         traffic_direction: "ingress", # required, accepts ingress, egress
    #         rule_number: 1, # required
    #         rule_action: "accept", # required, accepts accept, reject
    #         destination_port_range: {
    #           from_port: 1,
    #           to_port: 1,
    #         },
    #         source_port_range: {
    #           from_port: 1,
    #           to_port: 1,
    #         },
    #         protocol: 1,
    #         destination_cidr_block: "String", # required
    #         source_cidr_block: "String", # required
    #         description: "String",
    #         dry_run: false,
    #         client_token: "String",
    #       }
    #
    # @!attribute [rw] traffic_mirror_filter_id
    #   The ID of the filter that this rule is associated with.
    #   @return [String]
    #
    # @!attribute [rw] traffic_direction
    #   The type of traffic (`ingress` \| `egress`).
    #   @return [String]
    #
    # @!attribute [rw] rule_number
    #   The number of the Traffic Mirror rule. This number must be unique
    #   for each Traffic Mirror rule in a given direction. The rules are
    #   processed in ascending order by rule number.
    #   @return [Integer]
    #
    # @!attribute [rw] rule_action
    #   The action to take (`accept` \| `reject`) on the filtered traffic.
    #   @return [String]
    #
    # @!attribute [rw] destination_port_range
    #   The destination port range.
    #   @return [Types::TrafficMirrorPortRangeRequest]
    #
    # @!attribute [rw] source_port_range
    #   The source port range.
    #   @return [Types::TrafficMirrorPortRangeRequest]
    #
    # @!attribute [rw] protocol
    #   The protocol, for example UDP, to assign to the Traffic Mirror rule.
    #
    #   For information about the protocol value, see [Protocol Numbers][1]
    #   on the Internet Assigned Numbers Authority (IANA) website.
    #
    #
    #
    #   [1]: https://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml
    #   @return [Integer]
    #
    # @!attribute [rw] destination_cidr_block
    #   The destination CIDR block to assign to the Traffic Mirror rule.
    #   @return [String]
    #
    # @!attribute [rw] source_cidr_block
    #   The source CIDR block to assign to the Traffic Mirror rule.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   The description of the Traffic Mirror rule.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #   **A suitable default value is auto-generated.** You should normally
    #   not need to pass this option.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTrafficMirrorFilterRuleRequest AWS API Documentation
    #
    class CreateTrafficMirrorFilterRuleRequest < Struct.new(
      :traffic_mirror_filter_id,
      :traffic_direction,
      :rule_number,
      :rule_action,
      :destination_port_range,
      :source_port_range,
      :protocol,
      :destination_cidr_block,
      :source_cidr_block,
      :description,
      :dry_run,
      :client_token)
      include Aws::Structure
    end

    # @!attribute [rw] traffic_mirror_filter_rule
    #   The Traffic Mirror rule.
    #   @return [Types::TrafficMirrorFilterRule]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTrafficMirrorFilterRuleResult AWS API Documentation
    #
    class CreateTrafficMirrorFilterRuleResult < Struct.new(
      :traffic_mirror_filter_rule,
      :client_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateTrafficMirrorSessionRequest
    #   data as a hash:
    #
    #       {
    #         network_interface_id: "NetworkInterfaceId", # required
    #         traffic_mirror_target_id: "TrafficMirrorTargetId", # required
    #         traffic_mirror_filter_id: "TrafficMirrorFilterId", # required
    #         packet_length: 1,
    #         session_number: 1, # required
    #         virtual_network_id: 1,
    #         description: "String",
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         dry_run: false,
    #         client_token: "String",
    #       }
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the source network interface.
    #   @return [String]
    #
    # @!attribute [rw] traffic_mirror_target_id
    #   The ID of the Traffic Mirror target.
    #   @return [String]
    #
    # @!attribute [rw] traffic_mirror_filter_id
    #   The ID of the Traffic Mirror filter.
    #   @return [String]
    #
    # @!attribute [rw] packet_length
    #   The number of bytes in each packet to mirror. These are bytes after
    #   the VXLAN header. Do not specify this parameter when you want to
    #   mirror the entire packet. To mirror a subset of the packet, set this
    #   to the length (in bytes) that you want to mirror. For example, if
    #   you set this value to 100, then the first 100 bytes that meet the
    #   filter criteria are copied to the target.
    #
    #   If you do not want to mirror the entire packet, use the
    #   `PacketLength` parameter to specify the number of bytes in each
    #   packet to mirror.
    #   @return [Integer]
    #
    # @!attribute [rw] session_number
    #   The session number determines the order in which sessions are
    #   evaluated when an interface is used by multiple sessions. The first
    #   session with a matching filter is the one that mirrors the packets.
    #
    #   Valid values are 1-32766.
    #   @return [Integer]
    #
    # @!attribute [rw] virtual_network_id
    #   The VXLAN ID for the Traffic Mirror session. For more information
    #   about the VXLAN protocol, see [RFC 7348][1]. If you do not specify a
    #   `VirtualNetworkId`, an account-wide unique id is chosen at random.
    #
    #
    #
    #   [1]: https://tools.ietf.org/html/rfc7348
    #   @return [Integer]
    #
    # @!attribute [rw] description
    #   The description of the Traffic Mirror session.
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to assign to a Traffic Mirror session.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #   **A suitable default value is auto-generated.** You should normally
    #   not need to pass this option.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTrafficMirrorSessionRequest AWS API Documentation
    #
    class CreateTrafficMirrorSessionRequest < Struct.new(
      :network_interface_id,
      :traffic_mirror_target_id,
      :traffic_mirror_filter_id,
      :packet_length,
      :session_number,
      :virtual_network_id,
      :description,
      :tag_specifications,
      :dry_run,
      :client_token)
      include Aws::Structure
    end

    # @!attribute [rw] traffic_mirror_session
    #   Information about the Traffic Mirror session.
    #   @return [Types::TrafficMirrorSession]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTrafficMirrorSessionResult AWS API Documentation
    #
    class CreateTrafficMirrorSessionResult < Struct.new(
      :traffic_mirror_session,
      :client_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateTrafficMirrorTargetRequest
    #   data as a hash:
    #
    #       {
    #         network_interface_id: "NetworkInterfaceId",
    #         network_load_balancer_arn: "String",
    #         description: "String",
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         dry_run: false,
    #         client_token: "String",
    #       }
    #
    # @!attribute [rw] network_interface_id
    #   The network interface ID that is associated with the target.
    #   @return [String]
    #
    # @!attribute [rw] network_load_balancer_arn
    #   The Amazon Resource Name (ARN) of the Network Load Balancer that is
    #   associated with the target.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   The description of the Traffic Mirror target.
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to assign to the Traffic Mirror target.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #   **A suitable default value is auto-generated.** You should normally
    #   not need to pass this option.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTrafficMirrorTargetRequest AWS API Documentation
    #
    class CreateTrafficMirrorTargetRequest < Struct.new(
      :network_interface_id,
      :network_load_balancer_arn,
      :description,
      :tag_specifications,
      :dry_run,
      :client_token)
      include Aws::Structure
    end

    # @!attribute [rw] traffic_mirror_target
    #   Information about the Traffic Mirror target.
    #   @return [Types::TrafficMirrorTarget]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTrafficMirrorTargetResult AWS API Documentation
    #
    class CreateTrafficMirrorTargetResult < Struct.new(
      :traffic_mirror_target,
      :client_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateTransitGatewayMulticastDomainRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_id: "TransitGatewayId", # required
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags for the transit gateway multicast domain.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTransitGatewayMulticastDomainRequest AWS API Documentation
    #
    class CreateTransitGatewayMulticastDomainRequest < Struct.new(
      :transit_gateway_id,
      :tag_specifications,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_multicast_domain
    #   Information about the transit gateway multicast domain.
    #   @return [Types::TransitGatewayMulticastDomain]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTransitGatewayMulticastDomainResult AWS API Documentation
    #
    class CreateTransitGatewayMulticastDomainResult < Struct.new(
      :transit_gateway_multicast_domain)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateTransitGatewayPeeringAttachmentRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_id: "TransitGatewayId", # required
    #         peer_transit_gateway_id: "TransitAssociationGatewayId", # required
    #         peer_account_id: "String", # required
    #         peer_region: "String", # required
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] peer_transit_gateway_id
    #   The ID of the peer transit gateway with which to create the peering
    #   attachment.
    #   @return [String]
    #
    # @!attribute [rw] peer_account_id
    #   The AWS account ID of the owner of the peer transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] peer_region
    #   The Region where the peer transit gateway is located.
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the transit gateway peering attachment.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTransitGatewayPeeringAttachmentRequest AWS API Documentation
    #
    class CreateTransitGatewayPeeringAttachmentRequest < Struct.new(
      :transit_gateway_id,
      :peer_transit_gateway_id,
      :peer_account_id,
      :peer_region,
      :tag_specifications,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_peering_attachment
    #   The transit gateway peering attachment.
    #   @return [Types::TransitGatewayPeeringAttachment]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTransitGatewayPeeringAttachmentResult AWS API Documentation
    #
    class CreateTransitGatewayPeeringAttachmentResult < Struct.new(
      :transit_gateway_peering_attachment)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateTransitGatewayRequest
    #   data as a hash:
    #
    #       {
    #         description: "String",
    #         options: {
    #           amazon_side_asn: 1,
    #           auto_accept_shared_attachments: "enable", # accepts enable, disable
    #           default_route_table_association: "enable", # accepts enable, disable
    #           default_route_table_propagation: "enable", # accepts enable, disable
    #           vpn_ecmp_support: "enable", # accepts enable, disable
    #           dns_support: "enable", # accepts enable, disable
    #           multicast_support: "enable", # accepts enable, disable
    #         },
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] description
    #   A description of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] options
    #   The transit gateway options.
    #   @return [Types::TransitGatewayRequestOptions]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the transit gateway.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTransitGatewayRequest AWS API Documentation
    #
    class CreateTransitGatewayRequest < Struct.new(
      :description,
      :options,
      :tag_specifications,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway
    #   Information about the transit gateway.
    #   @return [Types::TransitGateway]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTransitGatewayResult AWS API Documentation
    #
    class CreateTransitGatewayResult < Struct.new(
      :transit_gateway)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateTransitGatewayRouteRequest
    #   data as a hash:
    #
    #       {
    #         destination_cidr_block: "String", # required
    #         transit_gateway_route_table_id: "TransitGatewayRouteTableId", # required
    #         transit_gateway_attachment_id: "TransitGatewayAttachmentId",
    #         blackhole: false,
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] destination_cidr_block
    #   The CIDR range used for destination matches. Routing decisions are
    #   based on the most specific match.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the transit gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] blackhole
    #   Indicates whether to drop traffic that matches this route.
    #   @return [Boolean]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTransitGatewayRouteRequest AWS API Documentation
    #
    class CreateTransitGatewayRouteRequest < Struct.new(
      :destination_cidr_block,
      :transit_gateway_route_table_id,
      :transit_gateway_attachment_id,
      :blackhole,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] route
    #   Information about the route.
    #   @return [Types::TransitGatewayRoute]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTransitGatewayRouteResult AWS API Documentation
    #
    class CreateTransitGatewayRouteResult < Struct.new(
      :route)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateTransitGatewayRouteTableRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_id: "TransitGatewayId", # required
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the transit gateway route table.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTransitGatewayRouteTableRequest AWS API Documentation
    #
    class CreateTransitGatewayRouteTableRequest < Struct.new(
      :transit_gateway_id,
      :tag_specifications,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_route_table
    #   Information about the transit gateway route table.
    #   @return [Types::TransitGatewayRouteTable]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTransitGatewayRouteTableResult AWS API Documentation
    #
    class CreateTransitGatewayRouteTableResult < Struct.new(
      :transit_gateway_route_table)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateTransitGatewayVpcAttachmentRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_id: "TransitGatewayId", # required
    #         vpc_id: "VpcId", # required
    #         subnet_ids: ["SubnetId"], # required
    #         options: {
    #           dns_support: "enable", # accepts enable, disable
    #           ipv_6_support: "enable", # accepts enable, disable
    #         },
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] subnet_ids
    #   The IDs of one or more subnets. You can specify only one subnet per
    #   Availability Zone. You must specify at least one subnet, but we
    #   recommend that you specify two subnets for better availability. The
    #   transit gateway uses one IP address from each specified subnet.
    #   @return [Array<String>]
    #
    # @!attribute [rw] options
    #   The VPC attachment options.
    #   @return [Types::CreateTransitGatewayVpcAttachmentRequestOptions]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the VPC attachment.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTransitGatewayVpcAttachmentRequest AWS API Documentation
    #
    class CreateTransitGatewayVpcAttachmentRequest < Struct.new(
      :transit_gateway_id,
      :vpc_id,
      :subnet_ids,
      :options,
      :tag_specifications,
      :dry_run)
      include Aws::Structure
    end

    # Describes the options for a VPC attachment.
    #
    # @note When making an API call, you may pass CreateTransitGatewayVpcAttachmentRequestOptions
    #   data as a hash:
    #
    #       {
    #         dns_support: "enable", # accepts enable, disable
    #         ipv_6_support: "enable", # accepts enable, disable
    #       }
    #
    # @!attribute [rw] dns_support
    #   Enable or disable DNS support. The default is `enable`.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_support
    #   Enable or disable IPv6 support. The default is `enable`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTransitGatewayVpcAttachmentRequestOptions AWS API Documentation
    #
    class CreateTransitGatewayVpcAttachmentRequestOptions < Struct.new(
      :dns_support,
      :ipv_6_support)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_vpc_attachment
    #   Information about the VPC attachment.
    #   @return [Types::TransitGatewayVpcAttachment]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateTransitGatewayVpcAttachmentResult AWS API Documentation
    #
    class CreateTransitGatewayVpcAttachmentResult < Struct.new(
      :transit_gateway_vpc_attachment)
      include Aws::Structure
    end

    # Describes the user or group to be added or removed from the list of
    # create volume permissions for a volume.
    #
    # @note When making an API call, you may pass CreateVolumePermission
    #   data as a hash:
    #
    #       {
    #         group: "all", # accepts all
    #         user_id: "String",
    #       }
    #
    # @!attribute [rw] group
    #   The group to be added or removed. The possible value is `all`.
    #   @return [String]
    #
    # @!attribute [rw] user_id
    #   The AWS account ID to be added or removed.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVolumePermission AWS API Documentation
    #
    class CreateVolumePermission < Struct.new(
      :group,
      :user_id)
      include Aws::Structure
    end

    # Describes modifications to the list of create volume permissions for a
    # volume.
    #
    # @note When making an API call, you may pass CreateVolumePermissionModifications
    #   data as a hash:
    #
    #       {
    #         add: [
    #           {
    #             group: "all", # accepts all
    #             user_id: "String",
    #           },
    #         ],
    #         remove: [
    #           {
    #             group: "all", # accepts all
    #             user_id: "String",
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] add
    #   Adds the specified AWS account ID or group to the list.
    #   @return [Array<Types::CreateVolumePermission>]
    #
    # @!attribute [rw] remove
    #   Removes the specified AWS account ID or group from the list.
    #   @return [Array<Types::CreateVolumePermission>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVolumePermissionModifications AWS API Documentation
    #
    class CreateVolumePermissionModifications < Struct.new(
      :add,
      :remove)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateVolumeRequest
    #   data as a hash:
    #
    #       {
    #         availability_zone: "String", # required
    #         encrypted: false,
    #         iops: 1,
    #         kms_key_id: "KmsKeyId",
    #         outpost_arn: "String",
    #         size: 1,
    #         snapshot_id: "SnapshotId",
    #         volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #         dry_run: false,
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         multi_attach_enabled: false,
    #       }
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone in which to create the volume.
    #   @return [String]
    #
    # @!attribute [rw] encrypted
    #   Specifies whether the volume should be encrypted. The effect of
    #   setting the encryption state to `true` depends on the volume origin
    #   (new or from a snapshot), starting encryption state, ownership, and
    #   whether encryption by default is enabled. For more information, see
    #   [Encryption by Default][1] in the *Amazon Elastic Compute Cloud User
    #   Guide*.
    #
    #   Encrypted Amazon EBS volumes must be attached to instances that
    #   support Amazon EBS encryption. For more information, see [Supported
    #   Instance Types][2].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-by-default
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances
    #   @return [Boolean]
    #
    # @!attribute [rw] iops
    #   The number of I/O operations per second (IOPS) to provision for the
    #   volume, with a maximum ratio of 50 IOPS/GiB. Range is 100 to 64,000
    #   IOPS for volumes in most Regions. Maximum IOPS of 64,000 is
    #   guaranteed only on [Nitro-based instances][1]. Other instance
    #   families guarantee performance up to 32,000 IOPS. For more
    #   information, see [Amazon EBS Volume Types][2] in the *Amazon Elastic
    #   Compute Cloud User Guide*.
    #
    #   This parameter is valid only for Provisioned IOPS SSD (io1) volumes.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html
    #   @return [Integer]
    #
    # @!attribute [rw] kms_key_id
    #   The identifier of the AWS Key Management Service (AWS KMS) customer
    #   master key (CMK) to use for Amazon EBS encryption. If this parameter
    #   is not specified, your AWS managed CMK for EBS is used. If
    #   `KmsKeyId` is specified, the encrypted state must be `true`.
    #
    #   You can specify the CMK using any of the following:
    #
    #   * Key ID. For example, key/1234abcd-12ab-34cd-56ef-1234567890ab.
    #
    #   * Key alias. For example, alias/ExampleAlias.
    #
    #   * Key ARN. For example,
    #     arn:aws:kms:*us-east-1*\:*012345678910*\:key/*abcd1234-a123-456a-a12b-a123b4cd56ef*.
    #
    #   * Alias ARN. For example,
    #     arn:aws:kms:*us-east-1*\:*012345678910*\:alias/*ExampleAlias*.
    #
    #   AWS authenticates the CMK asynchronously. Therefore, if you specify
    #   an ID, alias, or ARN that is not valid, the action can appear to
    #   complete, but eventually fails.
    #   @return [String]
    #
    # @!attribute [rw] outpost_arn
    #   The Amazon Resource Name (ARN) of the Outpost.
    #   @return [String]
    #
    # @!attribute [rw] size
    #   The size of the volume, in GiBs. You must specify either a snapshot
    #   ID or a volume size.
    #
    #   Constraints: 1-16,384 for `gp2`, 4-16,384 for `io1`, 500-16,384 for
    #   `st1`, 500-16,384 for `sc1`, and 1-1,024 for `standard`. If you
    #   specify a snapshot, the volume size must be equal to or larger than
    #   the snapshot size.
    #
    #   Default: If you're creating the volume from a snapshot and don't
    #   specify a volume size, the default is the snapshot size.
    #   @return [Integer]
    #
    # @!attribute [rw] snapshot_id
    #   The snapshot from which to create the volume. You must specify
    #   either a snapshot ID or a volume size.
    #   @return [String]
    #
    # @!attribute [rw] volume_type
    #   The volume type. This can be `gp2` for General Purpose SSD, `io1`
    #   for Provisioned IOPS SSD, `st1` for Throughput Optimized HDD, `sc1`
    #   for Cold HDD, or `standard` for Magnetic volumes.
    #
    #   Default: `gp2`
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the volume during creation.
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] multi_attach_enabled
    #   Specifies whether to enable Amazon EBS Multi-Attach. If you enable
    #   Multi-Attach, you can attach the volume to up to 16 [Nitro-based
    #   instances][1] in the same Availability Zone. For more information,
    #   see [ Amazon EBS Multi-Attach][2] in the *Amazon Elastic Compute
    #   Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ebs-volumes-multi.html
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVolumeRequest AWS API Documentation
    #
    class CreateVolumeRequest < Struct.new(
      :availability_zone,
      :encrypted,
      :iops,
      :kms_key_id,
      :outpost_arn,
      :size,
      :snapshot_id,
      :volume_type,
      :dry_run,
      :tag_specifications,
      :multi_attach_enabled)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateVpcEndpointConnectionNotificationRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         service_id: "VpcEndpointServiceId",
    #         vpc_endpoint_id: "VpcEndpointId",
    #         connection_notification_arn: "String", # required
    #         connection_events: ["String"], # required
    #         client_token: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] service_id
    #   The ID of the endpoint service.
    #   @return [String]
    #
    # @!attribute [rw] vpc_endpoint_id
    #   The ID of the endpoint.
    #   @return [String]
    #
    # @!attribute [rw] connection_notification_arn
    #   The ARN of the SNS topic for the notifications.
    #   @return [String]
    #
    # @!attribute [rw] connection_events
    #   One or more endpoint events for which to receive notifications.
    #   Valid values are `Accept`, `Connect`, `Delete`, and `Reject`.
    #   @return [Array<String>]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVpcEndpointConnectionNotificationRequest AWS API Documentation
    #
    class CreateVpcEndpointConnectionNotificationRequest < Struct.new(
      :dry_run,
      :service_id,
      :vpc_endpoint_id,
      :connection_notification_arn,
      :connection_events,
      :client_token)
      include Aws::Structure
    end

    # @!attribute [rw] connection_notification
    #   Information about the notification.
    #   @return [Types::ConnectionNotification]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVpcEndpointConnectionNotificationResult AWS API Documentation
    #
    class CreateVpcEndpointConnectionNotificationResult < Struct.new(
      :connection_notification,
      :client_token)
      include Aws::Structure
    end

    # Contains the parameters for CreateVpcEndpoint.
    #
    # @note When making an API call, you may pass CreateVpcEndpointRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         vpc_endpoint_type: "Interface", # accepts Interface, Gateway
    #         vpc_id: "VpcId", # required
    #         service_name: "String", # required
    #         policy_document: "String",
    #         route_table_ids: ["RouteTableId"],
    #         subnet_ids: ["SubnetId"],
    #         security_group_ids: ["SecurityGroupId"],
    #         client_token: "String",
    #         private_dns_enabled: false,
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] vpc_endpoint_type
    #   The type of endpoint.
    #
    #   Default: Gateway
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC in which the endpoint will be used.
    #   @return [String]
    #
    # @!attribute [rw] service_name
    #   The service name. To get a list of available services, use the
    #   DescribeVpcEndpointServices request, or get the name from the
    #   service provider.
    #   @return [String]
    #
    # @!attribute [rw] policy_document
    #   A policy to attach to the endpoint that controls access to the
    #   service. The policy must be in valid JSON format. If this parameter
    #   is not specified, we attach a default policy that allows full access
    #   to the service.
    #   @return [String]
    #
    # @!attribute [rw] route_table_ids
    #   (Gateway endpoint) One or more route table IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] subnet_ids
    #   (Interface endpoint) The ID of one or more subnets in which to
    #   create an endpoint network interface.
    #   @return [Array<String>]
    #
    # @!attribute [rw] security_group_ids
    #   (Interface endpoint) The ID of one or more security groups to
    #   associate with the endpoint network interface.
    #   @return [Array<String>]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] private_dns_enabled
    #   (Interface endpoint) Indicates whether to associate a private hosted
    #   zone with the specified VPC. The private hosted zone contains a
    #   record set for the default public DNS name for the service for the
    #   Region (for example, `kinesis.us-east-1.amazonaws.com`), which
    #   resolves to the private IP addresses of the endpoint network
    #   interfaces in the VPC. This enables you to make requests to the
    #   default public DNS name for the service instead of the public DNS
    #   names that are automatically generated by the VPC endpoint service.
    #
    #   To use a private hosted zone, you must set the following VPC
    #   attributes to `true`\: `enableDnsHostnames` and `enableDnsSupport`.
    #   Use ModifyVpcAttribute to set the VPC attributes.
    #
    #   Default: `true`
    #   @return [Boolean]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to associate with the endpoint.
    #   @return [Array<Types::TagSpecification>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVpcEndpointRequest AWS API Documentation
    #
    class CreateVpcEndpointRequest < Struct.new(
      :dry_run,
      :vpc_endpoint_type,
      :vpc_id,
      :service_name,
      :policy_document,
      :route_table_ids,
      :subnet_ids,
      :security_group_ids,
      :client_token,
      :private_dns_enabled,
      :tag_specifications)
      include Aws::Structure
    end

    # Contains the output of CreateVpcEndpoint.
    #
    # @!attribute [rw] vpc_endpoint
    #   Information about the endpoint.
    #   @return [Types::VpcEndpoint]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVpcEndpointResult AWS API Documentation
    #
    class CreateVpcEndpointResult < Struct.new(
      :vpc_endpoint,
      :client_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateVpcEndpointServiceConfigurationRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         acceptance_required: false,
    #         private_dns_name: "String",
    #         network_load_balancer_arns: ["String"], # required
    #         client_token: "String",
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] acceptance_required
    #   Indicates whether requests from service consumers to create an
    #   endpoint to your service must be accepted. To accept a request, use
    #   AcceptVpcEndpointConnections.
    #   @return [Boolean]
    #
    # @!attribute [rw] private_dns_name
    #   The private DNS name to assign to the VPC endpoint service.
    #   @return [String]
    #
    # @!attribute [rw] network_load_balancer_arns
    #   The Amazon Resource Names (ARNs) of one or more Network Load
    #   Balancers for your service.
    #   @return [Array<String>]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to associate with the service.
    #   @return [Array<Types::TagSpecification>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVpcEndpointServiceConfigurationRequest AWS API Documentation
    #
    class CreateVpcEndpointServiceConfigurationRequest < Struct.new(
      :dry_run,
      :acceptance_required,
      :private_dns_name,
      :network_load_balancer_arns,
      :client_token,
      :tag_specifications)
      include Aws::Structure
    end

    # @!attribute [rw] service_configuration
    #   Information about the service configuration.
    #   @return [Types::ServiceConfiguration]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVpcEndpointServiceConfigurationResult AWS API Documentation
    #
    class CreateVpcEndpointServiceConfigurationResult < Struct.new(
      :service_configuration,
      :client_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateVpcPeeringConnectionRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         peer_owner_id: "String",
    #         peer_vpc_id: "String",
    #         vpc_id: "VpcId",
    #         peer_region: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] peer_owner_id
    #   The AWS account ID of the owner of the accepter VPC.
    #
    #   Default: Your AWS account ID
    #   @return [String]
    #
    # @!attribute [rw] peer_vpc_id
    #   The ID of the VPC with which you are creating the VPC peering
    #   connection. You must specify this parameter in the request.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the requester VPC. You must specify this parameter in the
    #   request.
    #   @return [String]
    #
    # @!attribute [rw] peer_region
    #   The Region code for the accepter VPC, if the accepter VPC is located
    #   in a Region other than the Region in which you make the request.
    #
    #   Default: The Region in which you make the request.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVpcPeeringConnectionRequest AWS API Documentation
    #
    class CreateVpcPeeringConnectionRequest < Struct.new(
      :dry_run,
      :peer_owner_id,
      :peer_vpc_id,
      :vpc_id,
      :peer_region)
      include Aws::Structure
    end

    # @!attribute [rw] vpc_peering_connection
    #   Information about the VPC peering connection.
    #   @return [Types::VpcPeeringConnection]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVpcPeeringConnectionResult AWS API Documentation
    #
    class CreateVpcPeeringConnectionResult < Struct.new(
      :vpc_peering_connection)
      include Aws::Structure
    end

    # @note When making an API call, you may pass CreateVpcRequest
    #   data as a hash:
    #
    #       {
    #         cidr_block: "String", # required
    #         amazon_provided_ipv_6_cidr_block: false,
    #         ipv_6_pool: "Ipv6PoolEc2Id",
    #         ipv_6_cidr_block: "String",
    #         dry_run: false,
    #         instance_tenancy: "default", # accepts default, dedicated, host
    #         ipv_6_cidr_block_network_border_group: "String",
    #       }
    #
    # @!attribute [rw] cidr_block
    #   The IPv4 network range for the VPC, in CIDR notation. For example,
    #   `10.0.0.0/16`.
    #   @return [String]
    #
    # @!attribute [rw] amazon_provided_ipv_6_cidr_block
    #   Requests an Amazon-provided IPv6 CIDR block with a /56 prefix length
    #   for the VPC. You cannot specify the range of IP addresses, or the
    #   size of the CIDR block.
    #   @return [Boolean]
    #
    # @!attribute [rw] ipv_6_pool
    #   The ID of an IPv6 address pool from which to allocate the IPv6 CIDR
    #   block.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_cidr_block
    #   The IPv6 CIDR block from the IPv6 address pool. You must also
    #   specify `Ipv6Pool` in the request.
    #
    #   To let Amazon choose the IPv6 CIDR block for you, omit this
    #   parameter.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_tenancy
    #   The tenancy options for instances launched into the VPC. For
    #   `default`, instances are launched with shared tenancy by default.
    #   You can launch instances with any tenancy into a shared tenancy VPC.
    #   For `dedicated`, instances are launched as dedicated tenancy
    #   instances by default. You can only launch instances with a tenancy
    #   of `dedicated` or `host` into a dedicated tenancy VPC.
    #
    #   **Important:** The `host` value cannot be used with this parameter.
    #   Use the `default` or `dedicated` values only.
    #
    #   Default: `default`
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_cidr_block_network_border_group
    #   The name of the location from which we advertise the IPV6 CIDR
    #   block. Use this parameter to limit the address to this location.
    #
    #   You must set `AmazonProvidedIpv6CidrBlock` to `true` to use this
    #   parameter.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVpcRequest AWS API Documentation
    #
    class CreateVpcRequest < Struct.new(
      :cidr_block,
      :amazon_provided_ipv_6_cidr_block,
      :ipv_6_pool,
      :ipv_6_cidr_block,
      :dry_run,
      :instance_tenancy,
      :ipv_6_cidr_block_network_border_group)
      include Aws::Structure
    end

    # @!attribute [rw] vpc
    #   Information about the VPC.
    #   @return [Types::Vpc]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVpcResult AWS API Documentation
    #
    class CreateVpcResult < Struct.new(
      :vpc)
      include Aws::Structure
    end

    # Contains the parameters for CreateVpnConnection.
    #
    # @note When making an API call, you may pass CreateVpnConnectionRequest
    #   data as a hash:
    #
    #       {
    #         customer_gateway_id: "CustomerGatewayId", # required
    #         type: "String", # required
    #         vpn_gateway_id: "VpnGatewayId",
    #         transit_gateway_id: "TransitGatewayId",
    #         dry_run: false,
    #         options: {
    #           enable_acceleration: false,
    #           static_routes_only: false,
    #           tunnel_options: [
    #             {
    #               tunnel_inside_cidr: "String",
    #               pre_shared_key: "String",
    #               phase_1_lifetime_seconds: 1,
    #               phase_2_lifetime_seconds: 1,
    #               rekey_margin_time_seconds: 1,
    #               rekey_fuzz_percentage: 1,
    #               replay_window_size: 1,
    #               dpd_timeout_seconds: 1,
    #               phase_1_encryption_algorithms: [
    #                 {
    #                   value: "String",
    #                 },
    #               ],
    #               phase_2_encryption_algorithms: [
    #                 {
    #                   value: "String",
    #                 },
    #               ],
    #               phase_1_integrity_algorithms: [
    #                 {
    #                   value: "String",
    #                 },
    #               ],
    #               phase_2_integrity_algorithms: [
    #                 {
    #                   value: "String",
    #                 },
    #               ],
    #               phase_1_dh_group_numbers: [
    #                 {
    #                   value: 1,
    #                 },
    #               ],
    #               phase_2_dh_group_numbers: [
    #                 {
    #                   value: 1,
    #                 },
    #               ],
    #               ike_versions: [
    #                 {
    #                   value: "String",
    #                 },
    #               ],
    #             },
    #           ],
    #         },
    #       }
    #
    # @!attribute [rw] customer_gateway_id
    #   The ID of the customer gateway.
    #   @return [String]
    #
    # @!attribute [rw] type
    #   The type of VPN connection (`ipsec.1`).
    #   @return [String]
    #
    # @!attribute [rw] vpn_gateway_id
    #   The ID of the virtual private gateway. If you specify a virtual
    #   private gateway, you cannot specify a transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of the transit gateway. If you specify a transit gateway, you
    #   cannot specify a virtual private gateway.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] options
    #   The options for the VPN connection.
    #   @return [Types::VpnConnectionOptionsSpecification]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVpnConnectionRequest AWS API Documentation
    #
    class CreateVpnConnectionRequest < Struct.new(
      :customer_gateway_id,
      :type,
      :vpn_gateway_id,
      :transit_gateway_id,
      :dry_run,
      :options)
      include Aws::Structure
    end

    # Contains the output of CreateVpnConnection.
    #
    # @!attribute [rw] vpn_connection
    #   Information about the VPN connection.
    #   @return [Types::VpnConnection]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVpnConnectionResult AWS API Documentation
    #
    class CreateVpnConnectionResult < Struct.new(
      :vpn_connection)
      include Aws::Structure
    end

    # Contains the parameters for CreateVpnConnectionRoute.
    #
    # @note When making an API call, you may pass CreateVpnConnectionRouteRequest
    #   data as a hash:
    #
    #       {
    #         destination_cidr_block: "String", # required
    #         vpn_connection_id: "VpnConnectionId", # required
    #       }
    #
    # @!attribute [rw] destination_cidr_block
    #   The CIDR block associated with the local subnet of the customer
    #   network.
    #   @return [String]
    #
    # @!attribute [rw] vpn_connection_id
    #   The ID of the VPN connection.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVpnConnectionRouteRequest AWS API Documentation
    #
    class CreateVpnConnectionRouteRequest < Struct.new(
      :destination_cidr_block,
      :vpn_connection_id)
      include Aws::Structure
    end

    # Contains the parameters for CreateVpnGateway.
    #
    # @note When making an API call, you may pass CreateVpnGatewayRequest
    #   data as a hash:
    #
    #       {
    #         availability_zone: "String",
    #         type: "ipsec.1", # required, accepts ipsec.1
    #         amazon_side_asn: 1,
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone for the virtual private gateway.
    #   @return [String]
    #
    # @!attribute [rw] type
    #   The type of VPN connection this virtual private gateway supports.
    #   @return [String]
    #
    # @!attribute [rw] amazon_side_asn
    #   A private Autonomous System Number (ASN) for the Amazon side of a
    #   BGP session. If you're using a 16-bit ASN, it must be in the 64512
    #   to 65534 range. If you're using a 32-bit ASN, it must be in the
    #   4200000000 to 4294967294 range.
    #
    #   Default: 64512
    #   @return [Integer]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVpnGatewayRequest AWS API Documentation
    #
    class CreateVpnGatewayRequest < Struct.new(
      :availability_zone,
      :type,
      :amazon_side_asn,
      :dry_run)
      include Aws::Structure
    end

    # Contains the output of CreateVpnGateway.
    #
    # @!attribute [rw] vpn_gateway
    #   Information about the virtual private gateway.
    #   @return [Types::VpnGateway]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreateVpnGatewayResult AWS API Documentation
    #
    class CreateVpnGatewayResult < Struct.new(
      :vpn_gateway)
      include Aws::Structure
    end

    # Describes the credit option for CPU usage of a T2 or T3 instance.
    #
    # @!attribute [rw] cpu_credits
    #   The credit option for CPU usage of a T2 or T3 instance. Valid values
    #   are `standard` and `unlimited`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreditSpecification AWS API Documentation
    #
    class CreditSpecification < Struct.new(
      :cpu_credits)
      include Aws::Structure
    end

    # The credit option for CPU usage of a T2 or T3 instance.
    #
    # @note When making an API call, you may pass CreditSpecificationRequest
    #   data as a hash:
    #
    #       {
    #         cpu_credits: "String", # required
    #       }
    #
    # @!attribute [rw] cpu_credits
    #   The credit option for CPU usage of a T2 or T3 instance. Valid values
    #   are `standard` and `unlimited`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CreditSpecificationRequest AWS API Documentation
    #
    class CreditSpecificationRequest < Struct.new(
      :cpu_credits)
      include Aws::Structure
    end

    # Describes a customer gateway.
    #
    # @!attribute [rw] bgp_asn
    #   The customer gateway's Border Gateway Protocol (BGP) Autonomous
    #   System Number (ASN).
    #   @return [String]
    #
    # @!attribute [rw] customer_gateway_id
    #   The ID of the customer gateway.
    #   @return [String]
    #
    # @!attribute [rw] ip_address
    #   The Internet-routable IP address of the customer gateway's outside
    #   interface.
    #   @return [String]
    #
    # @!attribute [rw] certificate_arn
    #   The Amazon Resource Name (ARN) for the customer gateway certificate.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The current state of the customer gateway (`pending | available |
    #   deleting | deleted`).
    #   @return [String]
    #
    # @!attribute [rw] type
    #   The type of VPN connection the customer gateway supports
    #   (`ipsec.1`).
    #   @return [String]
    #
    # @!attribute [rw] device_name
    #   The name of customer gateway device.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the customer gateway.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/CustomerGateway AWS API Documentation
    #
    class CustomerGateway < Struct.new(
      :bgp_asn,
      :customer_gateway_id,
      :ip_address,
      :certificate_arn,
      :state,
      :type,
      :device_name,
      :tags)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteClientVpnEndpointRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN to be deleted.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteClientVpnEndpointRequest AWS API Documentation
    #
    class DeleteClientVpnEndpointRequest < Struct.new(
      :client_vpn_endpoint_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] status
    #   The current state of the Client VPN endpoint.
    #   @return [Types::ClientVpnEndpointStatus]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteClientVpnEndpointResult AWS API Documentation
    #
    class DeleteClientVpnEndpointResult < Struct.new(
      :status)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteClientVpnRouteRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         target_vpc_subnet_id: "SubnetId",
    #         destination_cidr_block: "String", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint from which the route is to be
    #   deleted.
    #   @return [String]
    #
    # @!attribute [rw] target_vpc_subnet_id
    #   The ID of the target subnet used by the route.
    #   @return [String]
    #
    # @!attribute [rw] destination_cidr_block
    #   The IPv4 address range, in CIDR notation, of the route to be
    #   deleted.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteClientVpnRouteRequest AWS API Documentation
    #
    class DeleteClientVpnRouteRequest < Struct.new(
      :client_vpn_endpoint_id,
      :target_vpc_subnet_id,
      :destination_cidr_block,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] status
    #   The current state of the route.
    #   @return [Types::ClientVpnRouteStatus]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteClientVpnRouteResult AWS API Documentation
    #
    class DeleteClientVpnRouteResult < Struct.new(
      :status)
      include Aws::Structure
    end

    # Contains the parameters for DeleteCustomerGateway.
    #
    # @note When making an API call, you may pass DeleteCustomerGatewayRequest
    #   data as a hash:
    #
    #       {
    #         customer_gateway_id: "CustomerGatewayId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] customer_gateway_id
    #   The ID of the customer gateway.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteCustomerGatewayRequest AWS API Documentation
    #
    class DeleteCustomerGatewayRequest < Struct.new(
      :customer_gateway_id,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteDhcpOptionsRequest
    #   data as a hash:
    #
    #       {
    #         dhcp_options_id: "DhcpOptionsId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] dhcp_options_id
    #   The ID of the DHCP options set.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteDhcpOptionsRequest AWS API Documentation
    #
    class DeleteDhcpOptionsRequest < Struct.new(
      :dhcp_options_id,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteEgressOnlyInternetGatewayRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         egress_only_internet_gateway_id: "EgressOnlyInternetGatewayId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] egress_only_internet_gateway_id
    #   The ID of the egress-only internet gateway.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteEgressOnlyInternetGatewayRequest AWS API Documentation
    #
    class DeleteEgressOnlyInternetGatewayRequest < Struct.new(
      :dry_run,
      :egress_only_internet_gateway_id)
      include Aws::Structure
    end

    # @!attribute [rw] return_code
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteEgressOnlyInternetGatewayResult AWS API Documentation
    #
    class DeleteEgressOnlyInternetGatewayResult < Struct.new(
      :return_code)
      include Aws::Structure
    end

    # Describes an EC2 Fleet error.
    #
    # @!attribute [rw] code
    #   The error code.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   The description for the error code.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteFleetError AWS API Documentation
    #
    class DeleteFleetError < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # Describes an EC2 Fleet that was not successfully deleted.
    #
    # @!attribute [rw] error
    #   The error.
    #   @return [Types::DeleteFleetError]
    #
    # @!attribute [rw] fleet_id
    #   The ID of the EC2 Fleet.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteFleetErrorItem AWS API Documentation
    #
    class DeleteFleetErrorItem < Struct.new(
      :error,
      :fleet_id)
      include Aws::Structure
    end

    # Describes an EC2 Fleet that was successfully deleted.
    #
    # @!attribute [rw] current_fleet_state
    #   The current state of the EC2 Fleet.
    #   @return [String]
    #
    # @!attribute [rw] previous_fleet_state
    #   The previous state of the EC2 Fleet.
    #   @return [String]
    #
    # @!attribute [rw] fleet_id
    #   The ID of the EC2 Fleet.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteFleetSuccessItem AWS API Documentation
    #
    class DeleteFleetSuccessItem < Struct.new(
      :current_fleet_state,
      :previous_fleet_state,
      :fleet_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteFleetsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         fleet_ids: ["FleetId"], # required
    #         terminate_instances: false, # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] fleet_ids
    #   The IDs of the EC2 Fleets.
    #   @return [Array<String>]
    #
    # @!attribute [rw] terminate_instances
    #   Indicates whether to terminate instances for an EC2 Fleet if it is
    #   deleted successfully.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteFleetsRequest AWS API Documentation
    #
    class DeleteFleetsRequest < Struct.new(
      :dry_run,
      :fleet_ids,
      :terminate_instances)
      include Aws::Structure
    end

    # @!attribute [rw] successful_fleet_deletions
    #   Information about the EC2 Fleets that are successfully deleted.
    #   @return [Array<Types::DeleteFleetSuccessItem>]
    #
    # @!attribute [rw] unsuccessful_fleet_deletions
    #   Information about the EC2 Fleets that are not successfully deleted.
    #   @return [Array<Types::DeleteFleetErrorItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteFleetsResult AWS API Documentation
    #
    class DeleteFleetsResult < Struct.new(
      :successful_fleet_deletions,
      :unsuccessful_fleet_deletions)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteFlowLogsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         flow_log_ids: ["VpcFlowLogId"], # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] flow_log_ids
    #   One or more flow log IDs.
    #
    #   Constraint: Maximum of 1000 flow log IDs.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteFlowLogsRequest AWS API Documentation
    #
    class DeleteFlowLogsRequest < Struct.new(
      :dry_run,
      :flow_log_ids)
      include Aws::Structure
    end

    # @!attribute [rw] unsuccessful
    #   Information about the flow logs that could not be deleted
    #   successfully.
    #   @return [Array<Types::UnsuccessfulItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteFlowLogsResult AWS API Documentation
    #
    class DeleteFlowLogsResult < Struct.new(
      :unsuccessful)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteFpgaImageRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         fpga_image_id: "FpgaImageId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] fpga_image_id
    #   The ID of the AFI.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteFpgaImageRequest AWS API Documentation
    #
    class DeleteFpgaImageRequest < Struct.new(
      :dry_run,
      :fpga_image_id)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Is `true` if the request succeeds, and an error otherwise.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteFpgaImageResult AWS API Documentation
    #
    class DeleteFpgaImageResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteInternetGatewayRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         internet_gateway_id: "InternetGatewayId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] internet_gateway_id
    #   The ID of the internet gateway.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteInternetGatewayRequest AWS API Documentation
    #
    class DeleteInternetGatewayRequest < Struct.new(
      :dry_run,
      :internet_gateway_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteKeyPairRequest
    #   data as a hash:
    #
    #       {
    #         key_name: "KeyPairName",
    #         key_pair_id: "KeyPairId",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] key_name
    #   The name of the key pair.
    #   @return [String]
    #
    # @!attribute [rw] key_pair_id
    #   The ID of the key pair.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteKeyPairRequest AWS API Documentation
    #
    class DeleteKeyPairRequest < Struct.new(
      :key_name,
      :key_pair_id,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteLaunchTemplateRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         launch_template_id: "LaunchTemplateId",
    #         launch_template_name: "LaunchTemplateName",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] launch_template_id
    #   The ID of the launch template. You must specify either the launch
    #   template ID or launch template name in the request.
    #   @return [String]
    #
    # @!attribute [rw] launch_template_name
    #   The name of the launch template. You must specify either the launch
    #   template ID or launch template name in the request.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteLaunchTemplateRequest AWS API Documentation
    #
    class DeleteLaunchTemplateRequest < Struct.new(
      :dry_run,
      :launch_template_id,
      :launch_template_name)
      include Aws::Structure
    end

    # @!attribute [rw] launch_template
    #   Information about the launch template.
    #   @return [Types::LaunchTemplate]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteLaunchTemplateResult AWS API Documentation
    #
    class DeleteLaunchTemplateResult < Struct.new(
      :launch_template)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteLaunchTemplateVersionsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         launch_template_id: "LaunchTemplateId",
    #         launch_template_name: "LaunchTemplateName",
    #         versions: ["String"], # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] launch_template_id
    #   The ID of the launch template. You must specify either the launch
    #   template ID or launch template name in the request.
    #   @return [String]
    #
    # @!attribute [rw] launch_template_name
    #   The name of the launch template. You must specify either the launch
    #   template ID or launch template name in the request.
    #   @return [String]
    #
    # @!attribute [rw] versions
    #   The version numbers of one or more launch template versions to
    #   delete.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteLaunchTemplateVersionsRequest AWS API Documentation
    #
    class DeleteLaunchTemplateVersionsRequest < Struct.new(
      :dry_run,
      :launch_template_id,
      :launch_template_name,
      :versions)
      include Aws::Structure
    end

    # Describes a launch template version that could not be deleted.
    #
    # @!attribute [rw] launch_template_id
    #   The ID of the launch template.
    #   @return [String]
    #
    # @!attribute [rw] launch_template_name
    #   The name of the launch template.
    #   @return [String]
    #
    # @!attribute [rw] version_number
    #   The version number of the launch template.
    #   @return [Integer]
    #
    # @!attribute [rw] response_error
    #   Information about the error.
    #   @return [Types::ResponseError]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteLaunchTemplateVersionsResponseErrorItem AWS API Documentation
    #
    class DeleteLaunchTemplateVersionsResponseErrorItem < Struct.new(
      :launch_template_id,
      :launch_template_name,
      :version_number,
      :response_error)
      include Aws::Structure
    end

    # Describes a launch template version that was successfully deleted.
    #
    # @!attribute [rw] launch_template_id
    #   The ID of the launch template.
    #   @return [String]
    #
    # @!attribute [rw] launch_template_name
    #   The name of the launch template.
    #   @return [String]
    #
    # @!attribute [rw] version_number
    #   The version number of the launch template.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteLaunchTemplateVersionsResponseSuccessItem AWS API Documentation
    #
    class DeleteLaunchTemplateVersionsResponseSuccessItem < Struct.new(
      :launch_template_id,
      :launch_template_name,
      :version_number)
      include Aws::Structure
    end

    # @!attribute [rw] successfully_deleted_launch_template_versions
    #   Information about the launch template versions that were
    #   successfully deleted.
    #   @return [Array<Types::DeleteLaunchTemplateVersionsResponseSuccessItem>]
    #
    # @!attribute [rw] unsuccessfully_deleted_launch_template_versions
    #   Information about the launch template versions that could not be
    #   deleted.
    #   @return [Array<Types::DeleteLaunchTemplateVersionsResponseErrorItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteLaunchTemplateVersionsResult AWS API Documentation
    #
    class DeleteLaunchTemplateVersionsResult < Struct.new(
      :successfully_deleted_launch_template_versions,
      :unsuccessfully_deleted_launch_template_versions)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteLocalGatewayRouteRequest
    #   data as a hash:
    #
    #       {
    #         destination_cidr_block: "String", # required
    #         local_gateway_route_table_id: "LocalGatewayRoutetableId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] destination_cidr_block
    #   The CIDR range for the route. This must match the CIDR for the route
    #   exactly.
    #   @return [String]
    #
    # @!attribute [rw] local_gateway_route_table_id
    #   The ID of the local gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteLocalGatewayRouteRequest AWS API Documentation
    #
    class DeleteLocalGatewayRouteRequest < Struct.new(
      :destination_cidr_block,
      :local_gateway_route_table_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] route
    #   Information about the route.
    #   @return [Types::LocalGatewayRoute]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteLocalGatewayRouteResult AWS API Documentation
    #
    class DeleteLocalGatewayRouteResult < Struct.new(
      :route)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteLocalGatewayRouteTableVpcAssociationRequest
    #   data as a hash:
    #
    #       {
    #         local_gateway_route_table_vpc_association_id: "LocalGatewayRouteTableVpcAssociationId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] local_gateway_route_table_vpc_association_id
    #   The ID of the association.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteLocalGatewayRouteTableVpcAssociationRequest AWS API Documentation
    #
    class DeleteLocalGatewayRouteTableVpcAssociationRequest < Struct.new(
      :local_gateway_route_table_vpc_association_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] local_gateway_route_table_vpc_association
    #   Information about the association.
    #   @return [Types::LocalGatewayRouteTableVpcAssociation]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteLocalGatewayRouteTableVpcAssociationResult AWS API Documentation
    #
    class DeleteLocalGatewayRouteTableVpcAssociationResult < Struct.new(
      :local_gateway_route_table_vpc_association)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteNatGatewayRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         nat_gateway_id: "NatGatewayId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] nat_gateway_id
    #   The ID of the NAT gateway.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteNatGatewayRequest AWS API Documentation
    #
    class DeleteNatGatewayRequest < Struct.new(
      :dry_run,
      :nat_gateway_id)
      include Aws::Structure
    end

    # @!attribute [rw] nat_gateway_id
    #   The ID of the NAT gateway.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteNatGatewayResult AWS API Documentation
    #
    class DeleteNatGatewayResult < Struct.new(
      :nat_gateway_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteNetworkAclEntryRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         egress: false, # required
    #         network_acl_id: "NetworkAclId", # required
    #         rule_number: 1, # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] egress
    #   Indicates whether the rule is an egress rule.
    #   @return [Boolean]
    #
    # @!attribute [rw] network_acl_id
    #   The ID of the network ACL.
    #   @return [String]
    #
    # @!attribute [rw] rule_number
    #   The rule number of the entry to delete.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteNetworkAclEntryRequest AWS API Documentation
    #
    class DeleteNetworkAclEntryRequest < Struct.new(
      :dry_run,
      :egress,
      :network_acl_id,
      :rule_number)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteNetworkAclRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         network_acl_id: "NetworkAclId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] network_acl_id
    #   The ID of the network ACL.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteNetworkAclRequest AWS API Documentation
    #
    class DeleteNetworkAclRequest < Struct.new(
      :dry_run,
      :network_acl_id)
      include Aws::Structure
    end

    # Contains the parameters for DeleteNetworkInterfacePermission.
    #
    # @note When making an API call, you may pass DeleteNetworkInterfacePermissionRequest
    #   data as a hash:
    #
    #       {
    #         network_interface_permission_id: "NetworkInterfacePermissionId", # required
    #         force: false,
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] network_interface_permission_id
    #   The ID of the network interface permission.
    #   @return [String]
    #
    # @!attribute [rw] force
    #   Specify `true` to remove the permission even if the network
    #   interface is attached to an instance.
    #   @return [Boolean]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteNetworkInterfacePermissionRequest AWS API Documentation
    #
    class DeleteNetworkInterfacePermissionRequest < Struct.new(
      :network_interface_permission_id,
      :force,
      :dry_run)
      include Aws::Structure
    end

    # Contains the output for DeleteNetworkInterfacePermission.
    #
    # @!attribute [rw] return
    #   Returns `true` if the request succeeds, otherwise returns an error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteNetworkInterfacePermissionResult AWS API Documentation
    #
    class DeleteNetworkInterfacePermissionResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # Contains the parameters for DeleteNetworkInterface.
    #
    # @note When making an API call, you may pass DeleteNetworkInterfaceRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         network_interface_id: "NetworkInterfaceId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteNetworkInterfaceRequest AWS API Documentation
    #
    class DeleteNetworkInterfaceRequest < Struct.new(
      :dry_run,
      :network_interface_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeletePlacementGroupRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         group_name: "PlacementGroupName", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] group_name
    #   The name of the placement group.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeletePlacementGroupRequest AWS API Documentation
    #
    class DeletePlacementGroupRequest < Struct.new(
      :dry_run,
      :group_name)
      include Aws::Structure
    end

    # Describes the error for a Reserved Instance whose queued purchase
    # could not be deleted.
    #
    # @!attribute [rw] code
    #   The error code.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   The error message.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteQueuedReservedInstancesError AWS API Documentation
    #
    class DeleteQueuedReservedInstancesError < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteQueuedReservedInstancesRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         reserved_instances_ids: ["ReservationId"], # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] reserved_instances_ids
    #   The IDs of the Reserved Instances.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteQueuedReservedInstancesRequest AWS API Documentation
    #
    class DeleteQueuedReservedInstancesRequest < Struct.new(
      :dry_run,
      :reserved_instances_ids)
      include Aws::Structure
    end

    # @!attribute [rw] successful_queued_purchase_deletions
    #   Information about the queued purchases that were successfully
    #   deleted.
    #   @return [Array<Types::SuccessfulQueuedPurchaseDeletion>]
    #
    # @!attribute [rw] failed_queued_purchase_deletions
    #   Information about the queued purchases that could not be deleted.
    #   @return [Array<Types::FailedQueuedPurchaseDeletion>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteQueuedReservedInstancesResult AWS API Documentation
    #
    class DeleteQueuedReservedInstancesResult < Struct.new(
      :successful_queued_purchase_deletions,
      :failed_queued_purchase_deletions)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteRouteRequest
    #   data as a hash:
    #
    #       {
    #         destination_cidr_block: "String",
    #         destination_ipv_6_cidr_block: "String",
    #         dry_run: false,
    #         route_table_id: "RouteTableId", # required
    #       }
    #
    # @!attribute [rw] destination_cidr_block
    #   The IPv4 CIDR range for the route. The value you specify must match
    #   the CIDR for the route exactly.
    #   @return [String]
    #
    # @!attribute [rw] destination_ipv_6_cidr_block
    #   The IPv6 CIDR range for the route. The value you specify must match
    #   the CIDR for the route exactly.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] route_table_id
    #   The ID of the route table.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteRouteRequest AWS API Documentation
    #
    class DeleteRouteRequest < Struct.new(
      :destination_cidr_block,
      :destination_ipv_6_cidr_block,
      :dry_run,
      :route_table_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteRouteTableRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         route_table_id: "RouteTableId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] route_table_id
    #   The ID of the route table.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteRouteTableRequest AWS API Documentation
    #
    class DeleteRouteTableRequest < Struct.new(
      :dry_run,
      :route_table_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteSecurityGroupRequest
    #   data as a hash:
    #
    #       {
    #         group_id: "SecurityGroupId",
    #         group_name: "SecurityGroupName",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] group_id
    #   The ID of the security group. Required for a nondefault VPC.
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   \[EC2-Classic, default VPC\] The name of the security group. You can
    #   specify either the security group name or the security group ID.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteSecurityGroupRequest AWS API Documentation
    #
    class DeleteSecurityGroupRequest < Struct.new(
      :group_id,
      :group_name,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteSnapshotRequest
    #   data as a hash:
    #
    #       {
    #         snapshot_id: "SnapshotId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] snapshot_id
    #   The ID of the EBS snapshot.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteSnapshotRequest AWS API Documentation
    #
    class DeleteSnapshotRequest < Struct.new(
      :snapshot_id,
      :dry_run)
      include Aws::Structure
    end

    # Contains the parameters for DeleteSpotDatafeedSubscription.
    #
    # @note When making an API call, you may pass DeleteSpotDatafeedSubscriptionRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteSpotDatafeedSubscriptionRequest AWS API Documentation
    #
    class DeleteSpotDatafeedSubscriptionRequest < Struct.new(
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteSubnetRequest
    #   data as a hash:
    #
    #       {
    #         subnet_id: "SubnetId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteSubnetRequest AWS API Documentation
    #
    class DeleteSubnetRequest < Struct.new(
      :subnet_id,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteTagsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         resources: ["TaggableResourceId"], # required
    #         tags: [
    #           {
    #             key: "String",
    #             value: "String",
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] resources
    #   The IDs of the resources, separated by spaces.
    #
    #   Constraints: Up to 1000 resource IDs. We recommend breaking up this
    #   request into smaller batches.
    #   @return [Array<String>]
    #
    # @!attribute [rw] tags
    #   The tags to delete. Specify a tag key and an optional tag value to
    #   delete specific tags. If you specify a tag key without a tag value,
    #   we delete any tag with this key regardless of its value. If you
    #   specify a tag key with an empty string as the tag value, we delete
    #   the tag only if its value is an empty string.
    #
    #   If you omit this parameter, we delete all user-defined tags for the
    #   specified resources. We do not delete AWS-generated tags (tags that
    #   have the `aws:` prefix).
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTagsRequest AWS API Documentation
    #
    class DeleteTagsRequest < Struct.new(
      :dry_run,
      :resources,
      :tags)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteTrafficMirrorFilterRequest
    #   data as a hash:
    #
    #       {
    #         traffic_mirror_filter_id: "TrafficMirrorFilterId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] traffic_mirror_filter_id
    #   The ID of the Traffic Mirror filter.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTrafficMirrorFilterRequest AWS API Documentation
    #
    class DeleteTrafficMirrorFilterRequest < Struct.new(
      :traffic_mirror_filter_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] traffic_mirror_filter_id
    #   The ID of the Traffic Mirror filter.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTrafficMirrorFilterResult AWS API Documentation
    #
    class DeleteTrafficMirrorFilterResult < Struct.new(
      :traffic_mirror_filter_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteTrafficMirrorFilterRuleRequest
    #   data as a hash:
    #
    #       {
    #         traffic_mirror_filter_rule_id: "TrafficMirrorFilterRuleId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] traffic_mirror_filter_rule_id
    #   The ID of the Traffic Mirror rule.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTrafficMirrorFilterRuleRequest AWS API Documentation
    #
    class DeleteTrafficMirrorFilterRuleRequest < Struct.new(
      :traffic_mirror_filter_rule_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] traffic_mirror_filter_rule_id
    #   The ID of the deleted Traffic Mirror rule.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTrafficMirrorFilterRuleResult AWS API Documentation
    #
    class DeleteTrafficMirrorFilterRuleResult < Struct.new(
      :traffic_mirror_filter_rule_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteTrafficMirrorSessionRequest
    #   data as a hash:
    #
    #       {
    #         traffic_mirror_session_id: "TrafficMirrorSessionId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] traffic_mirror_session_id
    #   The ID of the Traffic Mirror session.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTrafficMirrorSessionRequest AWS API Documentation
    #
    class DeleteTrafficMirrorSessionRequest < Struct.new(
      :traffic_mirror_session_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] traffic_mirror_session_id
    #   The ID of the deleted Traffic Mirror session.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTrafficMirrorSessionResult AWS API Documentation
    #
    class DeleteTrafficMirrorSessionResult < Struct.new(
      :traffic_mirror_session_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteTrafficMirrorTargetRequest
    #   data as a hash:
    #
    #       {
    #         traffic_mirror_target_id: "TrafficMirrorTargetId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] traffic_mirror_target_id
    #   The ID of the Traffic Mirror target.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTrafficMirrorTargetRequest AWS API Documentation
    #
    class DeleteTrafficMirrorTargetRequest < Struct.new(
      :traffic_mirror_target_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] traffic_mirror_target_id
    #   The ID of the deleted Traffic Mirror target.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTrafficMirrorTargetResult AWS API Documentation
    #
    class DeleteTrafficMirrorTargetResult < Struct.new(
      :traffic_mirror_target_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteTransitGatewayMulticastDomainRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_multicast_domain_id: "TransitGatewayMulticastDomainId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_multicast_domain_id
    #   The ID of the transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTransitGatewayMulticastDomainRequest AWS API Documentation
    #
    class DeleteTransitGatewayMulticastDomainRequest < Struct.new(
      :transit_gateway_multicast_domain_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_multicast_domain
    #   Information about the deleted transit gateway multicast domain.
    #   @return [Types::TransitGatewayMulticastDomain]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTransitGatewayMulticastDomainResult AWS API Documentation
    #
    class DeleteTransitGatewayMulticastDomainResult < Struct.new(
      :transit_gateway_multicast_domain)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteTransitGatewayPeeringAttachmentRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_attachment_id: "TransitGatewayAttachmentId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the transit gateway peering attachment.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTransitGatewayPeeringAttachmentRequest AWS API Documentation
    #
    class DeleteTransitGatewayPeeringAttachmentRequest < Struct.new(
      :transit_gateway_attachment_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_peering_attachment
    #   The transit gateway peering attachment.
    #   @return [Types::TransitGatewayPeeringAttachment]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTransitGatewayPeeringAttachmentResult AWS API Documentation
    #
    class DeleteTransitGatewayPeeringAttachmentResult < Struct.new(
      :transit_gateway_peering_attachment)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteTransitGatewayRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_id: "TransitGatewayId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTransitGatewayRequest AWS API Documentation
    #
    class DeleteTransitGatewayRequest < Struct.new(
      :transit_gateway_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway
    #   Information about the deleted transit gateway.
    #   @return [Types::TransitGateway]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTransitGatewayResult AWS API Documentation
    #
    class DeleteTransitGatewayResult < Struct.new(
      :transit_gateway)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteTransitGatewayRouteRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_route_table_id: "TransitGatewayRouteTableId", # required
    #         destination_cidr_block: "String", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the transit gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] destination_cidr_block
    #   The CIDR range for the route. This must match the CIDR for the route
    #   exactly.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTransitGatewayRouteRequest AWS API Documentation
    #
    class DeleteTransitGatewayRouteRequest < Struct.new(
      :transit_gateway_route_table_id,
      :destination_cidr_block,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] route
    #   Information about the route.
    #   @return [Types::TransitGatewayRoute]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTransitGatewayRouteResult AWS API Documentation
    #
    class DeleteTransitGatewayRouteResult < Struct.new(
      :route)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteTransitGatewayRouteTableRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_route_table_id: "TransitGatewayRouteTableId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the transit gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTransitGatewayRouteTableRequest AWS API Documentation
    #
    class DeleteTransitGatewayRouteTableRequest < Struct.new(
      :transit_gateway_route_table_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_route_table
    #   Information about the deleted transit gateway route table.
    #   @return [Types::TransitGatewayRouteTable]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTransitGatewayRouteTableResult AWS API Documentation
    #
    class DeleteTransitGatewayRouteTableResult < Struct.new(
      :transit_gateway_route_table)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteTransitGatewayVpcAttachmentRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_attachment_id: "TransitGatewayAttachmentId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTransitGatewayVpcAttachmentRequest AWS API Documentation
    #
    class DeleteTransitGatewayVpcAttachmentRequest < Struct.new(
      :transit_gateway_attachment_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_vpc_attachment
    #   Information about the deleted VPC attachment.
    #   @return [Types::TransitGatewayVpcAttachment]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteTransitGatewayVpcAttachmentResult AWS API Documentation
    #
    class DeleteTransitGatewayVpcAttachmentResult < Struct.new(
      :transit_gateway_vpc_attachment)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteVolumeRequest
    #   data as a hash:
    #
    #       {
    #         volume_id: "VolumeId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] volume_id
    #   The ID of the volume.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteVolumeRequest AWS API Documentation
    #
    class DeleteVolumeRequest < Struct.new(
      :volume_id,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteVpcEndpointConnectionNotificationsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         connection_notification_ids: ["String"], # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] connection_notification_ids
    #   One or more notification IDs.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteVpcEndpointConnectionNotificationsRequest AWS API Documentation
    #
    class DeleteVpcEndpointConnectionNotificationsRequest < Struct.new(
      :dry_run,
      :connection_notification_ids)
      include Aws::Structure
    end

    # @!attribute [rw] unsuccessful
    #   Information about the notifications that could not be deleted
    #   successfully.
    #   @return [Array<Types::UnsuccessfulItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteVpcEndpointConnectionNotificationsResult AWS API Documentation
    #
    class DeleteVpcEndpointConnectionNotificationsResult < Struct.new(
      :unsuccessful)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteVpcEndpointServiceConfigurationsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         service_ids: ["VpcEndpointServiceId"], # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] service_ids
    #   The IDs of one or more services.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteVpcEndpointServiceConfigurationsRequest AWS API Documentation
    #
    class DeleteVpcEndpointServiceConfigurationsRequest < Struct.new(
      :dry_run,
      :service_ids)
      include Aws::Structure
    end

    # @!attribute [rw] unsuccessful
    #   Information about the service configurations that were not deleted,
    #   if applicable.
    #   @return [Array<Types::UnsuccessfulItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteVpcEndpointServiceConfigurationsResult AWS API Documentation
    #
    class DeleteVpcEndpointServiceConfigurationsResult < Struct.new(
      :unsuccessful)
      include Aws::Structure
    end

    # Contains the parameters for DeleteVpcEndpoints.
    #
    # @note When making an API call, you may pass DeleteVpcEndpointsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         vpc_endpoint_ids: ["VpcEndpointId"], # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] vpc_endpoint_ids
    #   One or more VPC endpoint IDs.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteVpcEndpointsRequest AWS API Documentation
    #
    class DeleteVpcEndpointsRequest < Struct.new(
      :dry_run,
      :vpc_endpoint_ids)
      include Aws::Structure
    end

    # Contains the output of DeleteVpcEndpoints.
    #
    # @!attribute [rw] unsuccessful
    #   Information about the VPC endpoints that were not successfully
    #   deleted.
    #   @return [Array<Types::UnsuccessfulItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteVpcEndpointsResult AWS API Documentation
    #
    class DeleteVpcEndpointsResult < Struct.new(
      :unsuccessful)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteVpcPeeringConnectionRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         vpc_peering_connection_id: "VpcPeeringConnectionId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] vpc_peering_connection_id
    #   The ID of the VPC peering connection.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteVpcPeeringConnectionRequest AWS API Documentation
    #
    class DeleteVpcPeeringConnectionRequest < Struct.new(
      :dry_run,
      :vpc_peering_connection_id)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteVpcPeeringConnectionResult AWS API Documentation
    #
    class DeleteVpcPeeringConnectionResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeleteVpcRequest
    #   data as a hash:
    #
    #       {
    #         vpc_id: "VpcId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteVpcRequest AWS API Documentation
    #
    class DeleteVpcRequest < Struct.new(
      :vpc_id,
      :dry_run)
      include Aws::Structure
    end

    # Contains the parameters for DeleteVpnConnection.
    #
    # @note When making an API call, you may pass DeleteVpnConnectionRequest
    #   data as a hash:
    #
    #       {
    #         vpn_connection_id: "VpnConnectionId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] vpn_connection_id
    #   The ID of the VPN connection.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteVpnConnectionRequest AWS API Documentation
    #
    class DeleteVpnConnectionRequest < Struct.new(
      :vpn_connection_id,
      :dry_run)
      include Aws::Structure
    end

    # Contains the parameters for DeleteVpnConnectionRoute.
    #
    # @note When making an API call, you may pass DeleteVpnConnectionRouteRequest
    #   data as a hash:
    #
    #       {
    #         destination_cidr_block: "String", # required
    #         vpn_connection_id: "VpnConnectionId", # required
    #       }
    #
    # @!attribute [rw] destination_cidr_block
    #   The CIDR block associated with the local subnet of the customer
    #   network.
    #   @return [String]
    #
    # @!attribute [rw] vpn_connection_id
    #   The ID of the VPN connection.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteVpnConnectionRouteRequest AWS API Documentation
    #
    class DeleteVpnConnectionRouteRequest < Struct.new(
      :destination_cidr_block,
      :vpn_connection_id)
      include Aws::Structure
    end

    # Contains the parameters for DeleteVpnGateway.
    #
    # @note When making an API call, you may pass DeleteVpnGatewayRequest
    #   data as a hash:
    #
    #       {
    #         vpn_gateway_id: "VpnGatewayId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] vpn_gateway_id
    #   The ID of the virtual private gateway.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeleteVpnGatewayRequest AWS API Documentation
    #
    class DeleteVpnGatewayRequest < Struct.new(
      :vpn_gateway_id,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeprovisionByoipCidrRequest
    #   data as a hash:
    #
    #       {
    #         cidr: "String", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] cidr
    #   The address range, in CIDR notation. The prefix must be the same
    #   prefix that you specified when you provisioned the address range.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeprovisionByoipCidrRequest AWS API Documentation
    #
    class DeprovisionByoipCidrRequest < Struct.new(
      :cidr,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] byoip_cidr
    #   Information about the address range.
    #   @return [Types::ByoipCidr]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeprovisionByoipCidrResult AWS API Documentation
    #
    class DeprovisionByoipCidrResult < Struct.new(
      :byoip_cidr)
      include Aws::Structure
    end

    # Contains the parameters for DeregisterImage.
    #
    # @note When making an API call, you may pass DeregisterImageRequest
    #   data as a hash:
    #
    #       {
    #         image_id: "ImageId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] image_id
    #   The ID of the AMI.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeregisterImageRequest AWS API Documentation
    #
    class DeregisterImageRequest < Struct.new(
      :image_id,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeregisterInstanceEventNotificationAttributesRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         instance_tag_attribute: {
    #           include_all_tags_of_instance: false,
    #           instance_tag_keys: ["String"],
    #         },
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_tag_attribute
    #   Information about the tag keys to deregister.
    #   @return [Types::DeregisterInstanceTagAttributeRequest]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeregisterInstanceEventNotificationAttributesRequest AWS API Documentation
    #
    class DeregisterInstanceEventNotificationAttributesRequest < Struct.new(
      :dry_run,
      :instance_tag_attribute)
      include Aws::Structure
    end

    # @!attribute [rw] instance_tag_attribute
    #   The resulting set of tag keys.
    #   @return [Types::InstanceTagNotificationAttribute]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeregisterInstanceEventNotificationAttributesResult AWS API Documentation
    #
    class DeregisterInstanceEventNotificationAttributesResult < Struct.new(
      :instance_tag_attribute)
      include Aws::Structure
    end

    # Information about the tag keys to deregister for the current Region.
    # You can either specify individual tag keys or deregister all tag keys
    # in the current Region. You must specify either
    # `IncludeAllTagsOfInstance` or `InstanceTagKeys` in the request
    #
    # @note When making an API call, you may pass DeregisterInstanceTagAttributeRequest
    #   data as a hash:
    #
    #       {
    #         include_all_tags_of_instance: false,
    #         instance_tag_keys: ["String"],
    #       }
    #
    # @!attribute [rw] include_all_tags_of_instance
    #   Indicates whether to deregister all tag keys in the current Region.
    #   Specify `false` to deregister all tag keys.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_tag_keys
    #   Information about the tag keys to deregister.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeregisterInstanceTagAttributeRequest AWS API Documentation
    #
    class DeregisterInstanceTagAttributeRequest < Struct.new(
      :include_all_tags_of_instance,
      :instance_tag_keys)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeregisterTransitGatewayMulticastGroupMembersRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_multicast_domain_id: "TransitGatewayMulticastDomainId",
    #         group_ip_address: "String",
    #         network_interface_ids: ["NetworkInterfaceId"],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_multicast_domain_id
    #   The ID of the transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] group_ip_address
    #   The IP address assigned to the transit gateway multicast group.
    #   @return [String]
    #
    # @!attribute [rw] network_interface_ids
    #   The IDs of the group members' network interfaces.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeregisterTransitGatewayMulticastGroupMembersRequest AWS API Documentation
    #
    class DeregisterTransitGatewayMulticastGroupMembersRequest < Struct.new(
      :transit_gateway_multicast_domain_id,
      :group_ip_address,
      :network_interface_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] deregistered_multicast_group_members
    #   Information about the deregistered members.
    #   @return [Types::TransitGatewayMulticastDeregisteredGroupMembers]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeregisterTransitGatewayMulticastGroupMembersResult AWS API Documentation
    #
    class DeregisterTransitGatewayMulticastGroupMembersResult < Struct.new(
      :deregistered_multicast_group_members)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DeregisterTransitGatewayMulticastGroupSourcesRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_multicast_domain_id: "TransitGatewayMulticastDomainId",
    #         group_ip_address: "String",
    #         network_interface_ids: ["NetworkInterfaceId"],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_multicast_domain_id
    #   The ID of the transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] group_ip_address
    #   The IP address assigned to the transit gateway multicast group.
    #   @return [String]
    #
    # @!attribute [rw] network_interface_ids
    #   The IDs of the group sources' network interfaces.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeregisterTransitGatewayMulticastGroupSourcesRequest AWS API Documentation
    #
    class DeregisterTransitGatewayMulticastGroupSourcesRequest < Struct.new(
      :transit_gateway_multicast_domain_id,
      :group_ip_address,
      :network_interface_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] deregistered_multicast_group_sources
    #   Information about the deregistered group sources.
    #   @return [Types::TransitGatewayMulticastDeregisteredGroupSources]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DeregisterTransitGatewayMulticastGroupSourcesResult AWS API Documentation
    #
    class DeregisterTransitGatewayMulticastGroupSourcesResult < Struct.new(
      :deregistered_multicast_group_sources)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeAccountAttributesRequest
    #   data as a hash:
    #
    #       {
    #         attribute_names: ["supported-platforms"], # accepts supported-platforms, default-vpc
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] attribute_names
    #   The account attribute names.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeAccountAttributesRequest AWS API Documentation
    #
    class DescribeAccountAttributesRequest < Struct.new(
      :attribute_names,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] account_attributes
    #   Information about the account attributes.
    #   @return [Array<Types::AccountAttribute>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeAccountAttributesResult AWS API Documentation
    #
    class DescribeAccountAttributesResult < Struct.new(
      :account_attributes)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeAddressesRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         public_ips: ["String"],
    #         allocation_ids: ["AllocationId"],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters. Filter names and values are case-sensitive.
    #
    #   * `allocation-id` - \[EC2-VPC\] The allocation ID for the address.
    #
    #   * `association-id` - \[EC2-VPC\] The association ID for the address.
    #
    #   * `domain` - Indicates whether the address is for use in EC2-Classic
    #     (`standard`) or in a VPC (`vpc`).
    #
    #   * `instance-id` - The ID of the instance the address is associated
    #     with, if any.
    #
    #   * `network-border-group` - The location from where the IP address is
    #     advertised.
    #
    #   * `network-interface-id` - \[EC2-VPC\] The ID of the network
    #     interface that the address is associated with, if any.
    #
    #   * `network-interface-owner-id` - The AWS account ID of the owner.
    #
    #   * `private-ip-address` - \[EC2-VPC\] The private IP address
    #     associated with the Elastic IP address.
    #
    #   * `public-ip` - The Elastic IP address.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] public_ips
    #   One or more Elastic IP addresses.
    #
    #   Default: Describes all your Elastic IP addresses.
    #   @return [Array<String>]
    #
    # @!attribute [rw] allocation_ids
    #   \[EC2-VPC\] Information about the allocation IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeAddressesRequest AWS API Documentation
    #
    class DescribeAddressesRequest < Struct.new(
      :filters,
      :public_ips,
      :allocation_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] addresses
    #   Information about the Elastic IP addresses.
    #   @return [Array<Types::Address>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeAddressesResult AWS API Documentation
    #
    class DescribeAddressesResult < Struct.new(
      :addresses)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeAggregateIdFormatRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeAggregateIdFormatRequest AWS API Documentation
    #
    class DescribeAggregateIdFormatRequest < Struct.new(
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] use_long_ids_aggregated
    #   Indicates whether all resource types in the Region are configured to
    #   use longer IDs. This value is only `true` if all users are
    #   configured to use longer IDs for all resources types in the Region.
    #   @return [Boolean]
    #
    # @!attribute [rw] statuses
    #   Information about each resource's ID format.
    #   @return [Array<Types::IdFormat>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeAggregateIdFormatResult AWS API Documentation
    #
    class DescribeAggregateIdFormatResult < Struct.new(
      :use_long_ids_aggregated,
      :statuses)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeAvailabilityZonesRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         zone_names: ["String"],
    #         zone_ids: ["String"],
    #         all_availability_zones: false,
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `group-name` - For Availability Zones, use the Region name. For
    #     Local Zones, use the name of the group associated with the Local
    #     Zone (for example, `us-west-2-lax-1`).
    #
    #   * `message` - The Availability Zone or Local Zone message.
    #
    #   * `opt-in-status` - The opt in status (`opted-in`, and
    #     `not-opted-in` \| `opt-in-not-required`).
    #
    #   * `region-name` - The name of the Region for the Availability Zone
    #     or Local Zone (for example, `us-east-1`).
    #
    #   * `state` - The state of the Availability Zone or Local Zone
    #     (`available` \| `information` \| `impaired` \| `unavailable`).
    #
    #   * `zone-id` - The ID of the Availability Zone (for example,
    #     `use1-az1`) or the Local Zone (for example, use `usw2-lax1-az1`).
    #
    #   * `zone-name` - The name of the Availability Zone (for example,
    #     `us-east-1a`) or the Local Zone (for example, use
    #     `us-west-2-lax-1a`).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] zone_names
    #   The names of the Availability Zones and Local Zones.
    #   @return [Array<String>]
    #
    # @!attribute [rw] zone_ids
    #   The IDs of the Availability Zones and Local Zones.
    #   @return [Array<String>]
    #
    # @!attribute [rw] all_availability_zones
    #   Include all Availability Zones and Local Zones regardless of your
    #   opt in status.
    #
    #   If you do not use this parameter, the results include only the zones
    #   for the Regions where you have chosen the option to opt in.
    #   @return [Boolean]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeAvailabilityZonesRequest AWS API Documentation
    #
    class DescribeAvailabilityZonesRequest < Struct.new(
      :filters,
      :zone_names,
      :zone_ids,
      :all_availability_zones,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] availability_zones
    #   Information about the Availability Zones and Local Zones.
    #   @return [Array<Types::AvailabilityZone>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeAvailabilityZonesResult AWS API Documentation
    #
    class DescribeAvailabilityZonesResult < Struct.new(
      :availability_zones)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeBundleTasksRequest
    #   data as a hash:
    #
    #       {
    #         bundle_ids: ["BundleId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] bundle_ids
    #   The bundle task IDs.
    #
    #   Default: Describes all your bundle tasks.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `bundle-id` - The ID of the bundle task.
    #
    #   * `error-code` - If the task failed, the error code returned.
    #
    #   * `error-message` - If the task failed, the error message returned.
    #
    #   * `instance-id` - The ID of the instance.
    #
    #   * `progress` - The level of task completion, as a percentage (for
    #     example, 20%).
    #
    #   * `s3-bucket` - The Amazon S3 bucket to store the AMI.
    #
    #   * `s3-prefix` - The beginning of the AMI name.
    #
    #   * `start-time` - The time the task started (for example,
    #     2013-09-15T17:15:20.000Z).
    #
    #   * `state` - The state of the task (`pending` \|
    #     `waiting-for-shutdown` \| `bundling` \| `storing` \| `cancelling`
    #     \| `complete` \| `failed`).
    #
    #   * `update-time` - The time of the most recent update for the task.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeBundleTasksRequest AWS API Documentation
    #
    class DescribeBundleTasksRequest < Struct.new(
      :bundle_ids,
      :filters,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] bundle_tasks
    #   Information about the bundle tasks.
    #   @return [Array<Types::BundleTask>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeBundleTasksResult AWS API Documentation
    #
    class DescribeBundleTasksResult < Struct.new(
      :bundle_tasks)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeByoipCidrsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         max_results: 1, # required
    #         next_token: "NextToken",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeByoipCidrsRequest AWS API Documentation
    #
    class DescribeByoipCidrsRequest < Struct.new(
      :dry_run,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] byoip_cidrs
    #   Information about your address ranges.
    #   @return [Array<Types::ByoipCidr>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeByoipCidrsResult AWS API Documentation
    #
    class DescribeByoipCidrsResult < Struct.new(
      :byoip_cidrs,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeCapacityReservationsRequest
    #   data as a hash:
    #
    #       {
    #         capacity_reservation_ids: ["CapacityReservationId"],
    #         next_token: "String",
    #         max_results: 1,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] capacity_reservation_ids
    #   The ID of the Capacity Reservation.
    #   @return [Array<String>]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results can be seen by sending another request
    #   with the returned nextToken value.
    #   @return [Integer]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `instance-type` - The type of instance for which the Capacity
    #     Reservation reserves capacity.
    #
    #   * `owner-id` - The ID of the AWS account that owns the Capacity
    #     Reservation.
    #
    #   * `availability-zone-id` - The Availability Zone ID of the Capacity
    #     Reservation.
    #
    #   * `instance-platform` - The type of operating system for which the
    #     Capacity Reservation reserves capacity.
    #
    #   * `availability-zone` - The Availability Zone ID of the Capacity
    #     Reservation.
    #
    #   * `tenancy` - Indicates the tenancy of the Capacity Reservation. A
    #     Capacity Reservation can have one of the following tenancy
    #     settings:
    #
    #     * `default` - The Capacity Reservation is created on hardware that
    #       is shared with other AWS accounts.
    #
    #     * `dedicated` - The Capacity Reservation is created on
    #       single-tenant hardware that is dedicated to a single AWS
    #       account.
    #
    #   * `state` - The current state of the Capacity Reservation. A
    #     Capacity Reservation can be in one of the following states:
    #
    #     * `active`- The Capacity Reservation is active and the capacity is
    #       available for your use.
    #
    #     * `expired` - The Capacity Reservation expired automatically at
    #       the date and time specified in your request. The reserved
    #       capacity is no longer available for your use.
    #
    #     * `cancelled` - The Capacity Reservation was manually cancelled.
    #       The reserved capacity is no longer available for your use.
    #
    #     * `pending` - The Capacity Reservation request was successful but
    #       the capacity provisioning is still pending.
    #
    #     * `failed` - The Capacity Reservation request has failed. A
    #       request might fail due to invalid request parameters, capacity
    #       constraints, or instance limit constraints. Failed requests are
    #       retained for 60 minutes.
    #
    #   * `end-date` - The date and time at which the Capacity Reservation
    #     expires. When a Capacity Reservation expires, the reserved
    #     capacity is released and you can no longer launch instances into
    #     it. The Capacity Reservation's state changes to expired when it
    #     reaches its end date and time.
    #
    #   * `end-date-type` - Indicates the way in which the Capacity
    #     Reservation ends. A Capacity Reservation can have one of the
    #     following end types:
    #
    #     * `unlimited` - The Capacity Reservation remains active until you
    #       explicitly cancel it.
    #
    #     * `limited` - The Capacity Reservation expires automatically at a
    #       specified date and time.
    #
    #   * `instance-match-criteria` - Indicates the type of instance
    #     launches that the Capacity Reservation accepts. The options
    #     include:
    #
    #     * `open` - The Capacity Reservation accepts all instances that
    #       have matching attributes (instance type, platform, and
    #       Availability Zone). Instances that have matching attributes
    #       launch into the Capacity Reservation automatically without
    #       specifying any additional parameters.
    #
    #     * `targeted` - The Capacity Reservation only accepts instances
    #       that have matching attributes (instance type, platform, and
    #       Availability Zone), and explicitly target the Capacity
    #       Reservation. This ensures that only permitted instances can use
    #       the reserved capacity.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeCapacityReservationsRequest AWS API Documentation
    #
    class DescribeCapacityReservationsRequest < Struct.new(
      :capacity_reservation_ids,
      :next_token,
      :max_results,
      :filters,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @!attribute [rw] capacity_reservations
    #   Information about the Capacity Reservations.
    #   @return [Array<Types::CapacityReservation>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeCapacityReservationsResult AWS API Documentation
    #
    class DescribeCapacityReservationsResult < Struct.new(
      :next_token,
      :capacity_reservations)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeClassicLinkInstancesRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #         instance_ids: ["InstanceId"],
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `group-id` - The ID of a VPC security group that's associated
    #     with the instance.
    #
    #   * `instance-id` - The ID of the instance.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `vpc-id` - The ID of the VPC to which the instance is linked.
    #
    #     `vpc-id` - The ID of the VPC that the instance is linked to.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_ids
    #   One or more instance IDs. Must be instances linked to a VPC through
    #   ClassicLink.
    #   @return [Array<String>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #
    #   Constraint: If the value is greater than 1000, we return only 1000
    #   items.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeClassicLinkInstancesRequest AWS API Documentation
    #
    class DescribeClassicLinkInstancesRequest < Struct.new(
      :filters,
      :dry_run,
      :instance_ids,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] instances
    #   Information about one or more linked EC2-Classic instances.
    #   @return [Array<Types::ClassicLinkInstance>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeClassicLinkInstancesResult AWS API Documentation
    #
    class DescribeClassicLinkInstancesResult < Struct.new(
      :instances,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeClientVpnAuthorizationRulesRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         dry_run: false,
    #         next_token: "NextToken",
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters. Filter names and values are case-sensitive.
    #
    #   * `description` - The description of the authorization rule.
    #
    #   * `destination-cidr` - The CIDR of the network to which the
    #     authorization rule applies.
    #
    #   * `group-id` - The ID of the Active Directory group to which the
    #     authorization rule grants access.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results can be seen by sending another request
    #   with the nextToken value.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeClientVpnAuthorizationRulesRequest AWS API Documentation
    #
    class DescribeClientVpnAuthorizationRulesRequest < Struct.new(
      :client_vpn_endpoint_id,
      :dry_run,
      :next_token,
      :filters,
      :max_results)
      include Aws::Structure
    end

    # @!attribute [rw] authorization_rules
    #   Information about the authorization rules.
    #   @return [Array<Types::AuthorizationRule>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeClientVpnAuthorizationRulesResult AWS API Documentation
    #
    class DescribeClientVpnAuthorizationRulesResult < Struct.new(
      :authorization_rules,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeClientVpnConnectionsRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         next_token: "NextToken",
    #         max_results: 1,
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters. Filter names and values are case-sensitive.
    #
    #   * `connection-id` - The ID of the connection.
    #
    #   * `username` - For Active Directory client authentication, the user
    #     name of the client who established the client connection.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results can be seen by sending another request
    #   with the nextToken value.
    #   @return [Integer]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeClientVpnConnectionsRequest AWS API Documentation
    #
    class DescribeClientVpnConnectionsRequest < Struct.new(
      :client_vpn_endpoint_id,
      :filters,
      :next_token,
      :max_results,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] connections
    #   Information about the active and terminated client connections.
    #   @return [Array<Types::ClientVpnConnection>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeClientVpnConnectionsResult AWS API Documentation
    #
    class DescribeClientVpnConnectionsResult < Struct.new(
      :connections,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeClientVpnEndpointsRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_ids: ["ClientVpnEndpointId"],
    #         max_results: 1,
    #         next_token: "NextToken",
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_ids
    #   The ID of the Client VPN endpoint.
    #   @return [Array<String>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results can be seen by sending another request
    #   with the nextToken value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters. Filter names and values are case-sensitive.
    #
    #   * `endpoint-id` - The ID of the Client VPN endpoint.
    #
    #   * `transport-protocol` - The transport protocol (`tcp` \| `udp`).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeClientVpnEndpointsRequest AWS API Documentation
    #
    class DescribeClientVpnEndpointsRequest < Struct.new(
      :client_vpn_endpoint_ids,
      :max_results,
      :next_token,
      :filters,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] client_vpn_endpoints
    #   Information about the Client VPN endpoints.
    #   @return [Array<Types::ClientVpnEndpoint>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeClientVpnEndpointsResult AWS API Documentation
    #
    class DescribeClientVpnEndpointsResult < Struct.new(
      :client_vpn_endpoints,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeClientVpnRoutesRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "NextToken",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters. Filter names and values are case-sensitive.
    #
    #   * `destination-cidr` - The CIDR of the route destination.
    #
    #   * `origin` - How the route was associated with the Client VPN
    #     endpoint (`associate` \| `add-route`).
    #
    #   * `target-subnet` - The ID of the subnet through which traffic is
    #     routed.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results can be seen by sending another request
    #   with the nextToken value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeClientVpnRoutesRequest AWS API Documentation
    #
    class DescribeClientVpnRoutesRequest < Struct.new(
      :client_vpn_endpoint_id,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] routes
    #   Information about the Client VPN endpoint routes.
    #   @return [Array<Types::ClientVpnRoute>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeClientVpnRoutesResult AWS API Documentation
    #
    class DescribeClientVpnRoutesResult < Struct.new(
      :routes,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeClientVpnTargetNetworksRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         association_ids: ["String"],
    #         max_results: 1,
    #         next_token: "NextToken",
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] association_ids
    #   The IDs of the target network associations.
    #   @return [Array<String>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results can be seen by sending another request
    #   with the nextToken value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters. Filter names and values are case-sensitive.
    #
    #   * `association-id` - The ID of the association.
    #
    #   * `target-network-id` - The ID of the subnet specified as the target
    #     network.
    #
    #   * `vpc-id` - The ID of the VPC in which the target network is
    #     located.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeClientVpnTargetNetworksRequest AWS API Documentation
    #
    class DescribeClientVpnTargetNetworksRequest < Struct.new(
      :client_vpn_endpoint_id,
      :association_ids,
      :max_results,
      :next_token,
      :filters,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] client_vpn_target_networks
    #   Information about the associated target networks.
    #   @return [Array<Types::TargetNetwork>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeClientVpnTargetNetworksResult AWS API Documentation
    #
    class DescribeClientVpnTargetNetworksResult < Struct.new(
      :client_vpn_target_networks,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeCoipPoolsRequest
    #   data as a hash:
    #
    #       {
    #         pool_ids: ["CoipPoolId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] pool_ids
    #   The IDs of the address pools.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   The filters. The following are the possible values:
    #
    #   * `coip-pool.pool-id`
    #
    #   ^
    #   ^
    #
    #   * `coip-pool.local-gateway-route-table-id`
    #
    #   ^
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeCoipPoolsRequest AWS API Documentation
    #
    class DescribeCoipPoolsRequest < Struct.new(
      :pool_ids,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] coip_pools
    #   Information about the address pools.
    #   @return [Array<Types::CoipPool>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeCoipPoolsResult AWS API Documentation
    #
    class DescribeCoipPoolsResult < Struct.new(
      :coip_pools,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeConversionTasksRequest
    #   data as a hash:
    #
    #       {
    #         conversion_task_ids: ["ConversionTaskId"],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] conversion_task_ids
    #   The conversion task IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeConversionTasksRequest AWS API Documentation
    #
    class DescribeConversionTasksRequest < Struct.new(
      :conversion_task_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] conversion_tasks
    #   Information about the conversion tasks.
    #   @return [Array<Types::ConversionTask>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeConversionTasksResult AWS API Documentation
    #
    class DescribeConversionTasksResult < Struct.new(
      :conversion_tasks)
      include Aws::Structure
    end

    # Contains the parameters for DescribeCustomerGateways.
    #
    # @note When making an API call, you may pass DescribeCustomerGatewaysRequest
    #   data as a hash:
    #
    #       {
    #         customer_gateway_ids: ["CustomerGatewayId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] customer_gateway_ids
    #   One or more customer gateway IDs.
    #
    #   Default: Describes all your customer gateways.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `bgp-asn` - The customer gateway's Border Gateway Protocol (BGP)
    #     Autonomous System Number (ASN).
    #
    #   * `customer-gateway-id` - The ID of the customer gateway.
    #
    #   * `ip-address` - The IP address of the customer gateway's
    #     Internet-routable external interface.
    #
    #   * `state` - The state of the customer gateway (`pending` \|
    #     `available` \| `deleting` \| `deleted`).
    #
    #   * `type` - The type of customer gateway. Currently, the only
    #     supported type is `ipsec.1`.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeCustomerGatewaysRequest AWS API Documentation
    #
    class DescribeCustomerGatewaysRequest < Struct.new(
      :customer_gateway_ids,
      :filters,
      :dry_run)
      include Aws::Structure
    end

    # Contains the output of DescribeCustomerGateways.
    #
    # @!attribute [rw] customer_gateways
    #   Information about one or more customer gateways.
    #   @return [Array<Types::CustomerGateway>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeCustomerGatewaysResult AWS API Documentation
    #
    class DescribeCustomerGatewaysResult < Struct.new(
      :customer_gateways)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeDhcpOptionsRequest
    #   data as a hash:
    #
    #       {
    #         dhcp_options_ids: ["DhcpOptionsId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #         next_token: "String",
    #         max_results: 1,
    #       }
    #
    # @!attribute [rw] dhcp_options_ids
    #   The IDs of one or more DHCP options sets.
    #
    #   Default: Describes all your DHCP options sets.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `dhcp-options-id` - The ID of a DHCP options set.
    #
    #   * `key` - The key for one of the options (for example,
    #     `domain-name`).
    #
    #   * `value` - The value for one of the options.
    #
    #   * `owner-id` - The ID of the AWS account that owns the DHCP options
    #     set.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeDhcpOptionsRequest AWS API Documentation
    #
    class DescribeDhcpOptionsRequest < Struct.new(
      :dhcp_options_ids,
      :filters,
      :dry_run,
      :next_token,
      :max_results)
      include Aws::Structure
    end

    # @!attribute [rw] dhcp_options
    #   Information about one or more DHCP options sets.
    #   @return [Array<Types::DhcpOptions>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeDhcpOptionsResult AWS API Documentation
    #
    class DescribeDhcpOptionsResult < Struct.new(
      :dhcp_options,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeEgressOnlyInternetGatewaysRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         egress_only_internet_gateway_ids: ["EgressOnlyInternetGatewayId"],
    #         max_results: 1,
    #         next_token: "String",
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] egress_only_internet_gateway_ids
    #   One or more egress-only internet gateway IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #   @return [Array<Types::Filter>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeEgressOnlyInternetGatewaysRequest AWS API Documentation
    #
    class DescribeEgressOnlyInternetGatewaysRequest < Struct.new(
      :dry_run,
      :egress_only_internet_gateway_ids,
      :max_results,
      :next_token,
      :filters)
      include Aws::Structure
    end

    # @!attribute [rw] egress_only_internet_gateways
    #   Information about the egress-only internet gateways.
    #   @return [Array<Types::EgressOnlyInternetGateway>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeEgressOnlyInternetGatewaysResult AWS API Documentation
    #
    class DescribeEgressOnlyInternetGatewaysResult < Struct.new(
      :egress_only_internet_gateways,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeElasticGpusRequest
    #   data as a hash:
    #
    #       {
    #         elastic_gpu_ids: ["ElasticGpuId"],
    #         dry_run: false,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] elastic_gpu_ids
    #   The Elastic Graphics accelerator IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `availability-zone` - The Availability Zone in which the Elastic
    #     Graphics accelerator resides.
    #
    #   * `elastic-gpu-health` - The status of the Elastic Graphics
    #     accelerator (`OK` \| `IMPAIRED`).
    #
    #   * `elastic-gpu-state` - The state of the Elastic Graphics
    #     accelerator (`ATTACHED`).
    #
    #   * `elastic-gpu-type` - The type of Elastic Graphics accelerator; for
    #     example, `eg1.medium`.
    #
    #   * `instance-id` - The ID of the instance to which the Elastic
    #     Graphics accelerator is associated.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `NextToken` value. This value can be between 5 and 1000.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to request the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeElasticGpusRequest AWS API Documentation
    #
    class DescribeElasticGpusRequest < Struct.new(
      :elastic_gpu_ids,
      :dry_run,
      :filters,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] elastic_gpu_set
    #   Information about the Elastic Graphics accelerators.
    #   @return [Array<Types::ElasticGpus>]
    #
    # @!attribute [rw] max_results
    #   The total number of items to return. If the total number of items
    #   available is more than the value specified in max-items then a
    #   Next-Token will be provided in the output that you can use to resume
    #   pagination.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeElasticGpusResult AWS API Documentation
    #
    class DescribeElasticGpusResult < Struct.new(
      :elastic_gpu_set,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeExportImageTasksRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         export_image_task_ids: ["ExportImageTaskId"],
    #         max_results: 1,
    #         next_token: "NextToken",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] filters
    #   Filter tasks using the `task-state` filter and one of the following
    #   values: `active`, `completed`, `deleting`, or `deleted`.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] export_image_task_ids
    #   The IDs of the export image tasks.
    #   @return [Array<String>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   A token that indicates the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeExportImageTasksRequest AWS API Documentation
    #
    class DescribeExportImageTasksRequest < Struct.new(
      :dry_run,
      :filters,
      :export_image_task_ids,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] export_image_tasks
    #   Information about the export image tasks.
    #   @return [Array<Types::ExportImageTask>]
    #
    # @!attribute [rw] next_token
    #   The token to use to get the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeExportImageTasksResult AWS API Documentation
    #
    class DescribeExportImageTasksResult < Struct.new(
      :export_image_tasks,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeExportTasksRequest
    #   data as a hash:
    #
    #       {
    #         export_task_ids: ["ExportTaskId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] export_task_ids
    #   The export task IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   the filters for the export tasks.
    #   @return [Array<Types::Filter>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeExportTasksRequest AWS API Documentation
    #
    class DescribeExportTasksRequest < Struct.new(
      :export_task_ids,
      :filters)
      include Aws::Structure
    end

    # @!attribute [rw] export_tasks
    #   Information about the export tasks.
    #   @return [Array<Types::ExportTask>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeExportTasksResult AWS API Documentation
    #
    class DescribeExportTasksResult < Struct.new(
      :export_tasks)
      include Aws::Structure
    end

    # Describes fast snapshot restores for a snapshot.
    #
    # @!attribute [rw] snapshot_id
    #   The ID of the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of fast snapshot restores.
    #   @return [String]
    #
    # @!attribute [rw] state_transition_reason
    #   The reason for the state transition. The possible values are as
    #   follows:
    #
    #   * `Client.UserInitiated` - The state successfully transitioned to
    #     `enabling` or `disabling`.
    #
    #   * `Client.UserInitiated - Lifecycle state transition` - The state
    #     successfully transitioned to `optimizing`, `enabled`, or
    #     `disabled`.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account that owns the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] owner_alias
    #   The alias of the snapshot owner.
    #   @return [String]
    #
    # @!attribute [rw] enabling_time
    #   The time at which fast snapshot restores entered the `enabling`
    #   state.
    #   @return [Time]
    #
    # @!attribute [rw] optimizing_time
    #   The time at which fast snapshot restores entered the `optimizing`
    #   state.
    #   @return [Time]
    #
    # @!attribute [rw] enabled_time
    #   The time at which fast snapshot restores entered the `enabled`
    #   state.
    #   @return [Time]
    #
    # @!attribute [rw] disabling_time
    #   The time at which fast snapshot restores entered the `disabling`
    #   state.
    #   @return [Time]
    #
    # @!attribute [rw] disabled_time
    #   The time at which fast snapshot restores entered the `disabled`
    #   state.
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFastSnapshotRestoreSuccessItem AWS API Documentation
    #
    class DescribeFastSnapshotRestoreSuccessItem < Struct.new(
      :snapshot_id,
      :availability_zone,
      :state,
      :state_transition_reason,
      :owner_id,
      :owner_alias,
      :enabling_time,
      :optimizing_time,
      :enabled_time,
      :disabling_time,
      :disabled_time)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeFastSnapshotRestoresRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "NextToken",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] filters
    #   The filters. The possible values are:
    #
    #   * `availability-zone`\: The Availability Zone of the snapshot.
    #
    #   * `owner-id`\: The ID of the AWS account that owns the snapshot.
    #
    #   * `snapshot-id`\: The ID of the snapshot.
    #
    #   * `state`\: The state of fast snapshot restores for the snapshot
    #     (`enabling` \| `optimizing` \| `enabled` \| `disabling` \|
    #     `disabled`).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFastSnapshotRestoresRequest AWS API Documentation
    #
    class DescribeFastSnapshotRestoresRequest < Struct.new(
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] fast_snapshot_restores
    #   Information about the state of fast snapshot restores.
    #   @return [Array<Types::DescribeFastSnapshotRestoreSuccessItem>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFastSnapshotRestoresResult AWS API Documentation
    #
    class DescribeFastSnapshotRestoresResult < Struct.new(
      :fast_snapshot_restores,
      :next_token)
      include Aws::Structure
    end

    # Describes the instances that could not be launched by the fleet.
    #
    # @!attribute [rw] launch_template_and_overrides
    #   The launch templates and overrides that were used for launching the
    #   instances. The values that you specify in the Overrides replace the
    #   values in the launch template.
    #   @return [Types::LaunchTemplateAndOverridesResponse]
    #
    # @!attribute [rw] lifecycle
    #   Indicates if the instance that could not be launched was a Spot
    #   Instance or On-Demand Instance.
    #   @return [String]
    #
    # @!attribute [rw] error_code
    #   The error code that indicates why the instance could not be
    #   launched. For more information about error codes, see [Error
    #   Codes][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html
    #   @return [String]
    #
    # @!attribute [rw] error_message
    #   The error message that describes why the instance could not be
    #   launched. For more information about error messages, see [Error
    #   Codes][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFleetError AWS API Documentation
    #
    class DescribeFleetError < Struct.new(
      :launch_template_and_overrides,
      :lifecycle,
      :error_code,
      :error_message)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeFleetHistoryRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         event_type: "instance-change", # accepts instance-change, fleet-change, service-error
    #         max_results: 1,
    #         next_token: "String",
    #         fleet_id: "FleetId", # required
    #         start_time: Time.now, # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] event_type
    #   The type of events to describe. By default, all events are
    #   described.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. Specify a
    #   value between 1 and 1000. The default value is 1000. To retrieve the
    #   remaining results, make another call with the returned `NextToken`
    #   value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next set of results.
    #   @return [String]
    #
    # @!attribute [rw] fleet_id
    #   The ID of the EC2 Fleet.
    #   @return [String]
    #
    # @!attribute [rw] start_time
    #   The start date and time for the events, in UTC format (for example,
    #   *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z).
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFleetHistoryRequest AWS API Documentation
    #
    class DescribeFleetHistoryRequest < Struct.new(
      :dry_run,
      :event_type,
      :max_results,
      :next_token,
      :fleet_id,
      :start_time)
      include Aws::Structure
    end

    # @!attribute [rw] history_records
    #   Information about the events in the history of the EC2 Fleet.
    #   @return [Array<Types::HistoryRecordEntry>]
    #
    # @!attribute [rw] last_evaluated_time
    #   The last date and time for the events, in UTC format (for example,
    #   *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z). All records up to this time
    #   were retrieved.
    #
    #   If `nextToken` indicates that there are more results, this value is
    #   not present.
    #   @return [Time]
    #
    # @!attribute [rw] next_token
    #   The token for the next set of results.
    #   @return [String]
    #
    # @!attribute [rw] fleet_id
    #   The ID of the EC Fleet.
    #   @return [String]
    #
    # @!attribute [rw] start_time
    #   The start date and time for the events, in UTC format (for example,
    #   *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z).
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFleetHistoryResult AWS API Documentation
    #
    class DescribeFleetHistoryResult < Struct.new(
      :history_records,
      :last_evaluated_time,
      :next_token,
      :fleet_id,
      :start_time)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeFleetInstancesRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         max_results: 1,
    #         next_token: "String",
    #         fleet_id: "FleetId", # required
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. Specify a
    #   value between 1 and 1000. The default value is 1000. To retrieve the
    #   remaining results, make another call with the returned `NextToken`
    #   value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next set of results.
    #   @return [String]
    #
    # @!attribute [rw] fleet_id
    #   The ID of the EC2 Fleet.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `instance-type` - The instance type.
    #
    #   ^
    #   @return [Array<Types::Filter>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFleetInstancesRequest AWS API Documentation
    #
    class DescribeFleetInstancesRequest < Struct.new(
      :dry_run,
      :max_results,
      :next_token,
      :fleet_id,
      :filters)
      include Aws::Structure
    end

    # @!attribute [rw] active_instances
    #   The running instances. This list is refreshed periodically and might
    #   be out of date.
    #   @return [Array<Types::ActiveInstance>]
    #
    # @!attribute [rw] next_token
    #   The token for the next set of results.
    #   @return [String]
    #
    # @!attribute [rw] fleet_id
    #   The ID of the EC2 Fleet.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFleetInstancesResult AWS API Documentation
    #
    class DescribeFleetInstancesResult < Struct.new(
      :active_instances,
      :next_token,
      :fleet_id)
      include Aws::Structure
    end

    # Describes the instances that were launched by the fleet.
    #
    # @!attribute [rw] launch_template_and_overrides
    #   The launch templates and overrides that were used for launching the
    #   instances. The values that you specify in the Overrides replace the
    #   values in the launch template.
    #   @return [Types::LaunchTemplateAndOverridesResponse]
    #
    # @!attribute [rw] lifecycle
    #   Indicates if the instance that was launched is a Spot Instance or
    #   On-Demand Instance.
    #   @return [String]
    #
    # @!attribute [rw] instance_ids
    #   The IDs of the instances.
    #   @return [Array<String>]
    #
    # @!attribute [rw] instance_type
    #   The instance type.
    #   @return [String]
    #
    # @!attribute [rw] platform
    #   The value is `Windows` for Windows instances. Otherwise, the value
    #   is blank.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFleetsInstances AWS API Documentation
    #
    class DescribeFleetsInstances < Struct.new(
      :launch_template_and_overrides,
      :lifecycle,
      :instance_ids,
      :instance_type,
      :platform)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeFleetsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         max_results: 1,
    #         next_token: "String",
    #         fleet_ids: ["FleetId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. Specify a
    #   value between 1 and 1000. The default value is 1000. To retrieve the
    #   remaining results, make another call with the returned `NextToken`
    #   value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next set of results.
    #   @return [String]
    #
    # @!attribute [rw] fleet_ids
    #   The ID of the EC2 Fleets.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `activity-status` - The progress of the EC2 Fleet ( `error` \|
    #     `pending-fulfillment` \| `pending-termination` \| `fulfilled`).
    #
    #   * `excess-capacity-termination-policy` - Indicates whether to
    #     terminate running instances if the target capacity is decreased
    #     below the current EC2 Fleet size (`true` \| `false`).
    #
    #   * `fleet-state` - The state of the EC2 Fleet (`submitted` \|
    #     `active` \| `deleted` \| `failed` \| `deleted-running` \|
    #     `deleted-terminating` \| `modifying`).
    #
    #   * `replace-unhealthy-instances` - Indicates whether EC2 Fleet should
    #     replace unhealthy instances (`true` \| `false`).
    #
    #   * `type` - The type of request (`instant` \| `request` \|
    #     `maintain`).
    #   @return [Array<Types::Filter>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFleetsRequest AWS API Documentation
    #
    class DescribeFleetsRequest < Struct.new(
      :dry_run,
      :max_results,
      :next_token,
      :fleet_ids,
      :filters)
      include Aws::Structure
    end

    # @!attribute [rw] next_token
    #   The token for the next set of results.
    #   @return [String]
    #
    # @!attribute [rw] fleets
    #   Information about the EC2 Fleets.
    #   @return [Array<Types::FleetData>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFleetsResult AWS API Documentation
    #
    class DescribeFleetsResult < Struct.new(
      :next_token,
      :fleets)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeFlowLogsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         filter: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         flow_log_ids: ["VpcFlowLogId"],
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] filter
    #   One or more filters.
    #
    #   * `deliver-log-status` - The status of the logs delivery (`SUCCESS`
    #     \| `FAILED`).
    #
    #   * `log-destination-type` - The type of destination to which the flow
    #     log publishes data. Possible destination types include
    #     `cloud-watch-logs` and `S3`.
    #
    #   * `flow-log-id` - The ID of the flow log.
    #
    #   * `log-group-name` - The name of the log group.
    #
    #   * `resource-id` - The ID of the VPC, subnet, or network interface.
    #
    #   * `traffic-type` - The type of traffic (`ACCEPT` \| `REJECT` \|
    #     `ALL`).
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] flow_log_ids
    #   One or more flow log IDs.
    #
    #   Constraint: Maximum of 1000 flow log IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFlowLogsRequest AWS API Documentation
    #
    class DescribeFlowLogsRequest < Struct.new(
      :dry_run,
      :filter,
      :flow_log_ids,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] flow_logs
    #   Information about the flow logs.
    #   @return [Array<Types::FlowLog>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFlowLogsResult AWS API Documentation
    #
    class DescribeFlowLogsResult < Struct.new(
      :flow_logs,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeFpgaImageAttributeRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         fpga_image_id: "FpgaImageId", # required
    #         attribute: "description", # required, accepts description, name, loadPermission, productCodes
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] fpga_image_id
    #   The ID of the AFI.
    #   @return [String]
    #
    # @!attribute [rw] attribute
    #   The AFI attribute.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFpgaImageAttributeRequest AWS API Documentation
    #
    class DescribeFpgaImageAttributeRequest < Struct.new(
      :dry_run,
      :fpga_image_id,
      :attribute)
      include Aws::Structure
    end

    # @!attribute [rw] fpga_image_attribute
    #   Information about the attribute.
    #   @return [Types::FpgaImageAttribute]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFpgaImageAttributeResult AWS API Documentation
    #
    class DescribeFpgaImageAttributeResult < Struct.new(
      :fpga_image_attribute)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeFpgaImagesRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         fpga_image_ids: ["FpgaImageId"],
    #         owners: ["String"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         next_token: "NextToken",
    #         max_results: 1,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] fpga_image_ids
    #   The AFI IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] owners
    #   Filters the AFI by owner. Specify an AWS account ID, `self` (owner
    #   is the sender of the request), or an AWS owner alias (valid values
    #   are `amazon` \| `aws-marketplace`).
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `create-time` - The creation time of the AFI.
    #
    #   * `fpga-image-id` - The FPGA image identifier (AFI ID).
    #
    #   * `fpga-image-global-id` - The global FPGA image identifier (AGFI
    #     ID).
    #
    #   * `name` - The name of the AFI.
    #
    #   * `owner-id` - The AWS account ID of the AFI owner.
    #
    #   * `product-code` - The product code.
    #
    #   * `shell-version` - The version of the AWS Shell that was used to
    #     create the bitstream.
    #
    #   * `state` - The state of the AFI (`pending` \| `failed` \|
    #     `available` \| `unavailable`).
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `update-time` - The time of the most recent update.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFpgaImagesRequest AWS API Documentation
    #
    class DescribeFpgaImagesRequest < Struct.new(
      :dry_run,
      :fpga_image_ids,
      :owners,
      :filters,
      :next_token,
      :max_results)
      include Aws::Structure
    end

    # @!attribute [rw] fpga_images
    #   Information about the FPGA images.
    #   @return [Array<Types::FpgaImage>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeFpgaImagesResult AWS API Documentation
    #
    class DescribeFpgaImagesResult < Struct.new(
      :fpga_images,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeHostReservationOfferingsRequest
    #   data as a hash:
    #
    #       {
    #         filter: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_duration: 1,
    #         max_results: 1,
    #         min_duration: 1,
    #         next_token: "String",
    #         offering_id: "OfferingId",
    #       }
    #
    # @!attribute [rw] filter
    #   The filters.
    #
    #   * `instance-family` - The instance family of the offering (for
    #     example, `m4`).
    #
    #   * `payment-option` - The payment option (`NoUpfront` \|
    #     `PartialUpfront` \| `AllUpfront`).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_duration
    #   This is the maximum duration of the reservation to purchase,
    #   specified in seconds. Reservations are available in one-year and
    #   three-year terms. The number of seconds specified must be the number
    #   of seconds in a year (365x24x60x60) times one of the supported
    #   durations (1 or 3). For example, specify 94608000 for three years.
    #   @return [Integer]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results can be seen by sending another request
    #   with the returned `nextToken` value. This value can be between 5 and
    #   500. If `maxResults` is given a larger value than 500, you receive
    #   an error.
    #   @return [Integer]
    #
    # @!attribute [rw] min_duration
    #   This is the minimum duration of the reservation you'd like to
    #   purchase, specified in seconds. Reservations are available in
    #   one-year and three-year terms. The number of seconds specified must
    #   be the number of seconds in a year (365x24x60x60) times one of the
    #   supported durations (1 or 3). For example, specify 31536000 for one
    #   year.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] offering_id
    #   The ID of the reservation offering.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeHostReservationOfferingsRequest AWS API Documentation
    #
    class DescribeHostReservationOfferingsRequest < Struct.new(
      :filter,
      :max_duration,
      :max_results,
      :min_duration,
      :next_token,
      :offering_id)
      include Aws::Structure
    end

    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @!attribute [rw] offering_set
    #   Information about the offerings.
    #   @return [Array<Types::HostOffering>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeHostReservationOfferingsResult AWS API Documentation
    #
    class DescribeHostReservationOfferingsResult < Struct.new(
      :next_token,
      :offering_set)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeHostReservationsRequest
    #   data as a hash:
    #
    #       {
    #         filter: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         host_reservation_id_set: ["HostReservationId"],
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] filter
    #   The filters.
    #
    #   * `instance-family` - The instance family (for example, `m4`).
    #
    #   * `payment-option` - The payment option (`NoUpfront` \|
    #     `PartialUpfront` \| `AllUpfront`).
    #
    #   * `state` - The state of the reservation (`payment-pending` \|
    #     `payment-failed` \| `active` \| `retired`).
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] host_reservation_id_set
    #   The host reservation IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results can be seen by sending another request
    #   with the returned `nextToken` value. This value can be between 5 and
    #   500. If `maxResults` is given a larger value than 500, you receive
    #   an error.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeHostReservationsRequest AWS API Documentation
    #
    class DescribeHostReservationsRequest < Struct.new(
      :filter,
      :host_reservation_id_set,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] host_reservation_set
    #   Details about the reservation's configuration.
    #   @return [Array<Types::HostReservation>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeHostReservationsResult AWS API Documentation
    #
    class DescribeHostReservationsResult < Struct.new(
      :host_reservation_set,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeHostsRequest
    #   data as a hash:
    #
    #       {
    #         filter: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         host_ids: ["DedicatedHostId"],
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] filter
    #   The filters.
    #
    #   * `auto-placement` - Whether auto-placement is enabled or disabled
    #     (`on` \| `off`).
    #
    #   * `availability-zone` - The Availability Zone of the host.
    #
    #   * `client-token` - The idempotency token that you provided when you
    #     allocated the host.
    #
    #   * `host-reservation-id` - The ID of the reservation assigned to this
    #     host.
    #
    #   * `instance-type` - The instance type size that the Dedicated Host
    #     is configured to support.
    #
    #   * `state` - The allocation state of the Dedicated Host (`available`
    #     \| `under-assessment` \| `permanent-failure` \| `released` \|
    #     `released-permanent-failure`).
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] host_ids
    #   The IDs of the Dedicated Hosts. The IDs are used for targeted
    #   instance launches.
    #   @return [Array<String>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results can be seen by sending another request
    #   with the returned `nextToken` value. This value can be between 5 and
    #   500. If `maxResults` is given a larger value than 500, you receive
    #   an error.
    #
    #   You cannot specify this parameter and the host IDs parameter in the
    #   same request.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeHostsRequest AWS API Documentation
    #
    class DescribeHostsRequest < Struct.new(
      :filter,
      :host_ids,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] hosts
    #   Information about the Dedicated Hosts.
    #   @return [Array<Types::Host>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeHostsResult AWS API Documentation
    #
    class DescribeHostsResult < Struct.new(
      :hosts,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeIamInstanceProfileAssociationsRequest
    #   data as a hash:
    #
    #       {
    #         association_ids: ["IamInstanceProfileAssociationId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "NextToken",
    #       }
    #
    # @!attribute [rw] association_ids
    #   The IAM instance profile associations.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `instance-id` - The ID of the instance.
    #
    #   * `state` - The state of the association (`associating` \|
    #     `associated` \| `disassociating`).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `NextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to request the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeIamInstanceProfileAssociationsRequest AWS API Documentation
    #
    class DescribeIamInstanceProfileAssociationsRequest < Struct.new(
      :association_ids,
      :filters,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] iam_instance_profile_associations
    #   Information about the IAM instance profile associations.
    #   @return [Array<Types::IamInstanceProfileAssociation>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeIamInstanceProfileAssociationsResult AWS API Documentation
    #
    class DescribeIamInstanceProfileAssociationsResult < Struct.new(
      :iam_instance_profile_associations,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeIdFormatRequest
    #   data as a hash:
    #
    #       {
    #         resource: "String",
    #       }
    #
    # @!attribute [rw] resource
    #   The type of resource: `bundle` \| `conversion-task` \|
    #   `customer-gateway` \| `dhcp-options` \| `elastic-ip-allocation` \|
    #   `elastic-ip-association` \| `export-task` \| `flow-log` \| `image`
    #   \| `import-task` \| `instance` \| `internet-gateway` \|
    #   `network-acl` \| `network-acl-association` \| `network-interface` \|
    #   `network-interface-attachment` \| `prefix-list` \| `reservation` \|
    #   `route-table` \| `route-table-association` \| `security-group` \|
    #   `snapshot` \| `subnet` \| `subnet-cidr-block-association` \|
    #   `volume` \| `vpc` \| `vpc-cidr-block-association` \| `vpc-endpoint`
    #   \| `vpc-peering-connection` \| `vpn-connection` \| `vpn-gateway`
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeIdFormatRequest AWS API Documentation
    #
    class DescribeIdFormatRequest < Struct.new(
      :resource)
      include Aws::Structure
    end

    # @!attribute [rw] statuses
    #   Information about the ID format for the resource.
    #   @return [Array<Types::IdFormat>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeIdFormatResult AWS API Documentation
    #
    class DescribeIdFormatResult < Struct.new(
      :statuses)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeIdentityIdFormatRequest
    #   data as a hash:
    #
    #       {
    #         principal_arn: "String", # required
    #         resource: "String",
    #       }
    #
    # @!attribute [rw] principal_arn
    #   The ARN of the principal, which can be an IAM role, IAM user, or the
    #   root user.
    #   @return [String]
    #
    # @!attribute [rw] resource
    #   The type of resource: `bundle` \| `conversion-task` \|
    #   `customer-gateway` \| `dhcp-options` \| `elastic-ip-allocation` \|
    #   `elastic-ip-association` \| `export-task` \| `flow-log` \| `image`
    #   \| `import-task` \| `instance` \| `internet-gateway` \|
    #   `network-acl` \| `network-acl-association` \| `network-interface` \|
    #   `network-interface-attachment` \| `prefix-list` \| `reservation` \|
    #   `route-table` \| `route-table-association` \| `security-group` \|
    #   `snapshot` \| `subnet` \| `subnet-cidr-block-association` \|
    #   `volume` \| `vpc` \| `vpc-cidr-block-association` \| `vpc-endpoint`
    #   \| `vpc-peering-connection` \| `vpn-connection` \| `vpn-gateway`
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeIdentityIdFormatRequest AWS API Documentation
    #
    class DescribeIdentityIdFormatRequest < Struct.new(
      :principal_arn,
      :resource)
      include Aws::Structure
    end

    # @!attribute [rw] statuses
    #   Information about the ID format for the resources.
    #   @return [Array<Types::IdFormat>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeIdentityIdFormatResult AWS API Documentation
    #
    class DescribeIdentityIdFormatResult < Struct.new(
      :statuses)
      include Aws::Structure
    end

    # Contains the parameters for DescribeImageAttribute.
    #
    # @note When making an API call, you may pass DescribeImageAttributeRequest
    #   data as a hash:
    #
    #       {
    #         attribute: "description", # required, accepts description, kernel, ramdisk, launchPermission, productCodes, blockDeviceMapping, sriovNetSupport
    #         image_id: "ImageId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] attribute
    #   The AMI attribute.
    #
    #   **Note**\: Depending on your account privileges, the
    #   `blockDeviceMapping` attribute may return a `Client.AuthFailure`
    #   error. If this happens, use DescribeImages to get information about
    #   the block device mapping for the AMI.
    #   @return [String]
    #
    # @!attribute [rw] image_id
    #   The ID of the AMI.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeImageAttributeRequest AWS API Documentation
    #
    class DescribeImageAttributeRequest < Struct.new(
      :attribute,
      :image_id,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeImagesRequest
    #   data as a hash:
    #
    #       {
    #         executable_users: ["String"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         image_ids: ["ImageId"],
    #         owners: ["String"],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] executable_users
    #   Scopes the images by users with explicit launch permissions. Specify
    #   an AWS account ID, `self` (the sender of the request), or `all`
    #   (public AMIs).
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `architecture` - The image architecture (`i386` \| `x86_64` \|
    #     `arm64`).
    #
    #   * `block-device-mapping.delete-on-termination` - A Boolean value
    #     that indicates whether the Amazon EBS volume is deleted on
    #     instance termination.
    #
    #   * `block-device-mapping.device-name` - The device name specified in
    #     the block device mapping (for example, `/dev/sdh` or `xvdh`).
    #
    #   * `block-device-mapping.snapshot-id` - The ID of the snapshot used
    #     for the EBS volume.
    #
    #   * `block-device-mapping.volume-size` - The volume size of the EBS
    #     volume, in GiB.
    #
    #   * `block-device-mapping.volume-type` - The volume type of the EBS
    #     volume (`gp2` \| `io1` \| `st1 `\| `sc1` \| `standard`).
    #
    #   * `block-device-mapping.encrypted` - A Boolean that indicates
    #     whether the EBS volume is encrypted.
    #
    #   * `description` - The description of the image (provided during
    #     image creation).
    #
    #   * `ena-support` - A Boolean that indicates whether enhanced
    #     networking with ENA is enabled.
    #
    #   * `hypervisor` - The hypervisor type (`ovm` \| `xen`).
    #
    #   * `image-id` - The ID of the image.
    #
    #   * `image-type` - The image type (`machine` \| `kernel` \|
    #     `ramdisk`).
    #
    #   * `is-public` - A Boolean that indicates whether the image is
    #     public.
    #
    #   * `kernel-id` - The kernel ID.
    #
    #   * `manifest-location` - The location of the image manifest.
    #
    #   * `name` - The name of the AMI (provided during image creation).
    #
    #   * `owner-alias` - String value from an Amazon-maintained list
    #     (`amazon` \| `aws-marketplace` \| `microsoft`) of snapshot owners.
    #     Not to be confused with the user-configured AWS account alias,
    #     which is set from the IAM console.
    #
    #   * `owner-id` - The AWS account ID of the image owner.
    #
    #   * `platform` - The platform. To only list Windows-based AMIs, use
    #     `windows`.
    #
    #   * `product-code` - The product code.
    #
    #   * `product-code.type` - The type of the product code (`devpay` \|
    #     `marketplace`).
    #
    #   * `ramdisk-id` - The RAM disk ID.
    #
    #   * `root-device-name` - The device name of the root device volume
    #     (for example, `/dev/sda1`).
    #
    #   * `root-device-type` - The type of the root device volume (`ebs` \|
    #     `instance-store`).
    #
    #   * `state` - The state of the image (`available` \| `pending` \|
    #     `failed`).
    #
    #   * `state-reason-code` - The reason code for the state change.
    #
    #   * `state-reason-message` - The message for the state change.
    #
    #   * `sriov-net-support` - A value of `simple` indicates that enhanced
    #     networking with the Intel 82599 VF interface is enabled.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `virtualization-type` - The virtualization type (`paravirtual` \|
    #     `hvm`).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] image_ids
    #   The image IDs.
    #
    #   Default: Describes all images available to you.
    #   @return [Array<String>]
    #
    # @!attribute [rw] owners
    #   Filters the images by the owner. Specify an AWS account ID, `self`
    #   (owner is the sender of the request), or an AWS owner alias (valid
    #   values are `amazon` \| `aws-marketplace` \| `microsoft`). Omitting
    #   this option returns all images for which you have launch
    #   permissions, regardless of ownership.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeImagesRequest AWS API Documentation
    #
    class DescribeImagesRequest < Struct.new(
      :executable_users,
      :filters,
      :image_ids,
      :owners,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] images
    #   Information about the images.
    #   @return [Array<Types::Image>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeImagesResult AWS API Documentation
    #
    class DescribeImagesResult < Struct.new(
      :images)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeImportImageTasksRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         import_task_ids: ["ImportImageTaskId"],
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] filters
    #   Filter tasks using the `task-state` filter and one of the following
    #   values: `active`, `completed`, `deleting`, or `deleted`.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] import_task_ids
    #   The IDs of the import image tasks.
    #   @return [Array<String>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   A token that indicates the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeImportImageTasksRequest AWS API Documentation
    #
    class DescribeImportImageTasksRequest < Struct.new(
      :dry_run,
      :filters,
      :import_task_ids,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] import_image_tasks
    #   A list of zero or more import image tasks that are currently active
    #   or were completed or canceled in the previous 7 days.
    #   @return [Array<Types::ImportImageTask>]
    #
    # @!attribute [rw] next_token
    #   The token to use to get the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeImportImageTasksResult AWS API Documentation
    #
    class DescribeImportImageTasksResult < Struct.new(
      :import_image_tasks,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeImportSnapshotTasksRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         import_task_ids: ["ImportSnapshotTaskId"],
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] filters
    #   The filters.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] import_task_ids
    #   A list of import snapshot task IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `NextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   A token that indicates the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeImportSnapshotTasksRequest AWS API Documentation
    #
    class DescribeImportSnapshotTasksRequest < Struct.new(
      :dry_run,
      :filters,
      :import_task_ids,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] import_snapshot_tasks
    #   A list of zero or more import snapshot tasks that are currently
    #   active or were completed or canceled in the previous 7 days.
    #   @return [Array<Types::ImportSnapshotTask>]
    #
    # @!attribute [rw] next_token
    #   The token to use to get the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeImportSnapshotTasksResult AWS API Documentation
    #
    class DescribeImportSnapshotTasksResult < Struct.new(
      :import_snapshot_tasks,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeInstanceAttributeRequest
    #   data as a hash:
    #
    #       {
    #         attribute: "instanceType", # required, accepts instanceType, kernel, ramdisk, userData, disableApiTermination, instanceInitiatedShutdownBehavior, rootDeviceName, blockDeviceMapping, productCodes, sourceDestCheck, groupSet, ebsOptimized, sriovNetSupport, enaSupport
    #         dry_run: false,
    #         instance_id: "InstanceId", # required
    #       }
    #
    # @!attribute [rw] attribute
    #   The instance attribute.
    #
    #   Note: The `enaSupport` attribute is not supported at this time.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeInstanceAttributeRequest AWS API Documentation
    #
    class DescribeInstanceAttributeRequest < Struct.new(
      :attribute,
      :dry_run,
      :instance_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeInstanceCreditSpecificationsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         instance_ids: ["InstanceId"],
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `instance-id` - The ID of the instance.
    #
    #   ^
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] instance_ids
    #   The instance IDs.
    #
    #   Default: Describes all your instances.
    #
    #   Constraints: Maximum 1000 explicitly specified instance IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `NextToken` value. This value can be between 5 and 1000. You cannot
    #   specify this parameter and the instance IDs parameter in the same
    #   call.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeInstanceCreditSpecificationsRequest AWS API Documentation
    #
    class DescribeInstanceCreditSpecificationsRequest < Struct.new(
      :dry_run,
      :filters,
      :instance_ids,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] instance_credit_specifications
    #   Information about the credit option for CPU usage of an instance.
    #   @return [Array<Types::InstanceCreditSpecification>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeInstanceCreditSpecificationsResult AWS API Documentation
    #
    class DescribeInstanceCreditSpecificationsResult < Struct.new(
      :instance_credit_specifications,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeInstanceEventNotificationAttributesRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeInstanceEventNotificationAttributesRequest AWS API Documentation
    #
    class DescribeInstanceEventNotificationAttributesRequest < Struct.new(
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] instance_tag_attribute
    #   Information about the registered tag keys.
    #   @return [Types::InstanceTagNotificationAttribute]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeInstanceEventNotificationAttributesResult AWS API Documentation
    #
    class DescribeInstanceEventNotificationAttributesResult < Struct.new(
      :instance_tag_attribute)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeInstanceStatusRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         instance_ids: ["InstanceId"],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #         include_all_instances: false,
    #       }
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `availability-zone` - The Availability Zone of the instance.
    #
    #   * `event.code` - The code for the scheduled event (`instance-reboot`
    #     \| `system-reboot` \| `system-maintenance` \|
    #     `instance-retirement` \| `instance-stop`).
    #
    #   * `event.description` - A description of the event.
    #
    #   * `event.instance-event-id` - The ID of the event whose date and
    #     time you are modifying.
    #
    #   * `event.not-after` - The latest end time for the scheduled event
    #     (for example, `2014-09-15T17:15:20.000Z`).
    #
    #   * `event.not-before` - The earliest start time for the scheduled
    #     event (for example, `2014-09-15T17:15:20.000Z`).
    #
    #   * `event.not-before-deadline` - The deadline for starting the event
    #     (for example, `2014-09-15T17:15:20.000Z`).
    #
    #   * `instance-state-code` - The code for the instance state, as a
    #     16-bit unsigned integer. The high byte is used for internal
    #     purposes and should be ignored. The low byte is set based on the
    #     state represented. The valid values are 0 (pending), 16 (running),
    #     32 (shutting-down), 48 (terminated), 64 (stopping), and 80
    #     (stopped).
    #
    #   * `instance-state-name` - The state of the instance (`pending` \|
    #     `running` \| `shutting-down` \| `terminated` \| `stopping` \|
    #     `stopped`).
    #
    #   * `instance-status.reachability` - Filters on instance status where
    #     the name is `reachability` (`passed` \| `failed` \| `initializing`
    #     \| `insufficient-data`).
    #
    #   * `instance-status.status` - The status of the instance (`ok` \|
    #     `impaired` \| `initializing` \| `insufficient-data` \|
    #     `not-applicable`).
    #
    #   * `system-status.reachability` - Filters on system status where the
    #     name is `reachability` (`passed` \| `failed` \| `initializing` \|
    #     `insufficient-data`).
    #
    #   * `system-status.status` - The system status of the instance (`ok`
    #     \| `impaired` \| `initializing` \| `insufficient-data` \|
    #     `not-applicable`).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] instance_ids
    #   The instance IDs.
    #
    #   Default: Describes all your instances.
    #
    #   Constraints: Maximum 100 explicitly specified instance IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `NextToken` value. This value can be between 5 and 1000. You cannot
    #   specify this parameter and the instance IDs parameter in the same
    #   call.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] include_all_instances
    #   When `true`, includes the health status for all instances. When
    #   `false`, includes the health status for running instances only.
    #
    #   Default: `false`
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeInstanceStatusRequest AWS API Documentation
    #
    class DescribeInstanceStatusRequest < Struct.new(
      :filters,
      :instance_ids,
      :max_results,
      :next_token,
      :dry_run,
      :include_all_instances)
      include Aws::Structure
    end

    # @!attribute [rw] instance_statuses
    #   Information about the status of the instances.
    #   @return [Array<Types::InstanceStatus>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeInstanceStatusResult AWS API Documentation
    #
    class DescribeInstanceStatusResult < Struct.new(
      :instance_statuses,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeInstanceTypeOfferingsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         location_type: "region", # accepts region, availability-zone, availability-zone-id
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "NextToken",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] location_type
    #   The location type.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters. Filter names and values are case-sensitive.
    #
    #   * `location` - This depends on the location type. For example, if
    #     the location type is `region` (default), the location is the
    #     Region code (for example, `us-east-2`.)
    #
    #   * `instance-type` - The instance type.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results can be seen by sending another request
    #   with the next token value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeInstanceTypeOfferingsRequest AWS API Documentation
    #
    class DescribeInstanceTypeOfferingsRequest < Struct.new(
      :dry_run,
      :location_type,
      :filters,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] instance_type_offerings
    #   The instance types offered.
    #   @return [Array<Types::InstanceTypeOffering>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeInstanceTypeOfferingsResult AWS API Documentation
    #
    class DescribeInstanceTypeOfferingsResult < Struct.new(
      :instance_type_offerings,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeInstanceTypesRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         instance_types: ["t1.micro"], # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "NextToken",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_types
    #   The instance types. For more information, see [Instance Types][1] in
    #   the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters. Filter names and values are case-sensitive.
    #
    #   * `auto-recovery-supported` - Indicates whether auto recovery is
    #     supported. (`true` \| `false`)
    #
    #   * `bare-metal` - Indicates whether it is a bare metal instance type.
    #     (`true` \| `false`)
    #
    #   * `burstable-performance-supported` - Indicates whether it is a
    #     burstable performance instance type. (`true` \| `false`)
    #
    #   * `current-generation` - Indicates whether this instance type is the
    #     latest generation instance type of an instance family. (`true` \|
    #     `false`)
    #
    #   * `ebs-info.ebs-optimized-info.baseline-bandwidth-in-mbps` - The
    #     baseline bandwidth performance for an EBS-optimized instance type,
    #     in Mbps.
    #
    #   * `ebs-info.ebs-optimized-info.baseline-throughput-in-mbps` - The
    #     baseline throughput performance for an EBS-optimized instance
    #     type, in MBps.
    #
    #   * `ebs-info.ebs-optimized-info.baseline-iops` - The baseline
    #     input/output storage operations per second for an EBS-optimized
    #     instance type.
    #
    #   * `ebs-info.ebs-optimized-info.maximum-bandwidth-in-mbps` - The
    #     maximum bandwidth performance for an EBS-optimized instance type,
    #     in Mbps.
    #
    #   * `ebs-info.ebs-optimized-info.maximum-throughput-in-mbps` - The
    #     maximum throughput performance for an EBS-optimized instance type,
    #     in MBps.
    #
    #   * `ebs-info.ebs-optimized-info.maximum-iops` - The maximum
    #     input/output storage operations per second for an EBS-optimized
    #     instance type.
    #
    #   * `ebs-info.ebs-optimized-support` - Indicates whether the instance
    #     type is EBS-optimized. (`supported` \| `unsupported` \| `default`)
    #
    #   * `ebs-info.encryption-support` - Indicates whether EBS encryption
    #     is supported. (`supported` \| `unsupported`)
    #
    #   * `free-tier-eligible` - Indicates whether the instance type is
    #     eligible to use in the free tier. (`true` \| `false`)
    #
    #   * `hibernation-supported` - Indicates whether On-Demand hibernation
    #     is supported. (`true` \| `false`)
    #
    #   * `hypervisor` - The hypervisor used. (`nitro` \| `xen`)
    #
    #   * `instance-storage-info.disk.count` - The number of local disks.
    #
    #   * `instance-storage-info.disk.size-in-gb` - The storage size of each
    #     instance storage disk, in GB.
    #
    #   * `instance-storage-info.disk.type` - The storage technology for the
    #     local instance storage disks. (`hdd` \| `ssd`)
    #
    #   * `instance-storage-info.total-size-in-gb` - The total amount of
    #     storage available from all local instance storage, in GB.
    #
    #   * `instance-storage-supported` - Indicates whether the instance type
    #     has local instance storage. (`true` \| `false`)
    #
    #   * `memory-info.size-in-mib` - The memory size.
    #
    #   * `network-info.ena-support` - Indicates whether Elastic Network
    #     Adapter (ENA) is supported or required. (`required` \| `supported`
    #     \| `unsupported`)
    #
    #   * `network-info.efa-supported` - Indicates whether the instance type
    #     supports Elastic Fabric Adapter (EFA). (`true` \| `false`)
    #
    #   * `network-info.ipv4-addresses-per-interface` - The maximum number
    #     of private IPv4 addresses per network interface.
    #
    #   * `network-info.ipv6-addresses-per-interface` - The maximum number
    #     of private IPv6 addresses per network interface.
    #
    #   * `network-info.ipv6-supported` - Indicates whether the instance
    #     type supports IPv6. (`true` \| `false`)
    #
    #   * `network-info.maximum-network-interfaces` - The maximum number of
    #     network interfaces per instance.
    #
    #   * `network-info.network-performance` - Describes the network
    #     performance.
    #
    #   * `processor-info.sustained-clock-speed-in-ghz` - The CPU clock
    #     speed, in GHz.
    #
    #   * `vcpu-info.default-cores` - The default number of cores for the
    #     instance type.
    #
    #   * `vcpu-info.default-threads-per-core` - The default number of
    #     threads per core for the instance type.
    #
    #   * `vcpu-info.default-vcpus` - The default number of vCPUs for the
    #     instance type.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results can be seen by sending another request
    #   with the next token value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeInstanceTypesRequest AWS API Documentation
    #
    class DescribeInstanceTypesRequest < Struct.new(
      :dry_run,
      :instance_types,
      :filters,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] instance_types
    #   The instance type. For more information, see [Instance Types][1] in
    #   the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html
    #   @return [Array<Types::InstanceTypeInfo>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeInstanceTypesResult AWS API Documentation
    #
    class DescribeInstanceTypesResult < Struct.new(
      :instance_types,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeInstancesRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         instance_ids: ["InstanceId"],
    #         dry_run: false,
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `affinity` - The affinity setting for an instance running on a
    #     Dedicated Host (`default` \| `host`).
    #
    #   * `architecture` - The instance architecture (`i386` \| `x86_64` \|
    #     `arm64`).
    #
    #   * `availability-zone` - The Availability Zone of the instance.
    #
    #   * `block-device-mapping.attach-time` - The attach time for an EBS
    #     volume mapped to the instance, for example,
    #     `2010-09-15T17:15:20.000Z`.
    #
    #   * `block-device-mapping.delete-on-termination` - A Boolean that
    #     indicates whether the EBS volume is deleted on instance
    #     termination.
    #
    #   * `block-device-mapping.device-name` - The device name specified in
    #     the block device mapping (for example, `/dev/sdh` or `xvdh`).
    #
    #   * `block-device-mapping.status` - The status for the EBS volume
    #     (`attaching` \| `attached` \| `detaching` \| `detached`).
    #
    #   * `block-device-mapping.volume-id` - The volume ID of the EBS
    #     volume.
    #
    #   * `client-token` - The idempotency token you provided when you
    #     launched the instance.
    #
    #   * `dns-name` - The public DNS name of the instance.
    #
    #   * `group-id` - The ID of the security group for the instance.
    #     EC2-Classic only.
    #
    #   * `group-name` - The name of the security group for the instance.
    #     EC2-Classic only.
    #
    #   * `hibernation-options.configured` - A Boolean that indicates
    #     whether the instance is enabled for hibernation. A value of `true`
    #     means that the instance is enabled for hibernation.
    #
    #   * `host-id` - The ID of the Dedicated Host on which the instance is
    #     running, if applicable.
    #
    #   * `hypervisor` - The hypervisor type of the instance (`ovm` \|
    #     `xen`). The value `xen` is used for both Xen and Nitro
    #     hypervisors.
    #
    #   * `iam-instance-profile.arn` - The instance profile associated with
    #     the instance. Specified as an ARN.
    #
    #   * `image-id` - The ID of the image used to launch the instance.
    #
    #   * `instance-id` - The ID of the instance.
    #
    #   * `instance-lifecycle` - Indicates whether this is a Spot Instance
    #     or a Scheduled Instance (`spot` \| `scheduled`).
    #
    #   * `instance-state-code` - The state of the instance, as a 16-bit
    #     unsigned integer. The high byte is used for internal purposes and
    #     should be ignored. The low byte is set based on the state
    #     represented. The valid values are: 0 (pending), 16 (running), 32
    #     (shutting-down), 48 (terminated), 64 (stopping), and 80 (stopped).
    #
    #   * `instance-state-name` - The state of the instance (`pending` \|
    #     `running` \| `shutting-down` \| `terminated` \| `stopping` \|
    #     `stopped`).
    #
    #   * `instance-type` - The type of instance (for example, `t2.micro`).
    #
    #   * `instance.group-id` - The ID of the security group for the
    #     instance.
    #
    #   * `instance.group-name` - The name of the security group for the
    #     instance.
    #
    #   * `ip-address` - The public IPv4 address of the instance.
    #
    #   * `kernel-id` - The kernel ID.
    #
    #   * `key-name` - The name of the key pair used when the instance was
    #     launched.
    #
    #   * `launch-index` - When launching multiple instances, this is the
    #     index for the instance in the launch group (for example, 0, 1, 2,
    #     and so on).
    #
    #   * `launch-time` - The time when the instance was launched.
    #
    #   * `metadata-options.http-tokens` - The metadata request
    #     authorization state (`optional` \| `required`)
    #
    #   * `metadata-options.http-put-response-hop-limit` - The http metadata
    #     request put response hop limit (integer, possible values `1` to
    #     `64`)
    #
    #   * `metadata-options.http-endpoint` - Enable or disable metadata
    #     access on http endpoint (`enabled` \| `disabled`)
    #
    #   * `monitoring-state` - Indicates whether detailed monitoring is
    #     enabled (`disabled` \| `enabled`).
    #
    #   * `network-interface.addresses.private-ip-address` - The private
    #     IPv4 address associated with the network interface.
    #
    #   * `network-interface.addresses.primary` - Specifies whether the IPv4
    #     address of the network interface is the primary private IPv4
    #     address.
    #
    #   * `network-interface.addresses.association.public-ip` - The ID of
    #     the association of an Elastic IP address (IPv4) with a network
    #     interface.
    #
    #   * `network-interface.addresses.association.ip-owner-id` - The owner
    #     ID of the private IPv4 address associated with the network
    #     interface.
    #
    #   * `network-interface.association.public-ip` - The address of the
    #     Elastic IP address (IPv4) bound to the network interface.
    #
    #   * `network-interface.association.ip-owner-id` - The owner of the
    #     Elastic IP address (IPv4) associated with the network interface.
    #
    #   * `network-interface.association.allocation-id` - The allocation ID
    #     returned when you allocated the Elastic IP address (IPv4) for your
    #     network interface.
    #
    #   * `network-interface.association.association-id` - The association
    #     ID returned when the network interface was associated with an IPv4
    #     address.
    #
    #   * `network-interface.attachment.attachment-id` - The ID of the
    #     interface attachment.
    #
    #   * `network-interface.attachment.instance-id` - The ID of the
    #     instance to which the network interface is attached.
    #
    #   * `network-interface.attachment.instance-owner-id` - The owner ID of
    #     the instance to which the network interface is attached.
    #
    #   * `network-interface.attachment.device-index` - The device index to
    #     which the network interface is attached.
    #
    #   * `network-interface.attachment.status` - The status of the
    #     attachment (`attaching` \| `attached` \| `detaching` \|
    #     `detached`).
    #
    #   * `network-interface.attachment.attach-time` - The time that the
    #     network interface was attached to an instance.
    #
    #   * `network-interface.attachment.delete-on-termination` - Specifies
    #     whether the attachment is deleted when an instance is terminated.
    #
    #   * `network-interface.availability-zone` - The Availability Zone for
    #     the network interface.
    #
    #   * `network-interface.description` - The description of the network
    #     interface.
    #
    #   * `network-interface.group-id` - The ID of a security group
    #     associated with the network interface.
    #
    #   * `network-interface.group-name` - The name of a security group
    #     associated with the network interface.
    #
    #   * `network-interface.ipv6-addresses.ipv6-address` - The IPv6 address
    #     associated with the network interface.
    #
    #   * `network-interface.mac-address` - The MAC address of the network
    #     interface.
    #
    #   * `network-interface.network-interface-id` - The ID of the network
    #     interface.
    #
    #   * `network-interface.owner-id` - The ID of the owner of the network
    #     interface.
    #
    #   * `network-interface.private-dns-name` - The private DNS name of the
    #     network interface.
    #
    #   * `network-interface.requester-id` - The requester ID for the
    #     network interface.
    #
    #   * `network-interface.requester-managed` - Indicates whether the
    #     network interface is being managed by AWS.
    #
    #   * `network-interface.status` - The status of the network interface
    #     (`available`) \| `in-use`).
    #
    #   * `network-interface.source-dest-check` - Whether the network
    #     interface performs source/destination checking. A value of `true`
    #     means that checking is enabled, and `false` means that checking is
    #     disabled. The value must be `false` for the network interface to
    #     perform network address translation (NAT) in your VPC.
    #
    #   * `network-interface.subnet-id` - The ID of the subnet for the
    #     network interface.
    #
    #   * `network-interface.vpc-id` - The ID of the VPC for the network
    #     interface.
    #
    #   * `owner-id` - The AWS account ID of the instance owner.
    #
    #   * `placement-group-name` - The name of the placement group for the
    #     instance.
    #
    #   * `placement-partition-number` - The partition in which the instance
    #     is located.
    #
    #   * `platform` - The platform. To list only Windows instances, use
    #     `windows`.
    #
    #   * `private-dns-name` - The private IPv4 DNS name of the instance.
    #
    #   * `private-ip-address` - The private IPv4 address of the instance.
    #
    #   * `product-code` - The product code associated with the AMI used to
    #     launch the instance.
    #
    #   * `product-code.type` - The type of product code (`devpay` \|
    #     `marketplace`).
    #
    #   * `ramdisk-id` - The RAM disk ID.
    #
    #   * `reason` - The reason for the current state of the instance (for
    #     example, shows "User Initiated \[date\]" when you stop or
    #     terminate the instance). Similar to the state-reason-code filter.
    #
    #   * `requester-id` - The ID of the entity that launched the instance
    #     on your behalf (for example, AWS Management Console, Auto Scaling,
    #     and so on).
    #
    #   * `reservation-id` - The ID of the instance's reservation. A
    #     reservation ID is created any time you launch an instance. A
    #     reservation ID has a one-to-one relationship with an instance
    #     launch request, but can be associated with more than one instance
    #     if you launch multiple instances using the same launch request.
    #     For example, if you launch one instance, you get one reservation
    #     ID. If you launch ten instances using the same launch request, you
    #     also get one reservation ID.
    #
    #   * `root-device-name` - The device name of the root device volume
    #     (for example, `/dev/sda1`).
    #
    #   * `root-device-type` - The type of the root device volume (`ebs` \|
    #     `instance-store`).
    #
    #   * `source-dest-check` - Indicates whether the instance performs
    #     source/destination checking. A value of `true` means that checking
    #     is enabled, and `false` means that checking is disabled. The value
    #     must be `false` for the instance to perform network address
    #     translation (NAT) in your VPC.
    #
    #   * `spot-instance-request-id` - The ID of the Spot Instance request.
    #
    #   * `state-reason-code` - The reason code for the state change.
    #
    #   * `state-reason-message` - A message that describes the state
    #     change.
    #
    #   * `subnet-id` - The ID of the subnet for the instance.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources that have a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `tenancy` - The tenancy of an instance (`dedicated` \| `default`
    #     \| `host`).
    #
    #   * `virtualization-type` - The virtualization type of the instance
    #     (`paravirtual` \| `hvm`).
    #
    #   * `vpc-id` - The ID of the VPC that the instance is running in.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] instance_ids
    #   The instance IDs.
    #
    #   Default: Describes all your instances.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `NextToken` value. This value can be between 5 and 1000. You cannot
    #   specify this parameter and the instance IDs parameter in the same
    #   call.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to request the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeInstancesRequest AWS API Documentation
    #
    class DescribeInstancesRequest < Struct.new(
      :filters,
      :instance_ids,
      :dry_run,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] reservations
    #   Information about the reservations.
    #   @return [Array<Types::Reservation>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeInstancesResult AWS API Documentation
    #
    class DescribeInstancesResult < Struct.new(
      :reservations,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeInternetGatewaysRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #         internet_gateway_ids: ["InternetGatewayId"],
    #         next_token: "String",
    #         max_results: 1,
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `attachment.state` - The current state of the attachment between
    #     the gateway and the VPC (`available`). Present only if a VPC is
    #     attached.
    #
    #   * `attachment.vpc-id` - The ID of an attached VPC.
    #
    #   * `internet-gateway-id` - The ID of the Internet gateway.
    #
    #   * `owner-id` - The ID of the AWS account that owns the internet
    #     gateway.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] internet_gateway_ids
    #   One or more internet gateway IDs.
    #
    #   Default: Describes all your internet gateways.
    #   @return [Array<String>]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeInternetGatewaysRequest AWS API Documentation
    #
    class DescribeInternetGatewaysRequest < Struct.new(
      :filters,
      :dry_run,
      :internet_gateway_ids,
      :next_token,
      :max_results)
      include Aws::Structure
    end

    # @!attribute [rw] internet_gateways
    #   Information about one or more internet gateways.
    #   @return [Array<Types::InternetGateway>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeInternetGatewaysResult AWS API Documentation
    #
    class DescribeInternetGatewaysResult < Struct.new(
      :internet_gateways,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeIpv6PoolsRequest
    #   data as a hash:
    #
    #       {
    #         pool_ids: ["Ipv6PoolEc2Id"],
    #         next_token: "NextToken",
    #         max_results: 1,
    #         dry_run: false,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] pool_ids
    #   The IDs of the IPv6 address pools.
    #   @return [Array<String>]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #   @return [Array<Types::Filter>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeIpv6PoolsRequest AWS API Documentation
    #
    class DescribeIpv6PoolsRequest < Struct.new(
      :pool_ids,
      :next_token,
      :max_results,
      :dry_run,
      :filters)
      include Aws::Structure
    end

    # @!attribute [rw] ipv_6_pools
    #   Information about the IPv6 address pools.
    #   @return [Array<Types::Ipv6Pool>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeIpv6PoolsResult AWS API Documentation
    #
    class DescribeIpv6PoolsResult < Struct.new(
      :ipv_6_pools,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeKeyPairsRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         key_names: ["KeyPairName"],
    #         key_pair_ids: ["KeyPairId"],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `key-pair-id` - The ID of the key pair.
    #
    #   * `fingerprint` - The fingerprint of the key pair.
    #
    #   * `key-name` - The name of the key pair.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] key_names
    #   The key pair names.
    #
    #   Default: Describes all your key pairs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] key_pair_ids
    #   The IDs of the key pairs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeKeyPairsRequest AWS API Documentation
    #
    class DescribeKeyPairsRequest < Struct.new(
      :filters,
      :key_names,
      :key_pair_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] key_pairs
    #   Information about the key pairs.
    #   @return [Array<Types::KeyPairInfo>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeKeyPairsResult AWS API Documentation
    #
    class DescribeKeyPairsResult < Struct.new(
      :key_pairs)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeLaunchTemplateVersionsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         launch_template_id: "LaunchTemplateId",
    #         launch_template_name: "LaunchTemplateName",
    #         versions: ["String"],
    #         min_version: "String",
    #         max_version: "String",
    #         next_token: "String",
    #         max_results: 1,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] launch_template_id
    #   The ID of the launch template. You must specify either the launch
    #   template ID or launch template name in the request.
    #   @return [String]
    #
    # @!attribute [rw] launch_template_name
    #   The name of the launch template. You must specify either the launch
    #   template ID or launch template name in the request.
    #   @return [String]
    #
    # @!attribute [rw] versions
    #   One or more versions of the launch template.
    #   @return [Array<String>]
    #
    # @!attribute [rw] min_version
    #   The version number after which to describe launch template versions.
    #   @return [String]
    #
    # @!attribute [rw] max_version
    #   The version number up to which to describe launch template versions.
    #   @return [String]
    #
    # @!attribute [rw] next_token
    #   The token to request the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `NextToken` value. This value can be between 1 and 200.
    #   @return [Integer]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `create-time` - The time the launch template version was created.
    #
    #   * `ebs-optimized` - A boolean that indicates whether the instance is
    #     optimized for Amazon EBS I/O.
    #
    #   * `iam-instance-profile` - The ARN of the IAM instance profile.
    #
    #   * `image-id` - The ID of the AMI.
    #
    #   * `instance-type` - The instance type.
    #
    #   * `is-default-version` - A boolean that indicates whether the launch
    #     template version is the default version.
    #
    #   * `kernel-id` - The kernel ID.
    #
    #   * `ram-disk-id` - The RAM disk ID.
    #   @return [Array<Types::Filter>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeLaunchTemplateVersionsRequest AWS API Documentation
    #
    class DescribeLaunchTemplateVersionsRequest < Struct.new(
      :dry_run,
      :launch_template_id,
      :launch_template_name,
      :versions,
      :min_version,
      :max_version,
      :next_token,
      :max_results,
      :filters)
      include Aws::Structure
    end

    # @!attribute [rw] launch_template_versions
    #   Information about the launch template versions.
    #   @return [Array<Types::LaunchTemplateVersion>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeLaunchTemplateVersionsResult AWS API Documentation
    #
    class DescribeLaunchTemplateVersionsResult < Struct.new(
      :launch_template_versions,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeLaunchTemplatesRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         launch_template_ids: ["LaunchTemplateId"],
    #         launch_template_names: ["LaunchTemplateName"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         next_token: "String",
    #         max_results: 1,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] launch_template_ids
    #   One or more launch template IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] launch_template_names
    #   One or more launch template names.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `create-time` - The time the launch template was created.
    #
    #   * `launch-template-name` - The name of the launch template.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] next_token
    #   The token to request the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `NextToken` value. This value can be between 1 and 200.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeLaunchTemplatesRequest AWS API Documentation
    #
    class DescribeLaunchTemplatesRequest < Struct.new(
      :dry_run,
      :launch_template_ids,
      :launch_template_names,
      :filters,
      :next_token,
      :max_results)
      include Aws::Structure
    end

    # @!attribute [rw] launch_templates
    #   Information about the launch templates.
    #   @return [Array<Types::LaunchTemplate>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeLaunchTemplatesResult AWS API Documentation
    #
    class DescribeLaunchTemplatesResult < Struct.new(
      :launch_templates,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsRequest
    #   data as a hash:
    #
    #       {
    #         local_gateway_route_table_virtual_interface_group_association_ids: ["LocalGatewayRouteTableVirtualInterfaceGroupAssociationId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] local_gateway_route_table_virtual_interface_group_association_ids
    #   The IDs of the associations.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `local-gateway-id` - The ID of a local gateway.
    #
    #   * `local-gateway-route-table-id` - The ID of the local gateway route
    #     table.
    #
    #   * `local-gateway-route-table-virtual-interface-group-association-id`
    #     - The ID of the association.
    #
    #   * `local-gateway-route-table-virtual-interface-group-id` - The ID of
    #     the virtual interface group.
    #
    #   * `state` - The state of the association.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsRequest AWS API Documentation
    #
    class DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsRequest < Struct.new(
      :local_gateway_route_table_virtual_interface_group_association_ids,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] local_gateway_route_table_virtual_interface_group_associations
    #   Information about the associations.
    #   @return [Array<Types::LocalGatewayRouteTableVirtualInterfaceGroupAssociation>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsResult AWS API Documentation
    #
    class DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsResult < Struct.new(
      :local_gateway_route_table_virtual_interface_group_associations,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeLocalGatewayRouteTableVpcAssociationsRequest
    #   data as a hash:
    #
    #       {
    #         local_gateway_route_table_vpc_association_ids: ["LocalGatewayRouteTableVpcAssociationId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] local_gateway_route_table_vpc_association_ids
    #   The IDs of the associations.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `local-gateway-id` - The ID of a local gateway.
    #
    #   * `local-gateway-route-table-id` - The ID of the local gateway route
    #     table.
    #
    #   * `local-gateway-route-table-vpc-association-id` - The ID of the
    #     association.
    #
    #   * `state` - The state of the association.
    #
    #   * `vpc-id` - The ID of the VPC.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeLocalGatewayRouteTableVpcAssociationsRequest AWS API Documentation
    #
    class DescribeLocalGatewayRouteTableVpcAssociationsRequest < Struct.new(
      :local_gateway_route_table_vpc_association_ids,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] local_gateway_route_table_vpc_associations
    #   Information about the associations.
    #   @return [Array<Types::LocalGatewayRouteTableVpcAssociation>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeLocalGatewayRouteTableVpcAssociationsResult AWS API Documentation
    #
    class DescribeLocalGatewayRouteTableVpcAssociationsResult < Struct.new(
      :local_gateway_route_table_vpc_associations,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeLocalGatewayRouteTablesRequest
    #   data as a hash:
    #
    #       {
    #         local_gateway_route_table_ids: ["LocalGatewayRoutetableId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] local_gateway_route_table_ids
    #   The IDs of the local gateway route tables.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `local-gateway-id` - The ID of a local gateway.
    #
    #   * `local-gateway-route-table-id` - The ID of a local gateway route
    #     table.
    #
    #   * `outpost-arn` - The Amazon Resource Name (ARN) of the Outpost.
    #
    #   * `state` - The state of the local gateway route table.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeLocalGatewayRouteTablesRequest AWS API Documentation
    #
    class DescribeLocalGatewayRouteTablesRequest < Struct.new(
      :local_gateway_route_table_ids,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] local_gateway_route_tables
    #   Information about the local gateway route tables.
    #   @return [Array<Types::LocalGatewayRouteTable>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeLocalGatewayRouteTablesResult AWS API Documentation
    #
    class DescribeLocalGatewayRouteTablesResult < Struct.new(
      :local_gateway_route_tables,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeLocalGatewayVirtualInterfaceGroupsRequest
    #   data as a hash:
    #
    #       {
    #         local_gateway_virtual_interface_group_ids: ["LocalGatewayVirtualInterfaceGroupId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] local_gateway_virtual_interface_group_ids
    #   The IDs of the virtual interface groups.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `local-gateway-id` - The ID of a local gateway.
    #
    #   * `local-gateway-virtual-interface-id` - The ID of the virtual
    #     interface.
    #
    #   * `local-gateway-virtual-interface-group-id` - The ID of the virtual
    #     interface group.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeLocalGatewayVirtualInterfaceGroupsRequest AWS API Documentation
    #
    class DescribeLocalGatewayVirtualInterfaceGroupsRequest < Struct.new(
      :local_gateway_virtual_interface_group_ids,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] local_gateway_virtual_interface_groups
    #   The virtual interface groups.
    #   @return [Array<Types::LocalGatewayVirtualInterfaceGroup>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeLocalGatewayVirtualInterfaceGroupsResult AWS API Documentation
    #
    class DescribeLocalGatewayVirtualInterfaceGroupsResult < Struct.new(
      :local_gateway_virtual_interface_groups,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeLocalGatewayVirtualInterfacesRequest
    #   data as a hash:
    #
    #       {
    #         local_gateway_virtual_interface_ids: ["LocalGatewayVirtualInterfaceId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] local_gateway_virtual_interface_ids
    #   The IDs of the virtual interfaces.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeLocalGatewayVirtualInterfacesRequest AWS API Documentation
    #
    class DescribeLocalGatewayVirtualInterfacesRequest < Struct.new(
      :local_gateway_virtual_interface_ids,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] local_gateway_virtual_interfaces
    #   Information about the virtual interfaces.
    #   @return [Array<Types::LocalGatewayVirtualInterface>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeLocalGatewayVirtualInterfacesResult AWS API Documentation
    #
    class DescribeLocalGatewayVirtualInterfacesResult < Struct.new(
      :local_gateway_virtual_interfaces,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeLocalGatewaysRequest
    #   data as a hash:
    #
    #       {
    #         local_gateway_ids: ["LocalGatewayId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] local_gateway_ids
    #   One or more filters.
    #
    #   * `local-gateway-id` - The ID of a local gateway.
    #
    #   * `local-gateway-route-table-id` - The ID of the local gateway route
    #     table.
    #
    #   * `local-gateway-route-table-virtual-interface-group-association-id`
    #     - The ID of the association.
    #
    #   * `local-gateway-route-table-virtual-interface-group-id` - The ID of
    #     the virtual interface group.
    #
    #   * `outpost-arn` - The Amazon Resource Name (ARN) of the Outpost.
    #
    #   * `state` - The state of the association.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeLocalGatewaysRequest AWS API Documentation
    #
    class DescribeLocalGatewaysRequest < Struct.new(
      :local_gateway_ids,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] local_gateways
    #   Information about the local gateways.
    #   @return [Array<Types::LocalGateway>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeLocalGatewaysResult AWS API Documentation
    #
    class DescribeLocalGatewaysResult < Struct.new(
      :local_gateways,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeMovingAddressesRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #         max_results: 1,
    #         next_token: "String",
    #         public_ips: ["String"],
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `moving-status` - The status of the Elastic IP address
    #     (`MovingToVpc` \| `RestoringToClassic`).
    #
    #   ^
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results of the initial request can be seen by
    #   sending another request with the returned `NextToken` value. This
    #   value can be between 5 and 1000; if `MaxResults` is given a value
    #   outside of this range, an error is returned.
    #
    #   Default: If no value is provided, the default is 1000.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] public_ips
    #   One or more Elastic IP addresses.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeMovingAddressesRequest AWS API Documentation
    #
    class DescribeMovingAddressesRequest < Struct.new(
      :filters,
      :dry_run,
      :max_results,
      :next_token,
      :public_ips)
      include Aws::Structure
    end

    # @!attribute [rw] moving_address_statuses
    #   The status for each Elastic IP address.
    #   @return [Array<Types::MovingAddressStatus>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeMovingAddressesResult AWS API Documentation
    #
    class DescribeMovingAddressesResult < Struct.new(
      :moving_address_statuses,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeNatGatewaysRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         filter: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         nat_gateway_ids: ["NatGatewayId"],
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] filter
    #   One or more filters.
    #
    #   * `nat-gateway-id` - The ID of the NAT gateway.
    #
    #   * `state` - The state of the NAT gateway (`pending` \| `failed` \|
    #     `available` \| `deleting` \| `deleted`).
    #
    #   * `subnet-id` - The ID of the subnet in which the NAT gateway
    #     resides.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `vpc-id` - The ID of the VPC in which the NAT gateway resides.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] nat_gateway_ids
    #   One or more NAT gateway IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeNatGatewaysRequest AWS API Documentation
    #
    class DescribeNatGatewaysRequest < Struct.new(
      :dry_run,
      :filter,
      :max_results,
      :nat_gateway_ids,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] nat_gateways
    #   Information about the NAT gateways.
    #   @return [Array<Types::NatGateway>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeNatGatewaysResult AWS API Documentation
    #
    class DescribeNatGatewaysResult < Struct.new(
      :nat_gateways,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeNetworkAclsRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #         network_acl_ids: ["NetworkAclId"],
    #         next_token: "String",
    #         max_results: 1,
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `association.association-id` - The ID of an association ID for the
    #     ACL.
    #
    #   * `association.network-acl-id` - The ID of the network ACL involved
    #     in the association.
    #
    #   * `association.subnet-id` - The ID of the subnet involved in the
    #     association.
    #
    #   * `default` - Indicates whether the ACL is the default network ACL
    #     for the VPC.
    #
    #   * `entry.cidr` - The IPv4 CIDR range specified in the entry.
    #
    #   * `entry.icmp.code` - The ICMP code specified in the entry, if any.
    #
    #   * `entry.icmp.type` - The ICMP type specified in the entry, if any.
    #
    #   * `entry.ipv6-cidr` - The IPv6 CIDR range specified in the entry.
    #
    #   * `entry.port-range.from` - The start of the port range specified in
    #     the entry.
    #
    #   * `entry.port-range.to` - The end of the port range specified in the
    #     entry.
    #
    #   * `entry.protocol` - The protocol specified in the entry (`tcp` \|
    #     `udp` \| `icmp` or a protocol number).
    #
    #   * `entry.rule-action` - Allows or denies the matching traffic
    #     (`allow` \| `deny`).
    #
    #   * `entry.rule-number` - The number of an entry (in other words,
    #     rule) in the set of ACL entries.
    #
    #   * `network-acl-id` - The ID of the network ACL.
    #
    #   * `owner-id` - The ID of the AWS account that owns the network ACL.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `vpc-id` - The ID of the VPC for the network ACL.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] network_acl_ids
    #   One or more network ACL IDs.
    #
    #   Default: Describes all your network ACLs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeNetworkAclsRequest AWS API Documentation
    #
    class DescribeNetworkAclsRequest < Struct.new(
      :filters,
      :dry_run,
      :network_acl_ids,
      :next_token,
      :max_results)
      include Aws::Structure
    end

    # @!attribute [rw] network_acls
    #   Information about one or more network ACLs.
    #   @return [Array<Types::NetworkAcl>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeNetworkAclsResult AWS API Documentation
    #
    class DescribeNetworkAclsResult < Struct.new(
      :network_acls,
      :next_token)
      include Aws::Structure
    end

    # Contains the parameters for DescribeNetworkInterfaceAttribute.
    #
    # @note When making an API call, you may pass DescribeNetworkInterfaceAttributeRequest
    #   data as a hash:
    #
    #       {
    #         attribute: "description", # accepts description, groupSet, sourceDestCheck, attachment
    #         dry_run: false,
    #         network_interface_id: "NetworkInterfaceId", # required
    #       }
    #
    # @!attribute [rw] attribute
    #   The attribute of the network interface. This parameter is required.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeNetworkInterfaceAttributeRequest AWS API Documentation
    #
    class DescribeNetworkInterfaceAttributeRequest < Struct.new(
      :attribute,
      :dry_run,
      :network_interface_id)
      include Aws::Structure
    end

    # Contains the output of DescribeNetworkInterfaceAttribute.
    #
    # @!attribute [rw] attachment
    #   The attachment (if any) of the network interface.
    #   @return [Types::NetworkInterfaceAttachment]
    #
    # @!attribute [rw] description
    #   The description of the network interface.
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] groups
    #   The security groups associated with the network interface.
    #   @return [Array<Types::GroupIdentifier>]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] source_dest_check
    #   Indicates whether source/destination checking is enabled.
    #   @return [Types::AttributeBooleanValue]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeNetworkInterfaceAttributeResult AWS API Documentation
    #
    class DescribeNetworkInterfaceAttributeResult < Struct.new(
      :attachment,
      :description,
      :groups,
      :network_interface_id,
      :source_dest_check)
      include Aws::Structure
    end

    # Contains the parameters for DescribeNetworkInterfacePermissions.
    #
    # @note When making an API call, you may pass DescribeNetworkInterfacePermissionsRequest
    #   data as a hash:
    #
    #       {
    #         network_interface_permission_ids: ["NetworkInterfacePermissionId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         next_token: "String",
    #         max_results: 1,
    #       }
    #
    # @!attribute [rw] network_interface_permission_ids
    #   One or more network interface permission IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `network-interface-permission.network-interface-permission-id` -
    #     The ID of the permission.
    #
    #   * `network-interface-permission.network-interface-id` - The ID of
    #     the network interface.
    #
    #   * `network-interface-permission.aws-account-id` - The AWS account
    #     ID.
    #
    #   * `network-interface-permission.aws-service` - The AWS service.
    #
    #   * `network-interface-permission.permission` - The type of permission
    #     (`INSTANCE-ATTACH` \| `EIP-ASSOCIATE`).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] next_token
    #   The token to request the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `NextToken` value. If this parameter is not specified, up to 50
    #   results are returned by default.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeNetworkInterfacePermissionsRequest AWS API Documentation
    #
    class DescribeNetworkInterfacePermissionsRequest < Struct.new(
      :network_interface_permission_ids,
      :filters,
      :next_token,
      :max_results)
      include Aws::Structure
    end

    # Contains the output for DescribeNetworkInterfacePermissions.
    #
    # @!attribute [rw] network_interface_permissions
    #   The network interface permissions.
    #   @return [Array<Types::NetworkInterfacePermission>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeNetworkInterfacePermissionsResult AWS API Documentation
    #
    class DescribeNetworkInterfacePermissionsResult < Struct.new(
      :network_interface_permissions,
      :next_token)
      include Aws::Structure
    end

    # Contains the parameters for DescribeNetworkInterfaces.
    #
    # @note When making an API call, you may pass DescribeNetworkInterfacesRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #         network_interface_ids: ["NetworkInterfaceId"],
    #         next_token: "String",
    #         max_results: 1,
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `addresses.private-ip-address` - The private IPv4 addresses
    #     associated with the network interface.
    #
    #   * `addresses.primary` - Whether the private IPv4 address is the
    #     primary IP address associated with the network interface.
    #
    #   * `addresses.association.public-ip` - The association ID returned
    #     when the network interface was associated with the Elastic IP
    #     address (IPv4).
    #
    #   * `addresses.association.owner-id` - The owner ID of the addresses
    #     associated with the network interface.
    #
    #   * `association.association-id` - The association ID returned when
    #     the network interface was associated with an IPv4 address.
    #
    #   * `association.allocation-id` - The allocation ID returned when you
    #     allocated the Elastic IP address (IPv4) for your network
    #     interface.
    #
    #   * `association.ip-owner-id` - The owner of the Elastic IP address
    #     (IPv4) associated with the network interface.
    #
    #   * `association.public-ip` - The address of the Elastic IP address
    #     (IPv4) bound to the network interface.
    #
    #   * `association.public-dns-name` - The public DNS name for the
    #     network interface (IPv4).
    #
    #   * `attachment.attachment-id` - The ID of the interface attachment.
    #
    #   * `attachment.attach-time` - The time that the network interface was
    #     attached to an instance.
    #
    #   * `attachment.delete-on-termination` - Indicates whether the
    #     attachment is deleted when an instance is terminated.
    #
    #   * `attachment.device-index` - The device index to which the network
    #     interface is attached.
    #
    #   * `attachment.instance-id` - The ID of the instance to which the
    #     network interface is attached.
    #
    #   * `attachment.instance-owner-id` - The owner ID of the instance to
    #     which the network interface is attached.
    #
    #   * `attachment.nat-gateway-id` - The ID of the NAT gateway to which
    #     the network interface is attached.
    #
    #   * `attachment.status` - The status of the attachment (`attaching` \|
    #     `attached` \| `detaching` \| `detached`).
    #
    #   * `availability-zone` - The Availability Zone of the network
    #     interface.
    #
    #   * `description` - The description of the network interface.
    #
    #   * `group-id` - The ID of a security group associated with the
    #     network interface.
    #
    #   * `group-name` - The name of a security group associated with the
    #     network interface.
    #
    #   * `ipv6-addresses.ipv6-address` - An IPv6 address associated with
    #     the network interface.
    #
    #   * `mac-address` - The MAC address of the network interface.
    #
    #   * `network-interface-id` - The ID of the network interface.
    #
    #   * `owner-id` - The AWS account ID of the network interface owner.
    #
    #   * `private-ip-address` - The private IPv4 address or addresses of
    #     the network interface.
    #
    #   * `private-dns-name` - The private DNS name of the network interface
    #     (IPv4).
    #
    #   * `requester-id` - The ID of the entity that launched the instance
    #     on your behalf (for example, AWS Management Console, Auto Scaling,
    #     and so on).
    #
    #   * `requester-managed` - Indicates whether the network interface is
    #     being managed by an AWS service (for example, AWS Management
    #     Console, Auto Scaling, and so on).
    #
    #   * `source-dest-check` - Indicates whether the network interface
    #     performs source/destination checking. A value of `true` means
    #     checking is enabled, and `false` means checking is disabled. The
    #     value must be `false` for the network interface to perform network
    #     address translation (NAT) in your VPC.
    #
    #   * `status` - The status of the network interface. If the network
    #     interface is not attached to an instance, the status is
    #     `available`; if a network interface is attached to an instance the
    #     status is `in-use`.
    #
    #   * `subnet-id` - The ID of the subnet for the network interface.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `vpc-id` - The ID of the VPC for the network interface.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] network_interface_ids
    #   One or more network interface IDs.
    #
    #   Default: Describes all your network interfaces.
    #   @return [Array<String>]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of items to return for this request. The request
    #   returns a token that you can specify in a subsequent call to get the
    #   next set of results. You cannot specify this parameter and the
    #   network interface IDs parameter in the same request.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeNetworkInterfacesRequest AWS API Documentation
    #
    class DescribeNetworkInterfacesRequest < Struct.new(
      :filters,
      :dry_run,
      :network_interface_ids,
      :next_token,
      :max_results)
      include Aws::Structure
    end

    # Contains the output of DescribeNetworkInterfaces.
    #
    # @!attribute [rw] network_interfaces
    #   Information about one or more network interfaces.
    #   @return [Array<Types::NetworkInterface>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeNetworkInterfacesResult AWS API Documentation
    #
    class DescribeNetworkInterfacesResult < Struct.new(
      :network_interfaces,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribePlacementGroupsRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #         group_names: ["PlacementGroupName"],
    #         group_ids: ["PlacementGroupId"],
    #       }
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `group-name` - The name of the placement group.
    #
    #   * `state` - The state of the placement group (`pending` \|
    #     `available` \| `deleting` \| `deleted`).
    #
    #   * `strategy` - The strategy of the placement group (`cluster` \|
    #     `spread` \| `partition`).
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources that have a tag with a specific key,
    #     regardless of the tag value.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] group_names
    #   The names of the placement groups.
    #
    #   Default: Describes all your placement groups, or only those
    #   otherwise specified.
    #   @return [Array<String>]
    #
    # @!attribute [rw] group_ids
    #   The IDs of the placement groups.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribePlacementGroupsRequest AWS API Documentation
    #
    class DescribePlacementGroupsRequest < Struct.new(
      :filters,
      :dry_run,
      :group_names,
      :group_ids)
      include Aws::Structure
    end

    # @!attribute [rw] placement_groups
    #   Information about the placement groups.
    #   @return [Array<Types::PlacementGroup>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribePlacementGroupsResult AWS API Documentation
    #
    class DescribePlacementGroupsResult < Struct.new(
      :placement_groups)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribePrefixListsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         prefix_list_ids: ["PrefixListResourceId"],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `prefix-list-id`\: The ID of a prefix list.
    #
    #   * `prefix-list-name`\: The name of a prefix list.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] prefix_list_ids
    #   One or more prefix list IDs.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribePrefixListsRequest AWS API Documentation
    #
    class DescribePrefixListsRequest < Struct.new(
      :dry_run,
      :filters,
      :max_results,
      :next_token,
      :prefix_list_ids)
      include Aws::Structure
    end

    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @!attribute [rw] prefix_lists
    #   All available prefix lists.
    #   @return [Array<Types::PrefixList>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribePrefixListsResult AWS API Documentation
    #
    class DescribePrefixListsResult < Struct.new(
      :next_token,
      :prefix_lists)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribePrincipalIdFormatRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         resources: ["String"],
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] resources
    #   The type of resource: `bundle` \| `conversion-task` \|
    #   `customer-gateway` \| `dhcp-options` \| `elastic-ip-allocation` \|
    #   `elastic-ip-association` \| `export-task` \| `flow-log` \| `image`
    #   \| `import-task` \| `instance` \| `internet-gateway` \|
    #   `network-acl` \| `network-acl-association` \| `network-interface` \|
    #   `network-interface-attachment` \| `prefix-list` \| `reservation` \|
    #   `route-table` \| `route-table-association` \| `security-group` \|
    #   `snapshot` \| `subnet` \| `subnet-cidr-block-association` \|
    #   `volume` \| `vpc` \| `vpc-cidr-block-association` \| `vpc-endpoint`
    #   \| `vpc-peering-connection` \| `vpn-connection` \| `vpn-gateway`
    #   @return [Array<String>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   NextToken value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to request the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribePrincipalIdFormatRequest AWS API Documentation
    #
    class DescribePrincipalIdFormatRequest < Struct.new(
      :dry_run,
      :resources,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] principals
    #   Information about the ID format settings for the ARN.
    #   @return [Array<Types::PrincipalIdFormat>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   null when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribePrincipalIdFormatResult AWS API Documentation
    #
    class DescribePrincipalIdFormatResult < Struct.new(
      :principals,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribePublicIpv4PoolsRequest
    #   data as a hash:
    #
    #       {
    #         pool_ids: ["Ipv4PoolEc2Id"],
    #         next_token: "NextToken",
    #         max_results: 1,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] pool_ids
    #   The IDs of the address pools.
    #   @return [Array<String>]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #   @return [Array<Types::Filter>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribePublicIpv4PoolsRequest AWS API Documentation
    #
    class DescribePublicIpv4PoolsRequest < Struct.new(
      :pool_ids,
      :next_token,
      :max_results,
      :filters)
      include Aws::Structure
    end

    # @!attribute [rw] public_ipv_4_pools
    #   Information about the address pools.
    #   @return [Array<Types::PublicIpv4Pool>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribePublicIpv4PoolsResult AWS API Documentation
    #
    class DescribePublicIpv4PoolsResult < Struct.new(
      :public_ipv_4_pools,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeRegionsRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         region_names: ["String"],
    #         dry_run: false,
    #         all_regions: false,
    #       }
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `endpoint` - The endpoint of the Region (for example,
    #     `ec2.us-east-1.amazonaws.com`).
    #
    #   * `opt-in-status` - The opt-in status of the Region
    #     (`opt-in-not-required` \| `opted-in` \| `not-opted-in`).
    #
    #   * `region-name` - The name of the Region (for example, `us-east-1`).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] region_names
    #   The names of the Regions. You can specify any Regions, whether they
    #   are enabled and disabled for your account.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] all_regions
    #   Indicates whether to display all Regions, including Regions that are
    #   disabled for your account.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeRegionsRequest AWS API Documentation
    #
    class DescribeRegionsRequest < Struct.new(
      :filters,
      :region_names,
      :dry_run,
      :all_regions)
      include Aws::Structure
    end

    # @!attribute [rw] regions
    #   Information about the Regions.
    #   @return [Array<Types::Region>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeRegionsResult AWS API Documentation
    #
    class DescribeRegionsResult < Struct.new(
      :regions)
      include Aws::Structure
    end

    # Contains the parameters for DescribeReservedInstancesListings.
    #
    # @note When making an API call, you may pass DescribeReservedInstancesListingsRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         reserved_instances_id: "ReservationId",
    #         reserved_instances_listing_id: "ReservedInstancesListingId",
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `reserved-instances-id` - The ID of the Reserved Instances.
    #
    #   * `reserved-instances-listing-id` - The ID of the Reserved Instances
    #     listing.
    #
    #   * `status` - The status of the Reserved Instance listing (`pending`
    #     \| `active` \| `cancelled` \| `closed`).
    #
    #   * `status-message` - The reason for the status.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] reserved_instances_id
    #   One or more Reserved Instance IDs.
    #   @return [String]
    #
    # @!attribute [rw] reserved_instances_listing_id
    #   One or more Reserved Instance listing IDs.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeReservedInstancesListingsRequest AWS API Documentation
    #
    class DescribeReservedInstancesListingsRequest < Struct.new(
      :filters,
      :reserved_instances_id,
      :reserved_instances_listing_id)
      include Aws::Structure
    end

    # Contains the output of DescribeReservedInstancesListings.
    #
    # @!attribute [rw] reserved_instances_listings
    #   Information about the Reserved Instance listing.
    #   @return [Array<Types::ReservedInstancesListing>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeReservedInstancesListingsResult AWS API Documentation
    #
    class DescribeReservedInstancesListingsResult < Struct.new(
      :reserved_instances_listings)
      include Aws::Structure
    end

    # Contains the parameters for DescribeReservedInstancesModifications.
    #
    # @note When making an API call, you may pass DescribeReservedInstancesModificationsRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         reserved_instances_modification_ids: ["ReservedInstancesModificationId"],
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `client-token` - The idempotency token for the modification
    #     request.
    #
    #   * `create-date` - The time when the modification request was
    #     created.
    #
    #   * `effective-date` - The time when the modification becomes
    #     effective.
    #
    #   * `modification-result.reserved-instances-id` - The ID for the
    #     Reserved Instances created as part of the modification request.
    #     This ID is only available when the status of the modification is
    #     `fulfilled`.
    #
    #   * `modification-result.target-configuration.availability-zone` - The
    #     Availability Zone for the new Reserved Instances.
    #
    #   * `modification-result.target-configuration.instance-count ` - The
    #     number of new Reserved Instances.
    #
    #   * `modification-result.target-configuration.instance-type` - The
    #     instance type of the new Reserved Instances.
    #
    #   * `modification-result.target-configuration.platform` - The network
    #     platform of the new Reserved Instances (`EC2-Classic` \|
    #     `EC2-VPC`).
    #
    #   * `reserved-instances-id` - The ID of the Reserved Instances
    #     modified.
    #
    #   * `reserved-instances-modification-id` - The ID of the modification
    #     request.
    #
    #   * `status` - The status of the Reserved Instances modification
    #     request (`processing` \| `fulfilled` \| `failed`).
    #
    #   * `status-message` - The reason for the status.
    #
    #   * `update-date` - The time when the modification request was last
    #     updated.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] reserved_instances_modification_ids
    #   IDs for the submitted modification request.
    #   @return [Array<String>]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeReservedInstancesModificationsRequest AWS API Documentation
    #
    class DescribeReservedInstancesModificationsRequest < Struct.new(
      :filters,
      :reserved_instances_modification_ids,
      :next_token)
      include Aws::Structure
    end

    # Contains the output of DescribeReservedInstancesModifications.
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @!attribute [rw] reserved_instances_modifications
    #   The Reserved Instance modification information.
    #   @return [Array<Types::ReservedInstancesModification>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeReservedInstancesModificationsResult AWS API Documentation
    #
    class DescribeReservedInstancesModificationsResult < Struct.new(
      :next_token,
      :reserved_instances_modifications)
      include Aws::Structure
    end

    # Contains the parameters for DescribeReservedInstancesOfferings.
    #
    # @note When making an API call, you may pass DescribeReservedInstancesOfferingsRequest
    #   data as a hash:
    #
    #       {
    #         availability_zone: "String",
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         include_marketplace: false,
    #         instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #         max_duration: 1,
    #         max_instance_count: 1,
    #         min_duration: 1,
    #         offering_class: "standard", # accepts standard, convertible
    #         product_description: "Linux/UNIX", # accepts Linux/UNIX, Linux/UNIX (Amazon VPC), Windows, Windows (Amazon VPC)
    #         reserved_instances_offering_ids: ["ReservedInstancesOfferingId"],
    #         dry_run: false,
    #         instance_tenancy: "default", # accepts default, dedicated, host
    #         max_results: 1,
    #         next_token: "String",
    #         offering_type: "Heavy Utilization", # accepts Heavy Utilization, Medium Utilization, Light Utilization, No Upfront, Partial Upfront, All Upfront
    #       }
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone in which the Reserved Instance can be used.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `availability-zone` - The Availability Zone where the Reserved
    #     Instance can be used.
    #
    #   * `duration` - The duration of the Reserved Instance (for example,
    #     one year or three years), in seconds (`31536000` \| `94608000`).
    #
    #   * `fixed-price` - The purchase price of the Reserved Instance (for
    #     example, 9800.0).
    #
    #   * `instance-type` - The instance type that is covered by the
    #     reservation.
    #
    #   * `marketplace` - Set to `true` to show only Reserved Instance
    #     Marketplace offerings. When this filter is not used, which is the
    #     default behavior, all offerings from both AWS and the Reserved
    #     Instance Marketplace are listed.
    #
    #   * `product-description` - The Reserved Instance product platform
    #     description. Instances that include `(Amazon VPC)` in the product
    #     platform description will only be displayed to EC2-Classic account
    #     holders and are for use with Amazon VPC. (`Linux/UNIX` \|
    #     `Linux/UNIX (Amazon VPC)` \| `SUSE Linux` \| `SUSE Linux (Amazon
    #     VPC)` \| `Red Hat Enterprise Linux` \| `Red Hat Enterprise Linux
    #     (Amazon VPC)` \| `Windows` \| `Windows (Amazon VPC)` \| `Windows
    #     with SQL Server Standard` \| `Windows with SQL Server Standard
    #     (Amazon VPC)` \| `Windows with SQL Server Web` \| ` Windows with
    #     SQL Server Web (Amazon VPC)` \| `Windows with SQL Server
    #     Enterprise` \| `Windows with SQL Server Enterprise (Amazon VPC)`)
    #
    #   * `reserved-instances-offering-id` - The Reserved Instances offering
    #     ID.
    #
    #   * `scope` - The scope of the Reserved Instance (`Availability Zone`
    #     or `Region`).
    #
    #   * `usage-price` - The usage price of the Reserved Instance, per hour
    #     (for example, 0.84).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] include_marketplace
    #   Include Reserved Instance Marketplace offerings in the response.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_type
    #   The instance type that the reservation will cover (for example,
    #   `m1.small`). For more information, see [Instance Types][1] in the
    #   *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html
    #   @return [String]
    #
    # @!attribute [rw] max_duration
    #   The maximum duration (in seconds) to filter when searching for
    #   offerings.
    #
    #   Default: 94608000 (3 years)
    #   @return [Integer]
    #
    # @!attribute [rw] max_instance_count
    #   The maximum number of instances to filter when searching for
    #   offerings.
    #
    #   Default: 20
    #   @return [Integer]
    #
    # @!attribute [rw] min_duration
    #   The minimum duration (in seconds) to filter when searching for
    #   offerings.
    #
    #   Default: 2592000 (1 month)
    #   @return [Integer]
    #
    # @!attribute [rw] offering_class
    #   The offering class of the Reserved Instance. Can be `standard` or
    #   `convertible`.
    #   @return [String]
    #
    # @!attribute [rw] product_description
    #   The Reserved Instance product platform description. Instances that
    #   include `(Amazon VPC)` in the description are for use with Amazon
    #   VPC.
    #   @return [String]
    #
    # @!attribute [rw] reserved_instances_offering_ids
    #   One or more Reserved Instances offering IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_tenancy
    #   The tenancy of the instances covered by the reservation. A Reserved
    #   Instance with a tenancy of `dedicated` is applied to instances that
    #   run in a VPC on single-tenant hardware (i.e., Dedicated Instances).
    #
    #   **Important:** The `host` value cannot be used with this parameter.
    #   Use the `default` or `dedicated` values only.
    #
    #   Default: `default`
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results of the initial request can be seen by
    #   sending another request with the returned `NextToken` value. The
    #   maximum is 100.
    #
    #   Default: 100
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] offering_type
    #   The Reserved Instance offering type. If you are using tools that
    #   predate the 2011-11-01 API version, you only have access to the
    #   `Medium Utilization` Reserved Instance offering type.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeReservedInstancesOfferingsRequest AWS API Documentation
    #
    class DescribeReservedInstancesOfferingsRequest < Struct.new(
      :availability_zone,
      :filters,
      :include_marketplace,
      :instance_type,
      :max_duration,
      :max_instance_count,
      :min_duration,
      :offering_class,
      :product_description,
      :reserved_instances_offering_ids,
      :dry_run,
      :instance_tenancy,
      :max_results,
      :next_token,
      :offering_type)
      include Aws::Structure
    end

    # Contains the output of DescribeReservedInstancesOfferings.
    #
    # @!attribute [rw] reserved_instances_offerings
    #   A list of Reserved Instances offerings.
    #   @return [Array<Types::ReservedInstancesOffering>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeReservedInstancesOfferingsResult AWS API Documentation
    #
    class DescribeReservedInstancesOfferingsResult < Struct.new(
      :reserved_instances_offerings,
      :next_token)
      include Aws::Structure
    end

    # Contains the parameters for DescribeReservedInstances.
    #
    # @note When making an API call, you may pass DescribeReservedInstancesRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         offering_class: "standard", # accepts standard, convertible
    #         reserved_instances_ids: ["ReservationId"],
    #         dry_run: false,
    #         offering_type: "Heavy Utilization", # accepts Heavy Utilization, Medium Utilization, Light Utilization, No Upfront, Partial Upfront, All Upfront
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `availability-zone` - The Availability Zone where the Reserved
    #     Instance can be used.
    #
    #   * `duration` - The duration of the Reserved Instance (one year or
    #     three years), in seconds (`31536000` \| `94608000`).
    #
    #   * `end` - The time when the Reserved Instance expires (for example,
    #     2015-08-07T11:54:42.000Z).
    #
    #   * `fixed-price` - The purchase price of the Reserved Instance (for
    #     example, 9800.0).
    #
    #   * `instance-type` - The instance type that is covered by the
    #     reservation.
    #
    #   * `scope` - The scope of the Reserved Instance (`Region` or
    #     `Availability Zone`).
    #
    #   * `product-description` - The Reserved Instance product platform
    #     description. Instances that include `(Amazon VPC)` in the product
    #     platform description will only be displayed to EC2-Classic account
    #     holders and are for use with Amazon VPC (`Linux/UNIX` \|
    #     `Linux/UNIX (Amazon VPC)` \| `SUSE Linux` \| `SUSE Linux (Amazon
    #     VPC)` \| `Red Hat Enterprise Linux` \| `Red Hat Enterprise Linux
    #     (Amazon VPC)` \| `Windows` \| `Windows (Amazon VPC)` \| `Windows
    #     with SQL Server Standard` \| `Windows with SQL Server Standard
    #     (Amazon VPC)` \| `Windows with SQL Server Web` \| `Windows with
    #     SQL Server Web (Amazon VPC)` \| `Windows with SQL Server
    #     Enterprise` \| `Windows with SQL Server Enterprise (Amazon VPC)`).
    #
    #   * `reserved-instances-id` - The ID of the Reserved Instance.
    #
    #   * `start` - The time at which the Reserved Instance purchase request
    #     was placed (for example, 2014-08-07T11:54:42.000Z).
    #
    #   * `state` - The state of the Reserved Instance (`payment-pending` \|
    #     `active` \| `payment-failed` \| `retired`).
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `usage-price` - The usage price of the Reserved Instance, per hour
    #     (for example, 0.84).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] offering_class
    #   Describes whether the Reserved Instance is Standard or Convertible.
    #   @return [String]
    #
    # @!attribute [rw] reserved_instances_ids
    #   One or more Reserved Instance IDs.
    #
    #   Default: Describes all your Reserved Instances, or only those
    #   otherwise specified.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] offering_type
    #   The Reserved Instance offering type. If you are using tools that
    #   predate the 2011-11-01 API version, you only have access to the
    #   `Medium Utilization` Reserved Instance offering type.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeReservedInstancesRequest AWS API Documentation
    #
    class DescribeReservedInstancesRequest < Struct.new(
      :filters,
      :offering_class,
      :reserved_instances_ids,
      :dry_run,
      :offering_type)
      include Aws::Structure
    end

    # Contains the output for DescribeReservedInstances.
    #
    # @!attribute [rw] reserved_instances
    #   A list of Reserved Instances.
    #   @return [Array<Types::ReservedInstances>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeReservedInstancesResult AWS API Documentation
    #
    class DescribeReservedInstancesResult < Struct.new(
      :reserved_instances)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeRouteTablesRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #         route_table_ids: ["RouteTableId"],
    #         next_token: "String",
    #         max_results: 1,
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `association.route-table-association-id` - The ID of an
    #     association ID for the route table.
    #
    #   * `association.route-table-id` - The ID of the route table involved
    #     in the association.
    #
    #   * `association.subnet-id` - The ID of the subnet involved in the
    #     association.
    #
    #   * `association.main` - Indicates whether the route table is the main
    #     route table for the VPC (`true` \| `false`). Route tables that do
    #     not have an association ID are not returned in the response.
    #
    #   * `owner-id` - The ID of the AWS account that owns the route table.
    #
    #   * `route-table-id` - The ID of the route table.
    #
    #   * `route.destination-cidr-block` - The IPv4 CIDR range specified in
    #     a route in the table.
    #
    #   * `route.destination-ipv6-cidr-block` - The IPv6 CIDR range
    #     specified in a route in the route table.
    #
    #   * `route.destination-prefix-list-id` - The ID (prefix) of the AWS
    #     service specified in a route in the table.
    #
    #   * `route.egress-only-internet-gateway-id` - The ID of an egress-only
    #     Internet gateway specified in a route in the route table.
    #
    #   * `route.gateway-id` - The ID of a gateway specified in a route in
    #     the table.
    #
    #   * `route.instance-id` - The ID of an instance specified in a route
    #     in the table.
    #
    #   * `route.nat-gateway-id` - The ID of a NAT gateway.
    #
    #   * `route.transit-gateway-id` - The ID of a transit gateway.
    #
    #   * `route.origin` - Describes how the route was created.
    #     `CreateRouteTable` indicates that the route was automatically
    #     created when the route table was created; `CreateRoute` indicates
    #     that the route was manually added to the route table;
    #     `EnableVgwRoutePropagation` indicates that the route was
    #     propagated by route propagation.
    #
    #   * `route.state` - The state of a route in the route table (`active`
    #     \| `blackhole`). The blackhole state indicates that the route's
    #     target isn't available (for example, the specified gateway isn't
    #     attached to the VPC, the specified NAT instance has been
    #     terminated, and so on).
    #
    #   * `route.vpc-peering-connection-id` - The ID of a VPC peering
    #     connection specified in a route in the table.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `transit-gateway-id` - The ID of a transit gateway.
    #
    #   * `vpc-id` - The ID of the VPC for the route table.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] route_table_ids
    #   One or more route table IDs.
    #
    #   Default: Describes all your route tables.
    #   @return [Array<String>]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeRouteTablesRequest AWS API Documentation
    #
    class DescribeRouteTablesRequest < Struct.new(
      :filters,
      :dry_run,
      :route_table_ids,
      :next_token,
      :max_results)
      include Aws::Structure
    end

    # Contains the output of DescribeRouteTables.
    #
    # @!attribute [rw] route_tables
    #   Information about one or more route tables.
    #   @return [Array<Types::RouteTable>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeRouteTablesResult AWS API Documentation
    #
    class DescribeRouteTablesResult < Struct.new(
      :route_tables,
      :next_token)
      include Aws::Structure
    end

    # Contains the parameters for DescribeScheduledInstanceAvailability.
    #
    # @note When making an API call, you may pass DescribeScheduledInstanceAvailabilityRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         first_slot_start_time_range: { # required
    #           earliest_time: Time.now, # required
    #           latest_time: Time.now, # required
    #         },
    #         max_results: 1,
    #         max_slot_duration_in_hours: 1,
    #         min_slot_duration_in_hours: 1,
    #         next_token: "String",
    #         recurrence: { # required
    #           frequency: "String",
    #           interval: 1,
    #           occurrence_days: [1],
    #           occurrence_relative_to_end: false,
    #           occurrence_unit: "String",
    #         },
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `availability-zone` - The Availability Zone (for example,
    #     `us-west-2a`).
    #
    #   * `instance-type` - The instance type (for example, `c4.large`).
    #
    #   * `network-platform` - The network platform (`EC2-Classic` or
    #     `EC2-VPC`).
    #
    #   * `platform` - The platform (`Linux/UNIX` or `Windows`).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] first_slot_start_time_range
    #   The time period for the first schedule to start.
    #   @return [Types::SlotDateTimeRangeRequest]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. This value
    #   can be between 5 and 300. The default value is 300. To retrieve the
    #   remaining results, make another call with the returned `NextToken`
    #   value.
    #   @return [Integer]
    #
    # @!attribute [rw] max_slot_duration_in_hours
    #   The maximum available duration, in hours. This value must be greater
    #   than `MinSlotDurationInHours` and less than 1,720.
    #   @return [Integer]
    #
    # @!attribute [rw] min_slot_duration_in_hours
    #   The minimum available duration, in hours. The minimum required
    #   duration is 1,200 hours per year. For example, the minimum daily
    #   schedule is 4 hours, the minimum weekly schedule is 24 hours, and
    #   the minimum monthly schedule is 100 hours.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next set of results.
    #   @return [String]
    #
    # @!attribute [rw] recurrence
    #   The schedule recurrence.
    #   @return [Types::ScheduledInstanceRecurrenceRequest]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeScheduledInstanceAvailabilityRequest AWS API Documentation
    #
    class DescribeScheduledInstanceAvailabilityRequest < Struct.new(
      :dry_run,
      :filters,
      :first_slot_start_time_range,
      :max_results,
      :max_slot_duration_in_hours,
      :min_slot_duration_in_hours,
      :next_token,
      :recurrence)
      include Aws::Structure
    end

    # Contains the output of DescribeScheduledInstanceAvailability.
    #
    # @!attribute [rw] next_token
    #   The token required to retrieve the next set of results. This value
    #   is `null` when there are no more results to return.
    #   @return [String]
    #
    # @!attribute [rw] scheduled_instance_availability_set
    #   Information about the available Scheduled Instances.
    #   @return [Array<Types::ScheduledInstanceAvailability>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeScheduledInstanceAvailabilityResult AWS API Documentation
    #
    class DescribeScheduledInstanceAvailabilityResult < Struct.new(
      :next_token,
      :scheduled_instance_availability_set)
      include Aws::Structure
    end

    # Contains the parameters for DescribeScheduledInstances.
    #
    # @note When making an API call, you may pass DescribeScheduledInstancesRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         scheduled_instance_ids: ["ScheduledInstanceId"],
    #         slot_start_time_range: {
    #           earliest_time: Time.now,
    #           latest_time: Time.now,
    #         },
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `availability-zone` - The Availability Zone (for example,
    #     `us-west-2a`).
    #
    #   * `instance-type` - The instance type (for example, `c4.large`).
    #
    #   * `network-platform` - The network platform (`EC2-Classic` or
    #     `EC2-VPC`).
    #
    #   * `platform` - The platform (`Linux/UNIX` or `Windows`).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. This value
    #   can be between 5 and 300. The default value is 100. To retrieve the
    #   remaining results, make another call with the returned `NextToken`
    #   value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next set of results.
    #   @return [String]
    #
    # @!attribute [rw] scheduled_instance_ids
    #   The Scheduled Instance IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] slot_start_time_range
    #   The time period for the first schedule to start.
    #   @return [Types::SlotStartTimeRangeRequest]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeScheduledInstancesRequest AWS API Documentation
    #
    class DescribeScheduledInstancesRequest < Struct.new(
      :dry_run,
      :filters,
      :max_results,
      :next_token,
      :scheduled_instance_ids,
      :slot_start_time_range)
      include Aws::Structure
    end

    # Contains the output of DescribeScheduledInstances.
    #
    # @!attribute [rw] next_token
    #   The token required to retrieve the next set of results. This value
    #   is `null` when there are no more results to return.
    #   @return [String]
    #
    # @!attribute [rw] scheduled_instance_set
    #   Information about the Scheduled Instances.
    #   @return [Array<Types::ScheduledInstance>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeScheduledInstancesResult AWS API Documentation
    #
    class DescribeScheduledInstancesResult < Struct.new(
      :next_token,
      :scheduled_instance_set)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeSecurityGroupReferencesRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         group_id: ["SecurityGroupId"], # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] group_id
    #   The IDs of the security groups in your account.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSecurityGroupReferencesRequest AWS API Documentation
    #
    class DescribeSecurityGroupReferencesRequest < Struct.new(
      :dry_run,
      :group_id)
      include Aws::Structure
    end

    # @!attribute [rw] security_group_reference_set
    #   Information about the VPCs with the referencing security groups.
    #   @return [Array<Types::SecurityGroupReference>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSecurityGroupReferencesResult AWS API Documentation
    #
    class DescribeSecurityGroupReferencesResult < Struct.new(
      :security_group_reference_set)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeSecurityGroupsRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         group_ids: ["String"],
    #         group_names: ["SecurityGroupName"],
    #         dry_run: false,
    #         next_token: "String",
    #         max_results: 1,
    #       }
    #
    # @!attribute [rw] filters
    #   The filters. If using multiple filters for rules, the results
    #   include security groups for which any combination of rules - not
    #   necessarily a single rule - match all filters.
    #
    #   * `description` - The description of the security group.
    #
    #   * `egress.ip-permission.cidr` - An IPv4 CIDR block for an outbound
    #     security group rule.
    #
    #   * `egress.ip-permission.from-port` - For an outbound rule, the start
    #     of port range for the TCP and UDP protocols, or an ICMP type
    #     number.
    #
    #   * `egress.ip-permission.group-id` - The ID of a security group that
    #     has been referenced in an outbound security group rule.
    #
    #   * `egress.ip-permission.group-name` - The name of a security group
    #     that has been referenced in an outbound security group rule.
    #
    #   * `egress.ip-permission.ipv6-cidr` - An IPv6 CIDR block for an
    #     outbound security group rule.
    #
    #   * `egress.ip-permission.prefix-list-id` - The ID (prefix) of the AWS
    #     service to which a security group rule allows outbound access.
    #
    #   * `egress.ip-permission.protocol` - The IP protocol for an outbound
    #     security group rule (`tcp` \| `udp` \| `icmp` or a protocol
    #     number).
    #
    #   * `egress.ip-permission.to-port` - For an outbound rule, the end of
    #     port range for the TCP and UDP protocols, or an ICMP code.
    #
    #   * `egress.ip-permission.user-id` - The ID of an AWS account that has
    #     been referenced in an outbound security group rule.
    #
    #   * `group-id` - The ID of the security group.
    #
    #   * `group-name` - The name of the security group.
    #
    #   * `ip-permission.cidr` - An IPv4 CIDR block for an inbound security
    #     group rule.
    #
    #   * `ip-permission.from-port` - For an inbound rule, the start of port
    #     range for the TCP and UDP protocols, or an ICMP type number.
    #
    #   * `ip-permission.group-id` - The ID of a security group that has
    #     been referenced in an inbound security group rule.
    #
    #   * `ip-permission.group-name` - The name of a security group that has
    #     been referenced in an inbound security group rule.
    #
    #   * `ip-permission.ipv6-cidr` - An IPv6 CIDR block for an inbound
    #     security group rule.
    #
    #   * `ip-permission.prefix-list-id` - The ID (prefix) of the AWS
    #     service from which a security group rule allows inbound access.
    #
    #   * `ip-permission.protocol` - The IP protocol for an inbound security
    #     group rule (`tcp` \| `udp` \| `icmp` or a protocol number).
    #
    #   * `ip-permission.to-port` - For an inbound rule, the end of port
    #     range for the TCP and UDP protocols, or an ICMP code.
    #
    #   * `ip-permission.user-id` - The ID of an AWS account that has been
    #     referenced in an inbound security group rule.
    #
    #   * `owner-id` - The AWS account ID of the owner of the security
    #     group.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `vpc-id` - The ID of the VPC specified when the security group was
    #     created.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] group_ids
    #   The IDs of the security groups. Required for security groups in a
    #   nondefault VPC.
    #
    #   Default: Describes all your security groups.
    #   @return [Array<String>]
    #
    # @!attribute [rw] group_names
    #   \[EC2-Classic and default VPC only\] The names of the security
    #   groups. You can specify either the security group name or the
    #   security group ID. For security groups in a nondefault VPC, use the
    #   `group-name` filter to describe security groups by name.
    #
    #   Default: Describes all your security groups.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] next_token
    #   The token to request the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. To
    #   retrieve the remaining results, make another request with the
    #   returned `NextToken` value. This value can be between 5 and 1000. If
    #   this parameter is not specified, then all results are returned.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSecurityGroupsRequest AWS API Documentation
    #
    class DescribeSecurityGroupsRequest < Struct.new(
      :filters,
      :group_ids,
      :group_names,
      :dry_run,
      :next_token,
      :max_results)
      include Aws::Structure
    end

    # @!attribute [rw] security_groups
    #   Information about the security groups.
    #   @return [Array<Types::SecurityGroup>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSecurityGroupsResult AWS API Documentation
    #
    class DescribeSecurityGroupsResult < Struct.new(
      :security_groups,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeSnapshotAttributeRequest
    #   data as a hash:
    #
    #       {
    #         attribute: "productCodes", # required, accepts productCodes, createVolumePermission
    #         snapshot_id: "SnapshotId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] attribute
    #   The snapshot attribute you would like to view.
    #   @return [String]
    #
    # @!attribute [rw] snapshot_id
    #   The ID of the EBS snapshot.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSnapshotAttributeRequest AWS API Documentation
    #
    class DescribeSnapshotAttributeRequest < Struct.new(
      :attribute,
      :snapshot_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] create_volume_permissions
    #   The users and groups that have the permissions for creating volumes
    #   from the snapshot.
    #   @return [Array<Types::CreateVolumePermission>]
    #
    # @!attribute [rw] product_codes
    #   The product codes.
    #   @return [Array<Types::ProductCode>]
    #
    # @!attribute [rw] snapshot_id
    #   The ID of the EBS snapshot.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSnapshotAttributeResult AWS API Documentation
    #
    class DescribeSnapshotAttributeResult < Struct.new(
      :create_volume_permissions,
      :product_codes,
      :snapshot_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeSnapshotsRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         owner_ids: ["String"],
    #         restorable_by_user_ids: ["String"],
    #         snapshot_ids: ["SnapshotId"],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `description` - A description of the snapshot.
    #
    #   * `encrypted` - Indicates whether the snapshot is encrypted (`true`
    #     \| `false`)
    #
    #   * `owner-alias` - Value from an Amazon-maintained list (`amazon` \|
    #     `self` \| `all` \| `aws-marketplace` \| `microsoft`) of snapshot
    #     owners. Not to be confused with the user-configured AWS account
    #     alias, which is set from the IAM console.
    #
    #   * `owner-id` - The ID of the AWS account that owns the snapshot.
    #
    #   * `progress` - The progress of the snapshot, as a percentage (for
    #     example, 80%).
    #
    #   * `snapshot-id` - The snapshot ID.
    #
    #   * `start-time` - The time stamp when the snapshot was initiated.
    #
    #   * `status` - The status of the snapshot (`pending` \| `completed` \|
    #     `error`).
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `volume-id` - The ID of the volume the snapshot is for.
    #
    #   * `volume-size` - The size of the volume, in GiB.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of snapshot results returned by
    #   `DescribeSnapshots` in paginated output. When this parameter is
    #   used, `DescribeSnapshots` only returns `MaxResults` results in a
    #   single page along with a `NextToken` response element. The remaining
    #   results of the initial request can be seen by sending another
    #   `DescribeSnapshots` request with the returned `NextToken` value.
    #   This value can be between 5 and 1000; if `MaxResults` is given a
    #   value larger than 1000, only 1000 results are returned. If this
    #   parameter is not used, then `DescribeSnapshots` returns all results.
    #   You cannot specify this parameter and the snapshot IDs parameter in
    #   the same request.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The `NextToken` value returned from a previous paginated
    #   `DescribeSnapshots` request where `MaxResults` was used and the
    #   results exceeded the value of that parameter. Pagination continues
    #   from the end of the previous results that returned the `NextToken`
    #   value. This value is `null` when there are no more results to
    #   return.
    #   @return [String]
    #
    # @!attribute [rw] owner_ids
    #   Describes the snapshots owned by these owners.
    #   @return [Array<String>]
    #
    # @!attribute [rw] restorable_by_user_ids
    #   The IDs of the AWS accounts that can create volumes from the
    #   snapshot.
    #   @return [Array<String>]
    #
    # @!attribute [rw] snapshot_ids
    #   The snapshot IDs.
    #
    #   Default: Describes the snapshots for which you have create volume
    #   permissions.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSnapshotsRequest AWS API Documentation
    #
    class DescribeSnapshotsRequest < Struct.new(
      :filters,
      :max_results,
      :next_token,
      :owner_ids,
      :restorable_by_user_ids,
      :snapshot_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] snapshots
    #   Information about the snapshots.
    #   @return [Array<Types::Snapshot>]
    #
    # @!attribute [rw] next_token
    #   The `NextToken` value to include in a future `DescribeSnapshots`
    #   request. When the results of a `DescribeSnapshots` request exceed
    #   `MaxResults`, this value can be used to retrieve the next page of
    #   results. This value is `null` when there are no more results to
    #   return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSnapshotsResult AWS API Documentation
    #
    class DescribeSnapshotsResult < Struct.new(
      :snapshots,
      :next_token)
      include Aws::Structure
    end

    # Contains the parameters for DescribeSpotDatafeedSubscription.
    #
    # @note When making an API call, you may pass DescribeSpotDatafeedSubscriptionRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSpotDatafeedSubscriptionRequest AWS API Documentation
    #
    class DescribeSpotDatafeedSubscriptionRequest < Struct.new(
      :dry_run)
      include Aws::Structure
    end

    # Contains the output of DescribeSpotDatafeedSubscription.
    #
    # @!attribute [rw] spot_datafeed_subscription
    #   The Spot Instance data feed subscription.
    #   @return [Types::SpotDatafeedSubscription]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSpotDatafeedSubscriptionResult AWS API Documentation
    #
    class DescribeSpotDatafeedSubscriptionResult < Struct.new(
      :spot_datafeed_subscription)
      include Aws::Structure
    end

    # Contains the parameters for DescribeSpotFleetInstances.
    #
    # @note When making an API call, you may pass DescribeSpotFleetInstancesRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         max_results: 1,
    #         next_token: "String",
    #         spot_fleet_request_id: "SpotFleetRequestId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. Specify a
    #   value between 1 and 1000. The default value is 1000. To retrieve the
    #   remaining results, make another call with the returned `NextToken`
    #   value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next set of results.
    #   @return [String]
    #
    # @!attribute [rw] spot_fleet_request_id
    #   The ID of the Spot Fleet request.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSpotFleetInstancesRequest AWS API Documentation
    #
    class DescribeSpotFleetInstancesRequest < Struct.new(
      :dry_run,
      :max_results,
      :next_token,
      :spot_fleet_request_id)
      include Aws::Structure
    end

    # Contains the output of DescribeSpotFleetInstances.
    #
    # @!attribute [rw] active_instances
    #   The running instances. This list is refreshed periodically and might
    #   be out of date.
    #   @return [Array<Types::ActiveInstance>]
    #
    # @!attribute [rw] next_token
    #   The token required to retrieve the next set of results. This value
    #   is `null` when there are no more results to return.
    #   @return [String]
    #
    # @!attribute [rw] spot_fleet_request_id
    #   The ID of the Spot Fleet request.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSpotFleetInstancesResponse AWS API Documentation
    #
    class DescribeSpotFleetInstancesResponse < Struct.new(
      :active_instances,
      :next_token,
      :spot_fleet_request_id)
      include Aws::Structure
    end

    # Contains the parameters for DescribeSpotFleetRequestHistory.
    #
    # @note When making an API call, you may pass DescribeSpotFleetRequestHistoryRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         event_type: "instanceChange", # accepts instanceChange, fleetRequestChange, error, information
    #         max_results: 1,
    #         next_token: "String",
    #         spot_fleet_request_id: "SpotFleetRequestId", # required
    #         start_time: Time.now, # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] event_type
    #   The type of events to describe. By default, all events are
    #   described.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. Specify a
    #   value between 1 and 1000. The default value is 1000. To retrieve the
    #   remaining results, make another call with the returned `NextToken`
    #   value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next set of results.
    #   @return [String]
    #
    # @!attribute [rw] spot_fleet_request_id
    #   The ID of the Spot Fleet request.
    #   @return [String]
    #
    # @!attribute [rw] start_time
    #   The starting date and time for the events, in UTC format (for
    #   example, *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z).
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSpotFleetRequestHistoryRequest AWS API Documentation
    #
    class DescribeSpotFleetRequestHistoryRequest < Struct.new(
      :dry_run,
      :event_type,
      :max_results,
      :next_token,
      :spot_fleet_request_id,
      :start_time)
      include Aws::Structure
    end

    # Contains the output of DescribeSpotFleetRequestHistory.
    #
    # @!attribute [rw] history_records
    #   Information about the events in the history of the Spot Fleet
    #   request.
    #   @return [Array<Types::HistoryRecord>]
    #
    # @!attribute [rw] last_evaluated_time
    #   The last date and time for the events, in UTC format (for example,
    #   *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z). All records up to this time
    #   were retrieved.
    #
    #   If `nextToken` indicates that there are more results, this value is
    #   not present.
    #   @return [Time]
    #
    # @!attribute [rw] next_token
    #   The token required to retrieve the next set of results. This value
    #   is `null` when there are no more results to return.
    #   @return [String]
    #
    # @!attribute [rw] spot_fleet_request_id
    #   The ID of the Spot Fleet request.
    #   @return [String]
    #
    # @!attribute [rw] start_time
    #   The starting date and time for the events, in UTC format (for
    #   example, *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z).
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSpotFleetRequestHistoryResponse AWS API Documentation
    #
    class DescribeSpotFleetRequestHistoryResponse < Struct.new(
      :history_records,
      :last_evaluated_time,
      :next_token,
      :spot_fleet_request_id,
      :start_time)
      include Aws::Structure
    end

    # Contains the parameters for DescribeSpotFleetRequests.
    #
    # @note When making an API call, you may pass DescribeSpotFleetRequestsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         max_results: 1,
    #         next_token: "String",
    #         spot_fleet_request_ids: ["SpotFleetRequestId"],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. Specify a
    #   value between 1 and 1000. The default value is 1000. To retrieve the
    #   remaining results, make another call with the returned `NextToken`
    #   value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next set of results.
    #   @return [String]
    #
    # @!attribute [rw] spot_fleet_request_ids
    #   The IDs of the Spot Fleet requests.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSpotFleetRequestsRequest AWS API Documentation
    #
    class DescribeSpotFleetRequestsRequest < Struct.new(
      :dry_run,
      :max_results,
      :next_token,
      :spot_fleet_request_ids)
      include Aws::Structure
    end

    # Contains the output of DescribeSpotFleetRequests.
    #
    # @!attribute [rw] next_token
    #   The token required to retrieve the next set of results. This value
    #   is `null` when there are no more results to return.
    #   @return [String]
    #
    # @!attribute [rw] spot_fleet_request_configs
    #   Information about the configuration of your Spot Fleet.
    #   @return [Array<Types::SpotFleetRequestConfig>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSpotFleetRequestsResponse AWS API Documentation
    #
    class DescribeSpotFleetRequestsResponse < Struct.new(
      :next_token,
      :spot_fleet_request_configs)
      include Aws::Structure
    end

    # Contains the parameters for DescribeSpotInstanceRequests.
    #
    # @note When making an API call, you may pass DescribeSpotInstanceRequestsRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #         spot_instance_request_ids: ["SpotInstanceRequestId"],
    #         next_token: "String",
    #         max_results: 1,
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `availability-zone-group` - The Availability Zone group.
    #
    #   * `create-time` - The time stamp when the Spot Instance request was
    #     created.
    #
    #   * `fault-code` - The fault code related to the request.
    #
    #   * `fault-message` - The fault message related to the request.
    #
    #   * `instance-id` - The ID of the instance that fulfilled the request.
    #
    #   * `launch-group` - The Spot Instance launch group.
    #
    #   * `launch.block-device-mapping.delete-on-termination` - Indicates
    #     whether the EBS volume is deleted on instance termination.
    #
    #   * `launch.block-device-mapping.device-name` - The device name for
    #     the volume in the block device mapping (for example, `/dev/sdh` or
    #     `xvdh`).
    #
    #   * `launch.block-device-mapping.snapshot-id` - The ID of the snapshot
    #     for the EBS volume.
    #
    #   * `launch.block-device-mapping.volume-size` - The size of the EBS
    #     volume, in GiB.
    #
    #   * `launch.block-device-mapping.volume-type` - The type of EBS
    #     volume: `gp2` for General Purpose SSD, `io1` for Provisioned IOPS
    #     SSD, `st1` for Throughput Optimized HDD, `sc1`for Cold HDD, or
    #     `standard` for Magnetic.
    #
    #   * `launch.group-id` - The ID of the security group for the instance.
    #
    #   * `launch.group-name` - The name of the security group for the
    #     instance.
    #
    #   * `launch.image-id` - The ID of the AMI.
    #
    #   * `launch.instance-type` - The type of instance (for example,
    #     `m3.medium`).
    #
    #   * `launch.kernel-id` - The kernel ID.
    #
    #   * `launch.key-name` - The name of the key pair the instance launched
    #     with.
    #
    #   * `launch.monitoring-enabled` - Whether detailed monitoring is
    #     enabled for the Spot Instance.
    #
    #   * `launch.ramdisk-id` - The RAM disk ID.
    #
    #   * `launched-availability-zone` - The Availability Zone in which the
    #     request is launched.
    #
    #   * `network-interface.addresses.primary` - Indicates whether the IP
    #     address is the primary private IP address.
    #
    #   * `network-interface.delete-on-termination` - Indicates whether the
    #     network interface is deleted when the instance is terminated.
    #
    #   * `network-interface.description` - A description of the network
    #     interface.
    #
    #   * `network-interface.device-index` - The index of the device for the
    #     network interface attachment on the instance.
    #
    #   * `network-interface.group-id` - The ID of the security group
    #     associated with the network interface.
    #
    #   * `network-interface.network-interface-id` - The ID of the network
    #     interface.
    #
    #   * `network-interface.private-ip-address` - The primary private IP
    #     address of the network interface.
    #
    #   * `network-interface.subnet-id` - The ID of the subnet for the
    #     instance.
    #
    #   * `product-description` - The product description associated with
    #     the instance (`Linux/UNIX` \| `Windows`).
    #
    #   * `spot-instance-request-id` - The Spot Instance request ID.
    #
    #   * `spot-price` - The maximum hourly price for any Spot Instance
    #     launched to fulfill the request.
    #
    #   * `state` - The state of the Spot Instance request (`open` \|
    #     `active` \| `closed` \| `cancelled` \| `failed`). Spot request
    #     status information can help you track your Amazon EC2 Spot
    #     Instance requests. For more information, see [Spot Request
    #     Status][1] in the *Amazon EC2 User Guide for Linux Instances*.
    #
    #   * `status-code` - The short code describing the most recent
    #     evaluation of your Spot Instance request.
    #
    #   * `status-message` - The message explaining the status of the Spot
    #     Instance request.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `type` - The type of Spot Instance request (`one-time` \|
    #     `persistent`).
    #
    #   * `valid-from` - The start date of the request.
    #
    #   * `valid-until` - The end date of the request.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] spot_instance_request_ids
    #   One or more Spot Instance request IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] next_token
    #   The token to request the next set of results. This value is `null`
    #   when there are no more results to return.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. Specify a
    #   value between 5 and 1000. To retrieve the remaining results, make
    #   another call with the returned `NextToken` value.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSpotInstanceRequestsRequest AWS API Documentation
    #
    class DescribeSpotInstanceRequestsRequest < Struct.new(
      :filters,
      :dry_run,
      :spot_instance_request_ids,
      :next_token,
      :max_results)
      include Aws::Structure
    end

    # Contains the output of DescribeSpotInstanceRequests.
    #
    # @!attribute [rw] spot_instance_requests
    #   One or more Spot Instance requests.
    #   @return [Array<Types::SpotInstanceRequest>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next set of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSpotInstanceRequestsResult AWS API Documentation
    #
    class DescribeSpotInstanceRequestsResult < Struct.new(
      :spot_instance_requests,
      :next_token)
      include Aws::Structure
    end

    # Contains the parameters for DescribeSpotPriceHistory.
    #
    # @note When making an API call, you may pass DescribeSpotPriceHistoryRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         availability_zone: "String",
    #         dry_run: false,
    #         end_time: Time.now,
    #         instance_types: ["t1.micro"], # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #         max_results: 1,
    #         next_token: "String",
    #         product_descriptions: ["String"],
    #         start_time: Time.now,
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `availability-zone` - The Availability Zone for which prices
    #     should be returned.
    #
    #   * `instance-type` - The type of instance (for example, `m3.medium`).
    #
    #   * `product-description` - The product description for the Spot price
    #     (`Linux/UNIX` \| `SUSE Linux` \| `Windows` \| `Linux/UNIX (Amazon
    #     VPC)` \| `SUSE Linux (Amazon VPC)` \| `Windows (Amazon VPC)`).
    #
    #   * `spot-price` - The Spot price. The value must match exactly (or
    #     use wildcards; greater than or less than comparison is not
    #     supported).
    #
    #   * `timestamp` - The time stamp of the Spot price history, in UTC
    #     format (for example, *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z). You can
    #     use wildcards (* and ?). Greater than or less than comparison is
    #     not supported.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] availability_zone
    #   Filters the results by the specified Availability Zone.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] end_time
    #   The date and time, up to the current date, from which to stop
    #   retrieving the price history data, in UTC format (for example,
    #   *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z).
    #   @return [Time]
    #
    # @!attribute [rw] instance_types
    #   Filters the results by the specified instance types.
    #   @return [Array<String>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. Specify a
    #   value between 1 and 1000. The default value is 1000. To retrieve the
    #   remaining results, make another call with the returned `NextToken`
    #   value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next set of results.
    #   @return [String]
    #
    # @!attribute [rw] product_descriptions
    #   Filters the results by the specified basic product descriptions.
    #   @return [Array<String>]
    #
    # @!attribute [rw] start_time
    #   The date and time, up to the past 90 days, from which to start
    #   retrieving the price history data, in UTC format (for example,
    #   *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z).
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSpotPriceHistoryRequest AWS API Documentation
    #
    class DescribeSpotPriceHistoryRequest < Struct.new(
      :filters,
      :availability_zone,
      :dry_run,
      :end_time,
      :instance_types,
      :max_results,
      :next_token,
      :product_descriptions,
      :start_time)
      include Aws::Structure
    end

    # Contains the output of DescribeSpotPriceHistory.
    #
    # @!attribute [rw] next_token
    #   The token required to retrieve the next set of results. This value
    #   is null or an empty string when there are no more results to return.
    #   @return [String]
    #
    # @!attribute [rw] spot_price_history
    #   The historical Spot prices.
    #   @return [Array<Types::SpotPrice>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSpotPriceHistoryResult AWS API Documentation
    #
    class DescribeSpotPriceHistoryResult < Struct.new(
      :next_token,
      :spot_price_history)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeStaleSecurityGroupsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         max_results: 1,
    #         next_token: "DescribeStaleSecurityGroupsNextToken",
    #         vpc_id: "VpcId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] max_results
    #   The maximum number of items to return for this request. The request
    #   returns a token that you can specify in a subsequent call to get the
    #   next set of results.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next set of items to return. (You received this
    #   token from a prior call.)
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeStaleSecurityGroupsRequest AWS API Documentation
    #
    class DescribeStaleSecurityGroupsRequest < Struct.new(
      :dry_run,
      :max_results,
      :next_token,
      :vpc_id)
      include Aws::Structure
    end

    # @!attribute [rw] next_token
    #   The token to use when requesting the next set of items. If there are
    #   no additional items to return, the string is empty.
    #   @return [String]
    #
    # @!attribute [rw] stale_security_group_set
    #   Information about the stale security groups.
    #   @return [Array<Types::StaleSecurityGroup>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeStaleSecurityGroupsResult AWS API Documentation
    #
    class DescribeStaleSecurityGroupsResult < Struct.new(
      :next_token,
      :stale_security_group_set)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeSubnetsRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         subnet_ids: ["SubnetId"],
    #         dry_run: false,
    #         next_token: "String",
    #         max_results: 1,
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `availability-zone` - The Availability Zone for the subnet. You
    #     can also use `availabilityZone` as the filter name.
    #
    #   * `availability-zone-id` - The ID of the Availability Zone for the
    #     subnet. You can also use `availabilityZoneId` as the filter name.
    #
    #   * `available-ip-address-count` - The number of IPv4 addresses in the
    #     subnet that are available.
    #
    #   * `cidr-block` - The IPv4 CIDR block of the subnet. The CIDR block
    #     you specify must exactly match the subnet's CIDR block for
    #     information to be returned for the subnet. You can also use `cidr`
    #     or `cidrBlock` as the filter names.
    #
    #   * `default-for-az` - Indicates whether this is the default subnet
    #     for the Availability Zone. You can also use `defaultForAz` as the
    #     filter name.
    #
    #   * `ipv6-cidr-block-association.ipv6-cidr-block` - An IPv6 CIDR block
    #     associated with the subnet.
    #
    #   * `ipv6-cidr-block-association.association-id` - An association ID
    #     for an IPv6 CIDR block associated with the subnet.
    #
    #   * `ipv6-cidr-block-association.state` - The state of an IPv6 CIDR
    #     block associated with the subnet.
    #
    #   * `owner-id` - The ID of the AWS account that owns the subnet.
    #
    #   * `state` - The state of the subnet (`pending` \| `available`).
    #
    #   * `subnet-arn` - The Amazon Resource Name (ARN) of the subnet.
    #
    #   * `subnet-id` - The ID of the subnet.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `vpc-id` - The ID of the VPC for the subnet.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] subnet_ids
    #   One or more subnet IDs.
    #
    #   Default: Describes all your subnets.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSubnetsRequest AWS API Documentation
    #
    class DescribeSubnetsRequest < Struct.new(
      :filters,
      :subnet_ids,
      :dry_run,
      :next_token,
      :max_results)
      include Aws::Structure
    end

    # @!attribute [rw] subnets
    #   Information about one or more subnets.
    #   @return [Array<Types::Subnet>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeSubnetsResult AWS API Documentation
    #
    class DescribeSubnetsResult < Struct.new(
      :subnets,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeTagsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `key` - The tag key.
    #
    #   * `resource-id` - The ID of the resource.
    #
    #   * `resource-type` - The resource type (`customer-gateway` \|
    #     `dedicated-host` \| `dhcp-options` \| `elastic-ip` \| `fleet` \|
    #     `fpga-image` \| `host-reservation` \| `image` \| `instance` \|
    #     `internet-gateway` \| `key-pair` \| `launch-template` \|
    #     `natgateway` \| `network-acl` \| `network-interface` \|
    #     `placement-group` \| `reserved-instances` \| `route-table` \|
    #     `security-group` \| `snapshot` \| `spot-instances-request` \|
    #     `subnet` \| `volume` \| `vpc` \| `vpc-endpoint` \|
    #     `vpc-endpoint-service` \| `vpc-peering-connection` \|
    #     `vpn-connection` \| `vpn-gateway`).
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of the tag. For
    #     example, specify "tag:Owner" for the filter name and "TeamA"
    #     for the filter value to find resources with the tag
    #     "Owner=TeamA".
    #
    #   * `value` - The tag value.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. This value
    #   can be between 5 and 1000. To retrieve the remaining results, make
    #   another call with the returned `NextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTagsRequest AWS API Documentation
    #
    class DescribeTagsRequest < Struct.new(
      :dry_run,
      :filters,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags.
    #   @return [Array<Types::TagDescription>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTagsResult AWS API Documentation
    #
    class DescribeTagsResult < Struct.new(
      :next_token,
      :tags)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeTrafficMirrorFiltersRequest
    #   data as a hash:
    #
    #       {
    #         traffic_mirror_filter_ids: ["TrafficMirrorFilterId"],
    #         dry_run: false,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "NextToken",
    #       }
    #
    # @!attribute [rw] traffic_mirror_filter_ids
    #   The ID of the Traffic Mirror filter.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] filters
    #   One or more filters. The possible values are:
    #
    #   * `description`\: The Traffic Mirror filter description.
    #
    #   * `traffic-mirror-filter-id`\: The ID of the Traffic Mirror filter.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTrafficMirrorFiltersRequest AWS API Documentation
    #
    class DescribeTrafficMirrorFiltersRequest < Struct.new(
      :traffic_mirror_filter_ids,
      :dry_run,
      :filters,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] traffic_mirror_filters
    #   Information about one or more Traffic Mirror filters.
    #   @return [Array<Types::TrafficMirrorFilter>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. The value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTrafficMirrorFiltersResult AWS API Documentation
    #
    class DescribeTrafficMirrorFiltersResult < Struct.new(
      :traffic_mirror_filters,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeTrafficMirrorSessionsRequest
    #   data as a hash:
    #
    #       {
    #         traffic_mirror_session_ids: ["TrafficMirrorSessionId"],
    #         dry_run: false,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "NextToken",
    #       }
    #
    # @!attribute [rw] traffic_mirror_session_ids
    #   The ID of the Traffic Mirror session.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] filters
    #   One or more filters. The possible values are:
    #
    #   * `description`\: The Traffic Mirror session description.
    #
    #   * `network-interface-id`\: The ID of the Traffic Mirror session
    #     network interface.
    #
    #   * `owner-id`\: The ID of the account that owns the Traffic Mirror
    #     session.
    #
    #   * `packet-length`\: The assigned number of packets to mirror.
    #
    #   * `session-number`\: The assigned session number.
    #
    #   * `traffic-mirror-filter-id`\: The ID of the Traffic Mirror filter.
    #
    #   * `traffic-mirror-session-id`\: The ID of the Traffic Mirror
    #     session.
    #
    #   * `traffic-mirror-target-id`\: The ID of the Traffic Mirror target.
    #
    #   * `virtual-network-id`\: The virtual network ID of the Traffic
    #     Mirror session.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTrafficMirrorSessionsRequest AWS API Documentation
    #
    class DescribeTrafficMirrorSessionsRequest < Struct.new(
      :traffic_mirror_session_ids,
      :dry_run,
      :filters,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] traffic_mirror_sessions
    #   Describes one or more Traffic Mirror sessions. By default, all
    #   Traffic Mirror sessions are described. Alternatively, you can filter
    #   the results.
    #   @return [Array<Types::TrafficMirrorSession>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. The value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTrafficMirrorSessionsResult AWS API Documentation
    #
    class DescribeTrafficMirrorSessionsResult < Struct.new(
      :traffic_mirror_sessions,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeTrafficMirrorTargetsRequest
    #   data as a hash:
    #
    #       {
    #         traffic_mirror_target_ids: ["TrafficMirrorTargetId"],
    #         dry_run: false,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "NextToken",
    #       }
    #
    # @!attribute [rw] traffic_mirror_target_ids
    #   The ID of the Traffic Mirror targets.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] filters
    #   One or more filters. The possible values are:
    #
    #   * `description`\: The Traffic Mirror target description.
    #
    #   * `network-interface-id`\: The ID of the Traffic Mirror session
    #     network interface.
    #
    #   * `network-load-balancer-arn`\: The Amazon Resource Name (ARN) of
    #     the Network Load Balancer that is associated with the session.
    #
    #   * `owner-id`\: The ID of the account that owns the Traffic Mirror
    #     session.
    #
    #   * `traffic-mirror-target-id`\: The ID of the Traffic Mirror target.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTrafficMirrorTargetsRequest AWS API Documentation
    #
    class DescribeTrafficMirrorTargetsRequest < Struct.new(
      :traffic_mirror_target_ids,
      :dry_run,
      :filters,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] traffic_mirror_targets
    #   Information about one or more Traffic Mirror targets.
    #   @return [Array<Types::TrafficMirrorTarget>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. The value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTrafficMirrorTargetsResult AWS API Documentation
    #
    class DescribeTrafficMirrorTargetsResult < Struct.new(
      :traffic_mirror_targets,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeTransitGatewayAttachmentsRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_attachment_ids: ["TransitGatewayAttachmentId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_attachment_ids
    #   The IDs of the attachments.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters. The possible values are:
    #
    #   * `association.state` - The state of the association (`associating`
    #     \| `associated` \| `disassociating`).
    #
    #   * `association.transit-gateway-route-table-id` - The ID of the route
    #     table for the transit gateway.
    #
    #   * `resource-id` - The ID of the resource.
    #
    #   * `resource-owner-id` - The ID of the AWS account that owns the
    #     resource.
    #
    #   * `resource-type` - The resource type (`vpc` \| `vpn`).
    #
    #   * `state` - The state of the attachment (`available` \| `deleted` \|
    #     `deleting` \| `failed` \| `modifying` \| `pendingAcceptance` \|
    #     `pending` \| `rollingBack` \| `rejected` \| `rejecting`).
    #
    #   * `transit-gateway-attachment-id` - The ID of the attachment.
    #
    #   * `transit-gateway-id` - The ID of the transit gateway.
    #
    #   * `transit-gateway-owner-id` - The ID of the AWS account that owns
    #     the transit gateway.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTransitGatewayAttachmentsRequest AWS API Documentation
    #
    class DescribeTransitGatewayAttachmentsRequest < Struct.new(
      :transit_gateway_attachment_ids,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_attachments
    #   Information about the attachments.
    #   @return [Array<Types::TransitGatewayAttachment>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTransitGatewayAttachmentsResult AWS API Documentation
    #
    class DescribeTransitGatewayAttachmentsResult < Struct.new(
      :transit_gateway_attachments,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeTransitGatewayMulticastDomainsRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_multicast_domain_ids: ["TransitGatewayMulticastDomainId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_multicast_domain_ids
    #   The ID of the transit gateway multicast domain.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters. The possible values are:
    #
    #   * `state` - The state of the transit gateway multicast domain. Valid
    #     values are `pending` \| `available` \| `deleting` \| `deleted`.
    #
    #   * `transit-gateway-id` - The ID of the transit gateway.
    #
    #   * `transit-gateway-multicast-domain-id` - The ID of the transit
    #     gateway multicast domain.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTransitGatewayMulticastDomainsRequest AWS API Documentation
    #
    class DescribeTransitGatewayMulticastDomainsRequest < Struct.new(
      :transit_gateway_multicast_domain_ids,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_multicast_domains
    #   Information about the transit gateway multicast domains.
    #   @return [Array<Types::TransitGatewayMulticastDomain>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTransitGatewayMulticastDomainsResult AWS API Documentation
    #
    class DescribeTransitGatewayMulticastDomainsResult < Struct.new(
      :transit_gateway_multicast_domains,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeTransitGatewayPeeringAttachmentsRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_attachment_ids: ["TransitGatewayAttachmentId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_attachment_ids
    #   One or more IDs of the transit gateway peering attachments.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters. The possible values are:
    #
    #   * `transit-gateway-attachment-id` - The ID of the transit gateway
    #     attachment.
    #
    #   * `local-owner-id` - The ID of your AWS account.
    #
    #   * `remote-owner-id` - The ID of the AWS account in the remote Region
    #     that owns the transit gateway.
    #
    #   * `state` - The state of the peering attachment (`available` \|
    #     `deleted` \| `deleting` \| `failed` \| `modifying` \|
    #     `pendingAcceptance` \| `pending` \| `rollingBack` \| `rejected` \|
    #     `rejecting`).
    #
    #   * `transit-gateway-id` - The ID of the transit gateway.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTransitGatewayPeeringAttachmentsRequest AWS API Documentation
    #
    class DescribeTransitGatewayPeeringAttachmentsRequest < Struct.new(
      :transit_gateway_attachment_ids,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_peering_attachments
    #   The transit gateway peering attachments.
    #   @return [Array<Types::TransitGatewayPeeringAttachment>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTransitGatewayPeeringAttachmentsResult AWS API Documentation
    #
    class DescribeTransitGatewayPeeringAttachmentsResult < Struct.new(
      :transit_gateway_peering_attachments,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeTransitGatewayRouteTablesRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_route_table_ids: ["TransitGatewayRouteTableId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_route_table_ids
    #   The IDs of the transit gateway route tables.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters. The possible values are:
    #
    #   * `default-association-route-table` - Indicates whether this is the
    #     default association route table for the transit gateway (`true` \|
    #     `false`).
    #
    #   * `default-propagation-route-table` - Indicates whether this is the
    #     default propagation route table for the transit gateway (`true` \|
    #     `false`).
    #
    #   * `state` - The state of the attachment (`available` \| `deleted` \|
    #     `deleting` \| `failed` \| `modifying` \| `pendingAcceptance` \|
    #     `pending` \| `rollingBack` \| `rejected` \| `rejecting`).
    #
    #   * `transit-gateway-id` - The ID of the transit gateway.
    #
    #   * `transit-gateway-route-table-id` - The ID of the transit gateway
    #     route table.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTransitGatewayRouteTablesRequest AWS API Documentation
    #
    class DescribeTransitGatewayRouteTablesRequest < Struct.new(
      :transit_gateway_route_table_ids,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_route_tables
    #   Information about the transit gateway route tables.
    #   @return [Array<Types::TransitGatewayRouteTable>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTransitGatewayRouteTablesResult AWS API Documentation
    #
    class DescribeTransitGatewayRouteTablesResult < Struct.new(
      :transit_gateway_route_tables,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeTransitGatewayVpcAttachmentsRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_attachment_ids: ["TransitGatewayAttachmentId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_attachment_ids
    #   The IDs of the attachments.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters. The possible values are:
    #
    #   * `state` - The state of the attachment (`available` \| `deleted` \|
    #     `deleting` \| `failed` \| `modifying` \| `pendingAcceptance` \|
    #     `pending` \| `rollingBack` \| `rejected` \| `rejecting`).
    #
    #   * `transit-gateway-attachment-id` - The ID of the attachment.
    #
    #   * `transit-gateway-id` - The ID of the transit gateway.
    #
    #   * `vpc-id` - The ID of the VPC.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTransitGatewayVpcAttachmentsRequest AWS API Documentation
    #
    class DescribeTransitGatewayVpcAttachmentsRequest < Struct.new(
      :transit_gateway_attachment_ids,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_vpc_attachments
    #   Information about the VPC attachments.
    #   @return [Array<Types::TransitGatewayVpcAttachment>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTransitGatewayVpcAttachmentsResult AWS API Documentation
    #
    class DescribeTransitGatewayVpcAttachmentsResult < Struct.new(
      :transit_gateway_vpc_attachments,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeTransitGatewaysRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_ids: ["TransitGatewayId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_ids
    #   The IDs of the transit gateways.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters. The possible values are:
    #
    #   * `options.propagation-default-route-table-id` - The ID of the
    #     default propagation route table.
    #
    #   * `options.amazon-side-asn` - The private ASN for the Amazon side of
    #     a BGP session.
    #
    #   * `options.association-default-route-table-id` - The ID of the
    #     default association route table.
    #
    #   * `options.auto-accept-shared-attachments` - Indicates whether there
    #     is automatic acceptance of attachment requests (`enable` \|
    #     `disable`).
    #
    #   * `options.default-route-table-association` - Indicates whether
    #     resource attachments are automatically associated with the default
    #     association route table (`enable` \| `disable`).
    #
    #   * `options.default-route-table-propagation` - Indicates whether
    #     resource attachments automatically propagate routes to the default
    #     propagation route table (`enable` \| `disable`).
    #
    #   * `options.dns-support` - Indicates whether DNS support is enabled
    #     (`enable` \| `disable`).
    #
    #   * `options.vpn-ecmp-support` - Indicates whether Equal Cost
    #     Multipath Protocol support is enabled (`enable` \| `disable`).
    #
    #   * `owner-id` - The ID of the AWS account that owns the transit
    #     gateway.
    #
    #   * `state` - The state of the attachment (`available` \| `deleted` \|
    #     `deleting` \| `failed` \| `modifying` \| `pendingAcceptance` \|
    #     `pending` \| `rollingBack` \| `rejected` \| `rejecting`).
    #
    #   * `transit-gateway-id` - The ID of the transit gateway.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTransitGatewaysRequest AWS API Documentation
    #
    class DescribeTransitGatewaysRequest < Struct.new(
      :transit_gateway_ids,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateways
    #   Information about the transit gateways.
    #   @return [Array<Types::TransitGateway>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeTransitGatewaysResult AWS API Documentation
    #
    class DescribeTransitGatewaysResult < Struct.new(
      :transit_gateways,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeVolumeAttributeRequest
    #   data as a hash:
    #
    #       {
    #         attribute: "autoEnableIO", # required, accepts autoEnableIO, productCodes
    #         volume_id: "VolumeId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] attribute
    #   The attribute of the volume. This parameter is required.
    #   @return [String]
    #
    # @!attribute [rw] volume_id
    #   The ID of the volume.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVolumeAttributeRequest AWS API Documentation
    #
    class DescribeVolumeAttributeRequest < Struct.new(
      :attribute,
      :volume_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] auto_enable_io
    #   The state of `autoEnableIO` attribute.
    #   @return [Types::AttributeBooleanValue]
    #
    # @!attribute [rw] product_codes
    #   A list of product codes.
    #   @return [Array<Types::ProductCode>]
    #
    # @!attribute [rw] volume_id
    #   The ID of the volume.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVolumeAttributeResult AWS API Documentation
    #
    class DescribeVolumeAttributeResult < Struct.new(
      :auto_enable_io,
      :product_codes,
      :volume_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeVolumeStatusRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         volume_ids: ["VolumeId"],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `action.code` - The action code for the event (for example,
    #     `enable-volume-io`).
    #
    #   * `action.description` - A description of the action.
    #
    #   * `action.event-id` - The event ID associated with the action.
    #
    #   * `availability-zone` - The Availability Zone of the instance.
    #
    #   * `event.description` - A description of the event.
    #
    #   * `event.event-id` - The event ID.
    #
    #   * `event.event-type` - The event type (for `io-enabled`\: `passed`
    #     \| `failed`; for `io-performance`\: `io-performance:degraded` \|
    #     `io-performance:severely-degraded` \| `io-performance:stalled`).
    #
    #   * `event.not-after` - The latest end time for the event.
    #
    #   * `event.not-before` - The earliest start time for the event.
    #
    #   * `volume-status.details-name` - The cause for
    #     `volume-status.status` (`io-enabled` \| `io-performance`).
    #
    #   * `volume-status.details-status` - The status of
    #     `volume-status.details-name` (for `io-enabled`\: `passed` \|
    #     `failed`; for `io-performance`\: `normal` \| `degraded` \|
    #     `severely-degraded` \| `stalled`).
    #
    #   * `volume-status.status` - The status of the volume (`ok` \|
    #     `impaired` \| `warning` \| `insufficient-data`).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of volume results returned by
    #   `DescribeVolumeStatus` in paginated output. When this parameter is
    #   used, the request only returns `MaxResults` results in a single page
    #   along with a `NextToken` response element. The remaining results of
    #   the initial request can be seen by sending another request with the
    #   returned `NextToken` value. This value can be between 5 and 1000; if
    #   `MaxResults` is given a value larger than 1000, only 1000 results
    #   are returned. If this parameter is not used, then
    #   `DescribeVolumeStatus` returns all results. You cannot specify this
    #   parameter and the volume IDs parameter in the same request.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The `NextToken` value to include in a future `DescribeVolumeStatus`
    #   request. When the results of the request exceed `MaxResults`, this
    #   value can be used to retrieve the next page of results. This value
    #   is `null` when there are no more results to return.
    #   @return [String]
    #
    # @!attribute [rw] volume_ids
    #   The IDs of the volumes.
    #
    #   Default: Describes all your volumes.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVolumeStatusRequest AWS API Documentation
    #
    class DescribeVolumeStatusRequest < Struct.new(
      :filters,
      :max_results,
      :next_token,
      :volume_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @!attribute [rw] volume_statuses
    #   Information about the status of the volumes.
    #   @return [Array<Types::VolumeStatusItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVolumeStatusResult AWS API Documentation
    #
    class DescribeVolumeStatusResult < Struct.new(
      :next_token,
      :volume_statuses)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeVolumesModificationsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         volume_ids: ["VolumeId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         next_token: "String",
    #         max_results: 1,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] volume_ids
    #   The IDs of the volumes for which in-progress modifications will be
    #   described.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   The filters. Supported filters: `volume-id` \| `modification-state`
    #   \| `target-size` \| `target-iops` \| `target-volume-type` \|
    #   `original-size` \| `original-iops` \| `original-volume-type` \|
    #   `start-time` \| `originalMultiAttachEnabled` \|
    #   `targetMultiAttachEnabled`.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] next_token
    #   The `nextToken` value returned by a previous paginated request.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results (up to a limit of 500) to be returned
    #   in a paginated request.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVolumesModificationsRequest AWS API Documentation
    #
    class DescribeVolumesModificationsRequest < Struct.new(
      :dry_run,
      :volume_ids,
      :filters,
      :next_token,
      :max_results)
      include Aws::Structure
    end

    # @!attribute [rw] volumes_modifications
    #   Information about the volume modifications.
    #   @return [Array<Types::VolumeModification>]
    #
    # @!attribute [rw] next_token
    #   Token for pagination, null if there are no more results
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVolumesModificationsResult AWS API Documentation
    #
    class DescribeVolumesModificationsResult < Struct.new(
      :volumes_modifications,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeVolumesRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         volume_ids: ["VolumeId"],
    #         dry_run: false,
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] filters
    #   The filters.
    #
    #   * `attachment.attach-time` - The time stamp when the attachment
    #     initiated.
    #
    #   * `attachment.delete-on-termination` - Whether the volume is deleted
    #     on instance termination.
    #
    #   * `attachment.device` - The device name specified in the block
    #     device mapping (for example, `/dev/sda1`).
    #
    #   * `attachment.instance-id` - The ID of the instance the volume is
    #     attached to.
    #
    #   * `attachment.status` - The attachment state (`attaching` \|
    #     `attached` \| `detaching`).
    #
    #   * `availability-zone` - The Availability Zone in which the volume
    #     was created.
    #
    #   * `create-time` - The time stamp when the volume was created.
    #
    #   * `encrypted` - Indicates whether the volume is encrypted (`true` \|
    #     `false`)
    #
    #   * `multi-attach-enabled` - Indicates whether the volume is enabled
    #     for Multi-Attach (`true` \| `false`)
    #
    #   * `fast-restored` - Indicates whether the volume was created from a
    #     snapshot that is enabled for fast snapshot restore (`true` \|
    #     `false`).
    #
    #   * `size` - The size of the volume, in GiB.
    #
    #   * `snapshot-id` - The snapshot from which the volume was created.
    #
    #   * `status` - The status of the volume (`creating` \| `available` \|
    #     `in-use` \| `deleting` \| `deleted` \| `error`).
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `volume-id` - The volume ID.
    #
    #   * `volume-type` - The Amazon EBS volume type. This can be `gp2` for
    #     General Purpose SSD, `io1` for Provisioned IOPS SSD, `st1` for
    #     Throughput Optimized HDD, `sc1` for Cold HDD, or `standard` for
    #     Magnetic volumes.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] volume_ids
    #   The volume IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] max_results
    #   The maximum number of volume results returned by `DescribeVolumes`
    #   in paginated output. When this parameter is used, `DescribeVolumes`
    #   only returns `MaxResults` results in a single page along with a
    #   `NextToken` response element. The remaining results of the initial
    #   request can be seen by sending another `DescribeVolumes` request
    #   with the returned `NextToken` value. This value can be between 5 and
    #   500; if `MaxResults` is given a value larger than 500, only 500
    #   results are returned. If this parameter is not used, then
    #   `DescribeVolumes` returns all results. You cannot specify this
    #   parameter and the volume IDs parameter in the same request.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The `NextToken` value returned from a previous paginated
    #   `DescribeVolumes` request where `MaxResults` was used and the
    #   results exceeded the value of that parameter. Pagination continues
    #   from the end of the previous results that returned the `NextToken`
    #   value. This value is `null` when there are no more results to
    #   return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVolumesRequest AWS API Documentation
    #
    class DescribeVolumesRequest < Struct.new(
      :filters,
      :volume_ids,
      :dry_run,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] volumes
    #   Information about the volumes.
    #   @return [Array<Types::Volume>]
    #
    # @!attribute [rw] next_token
    #   The `NextToken` value to include in a future `DescribeVolumes`
    #   request. When the results of a `DescribeVolumes` request exceed
    #   `MaxResults`, this value can be used to retrieve the next page of
    #   results. This value is `null` when there are no more results to
    #   return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVolumesResult AWS API Documentation
    #
    class DescribeVolumesResult < Struct.new(
      :volumes,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeVpcAttributeRequest
    #   data as a hash:
    #
    #       {
    #         attribute: "enableDnsSupport", # required, accepts enableDnsSupport, enableDnsHostnames
    #         vpc_id: "VpcId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] attribute
    #   The VPC attribute.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcAttributeRequest AWS API Documentation
    #
    class DescribeVpcAttributeRequest < Struct.new(
      :attribute,
      :vpc_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] enable_dns_hostnames
    #   Indicates whether the instances launched in the VPC get DNS
    #   hostnames. If this attribute is `true`, instances in the VPC get DNS
    #   hostnames; otherwise, they do not.
    #   @return [Types::AttributeBooleanValue]
    #
    # @!attribute [rw] enable_dns_support
    #   Indicates whether DNS resolution is enabled for the VPC. If this
    #   attribute is `true`, the Amazon DNS server resolves DNS hostnames
    #   for your instances to their corresponding IP addresses; otherwise,
    #   it does not.
    #   @return [Types::AttributeBooleanValue]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcAttributeResult AWS API Documentation
    #
    class DescribeVpcAttributeResult < Struct.new(
      :vpc_id,
      :enable_dns_hostnames,
      :enable_dns_support)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeVpcClassicLinkDnsSupportRequest
    #   data as a hash:
    #
    #       {
    #         max_results: 1,
    #         next_token: "DescribeVpcClassicLinkDnsSupportNextToken",
    #         vpc_ids: ["VpcId"],
    #       }
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] vpc_ids
    #   One or more VPC IDs.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcClassicLinkDnsSupportRequest AWS API Documentation
    #
    class DescribeVpcClassicLinkDnsSupportRequest < Struct.new(
      :max_results,
      :next_token,
      :vpc_ids)
      include Aws::Structure
    end

    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @!attribute [rw] vpcs
    #   Information about the ClassicLink DNS support status of the VPCs.
    #   @return [Array<Types::ClassicLinkDnsSupport>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcClassicLinkDnsSupportResult AWS API Documentation
    #
    class DescribeVpcClassicLinkDnsSupportResult < Struct.new(
      :next_token,
      :vpcs)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeVpcClassicLinkRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #         vpc_ids: ["VpcId"],
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `is-classic-link-enabled` - Whether the VPC is enabled for
    #     ClassicLink (`true` \| `false`).
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] vpc_ids
    #   One or more VPCs for which you want to describe the ClassicLink
    #   status.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcClassicLinkRequest AWS API Documentation
    #
    class DescribeVpcClassicLinkRequest < Struct.new(
      :filters,
      :dry_run,
      :vpc_ids)
      include Aws::Structure
    end

    # @!attribute [rw] vpcs
    #   The ClassicLink status of one or more VPCs.
    #   @return [Array<Types::VpcClassicLink>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcClassicLinkResult AWS API Documentation
    #
    class DescribeVpcClassicLinkResult < Struct.new(
      :vpcs)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeVpcEndpointConnectionNotificationsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         connection_notification_id: "ConnectionNotificationId",
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] connection_notification_id
    #   The ID of the notification.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `connection-notification-arn` - The ARN of the SNS topic for the
    #     notification.
    #
    #   * `connection-notification-id` - The ID of the notification.
    #
    #   * `connection-notification-state` - The state of the notification
    #     (`Enabled` \| `Disabled`).
    #
    #   * `connection-notification-type` - The type of notification
    #     (`Topic`).
    #
    #   * `service-id` - The ID of the endpoint service.
    #
    #   * `vpc-endpoint-id` - The ID of the VPC endpoint.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return in a single call. To
    #   retrieve the remaining results, make another request with the
    #   returned `NextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to request the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcEndpointConnectionNotificationsRequest AWS API Documentation
    #
    class DescribeVpcEndpointConnectionNotificationsRequest < Struct.new(
      :dry_run,
      :connection_notification_id,
      :filters,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] connection_notification_set
    #   One or more notifications.
    #   @return [Array<Types::ConnectionNotification>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcEndpointConnectionNotificationsResult AWS API Documentation
    #
    class DescribeVpcEndpointConnectionNotificationsResult < Struct.new(
      :connection_notification_set,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeVpcEndpointConnectionsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `service-id` - The ID of the service.
    #
    #   * `vpc-endpoint-owner` - The AWS account number of the owner of the
    #     endpoint.
    #
    #   * `vpc-endpoint-state` - The state of the endpoint
    #     (`pendingAcceptance` \| `pending` \| `available` \| `deleting` \|
    #     `deleted` \| `rejected` \| `failed`).
    #
    #   * `vpc-endpoint-id` - The ID of the endpoint.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results of the initial request can be seen by
    #   sending another request with the returned `NextToken` value. This
    #   value can be between 5 and 1,000; if `MaxResults` is given a value
    #   larger than 1,000, only 1,000 results are returned.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcEndpointConnectionsRequest AWS API Documentation
    #
    class DescribeVpcEndpointConnectionsRequest < Struct.new(
      :dry_run,
      :filters,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] vpc_endpoint_connections
    #   Information about one or more VPC endpoint connections.
    #   @return [Array<Types::VpcEndpointConnection>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcEndpointConnectionsResult AWS API Documentation
    #
    class DescribeVpcEndpointConnectionsResult < Struct.new(
      :vpc_endpoint_connections,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeVpcEndpointServiceConfigurationsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         service_ids: ["VpcEndpointServiceId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] service_ids
    #   The IDs of one or more services.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `service-name` - The name of the service.
    #
    #   * `service-id` - The ID of the service.
    #
    #   * `service-state` - The state of the service (`Pending` \|
    #     `Available` \| `Deleting` \| `Deleted` \| `Failed`).
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results of the initial request can be seen by
    #   sending another request with the returned `NextToken` value. This
    #   value can be between 5 and 1,000; if `MaxResults` is given a value
    #   larger than 1,000, only 1,000 results are returned.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcEndpointServiceConfigurationsRequest AWS API Documentation
    #
    class DescribeVpcEndpointServiceConfigurationsRequest < Struct.new(
      :dry_run,
      :service_ids,
      :filters,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] service_configurations
    #   Information about one or more services.
    #   @return [Array<Types::ServiceConfiguration>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcEndpointServiceConfigurationsResult AWS API Documentation
    #
    class DescribeVpcEndpointServiceConfigurationsResult < Struct.new(
      :service_configurations,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeVpcEndpointServicePermissionsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         service_id: "VpcEndpointServiceId", # required
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] service_id
    #   The ID of the service.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `principal` - The ARN of the principal.
    #
    #   * `principal-type` - The principal type (`All` \| `Service` \|
    #     `OrganizationUnit` \| `Account` \| `User` \| `Role`).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results of the initial request can be seen by
    #   sending another request with the returned `NextToken` value. This
    #   value can be between 5 and 1,000; if `MaxResults` is given a value
    #   larger than 1,000, only 1,000 results are returned.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcEndpointServicePermissionsRequest AWS API Documentation
    #
    class DescribeVpcEndpointServicePermissionsRequest < Struct.new(
      :dry_run,
      :service_id,
      :filters,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # @!attribute [rw] allowed_principals
    #   Information about one or more allowed principals.
    #   @return [Array<Types::AllowedPrincipal>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcEndpointServicePermissionsResult AWS API Documentation
    #
    class DescribeVpcEndpointServicePermissionsResult < Struct.new(
      :allowed_principals,
      :next_token)
      include Aws::Structure
    end

    # Contains the parameters for DescribeVpcEndpointServices.
    #
    # @note When making an API call, you may pass DescribeVpcEndpointServicesRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         service_names: ["String"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] service_names
    #   One or more service names.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `service-name` - The name of the service.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of items to return for this request. The request
    #   returns a token that you can specify in a subsequent call to get the
    #   next set of results.
    #
    #   Constraint: If the value is greater than 1,000, we return only 1,000
    #   items.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next set of items to return. (You received this
    #   token from a prior call.)
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcEndpointServicesRequest AWS API Documentation
    #
    class DescribeVpcEndpointServicesRequest < Struct.new(
      :dry_run,
      :service_names,
      :filters,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # Contains the output of DescribeVpcEndpointServices.
    #
    # @!attribute [rw] service_names
    #   A list of supported services.
    #   @return [Array<String>]
    #
    # @!attribute [rw] service_details
    #   Information about the service.
    #   @return [Array<Types::ServiceDetail>]
    #
    # @!attribute [rw] next_token
    #   The token to use when requesting the next set of items. If there are
    #   no additional items to return, the string is empty.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcEndpointServicesResult AWS API Documentation
    #
    class DescribeVpcEndpointServicesResult < Struct.new(
      :service_names,
      :service_details,
      :next_token)
      include Aws::Structure
    end

    # Contains the parameters for DescribeVpcEndpoints.
    #
    # @note When making an API call, you may pass DescribeVpcEndpointsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         vpc_endpoint_ids: ["VpcEndpointId"],
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] vpc_endpoint_ids
    #   One or more endpoint IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `service-name` - The name of the service.
    #
    #   * `vpc-id` - The ID of the VPC in which the endpoint resides.
    #
    #   * `vpc-endpoint-id` - The ID of the endpoint.
    #
    #   * `vpc-endpoint-state` - The state of the endpoint
    #     (`pendingAcceptance` \| `pending` \| `available` \| `deleting` \|
    #     `deleted` \| `rejected` \| `failed`).
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of items to return for this request. The request
    #   returns a token that you can specify in a subsequent call to get the
    #   next set of results.
    #
    #   Constraint: If the value is greater than 1,000, we return only 1,000
    #   items.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next set of items to return. (You received this
    #   token from a prior call.)
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcEndpointsRequest AWS API Documentation
    #
    class DescribeVpcEndpointsRequest < Struct.new(
      :dry_run,
      :vpc_endpoint_ids,
      :filters,
      :max_results,
      :next_token)
      include Aws::Structure
    end

    # Contains the output of DescribeVpcEndpoints.
    #
    # @!attribute [rw] vpc_endpoints
    #   Information about the endpoints.
    #   @return [Array<Types::VpcEndpoint>]
    #
    # @!attribute [rw] next_token
    #   The token to use when requesting the next set of items. If there are
    #   no additional items to return, the string is empty.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcEndpointsResult AWS API Documentation
    #
    class DescribeVpcEndpointsResult < Struct.new(
      :vpc_endpoints,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeVpcPeeringConnectionsRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         dry_run: false,
    #         vpc_peering_connection_ids: ["VpcPeeringConnectionId"],
    #         next_token: "String",
    #         max_results: 1,
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `accepter-vpc-info.cidr-block` - The IPv4 CIDR block of the
    #     accepter VPC.
    #
    #   * `accepter-vpc-info.owner-id` - The AWS account ID of the owner of
    #     the accepter VPC.
    #
    #   * `accepter-vpc-info.vpc-id` - The ID of the accepter VPC.
    #
    #   * `expiration-time` - The expiration date and time for the VPC
    #     peering connection.
    #
    #   * `requester-vpc-info.cidr-block` - The IPv4 CIDR block of the
    #     requester's VPC.
    #
    #   * `requester-vpc-info.owner-id` - The AWS account ID of the owner of
    #     the requester VPC.
    #
    #   * `requester-vpc-info.vpc-id` - The ID of the requester VPC.
    #
    #   * `status-code` - The status of the VPC peering connection
    #     (`pending-acceptance` \| `failed` \| `expired` \| `provisioning`
    #     \| `active` \| `deleting` \| `deleted` \| `rejected`).
    #
    #   * `status-message` - A message that provides more information about
    #     the status of the VPC peering connection, if applicable.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `vpc-peering-connection-id` - The ID of the VPC peering
    #     connection.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] vpc_peering_connection_ids
    #   One or more VPC peering connection IDs.
    #
    #   Default: Describes all your VPC peering connections.
    #   @return [Array<String>]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcPeeringConnectionsRequest AWS API Documentation
    #
    class DescribeVpcPeeringConnectionsRequest < Struct.new(
      :filters,
      :dry_run,
      :vpc_peering_connection_ids,
      :next_token,
      :max_results)
      include Aws::Structure
    end

    # @!attribute [rw] vpc_peering_connections
    #   Information about the VPC peering connections.
    #   @return [Array<Types::VpcPeeringConnection>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcPeeringConnectionsResult AWS API Documentation
    #
    class DescribeVpcPeeringConnectionsResult < Struct.new(
      :vpc_peering_connections,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DescribeVpcsRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         vpc_ids: ["VpcId"],
    #         dry_run: false,
    #         next_token: "String",
    #         max_results: 1,
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `cidr` - The primary IPv4 CIDR block of the VPC. The CIDR block
    #     you specify must exactly match the VPC's CIDR block for
    #     information to be returned for the VPC. Must contain the slash
    #     followed by one or two digits (for example, `/28`).
    #
    #   * `cidr-block-association.cidr-block` - An IPv4 CIDR block
    #     associated with the VPC.
    #
    #   * `cidr-block-association.association-id` - The association ID for
    #     an IPv4 CIDR block associated with the VPC.
    #
    #   * `cidr-block-association.state` - The state of an IPv4 CIDR block
    #     associated with the VPC.
    #
    #   * `dhcp-options-id` - The ID of a set of DHCP options.
    #
    #   * `ipv6-cidr-block-association.ipv6-cidr-block` - An IPv6 CIDR block
    #     associated with the VPC.
    #
    #   * `ipv6-cidr-block-association.ipv6-pool` - The ID of the IPv6
    #     address pool from which the IPv6 CIDR block is allocated.
    #
    #   * `ipv6-cidr-block-association.association-id` - The association ID
    #     for an IPv6 CIDR block associated with the VPC.
    #
    #   * `ipv6-cidr-block-association.state` - The state of an IPv6 CIDR
    #     block associated with the VPC.
    #
    #   * `isDefault` - Indicates whether the VPC is the default VPC.
    #
    #   * `owner-id` - The ID of the AWS account that owns the VPC.
    #
    #   * `state` - The state of the VPC (`pending` \| `available`).
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `vpc-id` - The ID of the VPC.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] vpc_ids
    #   One or more VPC IDs.
    #
    #   Default: Describes all your VPCs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcsRequest AWS API Documentation
    #
    class DescribeVpcsRequest < Struct.new(
      :filters,
      :vpc_ids,
      :dry_run,
      :next_token,
      :max_results)
      include Aws::Structure
    end

    # @!attribute [rw] vpcs
    #   Information about one or more VPCs.
    #   @return [Array<Types::Vpc>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpcsResult AWS API Documentation
    #
    class DescribeVpcsResult < Struct.new(
      :vpcs,
      :next_token)
      include Aws::Structure
    end

    # Contains the parameters for DescribeVpnConnections.
    #
    # @note When making an API call, you may pass DescribeVpnConnectionsRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         vpn_connection_ids: ["VpnConnectionId"],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `customer-gateway-configuration` - The configuration information
    #     for the customer gateway.
    #
    #   * `customer-gateway-id` - The ID of a customer gateway associated
    #     with the VPN connection.
    #
    #   * `state` - The state of the VPN connection (`pending` \|
    #     `available` \| `deleting` \| `deleted`).
    #
    #   * `option.static-routes-only` - Indicates whether the connection has
    #     static routes only. Used for devices that do not support Border
    #     Gateway Protocol (BGP).
    #
    #   * `route.destination-cidr-block` - The destination CIDR block. This
    #     corresponds to the subnet used in a customer data center.
    #
    #   * `bgp-asn` - The BGP Autonomous System Number (ASN) associated with
    #     a BGP device.
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `type` - The type of VPN connection. Currently the only supported
    #     type is `ipsec.1`.
    #
    #   * `vpn-connection-id` - The ID of the VPN connection.
    #
    #   * `vpn-gateway-id` - The ID of a virtual private gateway associated
    #     with the VPN connection.
    #
    #   * `transit-gateway-id` - The ID of a transit gateway associated with
    #     the VPN connection.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] vpn_connection_ids
    #   One or more VPN connection IDs.
    #
    #   Default: Describes your VPN connections.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpnConnectionsRequest AWS API Documentation
    #
    class DescribeVpnConnectionsRequest < Struct.new(
      :filters,
      :vpn_connection_ids,
      :dry_run)
      include Aws::Structure
    end

    # Contains the output of DescribeVpnConnections.
    #
    # @!attribute [rw] vpn_connections
    #   Information about one or more VPN connections.
    #   @return [Array<Types::VpnConnection>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpnConnectionsResult AWS API Documentation
    #
    class DescribeVpnConnectionsResult < Struct.new(
      :vpn_connections)
      include Aws::Structure
    end

    # Contains the parameters for DescribeVpnGateways.
    #
    # @note When making an API call, you may pass DescribeVpnGatewaysRequest
    #   data as a hash:
    #
    #       {
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         vpn_gateway_ids: ["VpnGatewayId"],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #
    #   * `amazon-side-asn` - The Autonomous System Number (ASN) for the
    #     Amazon side of the gateway.
    #
    #   * `attachment.state` - The current state of the attachment between
    #     the gateway and the VPC (`attaching` \| `attached` \| `detaching`
    #     \| `detached`).
    #
    #   * `attachment.vpc-id` - The ID of an attached VPC.
    #
    #   * `availability-zone` - The Availability Zone for the virtual
    #     private gateway (if applicable).
    #
    #   * `state` - The state of the virtual private gateway (`pending` \|
    #     `available` \| `deleting` \| `deleted`).
    #
    #   * `tag`\:&lt;key&gt; - The key/value combination of a tag assigned
    #     to the resource. Use the tag key in the filter name and the tag
    #     value as the filter value. For example, to find all resources that
    #     have a tag with the key `Owner` and the value `TeamA`, specify
    #     `tag:Owner` for the filter name and `TeamA` for the filter value.
    #
    #   * `tag-key` - The key of a tag assigned to the resource. Use this
    #     filter to find all resources assigned a tag with a specific key,
    #     regardless of the tag value.
    #
    #   * `type` - The type of virtual private gateway. Currently the only
    #     supported type is `ipsec.1`.
    #
    #   * `vpn-gateway-id` - The ID of the virtual private gateway.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] vpn_gateway_ids
    #   One or more virtual private gateway IDs.
    #
    #   Default: Describes all your virtual private gateways.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpnGatewaysRequest AWS API Documentation
    #
    class DescribeVpnGatewaysRequest < Struct.new(
      :filters,
      :vpn_gateway_ids,
      :dry_run)
      include Aws::Structure
    end

    # Contains the output of DescribeVpnGateways.
    #
    # @!attribute [rw] vpn_gateways
    #   Information about one or more virtual private gateways.
    #   @return [Array<Types::VpnGateway>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DescribeVpnGatewaysResult AWS API Documentation
    #
    class DescribeVpnGatewaysResult < Struct.new(
      :vpn_gateways)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DetachClassicLinkVpcRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         instance_id: "InstanceId", # required
    #         vpc_id: "VpcId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance to unlink from the VPC.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC to which the instance is linked.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DetachClassicLinkVpcRequest AWS API Documentation
    #
    class DetachClassicLinkVpcRequest < Struct.new(
      :dry_run,
      :instance_id,
      :vpc_id)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DetachClassicLinkVpcResult AWS API Documentation
    #
    class DetachClassicLinkVpcResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DetachInternetGatewayRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         internet_gateway_id: "InternetGatewayId", # required
    #         vpc_id: "VpcId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] internet_gateway_id
    #   The ID of the internet gateway.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DetachInternetGatewayRequest AWS API Documentation
    #
    class DetachInternetGatewayRequest < Struct.new(
      :dry_run,
      :internet_gateway_id,
      :vpc_id)
      include Aws::Structure
    end

    # Contains the parameters for DetachNetworkInterface.
    #
    # @note When making an API call, you may pass DetachNetworkInterfaceRequest
    #   data as a hash:
    #
    #       {
    #         attachment_id: "NetworkInterfaceAttachmentId", # required
    #         dry_run: false,
    #         force: false,
    #       }
    #
    # @!attribute [rw] attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] force
    #   Specifies whether to force a detachment.
    #
    #   <note markdown="1"> * Use the `Force` parameter only as a last resort to detach a
    #     network interface from a failed instance.
    #
    #   * If you use the `Force` parameter to detach a network interface,
    #     you might not be able to attach a different network interface to
    #     the same index on the instance without first stopping and starting
    #     the instance.
    #
    #   * If you force the detachment of a network interface, the [instance
    #     metadata][1] might not get updated. This means that the attributes
    #     associated with the detached network interface might still be
    #     visible. The instance metadata will get updated when you stop and
    #     start the instance.
    #
    #    </note>
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-instance-metadata.html
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DetachNetworkInterfaceRequest AWS API Documentation
    #
    class DetachNetworkInterfaceRequest < Struct.new(
      :attachment_id,
      :dry_run,
      :force)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DetachVolumeRequest
    #   data as a hash:
    #
    #       {
    #         device: "String",
    #         force: false,
    #         instance_id: "InstanceId",
    #         volume_id: "VolumeId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] device
    #   The device name.
    #   @return [String]
    #
    # @!attribute [rw] force
    #   Forces detachment if the previous detachment attempt did not occur
    #   cleanly (for example, logging into an instance, unmounting the
    #   volume, and detaching normally). This option can lead to data loss
    #   or a corrupted file system. Use this option only as a last resort to
    #   detach a volume from a failed instance. The instance won't have an
    #   opportunity to flush file system caches or file system metadata. If
    #   you use this option, you must perform file system check and repair
    #   procedures.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance. If you are detaching a Multi-Attach enabled
    #   volume, you must specify an instance ID.
    #   @return [String]
    #
    # @!attribute [rw] volume_id
    #   The ID of the volume.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DetachVolumeRequest AWS API Documentation
    #
    class DetachVolumeRequest < Struct.new(
      :device,
      :force,
      :instance_id,
      :volume_id,
      :dry_run)
      include Aws::Structure
    end

    # Contains the parameters for DetachVpnGateway.
    #
    # @note When making an API call, you may pass DetachVpnGatewayRequest
    #   data as a hash:
    #
    #       {
    #         vpc_id: "VpcId", # required
    #         vpn_gateway_id: "VpnGatewayId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] vpn_gateway_id
    #   The ID of the virtual private gateway.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DetachVpnGatewayRequest AWS API Documentation
    #
    class DetachVpnGatewayRequest < Struct.new(
      :vpc_id,
      :vpn_gateway_id,
      :dry_run)
      include Aws::Structure
    end

    # Describes a DHCP configuration option.
    #
    # @!attribute [rw] key
    #   The name of a DHCP option.
    #   @return [String]
    #
    # @!attribute [rw] values
    #   One or more values for the DHCP option.
    #   @return [Array<Types::AttributeValue>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DhcpConfiguration AWS API Documentation
    #
    class DhcpConfiguration < Struct.new(
      :key,
      :values)
      include Aws::Structure
    end

    # Describes a set of DHCP options.
    #
    # @!attribute [rw] dhcp_configurations
    #   One or more DHCP options in the set.
    #   @return [Array<Types::DhcpConfiguration>]
    #
    # @!attribute [rw] dhcp_options_id
    #   The ID of the set of DHCP options.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account that owns the DHCP options set.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the DHCP options set.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DhcpOptions AWS API Documentation
    #
    class DhcpOptions < Struct.new(
      :dhcp_configurations,
      :dhcp_options_id,
      :owner_id,
      :tags)
      include Aws::Structure
    end

    # Describes an Active Directory.
    #
    # @!attribute [rw] directory_id
    #   The ID of the Active Directory used for authentication.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DirectoryServiceAuthentication AWS API Documentation
    #
    class DirectoryServiceAuthentication < Struct.new(
      :directory_id)
      include Aws::Structure
    end

    # Describes the Active Directory to be used for client authentication.
    #
    # @note When making an API call, you may pass DirectoryServiceAuthenticationRequest
    #   data as a hash:
    #
    #       {
    #         directory_id: "String",
    #       }
    #
    # @!attribute [rw] directory_id
    #   The ID of the Active Directory to be used for authentication.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DirectoryServiceAuthenticationRequest AWS API Documentation
    #
    class DirectoryServiceAuthenticationRequest < Struct.new(
      :directory_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DisableEbsEncryptionByDefaultRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisableEbsEncryptionByDefaultRequest AWS API Documentation
    #
    class DisableEbsEncryptionByDefaultRequest < Struct.new(
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] ebs_encryption_by_default
    #   The updated status of encryption by default.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisableEbsEncryptionByDefaultResult AWS API Documentation
    #
    class DisableEbsEncryptionByDefaultResult < Struct.new(
      :ebs_encryption_by_default)
      include Aws::Structure
    end

    # Contains information about the errors that occurred when disabling
    # fast snapshot restores.
    #
    # @!attribute [rw] snapshot_id
    #   The ID of the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] fast_snapshot_restore_state_errors
    #   The errors.
    #   @return [Array<Types::DisableFastSnapshotRestoreStateErrorItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisableFastSnapshotRestoreErrorItem AWS API Documentation
    #
    class DisableFastSnapshotRestoreErrorItem < Struct.new(
      :snapshot_id,
      :fast_snapshot_restore_state_errors)
      include Aws::Structure
    end

    # Describes an error that occurred when disabling fast snapshot
    # restores.
    #
    # @!attribute [rw] code
    #   The error code.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   The error message.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisableFastSnapshotRestoreStateError AWS API Documentation
    #
    class DisableFastSnapshotRestoreStateError < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # Contains information about an error that occurred when disabling fast
    # snapshot restores.
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone.
    #   @return [String]
    #
    # @!attribute [rw] error
    #   The error.
    #   @return [Types::DisableFastSnapshotRestoreStateError]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisableFastSnapshotRestoreStateErrorItem AWS API Documentation
    #
    class DisableFastSnapshotRestoreStateErrorItem < Struct.new(
      :availability_zone,
      :error)
      include Aws::Structure
    end

    # Describes fast snapshot restores that were successfully disabled.
    #
    # @!attribute [rw] snapshot_id
    #   The ID of the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of fast snapshot restores for the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] state_transition_reason
    #   The reason for the state transition. The possible values are as
    #   follows:
    #
    #   * `Client.UserInitiated` - The state successfully transitioned to
    #     `enabling` or `disabling`.
    #
    #   * `Client.UserInitiated - Lifecycle state transition` - The state
    #     successfully transitioned to `optimizing`, `enabled`, or
    #     `disabled`.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account that owns the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] owner_alias
    #   The alias of the snapshot owner.
    #   @return [String]
    #
    # @!attribute [rw] enabling_time
    #   The time at which fast snapshot restores entered the `enabling`
    #   state.
    #   @return [Time]
    #
    # @!attribute [rw] optimizing_time
    #   The time at which fast snapshot restores entered the `optimizing`
    #   state.
    #   @return [Time]
    #
    # @!attribute [rw] enabled_time
    #   The time at which fast snapshot restores entered the `enabled`
    #   state.
    #   @return [Time]
    #
    # @!attribute [rw] disabling_time
    #   The time at which fast snapshot restores entered the `disabling`
    #   state.
    #   @return [Time]
    #
    # @!attribute [rw] disabled_time
    #   The time at which fast snapshot restores entered the `disabled`
    #   state.
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisableFastSnapshotRestoreSuccessItem AWS API Documentation
    #
    class DisableFastSnapshotRestoreSuccessItem < Struct.new(
      :snapshot_id,
      :availability_zone,
      :state,
      :state_transition_reason,
      :owner_id,
      :owner_alias,
      :enabling_time,
      :optimizing_time,
      :enabled_time,
      :disabling_time,
      :disabled_time)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DisableFastSnapshotRestoresRequest
    #   data as a hash:
    #
    #       {
    #         availability_zones: ["String"], # required
    #         source_snapshot_ids: ["SnapshotId"], # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] availability_zones
    #   One or more Availability Zones. For example, `us-east-2a`.
    #   @return [Array<String>]
    #
    # @!attribute [rw] source_snapshot_ids
    #   The IDs of one or more snapshots. For example,
    #   `snap-1234567890abcdef0`.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisableFastSnapshotRestoresRequest AWS API Documentation
    #
    class DisableFastSnapshotRestoresRequest < Struct.new(
      :availability_zones,
      :source_snapshot_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] successful
    #   Information about the snapshots for which fast snapshot restores
    #   were successfully disabled.
    #   @return [Array<Types::DisableFastSnapshotRestoreSuccessItem>]
    #
    # @!attribute [rw] unsuccessful
    #   Information about the snapshots for which fast snapshot restores
    #   could not be disabled.
    #   @return [Array<Types::DisableFastSnapshotRestoreErrorItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisableFastSnapshotRestoresResult AWS API Documentation
    #
    class DisableFastSnapshotRestoresResult < Struct.new(
      :successful,
      :unsuccessful)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DisableTransitGatewayRouteTablePropagationRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_route_table_id: "TransitGatewayRouteTableId", # required
    #         transit_gateway_attachment_id: "TransitGatewayAttachmentId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the propagation route table.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisableTransitGatewayRouteTablePropagationRequest AWS API Documentation
    #
    class DisableTransitGatewayRouteTablePropagationRequest < Struct.new(
      :transit_gateway_route_table_id,
      :transit_gateway_attachment_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] propagation
    #   Information about route propagation.
    #   @return [Types::TransitGatewayPropagation]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisableTransitGatewayRouteTablePropagationResult AWS API Documentation
    #
    class DisableTransitGatewayRouteTablePropagationResult < Struct.new(
      :propagation)
      include Aws::Structure
    end

    # Contains the parameters for DisableVgwRoutePropagation.
    #
    # @note When making an API call, you may pass DisableVgwRoutePropagationRequest
    #   data as a hash:
    #
    #       {
    #         gateway_id: "VpnGatewayId", # required
    #         route_table_id: "RouteTableId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] gateway_id
    #   The ID of the virtual private gateway.
    #   @return [String]
    #
    # @!attribute [rw] route_table_id
    #   The ID of the route table.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisableVgwRoutePropagationRequest AWS API Documentation
    #
    class DisableVgwRoutePropagationRequest < Struct.new(
      :gateway_id,
      :route_table_id,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DisableVpcClassicLinkDnsSupportRequest
    #   data as a hash:
    #
    #       {
    #         vpc_id: "VpcId",
    #       }
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisableVpcClassicLinkDnsSupportRequest AWS API Documentation
    #
    class DisableVpcClassicLinkDnsSupportRequest < Struct.new(
      :vpc_id)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisableVpcClassicLinkDnsSupportResult AWS API Documentation
    #
    class DisableVpcClassicLinkDnsSupportResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DisableVpcClassicLinkRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         vpc_id: "VpcId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisableVpcClassicLinkRequest AWS API Documentation
    #
    class DisableVpcClassicLinkRequest < Struct.new(
      :dry_run,
      :vpc_id)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisableVpcClassicLinkResult AWS API Documentation
    #
    class DisableVpcClassicLinkResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DisassociateAddressRequest
    #   data as a hash:
    #
    #       {
    #         association_id: "ElasticIpAssociationId",
    #         public_ip: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] association_id
    #   \[EC2-VPC\] The association ID. Required for EC2-VPC.
    #   @return [String]
    #
    # @!attribute [rw] public_ip
    #   \[EC2-Classic\] The Elastic IP address. Required for EC2-Classic.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisassociateAddressRequest AWS API Documentation
    #
    class DisassociateAddressRequest < Struct.new(
      :association_id,
      :public_ip,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DisassociateClientVpnTargetNetworkRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         association_id: "ClientVpnAssociationId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint from which to disassociate the
    #   target network.
    #   @return [String]
    #
    # @!attribute [rw] association_id
    #   The ID of the target network association.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisassociateClientVpnTargetNetworkRequest AWS API Documentation
    #
    class DisassociateClientVpnTargetNetworkRequest < Struct.new(
      :client_vpn_endpoint_id,
      :association_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] association_id
    #   The ID of the target network association.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The current state of the target network association.
    #   @return [Types::AssociationStatus]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisassociateClientVpnTargetNetworkResult AWS API Documentation
    #
    class DisassociateClientVpnTargetNetworkResult < Struct.new(
      :association_id,
      :status)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DisassociateIamInstanceProfileRequest
    #   data as a hash:
    #
    #       {
    #         association_id: "IamInstanceProfileAssociationId", # required
    #       }
    #
    # @!attribute [rw] association_id
    #   The ID of the IAM instance profile association.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisassociateIamInstanceProfileRequest AWS API Documentation
    #
    class DisassociateIamInstanceProfileRequest < Struct.new(
      :association_id)
      include Aws::Structure
    end

    # @!attribute [rw] iam_instance_profile_association
    #   Information about the IAM instance profile association.
    #   @return [Types::IamInstanceProfileAssociation]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisassociateIamInstanceProfileResult AWS API Documentation
    #
    class DisassociateIamInstanceProfileResult < Struct.new(
      :iam_instance_profile_association)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DisassociateRouteTableRequest
    #   data as a hash:
    #
    #       {
    #         association_id: "RouteTableAssociationId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] association_id
    #   The association ID representing the current association between the
    #   route table and subnet or gateway.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisassociateRouteTableRequest AWS API Documentation
    #
    class DisassociateRouteTableRequest < Struct.new(
      :association_id,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DisassociateSubnetCidrBlockRequest
    #   data as a hash:
    #
    #       {
    #         association_id: "SubnetCidrAssociationId", # required
    #       }
    #
    # @!attribute [rw] association_id
    #   The association ID for the CIDR block.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisassociateSubnetCidrBlockRequest AWS API Documentation
    #
    class DisassociateSubnetCidrBlockRequest < Struct.new(
      :association_id)
      include Aws::Structure
    end

    # @!attribute [rw] ipv_6_cidr_block_association
    #   Information about the IPv6 CIDR block association.
    #   @return [Types::SubnetIpv6CidrBlockAssociation]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisassociateSubnetCidrBlockResult AWS API Documentation
    #
    class DisassociateSubnetCidrBlockResult < Struct.new(
      :ipv_6_cidr_block_association,
      :subnet_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DisassociateTransitGatewayMulticastDomainRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_multicast_domain_id: "TransitGatewayMulticastDomainId",
    #         transit_gateway_attachment_id: "TransitGatewayAttachmentId",
    #         subnet_ids: ["String"],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_multicast_domain_id
    #   The ID of the transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] subnet_ids
    #   The IDs of the subnets;
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisassociateTransitGatewayMulticastDomainRequest AWS API Documentation
    #
    class DisassociateTransitGatewayMulticastDomainRequest < Struct.new(
      :transit_gateway_multicast_domain_id,
      :transit_gateway_attachment_id,
      :subnet_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] associations
    #   Information about the association.
    #   @return [Types::TransitGatewayMulticastDomainAssociations]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisassociateTransitGatewayMulticastDomainResult AWS API Documentation
    #
    class DisassociateTransitGatewayMulticastDomainResult < Struct.new(
      :associations)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DisassociateTransitGatewayRouteTableRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_route_table_id: "TransitGatewayRouteTableId", # required
    #         transit_gateway_attachment_id: "TransitGatewayAttachmentId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the transit gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisassociateTransitGatewayRouteTableRequest AWS API Documentation
    #
    class DisassociateTransitGatewayRouteTableRequest < Struct.new(
      :transit_gateway_route_table_id,
      :transit_gateway_attachment_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] association
    #   Information about the association.
    #   @return [Types::TransitGatewayAssociation]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisassociateTransitGatewayRouteTableResult AWS API Documentation
    #
    class DisassociateTransitGatewayRouteTableResult < Struct.new(
      :association)
      include Aws::Structure
    end

    # @note When making an API call, you may pass DisassociateVpcCidrBlockRequest
    #   data as a hash:
    #
    #       {
    #         association_id: "VpcCidrAssociationId", # required
    #       }
    #
    # @!attribute [rw] association_id
    #   The association ID for the CIDR block.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisassociateVpcCidrBlockRequest AWS API Documentation
    #
    class DisassociateVpcCidrBlockRequest < Struct.new(
      :association_id)
      include Aws::Structure
    end

    # @!attribute [rw] ipv_6_cidr_block_association
    #   Information about the IPv6 CIDR block association.
    #   @return [Types::VpcIpv6CidrBlockAssociation]
    #
    # @!attribute [rw] cidr_block_association
    #   Information about the IPv4 CIDR block association.
    #   @return [Types::VpcCidrBlockAssociation]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DisassociateVpcCidrBlockResult AWS API Documentation
    #
    class DisassociateVpcCidrBlockResult < Struct.new(
      :ipv_6_cidr_block_association,
      :cidr_block_association,
      :vpc_id)
      include Aws::Structure
    end

    # Describes a disk image.
    #
    # @note When making an API call, you may pass DiskImage
    #   data as a hash:
    #
    #       {
    #         description: "String",
    #         image: {
    #           bytes: 1, # required
    #           format: "VMDK", # required, accepts VMDK, RAW, VHD
    #           import_manifest_url: "String", # required
    #         },
    #         volume: {
    #           size: 1, # required
    #         },
    #       }
    #
    # @!attribute [rw] description
    #   A description of the disk image.
    #   @return [String]
    #
    # @!attribute [rw] image
    #   Information about the disk image.
    #   @return [Types::DiskImageDetail]
    #
    # @!attribute [rw] volume
    #   Information about the volume.
    #   @return [Types::VolumeDetail]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DiskImage AWS API Documentation
    #
    class DiskImage < Struct.new(
      :description,
      :image,
      :volume)
      include Aws::Structure
    end

    # Describes a disk image.
    #
    # @!attribute [rw] checksum
    #   The checksum computed for the disk image.
    #   @return [String]
    #
    # @!attribute [rw] format
    #   The disk image format.
    #   @return [String]
    #
    # @!attribute [rw] import_manifest_url
    #   A presigned URL for the import manifest stored in Amazon S3. For
    #   information about creating a presigned URL for an Amazon S3 object,
    #   read the "Query String Request Authentication Alternative" section
    #   of the [Authenticating REST Requests][1] topic in the *Amazon Simple
    #   Storage Service Developer Guide*.
    #
    #   For information about the import manifest referenced by this API
    #   action, see [VM Import Manifest][2].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html
    #   @return [String]
    #
    # @!attribute [rw] size
    #   The size of the disk image, in GiB.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DiskImageDescription AWS API Documentation
    #
    class DiskImageDescription < Struct.new(
      :checksum,
      :format,
      :import_manifest_url,
      :size)
      include Aws::Structure
    end

    # Describes a disk image.
    #
    # @note When making an API call, you may pass DiskImageDetail
    #   data as a hash:
    #
    #       {
    #         bytes: 1, # required
    #         format: "VMDK", # required, accepts VMDK, RAW, VHD
    #         import_manifest_url: "String", # required
    #       }
    #
    # @!attribute [rw] bytes
    #   The size of the disk image, in GiB.
    #   @return [Integer]
    #
    # @!attribute [rw] format
    #   The disk image format.
    #   @return [String]
    #
    # @!attribute [rw] import_manifest_url
    #   A presigned URL for the import manifest stored in Amazon S3 and
    #   presented here as an Amazon S3 presigned URL. For information about
    #   creating a presigned URL for an Amazon S3 object, read the "Query
    #   String Request Authentication Alternative" section of the
    #   [Authenticating REST Requests][1] topic in the *Amazon Simple
    #   Storage Service Developer Guide*.
    #
    #   For information about the import manifest referenced by this API
    #   action, see [VM Import Manifest][2].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AmazonS3/latest/dev/RESTAuthentication.html
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/manifest.html
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DiskImageDetail AWS API Documentation
    #
    class DiskImageDetail < Struct.new(
      :bytes,
      :format,
      :import_manifest_url)
      include Aws::Structure
    end

    # Describes a disk image volume.
    #
    # @!attribute [rw] id
    #   The volume identifier.
    #   @return [String]
    #
    # @!attribute [rw] size
    #   The size of the volume, in GiB.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DiskImageVolumeDescription AWS API Documentation
    #
    class DiskImageVolumeDescription < Struct.new(
      :id,
      :size)
      include Aws::Structure
    end

    # Describes the disk.
    #
    # @!attribute [rw] size_in_gb
    #   The size of the disk in GB.
    #   @return [Integer]
    #
    # @!attribute [rw] count
    #   The number of disks with this configuration.
    #   @return [Integer]
    #
    # @!attribute [rw] type
    #   The type of disk.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DiskInfo AWS API Documentation
    #
    class DiskInfo < Struct.new(
      :size_in_gb,
      :count,
      :type)
      include Aws::Structure
    end

    # Describes a DNS entry.
    #
    # @!attribute [rw] dns_name
    #   The DNS name.
    #   @return [String]
    #
    # @!attribute [rw] hosted_zone_id
    #   The ID of the private hosted zone.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DnsEntry AWS API Documentation
    #
    class DnsEntry < Struct.new(
      :dns_name,
      :hosted_zone_id)
      include Aws::Structure
    end

    # Information about the DNS server to be used.
    #
    # @note When making an API call, you may pass DnsServersOptionsModifyStructure
    #   data as a hash:
    #
    #       {
    #         custom_dns_servers: ["String"],
    #         enabled: false,
    #       }
    #
    # @!attribute [rw] custom_dns_servers
    #   The IPv4 address range, in CIDR notation, of the DNS servers to be
    #   used. You can specify up to two DNS servers. Ensure that the DNS
    #   servers can be reached by the clients. The specified values
    #   overwrite the existing values.
    #   @return [Array<String>]
    #
    # @!attribute [rw] enabled
    #   Indicates whether DNS servers should be used. Specify `False` to
    #   delete the existing DNS servers.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/DnsServersOptionsModifyStructure AWS API Documentation
    #
    class DnsServersOptionsModifyStructure < Struct.new(
      :custom_dns_servers,
      :enabled)
      include Aws::Structure
    end

    # Describes a block device for an EBS volume.
    #
    # @note When making an API call, you may pass EbsBlockDevice
    #   data as a hash:
    #
    #       {
    #         delete_on_termination: false,
    #         iops: 1,
    #         snapshot_id: "String",
    #         volume_size: 1,
    #         volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #         kms_key_id: "String",
    #         encrypted: false,
    #       }
    #
    # @!attribute [rw] delete_on_termination
    #   Indicates whether the EBS volume is deleted on instance termination.
    #   For more information, see [Preserving Amazon EBS Volumes on Instance
    #   Termination][1] in the Amazon Elastic Compute Cloud User Guide.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/terminating-instances.html#preserving-volumes-on-termination
    #   @return [Boolean]
    #
    # @!attribute [rw] iops
    #   The number of I/O operations per second (IOPS) that the volume
    #   supports. For `io1` volumes, this represents the number of IOPS that
    #   are provisioned for the volume. For `gp2` volumes, this represents
    #   the baseline performance of the volume and the rate at which the
    #   volume accumulates I/O credits for bursting. For more information,
    #   see [Amazon EBS Volume Types][1] in the *Amazon Elastic Compute
    #   Cloud User Guide*.
    #
    #   Constraints: Range is 100-16,000 IOPS for `gp2` volumes and 100 to
    #   64,000IOPS for `io1` volumes in most Regions. Maximum `io1` IOPS of
    #   64,000 is guaranteed only on [Nitro-based instances][2]. Other
    #   instance families guarantee performance up to 32,000 IOPS. For more
    #   information, see [Amazon EBS Volume Types][1] in the *Amazon Elastic
    #   Compute Cloud User Guide*.
    #
    #   Condition: This parameter is required for requests to create `io1`
    #   volumes; it is not used in requests to create `gp2`, `st1`, `sc1`,
    #   or `standard` volumes.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances
    #   @return [Integer]
    #
    # @!attribute [rw] snapshot_id
    #   The ID of the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] volume_size
    #   The size of the volume, in GiB.
    #
    #   Default: If you're creating the volume from a snapshot and don't
    #   specify a volume size, the default is the snapshot size.
    #
    #   Constraints: 1-16384 for General Purpose SSD (`gp2`), 4-16384 for
    #   Provisioned IOPS SSD (`io1`), 500-16384 for Throughput Optimized HDD
    #   (`st1`), 500-16384 for Cold HDD (`sc1`), and 1-1024 for Magnetic
    #   (`standard`) volumes. If you specify a snapshot, the volume size
    #   must be equal to or larger than the snapshot size.
    #   @return [Integer]
    #
    # @!attribute [rw] volume_type
    #   The volume type. If you set the type to `io1`, you must also specify
    #   the **Iops** parameter. If you set the type to `gp2`, `st1`, `sc1`,
    #   or `standard`, you must omit the **Iops** parameter.
    #
    #   Default: `gp2`
    #   @return [String]
    #
    # @!attribute [rw] kms_key_id
    #   Identifier (key ID, key alias, ID ARN, or alias ARN) for a customer
    #   managed CMK under which the EBS volume is encrypted.
    #
    #   This parameter is only supported on `BlockDeviceMapping` objects
    #   called by [RunInstances][1], [RequestSpotFleet][2], and
    #   [RequestSpotInstances][3].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotFleet.html
    #   [3]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RequestSpotInstances.html
    #   @return [String]
    #
    # @!attribute [rw] encrypted
    #   Indicates whether the encryption state of an EBS volume is changed
    #   while being restored from a backing snapshot. The effect of setting
    #   the encryption state to `true` depends on the volume origin (new or
    #   from a snapshot), starting encryption state, ownership, and whether
    #   encryption by default is enabled. For more information, see [Amazon
    #   EBS Encryption][1] in the *Amazon Elastic Compute Cloud User Guide*.
    #
    #   In no case can you remove encryption from an encrypted volume.
    #
    #   Encrypted volumes can only be attached to instances that support
    #   Amazon EBS encryption. For more information, see [Supported Instance
    #   Types][2].
    #
    #   This parameter is not returned by .
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-parameters
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EbsBlockDevice AWS API Documentation
    #
    class EbsBlockDevice < Struct.new(
      :delete_on_termination,
      :iops,
      :snapshot_id,
      :volume_size,
      :volume_type,
      :kms_key_id,
      :encrypted)
      include Aws::Structure
    end

    # Describes the Amazon EBS features supported by the instance type.
    #
    # @!attribute [rw] ebs_optimized_support
    #   Indicates that the instance type is Amazon EBS-optimized. For more
    #   information, see [Amazon EBS-Optimized Instances][1] in *Amazon EC2
    #   User Guide for Linux Instances*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSOptimized.html
    #   @return [String]
    #
    # @!attribute [rw] encryption_support
    #   Indicates whether Amazon EBS encryption is supported.
    #   @return [String]
    #
    # @!attribute [rw] ebs_optimized_info
    #   Describes the optimized EBS performance for the instance type.
    #   @return [Types::EbsOptimizedInfo]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EbsInfo AWS API Documentation
    #
    class EbsInfo < Struct.new(
      :ebs_optimized_support,
      :encryption_support,
      :ebs_optimized_info)
      include Aws::Structure
    end

    # Describes a parameter used to set up an EBS volume in a block device
    # mapping.
    #
    # @!attribute [rw] attach_time
    #   The time stamp when the attachment initiated.
    #   @return [Time]
    #
    # @!attribute [rw] delete_on_termination
    #   Indicates whether the volume is deleted on instance termination.
    #   @return [Boolean]
    #
    # @!attribute [rw] status
    #   The attachment state.
    #   @return [String]
    #
    # @!attribute [rw] volume_id
    #   The ID of the EBS volume.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EbsInstanceBlockDevice AWS API Documentation
    #
    class EbsInstanceBlockDevice < Struct.new(
      :attach_time,
      :delete_on_termination,
      :status,
      :volume_id)
      include Aws::Structure
    end

    # Describes information used to set up an EBS volume specified in a
    # block device mapping.
    #
    # @note When making an API call, you may pass EbsInstanceBlockDeviceSpecification
    #   data as a hash:
    #
    #       {
    #         delete_on_termination: false,
    #         volume_id: "VolumeId",
    #       }
    #
    # @!attribute [rw] delete_on_termination
    #   Indicates whether the volume is deleted on instance termination.
    #   @return [Boolean]
    #
    # @!attribute [rw] volume_id
    #   The ID of the EBS volume.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EbsInstanceBlockDeviceSpecification AWS API Documentation
    #
    class EbsInstanceBlockDeviceSpecification < Struct.new(
      :delete_on_termination,
      :volume_id)
      include Aws::Structure
    end

    # Describes the optimized EBS performance for supported instance types.
    #
    # @!attribute [rw] baseline_bandwidth_in_mbps
    #   The baseline bandwidth performance for an EBS-optimized instance
    #   type, in Mbps.
    #   @return [Integer]
    #
    # @!attribute [rw] baseline_throughput_in_m_bps
    #   The baseline throughput performance for an EBS-optimized instance
    #   type, in MBps.
    #   @return [Float]
    #
    # @!attribute [rw] baseline_iops
    #   The baseline input/output storage operations per seconds for an
    #   EBS-optimized instance type.
    #   @return [Integer]
    #
    # @!attribute [rw] maximum_bandwidth_in_mbps
    #   The maximum bandwidth performance for an EBS-optimized instance
    #   type, in Mbps.
    #   @return [Integer]
    #
    # @!attribute [rw] maximum_throughput_in_m_bps
    #   The maximum throughput performance for an EBS-optimized instance
    #   type, in MBps.
    #   @return [Float]
    #
    # @!attribute [rw] maximum_iops
    #   The maximum input/output storage operations per second for an
    #   EBS-optimized instance type.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EbsOptimizedInfo AWS API Documentation
    #
    class EbsOptimizedInfo < Struct.new(
      :baseline_bandwidth_in_mbps,
      :baseline_throughput_in_m_bps,
      :baseline_iops,
      :maximum_bandwidth_in_mbps,
      :maximum_throughput_in_m_bps,
      :maximum_iops)
      include Aws::Structure
    end

    # Describes an egress-only internet gateway.
    #
    # @!attribute [rw] attachments
    #   Information about the attachment of the egress-only internet
    #   gateway.
    #   @return [Array<Types::InternetGatewayAttachment>]
    #
    # @!attribute [rw] egress_only_internet_gateway_id
    #   The ID of the egress-only internet gateway.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags assigned to the egress-only internet gateway.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EgressOnlyInternetGateway AWS API Documentation
    #
    class EgressOnlyInternetGateway < Struct.new(
      :attachments,
      :egress_only_internet_gateway_id,
      :tags)
      include Aws::Structure
    end

    # Describes the association between an instance and an Elastic Graphics
    # accelerator.
    #
    # @!attribute [rw] elastic_gpu_id
    #   The ID of the Elastic Graphics accelerator.
    #   @return [String]
    #
    # @!attribute [rw] elastic_gpu_association_id
    #   The ID of the association.
    #   @return [String]
    #
    # @!attribute [rw] elastic_gpu_association_state
    #   The state of the association between the instance and the Elastic
    #   Graphics accelerator.
    #   @return [String]
    #
    # @!attribute [rw] elastic_gpu_association_time
    #   The time the Elastic Graphics accelerator was associated with the
    #   instance.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ElasticGpuAssociation AWS API Documentation
    #
    class ElasticGpuAssociation < Struct.new(
      :elastic_gpu_id,
      :elastic_gpu_association_id,
      :elastic_gpu_association_state,
      :elastic_gpu_association_time)
      include Aws::Structure
    end

    # Describes the status of an Elastic Graphics accelerator.
    #
    # @!attribute [rw] status
    #   The health status.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ElasticGpuHealth AWS API Documentation
    #
    class ElasticGpuHealth < Struct.new(
      :status)
      include Aws::Structure
    end

    # A specification for an Elastic Graphics accelerator.
    #
    # @note When making an API call, you may pass ElasticGpuSpecification
    #   data as a hash:
    #
    #       {
    #         type: "String", # required
    #       }
    #
    # @!attribute [rw] type
    #   The type of Elastic Graphics accelerator. For more information about
    #   the values to specify for `Type`, see [Elastic Graphics Basics][1],
    #   specifically the Elastic Graphics accelerator column, in the *Amazon
    #   Elastic Compute Cloud User Guide for Windows Instances*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/WindowsGuide/elastic-graphics.html#elastic-graphics-basics
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ElasticGpuSpecification AWS API Documentation
    #
    class ElasticGpuSpecification < Struct.new(
      :type)
      include Aws::Structure
    end

    # Describes an elastic GPU.
    #
    # @!attribute [rw] type
    #   The elastic GPU type.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ElasticGpuSpecificationResponse AWS API Documentation
    #
    class ElasticGpuSpecificationResponse < Struct.new(
      :type)
      include Aws::Structure
    end

    # Describes an Elastic Graphics accelerator.
    #
    # @!attribute [rw] elastic_gpu_id
    #   The ID of the Elastic Graphics accelerator.
    #   @return [String]
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone in the which the Elastic Graphics accelerator
    #   resides.
    #   @return [String]
    #
    # @!attribute [rw] elastic_gpu_type
    #   The type of Elastic Graphics accelerator.
    #   @return [String]
    #
    # @!attribute [rw] elastic_gpu_health
    #   The status of the Elastic Graphics accelerator.
    #   @return [Types::ElasticGpuHealth]
    #
    # @!attribute [rw] elastic_gpu_state
    #   The state of the Elastic Graphics accelerator.
    #   @return [String]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance to which the Elastic Graphics accelerator is
    #   attached.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags assigned to the Elastic Graphics accelerator.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ElasticGpus AWS API Documentation
    #
    class ElasticGpus < Struct.new(
      :elastic_gpu_id,
      :availability_zone,
      :elastic_gpu_type,
      :elastic_gpu_health,
      :elastic_gpu_state,
      :instance_id,
      :tags)
      include Aws::Structure
    end

    # Describes an elastic inference accelerator.
    #
    # @note When making an API call, you may pass ElasticInferenceAccelerator
    #   data as a hash:
    #
    #       {
    #         type: "String", # required
    #         count: 1,
    #       }
    #
    # @!attribute [rw] type
    #   The type of elastic inference accelerator. The possible values are
    #   `eia1.medium`, `eia1.large`, and `eia1.xlarge`.
    #   @return [String]
    #
    # @!attribute [rw] count
    #   The number of elastic inference accelerators to attach to the
    #   instance.
    #
    #   Default: 1
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ElasticInferenceAccelerator AWS API Documentation
    #
    class ElasticInferenceAccelerator < Struct.new(
      :type,
      :count)
      include Aws::Structure
    end

    # Describes the association between an instance and an elastic inference
    # accelerator.
    #
    # @!attribute [rw] elastic_inference_accelerator_arn
    #   The Amazon Resource Name (ARN) of the elastic inference accelerator.
    #   @return [String]
    #
    # @!attribute [rw] elastic_inference_accelerator_association_id
    #   The ID of the association.
    #   @return [String]
    #
    # @!attribute [rw] elastic_inference_accelerator_association_state
    #   The state of the elastic inference accelerator.
    #   @return [String]
    #
    # @!attribute [rw] elastic_inference_accelerator_association_time
    #   The time at which the elastic inference accelerator is associated
    #   with an instance.
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ElasticInferenceAcceleratorAssociation AWS API Documentation
    #
    class ElasticInferenceAcceleratorAssociation < Struct.new(
      :elastic_inference_accelerator_arn,
      :elastic_inference_accelerator_association_id,
      :elastic_inference_accelerator_association_state,
      :elastic_inference_accelerator_association_time)
      include Aws::Structure
    end

    # @note When making an API call, you may pass EnableEbsEncryptionByDefaultRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EnableEbsEncryptionByDefaultRequest AWS API Documentation
    #
    class EnableEbsEncryptionByDefaultRequest < Struct.new(
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] ebs_encryption_by_default
    #   The updated status of encryption by default.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EnableEbsEncryptionByDefaultResult AWS API Documentation
    #
    class EnableEbsEncryptionByDefaultResult < Struct.new(
      :ebs_encryption_by_default)
      include Aws::Structure
    end

    # Contains information about the errors that occurred when enabling fast
    # snapshot restores.
    #
    # @!attribute [rw] snapshot_id
    #   The ID of the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] fast_snapshot_restore_state_errors
    #   The errors.
    #   @return [Array<Types::EnableFastSnapshotRestoreStateErrorItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EnableFastSnapshotRestoreErrorItem AWS API Documentation
    #
    class EnableFastSnapshotRestoreErrorItem < Struct.new(
      :snapshot_id,
      :fast_snapshot_restore_state_errors)
      include Aws::Structure
    end

    # Describes an error that occurred when enabling fast snapshot restores.
    #
    # @!attribute [rw] code
    #   The error code.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   The error message.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EnableFastSnapshotRestoreStateError AWS API Documentation
    #
    class EnableFastSnapshotRestoreStateError < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # Contains information about an error that occurred when enabling fast
    # snapshot restores.
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone.
    #   @return [String]
    #
    # @!attribute [rw] error
    #   The error.
    #   @return [Types::EnableFastSnapshotRestoreStateError]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EnableFastSnapshotRestoreStateErrorItem AWS API Documentation
    #
    class EnableFastSnapshotRestoreStateErrorItem < Struct.new(
      :availability_zone,
      :error)
      include Aws::Structure
    end

    # Describes fast snapshot restores that were successfully enabled.
    #
    # @!attribute [rw] snapshot_id
    #   The ID of the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of fast snapshot restores.
    #   @return [String]
    #
    # @!attribute [rw] state_transition_reason
    #   The reason for the state transition. The possible values are as
    #   follows:
    #
    #   * `Client.UserInitiated` - The state successfully transitioned to
    #     `enabling` or `disabling`.
    #
    #   * `Client.UserInitiated - Lifecycle state transition` - The state
    #     successfully transitioned to `optimizing`, `enabled`, or
    #     `disabled`.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account that owns the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] owner_alias
    #   The alias of the snapshot owner.
    #   @return [String]
    #
    # @!attribute [rw] enabling_time
    #   The time at which fast snapshot restores entered the `enabling`
    #   state.
    #   @return [Time]
    #
    # @!attribute [rw] optimizing_time
    #   The time at which fast snapshot restores entered the `optimizing`
    #   state.
    #   @return [Time]
    #
    # @!attribute [rw] enabled_time
    #   The time at which fast snapshot restores entered the `enabled`
    #   state.
    #   @return [Time]
    #
    # @!attribute [rw] disabling_time
    #   The time at which fast snapshot restores entered the `disabling`
    #   state.
    #   @return [Time]
    #
    # @!attribute [rw] disabled_time
    #   The time at which fast snapshot restores entered the `disabled`
    #   state.
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EnableFastSnapshotRestoreSuccessItem AWS API Documentation
    #
    class EnableFastSnapshotRestoreSuccessItem < Struct.new(
      :snapshot_id,
      :availability_zone,
      :state,
      :state_transition_reason,
      :owner_id,
      :owner_alias,
      :enabling_time,
      :optimizing_time,
      :enabled_time,
      :disabling_time,
      :disabled_time)
      include Aws::Structure
    end

    # @note When making an API call, you may pass EnableFastSnapshotRestoresRequest
    #   data as a hash:
    #
    #       {
    #         availability_zones: ["String"], # required
    #         source_snapshot_ids: ["SnapshotId"], # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] availability_zones
    #   One or more Availability Zones. For example, `us-east-2a`.
    #   @return [Array<String>]
    #
    # @!attribute [rw] source_snapshot_ids
    #   The IDs of one or more snapshots. For example,
    #   `snap-1234567890abcdef0`. You can specify a snapshot that was shared
    #   with you from another AWS account.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EnableFastSnapshotRestoresRequest AWS API Documentation
    #
    class EnableFastSnapshotRestoresRequest < Struct.new(
      :availability_zones,
      :source_snapshot_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] successful
    #   Information about the snapshots for which fast snapshot restores
    #   were successfully enabled.
    #   @return [Array<Types::EnableFastSnapshotRestoreSuccessItem>]
    #
    # @!attribute [rw] unsuccessful
    #   Information about the snapshots for which fast snapshot restores
    #   could not be enabled.
    #   @return [Array<Types::EnableFastSnapshotRestoreErrorItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EnableFastSnapshotRestoresResult AWS API Documentation
    #
    class EnableFastSnapshotRestoresResult < Struct.new(
      :successful,
      :unsuccessful)
      include Aws::Structure
    end

    # @note When making an API call, you may pass EnableTransitGatewayRouteTablePropagationRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_route_table_id: "TransitGatewayRouteTableId", # required
    #         transit_gateway_attachment_id: "TransitGatewayAttachmentId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the propagation route table.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EnableTransitGatewayRouteTablePropagationRequest AWS API Documentation
    #
    class EnableTransitGatewayRouteTablePropagationRequest < Struct.new(
      :transit_gateway_route_table_id,
      :transit_gateway_attachment_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] propagation
    #   Information about route propagation.
    #   @return [Types::TransitGatewayPropagation]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EnableTransitGatewayRouteTablePropagationResult AWS API Documentation
    #
    class EnableTransitGatewayRouteTablePropagationResult < Struct.new(
      :propagation)
      include Aws::Structure
    end

    # Contains the parameters for EnableVgwRoutePropagation.
    #
    # @note When making an API call, you may pass EnableVgwRoutePropagationRequest
    #   data as a hash:
    #
    #       {
    #         gateway_id: "VpnGatewayId", # required
    #         route_table_id: "RouteTableId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] gateway_id
    #   The ID of the virtual private gateway that is attached to a VPC. The
    #   virtual private gateway must be attached to the same VPC that the
    #   routing tables are associated with.
    #   @return [String]
    #
    # @!attribute [rw] route_table_id
    #   The ID of the route table. The routing table must be associated with
    #   the same VPC that the virtual private gateway is attached to.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EnableVgwRoutePropagationRequest AWS API Documentation
    #
    class EnableVgwRoutePropagationRequest < Struct.new(
      :gateway_id,
      :route_table_id,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass EnableVolumeIORequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         volume_id: "VolumeId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] volume_id
    #   The ID of the volume.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EnableVolumeIORequest AWS API Documentation
    #
    class EnableVolumeIORequest < Struct.new(
      :dry_run,
      :volume_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass EnableVpcClassicLinkDnsSupportRequest
    #   data as a hash:
    #
    #       {
    #         vpc_id: "VpcId",
    #       }
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EnableVpcClassicLinkDnsSupportRequest AWS API Documentation
    #
    class EnableVpcClassicLinkDnsSupportRequest < Struct.new(
      :vpc_id)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EnableVpcClassicLinkDnsSupportResult AWS API Documentation
    #
    class EnableVpcClassicLinkDnsSupportResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass EnableVpcClassicLinkRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         vpc_id: "VpcId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EnableVpcClassicLinkRequest AWS API Documentation
    #
    class EnableVpcClassicLinkRequest < Struct.new(
      :dry_run,
      :vpc_id)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EnableVpcClassicLinkResult AWS API Documentation
    #
    class EnableVpcClassicLinkResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # Describes an EC2 Fleet or Spot Fleet event.
    #
    # @!attribute [rw] event_description
    #   The description of the event.
    #   @return [String]
    #
    # @!attribute [rw] event_sub_type
    #   The event.
    #
    #   The following are the `error` events:
    #
    #   * `iamFleetRoleInvalid` - The EC2 Fleet or Spot Fleet did not have
    #     the required permissions either to launch or terminate an
    #     instance.
    #
    #   * `spotFleetRequestConfigurationInvalid` - The configuration is not
    #     valid. For more information, see the description of the event.
    #
    #   * `spotInstanceCountLimitExceeded` - You've reached the limit on
    #     the number of Spot Instances that you can launch.
    #
    #   The following are the `fleetRequestChange` events:
    #
    #   * `active` - The EC2 Fleet or Spot Fleet request has been validated
    #     and Amazon EC2 is attempting to maintain the target number of
    #     running Spot Instances.
    #
    #   * `cancelled` - The EC2 Fleet or Spot Fleet request is canceled and
    #     has no running Spot Instances. The EC2 Fleet or Spot Fleet will be
    #     deleted two days after its instances were terminated.
    #
    #   * `cancelled_running` - The EC2 Fleet or Spot Fleet request is
    #     canceled and does not launch additional Spot Instances. Existing
    #     Spot Instances continue to run until they are interrupted or
    #     terminated.
    #
    #   * `cancelled_terminating` - The EC2 Fleet or Spot Fleet request is
    #     canceled and its Spot Instances are terminating.
    #
    #   * `expired` - The EC2 Fleet or Spot Fleet request has expired. A
    #     subsequent event indicates that the instances were terminated, if
    #     the request was created with `TerminateInstancesWithExpiration`
    #     set.
    #
    #   * `modify_in_progress` - A request to modify the EC2 Fleet or Spot
    #     Fleet request was accepted and is in progress.
    #
    #   * `modify_successful` - The EC2 Fleet or Spot Fleet request was
    #     modified.
    #
    #   * `price_update` - The price for a launch configuration was adjusted
    #     because it was too high. This change is permanent.
    #
    #   * `submitted` - The EC2 Fleet or Spot Fleet request is being
    #     evaluated and Amazon EC2 is preparing to launch the target number
    #     of Spot Instances.
    #
    #   The following are the `instanceChange` events:
    #
    #   * `launched` - A request was fulfilled and a new instance was
    #     launched.
    #
    #   * `terminated` - An instance was terminated by the user.
    #
    #   The following are the `Information` events:
    #
    #   * `launchSpecTemporarilyBlacklisted` - The configuration is not
    #     valid and several attempts to launch instances have failed. For
    #     more information, see the description of the event.
    #
    #   * `launchSpecUnusable` - The price in a launch specification is not
    #     valid because it is below the Spot price or the Spot price is
    #     above the On-Demand price.
    #
    #   * `fleetProgressHalted` - The price in every launch specification is
    #     not valid. A launch specification might become valid if the Spot
    #     price changes.
    #   @return [String]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance. This information is available only for
    #   `instanceChange` events.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/EventInformation AWS API Documentation
    #
    class EventInformation < Struct.new(
      :event_description,
      :event_sub_type,
      :instance_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ExportClientVpnClientCertificateRevocationListRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ExportClientVpnClientCertificateRevocationListRequest AWS API Documentation
    #
    class ExportClientVpnClientCertificateRevocationListRequest < Struct.new(
      :client_vpn_endpoint_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] certificate_revocation_list
    #   Information about the client certificate revocation list.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The current state of the client certificate revocation list.
    #   @return [Types::ClientCertificateRevocationListStatus]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ExportClientVpnClientCertificateRevocationListResult AWS API Documentation
    #
    class ExportClientVpnClientCertificateRevocationListResult < Struct.new(
      :certificate_revocation_list,
      :status)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ExportClientVpnClientConfigurationRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ExportClientVpnClientConfigurationRequest AWS API Documentation
    #
    class ExportClientVpnClientConfigurationRequest < Struct.new(
      :client_vpn_endpoint_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] client_configuration
    #   The contents of the Client VPN endpoint configuration file.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ExportClientVpnClientConfigurationResult AWS API Documentation
    #
    class ExportClientVpnClientConfigurationResult < Struct.new(
      :client_configuration)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ExportImageRequest
    #   data as a hash:
    #
    #       {
    #         client_token: "String",
    #         description: "String",
    #         disk_image_format: "VMDK", # required, accepts VMDK, RAW, VHD
    #         dry_run: false,
    #         image_id: "ImageId", # required
    #         s3_export_location: { # required
    #           s3_bucket: "String", # required
    #           s3_prefix: "String",
    #         },
    #         role_name: "String",
    #       }
    #
    # @!attribute [rw] client_token
    #   Token to enable idempotency for export image requests.
    #
    #   **A suitable default value is auto-generated.** You should normally
    #   not need to pass this option.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   A description of the image being exported. The maximum length is 255
    #   bytes.
    #   @return [String]
    #
    # @!attribute [rw] disk_image_format
    #   The disk image format.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] image_id
    #   The ID of the image.
    #   @return [String]
    #
    # @!attribute [rw] s3_export_location
    #   Information about the destination S3 bucket. The bucket must exist
    #   and grant WRITE and READ\_ACP permissions to the AWS account
    #   vm-import-export@amazon.com.
    #   @return [Types::ExportTaskS3LocationRequest]
    #
    # @!attribute [rw] role_name
    #   The name of the role that grants VM Import/Export permission to
    #   export images to your S3 bucket. If this parameter is not specified,
    #   the default role is named 'vmimport'.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ExportImageRequest AWS API Documentation
    #
    class ExportImageRequest < Struct.new(
      :client_token,
      :description,
      :disk_image_format,
      :dry_run,
      :image_id,
      :s3_export_location,
      :role_name)
      include Aws::Structure
    end

    # @!attribute [rw] description
    #   A description of the image being exported.
    #   @return [String]
    #
    # @!attribute [rw] disk_image_format
    #   The disk image format for the exported image.
    #   @return [String]
    #
    # @!attribute [rw] export_image_task_id
    #   The ID of the export image task.
    #   @return [String]
    #
    # @!attribute [rw] image_id
    #   The ID of the image.
    #   @return [String]
    #
    # @!attribute [rw] role_name
    #   The name of the role that grants VM Import/Export permission to
    #   export images to your S3 bucket.
    #   @return [String]
    #
    # @!attribute [rw] progress
    #   The percent complete of the export image task.
    #   @return [String]
    #
    # @!attribute [rw] s3_export_location
    #   Information about the destination S3 bucket.
    #   @return [Types::ExportTaskS3Location]
    #
    # @!attribute [rw] status
    #   The status of the export image task. The possible values are
    #   `active`, `completed`, `deleting`, and `deleted`.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   The status message for the export image task.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ExportImageResult AWS API Documentation
    #
    class ExportImageResult < Struct.new(
      :description,
      :disk_image_format,
      :export_image_task_id,
      :image_id,
      :role_name,
      :progress,
      :s3_export_location,
      :status,
      :status_message)
      include Aws::Structure
    end

    # Describes an export image task.
    #
    # @!attribute [rw] description
    #   A description of the image being exported.
    #   @return [String]
    #
    # @!attribute [rw] export_image_task_id
    #   The ID of the export image task.
    #   @return [String]
    #
    # @!attribute [rw] image_id
    #   The ID of the image.
    #   @return [String]
    #
    # @!attribute [rw] progress
    #   The percent complete of the export image task.
    #   @return [String]
    #
    # @!attribute [rw] s3_export_location
    #   Information about the destination S3 bucket.
    #   @return [Types::ExportTaskS3Location]
    #
    # @!attribute [rw] status
    #   The status of the export image task. The possible values are
    #   `active`, `completed`, `deleting`, and `deleted`.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   The status message for the export image task.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ExportImageTask AWS API Documentation
    #
    class ExportImageTask < Struct.new(
      :description,
      :export_image_task_id,
      :image_id,
      :progress,
      :s3_export_location,
      :status,
      :status_message)
      include Aws::Structure
    end

    # Describes an instance export task.
    #
    # @!attribute [rw] description
    #   A description of the resource being exported.
    #   @return [String]
    #
    # @!attribute [rw] export_task_id
    #   The ID of the export task.
    #   @return [String]
    #
    # @!attribute [rw] export_to_s3_task
    #   Information about the export task.
    #   @return [Types::ExportToS3Task]
    #
    # @!attribute [rw] instance_export_details
    #   Information about the instance to export.
    #   @return [Types::InstanceExportDetails]
    #
    # @!attribute [rw] state
    #   The state of the export task.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   The status message related to the export task.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags for the export task.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ExportTask AWS API Documentation
    #
    class ExportTask < Struct.new(
      :description,
      :export_task_id,
      :export_to_s3_task,
      :instance_export_details,
      :state,
      :status_message,
      :tags)
      include Aws::Structure
    end

    # Describes the destination for an export image task.
    #
    # @!attribute [rw] s3_bucket
    #   The destination S3 bucket.
    #   @return [String]
    #
    # @!attribute [rw] s3_prefix
    #   The prefix (logical hierarchy) in the bucket.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ExportTaskS3Location AWS API Documentation
    #
    class ExportTaskS3Location < Struct.new(
      :s3_bucket,
      :s3_prefix)
      include Aws::Structure
    end

    # Describes the destination for an export image task.
    #
    # @note When making an API call, you may pass ExportTaskS3LocationRequest
    #   data as a hash:
    #
    #       {
    #         s3_bucket: "String", # required
    #         s3_prefix: "String",
    #       }
    #
    # @!attribute [rw] s3_bucket
    #   The destination S3 bucket.
    #   @return [String]
    #
    # @!attribute [rw] s3_prefix
    #   The prefix (logical hierarchy) in the bucket.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ExportTaskS3LocationRequest AWS API Documentation
    #
    class ExportTaskS3LocationRequest < Struct.new(
      :s3_bucket,
      :s3_prefix)
      include Aws::Structure
    end

    # Describes the format and location for an instance export task.
    #
    # @!attribute [rw] container_format
    #   The container format used to combine disk images with metadata (such
    #   as OVF). If absent, only the disk image is exported.
    #   @return [String]
    #
    # @!attribute [rw] disk_image_format
    #   The format for the exported image.
    #   @return [String]
    #
    # @!attribute [rw] s3_bucket
    #   The S3 bucket for the destination image. The destination bucket must
    #   exist and grant WRITE and READ\_ACP permissions to the AWS account
    #   `vm-import-export@amazon.com`.
    #   @return [String]
    #
    # @!attribute [rw] s3_key
    #   The encryption key for your S3 bucket.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ExportToS3Task AWS API Documentation
    #
    class ExportToS3Task < Struct.new(
      :container_format,
      :disk_image_format,
      :s3_bucket,
      :s3_key)
      include Aws::Structure
    end

    # Describes an instance export task.
    #
    # @note When making an API call, you may pass ExportToS3TaskSpecification
    #   data as a hash:
    #
    #       {
    #         container_format: "ova", # accepts ova
    #         disk_image_format: "VMDK", # accepts VMDK, RAW, VHD
    #         s3_bucket: "String",
    #         s3_prefix: "String",
    #       }
    #
    # @!attribute [rw] container_format
    #   The container format used to combine disk images with metadata (such
    #   as OVF). If absent, only the disk image is exported.
    #   @return [String]
    #
    # @!attribute [rw] disk_image_format
    #   The format for the exported image.
    #   @return [String]
    #
    # @!attribute [rw] s3_bucket
    #   The S3 bucket for the destination image. The destination bucket must
    #   exist and grant WRITE and READ\_ACP permissions to the AWS account
    #   `vm-import-export@amazon.com`.
    #   @return [String]
    #
    # @!attribute [rw] s3_prefix
    #   The image is written to a single object in the S3 bucket at the S3
    #   key s3prefix + exportTaskId + '.' + diskImageFormat.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ExportToS3TaskSpecification AWS API Documentation
    #
    class ExportToS3TaskSpecification < Struct.new(
      :container_format,
      :disk_image_format,
      :s3_bucket,
      :s3_prefix)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ExportTransitGatewayRoutesRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_route_table_id: "TransitGatewayRouteTableId", # required
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         s3_bucket: "String", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the route table.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters. The possible values are:
    #
    #   * `attachment.transit-gateway-attachment-id` - The id of the transit
    #     gateway attachment.
    #
    #   * `attachment.resource-id` - The resource id of the transit gateway
    #     attachment.
    #
    #   * `route-search.exact-match` - The exact match of the specified
    #     filter.
    #
    #   * `route-search.longest-prefix-match` - The longest prefix that
    #     matches the route.
    #
    #   * `route-search.subnet-of-match` - The routes with a subnet that
    #     match the specified CIDR filter.
    #
    #   * `route-search.supernet-of-match` - The routes with a CIDR that
    #     encompass the CIDR filter. For example, if you have 10.0.1.0/29
    #     and 10.0.1.0/31 routes in your route table and you specify
    #     supernet-of-match as 10.0.1.0/30, then the result returns
    #     10.0.1.0/29.
    #
    #   * `state` - The state of the attachment (`available` \| `deleted` \|
    #     `deleting` \| `failed` \| `modifying` \| `pendingAcceptance` \|
    #     `pending` \| `rollingBack` \| `rejected` \| `rejecting`).
    #
    #   * `transit-gateway-route-destination-cidr-block` - The CIDR range.
    #
    #   * `type` - The type of route (`active` \| `blackhole`).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] s3_bucket
    #   The name of the S3 bucket.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ExportTransitGatewayRoutesRequest AWS API Documentation
    #
    class ExportTransitGatewayRoutesRequest < Struct.new(
      :transit_gateway_route_table_id,
      :filters,
      :s3_bucket,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] s3_location
    #   The URL of the exported file in Amazon S3. For example,
    #   s3://*bucket\_name*/VPCTransitGateway/TransitGatewayRouteTables/*file\_name*.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ExportTransitGatewayRoutesResult AWS API Documentation
    #
    class ExportTransitGatewayRoutesResult < Struct.new(
      :s3_location)
      include Aws::Structure
    end

    # Describes a Reserved Instance whose queued purchase was not deleted.
    #
    # @!attribute [rw] error
    #   The error.
    #   @return [Types::DeleteQueuedReservedInstancesError]
    #
    # @!attribute [rw] reserved_instances_id
    #   The ID of the Reserved Instance.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FailedQueuedPurchaseDeletion AWS API Documentation
    #
    class FailedQueuedPurchaseDeletion < Struct.new(
      :error,
      :reserved_instances_id)
      include Aws::Structure
    end

    # Describes the IAM SAML identity provider used for federated
    # authentication.
    #
    # @!attribute [rw] saml_provider_arn
    #   The Amazon Resource Name (ARN) of the IAM SAML identity provider.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FederatedAuthentication AWS API Documentation
    #
    class FederatedAuthentication < Struct.new(
      :saml_provider_arn)
      include Aws::Structure
    end

    # The IAM SAML identity provider used for federated authentication.
    #
    # @note When making an API call, you may pass FederatedAuthenticationRequest
    #   data as a hash:
    #
    #       {
    #         saml_provider_arn: "String",
    #       }
    #
    # @!attribute [rw] saml_provider_arn
    #   The Amazon Resource Name (ARN) of the IAM SAML identity provider.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FederatedAuthenticationRequest AWS API Documentation
    #
    class FederatedAuthenticationRequest < Struct.new(
      :saml_provider_arn)
      include Aws::Structure
    end

    # A filter name and value pair that is used to return a more specific
    # list of results from a describe operation. Filters can be used to
    # match a set of resources by specific criteria, such as tags,
    # attributes, or IDs. The filters supported by a describe operation are
    # documented with the describe operation. For example:
    #
    # * DescribeAvailabilityZones
    #
    # * DescribeImages
    #
    # * DescribeInstances
    #
    # * DescribeKeyPairs
    #
    # * DescribeSecurityGroups
    #
    # * DescribeSnapshots
    #
    # * DescribeSubnets
    #
    # * DescribeTags
    #
    # * DescribeVolumes
    #
    # * DescribeVpcs
    #
    # @note When making an API call, you may pass Filter
    #   data as a hash:
    #
    #       {
    #         name: "String",
    #         values: ["String"],
    #       }
    #
    # @!attribute [rw] name
    #   The name of the filter. Filter names are case-sensitive.
    #   @return [String]
    #
    # @!attribute [rw] values
    #   The filter values. Filter values are case-sensitive.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Filter AWS API Documentation
    #
    class Filter < Struct.new(
      :name,
      :values)
      include Aws::Structure
    end

    # Describes an EC2 Fleet.
    #
    # @!attribute [rw] activity_status
    #   The progress of the EC2 Fleet. If there is an error, the status is
    #   `error`. After all requests are placed, the status is
    #   `pending_fulfillment`. If the size of the EC2 Fleet is equal to or
    #   greater than its target capacity, the status is `fulfilled`. If the
    #   size of the EC2 Fleet is decreased, the status is
    #   `pending_termination` while instances are terminating.
    #   @return [String]
    #
    # @!attribute [rw] create_time
    #   The creation date and time of the EC2 Fleet.
    #   @return [Time]
    #
    # @!attribute [rw] fleet_id
    #   The ID of the EC2 Fleet.
    #   @return [String]
    #
    # @!attribute [rw] fleet_state
    #   The state of the EC2 Fleet.
    #   @return [String]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [Ensuring
    #   Idempotency][1].
    #
    #   Constraints: Maximum 64 ASCII characters
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] excess_capacity_termination_policy
    #   Indicates whether running instances should be terminated if the
    #   target capacity of the EC2 Fleet is decreased below the current size
    #   of the EC2 Fleet.
    #   @return [String]
    #
    # @!attribute [rw] fulfilled_capacity
    #   The number of units fulfilled by this request compared to the set
    #   target capacity.
    #   @return [Float]
    #
    # @!attribute [rw] fulfilled_on_demand_capacity
    #   The number of units fulfilled by this request compared to the set
    #   target On-Demand capacity.
    #   @return [Float]
    #
    # @!attribute [rw] launch_template_configs
    #   The launch template and overrides.
    #   @return [Array<Types::FleetLaunchTemplateConfig>]
    #
    # @!attribute [rw] target_capacity_specification
    #   The number of units to request. You can choose to set the target
    #   capacity in terms of instances or a performance characteristic that
    #   is important to your application workload, such as vCPUs, memory, or
    #   I/O. If the request type is `maintain`, you can specify a target
    #   capacity of 0 and add capacity later.
    #   @return [Types::TargetCapacitySpecification]
    #
    # @!attribute [rw] terminate_instances_with_expiration
    #   Indicates whether running instances should be terminated when the
    #   EC2 Fleet expires.
    #   @return [Boolean]
    #
    # @!attribute [rw] type
    #   The type of request. Indicates whether the EC2 Fleet only `requests`
    #   the target capacity, or also attempts to `maintain` it. If you
    #   request a certain target capacity, EC2 Fleet only places the
    #   required requests; it does not attempt to replenish instances if
    #   capacity is diminished, and it does not submit requests in
    #   alternative capacity pools if capacity is unavailable. To maintain a
    #   certain target capacity, EC2 Fleet places the required requests to
    #   meet this target capacity. It also automatically replenishes any
    #   interrupted Spot Instances. Default: `maintain`.
    #   @return [String]
    #
    # @!attribute [rw] valid_from
    #   The start date and time of the request, in UTC format (for example,
    #   *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z). The default is to start
    #   fulfilling the request immediately.
    #   @return [Time]
    #
    # @!attribute [rw] valid_until
    #   The end date and time of the request, in UTC format (for example,
    #   *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z). At this point, no new instance
    #   requests are placed or able to fulfill the request. The default end
    #   date is 7 days from the current date.
    #   @return [Time]
    #
    # @!attribute [rw] replace_unhealthy_instances
    #   Indicates whether EC2 Fleet should replace unhealthy instances.
    #   @return [Boolean]
    #
    # @!attribute [rw] spot_options
    #   The configuration of Spot Instances in an EC2 Fleet.
    #   @return [Types::SpotOptions]
    #
    # @!attribute [rw] on_demand_options
    #   The allocation strategy of On-Demand Instances in an EC2 Fleet.
    #   @return [Types::OnDemandOptions]
    #
    # @!attribute [rw] tags
    #   The tags for an EC2 Fleet resource.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] errors
    #   Information about the instances that could not be launched by the
    #   fleet. Valid only when **Type** is set to `instant`.
    #   @return [Array<Types::DescribeFleetError>]
    #
    # @!attribute [rw] instances
    #   Information about the instances that were launched by the fleet.
    #   Valid only when **Type** is set to `instant`.
    #   @return [Array<Types::DescribeFleetsInstances>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FleetData AWS API Documentation
    #
    class FleetData < Struct.new(
      :activity_status,
      :create_time,
      :fleet_id,
      :fleet_state,
      :client_token,
      :excess_capacity_termination_policy,
      :fulfilled_capacity,
      :fulfilled_on_demand_capacity,
      :launch_template_configs,
      :target_capacity_specification,
      :terminate_instances_with_expiration,
      :type,
      :valid_from,
      :valid_until,
      :replace_unhealthy_instances,
      :spot_options,
      :on_demand_options,
      :tags,
      :errors,
      :instances)
      include Aws::Structure
    end

    # Describes a launch template and overrides.
    #
    # @!attribute [rw] launch_template_specification
    #   The launch template.
    #   @return [Types::FleetLaunchTemplateSpecification]
    #
    # @!attribute [rw] overrides
    #   Any parameters that you specify override the same parameters in the
    #   launch template.
    #   @return [Array<Types::FleetLaunchTemplateOverrides>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FleetLaunchTemplateConfig AWS API Documentation
    #
    class FleetLaunchTemplateConfig < Struct.new(
      :launch_template_specification,
      :overrides)
      include Aws::Structure
    end

    # Describes a launch template and overrides.
    #
    # @note When making an API call, you may pass FleetLaunchTemplateConfigRequest
    #   data as a hash:
    #
    #       {
    #         launch_template_specification: {
    #           launch_template_id: "LaunchTemplateId",
    #           launch_template_name: "LaunchTemplateName",
    #           version: "String",
    #         },
    #         overrides: [
    #           {
    #             instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #             max_price: "String",
    #             subnet_id: "SubnetId",
    #             availability_zone: "String",
    #             weighted_capacity: 1.0,
    #             priority: 1.0,
    #             placement: {
    #               availability_zone: "String",
    #               affinity: "String",
    #               group_name: "String",
    #               partition_number: 1,
    #               host_id: "String",
    #               tenancy: "default", # accepts default, dedicated, host
    #               spread_domain: "String",
    #               host_resource_group_arn: "String",
    #             },
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] launch_template_specification
    #   The launch template to use. You must specify either the launch
    #   template ID or launch template name in the request.
    #   @return [Types::FleetLaunchTemplateSpecificationRequest]
    #
    # @!attribute [rw] overrides
    #   Any parameters that you specify override the same parameters in the
    #   launch template.
    #   @return [Array<Types::FleetLaunchTemplateOverridesRequest>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FleetLaunchTemplateConfigRequest AWS API Documentation
    #
    class FleetLaunchTemplateConfigRequest < Struct.new(
      :launch_template_specification,
      :overrides)
      include Aws::Structure
    end

    # Describes overrides for a launch template.
    #
    # @!attribute [rw] instance_type
    #   The instance type.
    #   @return [String]
    #
    # @!attribute [rw] max_price
    #   The maximum price per unit hour that you are willing to pay for a
    #   Spot Instance.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet in which to launch the instances.
    #   @return [String]
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone in which to launch the instances.
    #   @return [String]
    #
    # @!attribute [rw] weighted_capacity
    #   The number of units provided by the specified instance type.
    #   @return [Float]
    #
    # @!attribute [rw] priority
    #   The priority for the launch template override. If
    #   **AllocationStrategy** is set to `prioritized`, EC2 Fleet uses
    #   priority to determine which launch template override to use first in
    #   fulfilling On-Demand capacity. The highest priority is launched
    #   first. Valid values are whole numbers starting at `0`. The lower the
    #   number, the higher the priority. If no number is set, the override
    #   has the lowest priority.
    #   @return [Float]
    #
    # @!attribute [rw] placement
    #   The location where the instance launched, if applicable.
    #   @return [Types::PlacementResponse]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FleetLaunchTemplateOverrides AWS API Documentation
    #
    class FleetLaunchTemplateOverrides < Struct.new(
      :instance_type,
      :max_price,
      :subnet_id,
      :availability_zone,
      :weighted_capacity,
      :priority,
      :placement)
      include Aws::Structure
    end

    # Describes overrides for a launch template.
    #
    # @note When making an API call, you may pass FleetLaunchTemplateOverridesRequest
    #   data as a hash:
    #
    #       {
    #         instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #         max_price: "String",
    #         subnet_id: "SubnetId",
    #         availability_zone: "String",
    #         weighted_capacity: 1.0,
    #         priority: 1.0,
    #         placement: {
    #           availability_zone: "String",
    #           affinity: "String",
    #           group_name: "String",
    #           partition_number: 1,
    #           host_id: "String",
    #           tenancy: "default", # accepts default, dedicated, host
    #           spread_domain: "String",
    #           host_resource_group_arn: "String",
    #         },
    #       }
    #
    # @!attribute [rw] instance_type
    #   The instance type.
    #   @return [String]
    #
    # @!attribute [rw] max_price
    #   The maximum price per unit hour that you are willing to pay for a
    #   Spot Instance.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The IDs of the subnets in which to launch the instances. Separate
    #   multiple subnet IDs using commas (for example,
    #   `subnet-1234abcdeexample1, subnet-0987cdef6example2`). A request of
    #   type `instant` can have only one subnet ID.
    #   @return [String]
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone in which to launch the instances.
    #   @return [String]
    #
    # @!attribute [rw] weighted_capacity
    #   The number of units provided by the specified instance type.
    #   @return [Float]
    #
    # @!attribute [rw] priority
    #   The priority for the launch template override. If
    #   **AllocationStrategy** is set to `prioritized`, EC2 Fleet uses
    #   priority to determine which launch template override to use first in
    #   fulfilling On-Demand capacity. The highest priority is launched
    #   first. Valid values are whole numbers starting at `0`. The lower the
    #   number, the higher the priority. If no number is set, the launch
    #   template override has the lowest priority.
    #   @return [Float]
    #
    # @!attribute [rw] placement
    #   The location where the instance launched, if applicable.
    #   @return [Types::Placement]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FleetLaunchTemplateOverridesRequest AWS API Documentation
    #
    class FleetLaunchTemplateOverridesRequest < Struct.new(
      :instance_type,
      :max_price,
      :subnet_id,
      :availability_zone,
      :weighted_capacity,
      :priority,
      :placement)
      include Aws::Structure
    end

    # Describes the Amazon EC2 launch template and the launch template
    # version that can be used by a Spot Fleet request to configure Amazon
    # EC2 instances. For information about launch templates, see [Launching
    # an instance from a launch template][1] in the *Amazon EC2 User Guide
    # for Linux Instances*.
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-launch-templates.html
    #
    # @note When making an API call, you may pass FleetLaunchTemplateSpecification
    #   data as a hash:
    #
    #       {
    #         launch_template_id: "String",
    #         launch_template_name: "LaunchTemplateName",
    #         version: "String",
    #       }
    #
    # @!attribute [rw] launch_template_id
    #   The ID of the launch template. If you specify the template ID, you
    #   can't specify the template name.
    #   @return [String]
    #
    # @!attribute [rw] launch_template_name
    #   The name of the launch template. If you specify the template name,
    #   you can't specify the template ID.
    #   @return [String]
    #
    # @!attribute [rw] version
    #   The launch template version number, `$Latest`, or `$Default`. You
    #   must specify a value, otherwise the request fails.
    #
    #   If the value is `$Latest`, Amazon EC2 uses the latest version of the
    #   launch template.
    #
    #   If the value is `$Default`, Amazon EC2 uses the default version of
    #   the launch template.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FleetLaunchTemplateSpecification AWS API Documentation
    #
    class FleetLaunchTemplateSpecification < Struct.new(
      :launch_template_id,
      :launch_template_name,
      :version)
      include Aws::Structure
    end

    # Describes the Amazon EC2 launch template and the launch template
    # version that can be used by an EC2 Fleet to configure Amazon EC2
    # instances. For information about launch templates, see [Launching an
    # instance from a launch template][1] in the *Amazon Elastic Compute
    # Cloud User Guide*.
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-launch-templates.html
    #
    # @note When making an API call, you may pass FleetLaunchTemplateSpecificationRequest
    #   data as a hash:
    #
    #       {
    #         launch_template_id: "LaunchTemplateId",
    #         launch_template_name: "LaunchTemplateName",
    #         version: "String",
    #       }
    #
    # @!attribute [rw] launch_template_id
    #   The ID of the launch template. If you specify the template ID, you
    #   can't specify the template name.
    #   @return [String]
    #
    # @!attribute [rw] launch_template_name
    #   The name of the launch template. If you specify the template name,
    #   you can't specify the template ID.
    #   @return [String]
    #
    # @!attribute [rw] version
    #   The launch template version number, `$Latest`, or `$Default`. You
    #   must specify a value, otherwise the request fails.
    #
    #   If the value is `$Latest`, Amazon EC2 uses the latest version of the
    #   launch template.
    #
    #   If the value is `$Default`, Amazon EC2 uses the default version of
    #   the launch template.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FleetLaunchTemplateSpecificationRequest AWS API Documentation
    #
    class FleetLaunchTemplateSpecificationRequest < Struct.new(
      :launch_template_id,
      :launch_template_name,
      :version)
      include Aws::Structure
    end

    # Describes a flow log.
    #
    # @!attribute [rw] creation_time
    #   The date and time the flow log was created.
    #   @return [Time]
    #
    # @!attribute [rw] deliver_logs_error_message
    #   Information about the error that occurred. `Rate limited` indicates
    #   that CloudWatch Logs throttling has been applied for one or more
    #   network interfaces, or that you've reached the limit on the number
    #   of log groups that you can create. `Access error` indicates that the
    #   IAM role associated with the flow log does not have sufficient
    #   permissions to publish to CloudWatch Logs. `Unknown error` indicates
    #   an internal error.
    #   @return [String]
    #
    # @!attribute [rw] deliver_logs_permission_arn
    #   The ARN of the IAM role that posts logs to CloudWatch Logs.
    #   @return [String]
    #
    # @!attribute [rw] deliver_logs_status
    #   The status of the logs delivery (`SUCCESS` \| `FAILED`).
    #   @return [String]
    #
    # @!attribute [rw] flow_log_id
    #   The flow log ID.
    #   @return [String]
    #
    # @!attribute [rw] flow_log_status
    #   The status of the flow log (`ACTIVE`).
    #   @return [String]
    #
    # @!attribute [rw] log_group_name
    #   The name of the flow log group.
    #   @return [String]
    #
    # @!attribute [rw] resource_id
    #   The ID of the resource on which the flow log was created.
    #   @return [String]
    #
    # @!attribute [rw] traffic_type
    #   The type of traffic captured for the flow log.
    #   @return [String]
    #
    # @!attribute [rw] log_destination_type
    #   Specifies the type of destination to which the flow log data is
    #   published. Flow log data can be published to CloudWatch Logs or
    #   Amazon S3.
    #   @return [String]
    #
    # @!attribute [rw] log_destination
    #   Specifies the destination to which the flow log data is published.
    #   Flow log data can be published to an CloudWatch Logs log group or an
    #   Amazon S3 bucket. If the flow log publishes to CloudWatch Logs, this
    #   element indicates the Amazon Resource Name (ARN) of the CloudWatch
    #   Logs log group to which the data is published. If the flow log
    #   publishes to Amazon S3, this element indicates the ARN of the Amazon
    #   S3 bucket to which the data is published.
    #   @return [String]
    #
    # @!attribute [rw] log_format
    #   The format of the flow log record.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags for the flow log.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] max_aggregation_interval
    #   The maximum interval of time, in seconds, during which a flow of
    #   packets is captured and aggregated into a flow log record.
    #
    #   When a network interface is attached to a [Nitro-based instance][1],
    #   the aggregation interval is always 60 seconds (1 minute) or less,
    #   regardless of the specified value.
    #
    #   Valid Values: `60` \| `600`
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FlowLog AWS API Documentation
    #
    class FlowLog < Struct.new(
      :creation_time,
      :deliver_logs_error_message,
      :deliver_logs_permission_arn,
      :deliver_logs_status,
      :flow_log_id,
      :flow_log_status,
      :log_group_name,
      :resource_id,
      :traffic_type,
      :log_destination_type,
      :log_destination,
      :log_format,
      :tags,
      :max_aggregation_interval)
      include Aws::Structure
    end

    # Describes the FPGA accelerator for the instance type.
    #
    # @!attribute [rw] name
    #   The name of the FPGA accelerator.
    #   @return [String]
    #
    # @!attribute [rw] manufacturer
    #   The manufacturer of the FPGA accelerator.
    #   @return [String]
    #
    # @!attribute [rw] count
    #   The count of FPGA accelerators for the instance type.
    #   @return [Integer]
    #
    # @!attribute [rw] memory_info
    #   Describes the memory for the FPGA accelerator for the instance type.
    #   @return [Types::FpgaDeviceMemoryInfo]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FpgaDeviceInfo AWS API Documentation
    #
    class FpgaDeviceInfo < Struct.new(
      :name,
      :manufacturer,
      :count,
      :memory_info)
      include Aws::Structure
    end

    # Describes the memory for the FPGA accelerator for the instance type.
    #
    # @!attribute [rw] size_in_mi_b
    #   The size (in MiB) for the memory available to the FPGA accelerator.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FpgaDeviceMemoryInfo AWS API Documentation
    #
    class FpgaDeviceMemoryInfo < Struct.new(
      :size_in_mi_b)
      include Aws::Structure
    end

    # Describes an Amazon FPGA image (AFI).
    #
    # @!attribute [rw] fpga_image_id
    #   The FPGA image identifier (AFI ID).
    #   @return [String]
    #
    # @!attribute [rw] fpga_image_global_id
    #   The global FPGA image identifier (AGFI ID).
    #   @return [String]
    #
    # @!attribute [rw] name
    #   The name of the AFI.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   The description of the AFI.
    #   @return [String]
    #
    # @!attribute [rw] shell_version
    #   The version of the AWS Shell that was used to create the bitstream.
    #   @return [String]
    #
    # @!attribute [rw] pci_id
    #   Information about the PCI bus.
    #   @return [Types::PciId]
    #
    # @!attribute [rw] state
    #   Information about the state of the AFI.
    #   @return [Types::FpgaImageState]
    #
    # @!attribute [rw] create_time
    #   The date and time the AFI was created.
    #   @return [Time]
    #
    # @!attribute [rw] update_time
    #   The time of the most recent update to the AFI.
    #   @return [Time]
    #
    # @!attribute [rw] owner_id
    #   The AWS account ID of the AFI owner.
    #   @return [String]
    #
    # @!attribute [rw] owner_alias
    #   The alias of the AFI owner. Possible values include `self`,
    #   `amazon`, and `aws-marketplace`.
    #   @return [String]
    #
    # @!attribute [rw] product_codes
    #   The product codes for the AFI.
    #   @return [Array<Types::ProductCode>]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the AFI.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] public
    #   Indicates whether the AFI is public.
    #   @return [Boolean]
    #
    # @!attribute [rw] data_retention_support
    #   Indicates whether data retention support is enabled for the AFI.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FpgaImage AWS API Documentation
    #
    class FpgaImage < Struct.new(
      :fpga_image_id,
      :fpga_image_global_id,
      :name,
      :description,
      :shell_version,
      :pci_id,
      :state,
      :create_time,
      :update_time,
      :owner_id,
      :owner_alias,
      :product_codes,
      :tags,
      :public,
      :data_retention_support)
      include Aws::Structure
    end

    # Describes an Amazon FPGA image (AFI) attribute.
    #
    # @!attribute [rw] fpga_image_id
    #   The ID of the AFI.
    #   @return [String]
    #
    # @!attribute [rw] name
    #   The name of the AFI.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   The description of the AFI.
    #   @return [String]
    #
    # @!attribute [rw] load_permissions
    #   The load permissions.
    #   @return [Array<Types::LoadPermission>]
    #
    # @!attribute [rw] product_codes
    #   The product codes.
    #   @return [Array<Types::ProductCode>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FpgaImageAttribute AWS API Documentation
    #
    class FpgaImageAttribute < Struct.new(
      :fpga_image_id,
      :name,
      :description,
      :load_permissions,
      :product_codes)
      include Aws::Structure
    end

    # Describes the state of the bitstream generation process for an Amazon
    # FPGA image (AFI).
    #
    # @!attribute [rw] code
    #   The state. The following are the possible values:
    #
    #   * `pending` - AFI bitstream generation is in progress.
    #
    #   * `available` - The AFI is available for use.
    #
    #   * `failed` - AFI bitstream generation failed.
    #
    #   * `unavailable` - The AFI is no longer available for use.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   If the state is `failed`, this is the error message.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FpgaImageState AWS API Documentation
    #
    class FpgaImageState < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # Describes the FPGAs for the instance type.
    #
    # @!attribute [rw] fpgas
    #   Describes the FPGAs for the instance type.
    #   @return [Array<Types::FpgaDeviceInfo>]
    #
    # @!attribute [rw] total_fpga_memory_in_mi_b
    #   The total memory of all FPGA accelerators for the instance type.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/FpgaInfo AWS API Documentation
    #
    class FpgaInfo < Struct.new(
      :fpgas,
      :total_fpga_memory_in_mi_b)
      include Aws::Structure
    end

    # @note When making an API call, you may pass GetAssociatedIpv6PoolCidrsRequest
    #   data as a hash:
    #
    #       {
    #         pool_id: "Ipv6PoolEc2Id", # required
    #         next_token: "NextToken",
    #         max_results: 1,
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] pool_id
    #   The ID of the IPv6 address pool.
    #   @return [String]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetAssociatedIpv6PoolCidrsRequest AWS API Documentation
    #
    class GetAssociatedIpv6PoolCidrsRequest < Struct.new(
      :pool_id,
      :next_token,
      :max_results,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] ipv_6_cidr_associations
    #   Information about the IPv6 CIDR block associations.
    #   @return [Array<Types::Ipv6CidrAssociation>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetAssociatedIpv6PoolCidrsResult AWS API Documentation
    #
    class GetAssociatedIpv6PoolCidrsResult < Struct.new(
      :ipv_6_cidr_associations,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass GetCapacityReservationUsageRequest
    #   data as a hash:
    #
    #       {
    #         capacity_reservation_id: "CapacityReservationId", # required
    #         next_token: "String",
    #         max_results: 1,
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] capacity_reservation_id
    #   The ID of the Capacity Reservation.
    #   @return [String]
    #
    # @!attribute [rw] next_token
    #   The token to retrieve the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return for the request in a single
    #   page. The remaining results can be seen by sending another request
    #   with the returned nextToken value.
    #
    #   Valid range: Minimum value of 1. Maximum value of 1000.
    #   @return [Integer]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetCapacityReservationUsageRequest AWS API Documentation
    #
    class GetCapacityReservationUsageRequest < Struct.new(
      :capacity_reservation_id,
      :next_token,
      :max_results,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @!attribute [rw] capacity_reservation_id
    #   The ID of the Capacity Reservation.
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   The type of instance for which the Capacity Reservation reserves
    #   capacity.
    #   @return [String]
    #
    # @!attribute [rw] total_instance_count
    #   The number of instances for which the Capacity Reservation reserves
    #   capacity.
    #   @return [Integer]
    #
    # @!attribute [rw] available_instance_count
    #   The remaining capacity. Indicates the number of instances that can
    #   be launched in the Capacity Reservation.
    #   @return [Integer]
    #
    # @!attribute [rw] state
    #   The current state of the Capacity Reservation. A Capacity
    #   Reservation can be in one of the following states:
    #
    #   * `active` - The Capacity Reservation is active and the capacity is
    #     available for your use.
    #
    #   * `expired` - The Capacity Reservation expired automatically at the
    #     date and time specified in your request. The reserved capacity is
    #     no longer available for your use.
    #
    #   * `cancelled` - The Capacity Reservation was manually cancelled. The
    #     reserved capacity is no longer available for your use.
    #
    #   * `pending` - The Capacity Reservation request was successful but
    #     the capacity provisioning is still pending.
    #
    #   * `failed` - The Capacity Reservation request has failed. A request
    #     might fail due to invalid request parameters, capacity
    #     constraints, or instance limit constraints. Failed requests are
    #     retained for 60 minutes.
    #   @return [String]
    #
    # @!attribute [rw] instance_usages
    #   Information about the Capacity Reservation usage.
    #   @return [Array<Types::InstanceUsage>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetCapacityReservationUsageResult AWS API Documentation
    #
    class GetCapacityReservationUsageResult < Struct.new(
      :next_token,
      :capacity_reservation_id,
      :instance_type,
      :total_instance_count,
      :available_instance_count,
      :state,
      :instance_usages)
      include Aws::Structure
    end

    # @note When making an API call, you may pass GetCoipPoolUsageRequest
    #   data as a hash:
    #
    #       {
    #         pool_id: "CoipPoolId", # required
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] pool_id
    #   The ID of the address pool.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   The filters. The following are the possible values:
    #
    #   * `coip-address-usage.allocation-id`
    #
    #   ^
    #   ^
    #
    #   * `coip-address-usage.aws-account-id`
    #
    #   ^
    #   ^
    #
    #   * `coip-address-usage.aws-service`
    #
    #   ^
    #   ^
    #
    #   * `coip-address-usage.co-ip`
    #
    #   ^
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetCoipPoolUsageRequest AWS API Documentation
    #
    class GetCoipPoolUsageRequest < Struct.new(
      :pool_id,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] coip_pool_id
    #   The ID of the customer-owned address pool.
    #   @return [String]
    #
    # @!attribute [rw] coip_address_usages
    #   Information about the address usage.
    #   @return [Array<Types::CoipAddressUsage>]
    #
    # @!attribute [rw] local_gateway_route_table_id
    #   The ID of the local gateway route table.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetCoipPoolUsageResult AWS API Documentation
    #
    class GetCoipPoolUsageResult < Struct.new(
      :coip_pool_id,
      :coip_address_usages,
      :local_gateway_route_table_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass GetConsoleOutputRequest
    #   data as a hash:
    #
    #       {
    #         instance_id: "InstanceId", # required
    #         dry_run: false,
    #         latest: false,
    #       }
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] latest
    #   When enabled, retrieves the latest console output for the instance.
    #
    #   Default: disabled (`false`)
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetConsoleOutputRequest AWS API Documentation
    #
    class GetConsoleOutputRequest < Struct.new(
      :instance_id,
      :dry_run,
      :latest)
      include Aws::Structure
    end

    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] output
    #   The console output, base64-encoded. If you are using a command line
    #   tool, the tool decodes the output for you.
    #   @return [String]
    #
    # @!attribute [rw] timestamp
    #   The time at which the output was last updated.
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetConsoleOutputResult AWS API Documentation
    #
    class GetConsoleOutputResult < Struct.new(
      :instance_id,
      :output,
      :timestamp)
      include Aws::Structure
    end

    # @note When making an API call, you may pass GetConsoleScreenshotRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         instance_id: "InstanceId", # required
    #         wake_up: false,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] wake_up
    #   When set to `true`, acts as keystroke input and wakes up an instance
    #   that's in standby or "sleep" mode.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetConsoleScreenshotRequest AWS API Documentation
    #
    class GetConsoleScreenshotRequest < Struct.new(
      :dry_run,
      :instance_id,
      :wake_up)
      include Aws::Structure
    end

    # @!attribute [rw] image_data
    #   The data that comprises the image.
    #   @return [String]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetConsoleScreenshotResult AWS API Documentation
    #
    class GetConsoleScreenshotResult < Struct.new(
      :image_data,
      :instance_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass GetDefaultCreditSpecificationRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         instance_family: "t2", # required, accepts t2, t3, t3a
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_family
    #   The instance family.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetDefaultCreditSpecificationRequest AWS API Documentation
    #
    class GetDefaultCreditSpecificationRequest < Struct.new(
      :dry_run,
      :instance_family)
      include Aws::Structure
    end

    # @!attribute [rw] instance_family_credit_specification
    #   The default credit option for CPU usage of the instance family.
    #   @return [Types::InstanceFamilyCreditSpecification]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetDefaultCreditSpecificationResult AWS API Documentation
    #
    class GetDefaultCreditSpecificationResult < Struct.new(
      :instance_family_credit_specification)
      include Aws::Structure
    end

    # @note When making an API call, you may pass GetEbsDefaultKmsKeyIdRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetEbsDefaultKmsKeyIdRequest AWS API Documentation
    #
    class GetEbsDefaultKmsKeyIdRequest < Struct.new(
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] kms_key_id
    #   The Amazon Resource Name (ARN) of the default CMK for encryption by
    #   default.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetEbsDefaultKmsKeyIdResult AWS API Documentation
    #
    class GetEbsDefaultKmsKeyIdResult < Struct.new(
      :kms_key_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass GetEbsEncryptionByDefaultRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetEbsEncryptionByDefaultRequest AWS API Documentation
    #
    class GetEbsEncryptionByDefaultRequest < Struct.new(
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] ebs_encryption_by_default
    #   Indicates whether encryption by default is enabled.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetEbsEncryptionByDefaultResult AWS API Documentation
    #
    class GetEbsEncryptionByDefaultResult < Struct.new(
      :ebs_encryption_by_default)
      include Aws::Structure
    end

    # @note When making an API call, you may pass GetHostReservationPurchasePreviewRequest
    #   data as a hash:
    #
    #       {
    #         host_id_set: ["DedicatedHostId"], # required
    #         offering_id: "OfferingId", # required
    #       }
    #
    # @!attribute [rw] host_id_set
    #   The IDs of the Dedicated Hosts with which the reservation is
    #   associated.
    #   @return [Array<String>]
    #
    # @!attribute [rw] offering_id
    #   The offering ID of the reservation.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetHostReservationPurchasePreviewRequest AWS API Documentation
    #
    class GetHostReservationPurchasePreviewRequest < Struct.new(
      :host_id_set,
      :offering_id)
      include Aws::Structure
    end

    # @!attribute [rw] currency_code
    #   The currency in which the `totalUpfrontPrice` and `totalHourlyPrice`
    #   amounts are specified. At this time, the only supported currency is
    #   `USD`.
    #   @return [String]
    #
    # @!attribute [rw] purchase
    #   The purchase information of the Dedicated Host reservation and the
    #   Dedicated Hosts associated with it.
    #   @return [Array<Types::Purchase>]
    #
    # @!attribute [rw] total_hourly_price
    #   The potential total hourly price of the reservation per hour.
    #   @return [String]
    #
    # @!attribute [rw] total_upfront_price
    #   The potential total upfront price. This is billed immediately.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetHostReservationPurchasePreviewResult AWS API Documentation
    #
    class GetHostReservationPurchasePreviewResult < Struct.new(
      :currency_code,
      :purchase,
      :total_hourly_price,
      :total_upfront_price)
      include Aws::Structure
    end

    # @note When making an API call, you may pass GetLaunchTemplateDataRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         instance_id: "InstanceId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetLaunchTemplateDataRequest AWS API Documentation
    #
    class GetLaunchTemplateDataRequest < Struct.new(
      :dry_run,
      :instance_id)
      include Aws::Structure
    end

    # @!attribute [rw] launch_template_data
    #   The instance data.
    #   @return [Types::ResponseLaunchTemplateData]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetLaunchTemplateDataResult AWS API Documentation
    #
    class GetLaunchTemplateDataResult < Struct.new(
      :launch_template_data)
      include Aws::Structure
    end

    # @note When making an API call, you may pass GetPasswordDataRequest
    #   data as a hash:
    #
    #       {
    #         instance_id: "InstanceId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] instance_id
    #   The ID of the Windows instance.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetPasswordDataRequest AWS API Documentation
    #
    class GetPasswordDataRequest < Struct.new(
      :instance_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] instance_id
    #   The ID of the Windows instance.
    #   @return [String]
    #
    # @!attribute [rw] password_data
    #   The password of the instance. Returns an empty string if the
    #   password is not available.
    #   @return [String]
    #
    # @!attribute [rw] timestamp
    #   The time the data was last updated.
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetPasswordDataResult AWS API Documentation
    #
    class GetPasswordDataResult < Struct.new(
      :instance_id,
      :password_data,
      :timestamp)
      include Aws::Structure
    end

    # Contains the parameters for GetReservedInstanceExchangeQuote.
    #
    # @note When making an API call, you may pass GetReservedInstancesExchangeQuoteRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         reserved_instance_ids: ["ReservationId"], # required
    #         target_configurations: [
    #           {
    #             instance_count: 1,
    #             offering_id: "ReservedInstancesOfferingId", # required
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] reserved_instance_ids
    #   The IDs of the Convertible Reserved Instances to exchange.
    #   @return [Array<String>]
    #
    # @!attribute [rw] target_configurations
    #   The configuration of the target Convertible Reserved Instance to
    #   exchange for your current Convertible Reserved Instances.
    #   @return [Array<Types::TargetConfigurationRequest>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetReservedInstancesExchangeQuoteRequest AWS API Documentation
    #
    class GetReservedInstancesExchangeQuoteRequest < Struct.new(
      :dry_run,
      :reserved_instance_ids,
      :target_configurations)
      include Aws::Structure
    end

    # Contains the output of GetReservedInstancesExchangeQuote.
    #
    # @!attribute [rw] currency_code
    #   The currency of the transaction.
    #   @return [String]
    #
    # @!attribute [rw] is_valid_exchange
    #   If `true`, the exchange is valid. If `false`, the exchange cannot be
    #   completed.
    #   @return [Boolean]
    #
    # @!attribute [rw] output_reserved_instances_will_expire_at
    #   The new end date of the reservation term.
    #   @return [Time]
    #
    # @!attribute [rw] payment_due
    #   The total true upfront charge for the exchange.
    #   @return [String]
    #
    # @!attribute [rw] reserved_instance_value_rollup
    #   The cost associated with the Reserved Instance.
    #   @return [Types::ReservationValue]
    #
    # @!attribute [rw] reserved_instance_value_set
    #   The configuration of your Convertible Reserved Instances.
    #   @return [Array<Types::ReservedInstanceReservationValue>]
    #
    # @!attribute [rw] target_configuration_value_rollup
    #   The cost associated with the Reserved Instance.
    #   @return [Types::ReservationValue]
    #
    # @!attribute [rw] target_configuration_value_set
    #   The values of the target Convertible Reserved Instances.
    #   @return [Array<Types::TargetReservationValue>]
    #
    # @!attribute [rw] validation_failure_reason
    #   Describes the reason why the exchange cannot be completed.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetReservedInstancesExchangeQuoteResult AWS API Documentation
    #
    class GetReservedInstancesExchangeQuoteResult < Struct.new(
      :currency_code,
      :is_valid_exchange,
      :output_reserved_instances_will_expire_at,
      :payment_due,
      :reserved_instance_value_rollup,
      :reserved_instance_value_set,
      :target_configuration_value_rollup,
      :target_configuration_value_set,
      :validation_failure_reason)
      include Aws::Structure
    end

    # @note When making an API call, you may pass GetTransitGatewayAttachmentPropagationsRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_attachment_id: "TransitGatewayAttachmentId", # required
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters. The possible values are:
    #
    #   * `transit-gateway-route-table-id` - The ID of the transit gateway
    #     route table.
    #
    #   ^
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetTransitGatewayAttachmentPropagationsRequest AWS API Documentation
    #
    class GetTransitGatewayAttachmentPropagationsRequest < Struct.new(
      :transit_gateway_attachment_id,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_attachment_propagations
    #   Information about the propagation route tables.
    #   @return [Array<Types::TransitGatewayAttachmentPropagation>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetTransitGatewayAttachmentPropagationsResult AWS API Documentation
    #
    class GetTransitGatewayAttachmentPropagationsResult < Struct.new(
      :transit_gateway_attachment_propagations,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass GetTransitGatewayMulticastDomainAssociationsRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_multicast_domain_id: "TransitGatewayMulticastDomainId",
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_multicast_domain_id
    #   The ID of the transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters. The possible values are:
    #
    #   * `resource-id` - The ID of the resource.
    #
    #   * `resource-type` - The type of resource. The valid value is: `vpc`.
    #
    #   * `state` - The state of the subnet association. Valid values are
    #     `associated` \| `associating` \| `disassociated` \|
    #     `disassociating`.
    #
    #   * `subnet-id` - The ID of the subnet.
    #
    #   * `transit-gateway-attachment-id` - The id of the transit gateway
    #     attachment.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetTransitGatewayMulticastDomainAssociationsRequest AWS API Documentation
    #
    class GetTransitGatewayMulticastDomainAssociationsRequest < Struct.new(
      :transit_gateway_multicast_domain_id,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] multicast_domain_associations
    #   Information about the multicast domain associations.
    #   @return [Array<Types::TransitGatewayMulticastDomainAssociation>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetTransitGatewayMulticastDomainAssociationsResult AWS API Documentation
    #
    class GetTransitGatewayMulticastDomainAssociationsResult < Struct.new(
      :multicast_domain_associations,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass GetTransitGatewayRouteTableAssociationsRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_route_table_id: "TransitGatewayRouteTableId", # required
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the transit gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters. The possible values are:
    #
    #   * `resource-id` - The ID of the resource.
    #
    #   * `resource-type` - The resource type (`vpc` \| `vpn`).
    #
    #   * `transit-gateway-attachment-id` - The ID of the attachment.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetTransitGatewayRouteTableAssociationsRequest AWS API Documentation
    #
    class GetTransitGatewayRouteTableAssociationsRequest < Struct.new(
      :transit_gateway_route_table_id,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] associations
    #   Information about the associations.
    #   @return [Array<Types::TransitGatewayRouteTableAssociation>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetTransitGatewayRouteTableAssociationsResult AWS API Documentation
    #
    class GetTransitGatewayRouteTableAssociationsResult < Struct.new(
      :associations,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass GetTransitGatewayRouteTablePropagationsRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_route_table_id: "TransitGatewayRouteTableId", # required
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the transit gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters. The possible values are:
    #
    #   * `resource-id` - The ID of the resource.
    #
    #   * `resource-type` - The resource type (`vpc` \| `vpn`).
    #
    #   * `transit-gateway-attachment-id` - The ID of the attachment.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetTransitGatewayRouteTablePropagationsRequest AWS API Documentation
    #
    class GetTransitGatewayRouteTablePropagationsRequest < Struct.new(
      :transit_gateway_route_table_id,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_route_table_propagations
    #   Information about the route table propagations.
    #   @return [Array<Types::TransitGatewayRouteTablePropagation>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GetTransitGatewayRouteTablePropagationsResult AWS API Documentation
    #
    class GetTransitGatewayRouteTablePropagationsResult < Struct.new(
      :transit_gateway_route_table_propagations,
      :next_token)
      include Aws::Structure
    end

    # Describes the GPU accelerators for the instance type.
    #
    # @!attribute [rw] name
    #   The name of the GPU accelerator.
    #   @return [String]
    #
    # @!attribute [rw] manufacturer
    #   The manufacturer of the GPU accelerator.
    #   @return [String]
    #
    # @!attribute [rw] count
    #   The number of GPUs for the instance type.
    #   @return [Integer]
    #
    # @!attribute [rw] memory_info
    #   Describes the memory available to the GPU accelerator.
    #   @return [Types::GpuDeviceMemoryInfo]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GpuDeviceInfo AWS API Documentation
    #
    class GpuDeviceInfo < Struct.new(
      :name,
      :manufacturer,
      :count,
      :memory_info)
      include Aws::Structure
    end

    # Describes the memory available to the GPU accelerator.
    #
    # @!attribute [rw] size_in_mi_b
    #   The size (in MiB) for the memory available to the GPU accelerator.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GpuDeviceMemoryInfo AWS API Documentation
    #
    class GpuDeviceMemoryInfo < Struct.new(
      :size_in_mi_b)
      include Aws::Structure
    end

    # Describes the GPU accelerators for the instance type.
    #
    # @!attribute [rw] gpus
    #   Describes the GPU accelerators for the instance type.
    #   @return [Array<Types::GpuDeviceInfo>]
    #
    # @!attribute [rw] total_gpu_memory_in_mi_b
    #   The total size of the memory for the GPU accelerators for the
    #   instance type.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GpuInfo AWS API Documentation
    #
    class GpuInfo < Struct.new(
      :gpus,
      :total_gpu_memory_in_mi_b)
      include Aws::Structure
    end

    # Describes a security group.
    #
    # @note When making an API call, you may pass GroupIdentifier
    #   data as a hash:
    #
    #       {
    #         group_name: "String",
    #         group_id: "String",
    #       }
    #
    # @!attribute [rw] group_name
    #   The name of the security group.
    #   @return [String]
    #
    # @!attribute [rw] group_id
    #   The ID of the security group.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/GroupIdentifier AWS API Documentation
    #
    class GroupIdentifier < Struct.new(
      :group_name,
      :group_id)
      include Aws::Structure
    end

    # Indicates whether your instance is configured for hibernation. This
    # parameter is valid only if the instance meets the [hibernation
    # prerequisites][1]. For more information, see [Hibernate Your
    # Instance][2] in the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html#hibernating-prerequisites
    # [2]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html
    #
    # @!attribute [rw] configured
    #   If this parameter is set to `true`, your instance is enabled for
    #   hibernation; otherwise, it is not enabled for hibernation.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/HibernationOptions AWS API Documentation
    #
    class HibernationOptions < Struct.new(
      :configured)
      include Aws::Structure
    end

    # Indicates whether your instance is configured for hibernation. This
    # parameter is valid only if the instance meets the [hibernation
    # prerequisites][1]. For more information, see [Hibernate Your
    # Instance][2] in the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html#hibernating-prerequisites
    # [2]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html
    #
    # @note When making an API call, you may pass HibernationOptionsRequest
    #   data as a hash:
    #
    #       {
    #         configured: false,
    #       }
    #
    # @!attribute [rw] configured
    #   If you set this parameter to `true`, your instance is enabled for
    #   hibernation.
    #
    #   Default: `false`
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/HibernationOptionsRequest AWS API Documentation
    #
    class HibernationOptionsRequest < Struct.new(
      :configured)
      include Aws::Structure
    end

    # Describes an event in the history of the Spot Fleet request.
    #
    # @!attribute [rw] event_information
    #   Information about the event.
    #   @return [Types::EventInformation]
    #
    # @!attribute [rw] event_type
    #   The event type.
    #
    #   * `error` - An error with the Spot Fleet request.
    #
    #   * `fleetRequestChange` - A change in the status or configuration of
    #     the Spot Fleet request.
    #
    #   * `instanceChange` - An instance was launched or terminated.
    #
    #   * `Information` - An informational event.
    #   @return [String]
    #
    # @!attribute [rw] timestamp
    #   The date and time of the event, in UTC format (for example,
    #   *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z).
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/HistoryRecord AWS API Documentation
    #
    class HistoryRecord < Struct.new(
      :event_information,
      :event_type,
      :timestamp)
      include Aws::Structure
    end

    # Describes an event in the history of an EC2 Fleet.
    #
    # @!attribute [rw] event_information
    #   Information about the event.
    #   @return [Types::EventInformation]
    #
    # @!attribute [rw] event_type
    #   The event type.
    #   @return [String]
    #
    # @!attribute [rw] timestamp
    #   The date and time of the event, in UTC format (for example,
    #   *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z).
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/HistoryRecordEntry AWS API Documentation
    #
    class HistoryRecordEntry < Struct.new(
      :event_information,
      :event_type,
      :timestamp)
      include Aws::Structure
    end

    # Describes the properties of the Dedicated Host.
    #
    # @!attribute [rw] auto_placement
    #   Whether auto-placement is on or off.
    #   @return [String]
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone of the Dedicated Host.
    #   @return [String]
    #
    # @!attribute [rw] available_capacity
    #   Information about the instances running on the Dedicated Host.
    #   @return [Types::AvailableCapacity]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] host_id
    #   The ID of the Dedicated Host.
    #   @return [String]
    #
    # @!attribute [rw] host_properties
    #   The hardware specifications of the Dedicated Host.
    #   @return [Types::HostProperties]
    #
    # @!attribute [rw] host_reservation_id
    #   The reservation ID of the Dedicated Host. This returns a `null`
    #   response if the Dedicated Host doesn't have an associated
    #   reservation.
    #   @return [String]
    #
    # @!attribute [rw] instances
    #   The IDs and instance type that are currently running on the
    #   Dedicated Host.
    #   @return [Array<Types::HostInstance>]
    #
    # @!attribute [rw] state
    #   The Dedicated Host's state.
    #   @return [String]
    #
    # @!attribute [rw] allocation_time
    #   The time that the Dedicated Host was allocated.
    #   @return [Time]
    #
    # @!attribute [rw] release_time
    #   The time that the Dedicated Host was released.
    #   @return [Time]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the Dedicated Host.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] host_recovery
    #   Indicates whether host recovery is enabled or disabled for the
    #   Dedicated Host.
    #   @return [String]
    #
    # @!attribute [rw] allows_multiple_instance_types
    #   Indicates whether the Dedicated Host supports multiple instance
    #   types of the same instance family, or a specific instance type only.
    #   `one` indicates that the Dedicated Host supports multiple instance
    #   types in the instance family. `off` indicates that the Dedicated
    #   Host supports a single instance type only.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account that owns the Dedicated Host.
    #   @return [String]
    #
    # @!attribute [rw] availability_zone_id
    #   The ID of the Availability Zone in which the Dedicated Host is
    #   allocated.
    #   @return [String]
    #
    # @!attribute [rw] member_of_service_linked_resource_group
    #   Indicates whether the Dedicated Host is in a host resource group. If
    #   **memberOfServiceLinkedResourceGroup** is `true`, the host is in a
    #   host resource group; otherwise, it is not.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Host AWS API Documentation
    #
    class Host < Struct.new(
      :auto_placement,
      :availability_zone,
      :available_capacity,
      :client_token,
      :host_id,
      :host_properties,
      :host_reservation_id,
      :instances,
      :state,
      :allocation_time,
      :release_time,
      :tags,
      :host_recovery,
      :allows_multiple_instance_types,
      :owner_id,
      :availability_zone_id,
      :member_of_service_linked_resource_group)
      include Aws::Structure
    end

    # Describes an instance running on a Dedicated Host.
    #
    # @!attribute [rw] instance_id
    #   The ID of instance that is running on the Dedicated Host.
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   The instance type (for example, `m3.medium`) of the running
    #   instance.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account that owns the instance.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/HostInstance AWS API Documentation
    #
    class HostInstance < Struct.new(
      :instance_id,
      :instance_type,
      :owner_id)
      include Aws::Structure
    end

    # Details about the Dedicated Host Reservation offering.
    #
    # @!attribute [rw] currency_code
    #   The currency of the offering.
    #   @return [String]
    #
    # @!attribute [rw] duration
    #   The duration of the offering (in seconds).
    #   @return [Integer]
    #
    # @!attribute [rw] hourly_price
    #   The hourly price of the offering.
    #   @return [String]
    #
    # @!attribute [rw] instance_family
    #   The instance family of the offering.
    #   @return [String]
    #
    # @!attribute [rw] offering_id
    #   The ID of the offering.
    #   @return [String]
    #
    # @!attribute [rw] payment_option
    #   The available payment option.
    #   @return [String]
    #
    # @!attribute [rw] upfront_price
    #   The upfront price of the offering. Does not apply to No Upfront
    #   offerings.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/HostOffering AWS API Documentation
    #
    class HostOffering < Struct.new(
      :currency_code,
      :duration,
      :hourly_price,
      :instance_family,
      :offering_id,
      :payment_option,
      :upfront_price)
      include Aws::Structure
    end

    # Describes the properties of a Dedicated Host.
    #
    # @!attribute [rw] cores
    #   The number of cores on the Dedicated Host.
    #   @return [Integer]
    #
    # @!attribute [rw] instance_type
    #   The instance type supported by the Dedicated Host. For example,
    #   `m5.large`. If the host supports multiple instance types, no
    #   **instanceType** is returned.
    #   @return [String]
    #
    # @!attribute [rw] instance_family
    #   The instance family supported by the Dedicated Host. For example,
    #   `m5`.
    #   @return [String]
    #
    # @!attribute [rw] sockets
    #   The number of sockets on the Dedicated Host.
    #   @return [Integer]
    #
    # @!attribute [rw] total_v_cpus
    #   The total number of vCPUs on the Dedicated Host.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/HostProperties AWS API Documentation
    #
    class HostProperties < Struct.new(
      :cores,
      :instance_type,
      :instance_family,
      :sockets,
      :total_v_cpus)
      include Aws::Structure
    end

    # Details about the Dedicated Host Reservation and associated Dedicated
    # Hosts.
    #
    # @!attribute [rw] count
    #   The number of Dedicated Hosts the reservation is associated with.
    #   @return [Integer]
    #
    # @!attribute [rw] currency_code
    #   The currency in which the `upfrontPrice` and `hourlyPrice` amounts
    #   are specified. At this time, the only supported currency is `USD`.
    #   @return [String]
    #
    # @!attribute [rw] duration
    #   The length of the reservation's term, specified in seconds. Can be
    #   `31536000 (1 year)` \| `94608000 (3 years)`.
    #   @return [Integer]
    #
    # @!attribute [rw] end
    #   The date and time that the reservation ends.
    #   @return [Time]
    #
    # @!attribute [rw] host_id_set
    #   The IDs of the Dedicated Hosts associated with the reservation.
    #   @return [Array<String>]
    #
    # @!attribute [rw] host_reservation_id
    #   The ID of the reservation that specifies the associated Dedicated
    #   Hosts.
    #   @return [String]
    #
    # @!attribute [rw] hourly_price
    #   The hourly price of the reservation.
    #   @return [String]
    #
    # @!attribute [rw] instance_family
    #   The instance family of the Dedicated Host Reservation. The instance
    #   family on the Dedicated Host must be the same in order for it to
    #   benefit from the reservation.
    #   @return [String]
    #
    # @!attribute [rw] offering_id
    #   The ID of the reservation. This remains the same regardless of which
    #   Dedicated Hosts are associated with it.
    #   @return [String]
    #
    # @!attribute [rw] payment_option
    #   The payment option selected for this reservation.
    #   @return [String]
    #
    # @!attribute [rw] start
    #   The date and time that the reservation started.
    #   @return [Time]
    #
    # @!attribute [rw] state
    #   The state of the reservation.
    #   @return [String]
    #
    # @!attribute [rw] upfront_price
    #   The upfront price of the reservation.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the Dedicated Host Reservation.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/HostReservation AWS API Documentation
    #
    class HostReservation < Struct.new(
      :count,
      :currency_code,
      :duration,
      :end,
      :host_id_set,
      :host_reservation_id,
      :hourly_price,
      :instance_family,
      :offering_id,
      :payment_option,
      :start,
      :state,
      :upfront_price,
      :tags)
      include Aws::Structure
    end

    # The internet key exchange (IKE) version permitted for the VPN tunnel.
    #
    # @!attribute [rw] value
    #   The IKE version.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/IKEVersionsListValue AWS API Documentation
    #
    class IKEVersionsListValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # The IKE version that is permitted for the VPN tunnel.
    #
    # @note When making an API call, you may pass IKEVersionsRequestListValue
    #   data as a hash:
    #
    #       {
    #         value: "String",
    #       }
    #
    # @!attribute [rw] value
    #   The IKE version.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/IKEVersionsRequestListValue AWS API Documentation
    #
    class IKEVersionsRequestListValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # Describes an IAM instance profile.
    #
    # @!attribute [rw] arn
    #   The Amazon Resource Name (ARN) of the instance profile.
    #   @return [String]
    #
    # @!attribute [rw] id
    #   The ID of the instance profile.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/IamInstanceProfile AWS API Documentation
    #
    class IamInstanceProfile < Struct.new(
      :arn,
      :id)
      include Aws::Structure
    end

    # Describes an association between an IAM instance profile and an
    # instance.
    #
    # @!attribute [rw] association_id
    #   The ID of the association.
    #   @return [String]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] iam_instance_profile
    #   The IAM instance profile.
    #   @return [Types::IamInstanceProfile]
    #
    # @!attribute [rw] state
    #   The state of the association.
    #   @return [String]
    #
    # @!attribute [rw] timestamp
    #   The time the IAM instance profile was associated with the instance.
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/IamInstanceProfileAssociation AWS API Documentation
    #
    class IamInstanceProfileAssociation < Struct.new(
      :association_id,
      :instance_id,
      :iam_instance_profile,
      :state,
      :timestamp)
      include Aws::Structure
    end

    # Describes an IAM instance profile.
    #
    # @note When making an API call, you may pass IamInstanceProfileSpecification
    #   data as a hash:
    #
    #       {
    #         arn: "String",
    #         name: "String",
    #       }
    #
    # @!attribute [rw] arn
    #   The Amazon Resource Name (ARN) of the instance profile.
    #   @return [String]
    #
    # @!attribute [rw] name
    #   The name of the instance profile.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/IamInstanceProfileSpecification AWS API Documentation
    #
    class IamInstanceProfileSpecification < Struct.new(
      :arn,
      :name)
      include Aws::Structure
    end

    # Describes the ICMP type and code.
    #
    # @note When making an API call, you may pass IcmpTypeCode
    #   data as a hash:
    #
    #       {
    #         code: 1,
    #         type: 1,
    #       }
    #
    # @!attribute [rw] code
    #   The ICMP code. A value of -1 means all codes for the specified ICMP
    #   type.
    #   @return [Integer]
    #
    # @!attribute [rw] type
    #   The ICMP type. A value of -1 means all types.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/IcmpTypeCode AWS API Documentation
    #
    class IcmpTypeCode < Struct.new(
      :code,
      :type)
      include Aws::Structure
    end

    # Describes the ID format for a resource.
    #
    # @!attribute [rw] deadline
    #   The date in UTC at which you are permanently switched over to using
    #   longer IDs. If a deadline is not yet available for this resource
    #   type, this field is not returned.
    #   @return [Time]
    #
    # @!attribute [rw] resource
    #   The type of resource.
    #   @return [String]
    #
    # @!attribute [rw] use_long_ids
    #   Indicates whether longer IDs (17-character IDs) are enabled for the
    #   resource.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/IdFormat AWS API Documentation
    #
    class IdFormat < Struct.new(
      :deadline,
      :resource,
      :use_long_ids)
      include Aws::Structure
    end

    # Describes an image.
    #
    # @!attribute [rw] architecture
    #   The architecture of the image.
    #   @return [String]
    #
    # @!attribute [rw] creation_date
    #   The date and time the image was created.
    #   @return [String]
    #
    # @!attribute [rw] image_id
    #   The ID of the AMI.
    #   @return [String]
    #
    # @!attribute [rw] image_location
    #   The location of the AMI.
    #   @return [String]
    #
    # @!attribute [rw] image_type
    #   The type of image.
    #   @return [String]
    #
    # @!attribute [rw] public
    #   Indicates whether the image has public launch permissions. The value
    #   is `true` if this image has public launch permissions or `false` if
    #   it has only implicit and explicit launch permissions.
    #   @return [Boolean]
    #
    # @!attribute [rw] kernel_id
    #   The kernel associated with the image, if any. Only applicable for
    #   machine images.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The AWS account ID of the image owner.
    #   @return [String]
    #
    # @!attribute [rw] platform
    #   This value is set to `windows` for Windows AMIs; otherwise, it is
    #   blank.
    #   @return [String]
    #
    # @!attribute [rw] platform_details
    #   The platform details associated with the billing code of the AMI.
    #   For more information, see [Obtaining Billing Information][1] in the
    #   *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ami-billing-info.html
    #   @return [String]
    #
    # @!attribute [rw] usage_operation
    #   The operation of the Amazon EC2 instance and the billing code that
    #   is associated with the AMI. `usageOperation` corresponds to the
    #   [lineitem/Operation][1] column on your AWS Cost and Usage Report and
    #   in the [AWS Price List API][2]. For the list of `UsageOperation`
    #   codes, see [Platform Details and Usage Operation Billing Codes][3]
    #   in the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/cur/latest/userguide/Lineitem-columns.html#Lineitem-details-O-Operation
    #   [2]: https://docs.aws.amazon.com/awsaccountbilling/latest/aboutv2/price-changes.html
    #   [3]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ami-billing-info.html#billing-info
    #   @return [String]
    #
    # @!attribute [rw] product_codes
    #   Any product codes associated with the AMI.
    #   @return [Array<Types::ProductCode>]
    #
    # @!attribute [rw] ramdisk_id
    #   The RAM disk associated with the image, if any. Only applicable for
    #   machine images.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The current state of the AMI. If the state is `available`, the image
    #   is successfully registered and can be used to launch an instance.
    #   @return [String]
    #
    # @!attribute [rw] block_device_mappings
    #   Any block device mapping entries.
    #   @return [Array<Types::BlockDeviceMapping>]
    #
    # @!attribute [rw] description
    #   The description of the AMI that was provided during image creation.
    #   @return [String]
    #
    # @!attribute [rw] ena_support
    #   Specifies whether enhanced networking with ENA is enabled.
    #   @return [Boolean]
    #
    # @!attribute [rw] hypervisor
    #   The hypervisor type of the image.
    #   @return [String]
    #
    # @!attribute [rw] image_owner_alias
    #   The AWS account alias (for example, `amazon`, `self`) or the AWS
    #   account ID of the AMI owner.
    #   @return [String]
    #
    # @!attribute [rw] name
    #   The name of the AMI that was provided during image creation.
    #   @return [String]
    #
    # @!attribute [rw] root_device_name
    #   The device name of the root device volume (for example,
    #   `/dev/sda1`).
    #   @return [String]
    #
    # @!attribute [rw] root_device_type
    #   The type of root device used by the AMI. The AMI can use an EBS
    #   volume or an instance store volume.
    #   @return [String]
    #
    # @!attribute [rw] sriov_net_support
    #   Specifies whether enhanced networking with the Intel 82599 Virtual
    #   Function interface is enabled.
    #   @return [String]
    #
    # @!attribute [rw] state_reason
    #   The reason for the state change.
    #   @return [Types::StateReason]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the image.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] virtualization_type
    #   The type of virtualization of the AMI.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Image AWS API Documentation
    #
    class Image < Struct.new(
      :architecture,
      :creation_date,
      :image_id,
      :image_location,
      :image_type,
      :public,
      :kernel_id,
      :owner_id,
      :platform,
      :platform_details,
      :usage_operation,
      :product_codes,
      :ramdisk_id,
      :state,
      :block_device_mappings,
      :description,
      :ena_support,
      :hypervisor,
      :image_owner_alias,
      :name,
      :root_device_name,
      :root_device_type,
      :sriov_net_support,
      :state_reason,
      :tags,
      :virtualization_type)
      include Aws::Structure
    end

    # Describes an image attribute.
    #
    # @!attribute [rw] block_device_mappings
    #   The block device mapping entries.
    #   @return [Array<Types::BlockDeviceMapping>]
    #
    # @!attribute [rw] image_id
    #   The ID of the AMI.
    #   @return [String]
    #
    # @!attribute [rw] launch_permissions
    #   The launch permissions.
    #   @return [Array<Types::LaunchPermission>]
    #
    # @!attribute [rw] product_codes
    #   The product codes.
    #   @return [Array<Types::ProductCode>]
    #
    # @!attribute [rw] description
    #   A description for the AMI.
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] kernel_id
    #   The kernel ID.
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] ramdisk_id
    #   The RAM disk ID.
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] sriov_net_support
    #   Indicates whether enhanced networking with the Intel 82599 Virtual
    #   Function interface is enabled.
    #   @return [Types::AttributeValue]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImageAttribute AWS API Documentation
    #
    class ImageAttribute < Struct.new(
      :block_device_mappings,
      :image_id,
      :launch_permissions,
      :product_codes,
      :description,
      :kernel_id,
      :ramdisk_id,
      :sriov_net_support)
      include Aws::Structure
    end

    # Describes the disk container object for an import image task.
    #
    # @note When making an API call, you may pass ImageDiskContainer
    #   data as a hash:
    #
    #       {
    #         description: "String",
    #         device_name: "String",
    #         format: "String",
    #         snapshot_id: "SnapshotId",
    #         url: "String",
    #         user_bucket: {
    #           s3_bucket: "String",
    #           s3_key: "String",
    #         },
    #       }
    #
    # @!attribute [rw] description
    #   The description of the disk image.
    #   @return [String]
    #
    # @!attribute [rw] device_name
    #   The block device mapping for the disk.
    #   @return [String]
    #
    # @!attribute [rw] format
    #   The format of the disk image being imported.
    #
    #   Valid values: `VHD` \| `VMDK` \| `OVA`
    #   @return [String]
    #
    # @!attribute [rw] snapshot_id
    #   The ID of the EBS snapshot to be used for importing the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] url
    #   The URL to the Amazon S3-based disk image being imported. The URL
    #   can either be a https URL (https://..) or an Amazon S3 URL (s3://..)
    #   @return [String]
    #
    # @!attribute [rw] user_bucket
    #   The S3 bucket for the disk image.
    #   @return [Types::UserBucket]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImageDiskContainer AWS API Documentation
    #
    class ImageDiskContainer < Struct.new(
      :description,
      :device_name,
      :format,
      :snapshot_id,
      :url,
      :user_bucket)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ImportClientVpnClientCertificateRevocationListRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         certificate_revocation_list: "String", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint to which the client certificate
    #   revocation list applies.
    #   @return [String]
    #
    # @!attribute [rw] certificate_revocation_list
    #   The client certificate revocation list file. For more information,
    #   see [Generate a Client Certificate Revocation List][1] in the *AWS
    #   Client VPN Administrator Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/cvpn-working-certificates.html#cvpn-working-certificates-generate
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportClientVpnClientCertificateRevocationListRequest AWS API Documentation
    #
    class ImportClientVpnClientCertificateRevocationListRequest < Struct.new(
      :client_vpn_endpoint_id,
      :certificate_revocation_list,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportClientVpnClientCertificateRevocationListResult AWS API Documentation
    #
    class ImportClientVpnClientCertificateRevocationListResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # The request information of license configurations.
    #
    # @note When making an API call, you may pass ImportImageLicenseConfigurationRequest
    #   data as a hash:
    #
    #       {
    #         license_configuration_arn: "String",
    #       }
    #
    # @!attribute [rw] license_configuration_arn
    #   The ARN of a license configuration.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportImageLicenseConfigurationRequest AWS API Documentation
    #
    class ImportImageLicenseConfigurationRequest < Struct.new(
      :license_configuration_arn)
      include Aws::Structure
    end

    # The response information for license configurations.
    #
    # @!attribute [rw] license_configuration_arn
    #   The ARN of a license configuration.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportImageLicenseConfigurationResponse AWS API Documentation
    #
    class ImportImageLicenseConfigurationResponse < Struct.new(
      :license_configuration_arn)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ImportImageRequest
    #   data as a hash:
    #
    #       {
    #         architecture: "String",
    #         client_data: {
    #           comment: "String",
    #           upload_end: Time.now,
    #           upload_size: 1.0,
    #           upload_start: Time.now,
    #         },
    #         client_token: "String",
    #         description: "String",
    #         disk_containers: [
    #           {
    #             description: "String",
    #             device_name: "String",
    #             format: "String",
    #             snapshot_id: "SnapshotId",
    #             url: "String",
    #             user_bucket: {
    #               s3_bucket: "String",
    #               s3_key: "String",
    #             },
    #           },
    #         ],
    #         dry_run: false,
    #         encrypted: false,
    #         hypervisor: "String",
    #         kms_key_id: "KmsKeyId",
    #         license_type: "String",
    #         platform: "String",
    #         role_name: "String",
    #         license_specifications: [
    #           {
    #             license_configuration_arn: "String",
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] architecture
    #   The architecture of the virtual machine.
    #
    #   Valid values: `i386` \| `x86_64` \| `arm64`
    #   @return [String]
    #
    # @!attribute [rw] client_data
    #   The client-specific data.
    #   @return [Types::ClientData]
    #
    # @!attribute [rw] client_token
    #   The token to enable idempotency for VM import requests.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   A description string for the import image task.
    #   @return [String]
    #
    # @!attribute [rw] disk_containers
    #   Information about the disk containers.
    #   @return [Array<Types::ImageDiskContainer>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] encrypted
    #   Specifies whether the destination AMI of the imported image should
    #   be encrypted. The default CMK for EBS is used unless you specify a
    #   non-default AWS Key Management Service (AWS KMS) CMK using
    #   `KmsKeyId`. For more information, see [Amazon EBS Encryption][1] in
    #   the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html
    #   @return [Boolean]
    #
    # @!attribute [rw] hypervisor
    #   The target hypervisor platform.
    #
    #   Valid values: `xen`
    #   @return [String]
    #
    # @!attribute [rw] kms_key_id
    #   An identifier for the symmetric AWS Key Management Service (AWS KMS)
    #   customer master key (CMK) to use when creating the encrypted AMI.
    #   This parameter is only required if you want to use a non-default
    #   CMK; if this parameter is not specified, the default CMK for EBS is
    #   used. If a `KmsKeyId` is specified, the `Encrypted` flag must also
    #   be set.
    #
    #   The CMK identifier may be provided in any of the following formats:
    #
    #   * Key ID
    #
    #   * Key alias. The alias ARN contains the `arn:aws:kms` namespace,
    #     followed by the Region of the CMK, the AWS account ID of the CMK
    #     owner, the `alias` namespace, and then the CMK alias. For example,
    #     arn:aws:kms:*us-east-1*\:*012345678910*\:alias/*ExampleAlias*.
    #
    #   * ARN using key ID. The ID ARN contains the `arn:aws:kms` namespace,
    #     followed by the Region of the CMK, the AWS account ID of the CMK
    #     owner, the `key` namespace, and then the CMK ID. For example,
    #     arn:aws:kms:*us-east-1*\:*012345678910*\:key/*abcd1234-a123-456a-a12b-a123b4cd56ef*.
    #
    #   * ARN using key alias. The alias ARN contains the `arn:aws:kms`
    #     namespace, followed by the Region of the CMK, the AWS account ID
    #     of the CMK owner, the `alias` namespace, and then the CMK alias.
    #     For example,
    #     arn:aws:kms:*us-east-1*\:*012345678910*\:alias/*ExampleAlias*.
    #
    #   AWS parses `KmsKeyId` asynchronously, meaning that the action you
    #   call may appear to complete even though you provided an invalid
    #   identifier. This action will eventually report failure.
    #
    #   The specified CMK must exist in the Region that the AMI is being
    #   copied to.
    #
    #   Amazon EBS does not support asymmetric CMKs.
    #   @return [String]
    #
    # @!attribute [rw] license_type
    #   The license type to be used for the Amazon Machine Image (AMI) after
    #   importing.
    #
    #   By default, we detect the source-system operating system (OS) and
    #   apply the appropriate license. Specify `AWS` to replace the
    #   source-system license with an AWS license, if appropriate. Specify
    #   `BYOL` to retain the source-system license, if appropriate.
    #
    #   To use `BYOL`, you must have existing licenses with rights to use
    #   these licenses in a third party cloud, such as AWS. For more
    #   information, see [Prerequisites][1] in the VM Import/Export User
    #   Guide.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/vm-import/latest/userguide/vmimport-image-import.html#prerequisites-image
    #   @return [String]
    #
    # @!attribute [rw] platform
    #   The operating system of the virtual machine.
    #
    #   Valid values: `Windows` \| `Linux`
    #   @return [String]
    #
    # @!attribute [rw] role_name
    #   The name of the role to use when not using the default role,
    #   'vmimport'.
    #   @return [String]
    #
    # @!attribute [rw] license_specifications
    #   The ARNs of the license configurations.
    #   @return [Array<Types::ImportImageLicenseConfigurationRequest>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportImageRequest AWS API Documentation
    #
    class ImportImageRequest < Struct.new(
      :architecture,
      :client_data,
      :client_token,
      :description,
      :disk_containers,
      :dry_run,
      :encrypted,
      :hypervisor,
      :kms_key_id,
      :license_type,
      :platform,
      :role_name,
      :license_specifications)
      include Aws::Structure
    end

    # @!attribute [rw] architecture
    #   The architecture of the virtual machine.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   A description of the import task.
    #   @return [String]
    #
    # @!attribute [rw] encrypted
    #   Indicates whether the AMI is encypted.
    #   @return [Boolean]
    #
    # @!attribute [rw] hypervisor
    #   The target hypervisor of the import task.
    #   @return [String]
    #
    # @!attribute [rw] image_id
    #   The ID of the Amazon Machine Image (AMI) created by the import task.
    #   @return [String]
    #
    # @!attribute [rw] import_task_id
    #   The task ID of the import image task.
    #   @return [String]
    #
    # @!attribute [rw] kms_key_id
    #   The identifier for the symmetric AWS Key Management Service (AWS
    #   KMS) customer master key (CMK) that was used to create the encrypted
    #   AMI.
    #   @return [String]
    #
    # @!attribute [rw] license_type
    #   The license type of the virtual machine.
    #   @return [String]
    #
    # @!attribute [rw] platform
    #   The operating system of the virtual machine.
    #   @return [String]
    #
    # @!attribute [rw] progress
    #   The progress of the task.
    #   @return [String]
    #
    # @!attribute [rw] snapshot_details
    #   Information about the snapshots.
    #   @return [Array<Types::SnapshotDetail>]
    #
    # @!attribute [rw] status
    #   A brief status of the task.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   A detailed status message of the import task.
    #   @return [String]
    #
    # @!attribute [rw] license_specifications
    #   The ARNs of the license configurations.
    #   @return [Array<Types::ImportImageLicenseConfigurationResponse>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportImageResult AWS API Documentation
    #
    class ImportImageResult < Struct.new(
      :architecture,
      :description,
      :encrypted,
      :hypervisor,
      :image_id,
      :import_task_id,
      :kms_key_id,
      :license_type,
      :platform,
      :progress,
      :snapshot_details,
      :status,
      :status_message,
      :license_specifications)
      include Aws::Structure
    end

    # Describes an import image task.
    #
    # @!attribute [rw] architecture
    #   The architecture of the virtual machine.
    #
    #   Valid values: `i386` \| `x86_64` \| `arm64`
    #   @return [String]
    #
    # @!attribute [rw] description
    #   A description of the import task.
    #   @return [String]
    #
    # @!attribute [rw] encrypted
    #   Indicates whether the image is encrypted.
    #   @return [Boolean]
    #
    # @!attribute [rw] hypervisor
    #   The target hypervisor for the import task.
    #
    #   Valid values: `xen`
    #   @return [String]
    #
    # @!attribute [rw] image_id
    #   The ID of the Amazon Machine Image (AMI) of the imported virtual
    #   machine.
    #   @return [String]
    #
    # @!attribute [rw] import_task_id
    #   The ID of the import image task.
    #   @return [String]
    #
    # @!attribute [rw] kms_key_id
    #   The identifier for the AWS Key Management Service (AWS KMS) customer
    #   master key (CMK) that was used to create the encrypted image.
    #   @return [String]
    #
    # @!attribute [rw] license_type
    #   The license type of the virtual machine.
    #   @return [String]
    #
    # @!attribute [rw] platform
    #   The description string for the import image task.
    #   @return [String]
    #
    # @!attribute [rw] progress
    #   The percentage of progress of the import image task.
    #   @return [String]
    #
    # @!attribute [rw] snapshot_details
    #   Information about the snapshots.
    #   @return [Array<Types::SnapshotDetail>]
    #
    # @!attribute [rw] status
    #   A brief status for the import image task.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   A descriptive status message for the import image task.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags for the import image task.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] license_specifications
    #   The ARNs of the license configurations that are associated with the
    #   import image task.
    #   @return [Array<Types::ImportImageLicenseConfigurationResponse>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportImageTask AWS API Documentation
    #
    class ImportImageTask < Struct.new(
      :architecture,
      :description,
      :encrypted,
      :hypervisor,
      :image_id,
      :import_task_id,
      :kms_key_id,
      :license_type,
      :platform,
      :progress,
      :snapshot_details,
      :status,
      :status_message,
      :tags,
      :license_specifications)
      include Aws::Structure
    end

    # Describes the launch specification for VM import.
    #
    # @note When making an API call, you may pass ImportInstanceLaunchSpecification
    #   data as a hash:
    #
    #       {
    #         additional_info: "String",
    #         architecture: "i386", # accepts i386, x86_64, arm64
    #         group_ids: ["SecurityGroupId"],
    #         group_names: ["SecurityGroupName"],
    #         instance_initiated_shutdown_behavior: "stop", # accepts stop, terminate
    #         instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #         monitoring: false,
    #         placement: {
    #           availability_zone: "String",
    #           affinity: "String",
    #           group_name: "String",
    #           partition_number: 1,
    #           host_id: "String",
    #           tenancy: "default", # accepts default, dedicated, host
    #           spread_domain: "String",
    #           host_resource_group_arn: "String",
    #         },
    #         private_ip_address: "String",
    #         subnet_id: "SubnetId",
    #         user_data: {
    #           data: "String",
    #         },
    #       }
    #
    # @!attribute [rw] additional_info
    #   Reserved.
    #   @return [String]
    #
    # @!attribute [rw] architecture
    #   The architecture of the instance.
    #   @return [String]
    #
    # @!attribute [rw] group_ids
    #   The security group IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] group_names
    #   The security group names.
    #   @return [Array<String>]
    #
    # @!attribute [rw] instance_initiated_shutdown_behavior
    #   Indicates whether an instance stops or terminates when you initiate
    #   shutdown from the instance (using the operating system command for
    #   system shutdown).
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   The instance type. For more information about the instance types
    #   that you can import, see [Instance Types][1] in the VM Import/Export
    #   User Guide.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/vm-import/latest/userguide/vmie_prereqs.html#vmimport-instance-types
    #   @return [String]
    #
    # @!attribute [rw] monitoring
    #   Indicates whether monitoring is enabled.
    #   @return [Boolean]
    #
    # @!attribute [rw] placement
    #   The placement information for the instance.
    #   @return [Types::Placement]
    #
    # @!attribute [rw] private_ip_address
    #   \[EC2-VPC\] An available IP address from the IP address range of the
    #   subnet.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   \[EC2-VPC\] The ID of the subnet in which to launch the instance.
    #   @return [String]
    #
    # @!attribute [rw] user_data
    #   The Base64-encoded user data to make available to the instance.
    #   @return [Types::UserData]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportInstanceLaunchSpecification AWS API Documentation
    #
    class ImportInstanceLaunchSpecification < Struct.new(
      :additional_info,
      :architecture,
      :group_ids,
      :group_names,
      :instance_initiated_shutdown_behavior,
      :instance_type,
      :monitoring,
      :placement,
      :private_ip_address,
      :subnet_id,
      :user_data)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ImportInstanceRequest
    #   data as a hash:
    #
    #       {
    #         description: "String",
    #         disk_images: [
    #           {
    #             description: "String",
    #             image: {
    #               bytes: 1, # required
    #               format: "VMDK", # required, accepts VMDK, RAW, VHD
    #               import_manifest_url: "String", # required
    #             },
    #             volume: {
    #               size: 1, # required
    #             },
    #           },
    #         ],
    #         dry_run: false,
    #         launch_specification: {
    #           additional_info: "String",
    #           architecture: "i386", # accepts i386, x86_64, arm64
    #           group_ids: ["SecurityGroupId"],
    #           group_names: ["SecurityGroupName"],
    #           instance_initiated_shutdown_behavior: "stop", # accepts stop, terminate
    #           instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #           monitoring: false,
    #           placement: {
    #             availability_zone: "String",
    #             affinity: "String",
    #             group_name: "String",
    #             partition_number: 1,
    #             host_id: "String",
    #             tenancy: "default", # accepts default, dedicated, host
    #             spread_domain: "String",
    #             host_resource_group_arn: "String",
    #           },
    #           private_ip_address: "String",
    #           subnet_id: "SubnetId",
    #           user_data: {
    #             data: "String",
    #           },
    #         },
    #         platform: "Windows", # required, accepts Windows
    #       }
    #
    # @!attribute [rw] description
    #   A description for the instance being imported.
    #   @return [String]
    #
    # @!attribute [rw] disk_images
    #   The disk image.
    #   @return [Array<Types::DiskImage>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] launch_specification
    #   The launch specification.
    #   @return [Types::ImportInstanceLaunchSpecification]
    #
    # @!attribute [rw] platform
    #   The instance operating system.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportInstanceRequest AWS API Documentation
    #
    class ImportInstanceRequest < Struct.new(
      :description,
      :disk_images,
      :dry_run,
      :launch_specification,
      :platform)
      include Aws::Structure
    end

    # @!attribute [rw] conversion_task
    #   Information about the conversion task.
    #   @return [Types::ConversionTask]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportInstanceResult AWS API Documentation
    #
    class ImportInstanceResult < Struct.new(
      :conversion_task)
      include Aws::Structure
    end

    # Describes an import instance task.
    #
    # @!attribute [rw] description
    #   A description of the task.
    #   @return [String]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] platform
    #   The instance operating system.
    #   @return [String]
    #
    # @!attribute [rw] volumes
    #   The volumes.
    #   @return [Array<Types::ImportInstanceVolumeDetailItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportInstanceTaskDetails AWS API Documentation
    #
    class ImportInstanceTaskDetails < Struct.new(
      :description,
      :instance_id,
      :platform,
      :volumes)
      include Aws::Structure
    end

    # Describes an import volume task.
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone where the resulting instance will reside.
    #   @return [String]
    #
    # @!attribute [rw] bytes_converted
    #   The number of bytes converted so far.
    #   @return [Integer]
    #
    # @!attribute [rw] description
    #   A description of the task.
    #   @return [String]
    #
    # @!attribute [rw] image
    #   The image.
    #   @return [Types::DiskImageDescription]
    #
    # @!attribute [rw] status
    #   The status of the import of this particular disk image.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   The status information or errors related to the disk image.
    #   @return [String]
    #
    # @!attribute [rw] volume
    #   The volume.
    #   @return [Types::DiskImageVolumeDescription]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportInstanceVolumeDetailItem AWS API Documentation
    #
    class ImportInstanceVolumeDetailItem < Struct.new(
      :availability_zone,
      :bytes_converted,
      :description,
      :image,
      :status,
      :status_message,
      :volume)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ImportKeyPairRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         key_name: "String", # required
    #         public_key_material: "data", # required
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] key_name
    #   A unique name for the key pair.
    #   @return [String]
    #
    # @!attribute [rw] public_key_material
    #   The public key. For API calls, the text must be base64-encoded. For
    #   command line tools, base64 encoding is performed for you.
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the imported key pair.
    #   @return [Array<Types::TagSpecification>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportKeyPairRequest AWS API Documentation
    #
    class ImportKeyPairRequest < Struct.new(
      :dry_run,
      :key_name,
      :public_key_material,
      :tag_specifications)
      include Aws::Structure
    end

    # @!attribute [rw] key_fingerprint
    #   The MD5 public key fingerprint as specified in section 4 of RFC
    #   4716.
    #   @return [String]
    #
    # @!attribute [rw] key_name
    #   The key pair name you provided.
    #   @return [String]
    #
    # @!attribute [rw] key_pair_id
    #   The ID of the resulting key pair.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags applied to the imported key pair.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportKeyPairResult AWS API Documentation
    #
    class ImportKeyPairResult < Struct.new(
      :key_fingerprint,
      :key_name,
      :key_pair_id,
      :tags)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ImportSnapshotRequest
    #   data as a hash:
    #
    #       {
    #         client_data: {
    #           comment: "String",
    #           upload_end: Time.now,
    #           upload_size: 1.0,
    #           upload_start: Time.now,
    #         },
    #         client_token: "String",
    #         description: "String",
    #         disk_container: {
    #           description: "String",
    #           format: "String",
    #           url: "String",
    #           user_bucket: {
    #             s3_bucket: "String",
    #             s3_key: "String",
    #           },
    #         },
    #         dry_run: false,
    #         encrypted: false,
    #         kms_key_id: "KmsKeyId",
    #         role_name: "String",
    #       }
    #
    # @!attribute [rw] client_data
    #   The client-specific data.
    #   @return [Types::ClientData]
    #
    # @!attribute [rw] client_token
    #   Token to enable idempotency for VM import requests.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   The description string for the import snapshot task.
    #   @return [String]
    #
    # @!attribute [rw] disk_container
    #   Information about the disk container.
    #   @return [Types::SnapshotDiskContainer]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] encrypted
    #   Specifies whether the destination snapshot of the imported image
    #   should be encrypted. The default CMK for EBS is used unless you
    #   specify a non-default AWS Key Management Service (AWS KMS) CMK using
    #   `KmsKeyId`. For more information, see [Amazon EBS Encryption][1] in
    #   the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html
    #   @return [Boolean]
    #
    # @!attribute [rw] kms_key_id
    #   An identifier for the symmetric AWS Key Management Service (AWS KMS)
    #   customer master key (CMK) to use when creating the encrypted
    #   snapshot. This parameter is only required if you want to use a
    #   non-default CMK; if this parameter is not specified, the default CMK
    #   for EBS is used. If a `KmsKeyId` is specified, the `Encrypted` flag
    #   must also be set.
    #
    #   The CMK identifier may be provided in any of the following formats:
    #
    #   * Key ID
    #
    #   * Key alias. The alias ARN contains the `arn:aws:kms` namespace,
    #     followed by the Region of the CMK, the AWS account ID of the CMK
    #     owner, the `alias` namespace, and then the CMK alias. For example,
    #     arn:aws:kms:*us-east-1*\:*012345678910*\:alias/*ExampleAlias*.
    #
    #   * ARN using key ID. The ID ARN contains the `arn:aws:kms` namespace,
    #     followed by the Region of the CMK, the AWS account ID of the CMK
    #     owner, the `key` namespace, and then the CMK ID. For example,
    #     arn:aws:kms:*us-east-1*\:*012345678910*\:key/*abcd1234-a123-456a-a12b-a123b4cd56ef*.
    #
    #   * ARN using key alias. The alias ARN contains the `arn:aws:kms`
    #     namespace, followed by the Region of the CMK, the AWS account ID
    #     of the CMK owner, the `alias` namespace, and then the CMK alias.
    #     For example,
    #     arn:aws:kms:*us-east-1*\:*012345678910*\:alias/*ExampleAlias*.
    #
    #   AWS parses `KmsKeyId` asynchronously, meaning that the action you
    #   call may appear to complete even though you provided an invalid
    #   identifier. This action will eventually report failure.
    #
    #   The specified CMK must exist in the Region that the snapshot is
    #   being copied to.
    #
    #   Amazon EBS does not support asymmetric CMKs.
    #   @return [String]
    #
    # @!attribute [rw] role_name
    #   The name of the role to use when not using the default role,
    #   'vmimport'.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportSnapshotRequest AWS API Documentation
    #
    class ImportSnapshotRequest < Struct.new(
      :client_data,
      :client_token,
      :description,
      :disk_container,
      :dry_run,
      :encrypted,
      :kms_key_id,
      :role_name)
      include Aws::Structure
    end

    # @!attribute [rw] description
    #   A description of the import snapshot task.
    #   @return [String]
    #
    # @!attribute [rw] import_task_id
    #   The ID of the import snapshot task.
    #   @return [String]
    #
    # @!attribute [rw] snapshot_task_detail
    #   Information about the import snapshot task.
    #   @return [Types::SnapshotTaskDetail]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportSnapshotResult AWS API Documentation
    #
    class ImportSnapshotResult < Struct.new(
      :description,
      :import_task_id,
      :snapshot_task_detail)
      include Aws::Structure
    end

    # Describes an import snapshot task.
    #
    # @!attribute [rw] description
    #   A description of the import snapshot task.
    #   @return [String]
    #
    # @!attribute [rw] import_task_id
    #   The ID of the import snapshot task.
    #   @return [String]
    #
    # @!attribute [rw] snapshot_task_detail
    #   Describes an import snapshot task.
    #   @return [Types::SnapshotTaskDetail]
    #
    # @!attribute [rw] tags
    #   The tags for the import snapshot task.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportSnapshotTask AWS API Documentation
    #
    class ImportSnapshotTask < Struct.new(
      :description,
      :import_task_id,
      :snapshot_task_detail,
      :tags)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ImportVolumeRequest
    #   data as a hash:
    #
    #       {
    #         availability_zone: "String", # required
    #         description: "String",
    #         dry_run: false,
    #         image: { # required
    #           bytes: 1, # required
    #           format: "VMDK", # required, accepts VMDK, RAW, VHD
    #           import_manifest_url: "String", # required
    #         },
    #         volume: { # required
    #           size: 1, # required
    #         },
    #       }
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone for the resulting EBS volume.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   A description of the volume.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] image
    #   The disk image.
    #   @return [Types::DiskImageDetail]
    #
    # @!attribute [rw] volume
    #   The volume size.
    #   @return [Types::VolumeDetail]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportVolumeRequest AWS API Documentation
    #
    class ImportVolumeRequest < Struct.new(
      :availability_zone,
      :description,
      :dry_run,
      :image,
      :volume)
      include Aws::Structure
    end

    # @!attribute [rw] conversion_task
    #   Information about the conversion task.
    #   @return [Types::ConversionTask]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportVolumeResult AWS API Documentation
    #
    class ImportVolumeResult < Struct.new(
      :conversion_task)
      include Aws::Structure
    end

    # Describes an import volume task.
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone where the resulting volume will reside.
    #   @return [String]
    #
    # @!attribute [rw] bytes_converted
    #   The number of bytes converted so far.
    #   @return [Integer]
    #
    # @!attribute [rw] description
    #   The description you provided when starting the import volume task.
    #   @return [String]
    #
    # @!attribute [rw] image
    #   The image.
    #   @return [Types::DiskImageDescription]
    #
    # @!attribute [rw] volume
    #   The volume.
    #   @return [Types::DiskImageVolumeDescription]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ImportVolumeTaskDetails AWS API Documentation
    #
    class ImportVolumeTaskDetails < Struct.new(
      :availability_zone,
      :bytes_converted,
      :description,
      :image,
      :volume)
      include Aws::Structure
    end

    # Describes the Inference accelerators for the instance type.
    #
    # @!attribute [rw] accelerators
    #   Describes the Inference accelerators for the instance type.
    #   @return [Array<Types::InferenceDeviceInfo>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InferenceAcceleratorInfo AWS API Documentation
    #
    class InferenceAcceleratorInfo < Struct.new(
      :accelerators)
      include Aws::Structure
    end

    # Describes the Inference accelerators for the instance type.
    #
    # @!attribute [rw] count
    #   The number of Inference accelerators for the instance type.
    #   @return [Integer]
    #
    # @!attribute [rw] name
    #   The name of the Inference accelerator.
    #   @return [String]
    #
    # @!attribute [rw] manufacturer
    #   The manufacturer of the Inference accelerator.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InferenceDeviceInfo AWS API Documentation
    #
    class InferenceDeviceInfo < Struct.new(
      :count,
      :name,
      :manufacturer)
      include Aws::Structure
    end

    # Describes an instance.
    #
    # @!attribute [rw] ami_launch_index
    #   The AMI launch index, which can be used to find this instance in the
    #   launch group.
    #   @return [Integer]
    #
    # @!attribute [rw] image_id
    #   The ID of the AMI used to launch the instance.
    #   @return [String]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   The instance type.
    #   @return [String]
    #
    # @!attribute [rw] kernel_id
    #   The kernel associated with this instance, if applicable.
    #   @return [String]
    #
    # @!attribute [rw] key_name
    #   The name of the key pair, if this instance was launched with an
    #   associated key pair.
    #   @return [String]
    #
    # @!attribute [rw] launch_time
    #   The time the instance was launched.
    #   @return [Time]
    #
    # @!attribute [rw] monitoring
    #   The monitoring for the instance.
    #   @return [Types::Monitoring]
    #
    # @!attribute [rw] placement
    #   The location where the instance launched, if applicable.
    #   @return [Types::Placement]
    #
    # @!attribute [rw] platform
    #   The value is `Windows` for Windows instances; otherwise blank.
    #   @return [String]
    #
    # @!attribute [rw] private_dns_name
    #   (IPv4 only) The private DNS hostname name assigned to the instance.
    #   This DNS hostname can only be used inside the Amazon EC2 network.
    #   This name is not available until the instance enters the `running`
    #   state.
    #
    #   \[EC2-VPC\] The Amazon-provided DNS server resolves Amazon-provided
    #   private DNS hostnames if you've enabled DNS resolution and DNS
    #   hostnames in your VPC. If you are not using the Amazon-provided DNS
    #   server in your VPC, your custom domain name servers must resolve the
    #   hostname as appropriate.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_address
    #   The private IPv4 address assigned to the instance.
    #   @return [String]
    #
    # @!attribute [rw] product_codes
    #   The product codes attached to this instance, if applicable.
    #   @return [Array<Types::ProductCode>]
    #
    # @!attribute [rw] public_dns_name
    #   (IPv4 only) The public DNS name assigned to the instance. This name
    #   is not available until the instance enters the `running` state. For
    #   EC2-VPC, this name is only available if you've enabled DNS
    #   hostnames for your VPC.
    #   @return [String]
    #
    # @!attribute [rw] public_ip_address
    #   The public IPv4 address assigned to the instance, if applicable.
    #   @return [String]
    #
    # @!attribute [rw] ramdisk_id
    #   The RAM disk associated with this instance, if applicable.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The current state of the instance.
    #   @return [Types::InstanceState]
    #
    # @!attribute [rw] state_transition_reason
    #   The reason for the most recent state transition. This might be an
    #   empty string.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   \[EC2-VPC\] The ID of the subnet in which the instance is running.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   \[EC2-VPC\] The ID of the VPC in which the instance is running.
    #   @return [String]
    #
    # @!attribute [rw] architecture
    #   The architecture of the image.
    #   @return [String]
    #
    # @!attribute [rw] block_device_mappings
    #   Any block device mapping entries for the instance.
    #   @return [Array<Types::InstanceBlockDeviceMapping>]
    #
    # @!attribute [rw] client_token
    #   The idempotency token you provided when you launched the instance,
    #   if applicable.
    #   @return [String]
    #
    # @!attribute [rw] ebs_optimized
    #   Indicates whether the instance is optimized for Amazon EBS I/O. This
    #   optimization provides dedicated throughput to Amazon EBS and an
    #   optimized configuration stack to provide optimal I/O performance.
    #   This optimization isn't available with all instance types.
    #   Additional usage charges apply when using an EBS Optimized instance.
    #   @return [Boolean]
    #
    # @!attribute [rw] ena_support
    #   Specifies whether enhanced networking with ENA is enabled.
    #   @return [Boolean]
    #
    # @!attribute [rw] hypervisor
    #   The hypervisor type of the instance. The value `xen` is used for
    #   both Xen and Nitro hypervisors.
    #   @return [String]
    #
    # @!attribute [rw] iam_instance_profile
    #   The IAM instance profile associated with the instance, if
    #   applicable.
    #   @return [Types::IamInstanceProfile]
    #
    # @!attribute [rw] instance_lifecycle
    #   Indicates whether this is a Spot Instance or a Scheduled Instance.
    #   @return [String]
    #
    # @!attribute [rw] elastic_gpu_associations
    #   The Elastic GPU associated with the instance.
    #   @return [Array<Types::ElasticGpuAssociation>]
    #
    # @!attribute [rw] elastic_inference_accelerator_associations
    #   The elastic inference accelerator associated with the instance.
    #   @return [Array<Types::ElasticInferenceAcceleratorAssociation>]
    #
    # @!attribute [rw] network_interfaces
    #   \[EC2-VPC\] The network interfaces for the instance.
    #   @return [Array<Types::InstanceNetworkInterface>]
    #
    # @!attribute [rw] outpost_arn
    #   The Amazon Resource Name (ARN) of the Outpost.
    #   @return [String]
    #
    # @!attribute [rw] root_device_name
    #   The device name of the root device volume (for example,
    #   `/dev/sda1`).
    #   @return [String]
    #
    # @!attribute [rw] root_device_type
    #   The root device type used by the AMI. The AMI can use an EBS volume
    #   or an instance store volume.
    #   @return [String]
    #
    # @!attribute [rw] security_groups
    #   The security groups for the instance.
    #   @return [Array<Types::GroupIdentifier>]
    #
    # @!attribute [rw] source_dest_check
    #   Specifies whether to enable an instance launched in a VPC to perform
    #   NAT. This controls whether source/destination checking is enabled on
    #   the instance. A value of `true` means that checking is enabled, and
    #   `false` means that checking is disabled. The value must be `false`
    #   for the instance to perform NAT. For more information, see [NAT
    #   Instances][1] in the *Amazon Virtual Private Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AmazonVPC/latest/UserGuide/VPC_NAT_Instance.html
    #   @return [Boolean]
    #
    # @!attribute [rw] spot_instance_request_id
    #   If the request is a Spot Instance request, the ID of the request.
    #   @return [String]
    #
    # @!attribute [rw] sriov_net_support
    #   Specifies whether enhanced networking with the Intel 82599 Virtual
    #   Function interface is enabled.
    #   @return [String]
    #
    # @!attribute [rw] state_reason
    #   The reason for the most recent state transition.
    #   @return [Types::StateReason]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the instance.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] virtualization_type
    #   The virtualization type of the instance.
    #   @return [String]
    #
    # @!attribute [rw] cpu_options
    #   The CPU options for the instance.
    #   @return [Types::CpuOptions]
    #
    # @!attribute [rw] capacity_reservation_id
    #   The ID of the Capacity Reservation.
    #   @return [String]
    #
    # @!attribute [rw] capacity_reservation_specification
    #   Information about the Capacity Reservation targeting option.
    #   @return [Types::CapacityReservationSpecificationResponse]
    #
    # @!attribute [rw] hibernation_options
    #   Indicates whether the instance is enabled for hibernation.
    #   @return [Types::HibernationOptions]
    #
    # @!attribute [rw] licenses
    #   The license configurations.
    #   @return [Array<Types::LicenseConfiguration>]
    #
    # @!attribute [rw] metadata_options
    #   The metadata options for the instance.
    #   @return [Types::InstanceMetadataOptionsResponse]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Instance AWS API Documentation
    #
    class Instance < Struct.new(
      :ami_launch_index,
      :image_id,
      :instance_id,
      :instance_type,
      :kernel_id,
      :key_name,
      :launch_time,
      :monitoring,
      :placement,
      :platform,
      :private_dns_name,
      :private_ip_address,
      :product_codes,
      :public_dns_name,
      :public_ip_address,
      :ramdisk_id,
      :state,
      :state_transition_reason,
      :subnet_id,
      :vpc_id,
      :architecture,
      :block_device_mappings,
      :client_token,
      :ebs_optimized,
      :ena_support,
      :hypervisor,
      :iam_instance_profile,
      :instance_lifecycle,
      :elastic_gpu_associations,
      :elastic_inference_accelerator_associations,
      :network_interfaces,
      :outpost_arn,
      :root_device_name,
      :root_device_type,
      :security_groups,
      :source_dest_check,
      :spot_instance_request_id,
      :sriov_net_support,
      :state_reason,
      :tags,
      :virtualization_type,
      :cpu_options,
      :capacity_reservation_id,
      :capacity_reservation_specification,
      :hibernation_options,
      :licenses,
      :metadata_options)
      include Aws::Structure
    end

    # Describes an instance attribute.
    #
    # @!attribute [rw] groups
    #   The security groups associated with the instance.
    #   @return [Array<Types::GroupIdentifier>]
    #
    # @!attribute [rw] block_device_mappings
    #   The block device mapping of the instance.
    #   @return [Array<Types::InstanceBlockDeviceMapping>]
    #
    # @!attribute [rw] disable_api_termination
    #   If the value is `true`, you can't terminate the instance through
    #   the Amazon EC2 console, CLI, or API; otherwise, you can.
    #   @return [Types::AttributeBooleanValue]
    #
    # @!attribute [rw] ena_support
    #   Indicates whether enhanced networking with ENA is enabled.
    #   @return [Types::AttributeBooleanValue]
    #
    # @!attribute [rw] ebs_optimized
    #   Indicates whether the instance is optimized for Amazon EBS I/O.
    #   @return [Types::AttributeBooleanValue]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] instance_initiated_shutdown_behavior
    #   Indicates whether an instance stops or terminates when you initiate
    #   shutdown from the instance (using the operating system command for
    #   system shutdown).
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] instance_type
    #   The instance type.
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] kernel_id
    #   The kernel ID.
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] product_codes
    #   A list of product codes.
    #   @return [Array<Types::ProductCode>]
    #
    # @!attribute [rw] ramdisk_id
    #   The RAM disk ID.
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] root_device_name
    #   The device name of the root device volume (for example,
    #   `/dev/sda1`).
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] source_dest_check
    #   Indicates whether source/destination checking is enabled. A value of
    #   `true` means that checking is enabled, and `false` means that
    #   checking is disabled. This value must be `false` for a NAT instance
    #   to perform NAT.
    #   @return [Types::AttributeBooleanValue]
    #
    # @!attribute [rw] sriov_net_support
    #   Indicates whether enhanced networking with the Intel 82599 Virtual
    #   Function interface is enabled.
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] user_data
    #   The user data.
    #   @return [Types::AttributeValue]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceAttribute AWS API Documentation
    #
    class InstanceAttribute < Struct.new(
      :groups,
      :block_device_mappings,
      :disable_api_termination,
      :ena_support,
      :ebs_optimized,
      :instance_id,
      :instance_initiated_shutdown_behavior,
      :instance_type,
      :kernel_id,
      :product_codes,
      :ramdisk_id,
      :root_device_name,
      :source_dest_check,
      :sriov_net_support,
      :user_data)
      include Aws::Structure
    end

    # Describes a block device mapping.
    #
    # @!attribute [rw] device_name
    #   The device name (for example, `/dev/sdh` or `xvdh`).
    #   @return [String]
    #
    # @!attribute [rw] ebs
    #   Parameters used to automatically set up EBS volumes when the
    #   instance is launched.
    #   @return [Types::EbsInstanceBlockDevice]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceBlockDeviceMapping AWS API Documentation
    #
    class InstanceBlockDeviceMapping < Struct.new(
      :device_name,
      :ebs)
      include Aws::Structure
    end

    # Describes a block device mapping entry.
    #
    # @note When making an API call, you may pass InstanceBlockDeviceMappingSpecification
    #   data as a hash:
    #
    #       {
    #         device_name: "String",
    #         ebs: {
    #           delete_on_termination: false,
    #           volume_id: "VolumeId",
    #         },
    #         no_device: "String",
    #         virtual_name: "String",
    #       }
    #
    # @!attribute [rw] device_name
    #   The device name (for example, `/dev/sdh` or `xvdh`).
    #   @return [String]
    #
    # @!attribute [rw] ebs
    #   Parameters used to automatically set up EBS volumes when the
    #   instance is launched.
    #   @return [Types::EbsInstanceBlockDeviceSpecification]
    #
    # @!attribute [rw] no_device
    #   suppress the specified device included in the block device mapping.
    #   @return [String]
    #
    # @!attribute [rw] virtual_name
    #   The virtual device name.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceBlockDeviceMappingSpecification AWS API Documentation
    #
    class InstanceBlockDeviceMappingSpecification < Struct.new(
      :device_name,
      :ebs,
      :no_device,
      :virtual_name)
      include Aws::Structure
    end

    # Information about the number of instances that can be launched onto
    # the Dedicated Host.
    #
    # @!attribute [rw] available_capacity
    #   The number of instances that can be launched onto the Dedicated Host
    #   based on the host's available capacity.
    #   @return [Integer]
    #
    # @!attribute [rw] instance_type
    #   The instance type supported by the Dedicated Host.
    #   @return [String]
    #
    # @!attribute [rw] total_capacity
    #   The total number of instances that can be launched onto the
    #   Dedicated Host if there are no instances running on it.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceCapacity AWS API Documentation
    #
    class InstanceCapacity < Struct.new(
      :available_capacity,
      :instance_type,
      :total_capacity)
      include Aws::Structure
    end

    # Describes a Reserved Instance listing state.
    #
    # @!attribute [rw] instance_count
    #   The number of listed Reserved Instances in the state specified by
    #   the `state`.
    #   @return [Integer]
    #
    # @!attribute [rw] state
    #   The states of the listed Reserved Instances.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceCount AWS API Documentation
    #
    class InstanceCount < Struct.new(
      :instance_count,
      :state)
      include Aws::Structure
    end

    # Describes the credit option for CPU usage of a burstable performance
    # instance.
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] cpu_credits
    #   The credit option for CPU usage of the instance. Valid values are
    #   `standard` and `unlimited`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceCreditSpecification AWS API Documentation
    #
    class InstanceCreditSpecification < Struct.new(
      :instance_id,
      :cpu_credits)
      include Aws::Structure
    end

    # Describes the credit option for CPU usage of a burstable performance
    # instance.
    #
    # @note When making an API call, you may pass InstanceCreditSpecificationRequest
    #   data as a hash:
    #
    #       {
    #         instance_id: "InstanceId",
    #         cpu_credits: "String",
    #       }
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] cpu_credits
    #   The credit option for CPU usage of the instance. Valid values are
    #   `standard` and `unlimited`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceCreditSpecificationRequest AWS API Documentation
    #
    class InstanceCreditSpecificationRequest < Struct.new(
      :instance_id,
      :cpu_credits)
      include Aws::Structure
    end

    # Describes an instance to export.
    #
    # @!attribute [rw] instance_id
    #   The ID of the resource being exported.
    #   @return [String]
    #
    # @!attribute [rw] target_environment
    #   The target virtualization environment.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceExportDetails AWS API Documentation
    #
    class InstanceExportDetails < Struct.new(
      :instance_id,
      :target_environment)
      include Aws::Structure
    end

    # Describes the default credit option for CPU usage of a burstable
    # performance instance family.
    #
    # @!attribute [rw] instance_family
    #   The instance family.
    #   @return [String]
    #
    # @!attribute [rw] cpu_credits
    #   The default credit option for CPU usage of the instance family.
    #   Valid values are `standard` and `unlimited`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceFamilyCreditSpecification AWS API Documentation
    #
    class InstanceFamilyCreditSpecification < Struct.new(
      :instance_family,
      :cpu_credits)
      include Aws::Structure
    end

    # Describes an IPv6 address.
    #
    # @note When making an API call, you may pass InstanceIpv6Address
    #   data as a hash:
    #
    #       {
    #         ipv_6_address: "String",
    #       }
    #
    # @!attribute [rw] ipv_6_address
    #   The IPv6 address.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceIpv6Address AWS API Documentation
    #
    class InstanceIpv6Address < Struct.new(
      :ipv_6_address)
      include Aws::Structure
    end

    # Describes an IPv6 address.
    #
    # @note When making an API call, you may pass InstanceIpv6AddressRequest
    #   data as a hash:
    #
    #       {
    #         ipv_6_address: "String",
    #       }
    #
    # @!attribute [rw] ipv_6_address
    #   The IPv6 address.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceIpv6AddressRequest AWS API Documentation
    #
    class InstanceIpv6AddressRequest < Struct.new(
      :ipv_6_address)
      include Aws::Structure
    end

    # Describes the market (purchasing) option for the instances.
    #
    # @note When making an API call, you may pass InstanceMarketOptionsRequest
    #   data as a hash:
    #
    #       {
    #         market_type: "spot", # accepts spot
    #         spot_options: {
    #           max_price: "String",
    #           spot_instance_type: "one-time", # accepts one-time, persistent
    #           block_duration_minutes: 1,
    #           valid_until: Time.now,
    #           instance_interruption_behavior: "hibernate", # accepts hibernate, stop, terminate
    #         },
    #       }
    #
    # @!attribute [rw] market_type
    #   The market type.
    #   @return [String]
    #
    # @!attribute [rw] spot_options
    #   The options for Spot Instances.
    #   @return [Types::SpotMarketOptions]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceMarketOptionsRequest AWS API Documentation
    #
    class InstanceMarketOptionsRequest < Struct.new(
      :market_type,
      :spot_options)
      include Aws::Structure
    end

    # The metadata options for the instance.
    #
    # @note When making an API call, you may pass InstanceMetadataOptionsRequest
    #   data as a hash:
    #
    #       {
    #         http_tokens: "optional", # accepts optional, required
    #         http_put_response_hop_limit: 1,
    #         http_endpoint: "disabled", # accepts disabled, enabled
    #       }
    #
    # @!attribute [rw] http_tokens
    #   The state of token usage for your instance metadata requests. If the
    #   parameter is not specified in the request, the default state is
    #   `optional`.
    #
    #   If the state is `optional`, you can choose to retrieve instance
    #   metadata with or without a signed token header on your request. If
    #   you retrieve the IAM role credentials without a token, the version
    #   1.0 role credentials are returned. If you retrieve the IAM role
    #   credentials using a valid signed token, the version 2.0 role
    #   credentials are returned.
    #
    #   If the state is `required`, you must send a signed token header with
    #   any instance metadata retrieval requests. In this state, retrieving
    #   the IAM role credentials always returns the version 2.0 credentials;
    #   the version 1.0 credentials are not available.
    #   @return [String]
    #
    # @!attribute [rw] http_put_response_hop_limit
    #   The desired HTTP PUT response hop limit for instance metadata
    #   requests. The larger the number, the further instance metadata
    #   requests can travel.
    #
    #   Default: 1
    #
    #   Possible values: Integers from 1 to 64
    #   @return [Integer]
    #
    # @!attribute [rw] http_endpoint
    #   This parameter enables or disables the HTTP metadata endpoint on
    #   your instances. If the parameter is not specified, the default state
    #   is `enabled`.
    #
    #   <note markdown="1"> If you specify a value of `disabled`, you will not be able to access
    #   your instance metadata.
    #
    #    </note>
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceMetadataOptionsRequest AWS API Documentation
    #
    class InstanceMetadataOptionsRequest < Struct.new(
      :http_tokens,
      :http_put_response_hop_limit,
      :http_endpoint)
      include Aws::Structure
    end

    # The metadata options for the instance.
    #
    # @!attribute [rw] state
    #   The state of the metadata option changes.
    #
    #   `pending` - The metadata options are being updated and the instance
    #   is not ready to process metadata traffic with the new selection.
    #
    #   `applied` - The metadata options have been successfully applied on
    #   the instance.
    #   @return [String]
    #
    # @!attribute [rw] http_tokens
    #   The state of token usage for your instance metadata requests. If the
    #   parameter is not specified in the request, the default state is
    #   `optional`.
    #
    #   If the state is `optional`, you can choose to retrieve instance
    #   metadata with or without a signed token header on your request. If
    #   you retrieve the IAM role credentials without a token, the version
    #   1.0 role credentials are returned. If you retrieve the IAM role
    #   credentials using a valid signed token, the version 2.0 role
    #   credentials are returned.
    #
    #   If the state is `required`, you must send a signed token header with
    #   any instance metadata retrieval requests. In this state, retrieving
    #   the IAM role credential always returns the version 2.0 credentials;
    #   the version 1.0 credentials are not available.
    #   @return [String]
    #
    # @!attribute [rw] http_put_response_hop_limit
    #   The desired HTTP PUT response hop limit for instance metadata
    #   requests. The larger the number, the further instance metadata
    #   requests can travel.
    #
    #   Default: 1
    #
    #   Possible values: Integers from 1 to 64
    #   @return [Integer]
    #
    # @!attribute [rw] http_endpoint
    #   This parameter enables or disables the HTTP metadata endpoint on
    #   your instances. If the parameter is not specified, the default state
    #   is `enabled`.
    #
    #   <note markdown="1"> If you specify a value of `disabled`, you will not be able to access
    #   your instance metadata.
    #
    #    </note>
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceMetadataOptionsResponse AWS API Documentation
    #
    class InstanceMetadataOptionsResponse < Struct.new(
      :state,
      :http_tokens,
      :http_put_response_hop_limit,
      :http_endpoint)
      include Aws::Structure
    end

    # Describes the monitoring of an instance.
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] monitoring
    #   The monitoring for the instance.
    #   @return [Types::Monitoring]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceMonitoring AWS API Documentation
    #
    class InstanceMonitoring < Struct.new(
      :instance_id,
      :monitoring)
      include Aws::Structure
    end

    # Describes a network interface.
    #
    # @!attribute [rw] association
    #   The association information for an Elastic IPv4 associated with the
    #   network interface.
    #   @return [Types::InstanceNetworkInterfaceAssociation]
    #
    # @!attribute [rw] attachment
    #   The network interface attachment.
    #   @return [Types::InstanceNetworkInterfaceAttachment]
    #
    # @!attribute [rw] description
    #   The description.
    #   @return [String]
    #
    # @!attribute [rw] groups
    #   One or more security groups.
    #   @return [Array<Types::GroupIdentifier>]
    #
    # @!attribute [rw] ipv_6_addresses
    #   One or more IPv6 addresses associated with the network interface.
    #   @return [Array<Types::InstanceIpv6Address>]
    #
    # @!attribute [rw] mac_address
    #   The MAC address.
    #   @return [String]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account that created the network interface.
    #   @return [String]
    #
    # @!attribute [rw] private_dns_name
    #   The private DNS name.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_address
    #   The IPv4 address of the network interface within the subnet.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_addresses
    #   One or more private IPv4 addresses associated with the network
    #   interface.
    #   @return [Array<Types::InstancePrivateIpAddress>]
    #
    # @!attribute [rw] source_dest_check
    #   Indicates whether to validate network traffic to or from this
    #   network interface.
    #   @return [Boolean]
    #
    # @!attribute [rw] status
    #   The status of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] interface_type
    #   Describes the type of network interface.
    #
    #   Valid values: `interface` \| `efa`
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceNetworkInterface AWS API Documentation
    #
    class InstanceNetworkInterface < Struct.new(
      :association,
      :attachment,
      :description,
      :groups,
      :ipv_6_addresses,
      :mac_address,
      :network_interface_id,
      :owner_id,
      :private_dns_name,
      :private_ip_address,
      :private_ip_addresses,
      :source_dest_check,
      :status,
      :subnet_id,
      :vpc_id,
      :interface_type)
      include Aws::Structure
    end

    # Describes association information for an Elastic IP address (IPv4).
    #
    # @!attribute [rw] ip_owner_id
    #   The ID of the owner of the Elastic IP address.
    #   @return [String]
    #
    # @!attribute [rw] public_dns_name
    #   The public DNS name.
    #   @return [String]
    #
    # @!attribute [rw] public_ip
    #   The public IP address or Elastic IP address bound to the network
    #   interface.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceNetworkInterfaceAssociation AWS API Documentation
    #
    class InstanceNetworkInterfaceAssociation < Struct.new(
      :ip_owner_id,
      :public_dns_name,
      :public_ip)
      include Aws::Structure
    end

    # Describes a network interface attachment.
    #
    # @!attribute [rw] attach_time
    #   The time stamp when the attachment initiated.
    #   @return [Time]
    #
    # @!attribute [rw] attachment_id
    #   The ID of the network interface attachment.
    #   @return [String]
    #
    # @!attribute [rw] delete_on_termination
    #   Indicates whether the network interface is deleted when the instance
    #   is terminated.
    #   @return [Boolean]
    #
    # @!attribute [rw] device_index
    #   The index of the device on the instance for the network interface
    #   attachment.
    #   @return [Integer]
    #
    # @!attribute [rw] status
    #   The attachment state.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceNetworkInterfaceAttachment AWS API Documentation
    #
    class InstanceNetworkInterfaceAttachment < Struct.new(
      :attach_time,
      :attachment_id,
      :delete_on_termination,
      :device_index,
      :status)
      include Aws::Structure
    end

    # Describes a network interface.
    #
    # @note When making an API call, you may pass InstanceNetworkInterfaceSpecification
    #   data as a hash:
    #
    #       {
    #         associate_public_ip_address: false,
    #         delete_on_termination: false,
    #         description: "String",
    #         device_index: 1,
    #         groups: ["SecurityGroupId"],
    #         ipv_6_address_count: 1,
    #         ipv_6_addresses: [
    #           {
    #             ipv_6_address: "String",
    #           },
    #         ],
    #         network_interface_id: "String",
    #         private_ip_address: "String",
    #         private_ip_addresses: [
    #           {
    #             primary: false,
    #             private_ip_address: "String",
    #           },
    #         ],
    #         secondary_private_ip_address_count: 1,
    #         subnet_id: "String",
    #         interface_type: "String",
    #       }
    #
    # @!attribute [rw] associate_public_ip_address
    #   Indicates whether to assign a public IPv4 address to an instance you
    #   launch in a VPC. The public IP address can only be assigned to a
    #   network interface for eth0, and can only be assigned to a new
    #   network interface, not an existing one. You cannot specify more than
    #   one network interface in the request. If launching into a default
    #   subnet, the default value is `true`.
    #   @return [Boolean]
    #
    # @!attribute [rw] delete_on_termination
    #   If set to `true`, the interface is deleted when the instance is
    #   terminated. You can specify `true` only if creating a new network
    #   interface when launching an instance.
    #   @return [Boolean]
    #
    # @!attribute [rw] description
    #   The description of the network interface. Applies only if creating a
    #   network interface when launching an instance.
    #   @return [String]
    #
    # @!attribute [rw] device_index
    #   The position of the network interface in the attachment order. A
    #   primary network interface has a device index of 0.
    #
    #   If you specify a network interface when launching an instance, you
    #   must specify the device index.
    #   @return [Integer]
    #
    # @!attribute [rw] groups
    #   The IDs of the security groups for the network interface. Applies
    #   only if creating a network interface when launching an instance.
    #   @return [Array<String>]
    #
    # @!attribute [rw] ipv_6_address_count
    #   A number of IPv6 addresses to assign to the network interface.
    #   Amazon EC2 chooses the IPv6 addresses from the range of the subnet.
    #   You cannot specify this option and the option to assign specific
    #   IPv6 addresses in the same request. You can specify this option if
    #   you've specified a minimum number of instances to launch.
    #   @return [Integer]
    #
    # @!attribute [rw] ipv_6_addresses
    #   One or more IPv6 addresses to assign to the network interface. You
    #   cannot specify this option and the option to assign a number of IPv6
    #   addresses in the same request. You cannot specify this option if
    #   you've specified a minimum number of instances to launch.
    #   @return [Array<Types::InstanceIpv6Address>]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #
    #   If you are creating a Spot Fleet, omit this parameter because you
    #   can’t specify a network interface ID in a launch specification.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_address
    #   The private IPv4 address of the network interface. Applies only if
    #   creating a network interface when launching an instance. You cannot
    #   specify this option if you're launching more than one instance in a
    #   [RunInstances][1] request.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html
    #   @return [String]
    #
    # @!attribute [rw] private_ip_addresses
    #   One or more private IPv4 addresses to assign to the network
    #   interface. Only one private IPv4 address can be designated as
    #   primary. You cannot specify this option if you're launching more
    #   than one instance in a [RunInstances][1] request.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html
    #   @return [Array<Types::PrivateIpAddressSpecification>]
    #
    # @!attribute [rw] secondary_private_ip_address_count
    #   The number of secondary private IPv4 addresses. You can't specify
    #   this option and specify more than one private IP address using the
    #   private IP addresses option. You cannot specify this option if
    #   you're launching more than one instance in a [RunInstances][1]
    #   request.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances.html
    #   @return [Integer]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet associated with the network interface. Applies
    #   only if creating a network interface when launching an instance.
    #   @return [String]
    #
    # @!attribute [rw] interface_type
    #   The type of network interface. To create an Elastic Fabric Adapter
    #   (EFA), specify `efa`. For more information, see [Elastic Fabric
    #   Adapter][1] in the *Amazon Elastic Compute Cloud User Guide*.
    #
    #   If you are not creating an EFA, specify `interface` or omit this
    #   parameter.
    #
    #   Valid values: `interface` \| `efa`
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceNetworkInterfaceSpecification AWS API Documentation
    #
    class InstanceNetworkInterfaceSpecification < Struct.new(
      :associate_public_ip_address,
      :delete_on_termination,
      :description,
      :device_index,
      :groups,
      :ipv_6_address_count,
      :ipv_6_addresses,
      :network_interface_id,
      :private_ip_address,
      :private_ip_addresses,
      :secondary_private_ip_address_count,
      :subnet_id,
      :interface_type)
      include Aws::Structure
    end

    # Describes a private IPv4 address.
    #
    # @!attribute [rw] association
    #   The association information for an Elastic IP address for the
    #   network interface.
    #   @return [Types::InstanceNetworkInterfaceAssociation]
    #
    # @!attribute [rw] primary
    #   Indicates whether this IPv4 address is the primary private IP
    #   address of the network interface.
    #   @return [Boolean]
    #
    # @!attribute [rw] private_dns_name
    #   The private IPv4 DNS name.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_address
    #   The private IPv4 address of the network interface.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstancePrivateIpAddress AWS API Documentation
    #
    class InstancePrivateIpAddress < Struct.new(
      :association,
      :primary,
      :private_dns_name,
      :private_ip_address)
      include Aws::Structure
    end

    # The instance details to specify which volumes should be snapshotted.
    #
    # @note When making an API call, you may pass InstanceSpecification
    #   data as a hash:
    #
    #       {
    #         instance_id: "InstanceId",
    #         exclude_boot_volume: false,
    #       }
    #
    # @!attribute [rw] instance_id
    #   The instance to specify which volumes should be snapshotted.
    #   @return [String]
    #
    # @!attribute [rw] exclude_boot_volume
    #   Excludes the root volume from being snapshotted.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceSpecification AWS API Documentation
    #
    class InstanceSpecification < Struct.new(
      :instance_id,
      :exclude_boot_volume)
      include Aws::Structure
    end

    # Describes the current state of an instance.
    #
    # @!attribute [rw] code
    #   The state of the instance as a 16-bit unsigned integer.
    #
    #   The high byte is all of the bits between 2^8 and (2^16)-1, which
    #   equals decimal values between 256 and 65,535. These numerical values
    #   are used for internal purposes and should be ignored.
    #
    #   The low byte is all of the bits between 2^0 and (2^8)-1, which
    #   equals decimal values between 0 and 255.
    #
    #   The valid values for instance-state-code will all be in the range of
    #   the low byte and they are:
    #
    #   * `0`\: `pending`
    #
    #   * `16`\: `running`
    #
    #   * `32`\: `shutting-down`
    #
    #   * `48`\: `terminated`
    #
    #   * `64`\: `stopping`
    #
    #   * `80`\: `stopped`
    #
    #   You can ignore the high byte value by zeroing out all of the bits
    #   above 2^8 or 256 in decimal.
    #   @return [Integer]
    #
    # @!attribute [rw] name
    #   The current state of the instance.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceState AWS API Documentation
    #
    class InstanceState < Struct.new(
      :code,
      :name)
      include Aws::Structure
    end

    # Describes an instance state change.
    #
    # @!attribute [rw] current_state
    #   The current state of the instance.
    #   @return [Types::InstanceState]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] previous_state
    #   The previous state of the instance.
    #   @return [Types::InstanceState]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceStateChange AWS API Documentation
    #
    class InstanceStateChange < Struct.new(
      :current_state,
      :instance_id,
      :previous_state)
      include Aws::Structure
    end

    # Describes the status of an instance.
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone of the instance.
    #   @return [String]
    #
    # @!attribute [rw] outpost_arn
    #   The Amazon Resource Name (ARN) of the Outpost.
    #   @return [String]
    #
    # @!attribute [rw] events
    #   Any scheduled events associated with the instance.
    #   @return [Array<Types::InstanceStatusEvent>]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] instance_state
    #   The intended state of the instance. DescribeInstanceStatus requires
    #   that an instance be in the `running` state.
    #   @return [Types::InstanceState]
    #
    # @!attribute [rw] instance_status
    #   Reports impaired functionality that stems from issues internal to
    #   the instance, such as impaired reachability.
    #   @return [Types::InstanceStatusSummary]
    #
    # @!attribute [rw] system_status
    #   Reports impaired functionality that stems from issues related to the
    #   systems that support an instance, such as hardware failures and
    #   network connectivity problems.
    #   @return [Types::InstanceStatusSummary]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceStatus AWS API Documentation
    #
    class InstanceStatus < Struct.new(
      :availability_zone,
      :outpost_arn,
      :events,
      :instance_id,
      :instance_state,
      :instance_status,
      :system_status)
      include Aws::Structure
    end

    # Describes the instance status.
    #
    # @!attribute [rw] impaired_since
    #   The time when a status check failed. For an instance that was
    #   launched and impaired, this is the time when the instance was
    #   launched.
    #   @return [Time]
    #
    # @!attribute [rw] name
    #   The type of instance status.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The status.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceStatusDetails AWS API Documentation
    #
    class InstanceStatusDetails < Struct.new(
      :impaired_since,
      :name,
      :status)
      include Aws::Structure
    end

    # Describes a scheduled event for an instance.
    #
    # @!attribute [rw] instance_event_id
    #   The ID of the event.
    #   @return [String]
    #
    # @!attribute [rw] code
    #   The event code.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   A description of the event.
    #
    #   After a scheduled event is completed, it can still be described for
    #   up to a week. If the event has been completed, this description
    #   starts with the following text: \[Completed\].
    #   @return [String]
    #
    # @!attribute [rw] not_after
    #   The latest scheduled end time for the event.
    #   @return [Time]
    #
    # @!attribute [rw] not_before
    #   The earliest scheduled start time for the event.
    #   @return [Time]
    #
    # @!attribute [rw] not_before_deadline
    #   The deadline for starting the event.
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceStatusEvent AWS API Documentation
    #
    class InstanceStatusEvent < Struct.new(
      :instance_event_id,
      :code,
      :description,
      :not_after,
      :not_before,
      :not_before_deadline)
      include Aws::Structure
    end

    # Describes the status of an instance.
    #
    # @!attribute [rw] details
    #   The system instance health or application instance health.
    #   @return [Array<Types::InstanceStatusDetails>]
    #
    # @!attribute [rw] status
    #   The status.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceStatusSummary AWS API Documentation
    #
    class InstanceStatusSummary < Struct.new(
      :details,
      :status)
      include Aws::Structure
    end

    # Describes the disks that are available for the instance type.
    #
    # @!attribute [rw] total_size_in_gb
    #   The total size of the disks, in GB.
    #   @return [Integer]
    #
    # @!attribute [rw] disks
    #   Array describing the disks that are available for the instance type.
    #   @return [Array<Types::DiskInfo>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceStorageInfo AWS API Documentation
    #
    class InstanceStorageInfo < Struct.new(
      :total_size_in_gb,
      :disks)
      include Aws::Structure
    end

    # Describes the registered tag keys for the current Region.
    #
    # @!attribute [rw] instance_tag_keys
    #   The registered tag keys.
    #   @return [Array<String>]
    #
    # @!attribute [rw] include_all_tags_of_instance
    #   Indicates wheter all tag keys in the current Region are registered
    #   to appear in scheduled event notifications. `true` indicates that
    #   all tag keys in the current Region are registered.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceTagNotificationAttribute AWS API Documentation
    #
    class InstanceTagNotificationAttribute < Struct.new(
      :instance_tag_keys,
      :include_all_tags_of_instance)
      include Aws::Structure
    end

    # Describes the instance type.
    #
    # @!attribute [rw] instance_type
    #   The instance type. For more information, see [Instance Types][1] in
    #   the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html
    #   @return [String]
    #
    # @!attribute [rw] current_generation
    #   Indicates whether the instance type is a current generation.
    #   @return [Boolean]
    #
    # @!attribute [rw] free_tier_eligible
    #   Indicates whether the instance type is eligible for the free tier.
    #   @return [Boolean]
    #
    # @!attribute [rw] supported_usage_classes
    #   Indicates whether the instance type is offered for spot or
    #   On-Demand.
    #   @return [Array<String>]
    #
    # @!attribute [rw] supported_root_device_types
    #   Indicates the supported root device types.
    #   @return [Array<String>]
    #
    # @!attribute [rw] supported_virtualization_types
    #   The supported virtualization types.
    #   @return [Array<String>]
    #
    # @!attribute [rw] bare_metal
    #   Indicates whether the instance is bare metal.
    #   @return [Boolean]
    #
    # @!attribute [rw] hypervisor
    #   Indicates the hypervisor used for the instance type.
    #   @return [String]
    #
    # @!attribute [rw] processor_info
    #   Describes the processor.
    #   @return [Types::ProcessorInfo]
    #
    # @!attribute [rw] v_cpu_info
    #   Describes the vCPU configurations for the instance type.
    #   @return [Types::VCpuInfo]
    #
    # @!attribute [rw] memory_info
    #   Describes the memory for the instance type.
    #   @return [Types::MemoryInfo]
    #
    # @!attribute [rw] instance_storage_supported
    #   Indicates whether instance storage is supported.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_storage_info
    #   Describes the disks for the instance type.
    #   @return [Types::InstanceStorageInfo]
    #
    # @!attribute [rw] ebs_info
    #   Describes the Amazon EBS settings for the instance type.
    #   @return [Types::EbsInfo]
    #
    # @!attribute [rw] network_info
    #   Describes the network settings for the instance type.
    #   @return [Types::NetworkInfo]
    #
    # @!attribute [rw] gpu_info
    #   Describes the GPU accelerator settings for the instance type.
    #   @return [Types::GpuInfo]
    #
    # @!attribute [rw] fpga_info
    #   Describes the FPGA accelerator settings for the instance type.
    #   @return [Types::FpgaInfo]
    #
    # @!attribute [rw] placement_group_info
    #   Describes the placement group settings for the instance type.
    #   @return [Types::PlacementGroupInfo]
    #
    # @!attribute [rw] inference_accelerator_info
    #   Describes the Inference accelerator settings for the instance type.
    #   @return [Types::InferenceAcceleratorInfo]
    #
    # @!attribute [rw] hibernation_supported
    #   Indicates whether On-Demand hibernation is supported.
    #   @return [Boolean]
    #
    # @!attribute [rw] burstable_performance_supported
    #   Indicates whether the instance type is a burstable performance
    #   instance type.
    #   @return [Boolean]
    #
    # @!attribute [rw] dedicated_hosts_supported
    #   Indicates whether Dedicated Hosts are supported on the instance
    #   type.
    #   @return [Boolean]
    #
    # @!attribute [rw] auto_recovery_supported
    #   Indicates whether auto recovery is supported.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceTypeInfo AWS API Documentation
    #
    class InstanceTypeInfo < Struct.new(
      :instance_type,
      :current_generation,
      :free_tier_eligible,
      :supported_usage_classes,
      :supported_root_device_types,
      :supported_virtualization_types,
      :bare_metal,
      :hypervisor,
      :processor_info,
      :v_cpu_info,
      :memory_info,
      :instance_storage_supported,
      :instance_storage_info,
      :ebs_info,
      :network_info,
      :gpu_info,
      :fpga_info,
      :placement_group_info,
      :inference_accelerator_info,
      :hibernation_supported,
      :burstable_performance_supported,
      :dedicated_hosts_supported,
      :auto_recovery_supported)
      include Aws::Structure
    end

    # The instance types offered.
    #
    # @!attribute [rw] instance_type
    #   The instance type. For more information, see [Instance Types][1] in
    #   the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html
    #   @return [String]
    #
    # @!attribute [rw] location_type
    #   The location type.
    #   @return [String]
    #
    # @!attribute [rw] location
    #   The identifier for the location. This depends on the location type.
    #   For example, if the location type is `region`, the location is the
    #   Region code (for example, `us-east-2`.)
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceTypeOffering AWS API Documentation
    #
    class InstanceTypeOffering < Struct.new(
      :instance_type,
      :location_type,
      :location)
      include Aws::Structure
    end

    # Information about the Capacity Reservation usage.
    #
    # @!attribute [rw] account_id
    #   The ID of the AWS account that is making use of the Capacity
    #   Reservation.
    #   @return [String]
    #
    # @!attribute [rw] used_instance_count
    #   The number of instances the AWS account currently has in the
    #   Capacity Reservation.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InstanceUsage AWS API Documentation
    #
    class InstanceUsage < Struct.new(
      :account_id,
      :used_instance_count)
      include Aws::Structure
    end

    # Describes an internet gateway.
    #
    # @!attribute [rw] attachments
    #   Any VPCs attached to the internet gateway.
    #   @return [Array<Types::InternetGatewayAttachment>]
    #
    # @!attribute [rw] internet_gateway_id
    #   The ID of the internet gateway.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account that owns the internet gateway.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the internet gateway.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InternetGateway AWS API Documentation
    #
    class InternetGateway < Struct.new(
      :attachments,
      :internet_gateway_id,
      :owner_id,
      :tags)
      include Aws::Structure
    end

    # Describes the attachment of a VPC to an internet gateway or an
    # egress-only internet gateway.
    #
    # @!attribute [rw] state
    #   The current state of the attachment. For an internet gateway, the
    #   state is `available` when attached to a VPC; otherwise, this value
    #   is not returned.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/InternetGatewayAttachment AWS API Documentation
    #
    class InternetGatewayAttachment < Struct.new(
      :state,
      :vpc_id)
      include Aws::Structure
    end

    # Describes a set of permissions for a security group rule.
    #
    # @note When making an API call, you may pass IpPermission
    #   data as a hash:
    #
    #       {
    #         from_port: 1,
    #         ip_protocol: "String",
    #         ip_ranges: [
    #           {
    #             cidr_ip: "String",
    #             description: "String",
    #           },
    #         ],
    #         ipv_6_ranges: [
    #           {
    #             cidr_ipv_6: "String",
    #             description: "String",
    #           },
    #         ],
    #         prefix_list_ids: [
    #           {
    #             description: "String",
    #             prefix_list_id: "String",
    #           },
    #         ],
    #         to_port: 1,
    #         user_id_group_pairs: [
    #           {
    #             description: "String",
    #             group_id: "String",
    #             group_name: "String",
    #             peering_status: "String",
    #             user_id: "String",
    #             vpc_id: "String",
    #             vpc_peering_connection_id: "String",
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] from_port
    #   The start of port range for the TCP and UDP protocols, or an
    #   ICMP/ICMPv6 type number. A value of `-1` indicates all ICMP/ICMPv6
    #   types. If you specify all ICMP/ICMPv6 types, you must specify all
    #   codes.
    #   @return [Integer]
    #
    # @!attribute [rw] ip_protocol
    #   The IP protocol name (`tcp`, `udp`, `icmp`, `icmpv6`) or number (see
    #   [Protocol Numbers][1]).
    #
    #   \[VPC only\] Use `-1` to specify all protocols. When authorizing
    #   security group rules, specifying `-1` or a protocol number other
    #   than `tcp`, `udp`, `icmp`, or `icmpv6` allows traffic on all ports,
    #   regardless of any port range you specify. For `tcp`, `udp`, and
    #   `icmp`, you must specify a port range. For `icmpv6`, the port range
    #   is optional; if you omit the port range, traffic for all types and
    #   codes is allowed.
    #
    #
    #
    #   [1]: http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml
    #   @return [String]
    #
    # @!attribute [rw] ip_ranges
    #   The IPv4 ranges.
    #   @return [Array<Types::IpRange>]
    #
    # @!attribute [rw] ipv_6_ranges
    #   \[VPC only\] The IPv6 ranges.
    #   @return [Array<Types::Ipv6Range>]
    #
    # @!attribute [rw] prefix_list_ids
    #   \[VPC only\] The prefix list IDs for an AWS service. With outbound
    #   rules, this is the AWS service to access through a VPC endpoint from
    #   instances associated with the security group.
    #   @return [Array<Types::PrefixListId>]
    #
    # @!attribute [rw] to_port
    #   The end of port range for the TCP and UDP protocols, or an
    #   ICMP/ICMPv6 code. A value of `-1` indicates all ICMP/ICMPv6 codes.
    #   If you specify all ICMP/ICMPv6 types, you must specify all codes.
    #   @return [Integer]
    #
    # @!attribute [rw] user_id_group_pairs
    #   The security group and AWS account ID pairs.
    #   @return [Array<Types::UserIdGroupPair>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/IpPermission AWS API Documentation
    #
    class IpPermission < Struct.new(
      :from_port,
      :ip_protocol,
      :ip_ranges,
      :ipv_6_ranges,
      :prefix_list_ids,
      :to_port,
      :user_id_group_pairs)
      include Aws::Structure
    end

    # Describes an IPv4 range.
    #
    # @note When making an API call, you may pass IpRange
    #   data as a hash:
    #
    #       {
    #         cidr_ip: "String",
    #         description: "String",
    #       }
    #
    # @!attribute [rw] cidr_ip
    #   The IPv4 CIDR range. You can either specify a CIDR range or a source
    #   security group, not both. To specify a single IPv4 address, use the
    #   /32 prefix length.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   A description for the security group rule that references this IPv4
    #   address range.
    #
    #   Constraints: Up to 255 characters in length. Allowed characters are
    #   a-z, A-Z, 0-9, spaces, and .\_-:/()#,@\[\]+=&amp;;\\\{\\}!$*
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/IpRange AWS API Documentation
    #
    class IpRange < Struct.new(
      :cidr_ip,
      :description)
      include Aws::Structure
    end

    # Describes an IPv6 CIDR block association.
    #
    # @!attribute [rw] ipv_6_cidr
    #   The IPv6 CIDR block.
    #   @return [String]
    #
    # @!attribute [rw] associated_resource
    #   The resource that's associated with the IPv6 CIDR block.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Ipv6CidrAssociation AWS API Documentation
    #
    class Ipv6CidrAssociation < Struct.new(
      :ipv_6_cidr,
      :associated_resource)
      include Aws::Structure
    end

    # Describes an IPv6 CIDR block.
    #
    # @!attribute [rw] ipv_6_cidr_block
    #   The IPv6 CIDR block.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Ipv6CidrBlock AWS API Documentation
    #
    class Ipv6CidrBlock < Struct.new(
      :ipv_6_cidr_block)
      include Aws::Structure
    end

    # Describes an IPv6 address pool.
    #
    # @!attribute [rw] pool_id
    #   The ID of the address pool.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   The description for the address pool.
    #   @return [String]
    #
    # @!attribute [rw] pool_cidr_blocks
    #   The CIDR blocks for the address pool.
    #   @return [Array<Types::PoolCidrBlock>]
    #
    # @!attribute [rw] tags
    #   Any tags for the address pool.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Ipv6Pool AWS API Documentation
    #
    class Ipv6Pool < Struct.new(
      :pool_id,
      :description,
      :pool_cidr_blocks,
      :tags)
      include Aws::Structure
    end

    # \[EC2-VPC only\] Describes an IPv6 range.
    #
    # @note When making an API call, you may pass Ipv6Range
    #   data as a hash:
    #
    #       {
    #         cidr_ipv_6: "String",
    #         description: "String",
    #       }
    #
    # @!attribute [rw] cidr_ipv_6
    #   The IPv6 CIDR range. You can either specify a CIDR range or a source
    #   security group, not both. To specify a single IPv6 address, use the
    #   /128 prefix length.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   A description for the security group rule that references this IPv6
    #   address range.
    #
    #   Constraints: Up to 255 characters in length. Allowed characters are
    #   a-z, A-Z, 0-9, spaces, and .\_-:/()#,@\[\]+=&amp;;\\\{\\}!$*
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Ipv6Range AWS API Documentation
    #
    class Ipv6Range < Struct.new(
      :cidr_ipv_6,
      :description)
      include Aws::Structure
    end

    # Describes a key pair.
    #
    # @!attribute [rw] key_fingerprint
    #   The SHA-1 digest of the DER encoded private key.
    #   @return [String]
    #
    # @!attribute [rw] key_material
    #   An unencrypted PEM encoded RSA private key.
    #   @return [String]
    #
    # @!attribute [rw] key_name
    #   The name of the key pair.
    #   @return [String]
    #
    # @!attribute [rw] key_pair_id
    #   The ID of the key pair.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Any tags applied to the key pair.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/KeyPair AWS API Documentation
    #
    class KeyPair < Struct.new(
      :key_fingerprint,
      :key_material,
      :key_name,
      :key_pair_id,
      :tags)
      include Aws::Structure
    end

    # Describes a key pair.
    #
    # @!attribute [rw] key_pair_id
    #   The ID of the key pair.
    #   @return [String]
    #
    # @!attribute [rw] key_fingerprint
    #   If you used CreateKeyPair to create the key pair, this is the SHA-1
    #   digest of the DER encoded private key. If you used ImportKeyPair to
    #   provide AWS the public key, this is the MD5 public key fingerprint
    #   as specified in section 4 of RFC4716.
    #   @return [String]
    #
    # @!attribute [rw] key_name
    #   The name of the key pair.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Any tags applied to the key pair.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/KeyPairInfo AWS API Documentation
    #
    class KeyPairInfo < Struct.new(
      :key_pair_id,
      :key_fingerprint,
      :key_name,
      :tags)
      include Aws::Structure
    end

    # The last error that occurred for a VPC endpoint.
    #
    # @!attribute [rw] message
    #   The error message for the VPC endpoint error.
    #   @return [String]
    #
    # @!attribute [rw] code
    #   The error code for the VPC endpoint error.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LastError AWS API Documentation
    #
    class LastError < Struct.new(
      :message,
      :code)
      include Aws::Structure
    end

    # Describes a launch permission.
    #
    # @note When making an API call, you may pass LaunchPermission
    #   data as a hash:
    #
    #       {
    #         group: "all", # accepts all
    #         user_id: "String",
    #       }
    #
    # @!attribute [rw] group
    #   The name of the group.
    #   @return [String]
    #
    # @!attribute [rw] user_id
    #   The AWS account ID.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchPermission AWS API Documentation
    #
    class LaunchPermission < Struct.new(
      :group,
      :user_id)
      include Aws::Structure
    end

    # Describes a launch permission modification.
    #
    # @note When making an API call, you may pass LaunchPermissionModifications
    #   data as a hash:
    #
    #       {
    #         add: [
    #           {
    #             group: "all", # accepts all
    #             user_id: "String",
    #           },
    #         ],
    #         remove: [
    #           {
    #             group: "all", # accepts all
    #             user_id: "String",
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] add
    #   The AWS account ID to add to the list of launch permissions for the
    #   AMI.
    #   @return [Array<Types::LaunchPermission>]
    #
    # @!attribute [rw] remove
    #   The AWS account ID to remove from the list of launch permissions for
    #   the AMI.
    #   @return [Array<Types::LaunchPermission>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchPermissionModifications AWS API Documentation
    #
    class LaunchPermissionModifications < Struct.new(
      :add,
      :remove)
      include Aws::Structure
    end

    # Describes the launch specification for an instance.
    #
    # @!attribute [rw] user_data
    #   The Base64-encoded user data for the instance.
    #   @return [String]
    #
    # @!attribute [rw] security_groups
    #   One or more security groups. When requesting instances in a VPC, you
    #   must specify the IDs of the security groups. When requesting
    #   instances in EC2-Classic, you can specify the names or the IDs of
    #   the security groups.
    #   @return [Array<Types::GroupIdentifier>]
    #
    # @!attribute [rw] addressing_type
    #   Deprecated.
    #   @return [String]
    #
    # @!attribute [rw] block_device_mappings
    #   One or more block device mapping entries.
    #   @return [Array<Types::BlockDeviceMapping>]
    #
    # @!attribute [rw] ebs_optimized
    #   Indicates whether the instance is optimized for EBS I/O. This
    #   optimization provides dedicated throughput to Amazon EBS and an
    #   optimized configuration stack to provide optimal EBS I/O
    #   performance. This optimization isn't available with all instance
    #   types. Additional usage charges apply when using an EBS Optimized
    #   instance.
    #
    #   Default: `false`
    #   @return [Boolean]
    #
    # @!attribute [rw] iam_instance_profile
    #   The IAM instance profile.
    #   @return [Types::IamInstanceProfileSpecification]
    #
    # @!attribute [rw] image_id
    #   The ID of the AMI.
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   The instance type.
    #   @return [String]
    #
    # @!attribute [rw] kernel_id
    #   The ID of the kernel.
    #   @return [String]
    #
    # @!attribute [rw] key_name
    #   The name of the key pair.
    #   @return [String]
    #
    # @!attribute [rw] network_interfaces
    #   One or more network interfaces. If you specify a network interface,
    #   you must specify subnet IDs and security group IDs using the network
    #   interface.
    #   @return [Array<Types::InstanceNetworkInterfaceSpecification>]
    #
    # @!attribute [rw] placement
    #   The placement information for the instance.
    #   @return [Types::SpotPlacement]
    #
    # @!attribute [rw] ramdisk_id
    #   The ID of the RAM disk.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet in which to launch the instance.
    #   @return [String]
    #
    # @!attribute [rw] monitoring
    #   Describes the monitoring of an instance.
    #   @return [Types::RunInstancesMonitoringEnabled]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchSpecification AWS API Documentation
    #
    class LaunchSpecification < Struct.new(
      :user_data,
      :security_groups,
      :addressing_type,
      :block_device_mappings,
      :ebs_optimized,
      :iam_instance_profile,
      :image_id,
      :instance_type,
      :kernel_id,
      :key_name,
      :network_interfaces,
      :placement,
      :ramdisk_id,
      :subnet_id,
      :monitoring)
      include Aws::Structure
    end

    # Describes a launch template.
    #
    # @!attribute [rw] launch_template_id
    #   The ID of the launch template.
    #   @return [String]
    #
    # @!attribute [rw] launch_template_name
    #   The name of the launch template.
    #   @return [String]
    #
    # @!attribute [rw] create_time
    #   The time launch template was created.
    #   @return [Time]
    #
    # @!attribute [rw] created_by
    #   The principal that created the launch template.
    #   @return [String]
    #
    # @!attribute [rw] default_version_number
    #   The version number of the default version of the launch template.
    #   @return [Integer]
    #
    # @!attribute [rw] latest_version_number
    #   The version number of the latest version of the launch template.
    #   @return [Integer]
    #
    # @!attribute [rw] tags
    #   The tags for the launch template.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplate AWS API Documentation
    #
    class LaunchTemplate < Struct.new(
      :launch_template_id,
      :launch_template_name,
      :create_time,
      :created_by,
      :default_version_number,
      :latest_version_number,
      :tags)
      include Aws::Structure
    end

    # Describes a launch template and overrides.
    #
    # @!attribute [rw] launch_template_specification
    #   The launch template.
    #   @return [Types::FleetLaunchTemplateSpecification]
    #
    # @!attribute [rw] overrides
    #   Any parameters that you specify override the same parameters in the
    #   launch template.
    #   @return [Types::FleetLaunchTemplateOverrides]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateAndOverridesResponse AWS API Documentation
    #
    class LaunchTemplateAndOverridesResponse < Struct.new(
      :launch_template_specification,
      :overrides)
      include Aws::Structure
    end

    # Describes a block device mapping.
    #
    # @!attribute [rw] device_name
    #   The device name.
    #   @return [String]
    #
    # @!attribute [rw] virtual_name
    #   The virtual device name (ephemeralN).
    #   @return [String]
    #
    # @!attribute [rw] ebs
    #   Information about the block device for an EBS volume.
    #   @return [Types::LaunchTemplateEbsBlockDevice]
    #
    # @!attribute [rw] no_device
    #   Suppresses the specified device included in the block device mapping
    #   of the AMI.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateBlockDeviceMapping AWS API Documentation
    #
    class LaunchTemplateBlockDeviceMapping < Struct.new(
      :device_name,
      :virtual_name,
      :ebs,
      :no_device)
      include Aws::Structure
    end

    # Describes a block device mapping.
    #
    # @note When making an API call, you may pass LaunchTemplateBlockDeviceMappingRequest
    #   data as a hash:
    #
    #       {
    #         device_name: "String",
    #         virtual_name: "String",
    #         ebs: {
    #           encrypted: false,
    #           delete_on_termination: false,
    #           iops: 1,
    #           kms_key_id: "KmsKeyId",
    #           snapshot_id: "SnapshotId",
    #           volume_size: 1,
    #           volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #         },
    #         no_device: "String",
    #       }
    #
    # @!attribute [rw] device_name
    #   The device name (for example, /dev/sdh or xvdh).
    #   @return [String]
    #
    # @!attribute [rw] virtual_name
    #   The virtual device name (ephemeralN). Instance store volumes are
    #   numbered starting from 0. An instance type with 2 available instance
    #   store volumes can specify mappings for ephemeral0 and ephemeral1.
    #   The number of available instance store volumes depends on the
    #   instance type. After you connect to the instance, you must mount the
    #   volume.
    #   @return [String]
    #
    # @!attribute [rw] ebs
    #   Parameters used to automatically set up EBS volumes when the
    #   instance is launched.
    #   @return [Types::LaunchTemplateEbsBlockDeviceRequest]
    #
    # @!attribute [rw] no_device
    #   Suppresses the specified device included in the block device mapping
    #   of the AMI.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateBlockDeviceMappingRequest AWS API Documentation
    #
    class LaunchTemplateBlockDeviceMappingRequest < Struct.new(
      :device_name,
      :virtual_name,
      :ebs,
      :no_device)
      include Aws::Structure
    end

    # Describes an instance's Capacity Reservation targeting option. You
    # can specify only one option at a time. Use the
    # `CapacityReservationPreference` parameter to configure the instance to
    # run in On-Demand capacity or to run in any `open` Capacity Reservation
    # that has matching attributes (instance type, platform, Availability
    # Zone). Use the `CapacityReservationTarget` parameter to explicitly
    # target a specific Capacity Reservation.
    #
    # @note When making an API call, you may pass LaunchTemplateCapacityReservationSpecificationRequest
    #   data as a hash:
    #
    #       {
    #         capacity_reservation_preference: "open", # accepts open, none
    #         capacity_reservation_target: {
    #           capacity_reservation_id: "CapacityReservationId",
    #         },
    #       }
    #
    # @!attribute [rw] capacity_reservation_preference
    #   Indicates the instance's Capacity Reservation preferences. Possible
    #   preferences include:
    #
    #   * `open` - The instance can run in any `open` Capacity Reservation
    #     that has matching attributes (instance type, platform,
    #     Availability Zone).
    #
    #   * `none` - The instance avoids running in a Capacity Reservation
    #     even if one is available. The instance runs in On-Demand capacity.
    #   @return [String]
    #
    # @!attribute [rw] capacity_reservation_target
    #   Information about the target Capacity Reservation.
    #   @return [Types::CapacityReservationTarget]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateCapacityReservationSpecificationRequest AWS API Documentation
    #
    class LaunchTemplateCapacityReservationSpecificationRequest < Struct.new(
      :capacity_reservation_preference,
      :capacity_reservation_target)
      include Aws::Structure
    end

    # Information about the Capacity Reservation targeting option.
    #
    # @!attribute [rw] capacity_reservation_preference
    #   Indicates the instance's Capacity Reservation preferences. Possible
    #   preferences include:
    #
    #   * `open` - The instance can run in any `open` Capacity Reservation
    #     that has matching attributes (instance type, platform,
    #     Availability Zone).
    #
    #   * `none` - The instance avoids running in a Capacity Reservation
    #     even if one is available. The instance runs in On-Demand capacity.
    #   @return [String]
    #
    # @!attribute [rw] capacity_reservation_target
    #   Information about the target Capacity Reservation.
    #   @return [Types::CapacityReservationTargetResponse]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateCapacityReservationSpecificationResponse AWS API Documentation
    #
    class LaunchTemplateCapacityReservationSpecificationResponse < Struct.new(
      :capacity_reservation_preference,
      :capacity_reservation_target)
      include Aws::Structure
    end

    # Describes a launch template and overrides.
    #
    # @note When making an API call, you may pass LaunchTemplateConfig
    #   data as a hash:
    #
    #       {
    #         launch_template_specification: {
    #           launch_template_id: "String",
    #           launch_template_name: "LaunchTemplateName",
    #           version: "String",
    #         },
    #         overrides: [
    #           {
    #             instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #             spot_price: "String",
    #             subnet_id: "String",
    #             availability_zone: "String",
    #             weighted_capacity: 1.0,
    #             priority: 1.0,
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] launch_template_specification
    #   The launch template.
    #   @return [Types::FleetLaunchTemplateSpecification]
    #
    # @!attribute [rw] overrides
    #   Any parameters that you specify override the same parameters in the
    #   launch template.
    #   @return [Array<Types::LaunchTemplateOverrides>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateConfig AWS API Documentation
    #
    class LaunchTemplateConfig < Struct.new(
      :launch_template_specification,
      :overrides)
      include Aws::Structure
    end

    # The CPU options for the instance.
    #
    # @!attribute [rw] core_count
    #   The number of CPU cores for the instance.
    #   @return [Integer]
    #
    # @!attribute [rw] threads_per_core
    #   The number of threads per CPU core.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateCpuOptions AWS API Documentation
    #
    class LaunchTemplateCpuOptions < Struct.new(
      :core_count,
      :threads_per_core)
      include Aws::Structure
    end

    # The CPU options for the instance. Both the core count and threads per
    # core must be specified in the request.
    #
    # @note When making an API call, you may pass LaunchTemplateCpuOptionsRequest
    #   data as a hash:
    #
    #       {
    #         core_count: 1,
    #         threads_per_core: 1,
    #       }
    #
    # @!attribute [rw] core_count
    #   The number of CPU cores for the instance.
    #   @return [Integer]
    #
    # @!attribute [rw] threads_per_core
    #   The number of threads per CPU core. To disable multithreading for
    #   the instance, specify a value of 1. Otherwise, specify the default
    #   value of 2.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateCpuOptionsRequest AWS API Documentation
    #
    class LaunchTemplateCpuOptionsRequest < Struct.new(
      :core_count,
      :threads_per_core)
      include Aws::Structure
    end

    # Describes a block device for an EBS volume.
    #
    # @!attribute [rw] encrypted
    #   Indicates whether the EBS volume is encrypted.
    #   @return [Boolean]
    #
    # @!attribute [rw] delete_on_termination
    #   Indicates whether the EBS volume is deleted on instance termination.
    #   @return [Boolean]
    #
    # @!attribute [rw] iops
    #   The number of I/O operations per second (IOPS) that the volume
    #   supports.
    #   @return [Integer]
    #
    # @!attribute [rw] kms_key_id
    #   The ARN of the AWS Key Management Service (AWS KMS) CMK used for
    #   encryption.
    #   @return [String]
    #
    # @!attribute [rw] snapshot_id
    #   The ID of the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] volume_size
    #   The size of the volume, in GiB.
    #   @return [Integer]
    #
    # @!attribute [rw] volume_type
    #   The volume type.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateEbsBlockDevice AWS API Documentation
    #
    class LaunchTemplateEbsBlockDevice < Struct.new(
      :encrypted,
      :delete_on_termination,
      :iops,
      :kms_key_id,
      :snapshot_id,
      :volume_size,
      :volume_type)
      include Aws::Structure
    end

    # The parameters for a block device for an EBS volume.
    #
    # @note When making an API call, you may pass LaunchTemplateEbsBlockDeviceRequest
    #   data as a hash:
    #
    #       {
    #         encrypted: false,
    #         delete_on_termination: false,
    #         iops: 1,
    #         kms_key_id: "KmsKeyId",
    #         snapshot_id: "SnapshotId",
    #         volume_size: 1,
    #         volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #       }
    #
    # @!attribute [rw] encrypted
    #   Indicates whether the EBS volume is encrypted. Encrypted volumes can
    #   only be attached to instances that support Amazon EBS encryption. If
    #   you are creating a volume from a snapshot, you can't specify an
    #   encryption value.
    #   @return [Boolean]
    #
    # @!attribute [rw] delete_on_termination
    #   Indicates whether the EBS volume is deleted on instance termination.
    #   @return [Boolean]
    #
    # @!attribute [rw] iops
    #   The number of I/O operations per second (IOPS) that the volume
    #   supports. For io1, this represents the number of IOPS that are
    #   provisioned for the volume. For gp2, this represents the baseline
    #   performance of the volume and the rate at which the volume
    #   accumulates I/O credits for bursting. For more information about
    #   General Purpose SSD baseline performance, I/O credits, and bursting,
    #   see [Amazon EBS Volume Types][1] in the *Amazon Elastic Compute
    #   Cloud User Guide*.
    #
    #   Condition: This parameter is required for requests to create io1
    #   volumes; it is not used in requests to create gp2, st1, sc1, or
    #   standard volumes.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html
    #   @return [Integer]
    #
    # @!attribute [rw] kms_key_id
    #   The ARN of the symmetric AWS Key Management Service (AWS KMS) CMK
    #   used for encryption.
    #   @return [String]
    #
    # @!attribute [rw] snapshot_id
    #   The ID of the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] volume_size
    #   The size of the volume, in GiB.
    #
    #   Default: If you're creating the volume from a snapshot and don't
    #   specify a volume size, the default is the snapshot size.
    #   @return [Integer]
    #
    # @!attribute [rw] volume_type
    #   The volume type.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateEbsBlockDeviceRequest AWS API Documentation
    #
    class LaunchTemplateEbsBlockDeviceRequest < Struct.new(
      :encrypted,
      :delete_on_termination,
      :iops,
      :kms_key_id,
      :snapshot_id,
      :volume_size,
      :volume_type)
      include Aws::Structure
    end

    # Describes an elastic inference accelerator.
    #
    # @note When making an API call, you may pass LaunchTemplateElasticInferenceAccelerator
    #   data as a hash:
    #
    #       {
    #         type: "String", # required
    #         count: 1,
    #       }
    #
    # @!attribute [rw] type
    #   The type of elastic inference accelerator. The possible values are
    #   eia1.medium, eia1.large, and eia1.xlarge.
    #   @return [String]
    #
    # @!attribute [rw] count
    #   The number of elastic inference accelerators to attach to the
    #   instance.
    #
    #   Default: 1
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateElasticInferenceAccelerator AWS API Documentation
    #
    class LaunchTemplateElasticInferenceAccelerator < Struct.new(
      :type,
      :count)
      include Aws::Structure
    end

    # Describes an elastic inference accelerator.
    #
    # @!attribute [rw] type
    #   The type of elastic inference accelerator. The possible values are
    #   eia1.medium, eia1.large, and eia1.xlarge.
    #   @return [String]
    #
    # @!attribute [rw] count
    #   The number of elastic inference accelerators to attach to the
    #   instance.
    #
    #   Default: 1
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateElasticInferenceAcceleratorResponse AWS API Documentation
    #
    class LaunchTemplateElasticInferenceAcceleratorResponse < Struct.new(
      :type,
      :count)
      include Aws::Structure
    end

    # Indicates whether an instance is configured for hibernation.
    #
    # @!attribute [rw] configured
    #   If this parameter is set to `true`, the instance is enabled for
    #   hibernation; otherwise, it is not enabled for hibernation.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateHibernationOptions AWS API Documentation
    #
    class LaunchTemplateHibernationOptions < Struct.new(
      :configured)
      include Aws::Structure
    end

    # Indicates whether the instance is configured for hibernation. This
    # parameter is valid only if the instance meets the [hibernation
    # prerequisites][1].
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html#hibernating-prerequisites
    #
    # @note When making an API call, you may pass LaunchTemplateHibernationOptionsRequest
    #   data as a hash:
    #
    #       {
    #         configured: false,
    #       }
    #
    # @!attribute [rw] configured
    #   If you set this parameter to `true`, the instance is enabled for
    #   hibernation.
    #
    #   Default: `false`
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateHibernationOptionsRequest AWS API Documentation
    #
    class LaunchTemplateHibernationOptionsRequest < Struct.new(
      :configured)
      include Aws::Structure
    end

    # Describes an IAM instance profile.
    #
    # @!attribute [rw] arn
    #   The Amazon Resource Name (ARN) of the instance profile.
    #   @return [String]
    #
    # @!attribute [rw] name
    #   The name of the instance profile.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateIamInstanceProfileSpecification AWS API Documentation
    #
    class LaunchTemplateIamInstanceProfileSpecification < Struct.new(
      :arn,
      :name)
      include Aws::Structure
    end

    # An IAM instance profile.
    #
    # @note When making an API call, you may pass LaunchTemplateIamInstanceProfileSpecificationRequest
    #   data as a hash:
    #
    #       {
    #         arn: "String",
    #         name: "String",
    #       }
    #
    # @!attribute [rw] arn
    #   The Amazon Resource Name (ARN) of the instance profile.
    #   @return [String]
    #
    # @!attribute [rw] name
    #   The name of the instance profile.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateIamInstanceProfileSpecificationRequest AWS API Documentation
    #
    class LaunchTemplateIamInstanceProfileSpecificationRequest < Struct.new(
      :arn,
      :name)
      include Aws::Structure
    end

    # The market (purchasing) option for the instances.
    #
    # @!attribute [rw] market_type
    #   The market type.
    #   @return [String]
    #
    # @!attribute [rw] spot_options
    #   The options for Spot Instances.
    #   @return [Types::LaunchTemplateSpotMarketOptions]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateInstanceMarketOptions AWS API Documentation
    #
    class LaunchTemplateInstanceMarketOptions < Struct.new(
      :market_type,
      :spot_options)
      include Aws::Structure
    end

    # The market (purchasing) option for the instances.
    #
    # @note When making an API call, you may pass LaunchTemplateInstanceMarketOptionsRequest
    #   data as a hash:
    #
    #       {
    #         market_type: "spot", # accepts spot
    #         spot_options: {
    #           max_price: "String",
    #           spot_instance_type: "one-time", # accepts one-time, persistent
    #           block_duration_minutes: 1,
    #           valid_until: Time.now,
    #           instance_interruption_behavior: "hibernate", # accepts hibernate, stop, terminate
    #         },
    #       }
    #
    # @!attribute [rw] market_type
    #   The market type.
    #   @return [String]
    #
    # @!attribute [rw] spot_options
    #   The options for Spot Instances.
    #   @return [Types::LaunchTemplateSpotMarketOptionsRequest]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateInstanceMarketOptionsRequest AWS API Documentation
    #
    class LaunchTemplateInstanceMarketOptionsRequest < Struct.new(
      :market_type,
      :spot_options)
      include Aws::Structure
    end

    # The metadata options for the instance. For more information, see
    # [Instance Metadata and User Data][1] in the *Amazon Elastic Compute
    # Cloud User Guide*.
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-instance-metadata.html
    #
    # @!attribute [rw] state
    #   The state of the metadata option changes.
    #
    #   `pending` - The metadata options are being updated and the instance
    #   is not ready to process metadata traffic with the new selection.
    #
    #   `applied` - The metadata options have been successfully applied on
    #   the instance.
    #   @return [String]
    #
    # @!attribute [rw] http_tokens
    #   The state of token usage for your instance metadata requests. If the
    #   parameter is not specified in the request, the default state is
    #   `optional`.
    #
    #   If the state is `optional`, you can choose to retrieve instance
    #   metadata with or without a signed token header on your request. If
    #   you retrieve the IAM role credentials without a token, the version
    #   1.0 role credentials are returned. If you retrieve the IAM role
    #   credentials using a valid signed token, the version 2.0 role
    #   credentials are returned.
    #
    #   If the state is `required`, you must send a signed token header with
    #   any instance metadata retrieval requests. In this state, retrieving
    #   the IAM role credentials always returns the version 2.0 credentials;
    #   the version 1.0 credentials are not available.
    #   @return [String]
    #
    # @!attribute [rw] http_put_response_hop_limit
    #   The desired HTTP PUT response hop limit for instance metadata
    #   requests. The larger the number, the further instance metadata
    #   requests can travel.
    #
    #   Default: 1
    #
    #   Possible values: Integers from 1 to 64
    #   @return [Integer]
    #
    # @!attribute [rw] http_endpoint
    #   This parameter enables or disables the HTTP metadata endpoint on
    #   your instances. If the parameter is not specified, the default state
    #   is `enabled`.
    #
    #   <note markdown="1"> If you specify a value of `disabled`, you will not be able to access
    #   your instance metadata.
    #
    #    </note>
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateInstanceMetadataOptions AWS API Documentation
    #
    class LaunchTemplateInstanceMetadataOptions < Struct.new(
      :state,
      :http_tokens,
      :http_put_response_hop_limit,
      :http_endpoint)
      include Aws::Structure
    end

    # The metadata options for the instance. For more information, see
    # [Instance Metadata and User Data][1] in the *Amazon Elastic Compute
    # Cloud User Guide*.
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-instance-metadata.html
    #
    # @note When making an API call, you may pass LaunchTemplateInstanceMetadataOptionsRequest
    #   data as a hash:
    #
    #       {
    #         http_tokens: "optional", # accepts optional, required
    #         http_put_response_hop_limit: 1,
    #         http_endpoint: "disabled", # accepts disabled, enabled
    #       }
    #
    # @!attribute [rw] http_tokens
    #   The state of token usage for your instance metadata requests. If the
    #   parameter is not specified in the request, the default state is
    #   `optional`.
    #
    #   If the state is `optional`, you can choose to retrieve instance
    #   metadata with or without a signed token header on your request. If
    #   you retrieve the IAM role credentials without a token, the version
    #   1.0 role credentials are returned. If you retrieve the IAM role
    #   credentials using a valid signed token, the version 2.0 role
    #   credentials are returned.
    #
    #   If the state is `required`, you must send a signed token header with
    #   any instance metadata retrieval requests. In this state, retrieving
    #   the IAM role credentials always returns the version 2.0 credentials;
    #   the version 1.0 credentials are not available.
    #   @return [String]
    #
    # @!attribute [rw] http_put_response_hop_limit
    #   The desired HTTP PUT response hop limit for instance metadata
    #   requests. The larger the number, the further instance metadata
    #   requests can travel.
    #
    #   Default: 1
    #
    #   Possible values: Integers from 1 to 64
    #   @return [Integer]
    #
    # @!attribute [rw] http_endpoint
    #   This parameter enables or disables the HTTP metadata endpoint on
    #   your instances. If the parameter is not specified, the default state
    #   is `enabled`.
    #
    #   <note markdown="1"> If you specify a value of `disabled`, you will not be able to access
    #   your instance metadata.
    #
    #    </note>
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateInstanceMetadataOptionsRequest AWS API Documentation
    #
    class LaunchTemplateInstanceMetadataOptionsRequest < Struct.new(
      :http_tokens,
      :http_put_response_hop_limit,
      :http_endpoint)
      include Aws::Structure
    end

    # Describes a network interface.
    #
    # @!attribute [rw] associate_public_ip_address
    #   Indicates whether to associate a public IPv4 address with eth0 for a
    #   new network interface.
    #   @return [Boolean]
    #
    # @!attribute [rw] delete_on_termination
    #   Indicates whether the network interface is deleted when the instance
    #   is terminated.
    #   @return [Boolean]
    #
    # @!attribute [rw] description
    #   A description for the network interface.
    #   @return [String]
    #
    # @!attribute [rw] device_index
    #   The device index for the network interface attachment.
    #   @return [Integer]
    #
    # @!attribute [rw] groups
    #   The IDs of one or more security groups.
    #   @return [Array<String>]
    #
    # @!attribute [rw] interface_type
    #   The type of network interface.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_address_count
    #   The number of IPv6 addresses for the network interface.
    #   @return [Integer]
    #
    # @!attribute [rw] ipv_6_addresses
    #   The IPv6 addresses for the network interface.
    #   @return [Array<Types::InstanceIpv6Address>]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_address
    #   The primary private IPv4 address of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_addresses
    #   One or more private IPv4 addresses.
    #   @return [Array<Types::PrivateIpAddressSpecification>]
    #
    # @!attribute [rw] secondary_private_ip_address_count
    #   The number of secondary private IPv4 addresses for the network
    #   interface.
    #   @return [Integer]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet for the network interface.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateInstanceNetworkInterfaceSpecification AWS API Documentation
    #
    class LaunchTemplateInstanceNetworkInterfaceSpecification < Struct.new(
      :associate_public_ip_address,
      :delete_on_termination,
      :description,
      :device_index,
      :groups,
      :interface_type,
      :ipv_6_address_count,
      :ipv_6_addresses,
      :network_interface_id,
      :private_ip_address,
      :private_ip_addresses,
      :secondary_private_ip_address_count,
      :subnet_id)
      include Aws::Structure
    end

    # The parameters for a network interface.
    #
    # @note When making an API call, you may pass LaunchTemplateInstanceNetworkInterfaceSpecificationRequest
    #   data as a hash:
    #
    #       {
    #         associate_public_ip_address: false,
    #         delete_on_termination: false,
    #         description: "String",
    #         device_index: 1,
    #         groups: ["SecurityGroupId"],
    #         interface_type: "String",
    #         ipv_6_address_count: 1,
    #         ipv_6_addresses: [
    #           {
    #             ipv_6_address: "String",
    #           },
    #         ],
    #         network_interface_id: "NetworkInterfaceId",
    #         private_ip_address: "String",
    #         private_ip_addresses: [
    #           {
    #             primary: false,
    #             private_ip_address: "String",
    #           },
    #         ],
    #         secondary_private_ip_address_count: 1,
    #         subnet_id: "SubnetId",
    #       }
    #
    # @!attribute [rw] associate_public_ip_address
    #   Associates a public IPv4 address with eth0 for a new network
    #   interface.
    #   @return [Boolean]
    #
    # @!attribute [rw] delete_on_termination
    #   Indicates whether the network interface is deleted when the instance
    #   is terminated.
    #   @return [Boolean]
    #
    # @!attribute [rw] description
    #   A description for the network interface.
    #   @return [String]
    #
    # @!attribute [rw] device_index
    #   The device index for the network interface attachment.
    #   @return [Integer]
    #
    # @!attribute [rw] groups
    #   The IDs of one or more security groups.
    #   @return [Array<String>]
    #
    # @!attribute [rw] interface_type
    #   The type of network interface. To create an Elastic Fabric Adapter
    #   (EFA), specify `efa`. For more information, see [Elastic Fabric
    #   Adapter][1] in the *Amazon Elastic Compute Cloud User Guide*.
    #
    #   If you are not creating an EFA, specify `interface` or omit this
    #   parameter.
    #
    #   Valid values: `interface` \| `efa`
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_address_count
    #   The number of IPv6 addresses to assign to a network interface.
    #   Amazon EC2 automatically selects the IPv6 addresses from the subnet
    #   range. You can't use this option if specifying specific IPv6
    #   addresses.
    #   @return [Integer]
    #
    # @!attribute [rw] ipv_6_addresses
    #   One or more specific IPv6 addresses from the IPv6 CIDR block range
    #   of your subnet. You can't use this option if you're specifying a
    #   number of IPv6 addresses.
    #   @return [Array<Types::InstanceIpv6AddressRequest>]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_address
    #   The primary private IPv4 address of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_addresses
    #   One or more private IPv4 addresses.
    #   @return [Array<Types::PrivateIpAddressSpecification>]
    #
    # @!attribute [rw] secondary_private_ip_address_count
    #   The number of secondary private IPv4 addresses to assign to a
    #   network interface.
    #   @return [Integer]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet for the network interface.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateInstanceNetworkInterfaceSpecificationRequest AWS API Documentation
    #
    class LaunchTemplateInstanceNetworkInterfaceSpecificationRequest < Struct.new(
      :associate_public_ip_address,
      :delete_on_termination,
      :description,
      :device_index,
      :groups,
      :interface_type,
      :ipv_6_address_count,
      :ipv_6_addresses,
      :network_interface_id,
      :private_ip_address,
      :private_ip_addresses,
      :secondary_private_ip_address_count,
      :subnet_id)
      include Aws::Structure
    end

    # Describes a license configuration.
    #
    # @!attribute [rw] license_configuration_arn
    #   The Amazon Resource Name (ARN) of the license configuration.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateLicenseConfiguration AWS API Documentation
    #
    class LaunchTemplateLicenseConfiguration < Struct.new(
      :license_configuration_arn)
      include Aws::Structure
    end

    # Describes a license configuration.
    #
    # @note When making an API call, you may pass LaunchTemplateLicenseConfigurationRequest
    #   data as a hash:
    #
    #       {
    #         license_configuration_arn: "String",
    #       }
    #
    # @!attribute [rw] license_configuration_arn
    #   The Amazon Resource Name (ARN) of the license configuration.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateLicenseConfigurationRequest AWS API Documentation
    #
    class LaunchTemplateLicenseConfigurationRequest < Struct.new(
      :license_configuration_arn)
      include Aws::Structure
    end

    # Describes overrides for a launch template.
    #
    # @note When making an API call, you may pass LaunchTemplateOverrides
    #   data as a hash:
    #
    #       {
    #         instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #         spot_price: "String",
    #         subnet_id: "String",
    #         availability_zone: "String",
    #         weighted_capacity: 1.0,
    #         priority: 1.0,
    #       }
    #
    # @!attribute [rw] instance_type
    #   The instance type.
    #   @return [String]
    #
    # @!attribute [rw] spot_price
    #   The maximum price per unit hour that you are willing to pay for a
    #   Spot Instance.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet in which to launch the instances.
    #   @return [String]
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone in which to launch the instances.
    #   @return [String]
    #
    # @!attribute [rw] weighted_capacity
    #   The number of units provided by the specified instance type.
    #   @return [Float]
    #
    # @!attribute [rw] priority
    #   The priority for the launch template override. If
    #   **OnDemandAllocationStrategy** is set to `prioritized`, Spot Fleet
    #   uses priority to determine which launch template override to use
    #   first in fulfilling On-Demand capacity. The highest priority is
    #   launched first. Valid values are whole numbers starting at `0`. The
    #   lower the number, the higher the priority. If no number is set, the
    #   launch template override has the lowest priority.
    #   @return [Float]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateOverrides AWS API Documentation
    #
    class LaunchTemplateOverrides < Struct.new(
      :instance_type,
      :spot_price,
      :subnet_id,
      :availability_zone,
      :weighted_capacity,
      :priority)
      include Aws::Structure
    end

    # Describes the placement of an instance.
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone of the instance.
    #   @return [String]
    #
    # @!attribute [rw] affinity
    #   The affinity setting for the instance on the Dedicated Host.
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   The name of the placement group for the instance.
    #   @return [String]
    #
    # @!attribute [rw] host_id
    #   The ID of the Dedicated Host for the instance.
    #   @return [String]
    #
    # @!attribute [rw] tenancy
    #   The tenancy of the instance (if the instance is running in a VPC).
    #   An instance with a tenancy of `dedicated` runs on single-tenant
    #   hardware.
    #   @return [String]
    #
    # @!attribute [rw] spread_domain
    #   Reserved for future use.
    #   @return [String]
    #
    # @!attribute [rw] host_resource_group_arn
    #   The ARN of the host resource group in which to launch the instances.
    #   @return [String]
    #
    # @!attribute [rw] partition_number
    #   The number of the partition the instance should launch in. Valid
    #   only if the placement group strategy is set to `partition`.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplatePlacement AWS API Documentation
    #
    class LaunchTemplatePlacement < Struct.new(
      :availability_zone,
      :affinity,
      :group_name,
      :host_id,
      :tenancy,
      :spread_domain,
      :host_resource_group_arn,
      :partition_number)
      include Aws::Structure
    end

    # Describes the placement of an instance.
    #
    # @note When making an API call, you may pass LaunchTemplatePlacementRequest
    #   data as a hash:
    #
    #       {
    #         availability_zone: "String",
    #         affinity: "String",
    #         group_name: "PlacementGroupName",
    #         host_id: "DedicatedHostId",
    #         tenancy: "default", # accepts default, dedicated, host
    #         spread_domain: "String",
    #         host_resource_group_arn: "String",
    #         partition_number: 1,
    #       }
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone for the instance.
    #   @return [String]
    #
    # @!attribute [rw] affinity
    #   The affinity setting for an instance on a Dedicated Host.
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   The name of the placement group for the instance.
    #   @return [String]
    #
    # @!attribute [rw] host_id
    #   The ID of the Dedicated Host for the instance.
    #   @return [String]
    #
    # @!attribute [rw] tenancy
    #   The tenancy of the instance (if the instance is running in a VPC).
    #   An instance with a tenancy of dedicated runs on single-tenant
    #   hardware.
    #   @return [String]
    #
    # @!attribute [rw] spread_domain
    #   Reserved for future use.
    #   @return [String]
    #
    # @!attribute [rw] host_resource_group_arn
    #   The ARN of the host resource group in which to launch the instances.
    #   If you specify a host resource group ARN, omit the **Tenancy**
    #   parameter or set it to `host`.
    #   @return [String]
    #
    # @!attribute [rw] partition_number
    #   The number of the partition the instance should launch in. Valid
    #   only if the placement group strategy is set to `partition`.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplatePlacementRequest AWS API Documentation
    #
    class LaunchTemplatePlacementRequest < Struct.new(
      :availability_zone,
      :affinity,
      :group_name,
      :host_id,
      :tenancy,
      :spread_domain,
      :host_resource_group_arn,
      :partition_number)
      include Aws::Structure
    end

    # The launch template to use. You must specify either the launch
    # template ID or launch template name in the request, but not both.
    #
    # @note When making an API call, you may pass LaunchTemplateSpecification
    #   data as a hash:
    #
    #       {
    #         launch_template_id: "LaunchTemplateId",
    #         launch_template_name: "String",
    #         version: "String",
    #       }
    #
    # @!attribute [rw] launch_template_id
    #   The ID of the launch template.
    #   @return [String]
    #
    # @!attribute [rw] launch_template_name
    #   The name of the launch template.
    #   @return [String]
    #
    # @!attribute [rw] version
    #   The version number of the launch template.
    #
    #   Default: The default version for the launch template.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateSpecification AWS API Documentation
    #
    class LaunchTemplateSpecification < Struct.new(
      :launch_template_id,
      :launch_template_name,
      :version)
      include Aws::Structure
    end

    # The options for Spot Instances.
    #
    # @!attribute [rw] max_price
    #   The maximum hourly price you're willing to pay for the Spot
    #   Instances.
    #   @return [String]
    #
    # @!attribute [rw] spot_instance_type
    #   The Spot Instance request type.
    #   @return [String]
    #
    # @!attribute [rw] block_duration_minutes
    #   The required duration for the Spot Instances (also known as Spot
    #   blocks), in minutes. This value must be a multiple of 60 (60, 120,
    #   180, 240, 300, or 360).
    #   @return [Integer]
    #
    # @!attribute [rw] valid_until
    #   The end date of the request. For a one-time request, the request
    #   remains active until all instances launch, the request is canceled,
    #   or this date is reached. If the request is persistent, it remains
    #   active until it is canceled or this date and time is reached.
    #   @return [Time]
    #
    # @!attribute [rw] instance_interruption_behavior
    #   The behavior when a Spot Instance is interrupted.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateSpotMarketOptions AWS API Documentation
    #
    class LaunchTemplateSpotMarketOptions < Struct.new(
      :max_price,
      :spot_instance_type,
      :block_duration_minutes,
      :valid_until,
      :instance_interruption_behavior)
      include Aws::Structure
    end

    # The options for Spot Instances.
    #
    # @note When making an API call, you may pass LaunchTemplateSpotMarketOptionsRequest
    #   data as a hash:
    #
    #       {
    #         max_price: "String",
    #         spot_instance_type: "one-time", # accepts one-time, persistent
    #         block_duration_minutes: 1,
    #         valid_until: Time.now,
    #         instance_interruption_behavior: "hibernate", # accepts hibernate, stop, terminate
    #       }
    #
    # @!attribute [rw] max_price
    #   The maximum hourly price you're willing to pay for the Spot
    #   Instances.
    #   @return [String]
    #
    # @!attribute [rw] spot_instance_type
    #   The Spot Instance request type.
    #   @return [String]
    #
    # @!attribute [rw] block_duration_minutes
    #   The required duration for the Spot Instances (also known as Spot
    #   blocks), in minutes. This value must be a multiple of 60 (60, 120,
    #   180, 240, 300, or 360).
    #   @return [Integer]
    #
    # @!attribute [rw] valid_until
    #   The end date of the request. For a one-time request, the request
    #   remains active until all instances launch, the request is canceled,
    #   or this date is reached. If the request is persistent, it remains
    #   active until it is canceled or this date and time is reached. The
    #   default end date is 7 days from the current date.
    #   @return [Time]
    #
    # @!attribute [rw] instance_interruption_behavior
    #   The behavior when a Spot Instance is interrupted. The default is
    #   `terminate`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateSpotMarketOptionsRequest AWS API Documentation
    #
    class LaunchTemplateSpotMarketOptionsRequest < Struct.new(
      :max_price,
      :spot_instance_type,
      :block_duration_minutes,
      :valid_until,
      :instance_interruption_behavior)
      include Aws::Structure
    end

    # The tag specification for the launch template.
    #
    # @!attribute [rw] resource_type
    #   The type of resource.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags for the resource.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateTagSpecification AWS API Documentation
    #
    class LaunchTemplateTagSpecification < Struct.new(
      :resource_type,
      :tags)
      include Aws::Structure
    end

    # The tags specification for the launch template.
    #
    # @note When making an API call, you may pass LaunchTemplateTagSpecificationRequest
    #   data as a hash:
    #
    #       {
    #         resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #         tags: [
    #           {
    #             key: "String",
    #             value: "String",
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] resource_type
    #   The type of resource to tag. Currently, the resource types that
    #   support tagging on creation are `instance` and `volume`. To tag a
    #   resource after it has been created, see [CreateTags][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags to apply to the resource.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateTagSpecificationRequest AWS API Documentation
    #
    class LaunchTemplateTagSpecificationRequest < Struct.new(
      :resource_type,
      :tags)
      include Aws::Structure
    end

    # Describes a launch template version.
    #
    # @!attribute [rw] launch_template_id
    #   The ID of the launch template.
    #   @return [String]
    #
    # @!attribute [rw] launch_template_name
    #   The name of the launch template.
    #   @return [String]
    #
    # @!attribute [rw] version_number
    #   The version number.
    #   @return [Integer]
    #
    # @!attribute [rw] version_description
    #   The description for the version.
    #   @return [String]
    #
    # @!attribute [rw] create_time
    #   The time the version was created.
    #   @return [Time]
    #
    # @!attribute [rw] created_by
    #   The principal that created the version.
    #   @return [String]
    #
    # @!attribute [rw] default_version
    #   Indicates whether the version is the default version.
    #   @return [Boolean]
    #
    # @!attribute [rw] launch_template_data
    #   Information about the launch template.
    #   @return [Types::ResponseLaunchTemplateData]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplateVersion AWS API Documentation
    #
    class LaunchTemplateVersion < Struct.new(
      :launch_template_id,
      :launch_template_name,
      :version_number,
      :version_description,
      :create_time,
      :created_by,
      :default_version,
      :launch_template_data)
      include Aws::Structure
    end

    # Describes the monitoring for the instance.
    #
    # @!attribute [rw] enabled
    #   Indicates whether detailed monitoring is enabled. Otherwise, basic
    #   monitoring is enabled.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplatesMonitoring AWS API Documentation
    #
    class LaunchTemplatesMonitoring < Struct.new(
      :enabled)
      include Aws::Structure
    end

    # Describes the monitoring for the instance.
    #
    # @note When making an API call, you may pass LaunchTemplatesMonitoringRequest
    #   data as a hash:
    #
    #       {
    #         enabled: false,
    #       }
    #
    # @!attribute [rw] enabled
    #   Specify `true` to enable detailed monitoring. Otherwise, basic
    #   monitoring is enabled.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LaunchTemplatesMonitoringRequest AWS API Documentation
    #
    class LaunchTemplatesMonitoringRequest < Struct.new(
      :enabled)
      include Aws::Structure
    end

    # Describes a license configuration.
    #
    # @!attribute [rw] license_configuration_arn
    #   The Amazon Resource Name (ARN) of the license configuration.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LicenseConfiguration AWS API Documentation
    #
    class LicenseConfiguration < Struct.new(
      :license_configuration_arn)
      include Aws::Structure
    end

    # Describes a license configuration.
    #
    # @note When making an API call, you may pass LicenseConfigurationRequest
    #   data as a hash:
    #
    #       {
    #         license_configuration_arn: "String",
    #       }
    #
    # @!attribute [rw] license_configuration_arn
    #   The Amazon Resource Name (ARN) of the license configuration.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LicenseConfigurationRequest AWS API Documentation
    #
    class LicenseConfigurationRequest < Struct.new(
      :license_configuration_arn)
      include Aws::Structure
    end

    # Describes the Classic Load Balancers and target groups to attach to a
    # Spot Fleet request.
    #
    # @note When making an API call, you may pass LoadBalancersConfig
    #   data as a hash:
    #
    #       {
    #         classic_load_balancers_config: {
    #           classic_load_balancers: [
    #             {
    #               name: "String",
    #             },
    #           ],
    #         },
    #         target_groups_config: {
    #           target_groups: [
    #             {
    #               arn: "String",
    #             },
    #           ],
    #         },
    #       }
    #
    # @!attribute [rw] classic_load_balancers_config
    #   The Classic Load Balancers.
    #   @return [Types::ClassicLoadBalancersConfig]
    #
    # @!attribute [rw] target_groups_config
    #   The target groups.
    #   @return [Types::TargetGroupsConfig]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LoadBalancersConfig AWS API Documentation
    #
    class LoadBalancersConfig < Struct.new(
      :classic_load_balancers_config,
      :target_groups_config)
      include Aws::Structure
    end

    # Describes a load permission.
    #
    # @!attribute [rw] user_id
    #   The AWS account ID.
    #   @return [String]
    #
    # @!attribute [rw] group
    #   The name of the group.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LoadPermission AWS API Documentation
    #
    class LoadPermission < Struct.new(
      :user_id,
      :group)
      include Aws::Structure
    end

    # Describes modifications to the load permissions of an Amazon FPGA
    # image (AFI).
    #
    # @note When making an API call, you may pass LoadPermissionModifications
    #   data as a hash:
    #
    #       {
    #         add: [
    #           {
    #             group: "all", # accepts all
    #             user_id: "String",
    #           },
    #         ],
    #         remove: [
    #           {
    #             group: "all", # accepts all
    #             user_id: "String",
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] add
    #   The load permissions to add.
    #   @return [Array<Types::LoadPermissionRequest>]
    #
    # @!attribute [rw] remove
    #   The load permissions to remove.
    #   @return [Array<Types::LoadPermissionRequest>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LoadPermissionModifications AWS API Documentation
    #
    class LoadPermissionModifications < Struct.new(
      :add,
      :remove)
      include Aws::Structure
    end

    # Describes a load permission.
    #
    # @note When making an API call, you may pass LoadPermissionRequest
    #   data as a hash:
    #
    #       {
    #         group: "all", # accepts all
    #         user_id: "String",
    #       }
    #
    # @!attribute [rw] group
    #   The name of the group.
    #   @return [String]
    #
    # @!attribute [rw] user_id
    #   The AWS account ID.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LoadPermissionRequest AWS API Documentation
    #
    class LoadPermissionRequest < Struct.new(
      :group,
      :user_id)
      include Aws::Structure
    end

    # Describes a local gateway.
    #
    # @!attribute [rw] local_gateway_id
    #   The ID of the local gateway.
    #   @return [String]
    #
    # @!attribute [rw] outpost_arn
    #   The Amazon Resource Name (ARN) of the Outpost.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account ID that owns the local gateway.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the local gateway.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags assigned to the local gateway.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LocalGateway AWS API Documentation
    #
    class LocalGateway < Struct.new(
      :local_gateway_id,
      :outpost_arn,
      :owner_id,
      :state,
      :tags)
      include Aws::Structure
    end

    # Describes a route for a local gateway route table.
    #
    # @!attribute [rw] destination_cidr_block
    #   The CIDR block used for destination matches.
    #   @return [String]
    #
    # @!attribute [rw] local_gateway_virtual_interface_group_id
    #   The ID of the virtual interface group.
    #   @return [String]
    #
    # @!attribute [rw] type
    #   The route type.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the route.
    #   @return [String]
    #
    # @!attribute [rw] local_gateway_route_table_id
    #   The ID of the local gateway route table.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LocalGatewayRoute AWS API Documentation
    #
    class LocalGatewayRoute < Struct.new(
      :destination_cidr_block,
      :local_gateway_virtual_interface_group_id,
      :type,
      :state,
      :local_gateway_route_table_id)
      include Aws::Structure
    end

    # Describes a local gateway route table.
    #
    # @!attribute [rw] local_gateway_route_table_id
    #   The ID of the local gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] local_gateway_id
    #   The ID of the local gateway.
    #   @return [String]
    #
    # @!attribute [rw] outpost_arn
    #   The Amazon Resource Name (ARN) of the Outpost.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the local gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags assigned to the local gateway route table.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LocalGatewayRouteTable AWS API Documentation
    #
    class LocalGatewayRouteTable < Struct.new(
      :local_gateway_route_table_id,
      :local_gateway_id,
      :outpost_arn,
      :state,
      :tags)
      include Aws::Structure
    end

    # Describes an association between a local gateway route table and a
    # virtual interface group.
    #
    # @!attribute [rw] local_gateway_route_table_virtual_interface_group_association_id
    #   The ID of the association.
    #   @return [String]
    #
    # @!attribute [rw] local_gateway_virtual_interface_group_id
    #   The ID of the virtual interface group.
    #   @return [String]
    #
    # @!attribute [rw] local_gateway_id
    #   The ID of the local gateway.
    #   @return [String]
    #
    # @!attribute [rw] local_gateway_route_table_id
    #   The ID of the local gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the association.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags assigned to the association.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LocalGatewayRouteTableVirtualInterfaceGroupAssociation AWS API Documentation
    #
    class LocalGatewayRouteTableVirtualInterfaceGroupAssociation < Struct.new(
      :local_gateway_route_table_virtual_interface_group_association_id,
      :local_gateway_virtual_interface_group_id,
      :local_gateway_id,
      :local_gateway_route_table_id,
      :state,
      :tags)
      include Aws::Structure
    end

    # Describes an association between a local gateway route table and a
    # VPC.
    #
    # @!attribute [rw] local_gateway_route_table_vpc_association_id
    #   The ID of the association.
    #   @return [String]
    #
    # @!attribute [rw] local_gateway_route_table_id
    #   The ID of the local gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] local_gateway_id
    #   The ID of the local gateway.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the association.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags assigned to the association.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LocalGatewayRouteTableVpcAssociation AWS API Documentation
    #
    class LocalGatewayRouteTableVpcAssociation < Struct.new(
      :local_gateway_route_table_vpc_association_id,
      :local_gateway_route_table_id,
      :local_gateway_id,
      :vpc_id,
      :state,
      :tags)
      include Aws::Structure
    end

    # Describes a local gateway virtual interface.
    #
    # @!attribute [rw] local_gateway_virtual_interface_id
    #   The ID of the virtual interface.
    #   @return [String]
    #
    # @!attribute [rw] local_gateway_id
    #   The ID of the local gateway.
    #   @return [String]
    #
    # @!attribute [rw] vlan
    #   The ID of the VLAN.
    #   @return [Integer]
    #
    # @!attribute [rw] local_address
    #   The local address.
    #   @return [String]
    #
    # @!attribute [rw] peer_address
    #   The peer address.
    #   @return [String]
    #
    # @!attribute [rw] local_bgp_asn
    #   The Border Gateway Protocol (BGP) Autonomous System Number (ASN) of
    #   the local gateway.
    #   @return [Integer]
    #
    # @!attribute [rw] peer_bgp_asn
    #   The peer BGP ASN.
    #   @return [Integer]
    #
    # @!attribute [rw] tags
    #   The tags assigned to the virtual interface.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LocalGatewayVirtualInterface AWS API Documentation
    #
    class LocalGatewayVirtualInterface < Struct.new(
      :local_gateway_virtual_interface_id,
      :local_gateway_id,
      :vlan,
      :local_address,
      :peer_address,
      :local_bgp_asn,
      :peer_bgp_asn,
      :tags)
      include Aws::Structure
    end

    # Describes a local gateway virtual interface group.
    #
    # @!attribute [rw] local_gateway_virtual_interface_group_id
    #   The ID of the virtual interface group.
    #   @return [String]
    #
    # @!attribute [rw] local_gateway_virtual_interface_ids
    #   The IDs of the virtual interfaces.
    #   @return [Array<String>]
    #
    # @!attribute [rw] local_gateway_id
    #   The ID of the local gateway.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags assigned to the virtual interface group.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/LocalGatewayVirtualInterfaceGroup AWS API Documentation
    #
    class LocalGatewayVirtualInterfaceGroup < Struct.new(
      :local_gateway_virtual_interface_group_id,
      :local_gateway_virtual_interface_ids,
      :local_gateway_id,
      :tags)
      include Aws::Structure
    end

    # Describes the memory for the instance type.
    #
    # @!attribute [rw] size_in_mi_b
    #   Size of the memory, in MiB.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/MemoryInfo AWS API Documentation
    #
    class MemoryInfo < Struct.new(
      :size_in_mi_b)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyAvailabilityZoneGroupRequest
    #   data as a hash:
    #
    #       {
    #         group_name: "String", # required
    #         opt_in_status: "opted-in", # required, accepts opted-in, not-opted-in
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] group_name
    #   The name of the Availability Zone Group.
    #   @return [String]
    #
    # @!attribute [rw] opt_in_status
    #   Indicates whether to enable or disable membership. The valid values
    #   are `opted-in`. You must contact [AWS Support][1] to disable an
    #   Availability Zone group.
    #
    #
    #
    #   [1]: https://console.aws.amazon.com/support/home#/case/create%3FissueType=customer-service%26serviceCode=general-info%26getting-started%26categoryCode=using-aws%26services
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyAvailabilityZoneGroupRequest AWS API Documentation
    #
    class ModifyAvailabilityZoneGroupRequest < Struct.new(
      :group_name,
      :opt_in_status,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Is `true` if the request succeeds, and an error otherwise.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyAvailabilityZoneGroupResult AWS API Documentation
    #
    class ModifyAvailabilityZoneGroupResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyCapacityReservationRequest
    #   data as a hash:
    #
    #       {
    #         capacity_reservation_id: "CapacityReservationId", # required
    #         instance_count: 1,
    #         end_date: Time.now,
    #         end_date_type: "unlimited", # accepts unlimited, limited
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] capacity_reservation_id
    #   The ID of the Capacity Reservation.
    #   @return [String]
    #
    # @!attribute [rw] instance_count
    #   The number of instances for which to reserve capacity.
    #   @return [Integer]
    #
    # @!attribute [rw] end_date
    #   The date and time at which the Capacity Reservation expires. When a
    #   Capacity Reservation expires, the reserved capacity is released and
    #   you can no longer launch instances into it. The Capacity
    #   Reservation's state changes to `expired` when it reaches its end
    #   date and time.
    #
    #   The Capacity Reservation is cancelled within an hour from the
    #   specified time. For example, if you specify 5/31/2019, 13:30:55, the
    #   Capacity Reservation is guaranteed to end between 13:30:55 and
    #   14:30:55 on 5/31/2019.
    #
    #   You must provide an `EndDate` value if `EndDateType` is `limited`.
    #   Omit `EndDate` if `EndDateType` is `unlimited`.
    #   @return [Time]
    #
    # @!attribute [rw] end_date_type
    #   Indicates the way in which the Capacity Reservation ends. A Capacity
    #   Reservation can have one of the following end types:
    #
    #   * `unlimited` - The Capacity Reservation remains active until you
    #     explicitly cancel it. Do not provide an `EndDate` value if
    #     `EndDateType` is `unlimited`.
    #
    #   * `limited` - The Capacity Reservation expires automatically at a
    #     specified date and time. You must provide an `EndDate` value if
    #     `EndDateType` is `limited`.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyCapacityReservationRequest AWS API Documentation
    #
    class ModifyCapacityReservationRequest < Struct.new(
      :capacity_reservation_id,
      :instance_count,
      :end_date,
      :end_date_type,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyCapacityReservationResult AWS API Documentation
    #
    class ModifyCapacityReservationResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyClientVpnEndpointRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         server_certificate_arn: "String",
    #         connection_log_options: {
    #           enabled: false,
    #           cloudwatch_log_group: "String",
    #           cloudwatch_log_stream: "String",
    #         },
    #         dns_servers: {
    #           custom_dns_servers: ["String"],
    #           enabled: false,
    #         },
    #         vpn_port: 1,
    #         description: "String",
    #         split_tunnel: false,
    #         dry_run: false,
    #         security_group_ids: ["SecurityGroupId"],
    #         vpc_id: "VpcId",
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint to modify.
    #   @return [String]
    #
    # @!attribute [rw] server_certificate_arn
    #   The ARN of the server certificate to be used. The server certificate
    #   must be provisioned in AWS Certificate Manager (ACM).
    #   @return [String]
    #
    # @!attribute [rw] connection_log_options
    #   Information about the client connection logging options.
    #
    #   If you enable client connection logging, data about client
    #   connections is sent to a Cloudwatch Logs log stream. The following
    #   information is logged:
    #
    #   * Client connection requests
    #
    #   * Client connection results (successful and unsuccessful)
    #
    #   * Reasons for unsuccessful client connection requests
    #
    #   * Client connection termination time
    #   @return [Types::ConnectionLogOptions]
    #
    # @!attribute [rw] dns_servers
    #   Information about the DNS servers to be used by Client VPN
    #   connections. A Client VPN endpoint can have up to two DNS servers.
    #   @return [Types::DnsServersOptionsModifyStructure]
    #
    # @!attribute [rw] vpn_port
    #   The port number to assign to the Client VPN endpoint for TCP and UDP
    #   traffic.
    #
    #   Valid Values: `443` \| `1194`
    #
    #   Default Value: `443`
    #   @return [Integer]
    #
    # @!attribute [rw] description
    #   A brief description of the Client VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] split_tunnel
    #   Indicates whether the VPN is split-tunnel.
    #
    #   For information about split-tunnel VPN endpoints, see [Split-Tunnel
    #   AWS Client VPN Endpoint][1] in the *AWS Client VPN Administrator
    #   Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/split-tunnel-vpn.html
    #   @return [Boolean]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] security_group_ids
    #   The IDs of one or more security groups to apply to the target
    #   network.
    #   @return [Array<String>]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC to associate with the Client VPN endpoint.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyClientVpnEndpointRequest AWS API Documentation
    #
    class ModifyClientVpnEndpointRequest < Struct.new(
      :client_vpn_endpoint_id,
      :server_certificate_arn,
      :connection_log_options,
      :dns_servers,
      :vpn_port,
      :description,
      :split_tunnel,
      :dry_run,
      :security_group_ids,
      :vpc_id)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyClientVpnEndpointResult AWS API Documentation
    #
    class ModifyClientVpnEndpointResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyDefaultCreditSpecificationRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         instance_family: "t2", # required, accepts t2, t3, t3a
    #         cpu_credits: "String", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_family
    #   The instance family.
    #   @return [String]
    #
    # @!attribute [rw] cpu_credits
    #   The credit option for CPU usage of the instance family.
    #
    #   Valid Values: `standard` \| `unlimited`
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyDefaultCreditSpecificationRequest AWS API Documentation
    #
    class ModifyDefaultCreditSpecificationRequest < Struct.new(
      :dry_run,
      :instance_family,
      :cpu_credits)
      include Aws::Structure
    end

    # @!attribute [rw] instance_family_credit_specification
    #   The default credit option for CPU usage of the instance family.
    #   @return [Types::InstanceFamilyCreditSpecification]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyDefaultCreditSpecificationResult AWS API Documentation
    #
    class ModifyDefaultCreditSpecificationResult < Struct.new(
      :instance_family_credit_specification)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyEbsDefaultKmsKeyIdRequest
    #   data as a hash:
    #
    #       {
    #         kms_key_id: "KmsKeyId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] kms_key_id
    #   The identifier of the AWS Key Management Service (AWS KMS) customer
    #   master key (CMK) to use for Amazon EBS encryption. If this parameter
    #   is not specified, your AWS managed CMK for EBS is used. If
    #   `KmsKeyId` is specified, the encrypted state must be `true`.
    #
    #   You can specify the CMK using any of the following:
    #
    #   * Key ID. For example, key/1234abcd-12ab-34cd-56ef-1234567890ab.
    #
    #   * Key alias. For example, alias/ExampleAlias.
    #
    #   * Key ARN. For example,
    #     arn:aws:kms:*us-east-1*\:*012345678910*\:key/*abcd1234-a123-456a-a12b-a123b4cd56ef*.
    #
    #   * Alias ARN. For example,
    #     arn:aws:kms:*us-east-1*\:*012345678910*\:alias/*ExampleAlias*.
    #
    #   AWS authenticates the CMK asynchronously. Therefore, if you specify
    #   an ID, alias, or ARN that is not valid, the action can appear to
    #   complete, but eventually fails.
    #
    #   Amazon EBS does not support asymmetric CMKs.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyEbsDefaultKmsKeyIdRequest AWS API Documentation
    #
    class ModifyEbsDefaultKmsKeyIdRequest < Struct.new(
      :kms_key_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] kms_key_id
    #   The Amazon Resource Name (ARN) of the default CMK for encryption by
    #   default.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyEbsDefaultKmsKeyIdResult AWS API Documentation
    #
    class ModifyEbsDefaultKmsKeyIdResult < Struct.new(
      :kms_key_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyFleetRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         excess_capacity_termination_policy: "no-termination", # accepts no-termination, termination
    #         fleet_id: "FleetId", # required
    #         target_capacity_specification: { # required
    #           total_target_capacity: 1, # required
    #           on_demand_target_capacity: 1,
    #           spot_target_capacity: 1,
    #           default_target_capacity_type: "spot", # accepts spot, on-demand
    #         },
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] excess_capacity_termination_policy
    #   Indicates whether running instances should be terminated if the
    #   total target capacity of the EC2 Fleet is decreased below the
    #   current size of the EC2 Fleet.
    #   @return [String]
    #
    # @!attribute [rw] fleet_id
    #   The ID of the EC2 Fleet.
    #   @return [String]
    #
    # @!attribute [rw] target_capacity_specification
    #   The size of the EC2 Fleet.
    #   @return [Types::TargetCapacitySpecificationRequest]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyFleetRequest AWS API Documentation
    #
    class ModifyFleetRequest < Struct.new(
      :dry_run,
      :excess_capacity_termination_policy,
      :fleet_id,
      :target_capacity_specification)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Is `true` if the request succeeds, and an error otherwise.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyFleetResult AWS API Documentation
    #
    class ModifyFleetResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyFpgaImageAttributeRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         fpga_image_id: "FpgaImageId", # required
    #         attribute: "description", # accepts description, name, loadPermission, productCodes
    #         operation_type: "add", # accepts add, remove
    #         user_ids: ["String"],
    #         user_groups: ["String"],
    #         product_codes: ["String"],
    #         load_permission: {
    #           add: [
    #             {
    #               group: "all", # accepts all
    #               user_id: "String",
    #             },
    #           ],
    #           remove: [
    #             {
    #               group: "all", # accepts all
    #               user_id: "String",
    #             },
    #           ],
    #         },
    #         description: "String",
    #         name: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] fpga_image_id
    #   The ID of the AFI.
    #   @return [String]
    #
    # @!attribute [rw] attribute
    #   The name of the attribute.
    #   @return [String]
    #
    # @!attribute [rw] operation_type
    #   The operation type.
    #   @return [String]
    #
    # @!attribute [rw] user_ids
    #   The AWS account IDs. This parameter is valid only when modifying the
    #   `loadPermission` attribute.
    #   @return [Array<String>]
    #
    # @!attribute [rw] user_groups
    #   The user groups. This parameter is valid only when modifying the
    #   `loadPermission` attribute.
    #   @return [Array<String>]
    #
    # @!attribute [rw] product_codes
    #   The product codes. After you add a product code to an AFI, it can't
    #   be removed. This parameter is valid only when modifying the
    #   `productCodes` attribute.
    #   @return [Array<String>]
    #
    # @!attribute [rw] load_permission
    #   The load permission for the AFI.
    #   @return [Types::LoadPermissionModifications]
    #
    # @!attribute [rw] description
    #   A description for the AFI.
    #   @return [String]
    #
    # @!attribute [rw] name
    #   A name for the AFI.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyFpgaImageAttributeRequest AWS API Documentation
    #
    class ModifyFpgaImageAttributeRequest < Struct.new(
      :dry_run,
      :fpga_image_id,
      :attribute,
      :operation_type,
      :user_ids,
      :user_groups,
      :product_codes,
      :load_permission,
      :description,
      :name)
      include Aws::Structure
    end

    # @!attribute [rw] fpga_image_attribute
    #   Information about the attribute.
    #   @return [Types::FpgaImageAttribute]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyFpgaImageAttributeResult AWS API Documentation
    #
    class ModifyFpgaImageAttributeResult < Struct.new(
      :fpga_image_attribute)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyHostsRequest
    #   data as a hash:
    #
    #       {
    #         auto_placement: "on", # accepts on, off
    #         host_ids: ["DedicatedHostId"], # required
    #         host_recovery: "on", # accepts on, off
    #         instance_type: "String",
    #         instance_family: "String",
    #       }
    #
    # @!attribute [rw] auto_placement
    #   Specify whether to enable or disable auto-placement.
    #   @return [String]
    #
    # @!attribute [rw] host_ids
    #   The IDs of the Dedicated Hosts to modify.
    #   @return [Array<String>]
    #
    # @!attribute [rw] host_recovery
    #   Indicates whether to enable or disable host recovery for the
    #   Dedicated Host. For more information, see [ Host Recovery][1] in the
    #   *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/dedicated-hosts-recovery.html
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   Specifies the instance type to be supported by the Dedicated Host.
    #   Specify this parameter to modify a Dedicated Host to support only a
    #   specific instance type.
    #
    #   If you want to modify a Dedicated Host to support multiple instance
    #   types in its current instance family, omit this parameter and
    #   specify **InstanceFamily** instead. You cannot specify
    #   **InstanceType** and **InstanceFamily** in the same request.
    #   @return [String]
    #
    # @!attribute [rw] instance_family
    #   Specifies the instance family to be supported by the Dedicated Host.
    #   Specify this parameter to modify a Dedicated Host to support
    #   multiple instance types within its current instance family.
    #
    #   If you want to modify a Dedicated Host to support a specific
    #   instance type only, omit this parameter and specify **InstanceType**
    #   instead. You cannot specify **InstanceFamily** and **InstanceType**
    #   in the same request.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyHostsRequest AWS API Documentation
    #
    class ModifyHostsRequest < Struct.new(
      :auto_placement,
      :host_ids,
      :host_recovery,
      :instance_type,
      :instance_family)
      include Aws::Structure
    end

    # @!attribute [rw] successful
    #   The IDs of the Dedicated Hosts that were successfully modified.
    #   @return [Array<String>]
    #
    # @!attribute [rw] unsuccessful
    #   The IDs of the Dedicated Hosts that could not be modified. Check
    #   whether the setting you requested can be used.
    #   @return [Array<Types::UnsuccessfulItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyHostsResult AWS API Documentation
    #
    class ModifyHostsResult < Struct.new(
      :successful,
      :unsuccessful)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyIdFormatRequest
    #   data as a hash:
    #
    #       {
    #         resource: "String", # required
    #         use_long_ids: false, # required
    #       }
    #
    # @!attribute [rw] resource
    #   The type of resource: `bundle` \| `conversion-task` \|
    #   `customer-gateway` \| `dhcp-options` \| `elastic-ip-allocation` \|
    #   `elastic-ip-association` \| `export-task` \| `flow-log` \| `image`
    #   \| `import-task` \| `internet-gateway` \| `network-acl` \|
    #   `network-acl-association` \| `network-interface` \|
    #   `network-interface-attachment` \| `prefix-list` \| `route-table` \|
    #   `route-table-association` \| `security-group` \| `subnet` \|
    #   `subnet-cidr-block-association` \| `vpc` \|
    #   `vpc-cidr-block-association` \| `vpc-endpoint` \|
    #   `vpc-peering-connection` \| `vpn-connection` \| `vpn-gateway`.
    #
    #   Alternatively, use the `all-current` option to include all resource
    #   types that are currently within their opt-in period for longer IDs.
    #   @return [String]
    #
    # @!attribute [rw] use_long_ids
    #   Indicate whether the resource should use longer IDs (17-character
    #   IDs).
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyIdFormatRequest AWS API Documentation
    #
    class ModifyIdFormatRequest < Struct.new(
      :resource,
      :use_long_ids)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyIdentityIdFormatRequest
    #   data as a hash:
    #
    #       {
    #         principal_arn: "String", # required
    #         resource: "String", # required
    #         use_long_ids: false, # required
    #       }
    #
    # @!attribute [rw] principal_arn
    #   The ARN of the principal, which can be an IAM user, IAM role, or the
    #   root user. Specify `all` to modify the ID format for all IAM users,
    #   IAM roles, and the root user of the account.
    #   @return [String]
    #
    # @!attribute [rw] resource
    #   The type of resource: `bundle` \| `conversion-task` \|
    #   `customer-gateway` \| `dhcp-options` \| `elastic-ip-allocation` \|
    #   `elastic-ip-association` \| `export-task` \| `flow-log` \| `image`
    #   \| `import-task` \| `internet-gateway` \| `network-acl` \|
    #   `network-acl-association` \| `network-interface` \|
    #   `network-interface-attachment` \| `prefix-list` \| `route-table` \|
    #   `route-table-association` \| `security-group` \| `subnet` \|
    #   `subnet-cidr-block-association` \| `vpc` \|
    #   `vpc-cidr-block-association` \| `vpc-endpoint` \|
    #   `vpc-peering-connection` \| `vpn-connection` \| `vpn-gateway`.
    #
    #   Alternatively, use the `all-current` option to include all resource
    #   types that are currently within their opt-in period for longer IDs.
    #   @return [String]
    #
    # @!attribute [rw] use_long_ids
    #   Indicates whether the resource should use longer IDs (17-character
    #   IDs)
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyIdentityIdFormatRequest AWS API Documentation
    #
    class ModifyIdentityIdFormatRequest < Struct.new(
      :principal_arn,
      :resource,
      :use_long_ids)
      include Aws::Structure
    end

    # Contains the parameters for ModifyImageAttribute.
    #
    # @note When making an API call, you may pass ModifyImageAttributeRequest
    #   data as a hash:
    #
    #       {
    #         attribute: "String",
    #         description: "value", # value <Hash,Array,String,Numeric,Boolean,IO,Set,nil>
    #         image_id: "ImageId", # required
    #         launch_permission: {
    #           add: [
    #             {
    #               group: "all", # accepts all
    #               user_id: "String",
    #             },
    #           ],
    #           remove: [
    #             {
    #               group: "all", # accepts all
    #               user_id: "String",
    #             },
    #           ],
    #         },
    #         operation_type: "add", # accepts add, remove
    #         product_codes: ["String"],
    #         user_groups: ["String"],
    #         user_ids: ["String"],
    #         value: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] attribute
    #   The name of the attribute to modify. The valid values are
    #   `description`, `launchPermission`, and `productCodes`.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   A new description for the AMI.
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] image_id
    #   The ID of the AMI.
    #   @return [String]
    #
    # @!attribute [rw] launch_permission
    #   A new launch permission for the AMI.
    #   @return [Types::LaunchPermissionModifications]
    #
    # @!attribute [rw] operation_type
    #   The operation type. This parameter can be used only when the
    #   `Attribute` parameter is `launchPermission`.
    #   @return [String]
    #
    # @!attribute [rw] product_codes
    #   The DevPay product codes. After you add a product code to an AMI, it
    #   can't be removed.
    #   @return [Array<String>]
    #
    # @!attribute [rw] user_groups
    #   The user groups. This parameter can be used only when the
    #   `Attribute` parameter is `launchPermission`.
    #   @return [Array<String>]
    #
    # @!attribute [rw] user_ids
    #   The AWS account IDs. This parameter can be used only when the
    #   `Attribute` parameter is `launchPermission`.
    #   @return [Array<String>]
    #
    # @!attribute [rw] value
    #   The value of the attribute being modified. This parameter can be
    #   used only when the `Attribute` parameter is `description` or
    #   `productCodes`.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyImageAttributeRequest AWS API Documentation
    #
    class ModifyImageAttributeRequest < Struct.new(
      :attribute,
      :description,
      :image_id,
      :launch_permission,
      :operation_type,
      :product_codes,
      :user_groups,
      :user_ids,
      :value,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyInstanceAttributeRequest
    #   data as a hash:
    #
    #       {
    #         source_dest_check: {
    #           value: false,
    #         },
    #         attribute: "instanceType", # accepts instanceType, kernel, ramdisk, userData, disableApiTermination, instanceInitiatedShutdownBehavior, rootDeviceName, blockDeviceMapping, productCodes, sourceDestCheck, groupSet, ebsOptimized, sriovNetSupport, enaSupport
    #         block_device_mappings: [
    #           {
    #             device_name: "String",
    #             ebs: {
    #               delete_on_termination: false,
    #               volume_id: "VolumeId",
    #             },
    #             no_device: "String",
    #             virtual_name: "String",
    #           },
    #         ],
    #         disable_api_termination: {
    #           value: false,
    #         },
    #         dry_run: false,
    #         ebs_optimized: {
    #           value: false,
    #         },
    #         ena_support: {
    #           value: false,
    #         },
    #         groups: ["String"],
    #         instance_id: "InstanceId", # required
    #         instance_initiated_shutdown_behavior: "value", # value <Hash,Array,String,Numeric,Boolean,IO,Set,nil>
    #         instance_type: "value", # value <Hash,Array,String,Numeric,Boolean,IO,Set,nil>
    #         kernel: "value", # value <Hash,Array,String,Numeric,Boolean,IO,Set,nil>
    #         ramdisk: "value", # value <Hash,Array,String,Numeric,Boolean,IO,Set,nil>
    #         sriov_net_support: "value", # value <Hash,Array,String,Numeric,Boolean,IO,Set,nil>
    #         user_data: {
    #           value: "data",
    #         },
    #         value: "String",
    #       }
    #
    # @!attribute [rw] source_dest_check
    #   Specifies whether source/destination checking is enabled. A value of
    #   `true` means that checking is enabled, and `false` means that
    #   checking is disabled. This value must be `false` for a NAT instance
    #   to perform NAT.
    #   @return [Types::AttributeBooleanValue]
    #
    # @!attribute [rw] attribute
    #   The name of the attribute.
    #   @return [String]
    #
    # @!attribute [rw] block_device_mappings
    #   Modifies the `DeleteOnTermination` attribute for volumes that are
    #   currently attached. The volume must be owned by the caller. If no
    #   value is specified for `DeleteOnTermination`, the default is `true`
    #   and the volume is deleted when the instance is terminated.
    #
    #   To add instance store volumes to an Amazon EBS-backed instance, you
    #   must add them when you launch the instance. For more information,
    #   see [Updating the Block Device Mapping when Launching an
    #   Instance][1] in the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/block-device-mapping-concepts.html#Using_OverridingAMIBDM
    #   @return [Array<Types::InstanceBlockDeviceMappingSpecification>]
    #
    # @!attribute [rw] disable_api_termination
    #   If the value is `true`, you can't terminate the instance using the
    #   Amazon EC2 console, CLI, or API; otherwise, you can. You cannot use
    #   this parameter for Spot Instances.
    #   @return [Types::AttributeBooleanValue]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] ebs_optimized
    #   Specifies whether the instance is optimized for Amazon EBS I/O. This
    #   optimization provides dedicated throughput to Amazon EBS and an
    #   optimized configuration stack to provide optimal EBS I/O
    #   performance. This optimization isn't available with all instance
    #   types. Additional usage charges apply when using an EBS Optimized
    #   instance.
    #   @return [Types::AttributeBooleanValue]
    #
    # @!attribute [rw] ena_support
    #   Set to `true` to enable enhanced networking with ENA for the
    #   instance.
    #
    #   This option is supported only for HVM instances. Specifying this
    #   option with a PV instance can make it unreachable.
    #   @return [Types::AttributeBooleanValue]
    #
    # @!attribute [rw] groups
    #   \[EC2-VPC\] Changes the security groups of the instance. You must
    #   specify at least one security group, even if it's just the default
    #   security group for the VPC. You must specify the security group ID,
    #   not the security group name.
    #   @return [Array<String>]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] instance_initiated_shutdown_behavior
    #   Specifies whether an instance stops or terminates when you initiate
    #   shutdown from the instance (using the operating system command for
    #   system shutdown).
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] instance_type
    #   Changes the instance type to the specified value. For more
    #   information, see [Instance Types][1]. If the instance type is not
    #   valid, the error returned is `InvalidInstanceAttributeValue`.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] kernel
    #   Changes the instance's kernel to the specified value. We recommend
    #   that you use PV-GRUB instead of kernels and RAM disks. For more
    #   information, see [PV-GRUB][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedKernels.html
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] ramdisk
    #   Changes the instance's RAM disk to the specified value. We
    #   recommend that you use PV-GRUB instead of kernels and RAM disks. For
    #   more information, see [PV-GRUB][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedKernels.html
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] sriov_net_support
    #   Set to `simple` to enable enhanced networking with the Intel 82599
    #   Virtual Function interface for the instance.
    #
    #   There is no way to disable enhanced networking with the Intel 82599
    #   Virtual Function interface at this time.
    #
    #   This option is supported only for HVM instances. Specifying this
    #   option with a PV instance can make it unreachable.
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] user_data
    #   Changes the instance's user data to the specified value. If you are
    #   using an AWS SDK or command line tool, base64-encoding is performed
    #   for you, and you can load the text from a file. Otherwise, you must
    #   provide base64-encoded text.
    #   @return [Types::BlobAttributeValue]
    #
    # @!attribute [rw] value
    #   A new value for the attribute. Use only with the `kernel`,
    #   `ramdisk`, `userData`, `disableApiTermination`, or
    #   `instanceInitiatedShutdownBehavior` attribute.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyInstanceAttributeRequest AWS API Documentation
    #
    class ModifyInstanceAttributeRequest < Struct.new(
      :source_dest_check,
      :attribute,
      :block_device_mappings,
      :disable_api_termination,
      :dry_run,
      :ebs_optimized,
      :ena_support,
      :groups,
      :instance_id,
      :instance_initiated_shutdown_behavior,
      :instance_type,
      :kernel,
      :ramdisk,
      :sriov_net_support,
      :user_data,
      :value)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyInstanceCapacityReservationAttributesRequest
    #   data as a hash:
    #
    #       {
    #         instance_id: "InstanceId", # required
    #         capacity_reservation_specification: { # required
    #           capacity_reservation_preference: "open", # accepts open, none
    #           capacity_reservation_target: {
    #             capacity_reservation_id: "CapacityReservationId",
    #           },
    #         },
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance to be modified.
    #   @return [String]
    #
    # @!attribute [rw] capacity_reservation_specification
    #   Information about the Capacity Reservation targeting option.
    #   @return [Types::CapacityReservationSpecification]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyInstanceCapacityReservationAttributesRequest AWS API Documentation
    #
    class ModifyInstanceCapacityReservationAttributesRequest < Struct.new(
      :instance_id,
      :capacity_reservation_specification,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyInstanceCapacityReservationAttributesResult AWS API Documentation
    #
    class ModifyInstanceCapacityReservationAttributesResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyInstanceCreditSpecificationRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         client_token: "String",
    #         instance_credit_specifications: [ # required
    #           {
    #             instance_id: "InstanceId",
    #             cpu_credits: "String",
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] client_token
    #   A unique, case-sensitive token that you provide to ensure
    #   idempotency of your modification request. For more information, see
    #   [Ensuring Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] instance_credit_specifications
    #   Information about the credit option for CPU usage.
    #   @return [Array<Types::InstanceCreditSpecificationRequest>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyInstanceCreditSpecificationRequest AWS API Documentation
    #
    class ModifyInstanceCreditSpecificationRequest < Struct.new(
      :dry_run,
      :client_token,
      :instance_credit_specifications)
      include Aws::Structure
    end

    # @!attribute [rw] successful_instance_credit_specifications
    #   Information about the instances whose credit option for CPU usage
    #   was successfully modified.
    #   @return [Array<Types::SuccessfulInstanceCreditSpecificationItem>]
    #
    # @!attribute [rw] unsuccessful_instance_credit_specifications
    #   Information about the instances whose credit option for CPU usage
    #   was not modified.
    #   @return [Array<Types::UnsuccessfulInstanceCreditSpecificationItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyInstanceCreditSpecificationResult AWS API Documentation
    #
    class ModifyInstanceCreditSpecificationResult < Struct.new(
      :successful_instance_credit_specifications,
      :unsuccessful_instance_credit_specifications)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyInstanceEventStartTimeRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         instance_id: "InstanceId", # required
    #         instance_event_id: "String", # required
    #         not_before: Time.now, # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance with the scheduled event.
    #   @return [String]
    #
    # @!attribute [rw] instance_event_id
    #   The ID of the event whose date and time you are modifying.
    #   @return [String]
    #
    # @!attribute [rw] not_before
    #   The new date and time when the event will take place.
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyInstanceEventStartTimeRequest AWS API Documentation
    #
    class ModifyInstanceEventStartTimeRequest < Struct.new(
      :dry_run,
      :instance_id,
      :instance_event_id,
      :not_before)
      include Aws::Structure
    end

    # @!attribute [rw] event
    #   Describes a scheduled event for an instance.
    #   @return [Types::InstanceStatusEvent]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyInstanceEventStartTimeResult AWS API Documentation
    #
    class ModifyInstanceEventStartTimeResult < Struct.new(
      :event)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyInstanceMetadataOptionsRequest
    #   data as a hash:
    #
    #       {
    #         instance_id: "InstanceId", # required
    #         http_tokens: "optional", # accepts optional, required
    #         http_put_response_hop_limit: 1,
    #         http_endpoint: "disabled", # accepts disabled, enabled
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] http_tokens
    #   The state of token usage for your instance metadata requests. If the
    #   parameter is not specified in the request, the default state is
    #   `optional`.
    #
    #   If the state is `optional`, you can choose to retrieve instance
    #   metadata with or without a signed token header on your request. If
    #   you retrieve the IAM role credentials without a token, the version
    #   1.0 role credentials are returned. If you retrieve the IAM role
    #   credentials using a valid signed token, the version 2.0 role
    #   credentials are returned.
    #
    #   If the state is `required`, you must send a signed token header with
    #   any instance metadata retrieval requests. In this state, retrieving
    #   the IAM role credential always returns the version 2.0 credentials;
    #   the version 1.0 credentials are not available.
    #   @return [String]
    #
    # @!attribute [rw] http_put_response_hop_limit
    #   The desired HTTP PUT response hop limit for instance metadata
    #   requests. The larger the number, the further instance metadata
    #   requests can travel. If no parameter is specified, the existing
    #   state is maintained.
    #
    #   Possible values: Integers from 1 to 64
    #   @return [Integer]
    #
    # @!attribute [rw] http_endpoint
    #   This parameter enables or disables the HTTP metadata endpoint on
    #   your instances. If the parameter is not specified, the existing
    #   state is maintained.
    #
    #   <note markdown="1"> If you specify a value of `disabled`, you will not be able to access
    #   your instance metadata.
    #
    #    </note>
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyInstanceMetadataOptionsRequest AWS API Documentation
    #
    class ModifyInstanceMetadataOptionsRequest < Struct.new(
      :instance_id,
      :http_tokens,
      :http_put_response_hop_limit,
      :http_endpoint,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] instance_metadata_options
    #   The metadata options for the instance.
    #   @return [Types::InstanceMetadataOptionsResponse]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyInstanceMetadataOptionsResult AWS API Documentation
    #
    class ModifyInstanceMetadataOptionsResult < Struct.new(
      :instance_id,
      :instance_metadata_options)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyInstancePlacementRequest
    #   data as a hash:
    #
    #       {
    #         affinity: "default", # accepts default, host
    #         group_name: "PlacementGroupName",
    #         host_id: "DedicatedHostId",
    #         instance_id: "InstanceId", # required
    #         tenancy: "dedicated", # accepts dedicated, host
    #         partition_number: 1,
    #         host_resource_group_arn: "String",
    #       }
    #
    # @!attribute [rw] affinity
    #   The affinity setting for the instance.
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   The name of the placement group in which to place the instance. For
    #   spread placement groups, the instance must have a tenancy of
    #   `default`. For cluster and partition placement groups, the instance
    #   must have a tenancy of `default` or `dedicated`.
    #
    #   To remove an instance from a placement group, specify an empty
    #   string ("").
    #   @return [String]
    #
    # @!attribute [rw] host_id
    #   The ID of the Dedicated Host with which to associate the instance.
    #   @return [String]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance that you are modifying.
    #   @return [String]
    #
    # @!attribute [rw] tenancy
    #   The tenancy for the instance.
    #   @return [String]
    #
    # @!attribute [rw] partition_number
    #   Reserved for future use.
    #   @return [Integer]
    #
    # @!attribute [rw] host_resource_group_arn
    #   The ARN of the host resource group in which to place the instance.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyInstancePlacementRequest AWS API Documentation
    #
    class ModifyInstancePlacementRequest < Struct.new(
      :affinity,
      :group_name,
      :host_id,
      :instance_id,
      :tenancy,
      :partition_number,
      :host_resource_group_arn)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Is `true` if the request succeeds, and an error otherwise.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyInstancePlacementResult AWS API Documentation
    #
    class ModifyInstancePlacementResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyLaunchTemplateRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         client_token: "String",
    #         launch_template_id: "LaunchTemplateId",
    #         launch_template_name: "LaunchTemplateName",
    #         default_version: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier you provide to ensure the
    #   idempotency of the request. For more information, see [Ensuring
    #   Idempotency][1].
    #
    #   Constraint: Maximum 128 ASCII characters.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] launch_template_id
    #   The ID of the launch template. You must specify either the launch
    #   template ID or launch template name in the request.
    #   @return [String]
    #
    # @!attribute [rw] launch_template_name
    #   The name of the launch template. You must specify either the launch
    #   template ID or launch template name in the request.
    #   @return [String]
    #
    # @!attribute [rw] default_version
    #   The version number of the launch template to set as the default
    #   version.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyLaunchTemplateRequest AWS API Documentation
    #
    class ModifyLaunchTemplateRequest < Struct.new(
      :dry_run,
      :client_token,
      :launch_template_id,
      :launch_template_name,
      :default_version)
      include Aws::Structure
    end

    # @!attribute [rw] launch_template
    #   Information about the launch template.
    #   @return [Types::LaunchTemplate]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyLaunchTemplateResult AWS API Documentation
    #
    class ModifyLaunchTemplateResult < Struct.new(
      :launch_template)
      include Aws::Structure
    end

    # Contains the parameters for ModifyNetworkInterfaceAttribute.
    #
    # @note When making an API call, you may pass ModifyNetworkInterfaceAttributeRequest
    #   data as a hash:
    #
    #       {
    #         attachment: {
    #           attachment_id: "NetworkInterfaceAttachmentId",
    #           delete_on_termination: false,
    #         },
    #         description: "value", # value <Hash,Array,String,Numeric,Boolean,IO,Set,nil>
    #         dry_run: false,
    #         groups: ["SecurityGroupId"],
    #         network_interface_id: "NetworkInterfaceId", # required
    #         source_dest_check: {
    #           value: false,
    #         },
    #       }
    #
    # @!attribute [rw] attachment
    #   Information about the interface attachment. If modifying the
    #   'delete on termination' attribute, you must specify the ID of the
    #   interface attachment.
    #   @return [Types::NetworkInterfaceAttachmentChanges]
    #
    # @!attribute [rw] description
    #   A description for the network interface.
    #   @return [Types::AttributeValue]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] groups
    #   Changes the security groups for the network interface. The new set
    #   of groups you specify replaces the current set. You must specify at
    #   least one group, even if it's just the default security group in
    #   the VPC. You must specify the ID of the security group, not the
    #   name.
    #   @return [Array<String>]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] source_dest_check
    #   Indicates whether source/destination checking is enabled. A value of
    #   `true` means checking is enabled, and `false` means checking is
    #   disabled. This value must be `false` for a NAT instance to perform
    #   NAT. For more information, see [NAT Instances][1] in the *Amazon
    #   Virtual Private Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AmazonVPC/latest/UserGuide/VPC_NAT_Instance.html
    #   @return [Types::AttributeBooleanValue]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyNetworkInterfaceAttributeRequest AWS API Documentation
    #
    class ModifyNetworkInterfaceAttributeRequest < Struct.new(
      :attachment,
      :description,
      :dry_run,
      :groups,
      :network_interface_id,
      :source_dest_check)
      include Aws::Structure
    end

    # Contains the parameters for ModifyReservedInstances.
    #
    # @note When making an API call, you may pass ModifyReservedInstancesRequest
    #   data as a hash:
    #
    #       {
    #         reserved_instances_ids: ["ReservationId"], # required
    #         client_token: "String",
    #         target_configurations: [ # required
    #           {
    #             availability_zone: "String",
    #             instance_count: 1,
    #             instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #             platform: "String",
    #             scope: "Availability Zone", # accepts Availability Zone, Region
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] reserved_instances_ids
    #   The IDs of the Reserved Instances to modify.
    #   @return [Array<String>]
    #
    # @!attribute [rw] client_token
    #   A unique, case-sensitive token you provide to ensure idempotency of
    #   your modification request. For more information, see [Ensuring
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] target_configurations
    #   The configuration settings for the Reserved Instances to modify.
    #   @return [Array<Types::ReservedInstancesConfiguration>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyReservedInstancesRequest AWS API Documentation
    #
    class ModifyReservedInstancesRequest < Struct.new(
      :reserved_instances_ids,
      :client_token,
      :target_configurations)
      include Aws::Structure
    end

    # Contains the output of ModifyReservedInstances.
    #
    # @!attribute [rw] reserved_instances_modification_id
    #   The ID for the modification.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyReservedInstancesResult AWS API Documentation
    #
    class ModifyReservedInstancesResult < Struct.new(
      :reserved_instances_modification_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifySnapshotAttributeRequest
    #   data as a hash:
    #
    #       {
    #         attribute: "productCodes", # accepts productCodes, createVolumePermission
    #         create_volume_permission: {
    #           add: [
    #             {
    #               group: "all", # accepts all
    #               user_id: "String",
    #             },
    #           ],
    #           remove: [
    #             {
    #               group: "all", # accepts all
    #               user_id: "String",
    #             },
    #           ],
    #         },
    #         group_names: ["SecurityGroupName"],
    #         operation_type: "add", # accepts add, remove
    #         snapshot_id: "SnapshotId", # required
    #         user_ids: ["String"],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] attribute
    #   The snapshot attribute to modify. Only volume creation permissions
    #   can be modified.
    #   @return [String]
    #
    # @!attribute [rw] create_volume_permission
    #   A JSON representation of the snapshot attribute modification.
    #   @return [Types::CreateVolumePermissionModifications]
    #
    # @!attribute [rw] group_names
    #   The group to modify for the snapshot.
    #   @return [Array<String>]
    #
    # @!attribute [rw] operation_type
    #   The type of operation to perform to the attribute.
    #   @return [String]
    #
    # @!attribute [rw] snapshot_id
    #   The ID of the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] user_ids
    #   The account ID to modify for the snapshot.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifySnapshotAttributeRequest AWS API Documentation
    #
    class ModifySnapshotAttributeRequest < Struct.new(
      :attribute,
      :create_volume_permission,
      :group_names,
      :operation_type,
      :snapshot_id,
      :user_ids,
      :dry_run)
      include Aws::Structure
    end

    # Contains the parameters for ModifySpotFleetRequest.
    #
    # @note When making an API call, you may pass ModifySpotFleetRequestRequest
    #   data as a hash:
    #
    #       {
    #         excess_capacity_termination_policy: "noTermination", # accepts noTermination, default
    #         spot_fleet_request_id: "SpotFleetRequestId", # required
    #         target_capacity: 1,
    #         on_demand_target_capacity: 1,
    #       }
    #
    # @!attribute [rw] excess_capacity_termination_policy
    #   Indicates whether running Spot Instances should be terminated if the
    #   target capacity of the Spot Fleet request is decreased below the
    #   current size of the Spot Fleet.
    #   @return [String]
    #
    # @!attribute [rw] spot_fleet_request_id
    #   The ID of the Spot Fleet request.
    #   @return [String]
    #
    # @!attribute [rw] target_capacity
    #   The size of the fleet.
    #   @return [Integer]
    #
    # @!attribute [rw] on_demand_target_capacity
    #   The number of On-Demand Instances in the fleet.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifySpotFleetRequestRequest AWS API Documentation
    #
    class ModifySpotFleetRequestRequest < Struct.new(
      :excess_capacity_termination_policy,
      :spot_fleet_request_id,
      :target_capacity,
      :on_demand_target_capacity)
      include Aws::Structure
    end

    # Contains the output of ModifySpotFleetRequest.
    #
    # @!attribute [rw] return
    #   Is `true` if the request succeeds, and an error otherwise.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifySpotFleetRequestResponse AWS API Documentation
    #
    class ModifySpotFleetRequestResponse < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifySubnetAttributeRequest
    #   data as a hash:
    #
    #       {
    #         assign_ipv_6_address_on_creation: {
    #           value: false,
    #         },
    #         map_public_ip_on_launch: {
    #           value: false,
    #         },
    #         subnet_id: "SubnetId", # required
    #         map_customer_owned_ip_on_launch: {
    #           value: false,
    #         },
    #         customer_owned_ipv_4_pool: "CoipPoolId",
    #       }
    #
    # @!attribute [rw] assign_ipv_6_address_on_creation
    #   Specify `true` to indicate that network interfaces created in the
    #   specified subnet should be assigned an IPv6 address. This includes a
    #   network interface that's created when launching an instance into
    #   the subnet (the instance therefore receives an IPv6 address).
    #
    #   If you enable the IPv6 addressing feature for your subnet, your
    #   network interface or instance only receives an IPv6 address if it's
    #   created using version `2016-11-15` or later of the Amazon EC2 API.
    #   @return [Types::AttributeBooleanValue]
    #
    # @!attribute [rw] map_public_ip_on_launch
    #   Specify `true` to indicate that network interfaces attached to
    #   instances created in the specified subnet should be assigned a
    #   public IPv4 address.
    #   @return [Types::AttributeBooleanValue]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet.
    #   @return [String]
    #
    # @!attribute [rw] map_customer_owned_ip_on_launch
    #   Specify `true` to indicate that network interfaces attached to
    #   instances created in the specified subnet should be assigned a
    #   customer-owned IPv4 address.
    #
    #   When this value is `true`, you must specify the customer-owned IP
    #   pool using `CustomerOwnedIpv4Pool`.
    #   @return [Types::AttributeBooleanValue]
    #
    # @!attribute [rw] customer_owned_ipv_4_pool
    #   The customer-owned IPv4 address pool associated with the subnet.
    #
    #   You must set this value when you specify `true` for
    #   `MapCustomerOwnedIpOnLaunch`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifySubnetAttributeRequest AWS API Documentation
    #
    class ModifySubnetAttributeRequest < Struct.new(
      :assign_ipv_6_address_on_creation,
      :map_public_ip_on_launch,
      :subnet_id,
      :map_customer_owned_ip_on_launch,
      :customer_owned_ipv_4_pool)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyTrafficMirrorFilterNetworkServicesRequest
    #   data as a hash:
    #
    #       {
    #         traffic_mirror_filter_id: "TrafficMirrorFilterId", # required
    #         add_network_services: ["amazon-dns"], # accepts amazon-dns
    #         remove_network_services: ["amazon-dns"], # accepts amazon-dns
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] traffic_mirror_filter_id
    #   The ID of the Traffic Mirror filter.
    #   @return [String]
    #
    # @!attribute [rw] add_network_services
    #   The network service, for example Amazon DNS, that you want to
    #   mirror.
    #   @return [Array<String>]
    #
    # @!attribute [rw] remove_network_services
    #   The network service, for example Amazon DNS, that you no longer want
    #   to mirror.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyTrafficMirrorFilterNetworkServicesRequest AWS API Documentation
    #
    class ModifyTrafficMirrorFilterNetworkServicesRequest < Struct.new(
      :traffic_mirror_filter_id,
      :add_network_services,
      :remove_network_services,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] traffic_mirror_filter
    #   The Traffic Mirror filter that the network service is associated
    #   with.
    #   @return [Types::TrafficMirrorFilter]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyTrafficMirrorFilterNetworkServicesResult AWS API Documentation
    #
    class ModifyTrafficMirrorFilterNetworkServicesResult < Struct.new(
      :traffic_mirror_filter)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyTrafficMirrorFilterRuleRequest
    #   data as a hash:
    #
    #       {
    #         traffic_mirror_filter_rule_id: "TrafficMirrorFilterRuleId", # required
    #         traffic_direction: "ingress", # accepts ingress, egress
    #         rule_number: 1,
    #         rule_action: "accept", # accepts accept, reject
    #         destination_port_range: {
    #           from_port: 1,
    #           to_port: 1,
    #         },
    #         source_port_range: {
    #           from_port: 1,
    #           to_port: 1,
    #         },
    #         protocol: 1,
    #         destination_cidr_block: "String",
    #         source_cidr_block: "String",
    #         description: "String",
    #         remove_fields: ["destination-port-range"], # accepts destination-port-range, source-port-range, protocol, description
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] traffic_mirror_filter_rule_id
    #   The ID of the Traffic Mirror rule.
    #   @return [String]
    #
    # @!attribute [rw] traffic_direction
    #   The type of traffic (`ingress` \| `egress`) to assign to the rule.
    #   @return [String]
    #
    # @!attribute [rw] rule_number
    #   The number of the Traffic Mirror rule. This number must be unique
    #   for each Traffic Mirror rule in a given direction. The rules are
    #   processed in ascending order by rule number.
    #   @return [Integer]
    #
    # @!attribute [rw] rule_action
    #   The action to assign to the rule.
    #   @return [String]
    #
    # @!attribute [rw] destination_port_range
    #   The destination ports that are associated with the Traffic Mirror
    #   rule.
    #   @return [Types::TrafficMirrorPortRangeRequest]
    #
    # @!attribute [rw] source_port_range
    #   The port range to assign to the Traffic Mirror rule.
    #   @return [Types::TrafficMirrorPortRangeRequest]
    #
    # @!attribute [rw] protocol
    #   The protocol, for example TCP, to assign to the Traffic Mirror rule.
    #   @return [Integer]
    #
    # @!attribute [rw] destination_cidr_block
    #   The destination CIDR block to assign to the Traffic Mirror rule.
    #   @return [String]
    #
    # @!attribute [rw] source_cidr_block
    #   The source CIDR block to assign to the Traffic Mirror rule.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   The description to assign to the Traffic Mirror rule.
    #   @return [String]
    #
    # @!attribute [rw] remove_fields
    #   The properties that you want to remove from the Traffic Mirror
    #   filter rule.
    #
    #   When you remove a property from a Traffic Mirror filter rule, the
    #   property is set to the default.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyTrafficMirrorFilterRuleRequest AWS API Documentation
    #
    class ModifyTrafficMirrorFilterRuleRequest < Struct.new(
      :traffic_mirror_filter_rule_id,
      :traffic_direction,
      :rule_number,
      :rule_action,
      :destination_port_range,
      :source_port_range,
      :protocol,
      :destination_cidr_block,
      :source_cidr_block,
      :description,
      :remove_fields,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] traffic_mirror_filter_rule
    #   Modifies a Traffic Mirror rule.
    #   @return [Types::TrafficMirrorFilterRule]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyTrafficMirrorFilterRuleResult AWS API Documentation
    #
    class ModifyTrafficMirrorFilterRuleResult < Struct.new(
      :traffic_mirror_filter_rule)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyTrafficMirrorSessionRequest
    #   data as a hash:
    #
    #       {
    #         traffic_mirror_session_id: "TrafficMirrorSessionId", # required
    #         traffic_mirror_target_id: "TrafficMirrorTargetId",
    #         traffic_mirror_filter_id: "TrafficMirrorFilterId",
    #         packet_length: 1,
    #         session_number: 1,
    #         virtual_network_id: 1,
    #         description: "String",
    #         remove_fields: ["packet-length"], # accepts packet-length, description, virtual-network-id
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] traffic_mirror_session_id
    #   The ID of the Traffic Mirror session.
    #   @return [String]
    #
    # @!attribute [rw] traffic_mirror_target_id
    #   The Traffic Mirror target. The target must be in the same VPC as the
    #   source, or have a VPC peering connection with the source.
    #   @return [String]
    #
    # @!attribute [rw] traffic_mirror_filter_id
    #   The ID of the Traffic Mirror filter.
    #   @return [String]
    #
    # @!attribute [rw] packet_length
    #   The number of bytes in each packet to mirror. These are bytes after
    #   the VXLAN header. To mirror a subset, set this to the length (in
    #   bytes) to mirror. For example, if you set this value to 100, then
    #   the first 100 bytes that meet the filter criteria are copied to the
    #   target. Do not specify this parameter when you want to mirror the
    #   entire packet.
    #   @return [Integer]
    #
    # @!attribute [rw] session_number
    #   The session number determines the order in which sessions are
    #   evaluated when an interface is used by multiple sessions. The first
    #   session with a matching filter is the one that mirrors the packets.
    #
    #   Valid values are 1-32766.
    #   @return [Integer]
    #
    # @!attribute [rw] virtual_network_id
    #   The virtual network ID of the Traffic Mirror session.
    #   @return [Integer]
    #
    # @!attribute [rw] description
    #   The description to assign to the Traffic Mirror session.
    #   @return [String]
    #
    # @!attribute [rw] remove_fields
    #   The properties that you want to remove from the Traffic Mirror
    #   session.
    #
    #   When you remove a property from a Traffic Mirror session, the
    #   property is set to the default.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyTrafficMirrorSessionRequest AWS API Documentation
    #
    class ModifyTrafficMirrorSessionRequest < Struct.new(
      :traffic_mirror_session_id,
      :traffic_mirror_target_id,
      :traffic_mirror_filter_id,
      :packet_length,
      :session_number,
      :virtual_network_id,
      :description,
      :remove_fields,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] traffic_mirror_session
    #   Information about the Traffic Mirror session.
    #   @return [Types::TrafficMirrorSession]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyTrafficMirrorSessionResult AWS API Documentation
    #
    class ModifyTrafficMirrorSessionResult < Struct.new(
      :traffic_mirror_session)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyTransitGatewayVpcAttachmentRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_attachment_id: "TransitGatewayAttachmentId", # required
    #         add_subnet_ids: ["SubnetId"],
    #         remove_subnet_ids: ["SubnetId"],
    #         options: {
    #           dns_support: "enable", # accepts enable, disable
    #           ipv_6_support: "enable", # accepts enable, disable
    #         },
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] add_subnet_ids
    #   The IDs of one or more subnets to add. You can specify at most one
    #   subnet per Availability Zone.
    #   @return [Array<String>]
    #
    # @!attribute [rw] remove_subnet_ids
    #   The IDs of one or more subnets to remove.
    #   @return [Array<String>]
    #
    # @!attribute [rw] options
    #   The new VPC attachment options.
    #
    #   <note markdown="1"> You cannot modify the IPv6 options.
    #
    #    </note>
    #   @return [Types::ModifyTransitGatewayVpcAttachmentRequestOptions]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyTransitGatewayVpcAttachmentRequest AWS API Documentation
    #
    class ModifyTransitGatewayVpcAttachmentRequest < Struct.new(
      :transit_gateway_attachment_id,
      :add_subnet_ids,
      :remove_subnet_ids,
      :options,
      :dry_run)
      include Aws::Structure
    end

    # Describes the options for a VPC attachment.
    #
    # @note When making an API call, you may pass ModifyTransitGatewayVpcAttachmentRequestOptions
    #   data as a hash:
    #
    #       {
    #         dns_support: "enable", # accepts enable, disable
    #         ipv_6_support: "enable", # accepts enable, disable
    #       }
    #
    # @!attribute [rw] dns_support
    #   Enable or disable DNS support. The default is `enable`.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_support
    #   Enable or disable IPv6 support. The default is `enable`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyTransitGatewayVpcAttachmentRequestOptions AWS API Documentation
    #
    class ModifyTransitGatewayVpcAttachmentRequestOptions < Struct.new(
      :dns_support,
      :ipv_6_support)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_vpc_attachment
    #   Information about the modified attachment.
    #   @return [Types::TransitGatewayVpcAttachment]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyTransitGatewayVpcAttachmentResult AWS API Documentation
    #
    class ModifyTransitGatewayVpcAttachmentResult < Struct.new(
      :transit_gateway_vpc_attachment)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyVolumeAttributeRequest
    #   data as a hash:
    #
    #       {
    #         auto_enable_io: {
    #           value: false,
    #         },
    #         volume_id: "VolumeId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] auto_enable_io
    #   Indicates whether the volume should be auto-enabled for I/O
    #   operations.
    #   @return [Types::AttributeBooleanValue]
    #
    # @!attribute [rw] volume_id
    #   The ID of the volume.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVolumeAttributeRequest AWS API Documentation
    #
    class ModifyVolumeAttributeRequest < Struct.new(
      :auto_enable_io,
      :volume_id,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyVolumeRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         volume_id: "VolumeId", # required
    #         size: 1,
    #         volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #         iops: 1,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] volume_id
    #   The ID of the volume.
    #   @return [String]
    #
    # @!attribute [rw] size
    #   The target size of the volume, in GiB. The target volume size must
    #   be greater than or equal to than the existing size of the volume.
    #   For information about available EBS volume sizes, see [Amazon EBS
    #   Volume Types][1].
    #
    #   Default: If no size is specified, the existing size is retained.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html
    #   @return [Integer]
    #
    # @!attribute [rw] volume_type
    #   The target EBS volume type of the volume.
    #
    #   Default: If no type is specified, the existing type is retained.
    #   @return [String]
    #
    # @!attribute [rw] iops
    #   The target IOPS rate of the volume.
    #
    #   This is only valid for Provisioned IOPS SSD (`io1`) volumes. For
    #   more information, see [Provisioned IOPS SSD (io1) Volumes][1].
    #
    #   Default: If no IOPS value is specified, the existing value is
    #   retained.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html#EBSVolumeTypes_piops
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVolumeRequest AWS API Documentation
    #
    class ModifyVolumeRequest < Struct.new(
      :dry_run,
      :volume_id,
      :size,
      :volume_type,
      :iops)
      include Aws::Structure
    end

    # @!attribute [rw] volume_modification
    #   Information about the volume modification.
    #   @return [Types::VolumeModification]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVolumeResult AWS API Documentation
    #
    class ModifyVolumeResult < Struct.new(
      :volume_modification)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyVpcAttributeRequest
    #   data as a hash:
    #
    #       {
    #         enable_dns_hostnames: {
    #           value: false,
    #         },
    #         enable_dns_support: {
    #           value: false,
    #         },
    #         vpc_id: "VpcId", # required
    #       }
    #
    # @!attribute [rw] enable_dns_hostnames
    #   Indicates whether the instances launched in the VPC get DNS
    #   hostnames. If enabled, instances in the VPC get DNS hostnames;
    #   otherwise, they do not.
    #
    #   You cannot modify the DNS resolution and DNS hostnames attributes in
    #   the same request. Use separate requests for each attribute. You can
    #   only enable DNS hostnames if you've enabled DNS support.
    #   @return [Types::AttributeBooleanValue]
    #
    # @!attribute [rw] enable_dns_support
    #   Indicates whether the DNS resolution is supported for the VPC. If
    #   enabled, queries to the Amazon provided DNS server at the
    #   169.254.169.253 IP address, or the reserved IP address at the base
    #   of the VPC network range "plus two" succeed. If disabled, the
    #   Amazon provided DNS service in the VPC that resolves public DNS
    #   hostnames to IP addresses is not enabled.
    #
    #   You cannot modify the DNS resolution and DNS hostnames attributes in
    #   the same request. Use separate requests for each attribute.
    #   @return [Types::AttributeBooleanValue]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpcAttributeRequest AWS API Documentation
    #
    class ModifyVpcAttributeRequest < Struct.new(
      :enable_dns_hostnames,
      :enable_dns_support,
      :vpc_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyVpcEndpointConnectionNotificationRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         connection_notification_id: "ConnectionNotificationId", # required
    #         connection_notification_arn: "String",
    #         connection_events: ["String"],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] connection_notification_id
    #   The ID of the notification.
    #   @return [String]
    #
    # @!attribute [rw] connection_notification_arn
    #   The ARN for the SNS topic for the notification.
    #   @return [String]
    #
    # @!attribute [rw] connection_events
    #   One or more events for the endpoint. Valid values are `Accept`,
    #   `Connect`, `Delete`, and `Reject`.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpcEndpointConnectionNotificationRequest AWS API Documentation
    #
    class ModifyVpcEndpointConnectionNotificationRequest < Struct.new(
      :dry_run,
      :connection_notification_id,
      :connection_notification_arn,
      :connection_events)
      include Aws::Structure
    end

    # @!attribute [rw] return_value
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpcEndpointConnectionNotificationResult AWS API Documentation
    #
    class ModifyVpcEndpointConnectionNotificationResult < Struct.new(
      :return_value)
      include Aws::Structure
    end

    # Contains the parameters for ModifyVpcEndpoint.
    #
    # @note When making an API call, you may pass ModifyVpcEndpointRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         vpc_endpoint_id: "VpcEndpointId", # required
    #         reset_policy: false,
    #         policy_document: "String",
    #         add_route_table_ids: ["RouteTableId"],
    #         remove_route_table_ids: ["RouteTableId"],
    #         add_subnet_ids: ["SubnetId"],
    #         remove_subnet_ids: ["SubnetId"],
    #         add_security_group_ids: ["SecurityGroupId"],
    #         remove_security_group_ids: ["SecurityGroupId"],
    #         private_dns_enabled: false,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] vpc_endpoint_id
    #   The ID of the endpoint.
    #   @return [String]
    #
    # @!attribute [rw] reset_policy
    #   (Gateway endpoint) Specify `true` to reset the policy document to
    #   the default policy. The default policy allows full access to the
    #   service.
    #   @return [Boolean]
    #
    # @!attribute [rw] policy_document
    #   A policy to attach to the endpoint that controls access to the
    #   service. The policy must be in valid JSON format.
    #   @return [String]
    #
    # @!attribute [rw] add_route_table_ids
    #   (Gateway endpoint) One or more route tables IDs to associate with
    #   the endpoint.
    #   @return [Array<String>]
    #
    # @!attribute [rw] remove_route_table_ids
    #   (Gateway endpoint) One or more route table IDs to disassociate from
    #   the endpoint.
    #   @return [Array<String>]
    #
    # @!attribute [rw] add_subnet_ids
    #   (Interface endpoint) One or more subnet IDs in which to serve the
    #   endpoint.
    #   @return [Array<String>]
    #
    # @!attribute [rw] remove_subnet_ids
    #   (Interface endpoint) One or more subnets IDs in which to remove the
    #   endpoint.
    #   @return [Array<String>]
    #
    # @!attribute [rw] add_security_group_ids
    #   (Interface endpoint) One or more security group IDs to associate
    #   with the network interface.
    #   @return [Array<String>]
    #
    # @!attribute [rw] remove_security_group_ids
    #   (Interface endpoint) One or more security group IDs to disassociate
    #   from the network interface.
    #   @return [Array<String>]
    #
    # @!attribute [rw] private_dns_enabled
    #   (Interface endpoint) Indicates whether a private hosted zone is
    #   associated with the VPC.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpcEndpointRequest AWS API Documentation
    #
    class ModifyVpcEndpointRequest < Struct.new(
      :dry_run,
      :vpc_endpoint_id,
      :reset_policy,
      :policy_document,
      :add_route_table_ids,
      :remove_route_table_ids,
      :add_subnet_ids,
      :remove_subnet_ids,
      :add_security_group_ids,
      :remove_security_group_ids,
      :private_dns_enabled)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpcEndpointResult AWS API Documentation
    #
    class ModifyVpcEndpointResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyVpcEndpointServiceConfigurationRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         service_id: "VpcEndpointServiceId", # required
    #         private_dns_name: "String",
    #         remove_private_dns_name: false,
    #         acceptance_required: false,
    #         add_network_load_balancer_arns: ["String"],
    #         remove_network_load_balancer_arns: ["String"],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] service_id
    #   The ID of the service.
    #   @return [String]
    #
    # @!attribute [rw] private_dns_name
    #   The private DNS name to assign to the endpoint service.
    #   @return [String]
    #
    # @!attribute [rw] remove_private_dns_name
    #   Removes the private DNS name of the endpoint service.
    #   @return [Boolean]
    #
    # @!attribute [rw] acceptance_required
    #   Indicates whether requests to create an endpoint to your service
    #   must be accepted.
    #   @return [Boolean]
    #
    # @!attribute [rw] add_network_load_balancer_arns
    #   The Amazon Resource Names (ARNs) of Network Load Balancers to add to
    #   your service configuration.
    #   @return [Array<String>]
    #
    # @!attribute [rw] remove_network_load_balancer_arns
    #   The Amazon Resource Names (ARNs) of Network Load Balancers to remove
    #   from your service configuration.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpcEndpointServiceConfigurationRequest AWS API Documentation
    #
    class ModifyVpcEndpointServiceConfigurationRequest < Struct.new(
      :dry_run,
      :service_id,
      :private_dns_name,
      :remove_private_dns_name,
      :acceptance_required,
      :add_network_load_balancer_arns,
      :remove_network_load_balancer_arns)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpcEndpointServiceConfigurationResult AWS API Documentation
    #
    class ModifyVpcEndpointServiceConfigurationResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyVpcEndpointServicePermissionsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         service_id: "VpcEndpointServiceId", # required
    #         add_allowed_principals: ["String"],
    #         remove_allowed_principals: ["String"],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] service_id
    #   The ID of the service.
    #   @return [String]
    #
    # @!attribute [rw] add_allowed_principals
    #   The Amazon Resource Names (ARN) of one or more principals.
    #   Permissions are granted to the principals in this list. To grant
    #   permissions to all principals, specify an asterisk (*).
    #   @return [Array<String>]
    #
    # @!attribute [rw] remove_allowed_principals
    #   The Amazon Resource Names (ARN) of one or more principals.
    #   Permissions are revoked for principals in this list.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpcEndpointServicePermissionsRequest AWS API Documentation
    #
    class ModifyVpcEndpointServicePermissionsRequest < Struct.new(
      :dry_run,
      :service_id,
      :add_allowed_principals,
      :remove_allowed_principals)
      include Aws::Structure
    end

    # @!attribute [rw] return_value
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpcEndpointServicePermissionsResult AWS API Documentation
    #
    class ModifyVpcEndpointServicePermissionsResult < Struct.new(
      :return_value)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyVpcPeeringConnectionOptionsRequest
    #   data as a hash:
    #
    #       {
    #         accepter_peering_connection_options: {
    #           allow_dns_resolution_from_remote_vpc: false,
    #           allow_egress_from_local_classic_link_to_remote_vpc: false,
    #           allow_egress_from_local_vpc_to_remote_classic_link: false,
    #         },
    #         dry_run: false,
    #         requester_peering_connection_options: {
    #           allow_dns_resolution_from_remote_vpc: false,
    #           allow_egress_from_local_classic_link_to_remote_vpc: false,
    #           allow_egress_from_local_vpc_to_remote_classic_link: false,
    #         },
    #         vpc_peering_connection_id: "VpcPeeringConnectionId", # required
    #       }
    #
    # @!attribute [rw] accepter_peering_connection_options
    #   The VPC peering connection options for the accepter VPC.
    #   @return [Types::PeeringConnectionOptionsRequest]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] requester_peering_connection_options
    #   The VPC peering connection options for the requester VPC.
    #   @return [Types::PeeringConnectionOptionsRequest]
    #
    # @!attribute [rw] vpc_peering_connection_id
    #   The ID of the VPC peering connection.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpcPeeringConnectionOptionsRequest AWS API Documentation
    #
    class ModifyVpcPeeringConnectionOptionsRequest < Struct.new(
      :accepter_peering_connection_options,
      :dry_run,
      :requester_peering_connection_options,
      :vpc_peering_connection_id)
      include Aws::Structure
    end

    # @!attribute [rw] accepter_peering_connection_options
    #   Information about the VPC peering connection options for the
    #   accepter VPC.
    #   @return [Types::PeeringConnectionOptions]
    #
    # @!attribute [rw] requester_peering_connection_options
    #   Information about the VPC peering connection options for the
    #   requester VPC.
    #   @return [Types::PeeringConnectionOptions]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpcPeeringConnectionOptionsResult AWS API Documentation
    #
    class ModifyVpcPeeringConnectionOptionsResult < Struct.new(
      :accepter_peering_connection_options,
      :requester_peering_connection_options)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyVpcTenancyRequest
    #   data as a hash:
    #
    #       {
    #         vpc_id: "VpcId", # required
    #         instance_tenancy: "default", # required, accepts default
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] instance_tenancy
    #   The instance tenancy attribute for the VPC.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpcTenancyRequest AWS API Documentation
    #
    class ModifyVpcTenancyRequest < Struct.new(
      :vpc_id,
      :instance_tenancy,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] return_value
    #   Returns `true` if the request succeeds; otherwise, returns an error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpcTenancyResult AWS API Documentation
    #
    class ModifyVpcTenancyResult < Struct.new(
      :return_value)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyVpnConnectionRequest
    #   data as a hash:
    #
    #       {
    #         vpn_connection_id: "VpnConnectionId", # required
    #         transit_gateway_id: "TransitGatewayId",
    #         customer_gateway_id: "CustomerGatewayId",
    #         vpn_gateway_id: "VpnGatewayId",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] vpn_connection_id
    #   The ID of the VPN connection.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] customer_gateway_id
    #   The ID of the customer gateway at your end of the VPN connection.
    #   @return [String]
    #
    # @!attribute [rw] vpn_gateway_id
    #   The ID of the virtual private gateway at the AWS side of the VPN
    #   connection.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpnConnectionRequest AWS API Documentation
    #
    class ModifyVpnConnectionRequest < Struct.new(
      :vpn_connection_id,
      :transit_gateway_id,
      :customer_gateway_id,
      :vpn_gateway_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] vpn_connection
    #   Describes a VPN connection.
    #   @return [Types::VpnConnection]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpnConnectionResult AWS API Documentation
    #
    class ModifyVpnConnectionResult < Struct.new(
      :vpn_connection)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyVpnTunnelCertificateRequest
    #   data as a hash:
    #
    #       {
    #         vpn_connection_id: "VpnConnectionId", # required
    #         vpn_tunnel_outside_ip_address: "String", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] vpn_connection_id
    #   The ID of the AWS Site-to-Site VPN connection.
    #   @return [String]
    #
    # @!attribute [rw] vpn_tunnel_outside_ip_address
    #   The external IP address of the VPN tunnel.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpnTunnelCertificateRequest AWS API Documentation
    #
    class ModifyVpnTunnelCertificateRequest < Struct.new(
      :vpn_connection_id,
      :vpn_tunnel_outside_ip_address,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] vpn_connection
    #   Describes a VPN connection.
    #   @return [Types::VpnConnection]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpnTunnelCertificateResult AWS API Documentation
    #
    class ModifyVpnTunnelCertificateResult < Struct.new(
      :vpn_connection)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ModifyVpnTunnelOptionsRequest
    #   data as a hash:
    #
    #       {
    #         vpn_connection_id: "VpnConnectionId", # required
    #         vpn_tunnel_outside_ip_address: "String", # required
    #         tunnel_options: { # required
    #           tunnel_inside_cidr: "String",
    #           pre_shared_key: "String",
    #           phase_1_lifetime_seconds: 1,
    #           phase_2_lifetime_seconds: 1,
    #           rekey_margin_time_seconds: 1,
    #           rekey_fuzz_percentage: 1,
    #           replay_window_size: 1,
    #           dpd_timeout_seconds: 1,
    #           phase_1_encryption_algorithms: [
    #             {
    #               value: "String",
    #             },
    #           ],
    #           phase_2_encryption_algorithms: [
    #             {
    #               value: "String",
    #             },
    #           ],
    #           phase_1_integrity_algorithms: [
    #             {
    #               value: "String",
    #             },
    #           ],
    #           phase_2_integrity_algorithms: [
    #             {
    #               value: "String",
    #             },
    #           ],
    #           phase_1_dh_group_numbers: [
    #             {
    #               value: 1,
    #             },
    #           ],
    #           phase_2_dh_group_numbers: [
    #             {
    #               value: 1,
    #             },
    #           ],
    #           ike_versions: [
    #             {
    #               value: "String",
    #             },
    #           ],
    #         },
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] vpn_connection_id
    #   The ID of the AWS Site-to-Site VPN connection.
    #   @return [String]
    #
    # @!attribute [rw] vpn_tunnel_outside_ip_address
    #   The external IP address of the VPN tunnel.
    #   @return [String]
    #
    # @!attribute [rw] tunnel_options
    #   The tunnel options to modify.
    #   @return [Types::ModifyVpnTunnelOptionsSpecification]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpnTunnelOptionsRequest AWS API Documentation
    #
    class ModifyVpnTunnelOptionsRequest < Struct.new(
      :vpn_connection_id,
      :vpn_tunnel_outside_ip_address,
      :tunnel_options,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] vpn_connection
    #   Describes a VPN connection.
    #   @return [Types::VpnConnection]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpnTunnelOptionsResult AWS API Documentation
    #
    class ModifyVpnTunnelOptionsResult < Struct.new(
      :vpn_connection)
      include Aws::Structure
    end

    # The AWS Site-to-Site VPN tunnel options to modify.
    #
    # @note When making an API call, you may pass ModifyVpnTunnelOptionsSpecification
    #   data as a hash:
    #
    #       {
    #         tunnel_inside_cidr: "String",
    #         pre_shared_key: "String",
    #         phase_1_lifetime_seconds: 1,
    #         phase_2_lifetime_seconds: 1,
    #         rekey_margin_time_seconds: 1,
    #         rekey_fuzz_percentage: 1,
    #         replay_window_size: 1,
    #         dpd_timeout_seconds: 1,
    #         phase_1_encryption_algorithms: [
    #           {
    #             value: "String",
    #           },
    #         ],
    #         phase_2_encryption_algorithms: [
    #           {
    #             value: "String",
    #           },
    #         ],
    #         phase_1_integrity_algorithms: [
    #           {
    #             value: "String",
    #           },
    #         ],
    #         phase_2_integrity_algorithms: [
    #           {
    #             value: "String",
    #           },
    #         ],
    #         phase_1_dh_group_numbers: [
    #           {
    #             value: 1,
    #           },
    #         ],
    #         phase_2_dh_group_numbers: [
    #           {
    #             value: 1,
    #           },
    #         ],
    #         ike_versions: [
    #           {
    #             value: "String",
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] tunnel_inside_cidr
    #   The range of inside IP addresses for the tunnel. Any specified CIDR
    #   blocks must be unique across all VPN connections that use the same
    #   virtual private gateway.
    #
    #   Constraints: A size /30 CIDR block from the `169.254.0.0/16` range.
    #   The following CIDR blocks are reserved and cannot be used:
    #
    #   * `169.254.0.0/30`
    #
    #   * `169.254.1.0/30`
    #
    #   * `169.254.2.0/30`
    #
    #   * `169.254.3.0/30`
    #
    #   * `169.254.4.0/30`
    #
    #   * `169.254.5.0/30`
    #
    #   * `169.254.169.252/30`
    #   @return [String]
    #
    # @!attribute [rw] pre_shared_key
    #   The pre-shared key (PSK) to establish initial authentication between
    #   the virtual private gateway and the customer gateway.
    #
    #   Constraints: Allowed characters are alphanumeric characters, periods
    #   (.), and underscores (\_). Must be between 8 and 64 characters in
    #   length and cannot start with zero (0).
    #   @return [String]
    #
    # @!attribute [rw] phase_1_lifetime_seconds
    #   The lifetime for phase 1 of the IKE negotiation, in seconds.
    #
    #   Constraints: A value between 900 and 28,800.
    #
    #   Default: `28800`
    #   @return [Integer]
    #
    # @!attribute [rw] phase_2_lifetime_seconds
    #   The lifetime for phase 2 of the IKE negotiation, in seconds.
    #
    #   Constraints: A value between 900 and 3,600. The value must be less
    #   than the value for `Phase1LifetimeSeconds`.
    #
    #   Default: `3600`
    #   @return [Integer]
    #
    # @!attribute [rw] rekey_margin_time_seconds
    #   The margin time, in seconds, before the phase 2 lifetime expires,
    #   during which the AWS side of the VPN connection performs an IKE
    #   rekey. The exact time of the rekey is randomly selected based on the
    #   value for `RekeyFuzzPercentage`.
    #
    #   Constraints: A value between 60 and half of `Phase2LifetimeSeconds`.
    #
    #   Default: `540`
    #   @return [Integer]
    #
    # @!attribute [rw] rekey_fuzz_percentage
    #   The percentage of the rekey window (determined by
    #   `RekeyMarginTimeSeconds`) during which the rekey time is randomly
    #   selected.
    #
    #   Constraints: A value between 0 and 100.
    #
    #   Default: `100`
    #   @return [Integer]
    #
    # @!attribute [rw] replay_window_size
    #   The number of packets in an IKE replay window.
    #
    #   Constraints: A value between 64 and 2048.
    #
    #   Default: `1024`
    #   @return [Integer]
    #
    # @!attribute [rw] dpd_timeout_seconds
    #   The number of seconds after which a DPD timeout occurs.
    #
    #   Constraints: A value between 0 and 30.
    #
    #   Default: `30`
    #   @return [Integer]
    #
    # @!attribute [rw] phase_1_encryption_algorithms
    #   One or more encryption algorithms that are permitted for the VPN
    #   tunnel for phase 1 IKE negotiations.
    #
    #   Valid values: `AES128` \| `AES256`
    #   @return [Array<Types::Phase1EncryptionAlgorithmsRequestListValue>]
    #
    # @!attribute [rw] phase_2_encryption_algorithms
    #   One or more encryption algorithms that are permitted for the VPN
    #   tunnel for phase 2 IKE negotiations.
    #
    #   Valid values: `AES128` \| `AES256`
    #   @return [Array<Types::Phase2EncryptionAlgorithmsRequestListValue>]
    #
    # @!attribute [rw] phase_1_integrity_algorithms
    #   One or more integrity algorithms that are permitted for the VPN
    #   tunnel for phase 1 IKE negotiations.
    #
    #   Valid values: `SHA1` \| `SHA2-256`
    #   @return [Array<Types::Phase1IntegrityAlgorithmsRequestListValue>]
    #
    # @!attribute [rw] phase_2_integrity_algorithms
    #   One or more integrity algorithms that are permitted for the VPN
    #   tunnel for phase 2 IKE negotiations.
    #
    #   Valid values: `SHA1` \| `SHA2-256`
    #   @return [Array<Types::Phase2IntegrityAlgorithmsRequestListValue>]
    #
    # @!attribute [rw] phase_1_dh_group_numbers
    #   One or more Diffie-Hellman group numbers that are permitted for the
    #   VPN tunnel for phase 1 IKE negotiations.
    #
    #   Valid values: `2` \| `14` \| `15` \| `16` \| `17` \| `18` \| `22` \|
    #   `23` \| `24`
    #   @return [Array<Types::Phase1DHGroupNumbersRequestListValue>]
    #
    # @!attribute [rw] phase_2_dh_group_numbers
    #   One or more Diffie-Hellman group numbers that are permitted for the
    #   VPN tunnel for phase 2 IKE negotiations.
    #
    #   Valid values: `2` \| `5` \| `14` \| `15` \| `16` \| `17` \| `18` \|
    #   `22` \| `23` \| `24`
    #   @return [Array<Types::Phase2DHGroupNumbersRequestListValue>]
    #
    # @!attribute [rw] ike_versions
    #   The IKE versions that are permitted for the VPN tunnel.
    #
    #   Valid values: `ikev1` \| `ikev2`
    #   @return [Array<Types::IKEVersionsRequestListValue>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ModifyVpnTunnelOptionsSpecification AWS API Documentation
    #
    class ModifyVpnTunnelOptionsSpecification < Struct.new(
      :tunnel_inside_cidr,
      :pre_shared_key,
      :phase_1_lifetime_seconds,
      :phase_2_lifetime_seconds,
      :rekey_margin_time_seconds,
      :rekey_fuzz_percentage,
      :replay_window_size,
      :dpd_timeout_seconds,
      :phase_1_encryption_algorithms,
      :phase_2_encryption_algorithms,
      :phase_1_integrity_algorithms,
      :phase_2_integrity_algorithms,
      :phase_1_dh_group_numbers,
      :phase_2_dh_group_numbers,
      :ike_versions)
      include Aws::Structure
    end

    # @note When making an API call, you may pass MonitorInstancesRequest
    #   data as a hash:
    #
    #       {
    #         instance_ids: ["InstanceId"], # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] instance_ids
    #   The IDs of the instances.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/MonitorInstancesRequest AWS API Documentation
    #
    class MonitorInstancesRequest < Struct.new(
      :instance_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] instance_monitorings
    #   The monitoring information.
    #   @return [Array<Types::InstanceMonitoring>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/MonitorInstancesResult AWS API Documentation
    #
    class MonitorInstancesResult < Struct.new(
      :instance_monitorings)
      include Aws::Structure
    end

    # Describes the monitoring of an instance.
    #
    # @!attribute [rw] state
    #   Indicates whether detailed monitoring is enabled. Otherwise, basic
    #   monitoring is enabled.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Monitoring AWS API Documentation
    #
    class Monitoring < Struct.new(
      :state)
      include Aws::Structure
    end

    # @note When making an API call, you may pass MoveAddressToVpcRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         public_ip: "String", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] public_ip
    #   The Elastic IP address.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/MoveAddressToVpcRequest AWS API Documentation
    #
    class MoveAddressToVpcRequest < Struct.new(
      :dry_run,
      :public_ip)
      include Aws::Structure
    end

    # @!attribute [rw] allocation_id
    #   The allocation ID for the Elastic IP address.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The status of the move of the IP address.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/MoveAddressToVpcResult AWS API Documentation
    #
    class MoveAddressToVpcResult < Struct.new(
      :allocation_id,
      :status)
      include Aws::Structure
    end

    # Describes the status of a moving Elastic IP address.
    #
    # @!attribute [rw] move_status
    #   The status of the Elastic IP address that's being moved to the
    #   EC2-VPC platform, or restored to the EC2-Classic platform.
    #   @return [String]
    #
    # @!attribute [rw] public_ip
    #   The Elastic IP address.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/MovingAddressStatus AWS API Documentation
    #
    class MovingAddressStatus < Struct.new(
      :move_status,
      :public_ip)
      include Aws::Structure
    end

    # Describes a NAT gateway.
    #
    # @!attribute [rw] create_time
    #   The date and time the NAT gateway was created.
    #   @return [Time]
    #
    # @!attribute [rw] delete_time
    #   The date and time the NAT gateway was deleted, if applicable.
    #   @return [Time]
    #
    # @!attribute [rw] failure_code
    #   If the NAT gateway could not be created, specifies the error code
    #   for the failure. (`InsufficientFreeAddressesInSubnet` \|
    #   `Gateway.NotAttached` \| `InvalidAllocationID.NotFound` \|
    #   `Resource.AlreadyAssociated` \| `InternalError` \|
    #   `InvalidSubnetID.NotFound`)
    #   @return [String]
    #
    # @!attribute [rw] failure_message
    #   If the NAT gateway could not be created, specifies the error message
    #   for the failure, that corresponds to the error code.
    #
    #   * For InsufficientFreeAddressesInSubnet: "Subnet has insufficient
    #     free addresses to create this NAT gateway"
    #
    #   * For Gateway.NotAttached: "Network vpc-xxxxxxxx has no Internet
    #     gateway attached"
    #
    #   * For InvalidAllocationID.NotFound: "Elastic IP address
    #     eipalloc-xxxxxxxx could not be associated with this NAT gateway"
    #
    #   * For Resource.AlreadyAssociated: "Elastic IP address
    #     eipalloc-xxxxxxxx is already associated"
    #
    #   * For InternalError: "Network interface eni-xxxxxxxx, created and
    #     used internally by this NAT gateway is in an invalid state. Please
    #     try again."
    #
    #   * For InvalidSubnetID.NotFound: "The specified subnet
    #     subnet-xxxxxxxx does not exist or could not be found."
    #   @return [String]
    #
    # @!attribute [rw] nat_gateway_addresses
    #   Information about the IP addresses and network interface associated
    #   with the NAT gateway.
    #   @return [Array<Types::NatGatewayAddress>]
    #
    # @!attribute [rw] nat_gateway_id
    #   The ID of the NAT gateway.
    #   @return [String]
    #
    # @!attribute [rw] provisioned_bandwidth
    #   Reserved. If you need to sustain traffic greater than the
    #   [documented limits][1], contact us through the [Support Center][2].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html
    #   [2]: https://console.aws.amazon.com/support/home?
    #   @return [Types::ProvisionedBandwidth]
    #
    # @!attribute [rw] state
    #   The state of the NAT gateway.
    #
    #   * `pending`\: The NAT gateway is being created and is not ready to
    #     process traffic.
    #
    #   * `failed`\: The NAT gateway could not be created. Check the
    #     `failureCode` and `failureMessage` fields for the reason.
    #
    #   * `available`\: The NAT gateway is able to process traffic. This
    #     status remains until you delete the NAT gateway, and does not
    #     indicate the health of the NAT gateway.
    #
    #   * `deleting`\: The NAT gateway is in the process of being terminated
    #     and may still be processing traffic.
    #
    #   * `deleted`\: The NAT gateway has been terminated and is no longer
    #     processing traffic.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet in which the NAT gateway is located.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC in which the NAT gateway is located.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags for the NAT gateway.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/NatGateway AWS API Documentation
    #
    class NatGateway < Struct.new(
      :create_time,
      :delete_time,
      :failure_code,
      :failure_message,
      :nat_gateway_addresses,
      :nat_gateway_id,
      :provisioned_bandwidth,
      :state,
      :subnet_id,
      :vpc_id,
      :tags)
      include Aws::Structure
    end

    # Describes the IP addresses and network interface associated with a NAT
    # gateway.
    #
    # @!attribute [rw] allocation_id
    #   The allocation ID of the Elastic IP address that's associated with
    #   the NAT gateway.
    #   @return [String]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface associated with the NAT gateway.
    #   @return [String]
    #
    # @!attribute [rw] private_ip
    #   The private IP address associated with the Elastic IP address.
    #   @return [String]
    #
    # @!attribute [rw] public_ip
    #   The Elastic IP address associated with the NAT gateway.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/NatGatewayAddress AWS API Documentation
    #
    class NatGatewayAddress < Struct.new(
      :allocation_id,
      :network_interface_id,
      :private_ip,
      :public_ip)
      include Aws::Structure
    end

    # Describes a network ACL.
    #
    # @!attribute [rw] associations
    #   Any associations between the network ACL and one or more subnets
    #   @return [Array<Types::NetworkAclAssociation>]
    #
    # @!attribute [rw] entries
    #   One or more entries (rules) in the network ACL.
    #   @return [Array<Types::NetworkAclEntry>]
    #
    # @!attribute [rw] is_default
    #   Indicates whether this is the default network ACL for the VPC.
    #   @return [Boolean]
    #
    # @!attribute [rw] network_acl_id
    #   The ID of the network ACL.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the network ACL.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC for the network ACL.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account that owns the network ACL.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/NetworkAcl AWS API Documentation
    #
    class NetworkAcl < Struct.new(
      :associations,
      :entries,
      :is_default,
      :network_acl_id,
      :tags,
      :vpc_id,
      :owner_id)
      include Aws::Structure
    end

    # Describes an association between a network ACL and a subnet.
    #
    # @!attribute [rw] network_acl_association_id
    #   The ID of the association between a network ACL and a subnet.
    #   @return [String]
    #
    # @!attribute [rw] network_acl_id
    #   The ID of the network ACL.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/NetworkAclAssociation AWS API Documentation
    #
    class NetworkAclAssociation < Struct.new(
      :network_acl_association_id,
      :network_acl_id,
      :subnet_id)
      include Aws::Structure
    end

    # Describes an entry in a network ACL.
    #
    # @!attribute [rw] cidr_block
    #   The IPv4 network range to allow or deny, in CIDR notation.
    #   @return [String]
    #
    # @!attribute [rw] egress
    #   Indicates whether the rule is an egress rule (applied to traffic
    #   leaving the subnet).
    #   @return [Boolean]
    #
    # @!attribute [rw] icmp_type_code
    #   ICMP protocol: The ICMP type and code.
    #   @return [Types::IcmpTypeCode]
    #
    # @!attribute [rw] ipv_6_cidr_block
    #   The IPv6 network range to allow or deny, in CIDR notation.
    #   @return [String]
    #
    # @!attribute [rw] port_range
    #   TCP or UDP protocols: The range of ports the rule applies to.
    #   @return [Types::PortRange]
    #
    # @!attribute [rw] protocol
    #   The protocol number. A value of "-1" means all protocols.
    #   @return [String]
    #
    # @!attribute [rw] rule_action
    #   Indicates whether to allow or deny the traffic that matches the
    #   rule.
    #   @return [String]
    #
    # @!attribute [rw] rule_number
    #   The rule number for the entry. ACL entries are processed in
    #   ascending order by rule number.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/NetworkAclEntry AWS API Documentation
    #
    class NetworkAclEntry < Struct.new(
      :cidr_block,
      :egress,
      :icmp_type_code,
      :ipv_6_cidr_block,
      :port_range,
      :protocol,
      :rule_action,
      :rule_number)
      include Aws::Structure
    end

    # Describes the networking features of the instance type.
    #
    # @!attribute [rw] network_performance
    #   Describes the network performance.
    #   @return [String]
    #
    # @!attribute [rw] maximum_network_interfaces
    #   The maximum number of network interfaces for the instance type.
    #   @return [Integer]
    #
    # @!attribute [rw] ipv_4_addresses_per_interface
    #   The maximum number of IPv4 addresses per network interface.
    #   @return [Integer]
    #
    # @!attribute [rw] ipv_6_addresses_per_interface
    #   The maximum number of IPv6 addresses per network interface.
    #   @return [Integer]
    #
    # @!attribute [rw] ipv_6_supported
    #   Indicates whether IPv6 is supported.
    #   @return [Boolean]
    #
    # @!attribute [rw] ena_support
    #   Indicates whether Elastic Network Adapter (ENA) is supported.
    #   @return [String]
    #
    # @!attribute [rw] efa_supported
    #   Indicates whether Elastic Fabric Adapter (EFA) is supported.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/NetworkInfo AWS API Documentation
    #
    class NetworkInfo < Struct.new(
      :network_performance,
      :maximum_network_interfaces,
      :ipv_4_addresses_per_interface,
      :ipv_6_addresses_per_interface,
      :ipv_6_supported,
      :ena_support,
      :efa_supported)
      include Aws::Structure
    end

    # Describes a network interface.
    #
    # @!attribute [rw] association
    #   The association information for an Elastic IP address (IPv4)
    #   associated with the network interface.
    #   @return [Types::NetworkInterfaceAssociation]
    #
    # @!attribute [rw] attachment
    #   The network interface attachment.
    #   @return [Types::NetworkInterfaceAttachment]
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   A description.
    #   @return [String]
    #
    # @!attribute [rw] groups
    #   Any security groups for the network interface.
    #   @return [Array<Types::GroupIdentifier>]
    #
    # @!attribute [rw] interface_type
    #   The type of network interface.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_addresses
    #   The IPv6 addresses associated with the network interface.
    #   @return [Array<Types::NetworkInterfaceIpv6Address>]
    #
    # @!attribute [rw] mac_address
    #   The MAC address.
    #   @return [String]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] outpost_arn
    #   The Amazon Resource Name (ARN) of the Outpost.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The AWS account ID of the owner of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] private_dns_name
    #   The private DNS name.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_address
    #   The IPv4 address of the network interface within the subnet.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_addresses
    #   The private IPv4 addresses associated with the network interface.
    #   @return [Array<Types::NetworkInterfacePrivateIpAddress>]
    #
    # @!attribute [rw] requester_id
    #   The ID of the entity that launched the instance on your behalf (for
    #   example, AWS Management Console or Auto Scaling).
    #   @return [String]
    #
    # @!attribute [rw] requester_managed
    #   Indicates whether the network interface is being managed by AWS.
    #   @return [Boolean]
    #
    # @!attribute [rw] source_dest_check
    #   Indicates whether traffic to or from the instance is validated.
    #   @return [Boolean]
    #
    # @!attribute [rw] status
    #   The status of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet.
    #   @return [String]
    #
    # @!attribute [rw] tag_set
    #   Any tags assigned to the network interface.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/NetworkInterface AWS API Documentation
    #
    class NetworkInterface < Struct.new(
      :association,
      :attachment,
      :availability_zone,
      :description,
      :groups,
      :interface_type,
      :ipv_6_addresses,
      :mac_address,
      :network_interface_id,
      :outpost_arn,
      :owner_id,
      :private_dns_name,
      :private_ip_address,
      :private_ip_addresses,
      :requester_id,
      :requester_managed,
      :source_dest_check,
      :status,
      :subnet_id,
      :tag_set,
      :vpc_id)
      include Aws::Structure
    end

    # Describes association information for an Elastic IP address (IPv4
    # only).
    #
    # @!attribute [rw] allocation_id
    #   The allocation ID.
    #   @return [String]
    #
    # @!attribute [rw] association_id
    #   The association ID.
    #   @return [String]
    #
    # @!attribute [rw] ip_owner_id
    #   The ID of the Elastic IP address owner.
    #   @return [String]
    #
    # @!attribute [rw] public_dns_name
    #   The public DNS name.
    #   @return [String]
    #
    # @!attribute [rw] public_ip
    #   The address of the Elastic IP address bound to the network
    #   interface.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/NetworkInterfaceAssociation AWS API Documentation
    #
    class NetworkInterfaceAssociation < Struct.new(
      :allocation_id,
      :association_id,
      :ip_owner_id,
      :public_dns_name,
      :public_ip)
      include Aws::Structure
    end

    # Describes a network interface attachment.
    #
    # @!attribute [rw] attach_time
    #   The timestamp indicating when the attachment initiated.
    #   @return [Time]
    #
    # @!attribute [rw] attachment_id
    #   The ID of the network interface attachment.
    #   @return [String]
    #
    # @!attribute [rw] delete_on_termination
    #   Indicates whether the network interface is deleted when the instance
    #   is terminated.
    #   @return [Boolean]
    #
    # @!attribute [rw] device_index
    #   The device index of the network interface attachment on the
    #   instance.
    #   @return [Integer]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] instance_owner_id
    #   The AWS account ID of the owner of the instance.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The attachment state.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/NetworkInterfaceAttachment AWS API Documentation
    #
    class NetworkInterfaceAttachment < Struct.new(
      :attach_time,
      :attachment_id,
      :delete_on_termination,
      :device_index,
      :instance_id,
      :instance_owner_id,
      :status)
      include Aws::Structure
    end

    # Describes an attachment change.
    #
    # @note When making an API call, you may pass NetworkInterfaceAttachmentChanges
    #   data as a hash:
    #
    #       {
    #         attachment_id: "NetworkInterfaceAttachmentId",
    #         delete_on_termination: false,
    #       }
    #
    # @!attribute [rw] attachment_id
    #   The ID of the network interface attachment.
    #   @return [String]
    #
    # @!attribute [rw] delete_on_termination
    #   Indicates whether the network interface is deleted when the instance
    #   is terminated.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/NetworkInterfaceAttachmentChanges AWS API Documentation
    #
    class NetworkInterfaceAttachmentChanges < Struct.new(
      :attachment_id,
      :delete_on_termination)
      include Aws::Structure
    end

    # Describes an IPv6 address associated with a network interface.
    #
    # @!attribute [rw] ipv_6_address
    #   The IPv6 address.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/NetworkInterfaceIpv6Address AWS API Documentation
    #
    class NetworkInterfaceIpv6Address < Struct.new(
      :ipv_6_address)
      include Aws::Structure
    end

    # Describes a permission for a network interface.
    #
    # @!attribute [rw] network_interface_permission_id
    #   The ID of the network interface permission.
    #   @return [String]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] aws_account_id
    #   The AWS account ID.
    #   @return [String]
    #
    # @!attribute [rw] aws_service
    #   The AWS service.
    #   @return [String]
    #
    # @!attribute [rw] permission
    #   The type of permission.
    #   @return [String]
    #
    # @!attribute [rw] permission_state
    #   Information about the state of the permission.
    #   @return [Types::NetworkInterfacePermissionState]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/NetworkInterfacePermission AWS API Documentation
    #
    class NetworkInterfacePermission < Struct.new(
      :network_interface_permission_id,
      :network_interface_id,
      :aws_account_id,
      :aws_service,
      :permission,
      :permission_state)
      include Aws::Structure
    end

    # Describes the state of a network interface permission.
    #
    # @!attribute [rw] state
    #   The state of the permission.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   A status message, if applicable.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/NetworkInterfacePermissionState AWS API Documentation
    #
    class NetworkInterfacePermissionState < Struct.new(
      :state,
      :status_message)
      include Aws::Structure
    end

    # Describes the private IPv4 address of a network interface.
    #
    # @!attribute [rw] association
    #   The association information for an Elastic IP address (IPv4)
    #   associated with the network interface.
    #   @return [Types::NetworkInterfaceAssociation]
    #
    # @!attribute [rw] primary
    #   Indicates whether this IPv4 address is the primary private IPv4
    #   address of the network interface.
    #   @return [Boolean]
    #
    # @!attribute [rw] private_dns_name
    #   The private DNS name.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_address
    #   The private IPv4 address.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/NetworkInterfacePrivateIpAddress AWS API Documentation
    #
    class NetworkInterfacePrivateIpAddress < Struct.new(
      :association,
      :primary,
      :private_dns_name,
      :private_ip_address)
      include Aws::Structure
    end

    # @note When making an API call, you may pass NewDhcpConfiguration
    #   data as a hash:
    #
    #       {
    #         key: "String",
    #         values: ["String"],
    #       }
    #
    # @!attribute [rw] key
    #   @return [String]
    #
    # @!attribute [rw] values
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/NewDhcpConfiguration AWS API Documentation
    #
    class NewDhcpConfiguration < Struct.new(
      :key,
      :values)
      include Aws::Structure
    end

    # Describes the configuration of On-Demand Instances in an EC2 Fleet.
    #
    # @!attribute [rw] allocation_strategy
    #   The order of the launch template overrides to use in fulfilling
    #   On-Demand capacity. If you specify `lowest-price`, EC2 Fleet uses
    #   price to determine the order, launching the lowest price first. If
    #   you specify `prioritized`, EC2 Fleet uses the priority that you
    #   assigned to each launch template override, launching the highest
    #   priority first. If you do not specify a value, EC2 Fleet defaults to
    #   `lowest-price`.
    #   @return [String]
    #
    # @!attribute [rw] capacity_reservation_options
    #   The strategy for using unused Capacity Reservations for fulfilling
    #   On-Demand capacity. Supported only for fleets of type `instant`.
    #   @return [Types::CapacityReservationOptions]
    #
    # @!attribute [rw] single_instance_type
    #   Indicates that the fleet uses a single instance type to launch all
    #   On-Demand Instances in the fleet. Supported only for fleets of type
    #   `instant`.
    #   @return [Boolean]
    #
    # @!attribute [rw] single_availability_zone
    #   Indicates that the fleet launches all On-Demand Instances into a
    #   single Availability Zone. Supported only for fleets of type
    #   `instant`.
    #   @return [Boolean]
    #
    # @!attribute [rw] min_target_capacity
    #   The minimum target capacity for On-Demand Instances in the fleet. If
    #   the minimum target capacity is not reached, the fleet launches no
    #   instances.
    #   @return [Integer]
    #
    # @!attribute [rw] max_total_price
    #   The maximum amount per hour for On-Demand Instances that you're
    #   willing to pay.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/OnDemandOptions AWS API Documentation
    #
    class OnDemandOptions < Struct.new(
      :allocation_strategy,
      :capacity_reservation_options,
      :single_instance_type,
      :single_availability_zone,
      :min_target_capacity,
      :max_total_price)
      include Aws::Structure
    end

    # Describes the configuration of On-Demand Instances in an EC2 Fleet.
    #
    # @note When making an API call, you may pass OnDemandOptionsRequest
    #   data as a hash:
    #
    #       {
    #         allocation_strategy: "lowest-price", # accepts lowest-price, prioritized
    #         capacity_reservation_options: {
    #           usage_strategy: "use-capacity-reservations-first", # accepts use-capacity-reservations-first
    #         },
    #         single_instance_type: false,
    #         single_availability_zone: false,
    #         min_target_capacity: 1,
    #         max_total_price: "String",
    #       }
    #
    # @!attribute [rw] allocation_strategy
    #   The order of the launch template overrides to use in fulfilling
    #   On-Demand capacity. If you specify `lowest-price`, EC2 Fleet uses
    #   price to determine the order, launching the lowest price first. If
    #   you specify `prioritized`, EC2 Fleet uses the priority that you
    #   assigned to each launch template override, launching the highest
    #   priority first. If you do not specify a value, EC2 Fleet defaults to
    #   `lowest-price`.
    #   @return [String]
    #
    # @!attribute [rw] capacity_reservation_options
    #   The strategy for using unused Capacity Reservations for fulfilling
    #   On-Demand capacity. Supported only for fleets of type `instant`.
    #   @return [Types::CapacityReservationOptionsRequest]
    #
    # @!attribute [rw] single_instance_type
    #   Indicates that the fleet uses a single instance type to launch all
    #   On-Demand Instances in the fleet. Supported only for fleets of type
    #   `instant`.
    #   @return [Boolean]
    #
    # @!attribute [rw] single_availability_zone
    #   Indicates that the fleet launches all On-Demand Instances into a
    #   single Availability Zone. Supported only for fleets of type
    #   `instant`.
    #   @return [Boolean]
    #
    # @!attribute [rw] min_target_capacity
    #   The minimum target capacity for On-Demand Instances in the fleet. If
    #   the minimum target capacity is not reached, the fleet launches no
    #   instances.
    #   @return [Integer]
    #
    # @!attribute [rw] max_total_price
    #   The maximum amount per hour for On-Demand Instances that you're
    #   willing to pay.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/OnDemandOptionsRequest AWS API Documentation
    #
    class OnDemandOptionsRequest < Struct.new(
      :allocation_strategy,
      :capacity_reservation_options,
      :single_instance_type,
      :single_availability_zone,
      :min_target_capacity,
      :max_total_price)
      include Aws::Structure
    end

    # Describes the data that identifies an Amazon FPGA image (AFI) on the
    # PCI bus.
    #
    # @!attribute [rw] device_id
    #   The ID of the device.
    #   @return [String]
    #
    # @!attribute [rw] vendor_id
    #   The ID of the vendor.
    #   @return [String]
    #
    # @!attribute [rw] subsystem_id
    #   The ID of the subsystem.
    #   @return [String]
    #
    # @!attribute [rw] subsystem_vendor_id
    #   The ID of the vendor for the subsystem.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PciId AWS API Documentation
    #
    class PciId < Struct.new(
      :device_id,
      :vendor_id,
      :subsystem_id,
      :subsystem_vendor_id)
      include Aws::Structure
    end

    # The status of the transit gateway peering attachment.
    #
    # @!attribute [rw] code
    #   The status code.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   The status message, if applicable.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PeeringAttachmentStatus AWS API Documentation
    #
    class PeeringAttachmentStatus < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # Describes the VPC peering connection options.
    #
    # @!attribute [rw] allow_dns_resolution_from_remote_vpc
    #   If true, the public DNS hostnames of instances in the specified VPC
    #   resolve to private IP addresses when queried from instances in the
    #   peer VPC.
    #   @return [Boolean]
    #
    # @!attribute [rw] allow_egress_from_local_classic_link_to_remote_vpc
    #   If true, enables outbound communication from an EC2-Classic instance
    #   that's linked to a local VPC using ClassicLink to instances in a
    #   peer VPC.
    #   @return [Boolean]
    #
    # @!attribute [rw] allow_egress_from_local_vpc_to_remote_classic_link
    #   If true, enables outbound communication from instances in a local
    #   VPC to an EC2-Classic instance that's linked to a peer VPC using
    #   ClassicLink.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PeeringConnectionOptions AWS API Documentation
    #
    class PeeringConnectionOptions < Struct.new(
      :allow_dns_resolution_from_remote_vpc,
      :allow_egress_from_local_classic_link_to_remote_vpc,
      :allow_egress_from_local_vpc_to_remote_classic_link)
      include Aws::Structure
    end

    # The VPC peering connection options.
    #
    # @note When making an API call, you may pass PeeringConnectionOptionsRequest
    #   data as a hash:
    #
    #       {
    #         allow_dns_resolution_from_remote_vpc: false,
    #         allow_egress_from_local_classic_link_to_remote_vpc: false,
    #         allow_egress_from_local_vpc_to_remote_classic_link: false,
    #       }
    #
    # @!attribute [rw] allow_dns_resolution_from_remote_vpc
    #   If true, enables a local VPC to resolve public DNS hostnames to
    #   private IP addresses when queried from instances in the peer VPC.
    #   @return [Boolean]
    #
    # @!attribute [rw] allow_egress_from_local_classic_link_to_remote_vpc
    #   If true, enables outbound communication from an EC2-Classic instance
    #   that's linked to a local VPC using ClassicLink to instances in a
    #   peer VPC.
    #   @return [Boolean]
    #
    # @!attribute [rw] allow_egress_from_local_vpc_to_remote_classic_link
    #   If true, enables outbound communication from instances in a local
    #   VPC to an EC2-Classic instance that's linked to a peer VPC using
    #   ClassicLink.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PeeringConnectionOptionsRequest AWS API Documentation
    #
    class PeeringConnectionOptionsRequest < Struct.new(
      :allow_dns_resolution_from_remote_vpc,
      :allow_egress_from_local_classic_link_to_remote_vpc,
      :allow_egress_from_local_vpc_to_remote_classic_link)
      include Aws::Structure
    end

    # Information about the transit gateway in the peering attachment.
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The AWS account ID of the owner of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] region
    #   The Region of the transit gateway.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PeeringTgwInfo AWS API Documentation
    #
    class PeeringTgwInfo < Struct.new(
      :transit_gateway_id,
      :owner_id,
      :region)
      include Aws::Structure
    end

    # The Diffie-Hellmann group number for phase 1 IKE negotiations.
    #
    # @!attribute [rw] value
    #   The Diffie-Hellmann group number.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Phase1DHGroupNumbersListValue AWS API Documentation
    #
    class Phase1DHGroupNumbersListValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # Specifies a Diffie-Hellman group number for the VPN tunnel for phase 1
    # IKE negotiations.
    #
    # @note When making an API call, you may pass Phase1DHGroupNumbersRequestListValue
    #   data as a hash:
    #
    #       {
    #         value: 1,
    #       }
    #
    # @!attribute [rw] value
    #   The Diffie-Hellmann group number.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Phase1DHGroupNumbersRequestListValue AWS API Documentation
    #
    class Phase1DHGroupNumbersRequestListValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # The encryption algorithm for phase 1 IKE negotiations.
    #
    # @!attribute [rw] value
    #   The value for the encryption algorithm.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Phase1EncryptionAlgorithmsListValue AWS API Documentation
    #
    class Phase1EncryptionAlgorithmsListValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # Specifies the encryption algorithm for the VPN tunnel for phase 1 IKE
    # negotiations.
    #
    # @note When making an API call, you may pass Phase1EncryptionAlgorithmsRequestListValue
    #   data as a hash:
    #
    #       {
    #         value: "String",
    #       }
    #
    # @!attribute [rw] value
    #   The value for the encryption algorithm.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Phase1EncryptionAlgorithmsRequestListValue AWS API Documentation
    #
    class Phase1EncryptionAlgorithmsRequestListValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # The integrity algorithm for phase 1 IKE negotiations.
    #
    # @!attribute [rw] value
    #   The value for the integrity algorithm.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Phase1IntegrityAlgorithmsListValue AWS API Documentation
    #
    class Phase1IntegrityAlgorithmsListValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # Specifies the integrity algorithm for the VPN tunnel for phase 1 IKE
    # negotiations.
    #
    # @note When making an API call, you may pass Phase1IntegrityAlgorithmsRequestListValue
    #   data as a hash:
    #
    #       {
    #         value: "String",
    #       }
    #
    # @!attribute [rw] value
    #   The value for the integrity algorithm.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Phase1IntegrityAlgorithmsRequestListValue AWS API Documentation
    #
    class Phase1IntegrityAlgorithmsRequestListValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # The Diffie-Hellmann group number for phase 2 IKE negotiations.
    #
    # @!attribute [rw] value
    #   The Diffie-Hellmann group number.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Phase2DHGroupNumbersListValue AWS API Documentation
    #
    class Phase2DHGroupNumbersListValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # Specifies a Diffie-Hellman group number for the VPN tunnel for phase 2
    # IKE negotiations.
    #
    # @note When making an API call, you may pass Phase2DHGroupNumbersRequestListValue
    #   data as a hash:
    #
    #       {
    #         value: 1,
    #       }
    #
    # @!attribute [rw] value
    #   The Diffie-Hellmann group number.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Phase2DHGroupNumbersRequestListValue AWS API Documentation
    #
    class Phase2DHGroupNumbersRequestListValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # The encryption algorithm for phase 2 IKE negotiations.
    #
    # @!attribute [rw] value
    #   The encryption algorithm.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Phase2EncryptionAlgorithmsListValue AWS API Documentation
    #
    class Phase2EncryptionAlgorithmsListValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # Specifies the encryption algorithm for the VPN tunnel for phase 2 IKE
    # negotiations.
    #
    # @note When making an API call, you may pass Phase2EncryptionAlgorithmsRequestListValue
    #   data as a hash:
    #
    #       {
    #         value: "String",
    #       }
    #
    # @!attribute [rw] value
    #   The encryption algorithm.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Phase2EncryptionAlgorithmsRequestListValue AWS API Documentation
    #
    class Phase2EncryptionAlgorithmsRequestListValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # The integrity algorithm for phase 2 IKE negotiations.
    #
    # @!attribute [rw] value
    #   The integrity algorithm.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Phase2IntegrityAlgorithmsListValue AWS API Documentation
    #
    class Phase2IntegrityAlgorithmsListValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # Specifies the integrity algorithm for the VPN tunnel for phase 2 IKE
    # negotiations.
    #
    # @note When making an API call, you may pass Phase2IntegrityAlgorithmsRequestListValue
    #   data as a hash:
    #
    #       {
    #         value: "String",
    #       }
    #
    # @!attribute [rw] value
    #   The integrity algorithm.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Phase2IntegrityAlgorithmsRequestListValue AWS API Documentation
    #
    class Phase2IntegrityAlgorithmsRequestListValue < Struct.new(
      :value)
      include Aws::Structure
    end

    # Describes the placement of an instance.
    #
    # @note When making an API call, you may pass Placement
    #   data as a hash:
    #
    #       {
    #         availability_zone: "String",
    #         affinity: "String",
    #         group_name: "String",
    #         partition_number: 1,
    #         host_id: "String",
    #         tenancy: "default", # accepts default, dedicated, host
    #         spread_domain: "String",
    #         host_resource_group_arn: "String",
    #       }
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone of the instance.
    #
    #   If not specified, an Availability Zone will be automatically chosen
    #   for you based on the load balancing criteria for the Region.
    #
    #   This parameter is not supported by [CreateFleet][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateFleet
    #   @return [String]
    #
    # @!attribute [rw] affinity
    #   The affinity setting for the instance on the Dedicated Host. This
    #   parameter is not supported for the [ImportInstance][1] command.
    #
    #   This parameter is not supported by [CreateFleet][2].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ImportInstance.html
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateFleet
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   The name of the placement group the instance is in.
    #   @return [String]
    #
    # @!attribute [rw] partition_number
    #   The number of the partition the instance is in. Valid only if the
    #   placement group strategy is set to `partition`.
    #
    #   This parameter is not supported by [CreateFleet][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateFleet
    #   @return [Integer]
    #
    # @!attribute [rw] host_id
    #   The ID of the Dedicated Host on which the instance resides. This
    #   parameter is not supported for the [ImportInstance][1] command.
    #
    #   This parameter is not supported by [CreateFleet][2].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ImportInstance.html
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateFleet
    #   @return [String]
    #
    # @!attribute [rw] tenancy
    #   The tenancy of the instance (if the instance is running in a VPC).
    #   An instance with a tenancy of `dedicated` runs on single-tenant
    #   hardware. The `host` tenancy is not supported for the
    #   [ImportInstance][1] command.
    #
    #   This parameter is not supported by [CreateFleet][2].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ImportInstance.html
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateFleet
    #   @return [String]
    #
    # @!attribute [rw] spread_domain
    #   Reserved for future use.
    #
    #   This parameter is not supported by [CreateFleet][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateFleet
    #   @return [String]
    #
    # @!attribute [rw] host_resource_group_arn
    #   The ARN of the host resource group in which to launch the instances.
    #   If you specify a host resource group ARN, omit the **Tenancy**
    #   parameter or set it to `host`.
    #
    #   This parameter is not supported by [CreateFleet][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateFleet
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Placement AWS API Documentation
    #
    class Placement < Struct.new(
      :availability_zone,
      :affinity,
      :group_name,
      :partition_number,
      :host_id,
      :tenancy,
      :spread_domain,
      :host_resource_group_arn)
      include Aws::Structure
    end

    # Describes a placement group.
    #
    # @!attribute [rw] group_name
    #   The name of the placement group.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the placement group.
    #   @return [String]
    #
    # @!attribute [rw] strategy
    #   The placement strategy.
    #   @return [String]
    #
    # @!attribute [rw] partition_count
    #   The number of partitions. Valid only if **strategy** is set to
    #   `partition`.
    #   @return [Integer]
    #
    # @!attribute [rw] group_id
    #   The ID of the placement group.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Any tags applied to the placement group.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PlacementGroup AWS API Documentation
    #
    class PlacementGroup < Struct.new(
      :group_name,
      :state,
      :strategy,
      :partition_count,
      :group_id,
      :tags)
      include Aws::Structure
    end

    # Describes the placement group support of the instance type.
    #
    # @!attribute [rw] supported_strategies
    #   A list of supported placement groups types.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PlacementGroupInfo AWS API Documentation
    #
    class PlacementGroupInfo < Struct.new(
      :supported_strategies)
      include Aws::Structure
    end

    # Describes the placement of an instance.
    #
    # @!attribute [rw] group_name
    #   The name of the placement group that the instance is in.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PlacementResponse AWS API Documentation
    #
    class PlacementResponse < Struct.new(
      :group_name)
      include Aws::Structure
    end

    # Describes a CIDR block for an address pool.
    #
    # @!attribute [rw] cidr
    #   The CIDR block.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PoolCidrBlock AWS API Documentation
    #
    class PoolCidrBlock < Struct.new(
      :cidr)
      include Aws::Structure
    end

    # Describes a range of ports.
    #
    # @note When making an API call, you may pass PortRange
    #   data as a hash:
    #
    #       {
    #         from: 1,
    #         to: 1,
    #       }
    #
    # @!attribute [rw] from
    #   The first port in the range.
    #   @return [Integer]
    #
    # @!attribute [rw] to
    #   The last port in the range.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PortRange AWS API Documentation
    #
    class PortRange < Struct.new(
      :from,
      :to)
      include Aws::Structure
    end

    # Describes prefixes for AWS services.
    #
    # @!attribute [rw] cidrs
    #   The IP address range of the AWS service.
    #   @return [Array<String>]
    #
    # @!attribute [rw] prefix_list_id
    #   The ID of the prefix.
    #   @return [String]
    #
    # @!attribute [rw] prefix_list_name
    #   The name of the prefix.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PrefixList AWS API Documentation
    #
    class PrefixList < Struct.new(
      :cidrs,
      :prefix_list_id,
      :prefix_list_name)
      include Aws::Structure
    end

    # Describes a prefix list ID.
    #
    # @note When making an API call, you may pass PrefixListId
    #   data as a hash:
    #
    #       {
    #         description: "String",
    #         prefix_list_id: "String",
    #       }
    #
    # @!attribute [rw] description
    #   A description for the security group rule that references this
    #   prefix list ID.
    #
    #   Constraints: Up to 255 characters in length. Allowed characters are
    #   a-z, A-Z, 0-9, spaces, and .\_-:/()#,@\[\]+=;\\\{\\}!$*
    #   @return [String]
    #
    # @!attribute [rw] prefix_list_id
    #   The ID of the prefix.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PrefixListId AWS API Documentation
    #
    class PrefixListId < Struct.new(
      :description,
      :prefix_list_id)
      include Aws::Structure
    end

    # Describes the price for a Reserved Instance.
    #
    # @!attribute [rw] active
    #   The current price schedule, as determined by the term remaining for
    #   the Reserved Instance in the listing.
    #
    #   A specific price schedule is always in effect, but only one price
    #   schedule can be active at any time. Take, for example, a Reserved
    #   Instance listing that has five months remaining in its term. When
    #   you specify price schedules for five months and two months, this
    #   means that schedule 1, covering the first three months of the
    #   remaining term, will be active during months 5, 4, and 3. Then
    #   schedule 2, covering the last two months of the term, will be active
    #   for months 2 and 1.
    #   @return [Boolean]
    #
    # @!attribute [rw] currency_code
    #   The currency for transacting the Reserved Instance resale. At this
    #   time, the only supported currency is `USD`.
    #   @return [String]
    #
    # @!attribute [rw] price
    #   The fixed price for the term.
    #   @return [Float]
    #
    # @!attribute [rw] term
    #   The number of months remaining in the reservation. For example, 2 is
    #   the second to the last month before the capacity reservation
    #   expires.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PriceSchedule AWS API Documentation
    #
    class PriceSchedule < Struct.new(
      :active,
      :currency_code,
      :price,
      :term)
      include Aws::Structure
    end

    # Describes the price for a Reserved Instance.
    #
    # @note When making an API call, you may pass PriceScheduleSpecification
    #   data as a hash:
    #
    #       {
    #         currency_code: "USD", # accepts USD
    #         price: 1.0,
    #         term: 1,
    #       }
    #
    # @!attribute [rw] currency_code
    #   The currency for transacting the Reserved Instance resale. At this
    #   time, the only supported currency is `USD`.
    #   @return [String]
    #
    # @!attribute [rw] price
    #   The fixed price for the term.
    #   @return [Float]
    #
    # @!attribute [rw] term
    #   The number of months remaining in the reservation. For example, 2 is
    #   the second to the last month before the capacity reservation
    #   expires.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PriceScheduleSpecification AWS API Documentation
    #
    class PriceScheduleSpecification < Struct.new(
      :currency_code,
      :price,
      :term)
      include Aws::Structure
    end

    # Describes a Reserved Instance offering.
    #
    # @!attribute [rw] count
    #   The number of reservations available for the price.
    #   @return [Integer]
    #
    # @!attribute [rw] price
    #   The price per instance.
    #   @return [Float]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PricingDetail AWS API Documentation
    #
    class PricingDetail < Struct.new(
      :count,
      :price)
      include Aws::Structure
    end

    # PrincipalIdFormat description
    #
    # @!attribute [rw] arn
    #   PrincipalIdFormatARN description
    #   @return [String]
    #
    # @!attribute [rw] statuses
    #   PrincipalIdFormatStatuses description
    #   @return [Array<Types::IdFormat>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PrincipalIdFormat AWS API Documentation
    #
    class PrincipalIdFormat < Struct.new(
      :arn,
      :statuses)
      include Aws::Structure
    end

    # Information about the private DNS name for the service endpoint. For
    # more information about these parameters, see [VPC Endpoint Service
    # Private DNS Name Verification][1] in the *Amazon Virtual Private Cloud
    # User Guide*.
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/vpc/latest/userguide/ndpoint-services-dns-validation.html
    #
    # @!attribute [rw] state
    #   The verification state of the VPC endpoint service.
    #
    #   &gt;Consumers of the endpoint service can use the private name only
    #   when the state is `verified`.
    #   @return [String]
    #
    # @!attribute [rw] type
    #   The endpoint service verification type, for example TXT.
    #   @return [String]
    #
    # @!attribute [rw] value
    #   The value the service provider adds to the private DNS name domain
    #   record before verification.
    #   @return [String]
    #
    # @!attribute [rw] name
    #   The name of the record subdomain the service provider needs to
    #   create. The service provider adds the `value` text to the `name`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PrivateDnsNameConfiguration AWS API Documentation
    #
    class PrivateDnsNameConfiguration < Struct.new(
      :state,
      :type,
      :value,
      :name)
      include Aws::Structure
    end

    # Describes a secondary private IPv4 address for a network interface.
    #
    # @note When making an API call, you may pass PrivateIpAddressSpecification
    #   data as a hash:
    #
    #       {
    #         primary: false,
    #         private_ip_address: "String",
    #       }
    #
    # @!attribute [rw] primary
    #   Indicates whether the private IPv4 address is the primary private
    #   IPv4 address. Only one IPv4 address can be designated as primary.
    #   @return [Boolean]
    #
    # @!attribute [rw] private_ip_address
    #   The private IPv4 addresses.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PrivateIpAddressSpecification AWS API Documentation
    #
    class PrivateIpAddressSpecification < Struct.new(
      :primary,
      :private_ip_address)
      include Aws::Structure
    end

    # Describes the processor used by the instance type.
    #
    # @!attribute [rw] supported_architectures
    #   A list of architectures supported by the instance type.
    #   @return [Array<String>]
    #
    # @!attribute [rw] sustained_clock_speed_in_ghz
    #   The speed of the processor, in GHz.
    #   @return [Float]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ProcessorInfo AWS API Documentation
    #
    class ProcessorInfo < Struct.new(
      :supported_architectures,
      :sustained_clock_speed_in_ghz)
      include Aws::Structure
    end

    # Describes a product code.
    #
    # @!attribute [rw] product_code_id
    #   The product code.
    #   @return [String]
    #
    # @!attribute [rw] product_code_type
    #   The type of product code.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ProductCode AWS API Documentation
    #
    class ProductCode < Struct.new(
      :product_code_id,
      :product_code_type)
      include Aws::Structure
    end

    # Describes a virtual private gateway propagating route.
    #
    # @!attribute [rw] gateway_id
    #   The ID of the virtual private gateway.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PropagatingVgw AWS API Documentation
    #
    class PropagatingVgw < Struct.new(
      :gateway_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ProvisionByoipCidrRequest
    #   data as a hash:
    #
    #       {
    #         cidr: "String", # required
    #         cidr_authorization_context: {
    #           message: "String", # required
    #           signature: "String", # required
    #         },
    #         publicly_advertisable: false,
    #         description: "String",
    #         dry_run: false,
    #         pool_tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] cidr
    #   The public IPv4 or IPv6 address range, in CIDR notation. The most
    #   specific IPv4 prefix that you can specify is /24. The most specific
    #   IPv6 prefix you can specify is /56. The address range cannot overlap
    #   with another address range that you've brought to this or another
    #   Region.
    #   @return [String]
    #
    # @!attribute [rw] cidr_authorization_context
    #   A signed document that proves that you are authorized to bring the
    #   specified IP address range to Amazon using BYOIP.
    #   @return [Types::CidrAuthorizationContext]
    #
    # @!attribute [rw] publicly_advertisable
    #   (IPv6 only) Indicate whether the address range will be publicly
    #   advertised to the internet.
    #
    #   Default: true
    #   @return [Boolean]
    #
    # @!attribute [rw] description
    #   A description for the address range and the address pool.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] pool_tag_specifications
    #   The tags to apply to the address pool.
    #   @return [Array<Types::TagSpecification>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ProvisionByoipCidrRequest AWS API Documentation
    #
    class ProvisionByoipCidrRequest < Struct.new(
      :cidr,
      :cidr_authorization_context,
      :publicly_advertisable,
      :description,
      :dry_run,
      :pool_tag_specifications)
      include Aws::Structure
    end

    # @!attribute [rw] byoip_cidr
    #   Information about the address range.
    #   @return [Types::ByoipCidr]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ProvisionByoipCidrResult AWS API Documentation
    #
    class ProvisionByoipCidrResult < Struct.new(
      :byoip_cidr)
      include Aws::Structure
    end

    # Reserved. If you need to sustain traffic greater than the [documented
    # limits][1], contact us through the [Support Center][2].
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html
    # [2]: https://console.aws.amazon.com/support/home?
    #
    # @!attribute [rw] provision_time
    #   Reserved. If you need to sustain traffic greater than the
    #   [documented limits][1], contact us through the [Support Center][2].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html
    #   [2]: https://console.aws.amazon.com/support/home?
    #   @return [Time]
    #
    # @!attribute [rw] provisioned
    #   Reserved. If you need to sustain traffic greater than the
    #   [documented limits][1], contact us through the [Support Center][2].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html
    #   [2]: https://console.aws.amazon.com/support/home?
    #   @return [String]
    #
    # @!attribute [rw] request_time
    #   Reserved. If you need to sustain traffic greater than the
    #   [documented limits][1], contact us through the [Support Center][2].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html
    #   [2]: https://console.aws.amazon.com/support/home?
    #   @return [Time]
    #
    # @!attribute [rw] requested
    #   Reserved. If you need to sustain traffic greater than the
    #   [documented limits][1], contact us through the [Support Center][2].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html
    #   [2]: https://console.aws.amazon.com/support/home?
    #   @return [String]
    #
    # @!attribute [rw] status
    #   Reserved. If you need to sustain traffic greater than the
    #   [documented limits][1], contact us through the [Support Center][2].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html
    #   [2]: https://console.aws.amazon.com/support/home?
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ProvisionedBandwidth AWS API Documentation
    #
    class ProvisionedBandwidth < Struct.new(
      :provision_time,
      :provisioned,
      :request_time,
      :requested,
      :status)
      include Aws::Structure
    end

    # Describes an IPv4 address pool.
    #
    # @!attribute [rw] pool_id
    #   The ID of the address pool.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   A description of the address pool.
    #   @return [String]
    #
    # @!attribute [rw] pool_address_ranges
    #   The address ranges.
    #   @return [Array<Types::PublicIpv4PoolRange>]
    #
    # @!attribute [rw] total_address_count
    #   The total number of addresses.
    #   @return [Integer]
    #
    # @!attribute [rw] total_available_address_count
    #   The total number of available addresses.
    #   @return [Integer]
    #
    # @!attribute [rw] network_border_group
    #   The name of the location from which the address pool is advertised.
    #   A network border group is a unique set of Availability Zones or
    #   Local Zones from where AWS advertises public IP addresses.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Any tags for the address pool.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PublicIpv4Pool AWS API Documentation
    #
    class PublicIpv4Pool < Struct.new(
      :pool_id,
      :description,
      :pool_address_ranges,
      :total_address_count,
      :total_available_address_count,
      :network_border_group,
      :tags)
      include Aws::Structure
    end

    # Describes an address range of an IPv4 address pool.
    #
    # @!attribute [rw] first_address
    #   The first IP address in the range.
    #   @return [String]
    #
    # @!attribute [rw] last_address
    #   The last IP address in the range.
    #   @return [String]
    #
    # @!attribute [rw] address_count
    #   The number of addresses in the range.
    #   @return [Integer]
    #
    # @!attribute [rw] available_address_count
    #   The number of available addresses in the range.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PublicIpv4PoolRange AWS API Documentation
    #
    class PublicIpv4PoolRange < Struct.new(
      :first_address,
      :last_address,
      :address_count,
      :available_address_count)
      include Aws::Structure
    end

    # Describes the result of the purchase.
    #
    # @!attribute [rw] currency_code
    #   The currency in which the `UpfrontPrice` and `HourlyPrice` amounts
    #   are specified. At this time, the only supported currency is `USD`.
    #   @return [String]
    #
    # @!attribute [rw] duration
    #   The duration of the reservation's term in seconds.
    #   @return [Integer]
    #
    # @!attribute [rw] host_id_set
    #   The IDs of the Dedicated Hosts associated with the reservation.
    #   @return [Array<String>]
    #
    # @!attribute [rw] host_reservation_id
    #   The ID of the reservation.
    #   @return [String]
    #
    # @!attribute [rw] hourly_price
    #   The hourly price of the reservation per hour.
    #   @return [String]
    #
    # @!attribute [rw] instance_family
    #   The instance family on the Dedicated Host that the reservation can
    #   be associated with.
    #   @return [String]
    #
    # @!attribute [rw] payment_option
    #   The payment option for the reservation.
    #   @return [String]
    #
    # @!attribute [rw] upfront_price
    #   The upfront price of the reservation.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Purchase AWS API Documentation
    #
    class Purchase < Struct.new(
      :currency_code,
      :duration,
      :host_id_set,
      :host_reservation_id,
      :hourly_price,
      :instance_family,
      :payment_option,
      :upfront_price)
      include Aws::Structure
    end

    # @note When making an API call, you may pass PurchaseHostReservationRequest
    #   data as a hash:
    #
    #       {
    #         client_token: "String",
    #         currency_code: "USD", # accepts USD
    #         host_id_set: ["DedicatedHostId"], # required
    #         limit_price: "String",
    #         offering_id: "OfferingId", # required
    #       }
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] currency_code
    #   The currency in which the `totalUpfrontPrice`, `LimitPrice`, and
    #   `totalHourlyPrice` amounts are specified. At this time, the only
    #   supported currency is `USD`.
    #   @return [String]
    #
    # @!attribute [rw] host_id_set
    #   The IDs of the Dedicated Hosts with which the reservation will be
    #   associated.
    #   @return [Array<String>]
    #
    # @!attribute [rw] limit_price
    #   The specified limit is checked against the total upfront cost of the
    #   reservation (calculated as the offering's upfront cost multiplied
    #   by the host count). If the total upfront cost is greater than the
    #   specified price limit, the request fails. This is used to ensure
    #   that the purchase does not exceed the expected upfront cost of the
    #   purchase. At this time, the only supported currency is `USD`. For
    #   example, to indicate a limit price of USD 100, specify 100.00.
    #   @return [String]
    #
    # @!attribute [rw] offering_id
    #   The ID of the offering.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PurchaseHostReservationRequest AWS API Documentation
    #
    class PurchaseHostReservationRequest < Struct.new(
      :client_token,
      :currency_code,
      :host_id_set,
      :limit_price,
      :offering_id)
      include Aws::Structure
    end

    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] currency_code
    #   The currency in which the `totalUpfrontPrice` and `totalHourlyPrice`
    #   amounts are specified. At this time, the only supported currency is
    #   `USD`.
    #   @return [String]
    #
    # @!attribute [rw] purchase
    #   Describes the details of the purchase.
    #   @return [Array<Types::Purchase>]
    #
    # @!attribute [rw] total_hourly_price
    #   The total hourly price of the reservation calculated per hour.
    #   @return [String]
    #
    # @!attribute [rw] total_upfront_price
    #   The total amount charged to your account when you purchase the
    #   reservation.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PurchaseHostReservationResult AWS API Documentation
    #
    class PurchaseHostReservationResult < Struct.new(
      :client_token,
      :currency_code,
      :purchase,
      :total_hourly_price,
      :total_upfront_price)
      include Aws::Structure
    end

    # Describes a request to purchase Scheduled Instances.
    #
    # @note When making an API call, you may pass PurchaseRequest
    #   data as a hash:
    #
    #       {
    #         instance_count: 1, # required
    #         purchase_token: "String", # required
    #       }
    #
    # @!attribute [rw] instance_count
    #   The number of instances.
    #   @return [Integer]
    #
    # @!attribute [rw] purchase_token
    #   The purchase token.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PurchaseRequest AWS API Documentation
    #
    class PurchaseRequest < Struct.new(
      :instance_count,
      :purchase_token)
      include Aws::Structure
    end

    # Contains the parameters for PurchaseReservedInstancesOffering.
    #
    # @note When making an API call, you may pass PurchaseReservedInstancesOfferingRequest
    #   data as a hash:
    #
    #       {
    #         instance_count: 1, # required
    #         reserved_instances_offering_id: "ReservedInstancesOfferingId", # required
    #         dry_run: false,
    #         limit_price: {
    #           amount: 1.0,
    #           currency_code: "USD", # accepts USD
    #         },
    #         purchase_time: Time.now,
    #       }
    #
    # @!attribute [rw] instance_count
    #   The number of Reserved Instances to purchase.
    #   @return [Integer]
    #
    # @!attribute [rw] reserved_instances_offering_id
    #   The ID of the Reserved Instance offering to purchase.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] limit_price
    #   Specified for Reserved Instance Marketplace offerings to limit the
    #   total order and ensure that the Reserved Instances are not purchased
    #   at unexpected prices.
    #   @return [Types::ReservedInstanceLimitPrice]
    #
    # @!attribute [rw] purchase_time
    #   The time at which to purchase the Reserved Instance, in UTC format
    #   (for example, *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z).
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PurchaseReservedInstancesOfferingRequest AWS API Documentation
    #
    class PurchaseReservedInstancesOfferingRequest < Struct.new(
      :instance_count,
      :reserved_instances_offering_id,
      :dry_run,
      :limit_price,
      :purchase_time)
      include Aws::Structure
    end

    # Contains the output of PurchaseReservedInstancesOffering.
    #
    # @!attribute [rw] reserved_instances_id
    #   The IDs of the purchased Reserved Instances.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PurchaseReservedInstancesOfferingResult AWS API Documentation
    #
    class PurchaseReservedInstancesOfferingResult < Struct.new(
      :reserved_instances_id)
      include Aws::Structure
    end

    # Contains the parameters for PurchaseScheduledInstances.
    #
    # @note When making an API call, you may pass PurchaseScheduledInstancesRequest
    #   data as a hash:
    #
    #       {
    #         client_token: "String",
    #         dry_run: false,
    #         purchase_requests: [ # required
    #           {
    #             instance_count: 1, # required
    #             purchase_token: "String", # required
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that ensures the idempotency of
    #   the request. For more information, see [Ensuring Idempotency][1].
    #
    #   **A suitable default value is auto-generated.** You should normally
    #   not need to pass this option.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] purchase_requests
    #   The purchase requests.
    #   @return [Array<Types::PurchaseRequest>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PurchaseScheduledInstancesRequest AWS API Documentation
    #
    class PurchaseScheduledInstancesRequest < Struct.new(
      :client_token,
      :dry_run,
      :purchase_requests)
      include Aws::Structure
    end

    # Contains the output of PurchaseScheduledInstances.
    #
    # @!attribute [rw] scheduled_instance_set
    #   Information about the Scheduled Instances.
    #   @return [Array<Types::ScheduledInstance>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/PurchaseScheduledInstancesResult AWS API Documentation
    #
    class PurchaseScheduledInstancesResult < Struct.new(
      :scheduled_instance_set)
      include Aws::Structure
    end

    # @note When making an API call, you may pass RebootInstancesRequest
    #   data as a hash:
    #
    #       {
    #         instance_ids: ["InstanceId"], # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] instance_ids
    #   The instance IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RebootInstancesRequest AWS API Documentation
    #
    class RebootInstancesRequest < Struct.new(
      :instance_ids,
      :dry_run)
      include Aws::Structure
    end

    # Describes a recurring charge.
    #
    # @!attribute [rw] amount
    #   The amount of the recurring charge.
    #   @return [Float]
    #
    # @!attribute [rw] frequency
    #   The frequency of the recurring charge.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RecurringCharge AWS API Documentation
    #
    class RecurringCharge < Struct.new(
      :amount,
      :frequency)
      include Aws::Structure
    end

    # Describes a Region.
    #
    # @!attribute [rw] endpoint
    #   The Region service endpoint.
    #   @return [String]
    #
    # @!attribute [rw] region_name
    #   The name of the Region.
    #   @return [String]
    #
    # @!attribute [rw] opt_in_status
    #   The Region opt-in status. The possible values are
    #   `opt-in-not-required`, `opted-in`, and `not-opted-in`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Region AWS API Documentation
    #
    class Region < Struct.new(
      :endpoint,
      :region_name,
      :opt_in_status)
      include Aws::Structure
    end

    # Contains the parameters for RegisterImage.
    #
    # @note When making an API call, you may pass RegisterImageRequest
    #   data as a hash:
    #
    #       {
    #         image_location: "String",
    #         architecture: "i386", # accepts i386, x86_64, arm64
    #         block_device_mappings: [
    #           {
    #             device_name: "String",
    #             virtual_name: "String",
    #             ebs: {
    #               delete_on_termination: false,
    #               iops: 1,
    #               snapshot_id: "String",
    #               volume_size: 1,
    #               volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #               kms_key_id: "String",
    #               encrypted: false,
    #             },
    #             no_device: "String",
    #           },
    #         ],
    #         description: "String",
    #         dry_run: false,
    #         ena_support: false,
    #         kernel_id: "KernelId",
    #         name: "String", # required
    #         billing_products: ["String"],
    #         ramdisk_id: "RamdiskId",
    #         root_device_name: "String",
    #         sriov_net_support: "String",
    #         virtualization_type: "String",
    #       }
    #
    # @!attribute [rw] image_location
    #   The full path to your AMI manifest in Amazon S3 storage. The
    #   specified bucket must have the `aws-exec-read` canned access control
    #   list (ACL) to ensure that it can be accessed by Amazon EC2. For more
    #   information, see [Canned ACLs][1] in the *Amazon S3 Service
    #   Developer Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AmazonS3/latest/dev/acl-overview.html#canned-acl
    #   @return [String]
    #
    # @!attribute [rw] architecture
    #   The architecture of the AMI.
    #
    #   Default: For Amazon EBS-backed AMIs, `i386`. For instance
    #   store-backed AMIs, the architecture specified in the manifest file.
    #   @return [String]
    #
    # @!attribute [rw] block_device_mappings
    #   The block device mapping entries.
    #   @return [Array<Types::BlockDeviceMapping>]
    #
    # @!attribute [rw] description
    #   A description for your AMI.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] ena_support
    #   Set to `true` to enable enhanced networking with ENA for the AMI and
    #   any instances that you launch from the AMI.
    #
    #   This option is supported only for HVM AMIs. Specifying this option
    #   with a PV AMI can make instances launched from the AMI unreachable.
    #   @return [Boolean]
    #
    # @!attribute [rw] kernel_id
    #   The ID of the kernel.
    #   @return [String]
    #
    # @!attribute [rw] name
    #   A name for your AMI.
    #
    #   Constraints: 3-128 alphanumeric characters, parentheses (()), square
    #   brackets (\[\]), spaces ( ), periods (.), slashes (/), dashes (-),
    #   single quotes ('), at-signs (@), or underscores(\_)
    #   @return [String]
    #
    # @!attribute [rw] billing_products
    #   The billing product codes. Your account must be authorized to
    #   specify billing product codes. Otherwise, you can use the AWS
    #   Marketplace to bill for the use of an AMI.
    #   @return [Array<String>]
    #
    # @!attribute [rw] ramdisk_id
    #   The ID of the RAM disk.
    #   @return [String]
    #
    # @!attribute [rw] root_device_name
    #   The device name of the root device volume (for example,
    #   `/dev/sda1`).
    #   @return [String]
    #
    # @!attribute [rw] sriov_net_support
    #   Set to `simple` to enable enhanced networking with the Intel 82599
    #   Virtual Function interface for the AMI and any instances that you
    #   launch from the AMI.
    #
    #   There is no way to disable `sriovNetSupport` at this time.
    #
    #   This option is supported only for HVM AMIs. Specifying this option
    #   with a PV AMI can make instances launched from the AMI unreachable.
    #   @return [String]
    #
    # @!attribute [rw] virtualization_type
    #   The type of virtualization (`hvm` \| `paravirtual`).
    #
    #   Default: `paravirtual`
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RegisterImageRequest AWS API Documentation
    #
    class RegisterImageRequest < Struct.new(
      :image_location,
      :architecture,
      :block_device_mappings,
      :description,
      :dry_run,
      :ena_support,
      :kernel_id,
      :name,
      :billing_products,
      :ramdisk_id,
      :root_device_name,
      :sriov_net_support,
      :virtualization_type)
      include Aws::Structure
    end

    # Contains the output of RegisterImage.
    #
    # @!attribute [rw] image_id
    #   The ID of the newly registered AMI.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RegisterImageResult AWS API Documentation
    #
    class RegisterImageResult < Struct.new(
      :image_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass RegisterInstanceEventNotificationAttributesRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         instance_tag_attribute: {
    #           include_all_tags_of_instance: false,
    #           instance_tag_keys: ["String"],
    #         },
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_tag_attribute
    #   Information about the tag keys to register.
    #   @return [Types::RegisterInstanceTagAttributeRequest]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RegisterInstanceEventNotificationAttributesRequest AWS API Documentation
    #
    class RegisterInstanceEventNotificationAttributesRequest < Struct.new(
      :dry_run,
      :instance_tag_attribute)
      include Aws::Structure
    end

    # @!attribute [rw] instance_tag_attribute
    #   The resulting set of tag keys.
    #   @return [Types::InstanceTagNotificationAttribute]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RegisterInstanceEventNotificationAttributesResult AWS API Documentation
    #
    class RegisterInstanceEventNotificationAttributesResult < Struct.new(
      :instance_tag_attribute)
      include Aws::Structure
    end

    # Information about the tag keys to register for the current Region. You
    # can either specify individual tag keys or register all tag keys in the
    # current Region. You must specify either `IncludeAllTagsOfInstance` or
    # `InstanceTagKeys` in the request
    #
    # @note When making an API call, you may pass RegisterInstanceTagAttributeRequest
    #   data as a hash:
    #
    #       {
    #         include_all_tags_of_instance: false,
    #         instance_tag_keys: ["String"],
    #       }
    #
    # @!attribute [rw] include_all_tags_of_instance
    #   Indicates whether to register all tag keys in the current Region.
    #   Specify `true` to register all tag keys.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_tag_keys
    #   The tag keys to register.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RegisterInstanceTagAttributeRequest AWS API Documentation
    #
    class RegisterInstanceTagAttributeRequest < Struct.new(
      :include_all_tags_of_instance,
      :instance_tag_keys)
      include Aws::Structure
    end

    # @note When making an API call, you may pass RegisterTransitGatewayMulticastGroupMembersRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_multicast_domain_id: "TransitGatewayMulticastDomainId",
    #         group_ip_address: "String",
    #         network_interface_ids: ["NetworkInterfaceId"],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_multicast_domain_id
    #   The ID of the transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] group_ip_address
    #   The IP address assigned to the transit gateway multicast group.
    #   @return [String]
    #
    # @!attribute [rw] network_interface_ids
    #   The group members' network interface IDs to register with the
    #   transit gateway multicast group.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RegisterTransitGatewayMulticastGroupMembersRequest AWS API Documentation
    #
    class RegisterTransitGatewayMulticastGroupMembersRequest < Struct.new(
      :transit_gateway_multicast_domain_id,
      :group_ip_address,
      :network_interface_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] registered_multicast_group_members
    #   Information about the registered transit gateway multicast group
    #   members.
    #   @return [Types::TransitGatewayMulticastRegisteredGroupMembers]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RegisterTransitGatewayMulticastGroupMembersResult AWS API Documentation
    #
    class RegisterTransitGatewayMulticastGroupMembersResult < Struct.new(
      :registered_multicast_group_members)
      include Aws::Structure
    end

    # @note When making an API call, you may pass RegisterTransitGatewayMulticastGroupSourcesRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_multicast_domain_id: "TransitGatewayMulticastDomainId",
    #         group_ip_address: "String",
    #         network_interface_ids: ["NetworkInterfaceId"],
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_multicast_domain_id
    #   The ID of the transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] group_ip_address
    #   The IP address assigned to the transit gateway multicast group.
    #   @return [String]
    #
    # @!attribute [rw] network_interface_ids
    #   The group sources' network interface IDs to register with the
    #   transit gateway multicast group.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RegisterTransitGatewayMulticastGroupSourcesRequest AWS API Documentation
    #
    class RegisterTransitGatewayMulticastGroupSourcesRequest < Struct.new(
      :transit_gateway_multicast_domain_id,
      :group_ip_address,
      :network_interface_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] registered_multicast_group_sources
    #   Information about the transit gateway multicast group sources.
    #   @return [Types::TransitGatewayMulticastRegisteredGroupSources]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RegisterTransitGatewayMulticastGroupSourcesResult AWS API Documentation
    #
    class RegisterTransitGatewayMulticastGroupSourcesResult < Struct.new(
      :registered_multicast_group_sources)
      include Aws::Structure
    end

    # @note When making an API call, you may pass RejectTransitGatewayPeeringAttachmentRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_attachment_id: "TransitGatewayAttachmentId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the transit gateway peering attachment.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RejectTransitGatewayPeeringAttachmentRequest AWS API Documentation
    #
    class RejectTransitGatewayPeeringAttachmentRequest < Struct.new(
      :transit_gateway_attachment_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_peering_attachment
    #   The transit gateway peering attachment.
    #   @return [Types::TransitGatewayPeeringAttachment]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RejectTransitGatewayPeeringAttachmentResult AWS API Documentation
    #
    class RejectTransitGatewayPeeringAttachmentResult < Struct.new(
      :transit_gateway_peering_attachment)
      include Aws::Structure
    end

    # @note When making an API call, you may pass RejectTransitGatewayVpcAttachmentRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_attachment_id: "TransitGatewayAttachmentId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RejectTransitGatewayVpcAttachmentRequest AWS API Documentation
    #
    class RejectTransitGatewayVpcAttachmentRequest < Struct.new(
      :transit_gateway_attachment_id,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] transit_gateway_vpc_attachment
    #   Information about the attachment.
    #   @return [Types::TransitGatewayVpcAttachment]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RejectTransitGatewayVpcAttachmentResult AWS API Documentation
    #
    class RejectTransitGatewayVpcAttachmentResult < Struct.new(
      :transit_gateway_vpc_attachment)
      include Aws::Structure
    end

    # @note When making an API call, you may pass RejectVpcEndpointConnectionsRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         service_id: "VpcEndpointServiceId", # required
    #         vpc_endpoint_ids: ["VpcEndpointId"], # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] service_id
    #   The ID of the service.
    #   @return [String]
    #
    # @!attribute [rw] vpc_endpoint_ids
    #   The IDs of one or more VPC endpoints.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RejectVpcEndpointConnectionsRequest AWS API Documentation
    #
    class RejectVpcEndpointConnectionsRequest < Struct.new(
      :dry_run,
      :service_id,
      :vpc_endpoint_ids)
      include Aws::Structure
    end

    # @!attribute [rw] unsuccessful
    #   Information about the endpoints that were not rejected, if
    #   applicable.
    #   @return [Array<Types::UnsuccessfulItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RejectVpcEndpointConnectionsResult AWS API Documentation
    #
    class RejectVpcEndpointConnectionsResult < Struct.new(
      :unsuccessful)
      include Aws::Structure
    end

    # @note When making an API call, you may pass RejectVpcPeeringConnectionRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         vpc_peering_connection_id: "VpcPeeringConnectionId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] vpc_peering_connection_id
    #   The ID of the VPC peering connection.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RejectVpcPeeringConnectionRequest AWS API Documentation
    #
    class RejectVpcPeeringConnectionRequest < Struct.new(
      :dry_run,
      :vpc_peering_connection_id)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RejectVpcPeeringConnectionResult AWS API Documentation
    #
    class RejectVpcPeeringConnectionResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ReleaseAddressRequest
    #   data as a hash:
    #
    #       {
    #         allocation_id: "AllocationId",
    #         public_ip: "String",
    #         network_border_group: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] allocation_id
    #   \[EC2-VPC\] The allocation ID. Required for EC2-VPC.
    #   @return [String]
    #
    # @!attribute [rw] public_ip
    #   \[EC2-Classic\] The Elastic IP address. Required for EC2-Classic.
    #   @return [String]
    #
    # @!attribute [rw] network_border_group
    #   The location that the IP address is released from.
    #
    #   If you provide an incorrect network border group, you will receive
    #   an `InvalidAddress.NotFound` error. For more information, see [Error
    #   Codes][1].
    #
    #   <note markdown="1"> You cannot use a network border group with EC2 Classic. If you
    #   attempt this operation on EC2 classic, you will receive an
    #   `InvalidParameterCombination` error. For more information, see
    #   [Error Codes][1].
    #
    #    </note>
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReleaseAddressRequest AWS API Documentation
    #
    class ReleaseAddressRequest < Struct.new(
      :allocation_id,
      :public_ip,
      :network_border_group,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ReleaseHostsRequest
    #   data as a hash:
    #
    #       {
    #         host_ids: ["DedicatedHostId"], # required
    #       }
    #
    # @!attribute [rw] host_ids
    #   The IDs of the Dedicated Hosts to release.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReleaseHostsRequest AWS API Documentation
    #
    class ReleaseHostsRequest < Struct.new(
      :host_ids)
      include Aws::Structure
    end

    # @!attribute [rw] successful
    #   The IDs of the Dedicated Hosts that were successfully released.
    #   @return [Array<String>]
    #
    # @!attribute [rw] unsuccessful
    #   The IDs of the Dedicated Hosts that could not be released, including
    #   an error message.
    #   @return [Array<Types::UnsuccessfulItem>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReleaseHostsResult AWS API Documentation
    #
    class ReleaseHostsResult < Struct.new(
      :successful,
      :unsuccessful)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ReplaceIamInstanceProfileAssociationRequest
    #   data as a hash:
    #
    #       {
    #         iam_instance_profile: { # required
    #           arn: "String",
    #           name: "String",
    #         },
    #         association_id: "IamInstanceProfileAssociationId", # required
    #       }
    #
    # @!attribute [rw] iam_instance_profile
    #   The IAM instance profile.
    #   @return [Types::IamInstanceProfileSpecification]
    #
    # @!attribute [rw] association_id
    #   The ID of the existing IAM instance profile association.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReplaceIamInstanceProfileAssociationRequest AWS API Documentation
    #
    class ReplaceIamInstanceProfileAssociationRequest < Struct.new(
      :iam_instance_profile,
      :association_id)
      include Aws::Structure
    end

    # @!attribute [rw] iam_instance_profile_association
    #   Information about the IAM instance profile association.
    #   @return [Types::IamInstanceProfileAssociation]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReplaceIamInstanceProfileAssociationResult AWS API Documentation
    #
    class ReplaceIamInstanceProfileAssociationResult < Struct.new(
      :iam_instance_profile_association)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ReplaceNetworkAclAssociationRequest
    #   data as a hash:
    #
    #       {
    #         association_id: "NetworkAclAssociationId", # required
    #         dry_run: false,
    #         network_acl_id: "NetworkAclId", # required
    #       }
    #
    # @!attribute [rw] association_id
    #   The ID of the current association between the original network ACL
    #   and the subnet.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] network_acl_id
    #   The ID of the new network ACL to associate with the subnet.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReplaceNetworkAclAssociationRequest AWS API Documentation
    #
    class ReplaceNetworkAclAssociationRequest < Struct.new(
      :association_id,
      :dry_run,
      :network_acl_id)
      include Aws::Structure
    end

    # @!attribute [rw] new_association_id
    #   The ID of the new association.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReplaceNetworkAclAssociationResult AWS API Documentation
    #
    class ReplaceNetworkAclAssociationResult < Struct.new(
      :new_association_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ReplaceNetworkAclEntryRequest
    #   data as a hash:
    #
    #       {
    #         cidr_block: "String",
    #         dry_run: false,
    #         egress: false, # required
    #         icmp_type_code: {
    #           code: 1,
    #           type: 1,
    #         },
    #         ipv_6_cidr_block: "String",
    #         network_acl_id: "NetworkAclId", # required
    #         port_range: {
    #           from: 1,
    #           to: 1,
    #         },
    #         protocol: "String", # required
    #         rule_action: "allow", # required, accepts allow, deny
    #         rule_number: 1, # required
    #       }
    #
    # @!attribute [rw] cidr_block
    #   The IPv4 network range to allow or deny, in CIDR notation (for
    #   example `172.16.0.0/24`).
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] egress
    #   Indicates whether to replace the egress rule.
    #
    #   Default: If no value is specified, we replace the ingress rule.
    #   @return [Boolean]
    #
    # @!attribute [rw] icmp_type_code
    #   ICMP protocol: The ICMP or ICMPv6 type and code. Required if
    #   specifying protocol 1 (ICMP) or protocol 58 (ICMPv6) with an IPv6
    #   CIDR block.
    #   @return [Types::IcmpTypeCode]
    #
    # @!attribute [rw] ipv_6_cidr_block
    #   The IPv6 network range to allow or deny, in CIDR notation (for
    #   example `2001:bd8:1234:1a00::/64`).
    #   @return [String]
    #
    # @!attribute [rw] network_acl_id
    #   The ID of the ACL.
    #   @return [String]
    #
    # @!attribute [rw] port_range
    #   TCP or UDP protocols: The range of ports the rule applies to.
    #   Required if specifying protocol 6 (TCP) or 17 (UDP).
    #   @return [Types::PortRange]
    #
    # @!attribute [rw] protocol
    #   The protocol number. A value of "-1" means all protocols. If you
    #   specify "-1" or a protocol number other than "6" (TCP), "17"
    #   (UDP), or "1" (ICMP), traffic on all ports is allowed, regardless
    #   of any ports or ICMP types or codes that you specify. If you specify
    #   protocol "58" (ICMPv6) and specify an IPv4 CIDR block, traffic for
    #   all ICMP types and codes allowed, regardless of any that you
    #   specify. If you specify protocol "58" (ICMPv6) and specify an IPv6
    #   CIDR block, you must specify an ICMP type and code.
    #   @return [String]
    #
    # @!attribute [rw] rule_action
    #   Indicates whether to allow or deny the traffic that matches the
    #   rule.
    #   @return [String]
    #
    # @!attribute [rw] rule_number
    #   The rule number of the entry to replace.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReplaceNetworkAclEntryRequest AWS API Documentation
    #
    class ReplaceNetworkAclEntryRequest < Struct.new(
      :cidr_block,
      :dry_run,
      :egress,
      :icmp_type_code,
      :ipv_6_cidr_block,
      :network_acl_id,
      :port_range,
      :protocol,
      :rule_action,
      :rule_number)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ReplaceRouteRequest
    #   data as a hash:
    #
    #       {
    #         destination_cidr_block: "String",
    #         destination_ipv_6_cidr_block: "String",
    #         dry_run: false,
    #         egress_only_internet_gateway_id: "EgressOnlyInternetGatewayId",
    #         gateway_id: "RouteGatewayId",
    #         instance_id: "InstanceId",
    #         local_target: false,
    #         nat_gateway_id: "NatGatewayId",
    #         transit_gateway_id: "TransitGatewayId",
    #         local_gateway_id: "LocalGatewayId",
    #         network_interface_id: "NetworkInterfaceId",
    #         route_table_id: "RouteTableId", # required
    #         vpc_peering_connection_id: "VpcPeeringConnectionId",
    #       }
    #
    # @!attribute [rw] destination_cidr_block
    #   The IPv4 CIDR address block used for the destination match. The
    #   value that you provide must match the CIDR of an existing route in
    #   the table.
    #   @return [String]
    #
    # @!attribute [rw] destination_ipv_6_cidr_block
    #   The IPv6 CIDR address block used for the destination match. The
    #   value that you provide must match the CIDR of an existing route in
    #   the table.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] egress_only_internet_gateway_id
    #   \[IPv6 traffic only\] The ID of an egress-only internet gateway.
    #   @return [String]
    #
    # @!attribute [rw] gateway_id
    #   The ID of an internet gateway or virtual private gateway.
    #   @return [String]
    #
    # @!attribute [rw] instance_id
    #   The ID of a NAT instance in your VPC.
    #   @return [String]
    #
    # @!attribute [rw] local_target
    #   Specifies whether to reset the local route to its default target
    #   (`local`).
    #   @return [Boolean]
    #
    # @!attribute [rw] nat_gateway_id
    #   \[IPv4 traffic only\] The ID of a NAT gateway.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of a transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] local_gateway_id
    #   The ID of the local gateway.
    #   @return [String]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of a network interface.
    #   @return [String]
    #
    # @!attribute [rw] route_table_id
    #   The ID of the route table.
    #   @return [String]
    #
    # @!attribute [rw] vpc_peering_connection_id
    #   The ID of a VPC peering connection.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReplaceRouteRequest AWS API Documentation
    #
    class ReplaceRouteRequest < Struct.new(
      :destination_cidr_block,
      :destination_ipv_6_cidr_block,
      :dry_run,
      :egress_only_internet_gateway_id,
      :gateway_id,
      :instance_id,
      :local_target,
      :nat_gateway_id,
      :transit_gateway_id,
      :local_gateway_id,
      :network_interface_id,
      :route_table_id,
      :vpc_peering_connection_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ReplaceRouteTableAssociationRequest
    #   data as a hash:
    #
    #       {
    #         association_id: "RouteTableAssociationId", # required
    #         dry_run: false,
    #         route_table_id: "RouteTableId", # required
    #       }
    #
    # @!attribute [rw] association_id
    #   The association ID.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] route_table_id
    #   The ID of the new route table to associate with the subnet.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReplaceRouteTableAssociationRequest AWS API Documentation
    #
    class ReplaceRouteTableAssociationRequest < Struct.new(
      :association_id,
      :dry_run,
      :route_table_id)
      include Aws::Structure
    end

    # @!attribute [rw] new_association_id
    #   The ID of the new association.
    #   @return [String]
    #
    # @!attribute [rw] association_state
    #   The state of the association.
    #   @return [Types::RouteTableAssociationState]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReplaceRouteTableAssociationResult AWS API Documentation
    #
    class ReplaceRouteTableAssociationResult < Struct.new(
      :new_association_id,
      :association_state)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ReplaceTransitGatewayRouteRequest
    #   data as a hash:
    #
    #       {
    #         destination_cidr_block: "String", # required
    #         transit_gateway_route_table_id: "TransitGatewayRouteTableId", # required
    #         transit_gateway_attachment_id: "TransitGatewayAttachmentId",
    #         blackhole: false,
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] destination_cidr_block
    #   The CIDR range used for the destination match. Routing decisions are
    #   based on the most specific match.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the route table.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] blackhole
    #   Indicates whether traffic matching this route is to be dropped.
    #   @return [Boolean]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReplaceTransitGatewayRouteRequest AWS API Documentation
    #
    class ReplaceTransitGatewayRouteRequest < Struct.new(
      :destination_cidr_block,
      :transit_gateway_route_table_id,
      :transit_gateway_attachment_id,
      :blackhole,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] route
    #   Information about the modified route.
    #   @return [Types::TransitGatewayRoute]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReplaceTransitGatewayRouteResult AWS API Documentation
    #
    class ReplaceTransitGatewayRouteResult < Struct.new(
      :route)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ReportInstanceStatusRequest
    #   data as a hash:
    #
    #       {
    #         description: "String",
    #         dry_run: false,
    #         end_time: Time.now,
    #         instances: ["InstanceId"], # required
    #         reason_codes: ["instance-stuck-in-state"], # required, accepts instance-stuck-in-state, unresponsive, not-accepting-credentials, password-not-available, performance-network, performance-instance-store, performance-ebs-volume, performance-other, other
    #         start_time: Time.now,
    #         status: "ok", # required, accepts ok, impaired
    #       }
    #
    # @!attribute [rw] description
    #   Descriptive text about the health state of your instance.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] end_time
    #   The time at which the reported instance health state ended.
    #   @return [Time]
    #
    # @!attribute [rw] instances
    #   The instances.
    #   @return [Array<String>]
    #
    # @!attribute [rw] reason_codes
    #   The reason codes that describe the health state of your instance.
    #
    #   * `instance-stuck-in-state`\: My instance is stuck in a state.
    #
    #   * `unresponsive`\: My instance is unresponsive.
    #
    #   * `not-accepting-credentials`\: My instance is not accepting my
    #     credentials.
    #
    #   * `password-not-available`\: A password is not available for my
    #     instance.
    #
    #   * `performance-network`\: My instance is experiencing performance
    #     problems that I believe are network related.
    #
    #   * `performance-instance-store`\: My instance is experiencing
    #     performance problems that I believe are related to the instance
    #     stores.
    #
    #   * `performance-ebs-volume`\: My instance is experiencing performance
    #     problems that I believe are related to an EBS volume.
    #
    #   * `performance-other`\: My instance is experiencing performance
    #     problems.
    #
    #   * `other`\: \[explain using the description parameter\]
    #   @return [Array<String>]
    #
    # @!attribute [rw] start_time
    #   The time at which the reported instance health state began.
    #   @return [Time]
    #
    # @!attribute [rw] status
    #   The status of all instances listed.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReportInstanceStatusRequest AWS API Documentation
    #
    class ReportInstanceStatusRequest < Struct.new(
      :description,
      :dry_run,
      :end_time,
      :instances,
      :reason_codes,
      :start_time,
      :status)
      include Aws::Structure
    end

    # The information to include in the launch template.
    #
    # @note When making an API call, you may pass RequestLaunchTemplateData
    #   data as a hash:
    #
    #       {
    #         kernel_id: "KernelId",
    #         ebs_optimized: false,
    #         iam_instance_profile: {
    #           arn: "String",
    #           name: "String",
    #         },
    #         block_device_mappings: [
    #           {
    #             device_name: "String",
    #             virtual_name: "String",
    #             ebs: {
    #               encrypted: false,
    #               delete_on_termination: false,
    #               iops: 1,
    #               kms_key_id: "KmsKeyId",
    #               snapshot_id: "SnapshotId",
    #               volume_size: 1,
    #               volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #             },
    #             no_device: "String",
    #           },
    #         ],
    #         network_interfaces: [
    #           {
    #             associate_public_ip_address: false,
    #             delete_on_termination: false,
    #             description: "String",
    #             device_index: 1,
    #             groups: ["SecurityGroupId"],
    #             interface_type: "String",
    #             ipv_6_address_count: 1,
    #             ipv_6_addresses: [
    #               {
    #                 ipv_6_address: "String",
    #               },
    #             ],
    #             network_interface_id: "NetworkInterfaceId",
    #             private_ip_address: "String",
    #             private_ip_addresses: [
    #               {
    #                 primary: false,
    #                 private_ip_address: "String",
    #               },
    #             ],
    #             secondary_private_ip_address_count: 1,
    #             subnet_id: "SubnetId",
    #           },
    #         ],
    #         image_id: "ImageId",
    #         instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #         key_name: "KeyPairName",
    #         monitoring: {
    #           enabled: false,
    #         },
    #         placement: {
    #           availability_zone: "String",
    #           affinity: "String",
    #           group_name: "PlacementGroupName",
    #           host_id: "DedicatedHostId",
    #           tenancy: "default", # accepts default, dedicated, host
    #           spread_domain: "String",
    #           host_resource_group_arn: "String",
    #           partition_number: 1,
    #         },
    #         ram_disk_id: "RamdiskId",
    #         disable_api_termination: false,
    #         instance_initiated_shutdown_behavior: "stop", # accepts stop, terminate
    #         user_data: "String",
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         elastic_gpu_specifications: [
    #           {
    #             type: "String", # required
    #           },
    #         ],
    #         elastic_inference_accelerators: [
    #           {
    #             type: "String", # required
    #             count: 1,
    #           },
    #         ],
    #         security_group_ids: ["SecurityGroupId"],
    #         security_groups: ["SecurityGroupName"],
    #         instance_market_options: {
    #           market_type: "spot", # accepts spot
    #           spot_options: {
    #             max_price: "String",
    #             spot_instance_type: "one-time", # accepts one-time, persistent
    #             block_duration_minutes: 1,
    #             valid_until: Time.now,
    #             instance_interruption_behavior: "hibernate", # accepts hibernate, stop, terminate
    #           },
    #         },
    #         credit_specification: {
    #           cpu_credits: "String", # required
    #         },
    #         cpu_options: {
    #           core_count: 1,
    #           threads_per_core: 1,
    #         },
    #         capacity_reservation_specification: {
    #           capacity_reservation_preference: "open", # accepts open, none
    #           capacity_reservation_target: {
    #             capacity_reservation_id: "CapacityReservationId",
    #           },
    #         },
    #         license_specifications: [
    #           {
    #             license_configuration_arn: "String",
    #           },
    #         ],
    #         hibernation_options: {
    #           configured: false,
    #         },
    #         metadata_options: {
    #           http_tokens: "optional", # accepts optional, required
    #           http_put_response_hop_limit: 1,
    #           http_endpoint: "disabled", # accepts disabled, enabled
    #         },
    #       }
    #
    # @!attribute [rw] kernel_id
    #   The ID of the kernel.
    #
    #   We recommend that you use PV-GRUB instead of kernels and RAM disks.
    #   For more information, see [User Provided Kernels][1] in the *Amazon
    #   Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedkernels.html
    #   @return [String]
    #
    # @!attribute [rw] ebs_optimized
    #   Indicates whether the instance is optimized for Amazon EBS I/O. This
    #   optimization provides dedicated throughput to Amazon EBS and an
    #   optimized configuration stack to provide optimal Amazon EBS I/O
    #   performance. This optimization isn't available with all instance
    #   types. Additional usage charges apply when using an EBS-optimized
    #   instance.
    #   @return [Boolean]
    #
    # @!attribute [rw] iam_instance_profile
    #   The IAM instance profile.
    #   @return [Types::LaunchTemplateIamInstanceProfileSpecificationRequest]
    #
    # @!attribute [rw] block_device_mappings
    #   The block device mapping.
    #   @return [Array<Types::LaunchTemplateBlockDeviceMappingRequest>]
    #
    # @!attribute [rw] network_interfaces
    #   One or more network interfaces. If you specify a network interface,
    #   you must specify any security groups and subnets as part of the
    #   network interface.
    #   @return [Array<Types::LaunchTemplateInstanceNetworkInterfaceSpecificationRequest>]
    #
    # @!attribute [rw] image_id
    #   The ID of the AMI.
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   The instance type. For more information, see [Instance Types][1] in
    #   the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html
    #   @return [String]
    #
    # @!attribute [rw] key_name
    #   The name of the key pair. You can create a key pair using
    #   [CreateKeyPair][1] or [ImportKeyPair][2].
    #
    #   If you do not specify a key pair, you can't connect to the instance
    #   unless you choose an AMI that is configured to allow users another
    #   way to log in.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateKeyPair.html
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ImportKeyPair.html
    #   @return [String]
    #
    # @!attribute [rw] monitoring
    #   The monitoring for the instance.
    #   @return [Types::LaunchTemplatesMonitoringRequest]
    #
    # @!attribute [rw] placement
    #   The placement for the instance.
    #   @return [Types::LaunchTemplatePlacementRequest]
    #
    # @!attribute [rw] ram_disk_id
    #   The ID of the RAM disk.
    #
    #   We recommend that you use PV-GRUB instead of kernels and RAM disks.
    #   For more information, see [User Provided Kernels][1] in the *Amazon
    #   Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedkernels.html
    #   @return [String]
    #
    # @!attribute [rw] disable_api_termination
    #   If you set this parameter to `true`, you can't terminate the
    #   instance using the Amazon EC2 console, CLI, or API; otherwise, you
    #   can. To change this attribute after launch, use
    #   [ModifyInstanceAttribute][1]. Alternatively, if you set
    #   `InstanceInitiatedShutdownBehavior` to `terminate`, you can
    #   terminate the instance by running the shutdown command from the
    #   instance.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ModifyInstanceAttribute.html
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_initiated_shutdown_behavior
    #   Indicates whether an instance stops or terminates when you initiate
    #   shutdown from the instance (using the operating system command for
    #   system shutdown).
    #
    #   Default: `stop`
    #   @return [String]
    #
    # @!attribute [rw] user_data
    #   The Base64-encoded user data to make available to the instance. For
    #   more information, see [Running Commands on Your Linux Instance at
    #   Launch][1] (Linux) and [Adding User Data][2] (Windows).
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/user-data.html
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/WindowsGuide/ec2-instance-metadata.html#instancedata-add-user-data
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the resources during launch. You can only tag
    #   instances and volumes on launch. The specified tags are applied to
    #   all instances or volumes that are created during launch. To tag a
    #   resource after it has been created, see [CreateTags][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html
    #   @return [Array<Types::LaunchTemplateTagSpecificationRequest>]
    #
    # @!attribute [rw] elastic_gpu_specifications
    #   An elastic GPU to associate with the instance.
    #   @return [Array<Types::ElasticGpuSpecification>]
    #
    # @!attribute [rw] elastic_inference_accelerators
    #   The elastic inference accelerator for the instance.
    #   @return [Array<Types::LaunchTemplateElasticInferenceAccelerator>]
    #
    # @!attribute [rw] security_group_ids
    #   One or more security group IDs. You can create a security group
    #   using [CreateSecurityGroup][1]. You cannot specify both a security
    #   group ID and security name in the same request.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateSecurityGroup.html
    #   @return [Array<String>]
    #
    # @!attribute [rw] security_groups
    #   \[EC2-Classic, default VPC\] One or more security group names. For a
    #   nondefault VPC, you must use security group IDs instead. You cannot
    #   specify both a security group ID and security name in the same
    #   request.
    #   @return [Array<String>]
    #
    # @!attribute [rw] instance_market_options
    #   The market (purchasing) option for the instances.
    #   @return [Types::LaunchTemplateInstanceMarketOptionsRequest]
    #
    # @!attribute [rw] credit_specification
    #   The credit option for CPU usage of the instance. Valid for T2 or T3
    #   instances only.
    #   @return [Types::CreditSpecificationRequest]
    #
    # @!attribute [rw] cpu_options
    #   The CPU options for the instance. For more information, see
    #   [Optimizing CPU Options][1] in the *Amazon Elastic Compute Cloud
    #   User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html
    #   @return [Types::LaunchTemplateCpuOptionsRequest]
    #
    # @!attribute [rw] capacity_reservation_specification
    #   The Capacity Reservation targeting option. If you do not specify
    #   this parameter, the instance's Capacity Reservation preference
    #   defaults to `open`, which enables it to run in any open Capacity
    #   Reservation that has matching attributes (instance type, platform,
    #   Availability Zone).
    #   @return [Types::LaunchTemplateCapacityReservationSpecificationRequest]
    #
    # @!attribute [rw] license_specifications
    #   The license configurations.
    #   @return [Array<Types::LaunchTemplateLicenseConfigurationRequest>]
    #
    # @!attribute [rw] hibernation_options
    #   Indicates whether an instance is enabled for hibernation. This
    #   parameter is valid only if the instance meets the [hibernation
    #   prerequisites][1]. For more information, see [Hibernate Your
    #   Instance][2] in the *Amazon Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html#hibernating-prerequisites
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html
    #   @return [Types::LaunchTemplateHibernationOptionsRequest]
    #
    # @!attribute [rw] metadata_options
    #   The metadata options for the instance. For more information, see
    #   [Instance Metadata and User Data][1] in the *Amazon Elastic Compute
    #   Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-instance-metadata.html
    #   @return [Types::LaunchTemplateInstanceMetadataOptionsRequest]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RequestLaunchTemplateData AWS API Documentation
    #
    class RequestLaunchTemplateData < Struct.new(
      :kernel_id,
      :ebs_optimized,
      :iam_instance_profile,
      :block_device_mappings,
      :network_interfaces,
      :image_id,
      :instance_type,
      :key_name,
      :monitoring,
      :placement,
      :ram_disk_id,
      :disable_api_termination,
      :instance_initiated_shutdown_behavior,
      :user_data,
      :tag_specifications,
      :elastic_gpu_specifications,
      :elastic_inference_accelerators,
      :security_group_ids,
      :security_groups,
      :instance_market_options,
      :credit_specification,
      :cpu_options,
      :capacity_reservation_specification,
      :license_specifications,
      :hibernation_options,
      :metadata_options)
      include Aws::Structure
    end

    # Contains the parameters for RequestSpotFleet.
    #
    # @note When making an API call, you may pass RequestSpotFleetRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         spot_fleet_request_config: { # required
    #           allocation_strategy: "lowestPrice", # accepts lowestPrice, diversified, capacityOptimized
    #           on_demand_allocation_strategy: "lowestPrice", # accepts lowestPrice, prioritized
    #           client_token: "String",
    #           excess_capacity_termination_policy: "noTermination", # accepts noTermination, default
    #           fulfilled_capacity: 1.0,
    #           on_demand_fulfilled_capacity: 1.0,
    #           iam_fleet_role: "String", # required
    #           launch_specifications: [
    #             {
    #               security_groups: [
    #                 {
    #                   group_name: "String",
    #                   group_id: "String",
    #                 },
    #               ],
    #               addressing_type: "String",
    #               block_device_mappings: [
    #                 {
    #                   device_name: "String",
    #                   virtual_name: "String",
    #                   ebs: {
    #                     delete_on_termination: false,
    #                     iops: 1,
    #                     snapshot_id: "String",
    #                     volume_size: 1,
    #                     volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #                     kms_key_id: "String",
    #                     encrypted: false,
    #                   },
    #                   no_device: "String",
    #                 },
    #               ],
    #               ebs_optimized: false,
    #               iam_instance_profile: {
    #                 arn: "String",
    #                 name: "String",
    #               },
    #               image_id: "String",
    #               instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #               kernel_id: "String",
    #               key_name: "String",
    #               monitoring: {
    #                 enabled: false,
    #               },
    #               network_interfaces: [
    #                 {
    #                   associate_public_ip_address: false,
    #                   delete_on_termination: false,
    #                   description: "String",
    #                   device_index: 1,
    #                   groups: ["SecurityGroupId"],
    #                   ipv_6_address_count: 1,
    #                   ipv_6_addresses: [
    #                     {
    #                       ipv_6_address: "String",
    #                     },
    #                   ],
    #                   network_interface_id: "String",
    #                   private_ip_address: "String",
    #                   private_ip_addresses: [
    #                     {
    #                       primary: false,
    #                       private_ip_address: "String",
    #                     },
    #                   ],
    #                   secondary_private_ip_address_count: 1,
    #                   subnet_id: "String",
    #                   interface_type: "String",
    #                 },
    #               ],
    #               placement: {
    #                 availability_zone: "String",
    #                 group_name: "String",
    #                 tenancy: "default", # accepts default, dedicated, host
    #               },
    #               ramdisk_id: "String",
    #               spot_price: "String",
    #               subnet_id: "String",
    #               user_data: "String",
    #               weighted_capacity: 1.0,
    #               tag_specifications: [
    #                 {
    #                   resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #                   tags: [
    #                     {
    #                       key: "String",
    #                       value: "String",
    #                     },
    #                   ],
    #                 },
    #               ],
    #             },
    #           ],
    #           launch_template_configs: [
    #             {
    #               launch_template_specification: {
    #                 launch_template_id: "String",
    #                 launch_template_name: "LaunchTemplateName",
    #                 version: "String",
    #               },
    #               overrides: [
    #                 {
    #                   instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #                   spot_price: "String",
    #                   subnet_id: "String",
    #                   availability_zone: "String",
    #                   weighted_capacity: 1.0,
    #                   priority: 1.0,
    #                 },
    #               ],
    #             },
    #           ],
    #           spot_price: "String",
    #           target_capacity: 1, # required
    #           on_demand_target_capacity: 1,
    #           on_demand_max_total_price: "String",
    #           spot_max_total_price: "String",
    #           terminate_instances_with_expiration: false,
    #           type: "request", # accepts request, maintain, instant
    #           valid_from: Time.now,
    #           valid_until: Time.now,
    #           replace_unhealthy_instances: false,
    #           instance_interruption_behavior: "hibernate", # accepts hibernate, stop, terminate
    #           load_balancers_config: {
    #             classic_load_balancers_config: {
    #               classic_load_balancers: [
    #                 {
    #                   name: "String",
    #                 },
    #               ],
    #             },
    #             target_groups_config: {
    #               target_groups: [
    #                 {
    #                   arn: "String",
    #                 },
    #               ],
    #             },
    #           },
    #           instance_pools_to_use_count: 1,
    #           tag_specifications: [
    #             {
    #               resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #               tags: [
    #                 {
    #                   key: "String",
    #                   value: "String",
    #                 },
    #               ],
    #             },
    #           ],
    #         },
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] spot_fleet_request_config
    #   The configuration for the Spot Fleet request.
    #   @return [Types::SpotFleetRequestConfigData]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RequestSpotFleetRequest AWS API Documentation
    #
    class RequestSpotFleetRequest < Struct.new(
      :dry_run,
      :spot_fleet_request_config)
      include Aws::Structure
    end

    # Contains the output of RequestSpotFleet.
    #
    # @!attribute [rw] spot_fleet_request_id
    #   The ID of the Spot Fleet request.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RequestSpotFleetResponse AWS API Documentation
    #
    class RequestSpotFleetResponse < Struct.new(
      :spot_fleet_request_id)
      include Aws::Structure
    end

    # Contains the parameters for RequestSpotInstances.
    #
    # @note When making an API call, you may pass RequestSpotInstancesRequest
    #   data as a hash:
    #
    #       {
    #         availability_zone_group: "String",
    #         block_duration_minutes: 1,
    #         client_token: "String",
    #         dry_run: false,
    #         instance_count: 1,
    #         launch_group: "String",
    #         launch_specification: {
    #           security_group_ids: ["SecurityGroupId"],
    #           security_groups: ["SecurityGroupName"],
    #           addressing_type: "String",
    #           block_device_mappings: [
    #             {
    #               device_name: "String",
    #               virtual_name: "String",
    #               ebs: {
    #                 delete_on_termination: false,
    #                 iops: 1,
    #                 snapshot_id: "String",
    #                 volume_size: 1,
    #                 volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #                 kms_key_id: "String",
    #                 encrypted: false,
    #               },
    #               no_device: "String",
    #             },
    #           ],
    #           ebs_optimized: false,
    #           iam_instance_profile: {
    #             arn: "String",
    #             name: "String",
    #           },
    #           image_id: "ImageId",
    #           instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #           kernel_id: "KernelId",
    #           key_name: "KeyPairName",
    #           monitoring: {
    #             enabled: false, # required
    #           },
    #           network_interfaces: [
    #             {
    #               associate_public_ip_address: false,
    #               delete_on_termination: false,
    #               description: "String",
    #               device_index: 1,
    #               groups: ["SecurityGroupId"],
    #               ipv_6_address_count: 1,
    #               ipv_6_addresses: [
    #                 {
    #                   ipv_6_address: "String",
    #                 },
    #               ],
    #               network_interface_id: "String",
    #               private_ip_address: "String",
    #               private_ip_addresses: [
    #                 {
    #                   primary: false,
    #                   private_ip_address: "String",
    #                 },
    #               ],
    #               secondary_private_ip_address_count: 1,
    #               subnet_id: "String",
    #               interface_type: "String",
    #             },
    #           ],
    #           placement: {
    #             availability_zone: "String",
    #             group_name: "String",
    #             tenancy: "default", # accepts default, dedicated, host
    #           },
    #           ramdisk_id: "RamdiskId",
    #           subnet_id: "SubnetId",
    #           user_data: "String",
    #         },
    #         spot_price: "String",
    #         type: "one-time", # accepts one-time, persistent
    #         valid_from: Time.now,
    #         valid_until: Time.now,
    #         instance_interruption_behavior: "hibernate", # accepts hibernate, stop, terminate
    #       }
    #
    # @!attribute [rw] availability_zone_group
    #   The user-specified name for a logical grouping of requests.
    #
    #   When you specify an Availability Zone group in a Spot Instance
    #   request, all Spot Instances in the request are launched in the same
    #   Availability Zone. Instance proximity is maintained with this
    #   parameter, but the choice of Availability Zone is not. The group
    #   applies only to requests for Spot Instances of the same instance
    #   type. Any additional Spot Instance requests that are specified with
    #   the same Availability Zone group name are launched in that same
    #   Availability Zone, as long as at least one instance from the group
    #   is still active.
    #
    #   If there is no active instance running in the Availability Zone
    #   group that you specify for a new Spot Instance request (all
    #   instances are terminated, the request is expired, or the maximum
    #   price you specified falls below current Spot price), then Amazon EC2
    #   launches the instance in any Availability Zone where the constraint
    #   can be met. Consequently, the subsequent set of Spot Instances could
    #   be placed in a different zone from the original request, even if you
    #   specified the same Availability Zone group.
    #
    #   Default: Instances are launched in any available Availability Zone.
    #   @return [String]
    #
    # @!attribute [rw] block_duration_minutes
    #   The required duration for the Spot Instances (also known as Spot
    #   blocks), in minutes. This value must be a multiple of 60 (60, 120,
    #   180, 240, 300, or 360).
    #
    #   The duration period starts as soon as your Spot Instance receives
    #   its instance ID. At the end of the duration period, Amazon EC2 marks
    #   the Spot Instance for termination and provides a Spot Instance
    #   termination notice, which gives the instance a two-minute warning
    #   before it terminates.
    #
    #   You can't specify an Availability Zone group or a launch group if
    #   you specify a duration.
    #   @return [Integer]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of the request. For more information, see [How to Ensure
    #   Idempotency][1] in the *Amazon EC2 User Guide for Linux Instances*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_count
    #   The maximum number of Spot Instances to launch.
    #
    #   Default: 1
    #   @return [Integer]
    #
    # @!attribute [rw] launch_group
    #   The instance launch group. Launch groups are Spot Instances that
    #   launch together and terminate together.
    #
    #   Default: Instances are launched and terminated individually
    #   @return [String]
    #
    # @!attribute [rw] launch_specification
    #   The launch specification.
    #   @return [Types::RequestSpotLaunchSpecification]
    #
    # @!attribute [rw] spot_price
    #   The maximum price per hour that you are willing to pay for a Spot
    #   Instance. The default is the On-Demand price.
    #   @return [String]
    #
    # @!attribute [rw] type
    #   The Spot Instance request type.
    #
    #   Default: `one-time`
    #   @return [String]
    #
    # @!attribute [rw] valid_from
    #   The start date of the request. If this is a one-time request, the
    #   request becomes active at this date and time and remains active
    #   until all instances launch, the request expires, or the request is
    #   canceled. If the request is persistent, the request becomes active
    #   at this date and time and remains active until it expires or is
    #   canceled.
    #
    #   The specified start date and time cannot be equal to the current
    #   date and time. You must specify a start date and time that occurs
    #   after the current date and time.
    #   @return [Time]
    #
    # @!attribute [rw] valid_until
    #   The end date of the request. If this is a one-time request, the
    #   request remains active until all instances launch, the request is
    #   canceled, or this date is reached. If the request is persistent, it
    #   remains active until it is canceled or this date is reached. The
    #   default end date is 7 days from the current date.
    #   @return [Time]
    #
    # @!attribute [rw] instance_interruption_behavior
    #   The behavior when a Spot Instance is interrupted. The default is
    #   `terminate`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RequestSpotInstancesRequest AWS API Documentation
    #
    class RequestSpotInstancesRequest < Struct.new(
      :availability_zone_group,
      :block_duration_minutes,
      :client_token,
      :dry_run,
      :instance_count,
      :launch_group,
      :launch_specification,
      :spot_price,
      :type,
      :valid_from,
      :valid_until,
      :instance_interruption_behavior)
      include Aws::Structure
    end

    # Contains the output of RequestSpotInstances.
    #
    # @!attribute [rw] spot_instance_requests
    #   One or more Spot Instance requests.
    #   @return [Array<Types::SpotInstanceRequest>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RequestSpotInstancesResult AWS API Documentation
    #
    class RequestSpotInstancesResult < Struct.new(
      :spot_instance_requests)
      include Aws::Structure
    end

    # Describes the launch specification for an instance.
    #
    # @note When making an API call, you may pass RequestSpotLaunchSpecification
    #   data as a hash:
    #
    #       {
    #         security_group_ids: ["SecurityGroupId"],
    #         security_groups: ["SecurityGroupName"],
    #         addressing_type: "String",
    #         block_device_mappings: [
    #           {
    #             device_name: "String",
    #             virtual_name: "String",
    #             ebs: {
    #               delete_on_termination: false,
    #               iops: 1,
    #               snapshot_id: "String",
    #               volume_size: 1,
    #               volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #               kms_key_id: "String",
    #               encrypted: false,
    #             },
    #             no_device: "String",
    #           },
    #         ],
    #         ebs_optimized: false,
    #         iam_instance_profile: {
    #           arn: "String",
    #           name: "String",
    #         },
    #         image_id: "ImageId",
    #         instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #         kernel_id: "KernelId",
    #         key_name: "KeyPairName",
    #         monitoring: {
    #           enabled: false, # required
    #         },
    #         network_interfaces: [
    #           {
    #             associate_public_ip_address: false,
    #             delete_on_termination: false,
    #             description: "String",
    #             device_index: 1,
    #             groups: ["SecurityGroupId"],
    #             ipv_6_address_count: 1,
    #             ipv_6_addresses: [
    #               {
    #                 ipv_6_address: "String",
    #               },
    #             ],
    #             network_interface_id: "String",
    #             private_ip_address: "String",
    #             private_ip_addresses: [
    #               {
    #                 primary: false,
    #                 private_ip_address: "String",
    #               },
    #             ],
    #             secondary_private_ip_address_count: 1,
    #             subnet_id: "String",
    #             interface_type: "String",
    #           },
    #         ],
    #         placement: {
    #           availability_zone: "String",
    #           group_name: "String",
    #           tenancy: "default", # accepts default, dedicated, host
    #         },
    #         ramdisk_id: "RamdiskId",
    #         subnet_id: "SubnetId",
    #         user_data: "String",
    #       }
    #
    # @!attribute [rw] security_group_ids
    #   One or more security group IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] security_groups
    #   One or more security groups. When requesting instances in a VPC, you
    #   must specify the IDs of the security groups. When requesting
    #   instances in EC2-Classic, you can specify the names or the IDs of
    #   the security groups.
    #   @return [Array<String>]
    #
    # @!attribute [rw] addressing_type
    #   Deprecated.
    #   @return [String]
    #
    # @!attribute [rw] block_device_mappings
    #   One or more block device mapping entries. You can't specify both a
    #   snapshot ID and an encryption value. This is because only blank
    #   volumes can be encrypted on creation. If a snapshot is the basis for
    #   a volume, it is not blank and its encryption status is used for the
    #   volume encryption status.
    #   @return [Array<Types::BlockDeviceMapping>]
    #
    # @!attribute [rw] ebs_optimized
    #   Indicates whether the instance is optimized for EBS I/O. This
    #   optimization provides dedicated throughput to Amazon EBS and an
    #   optimized configuration stack to provide optimal EBS I/O
    #   performance. This optimization isn't available with all instance
    #   types. Additional usage charges apply when using an EBS Optimized
    #   instance.
    #
    #   Default: `false`
    #   @return [Boolean]
    #
    # @!attribute [rw] iam_instance_profile
    #   The IAM instance profile.
    #   @return [Types::IamInstanceProfileSpecification]
    #
    # @!attribute [rw] image_id
    #   The ID of the AMI.
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   The instance type.
    #   @return [String]
    #
    # @!attribute [rw] kernel_id
    #   The ID of the kernel.
    #   @return [String]
    #
    # @!attribute [rw] key_name
    #   The name of the key pair.
    #   @return [String]
    #
    # @!attribute [rw] monitoring
    #   Indicates whether basic or detailed monitoring is enabled for the
    #   instance.
    #
    #   Default: Disabled
    #   @return [Types::RunInstancesMonitoringEnabled]
    #
    # @!attribute [rw] network_interfaces
    #   One or more network interfaces. If you specify a network interface,
    #   you must specify subnet IDs and security group IDs using the network
    #   interface.
    #   @return [Array<Types::InstanceNetworkInterfaceSpecification>]
    #
    # @!attribute [rw] placement
    #   The placement information for the instance.
    #   @return [Types::SpotPlacement]
    #
    # @!attribute [rw] ramdisk_id
    #   The ID of the RAM disk.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The IDs of the subnets in which to launch the instance. To specify
    #   multiple subnets, separate them using commas; for example,
    #   "subnet-1234abcdeexample1, subnet-0987cdef6example2".
    #   @return [String]
    #
    # @!attribute [rw] user_data
    #   The Base64-encoded user data for the instance. User data is limited
    #   to 16 KB.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RequestSpotLaunchSpecification AWS API Documentation
    #
    class RequestSpotLaunchSpecification < Struct.new(
      :security_group_ids,
      :security_groups,
      :addressing_type,
      :block_device_mappings,
      :ebs_optimized,
      :iam_instance_profile,
      :image_id,
      :instance_type,
      :kernel_id,
      :key_name,
      :monitoring,
      :network_interfaces,
      :placement,
      :ramdisk_id,
      :subnet_id,
      :user_data)
      include Aws::Structure
    end

    # Describes a reservation.
    #
    # @!attribute [rw] groups
    #   \[EC2-Classic only\] The security groups.
    #   @return [Array<Types::GroupIdentifier>]
    #
    # @!attribute [rw] instances
    #   The instances.
    #   @return [Array<Types::Instance>]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account that owns the reservation.
    #   @return [String]
    #
    # @!attribute [rw] requester_id
    #   The ID of the requester that launched the instances on your behalf
    #   (for example, AWS Management Console or Auto Scaling).
    #   @return [String]
    #
    # @!attribute [rw] reservation_id
    #   The ID of the reservation.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Reservation AWS API Documentation
    #
    class Reservation < Struct.new(
      :groups,
      :instances,
      :owner_id,
      :requester_id,
      :reservation_id)
      include Aws::Structure
    end

    # The cost associated with the Reserved Instance.
    #
    # @!attribute [rw] hourly_price
    #   The hourly rate of the reservation.
    #   @return [String]
    #
    # @!attribute [rw] remaining_total_value
    #   The balance of the total value (the sum of remainingUpfrontValue +
    #   hourlyPrice * number of hours remaining).
    #   @return [String]
    #
    # @!attribute [rw] remaining_upfront_value
    #   The remaining upfront cost of the reservation.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReservationValue AWS API Documentation
    #
    class ReservationValue < Struct.new(
      :hourly_price,
      :remaining_total_value,
      :remaining_upfront_value)
      include Aws::Structure
    end

    # Describes the limit price of a Reserved Instance offering.
    #
    # @note When making an API call, you may pass ReservedInstanceLimitPrice
    #   data as a hash:
    #
    #       {
    #         amount: 1.0,
    #         currency_code: "USD", # accepts USD
    #       }
    #
    # @!attribute [rw] amount
    #   Used for Reserved Instance Marketplace offerings. Specifies the
    #   limit price on the total order (instanceCount * price).
    #   @return [Float]
    #
    # @!attribute [rw] currency_code
    #   The currency in which the `limitPrice` amount is specified. At this
    #   time, the only supported currency is `USD`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReservedInstanceLimitPrice AWS API Documentation
    #
    class ReservedInstanceLimitPrice < Struct.new(
      :amount,
      :currency_code)
      include Aws::Structure
    end

    # The total value of the Convertible Reserved Instance.
    #
    # @!attribute [rw] reservation_value
    #   The total value of the Convertible Reserved Instance that you are
    #   exchanging.
    #   @return [Types::ReservationValue]
    #
    # @!attribute [rw] reserved_instance_id
    #   The ID of the Convertible Reserved Instance that you are exchanging.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReservedInstanceReservationValue AWS API Documentation
    #
    class ReservedInstanceReservationValue < Struct.new(
      :reservation_value,
      :reserved_instance_id)
      include Aws::Structure
    end

    # Describes a Reserved Instance.
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone in which the Reserved Instance can be used.
    #   @return [String]
    #
    # @!attribute [rw] duration
    #   The duration of the Reserved Instance, in seconds.
    #   @return [Integer]
    #
    # @!attribute [rw] end
    #   The time when the Reserved Instance expires.
    #   @return [Time]
    #
    # @!attribute [rw] fixed_price
    #   The purchase price of the Reserved Instance.
    #   @return [Float]
    #
    # @!attribute [rw] instance_count
    #   The number of reservations purchased.
    #   @return [Integer]
    #
    # @!attribute [rw] instance_type
    #   The instance type on which the Reserved Instance can be used.
    #   @return [String]
    #
    # @!attribute [rw] product_description
    #   The Reserved Instance product platform description.
    #   @return [String]
    #
    # @!attribute [rw] reserved_instances_id
    #   The ID of the Reserved Instance.
    #   @return [String]
    #
    # @!attribute [rw] start
    #   The date and time the Reserved Instance started.
    #   @return [Time]
    #
    # @!attribute [rw] state
    #   The state of the Reserved Instance purchase.
    #   @return [String]
    #
    # @!attribute [rw] usage_price
    #   The usage price of the Reserved Instance, per hour.
    #   @return [Float]
    #
    # @!attribute [rw] currency_code
    #   The currency of the Reserved Instance. It's specified using ISO
    #   4217 standard currency codes. At this time, the only supported
    #   currency is `USD`.
    #   @return [String]
    #
    # @!attribute [rw] instance_tenancy
    #   The tenancy of the instance.
    #   @return [String]
    #
    # @!attribute [rw] offering_class
    #   The offering class of the Reserved Instance.
    #   @return [String]
    #
    # @!attribute [rw] offering_type
    #   The Reserved Instance offering type.
    #   @return [String]
    #
    # @!attribute [rw] recurring_charges
    #   The recurring charge tag assigned to the resource.
    #   @return [Array<Types::RecurringCharge>]
    #
    # @!attribute [rw] scope
    #   The scope of the Reserved Instance.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the resource.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReservedInstances AWS API Documentation
    #
    class ReservedInstances < Struct.new(
      :availability_zone,
      :duration,
      :end,
      :fixed_price,
      :instance_count,
      :instance_type,
      :product_description,
      :reserved_instances_id,
      :start,
      :state,
      :usage_price,
      :currency_code,
      :instance_tenancy,
      :offering_class,
      :offering_type,
      :recurring_charges,
      :scope,
      :tags)
      include Aws::Structure
    end

    # Describes the configuration settings for the modified Reserved
    # Instances.
    #
    # @note When making an API call, you may pass ReservedInstancesConfiguration
    #   data as a hash:
    #
    #       {
    #         availability_zone: "String",
    #         instance_count: 1,
    #         instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #         platform: "String",
    #         scope: "Availability Zone", # accepts Availability Zone, Region
    #       }
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone for the modified Reserved Instances.
    #   @return [String]
    #
    # @!attribute [rw] instance_count
    #   The number of modified Reserved Instances.
    #
    #   <note markdown="1"> This is a required field for a request.
    #
    #    </note>
    #   @return [Integer]
    #
    # @!attribute [rw] instance_type
    #   The instance type for the modified Reserved Instances.
    #   @return [String]
    #
    # @!attribute [rw] platform
    #   The network platform of the modified Reserved Instances, which is
    #   either EC2-Classic or EC2-VPC.
    #   @return [String]
    #
    # @!attribute [rw] scope
    #   Whether the Reserved Instance is applied to instances in a Region or
    #   instances in a specific Availability Zone.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReservedInstancesConfiguration AWS API Documentation
    #
    class ReservedInstancesConfiguration < Struct.new(
      :availability_zone,
      :instance_count,
      :instance_type,
      :platform,
      :scope)
      include Aws::Structure
    end

    # Describes the ID of a Reserved Instance.
    #
    # @!attribute [rw] reserved_instances_id
    #   The ID of the Reserved Instance.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReservedInstancesId AWS API Documentation
    #
    class ReservedInstancesId < Struct.new(
      :reserved_instances_id)
      include Aws::Structure
    end

    # Describes a Reserved Instance listing.
    #
    # @!attribute [rw] client_token
    #   A unique, case-sensitive key supplied by the client to ensure that
    #   the request is idempotent. For more information, see [Ensuring
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] create_date
    #   The time the listing was created.
    #   @return [Time]
    #
    # @!attribute [rw] instance_counts
    #   The number of instances in this state.
    #   @return [Array<Types::InstanceCount>]
    #
    # @!attribute [rw] price_schedules
    #   The price of the Reserved Instance listing.
    #   @return [Array<Types::PriceSchedule>]
    #
    # @!attribute [rw] reserved_instances_id
    #   The ID of the Reserved Instance.
    #   @return [String]
    #
    # @!attribute [rw] reserved_instances_listing_id
    #   The ID of the Reserved Instance listing.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The status of the Reserved Instance listing.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   The reason for the current status of the Reserved Instance listing.
    #   The response can be blank.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the resource.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] update_date
    #   The last modified timestamp of the listing.
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReservedInstancesListing AWS API Documentation
    #
    class ReservedInstancesListing < Struct.new(
      :client_token,
      :create_date,
      :instance_counts,
      :price_schedules,
      :reserved_instances_id,
      :reserved_instances_listing_id,
      :status,
      :status_message,
      :tags,
      :update_date)
      include Aws::Structure
    end

    # Describes a Reserved Instance modification.
    #
    # @!attribute [rw] client_token
    #   A unique, case-sensitive key supplied by the client to ensure that
    #   the request is idempotent. For more information, see [Ensuring
    #   Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] create_date
    #   The time when the modification request was created.
    #   @return [Time]
    #
    # @!attribute [rw] effective_date
    #   The time for the modification to become effective.
    #   @return [Time]
    #
    # @!attribute [rw] modification_results
    #   Contains target configurations along with their corresponding new
    #   Reserved Instance IDs.
    #   @return [Array<Types::ReservedInstancesModificationResult>]
    #
    # @!attribute [rw] reserved_instances_ids
    #   The IDs of one or more Reserved Instances.
    #   @return [Array<Types::ReservedInstancesId>]
    #
    # @!attribute [rw] reserved_instances_modification_id
    #   A unique ID for the Reserved Instance modification.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The status of the Reserved Instances modification request.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   The reason for the status.
    #   @return [String]
    #
    # @!attribute [rw] update_date
    #   The time when the modification request was last updated.
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReservedInstancesModification AWS API Documentation
    #
    class ReservedInstancesModification < Struct.new(
      :client_token,
      :create_date,
      :effective_date,
      :modification_results,
      :reserved_instances_ids,
      :reserved_instances_modification_id,
      :status,
      :status_message,
      :update_date)
      include Aws::Structure
    end

    # Describes the modification request/s.
    #
    # @!attribute [rw] reserved_instances_id
    #   The ID for the Reserved Instances that were created as part of the
    #   modification request. This field is only available when the
    #   modification is fulfilled.
    #   @return [String]
    #
    # @!attribute [rw] target_configuration
    #   The target Reserved Instances configurations supplied as part of the
    #   modification request.
    #   @return [Types::ReservedInstancesConfiguration]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReservedInstancesModificationResult AWS API Documentation
    #
    class ReservedInstancesModificationResult < Struct.new(
      :reserved_instances_id,
      :target_configuration)
      include Aws::Structure
    end

    # Describes a Reserved Instance offering.
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone in which the Reserved Instance can be used.
    #   @return [String]
    #
    # @!attribute [rw] duration
    #   The duration of the Reserved Instance, in seconds.
    #   @return [Integer]
    #
    # @!attribute [rw] fixed_price
    #   The purchase price of the Reserved Instance.
    #   @return [Float]
    #
    # @!attribute [rw] instance_type
    #   The instance type on which the Reserved Instance can be used.
    #   @return [String]
    #
    # @!attribute [rw] product_description
    #   The Reserved Instance product platform description.
    #   @return [String]
    #
    # @!attribute [rw] reserved_instances_offering_id
    #   The ID of the Reserved Instance offering. This is the offering ID
    #   used in GetReservedInstancesExchangeQuote to confirm that an
    #   exchange can be made.
    #   @return [String]
    #
    # @!attribute [rw] usage_price
    #   The usage price of the Reserved Instance, per hour.
    #   @return [Float]
    #
    # @!attribute [rw] currency_code
    #   The currency of the Reserved Instance offering you are purchasing.
    #   It's specified using ISO 4217 standard currency codes. At this
    #   time, the only supported currency is `USD`.
    #   @return [String]
    #
    # @!attribute [rw] instance_tenancy
    #   The tenancy of the instance.
    #   @return [String]
    #
    # @!attribute [rw] marketplace
    #   Indicates whether the offering is available through the Reserved
    #   Instance Marketplace (resale) or AWS. If it's a Reserved Instance
    #   Marketplace offering, this is `true`.
    #   @return [Boolean]
    #
    # @!attribute [rw] offering_class
    #   If `convertible` it can be exchanged for Reserved Instances of the
    #   same or higher monetary value, with different configurations. If
    #   `standard`, it is not possible to perform an exchange.
    #   @return [String]
    #
    # @!attribute [rw] offering_type
    #   The Reserved Instance offering type.
    #   @return [String]
    #
    # @!attribute [rw] pricing_details
    #   The pricing details of the Reserved Instance offering.
    #   @return [Array<Types::PricingDetail>]
    #
    # @!attribute [rw] recurring_charges
    #   The recurring charge tag assigned to the resource.
    #   @return [Array<Types::RecurringCharge>]
    #
    # @!attribute [rw] scope
    #   Whether the Reserved Instance is applied to instances in a Region or
    #   an Availability Zone.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ReservedInstancesOffering AWS API Documentation
    #
    class ReservedInstancesOffering < Struct.new(
      :availability_zone,
      :duration,
      :fixed_price,
      :instance_type,
      :product_description,
      :reserved_instances_offering_id,
      :usage_price,
      :currency_code,
      :instance_tenancy,
      :marketplace,
      :offering_class,
      :offering_type,
      :pricing_details,
      :recurring_charges,
      :scope)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ResetEbsDefaultKmsKeyIdRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ResetEbsDefaultKmsKeyIdRequest AWS API Documentation
    #
    class ResetEbsDefaultKmsKeyIdRequest < Struct.new(
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] kms_key_id
    #   The Amazon Resource Name (ARN) of the default CMK for EBS encryption
    #   by default.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ResetEbsDefaultKmsKeyIdResult AWS API Documentation
    #
    class ResetEbsDefaultKmsKeyIdResult < Struct.new(
      :kms_key_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ResetFpgaImageAttributeRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         fpga_image_id: "FpgaImageId", # required
    #         attribute: "loadPermission", # accepts loadPermission
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] fpga_image_id
    #   The ID of the AFI.
    #   @return [String]
    #
    # @!attribute [rw] attribute
    #   The attribute.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ResetFpgaImageAttributeRequest AWS API Documentation
    #
    class ResetFpgaImageAttributeRequest < Struct.new(
      :dry_run,
      :fpga_image_id,
      :attribute)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Is `true` if the request succeeds, and an error otherwise.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ResetFpgaImageAttributeResult AWS API Documentation
    #
    class ResetFpgaImageAttributeResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # Contains the parameters for ResetImageAttribute.
    #
    # @note When making an API call, you may pass ResetImageAttributeRequest
    #   data as a hash:
    #
    #       {
    #         attribute: "launchPermission", # required, accepts launchPermission
    #         image_id: "ImageId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] attribute
    #   The attribute to reset (currently you can only reset the launch
    #   permission attribute).
    #   @return [String]
    #
    # @!attribute [rw] image_id
    #   The ID of the AMI.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ResetImageAttributeRequest AWS API Documentation
    #
    class ResetImageAttributeRequest < Struct.new(
      :attribute,
      :image_id,
      :dry_run)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ResetInstanceAttributeRequest
    #   data as a hash:
    #
    #       {
    #         attribute: "instanceType", # required, accepts instanceType, kernel, ramdisk, userData, disableApiTermination, instanceInitiatedShutdownBehavior, rootDeviceName, blockDeviceMapping, productCodes, sourceDestCheck, groupSet, ebsOptimized, sriovNetSupport, enaSupport
    #         dry_run: false,
    #         instance_id: "InstanceId", # required
    #       }
    #
    # @!attribute [rw] attribute
    #   The attribute to reset.
    #
    #   You can only reset the following attributes: `kernel` \| `ramdisk`
    #   \| `sourceDestCheck`. To change an instance attribute, use
    #   ModifyInstanceAttribute.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ResetInstanceAttributeRequest AWS API Documentation
    #
    class ResetInstanceAttributeRequest < Struct.new(
      :attribute,
      :dry_run,
      :instance_id)
      include Aws::Structure
    end

    # Contains the parameters for ResetNetworkInterfaceAttribute.
    #
    # @note When making an API call, you may pass ResetNetworkInterfaceAttributeRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         network_interface_id: "NetworkInterfaceId", # required
    #         source_dest_check: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] source_dest_check
    #   The source/destination checking attribute. Resets the value to
    #   `true`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ResetNetworkInterfaceAttributeRequest AWS API Documentation
    #
    class ResetNetworkInterfaceAttributeRequest < Struct.new(
      :dry_run,
      :network_interface_id,
      :source_dest_check)
      include Aws::Structure
    end

    # @note When making an API call, you may pass ResetSnapshotAttributeRequest
    #   data as a hash:
    #
    #       {
    #         attribute: "productCodes", # required, accepts productCodes, createVolumePermission
    #         snapshot_id: "SnapshotId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] attribute
    #   The attribute to reset. Currently, only the attribute for permission
    #   to create volumes can be reset.
    #   @return [String]
    #
    # @!attribute [rw] snapshot_id
    #   The ID of the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ResetSnapshotAttributeRequest AWS API Documentation
    #
    class ResetSnapshotAttributeRequest < Struct.new(
      :attribute,
      :snapshot_id,
      :dry_run)
      include Aws::Structure
    end

    # Describes the error that's returned when you cannot delete a launch
    # template version.
    #
    # @!attribute [rw] code
    #   The error code.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   The error message, if applicable.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ResponseError AWS API Documentation
    #
    class ResponseError < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # The information for a launch template.
    #
    # @!attribute [rw] kernel_id
    #   The ID of the kernel, if applicable.
    #   @return [String]
    #
    # @!attribute [rw] ebs_optimized
    #   Indicates whether the instance is optimized for Amazon EBS I/O.
    #   @return [Boolean]
    #
    # @!attribute [rw] iam_instance_profile
    #   The IAM instance profile.
    #   @return [Types::LaunchTemplateIamInstanceProfileSpecification]
    #
    # @!attribute [rw] block_device_mappings
    #   The block device mappings.
    #   @return [Array<Types::LaunchTemplateBlockDeviceMapping>]
    #
    # @!attribute [rw] network_interfaces
    #   The network interfaces.
    #   @return [Array<Types::LaunchTemplateInstanceNetworkInterfaceSpecification>]
    #
    # @!attribute [rw] image_id
    #   The ID of the AMI that was used to launch the instance.
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   The instance type.
    #   @return [String]
    #
    # @!attribute [rw] key_name
    #   The name of the key pair.
    #   @return [String]
    #
    # @!attribute [rw] monitoring
    #   The monitoring for the instance.
    #   @return [Types::LaunchTemplatesMonitoring]
    #
    # @!attribute [rw] placement
    #   The placement of the instance.
    #   @return [Types::LaunchTemplatePlacement]
    #
    # @!attribute [rw] ram_disk_id
    #   The ID of the RAM disk, if applicable.
    #   @return [String]
    #
    # @!attribute [rw] disable_api_termination
    #   If set to `true`, indicates that the instance cannot be terminated
    #   using the Amazon EC2 console, command line tool, or API.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_initiated_shutdown_behavior
    #   Indicates whether an instance stops or terminates when you initiate
    #   shutdown from the instance (using the operating system command for
    #   system shutdown).
    #   @return [String]
    #
    # @!attribute [rw] user_data
    #   The user data for the instance.
    #   @return [String]
    #
    # @!attribute [rw] tag_specifications
    #   The tags.
    #   @return [Array<Types::LaunchTemplateTagSpecification>]
    #
    # @!attribute [rw] elastic_gpu_specifications
    #   The elastic GPU specification.
    #   @return [Array<Types::ElasticGpuSpecificationResponse>]
    #
    # @!attribute [rw] elastic_inference_accelerators
    #   The elastic inference accelerator for the instance.
    #   @return [Array<Types::LaunchTemplateElasticInferenceAcceleratorResponse>]
    #
    # @!attribute [rw] security_group_ids
    #   The security group IDs.
    #   @return [Array<String>]
    #
    # @!attribute [rw] security_groups
    #   The security group names.
    #   @return [Array<String>]
    #
    # @!attribute [rw] instance_market_options
    #   The market (purchasing) option for the instances.
    #   @return [Types::LaunchTemplateInstanceMarketOptions]
    #
    # @!attribute [rw] credit_specification
    #   The credit option for CPU usage of the instance.
    #   @return [Types::CreditSpecification]
    #
    # @!attribute [rw] cpu_options
    #   The CPU options for the instance. For more information, see
    #   [Optimizing CPU Options][1] in the *Amazon Elastic Compute Cloud
    #   User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html
    #   @return [Types::LaunchTemplateCpuOptions]
    #
    # @!attribute [rw] capacity_reservation_specification
    #   Information about the Capacity Reservation targeting option.
    #   @return [Types::LaunchTemplateCapacityReservationSpecificationResponse]
    #
    # @!attribute [rw] license_specifications
    #   The license configurations.
    #   @return [Array<Types::LaunchTemplateLicenseConfiguration>]
    #
    # @!attribute [rw] hibernation_options
    #   Indicates whether an instance is configured for hibernation. For
    #   more information, see [Hibernate Your Instance][1] in the *Amazon
    #   Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html
    #   @return [Types::LaunchTemplateHibernationOptions]
    #
    # @!attribute [rw] metadata_options
    #   The metadata options for the instance. For more information, see
    #   [Instance Metadata and User Data][1] in the *Amazon Elastic Compute
    #   Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-instance-metadata.html
    #   @return [Types::LaunchTemplateInstanceMetadataOptions]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ResponseLaunchTemplateData AWS API Documentation
    #
    class ResponseLaunchTemplateData < Struct.new(
      :kernel_id,
      :ebs_optimized,
      :iam_instance_profile,
      :block_device_mappings,
      :network_interfaces,
      :image_id,
      :instance_type,
      :key_name,
      :monitoring,
      :placement,
      :ram_disk_id,
      :disable_api_termination,
      :instance_initiated_shutdown_behavior,
      :user_data,
      :tag_specifications,
      :elastic_gpu_specifications,
      :elastic_inference_accelerators,
      :security_group_ids,
      :security_groups,
      :instance_market_options,
      :credit_specification,
      :cpu_options,
      :capacity_reservation_specification,
      :license_specifications,
      :hibernation_options,
      :metadata_options)
      include Aws::Structure
    end

    # @note When making an API call, you may pass RestoreAddressToClassicRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         public_ip: "String", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] public_ip
    #   The Elastic IP address.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RestoreAddressToClassicRequest AWS API Documentation
    #
    class RestoreAddressToClassicRequest < Struct.new(
      :dry_run,
      :public_ip)
      include Aws::Structure
    end

    # @!attribute [rw] public_ip
    #   The Elastic IP address.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The move status for the IP address.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RestoreAddressToClassicResult AWS API Documentation
    #
    class RestoreAddressToClassicResult < Struct.new(
      :public_ip,
      :status)
      include Aws::Structure
    end

    # @note When making an API call, you may pass RevokeClientVpnIngressRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         target_network_cidr: "String", # required
    #         access_group_id: "String",
    #         revoke_all_groups: false,
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint with which the authorization rule
    #   is associated.
    #   @return [String]
    #
    # @!attribute [rw] target_network_cidr
    #   The IPv4 address range, in CIDR notation, of the network for which
    #   access is being removed.
    #   @return [String]
    #
    # @!attribute [rw] access_group_id
    #   The ID of the Active Directory group for which to revoke access.
    #   @return [String]
    #
    # @!attribute [rw] revoke_all_groups
    #   Indicates whether access should be revoked for all clients.
    #   @return [Boolean]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RevokeClientVpnIngressRequest AWS API Documentation
    #
    class RevokeClientVpnIngressRequest < Struct.new(
      :client_vpn_endpoint_id,
      :target_network_cidr,
      :access_group_id,
      :revoke_all_groups,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] status
    #   The current state of the authorization rule.
    #   @return [Types::ClientVpnAuthorizationRuleStatus]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RevokeClientVpnIngressResult AWS API Documentation
    #
    class RevokeClientVpnIngressResult < Struct.new(
      :status)
      include Aws::Structure
    end

    # @note When making an API call, you may pass RevokeSecurityGroupEgressRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         group_id: "SecurityGroupId", # required
    #         ip_permissions: [
    #           {
    #             from_port: 1,
    #             ip_protocol: "String",
    #             ip_ranges: [
    #               {
    #                 cidr_ip: "String",
    #                 description: "String",
    #               },
    #             ],
    #             ipv_6_ranges: [
    #               {
    #                 cidr_ipv_6: "String",
    #                 description: "String",
    #               },
    #             ],
    #             prefix_list_ids: [
    #               {
    #                 description: "String",
    #                 prefix_list_id: "String",
    #               },
    #             ],
    #             to_port: 1,
    #             user_id_group_pairs: [
    #               {
    #                 description: "String",
    #                 group_id: "String",
    #                 group_name: "String",
    #                 peering_status: "String",
    #                 user_id: "String",
    #                 vpc_id: "String",
    #                 vpc_peering_connection_id: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         cidr_ip: "String",
    #         from_port: 1,
    #         ip_protocol: "String",
    #         to_port: 1,
    #         source_security_group_name: "String",
    #         source_security_group_owner_id: "String",
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] group_id
    #   The ID of the security group.
    #   @return [String]
    #
    # @!attribute [rw] ip_permissions
    #   The sets of IP permissions. You can't specify a destination
    #   security group and a CIDR IP address range in the same set of
    #   permissions.
    #   @return [Array<Types::IpPermission>]
    #
    # @!attribute [rw] cidr_ip
    #   Not supported. Use a set of IP permissions to specify the CIDR.
    #   @return [String]
    #
    # @!attribute [rw] from_port
    #   Not supported. Use a set of IP permissions to specify the port.
    #   @return [Integer]
    #
    # @!attribute [rw] ip_protocol
    #   Not supported. Use a set of IP permissions to specify the protocol
    #   name or number.
    #   @return [String]
    #
    # @!attribute [rw] to_port
    #   Not supported. Use a set of IP permissions to specify the port.
    #   @return [Integer]
    #
    # @!attribute [rw] source_security_group_name
    #   Not supported. Use a set of IP permissions to specify a destination
    #   security group.
    #   @return [String]
    #
    # @!attribute [rw] source_security_group_owner_id
    #   Not supported. Use a set of IP permissions to specify a destination
    #   security group.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RevokeSecurityGroupEgressRequest AWS API Documentation
    #
    class RevokeSecurityGroupEgressRequest < Struct.new(
      :dry_run,
      :group_id,
      :ip_permissions,
      :cidr_ip,
      :from_port,
      :ip_protocol,
      :to_port,
      :source_security_group_name,
      :source_security_group_owner_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass RevokeSecurityGroupIngressRequest
    #   data as a hash:
    #
    #       {
    #         cidr_ip: "String",
    #         from_port: 1,
    #         group_id: "SecurityGroupId",
    #         group_name: "SecurityGroupName",
    #         ip_permissions: [
    #           {
    #             from_port: 1,
    #             ip_protocol: "String",
    #             ip_ranges: [
    #               {
    #                 cidr_ip: "String",
    #                 description: "String",
    #               },
    #             ],
    #             ipv_6_ranges: [
    #               {
    #                 cidr_ipv_6: "String",
    #                 description: "String",
    #               },
    #             ],
    #             prefix_list_ids: [
    #               {
    #                 description: "String",
    #                 prefix_list_id: "String",
    #               },
    #             ],
    #             to_port: 1,
    #             user_id_group_pairs: [
    #               {
    #                 description: "String",
    #                 group_id: "String",
    #                 group_name: "String",
    #                 peering_status: "String",
    #                 user_id: "String",
    #                 vpc_id: "String",
    #                 vpc_peering_connection_id: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         ip_protocol: "String",
    #         source_security_group_name: "String",
    #         source_security_group_owner_id: "String",
    #         to_port: 1,
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] cidr_ip
    #   The CIDR IP address range. You can't specify this parameter when
    #   specifying a source security group.
    #   @return [String]
    #
    # @!attribute [rw] from_port
    #   The start of port range for the TCP and UDP protocols, or an ICMP
    #   type number. For the ICMP type number, use `-1` to specify all ICMP
    #   types.
    #   @return [Integer]
    #
    # @!attribute [rw] group_id
    #   The ID of the security group. You must specify either the security
    #   group ID or the security group name in the request. For security
    #   groups in a nondefault VPC, you must specify the security group ID.
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   \[EC2-Classic, default VPC\] The name of the security group. You
    #   must specify either the security group ID or the security group name
    #   in the request.
    #   @return [String]
    #
    # @!attribute [rw] ip_permissions
    #   The sets of IP permissions. You can't specify a source security
    #   group and a CIDR IP address range in the same set of permissions.
    #   @return [Array<Types::IpPermission>]
    #
    # @!attribute [rw] ip_protocol
    #   The IP protocol name (`tcp`, `udp`, `icmp`) or number (see [Protocol
    #   Numbers][1]). Use `-1` to specify all.
    #
    #
    #
    #   [1]: http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml
    #   @return [String]
    #
    # @!attribute [rw] source_security_group_name
    #   \[EC2-Classic, default VPC\] The name of the source security group.
    #   You can't specify this parameter in combination with the following
    #   parameters: the CIDR IP address range, the start of the port range,
    #   the IP protocol, and the end of the port range. For EC2-VPC, the
    #   source security group must be in the same VPC. To revoke a specific
    #   rule for an IP protocol and port range, use a set of IP permissions
    #   instead.
    #   @return [String]
    #
    # @!attribute [rw] source_security_group_owner_id
    #   \[EC2-Classic\] The AWS account ID of the source security group, if
    #   the source security group is in a different account. You can't
    #   specify this parameter in combination with the following parameters:
    #   the CIDR IP address range, the IP protocol, the start of the port
    #   range, and the end of the port range. To revoke a specific rule for
    #   an IP protocol and port range, use a set of IP permissions instead.
    #   @return [String]
    #
    # @!attribute [rw] to_port
    #   The end of port range for the TCP and UDP protocols, or an ICMP code
    #   number. For the ICMP code number, use `-1` to specify all ICMP codes
    #   for the ICMP type.
    #   @return [Integer]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RevokeSecurityGroupIngressRequest AWS API Documentation
    #
    class RevokeSecurityGroupIngressRequest < Struct.new(
      :cidr_ip,
      :from_port,
      :group_id,
      :group_name,
      :ip_permissions,
      :ip_protocol,
      :source_security_group_name,
      :source_security_group_owner_id,
      :to_port,
      :dry_run)
      include Aws::Structure
    end

    # Describes a route in a route table.
    #
    # @!attribute [rw] destination_cidr_block
    #   The IPv4 CIDR block used for the destination match.
    #   @return [String]
    #
    # @!attribute [rw] destination_ipv_6_cidr_block
    #   The IPv6 CIDR block used for the destination match.
    #   @return [String]
    #
    # @!attribute [rw] destination_prefix_list_id
    #   The prefix of the AWS service.
    #   @return [String]
    #
    # @!attribute [rw] egress_only_internet_gateway_id
    #   The ID of the egress-only internet gateway.
    #   @return [String]
    #
    # @!attribute [rw] gateway_id
    #   The ID of a gateway attached to your VPC.
    #   @return [String]
    #
    # @!attribute [rw] instance_id
    #   The ID of a NAT instance in your VPC.
    #   @return [String]
    #
    # @!attribute [rw] instance_owner_id
    #   The AWS account ID of the owner of the instance.
    #   @return [String]
    #
    # @!attribute [rw] nat_gateway_id
    #   The ID of a NAT gateway.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of a transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] local_gateway_id
    #   The ID of the local gateway.
    #   @return [String]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] origin
    #   Describes how the route was created.
    #
    #   * `CreateRouteTable` - The route was automatically created when the
    #     route table was created.
    #
    #   * `CreateRoute` - The route was manually added to the route table.
    #
    #   * `EnableVgwRoutePropagation` - The route was propagated by route
    #     propagation.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the route. The `blackhole` state indicates that the
    #   route's target isn't available (for example, the specified gateway
    #   isn't attached to the VPC, or the specified NAT instance has been
    #   terminated).
    #   @return [String]
    #
    # @!attribute [rw] vpc_peering_connection_id
    #   The ID of a VPC peering connection.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Route AWS API Documentation
    #
    class Route < Struct.new(
      :destination_cidr_block,
      :destination_ipv_6_cidr_block,
      :destination_prefix_list_id,
      :egress_only_internet_gateway_id,
      :gateway_id,
      :instance_id,
      :instance_owner_id,
      :nat_gateway_id,
      :transit_gateway_id,
      :local_gateway_id,
      :network_interface_id,
      :origin,
      :state,
      :vpc_peering_connection_id)
      include Aws::Structure
    end

    # Describes a route table.
    #
    # @!attribute [rw] associations
    #   The associations between the route table and one or more subnets or
    #   a gateway.
    #   @return [Array<Types::RouteTableAssociation>]
    #
    # @!attribute [rw] propagating_vgws
    #   Any virtual private gateway (VGW) propagating routes.
    #   @return [Array<Types::PropagatingVgw>]
    #
    # @!attribute [rw] route_table_id
    #   The ID of the route table.
    #   @return [String]
    #
    # @!attribute [rw] routes
    #   The routes in the route table.
    #   @return [Array<Types::Route>]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the route table.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account that owns the route table.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RouteTable AWS API Documentation
    #
    class RouteTable < Struct.new(
      :associations,
      :propagating_vgws,
      :route_table_id,
      :routes,
      :tags,
      :vpc_id,
      :owner_id)
      include Aws::Structure
    end

    # Describes an association between a route table and a subnet or
    # gateway.
    #
    # @!attribute [rw] main
    #   Indicates whether this is the main route table.
    #   @return [Boolean]
    #
    # @!attribute [rw] route_table_association_id
    #   The ID of the association.
    #   @return [String]
    #
    # @!attribute [rw] route_table_id
    #   The ID of the route table.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet. A subnet ID is not returned for an implicit
    #   association.
    #   @return [String]
    #
    # @!attribute [rw] gateway_id
    #   The ID of the internet gateway or virtual private gateway.
    #   @return [String]
    #
    # @!attribute [rw] association_state
    #   The state of the association.
    #   @return [Types::RouteTableAssociationState]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RouteTableAssociation AWS API Documentation
    #
    class RouteTableAssociation < Struct.new(
      :main,
      :route_table_association_id,
      :route_table_id,
      :subnet_id,
      :gateway_id,
      :association_state)
      include Aws::Structure
    end

    # Describes the state of an association between a route table and a
    # subnet or gateway.
    #
    # @!attribute [rw] state
    #   The state of the association.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   The status message, if applicable.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RouteTableAssociationState AWS API Documentation
    #
    class RouteTableAssociationState < Struct.new(
      :state,
      :status_message)
      include Aws::Structure
    end

    # Describes the monitoring of an instance.
    #
    # @note When making an API call, you may pass RunInstancesMonitoringEnabled
    #   data as a hash:
    #
    #       {
    #         enabled: false, # required
    #       }
    #
    # @!attribute [rw] enabled
    #   Indicates whether detailed monitoring is enabled. Otherwise, basic
    #   monitoring is enabled.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RunInstancesMonitoringEnabled AWS API Documentation
    #
    class RunInstancesMonitoringEnabled < Struct.new(
      :enabled)
      include Aws::Structure
    end

    # @note When making an API call, you may pass RunInstancesRequest
    #   data as a hash:
    #
    #       {
    #         block_device_mappings: [
    #           {
    #             device_name: "String",
    #             virtual_name: "String",
    #             ebs: {
    #               delete_on_termination: false,
    #               iops: 1,
    #               snapshot_id: "String",
    #               volume_size: 1,
    #               volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #               kms_key_id: "String",
    #               encrypted: false,
    #             },
    #             no_device: "String",
    #           },
    #         ],
    #         image_id: "ImageId",
    #         instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #         ipv_6_address_count: 1,
    #         ipv_6_addresses: [
    #           {
    #             ipv_6_address: "String",
    #           },
    #         ],
    #         kernel_id: "KernelId",
    #         key_name: "KeyPairName",
    #         max_count: 1, # required
    #         min_count: 1, # required
    #         monitoring: {
    #           enabled: false, # required
    #         },
    #         placement: {
    #           availability_zone: "String",
    #           affinity: "String",
    #           group_name: "String",
    #           partition_number: 1,
    #           host_id: "String",
    #           tenancy: "default", # accepts default, dedicated, host
    #           spread_domain: "String",
    #           host_resource_group_arn: "String",
    #         },
    #         ramdisk_id: "RamdiskId",
    #         security_group_ids: ["SecurityGroupId"],
    #         security_groups: ["SecurityGroupName"],
    #         subnet_id: "SubnetId",
    #         user_data: "String",
    #         additional_info: "String",
    #         client_token: "String",
    #         disable_api_termination: false,
    #         dry_run: false,
    #         ebs_optimized: false,
    #         iam_instance_profile: {
    #           arn: "String",
    #           name: "String",
    #         },
    #         instance_initiated_shutdown_behavior: "stop", # accepts stop, terminate
    #         network_interfaces: [
    #           {
    #             associate_public_ip_address: false,
    #             delete_on_termination: false,
    #             description: "String",
    #             device_index: 1,
    #             groups: ["SecurityGroupId"],
    #             ipv_6_address_count: 1,
    #             ipv_6_addresses: [
    #               {
    #                 ipv_6_address: "String",
    #               },
    #             ],
    #             network_interface_id: "String",
    #             private_ip_address: "String",
    #             private_ip_addresses: [
    #               {
    #                 primary: false,
    #                 private_ip_address: "String",
    #               },
    #             ],
    #             secondary_private_ip_address_count: 1,
    #             subnet_id: "String",
    #             interface_type: "String",
    #           },
    #         ],
    #         private_ip_address: "String",
    #         elastic_gpu_specification: [
    #           {
    #             type: "String", # required
    #           },
    #         ],
    #         elastic_inference_accelerators: [
    #           {
    #             type: "String", # required
    #             count: 1,
    #           },
    #         ],
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #         launch_template: {
    #           launch_template_id: "LaunchTemplateId",
    #           launch_template_name: "String",
    #           version: "String",
    #         },
    #         instance_market_options: {
    #           market_type: "spot", # accepts spot
    #           spot_options: {
    #             max_price: "String",
    #             spot_instance_type: "one-time", # accepts one-time, persistent
    #             block_duration_minutes: 1,
    #             valid_until: Time.now,
    #             instance_interruption_behavior: "hibernate", # accepts hibernate, stop, terminate
    #           },
    #         },
    #         credit_specification: {
    #           cpu_credits: "String", # required
    #         },
    #         cpu_options: {
    #           core_count: 1,
    #           threads_per_core: 1,
    #         },
    #         capacity_reservation_specification: {
    #           capacity_reservation_preference: "open", # accepts open, none
    #           capacity_reservation_target: {
    #             capacity_reservation_id: "CapacityReservationId",
    #           },
    #         },
    #         hibernation_options: {
    #           configured: false,
    #         },
    #         license_specifications: [
    #           {
    #             license_configuration_arn: "String",
    #           },
    #         ],
    #         metadata_options: {
    #           http_tokens: "optional", # accepts optional, required
    #           http_put_response_hop_limit: 1,
    #           http_endpoint: "disabled", # accepts disabled, enabled
    #         },
    #       }
    #
    # @!attribute [rw] block_device_mappings
    #   The block device mapping entries.
    #   @return [Array<Types::BlockDeviceMapping>]
    #
    # @!attribute [rw] image_id
    #   The ID of the AMI. An AMI ID is required to launch an instance and
    #   must be specified here or in a launch template.
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   The instance type. For more information, see [Instance Types][1] in
    #   the *Amazon Elastic Compute Cloud User Guide*.
    #
    #   Default: `m1.small`
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_address_count
    #   \[EC2-VPC\] The number of IPv6 addresses to associate with the
    #   primary network interface. Amazon EC2 chooses the IPv6 addresses
    #   from the range of your subnet. You cannot specify this option and
    #   the option to assign specific IPv6 addresses in the same request.
    #   You can specify this option if you've specified a minimum number of
    #   instances to launch.
    #
    #   You cannot specify this option and the network interfaces option in
    #   the same request.
    #   @return [Integer]
    #
    # @!attribute [rw] ipv_6_addresses
    #   \[EC2-VPC\] The IPv6 addresses from the range of the subnet to
    #   associate with the primary network interface. You cannot specify
    #   this option and the option to assign a number of IPv6 addresses in
    #   the same request. You cannot specify this option if you've
    #   specified a minimum number of instances to launch.
    #
    #   You cannot specify this option and the network interfaces option in
    #   the same request.
    #   @return [Array<Types::InstanceIpv6Address>]
    #
    # @!attribute [rw] kernel_id
    #   The ID of the kernel.
    #
    #   We recommend that you use PV-GRUB instead of kernels and RAM disks.
    #   For more information, see [ PV-GRUB][1] in the *Amazon Elastic
    #   Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedkernels.html
    #   @return [String]
    #
    # @!attribute [rw] key_name
    #   The name of the key pair. You can create a key pair using
    #   [CreateKeyPair][1] or [ImportKeyPair][2].
    #
    #   If you do not specify a key pair, you can't connect to the instance
    #   unless you choose an AMI that is configured to allow users another
    #   way to log in.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateKeyPair.html
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ImportKeyPair.html
    #   @return [String]
    #
    # @!attribute [rw] max_count
    #   The maximum number of instances to launch. If you specify more
    #   instances than Amazon EC2 can launch in the target Availability
    #   Zone, Amazon EC2 launches the largest possible number of instances
    #   above `MinCount`.
    #
    #   Constraints: Between 1 and the maximum number you're allowed for
    #   the specified instance type. For more information about the default
    #   limits, and how to request an increase, see [How many instances can
    #   I run in Amazon EC2][1] in the Amazon EC2 FAQ.
    #
    #
    #
    #   [1]: http://aws.amazon.com/ec2/faqs/#How_many_instances_can_I_run_in_Amazon_EC2
    #   @return [Integer]
    #
    # @!attribute [rw] min_count
    #   The minimum number of instances to launch. If you specify a minimum
    #   that is more instances than Amazon EC2 can launch in the target
    #   Availability Zone, Amazon EC2 launches no instances.
    #
    #   Constraints: Between 1 and the maximum number you're allowed for
    #   the specified instance type. For more information about the default
    #   limits, and how to request an increase, see [How many instances can
    #   I run in Amazon EC2][1] in the Amazon EC2 General FAQ.
    #
    #
    #
    #   [1]: http://aws.amazon.com/ec2/faqs/#How_many_instances_can_I_run_in_Amazon_EC2
    #   @return [Integer]
    #
    # @!attribute [rw] monitoring
    #   Specifies whether detailed monitoring is enabled for the instance.
    #   @return [Types::RunInstancesMonitoringEnabled]
    #
    # @!attribute [rw] placement
    #   The placement for the instance.
    #   @return [Types::Placement]
    #
    # @!attribute [rw] ramdisk_id
    #   The ID of the RAM disk to select. Some kernels require additional
    #   drivers at launch. Check the kernel requirements for information
    #   about whether you need to specify a RAM disk. To find kernel
    #   requirements, go to the AWS Resource Center and search for the
    #   kernel ID.
    #
    #   We recommend that you use PV-GRUB instead of kernels and RAM disks.
    #   For more information, see [ PV-GRUB][1] in the *Amazon Elastic
    #   Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedkernels.html
    #   @return [String]
    #
    # @!attribute [rw] security_group_ids
    #   The IDs of the security groups. You can create a security group
    #   using [CreateSecurityGroup][1].
    #
    #   If you specify a network interface, you must specify any security
    #   groups as part of the network interface.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateSecurityGroup.html
    #   @return [Array<String>]
    #
    # @!attribute [rw] security_groups
    #   \[EC2-Classic, default VPC\] The names of the security groups. For a
    #   nondefault VPC, you must use security group IDs instead.
    #
    #   If you specify a network interface, you must specify any security
    #   groups as part of the network interface.
    #
    #   Default: Amazon EC2 uses the default security group.
    #   @return [Array<String>]
    #
    # @!attribute [rw] subnet_id
    #   \[EC2-VPC\] The ID of the subnet to launch the instance into.
    #
    #   If you specify a network interface, you must specify any subnets as
    #   part of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] user_data
    #   The user data to make available to the instance. For more
    #   information, see [Running Commands on Your Linux Instance at
    #   Launch][1] (Linux) and [Adding User Data][2] (Windows). If you are
    #   using a command line tool, base64-encoding is performed for you, and
    #   you can load the text from a file. Otherwise, you must provide
    #   base64-encoded text. User data is limited to 16 KB.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/user-data.html
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/WindowsGuide/ec2-instance-metadata.html#instancedata-add-user-data
    #   @return [String]
    #
    # @!attribute [rw] additional_info
    #   Reserved.
    #   @return [String]
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier you provide to ensure the
    #   idempotency of the request. If you do not specify a client token, a
    #   randomly generated token is used for the request to ensure
    #   idempotency.
    #
    #   For more information, see [Ensuring Idempotency][1].
    #
    #   Constraints: Maximum 64 ASCII characters
    #
    #   **A suitable default value is auto-generated.** You should normally
    #   not need to pass this option.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] disable_api_termination
    #   If you set this parameter to `true`, you can't terminate the
    #   instance using the Amazon EC2 console, CLI, or API; otherwise, you
    #   can. To change this attribute after launch, use
    #   [ModifyInstanceAttribute][1]. Alternatively, if you set
    #   `InstanceInitiatedShutdownBehavior` to `terminate`, you can
    #   terminate the instance by running the shutdown command from the
    #   instance.
    #
    #   Default: `false`
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ModifyInstanceAttribute.html
    #   @return [Boolean]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] ebs_optimized
    #   Indicates whether the instance is optimized for Amazon EBS I/O. This
    #   optimization provides dedicated throughput to Amazon EBS and an
    #   optimized configuration stack to provide optimal Amazon EBS I/O
    #   performance. This optimization isn't available with all instance
    #   types. Additional usage charges apply when using an EBS-optimized
    #   instance.
    #
    #   Default: `false`
    #   @return [Boolean]
    #
    # @!attribute [rw] iam_instance_profile
    #   The IAM instance profile.
    #   @return [Types::IamInstanceProfileSpecification]
    #
    # @!attribute [rw] instance_initiated_shutdown_behavior
    #   Indicates whether an instance stops or terminates when you initiate
    #   shutdown from the instance (using the operating system command for
    #   system shutdown).
    #
    #   Default: `stop`
    #   @return [String]
    #
    # @!attribute [rw] network_interfaces
    #   The network interfaces to associate with the instance. If you
    #   specify a network interface, you must specify any security groups
    #   and subnets as part of the network interface.
    #   @return [Array<Types::InstanceNetworkInterfaceSpecification>]
    #
    # @!attribute [rw] private_ip_address
    #   \[EC2-VPC\] The primary IPv4 address. You must specify a value from
    #   the IPv4 address range of the subnet.
    #
    #   Only one private IP address can be designated as primary. You can't
    #   specify this option if you've specified the option to designate a
    #   private IP address as the primary IP address in a network interface
    #   specification. You cannot specify this option if you're launching
    #   more than one instance in the request.
    #
    #   You cannot specify this option and the network interfaces option in
    #   the same request.
    #   @return [String]
    #
    # @!attribute [rw] elastic_gpu_specification
    #   An elastic GPU to associate with the instance. An Elastic GPU is a
    #   GPU resource that you can attach to your Windows instance to
    #   accelerate the graphics performance of your applications. For more
    #   information, see [ Amazon EC2 Elastic GPUs][1] in the *Amazon
    #   Elastic Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/WindowsGuide/elastic-graphics.html
    #   @return [Array<Types::ElasticGpuSpecification>]
    #
    # @!attribute [rw] elastic_inference_accelerators
    #   An elastic inference accelerator to associate with the instance.
    #   Elastic inference accelerators are a resource you can attach to your
    #   Amazon EC2 instances to accelerate your Deep Learning (DL) inference
    #   workloads.
    #
    #   You cannot specify accelerators from different generations in the
    #   same request.
    #   @return [Array<Types::ElasticInferenceAccelerator>]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply to the resources during launch. You can only tag
    #   instances and volumes on launch. The specified tags are applied to
    #   all instances or volumes that are created during launch. To tag a
    #   resource after it has been created, see [CreateTags][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html
    #   @return [Array<Types::TagSpecification>]
    #
    # @!attribute [rw] launch_template
    #   The launch template to use to launch the instances. Any parameters
    #   that you specify in RunInstances override the same parameters in the
    #   launch template. You can specify either the name or ID of a launch
    #   template, but not both.
    #   @return [Types::LaunchTemplateSpecification]
    #
    # @!attribute [rw] instance_market_options
    #   The market (purchasing) option for the instances.
    #
    #   For RunInstances, persistent Spot Instance requests are only
    #   supported when **InstanceInterruptionBehavior** is set to either
    #   `hibernate` or `stop`.
    #   @return [Types::InstanceMarketOptionsRequest]
    #
    # @!attribute [rw] credit_specification
    #   The credit option for CPU usage of the burstable performance
    #   instance. Valid values are `standard` and `unlimited`. To change
    #   this attribute after launch, use [
    #   ModifyInstanceCreditSpecification][1]. For more information, see
    #   [Burstable Performance Instances][2] in the *Amazon Elastic Compute
    #   Cloud User Guide*.
    #
    #   Default: `standard` (T2 instances) or `unlimited` (T3/T3a instances)
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ModifyInstanceCreditSpecification.html
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/burstable-performance-instances.html
    #   @return [Types::CreditSpecificationRequest]
    #
    # @!attribute [rw] cpu_options
    #   The CPU options for the instance. For more information, see
    #   [Optimizing CPU Options][1] in the *Amazon Elastic Compute Cloud
    #   User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html
    #   @return [Types::CpuOptionsRequest]
    #
    # @!attribute [rw] capacity_reservation_specification
    #   Information about the Capacity Reservation targeting option. If you
    #   do not specify this parameter, the instance's Capacity Reservation
    #   preference defaults to `open`, which enables it to run in any open
    #   Capacity Reservation that has matching attributes (instance type,
    #   platform, Availability Zone).
    #   @return [Types::CapacityReservationSpecification]
    #
    # @!attribute [rw] hibernation_options
    #   Indicates whether an instance is enabled for hibernation. For more
    #   information, see [Hibernate Your Instance][1] in the *Amazon Elastic
    #   Compute Cloud User Guide*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html
    #   @return [Types::HibernationOptionsRequest]
    #
    # @!attribute [rw] license_specifications
    #   The license configurations.
    #   @return [Array<Types::LicenseConfigurationRequest>]
    #
    # @!attribute [rw] metadata_options
    #   The metadata options for the instance. For more information, see
    #   [Instance Metadata and User Data][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-instance-metadata.html
    #   @return [Types::InstanceMetadataOptionsRequest]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RunInstancesRequest AWS API Documentation
    #
    class RunInstancesRequest < Struct.new(
      :block_device_mappings,
      :image_id,
      :instance_type,
      :ipv_6_address_count,
      :ipv_6_addresses,
      :kernel_id,
      :key_name,
      :max_count,
      :min_count,
      :monitoring,
      :placement,
      :ramdisk_id,
      :security_group_ids,
      :security_groups,
      :subnet_id,
      :user_data,
      :additional_info,
      :client_token,
      :disable_api_termination,
      :dry_run,
      :ebs_optimized,
      :iam_instance_profile,
      :instance_initiated_shutdown_behavior,
      :network_interfaces,
      :private_ip_address,
      :elastic_gpu_specification,
      :elastic_inference_accelerators,
      :tag_specifications,
      :launch_template,
      :instance_market_options,
      :credit_specification,
      :cpu_options,
      :capacity_reservation_specification,
      :hibernation_options,
      :license_specifications,
      :metadata_options)
      include Aws::Structure
    end

    # Contains the parameters for RunScheduledInstances.
    #
    # @note When making an API call, you may pass RunScheduledInstancesRequest
    #   data as a hash:
    #
    #       {
    #         client_token: "String",
    #         dry_run: false,
    #         instance_count: 1,
    #         launch_specification: { # required
    #           block_device_mappings: [
    #             {
    #               device_name: "String",
    #               ebs: {
    #                 delete_on_termination: false,
    #                 encrypted: false,
    #                 iops: 1,
    #                 snapshot_id: "SnapshotId",
    #                 volume_size: 1,
    #                 volume_type: "String",
    #               },
    #               no_device: "String",
    #               virtual_name: "String",
    #             },
    #           ],
    #           ebs_optimized: false,
    #           iam_instance_profile: {
    #             arn: "String",
    #             name: "String",
    #           },
    #           image_id: "ImageId", # required
    #           instance_type: "String",
    #           kernel_id: "KernelId",
    #           key_name: "KeyPairName",
    #           monitoring: {
    #             enabled: false,
    #           },
    #           network_interfaces: [
    #             {
    #               associate_public_ip_address: false,
    #               delete_on_termination: false,
    #               description: "String",
    #               device_index: 1,
    #               groups: ["SecurityGroupId"],
    #               ipv_6_address_count: 1,
    #               ipv_6_addresses: [
    #                 {
    #                   ipv_6_address: "Ipv6Address",
    #                 },
    #               ],
    #               network_interface_id: "NetworkInterfaceId",
    #               private_ip_address: "String",
    #               private_ip_address_configs: [
    #                 {
    #                   primary: false,
    #                   private_ip_address: "String",
    #                 },
    #               ],
    #               secondary_private_ip_address_count: 1,
    #               subnet_id: "SubnetId",
    #             },
    #           ],
    #           placement: {
    #             availability_zone: "String",
    #             group_name: "PlacementGroupName",
    #           },
    #           ramdisk_id: "RamdiskId",
    #           security_group_ids: ["SecurityGroupId"],
    #           subnet_id: "SubnetId",
    #           user_data: "String",
    #         },
    #         scheduled_instance_id: "ScheduledInstanceId", # required
    #       }
    #
    # @!attribute [rw] client_token
    #   Unique, case-sensitive identifier that ensures the idempotency of
    #   the request. For more information, see [Ensuring Idempotency][1].
    #
    #   **A suitable default value is auto-generated.** You should normally
    #   not need to pass this option.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_count
    #   The number of instances.
    #
    #   Default: 1
    #   @return [Integer]
    #
    # @!attribute [rw] launch_specification
    #   The launch specification. You must match the instance type,
    #   Availability Zone, network, and platform of the schedule that you
    #   purchased.
    #   @return [Types::ScheduledInstancesLaunchSpecification]
    #
    # @!attribute [rw] scheduled_instance_id
    #   The Scheduled Instance ID.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RunScheduledInstancesRequest AWS API Documentation
    #
    class RunScheduledInstancesRequest < Struct.new(
      :client_token,
      :dry_run,
      :instance_count,
      :launch_specification,
      :scheduled_instance_id)
      include Aws::Structure
    end

    # Contains the output of RunScheduledInstances.
    #
    # @!attribute [rw] instance_id_set
    #   The IDs of the newly launched instances.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/RunScheduledInstancesResult AWS API Documentation
    #
    class RunScheduledInstancesResult < Struct.new(
      :instance_id_set)
      include Aws::Structure
    end

    # Describes the storage parameters for S3 and S3 buckets for an instance
    # store-backed AMI.
    #
    # @note When making an API call, you may pass S3Storage
    #   data as a hash:
    #
    #       {
    #         aws_access_key_id: "String",
    #         bucket: "String",
    #         prefix: "String",
    #         upload_policy: "data",
    #         upload_policy_signature: "String",
    #       }
    #
    # @!attribute [rw] aws_access_key_id
    #   The access key ID of the owner of the bucket. Before you specify a
    #   value for your access key ID, review and follow the guidance in
    #   [Best Practices for Managing AWS Access Keys][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html
    #   @return [String]
    #
    # @!attribute [rw] bucket
    #   The bucket in which to store the AMI. You can specify a bucket that
    #   you already own or a new bucket that Amazon EC2 creates on your
    #   behalf. If you specify a bucket that belongs to someone else, Amazon
    #   EC2 returns an error.
    #   @return [String]
    #
    # @!attribute [rw] prefix
    #   The beginning of the file name of the AMI.
    #   @return [String]
    #
    # @!attribute [rw] upload_policy
    #   An Amazon S3 upload policy that gives Amazon EC2 permission to
    #   upload items into Amazon S3 on your behalf.
    #   @return [String]
    #
    # @!attribute [rw] upload_policy_signature
    #   The signature of the JSON document.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/S3Storage AWS API Documentation
    #
    class S3Storage < Struct.new(
      :aws_access_key_id,
      :bucket,
      :prefix,
      :upload_policy,
      :upload_policy_signature)
      include Aws::Structure
    end

    # Describes a Scheduled Instance.
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone.
    #   @return [String]
    #
    # @!attribute [rw] create_date
    #   The date when the Scheduled Instance was purchased.
    #   @return [Time]
    #
    # @!attribute [rw] hourly_price
    #   The hourly price for a single instance.
    #   @return [String]
    #
    # @!attribute [rw] instance_count
    #   The number of instances.
    #   @return [Integer]
    #
    # @!attribute [rw] instance_type
    #   The instance type.
    #   @return [String]
    #
    # @!attribute [rw] network_platform
    #   The network platform (`EC2-Classic` or `EC2-VPC`).
    #   @return [String]
    #
    # @!attribute [rw] next_slot_start_time
    #   The time for the next schedule to start.
    #   @return [Time]
    #
    # @!attribute [rw] platform
    #   The platform (`Linux/UNIX` or `Windows`).
    #   @return [String]
    #
    # @!attribute [rw] previous_slot_end_time
    #   The time that the previous schedule ended or will end.
    #   @return [Time]
    #
    # @!attribute [rw] recurrence
    #   The schedule recurrence.
    #   @return [Types::ScheduledInstanceRecurrence]
    #
    # @!attribute [rw] scheduled_instance_id
    #   The Scheduled Instance ID.
    #   @return [String]
    #
    # @!attribute [rw] slot_duration_in_hours
    #   The number of hours in the schedule.
    #   @return [Integer]
    #
    # @!attribute [rw] term_end_date
    #   The end date for the Scheduled Instance.
    #   @return [Time]
    #
    # @!attribute [rw] term_start_date
    #   The start date for the Scheduled Instance.
    #   @return [Time]
    #
    # @!attribute [rw] total_scheduled_instance_hours
    #   The total number of hours for a single instance for the entire term.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ScheduledInstance AWS API Documentation
    #
    class ScheduledInstance < Struct.new(
      :availability_zone,
      :create_date,
      :hourly_price,
      :instance_count,
      :instance_type,
      :network_platform,
      :next_slot_start_time,
      :platform,
      :previous_slot_end_time,
      :recurrence,
      :scheduled_instance_id,
      :slot_duration_in_hours,
      :term_end_date,
      :term_start_date,
      :total_scheduled_instance_hours)
      include Aws::Structure
    end

    # Describes a schedule that is available for your Scheduled Instances.
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone.
    #   @return [String]
    #
    # @!attribute [rw] available_instance_count
    #   The number of available instances.
    #   @return [Integer]
    #
    # @!attribute [rw] first_slot_start_time
    #   The time period for the first schedule to start.
    #   @return [Time]
    #
    # @!attribute [rw] hourly_price
    #   The hourly price for a single instance.
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   The instance type. You can specify one of the C3, C4, M4, or R3
    #   instance types.
    #   @return [String]
    #
    # @!attribute [rw] max_term_duration_in_days
    #   The maximum term. The only possible value is 365 days.
    #   @return [Integer]
    #
    # @!attribute [rw] min_term_duration_in_days
    #   The minimum term. The only possible value is 365 days.
    #   @return [Integer]
    #
    # @!attribute [rw] network_platform
    #   The network platform (`EC2-Classic` or `EC2-VPC`).
    #   @return [String]
    #
    # @!attribute [rw] platform
    #   The platform (`Linux/UNIX` or `Windows`).
    #   @return [String]
    #
    # @!attribute [rw] purchase_token
    #   The purchase token. This token expires in two hours.
    #   @return [String]
    #
    # @!attribute [rw] recurrence
    #   The schedule recurrence.
    #   @return [Types::ScheduledInstanceRecurrence]
    #
    # @!attribute [rw] slot_duration_in_hours
    #   The number of hours in the schedule.
    #   @return [Integer]
    #
    # @!attribute [rw] total_scheduled_instance_hours
    #   The total number of hours for a single instance for the entire term.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ScheduledInstanceAvailability AWS API Documentation
    #
    class ScheduledInstanceAvailability < Struct.new(
      :availability_zone,
      :available_instance_count,
      :first_slot_start_time,
      :hourly_price,
      :instance_type,
      :max_term_duration_in_days,
      :min_term_duration_in_days,
      :network_platform,
      :platform,
      :purchase_token,
      :recurrence,
      :slot_duration_in_hours,
      :total_scheduled_instance_hours)
      include Aws::Structure
    end

    # Describes the recurring schedule for a Scheduled Instance.
    #
    # @!attribute [rw] frequency
    #   The frequency (`Daily`, `Weekly`, or `Monthly`).
    #   @return [String]
    #
    # @!attribute [rw] interval
    #   The interval quantity. The interval unit depends on the value of
    #   `frequency`. For example, every 2 weeks or every 2 months.
    #   @return [Integer]
    #
    # @!attribute [rw] occurrence_day_set
    #   The days. For a monthly schedule, this is one or more days of the
    #   month (1-31). For a weekly schedule, this is one or more days of the
    #   week (1-7, where 1 is Sunday).
    #   @return [Array<Integer>]
    #
    # @!attribute [rw] occurrence_relative_to_end
    #   Indicates whether the occurrence is relative to the end of the
    #   specified week or month.
    #   @return [Boolean]
    #
    # @!attribute [rw] occurrence_unit
    #   The unit for `occurrenceDaySet` (`DayOfWeek` or `DayOfMonth`).
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ScheduledInstanceRecurrence AWS API Documentation
    #
    class ScheduledInstanceRecurrence < Struct.new(
      :frequency,
      :interval,
      :occurrence_day_set,
      :occurrence_relative_to_end,
      :occurrence_unit)
      include Aws::Structure
    end

    # Describes the recurring schedule for a Scheduled Instance.
    #
    # @note When making an API call, you may pass ScheduledInstanceRecurrenceRequest
    #   data as a hash:
    #
    #       {
    #         frequency: "String",
    #         interval: 1,
    #         occurrence_days: [1],
    #         occurrence_relative_to_end: false,
    #         occurrence_unit: "String",
    #       }
    #
    # @!attribute [rw] frequency
    #   The frequency (`Daily`, `Weekly`, or `Monthly`).
    #   @return [String]
    #
    # @!attribute [rw] interval
    #   The interval quantity. The interval unit depends on the value of
    #   `Frequency`. For example, every 2 weeks or every 2 months.
    #   @return [Integer]
    #
    # @!attribute [rw] occurrence_days
    #   The days. For a monthly schedule, this is one or more days of the
    #   month (1-31). For a weekly schedule, this is one or more days of the
    #   week (1-7, where 1 is Sunday). You can't specify this value with a
    #   daily schedule. If the occurrence is relative to the end of the
    #   month, you can specify only a single day.
    #   @return [Array<Integer>]
    #
    # @!attribute [rw] occurrence_relative_to_end
    #   Indicates whether the occurrence is relative to the end of the
    #   specified week or month. You can't specify this value with a daily
    #   schedule.
    #   @return [Boolean]
    #
    # @!attribute [rw] occurrence_unit
    #   The unit for `OccurrenceDays` (`DayOfWeek` or `DayOfMonth`). This
    #   value is required for a monthly schedule. You can't specify
    #   `DayOfWeek` with a weekly schedule. You can't specify this value
    #   with a daily schedule.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ScheduledInstanceRecurrenceRequest AWS API Documentation
    #
    class ScheduledInstanceRecurrenceRequest < Struct.new(
      :frequency,
      :interval,
      :occurrence_days,
      :occurrence_relative_to_end,
      :occurrence_unit)
      include Aws::Structure
    end

    # Describes a block device mapping for a Scheduled Instance.
    #
    # @note When making an API call, you may pass ScheduledInstancesBlockDeviceMapping
    #   data as a hash:
    #
    #       {
    #         device_name: "String",
    #         ebs: {
    #           delete_on_termination: false,
    #           encrypted: false,
    #           iops: 1,
    #           snapshot_id: "SnapshotId",
    #           volume_size: 1,
    #           volume_type: "String",
    #         },
    #         no_device: "String",
    #         virtual_name: "String",
    #       }
    #
    # @!attribute [rw] device_name
    #   The device name (for example, `/dev/sdh` or `xvdh`).
    #   @return [String]
    #
    # @!attribute [rw] ebs
    #   Parameters used to set up EBS volumes automatically when the
    #   instance is launched.
    #   @return [Types::ScheduledInstancesEbs]
    #
    # @!attribute [rw] no_device
    #   Suppresses the specified device included in the block device mapping
    #   of the AMI.
    #   @return [String]
    #
    # @!attribute [rw] virtual_name
    #   The virtual device name (`ephemeral`N). Instance store volumes are
    #   numbered starting from 0. An instance type with two available
    #   instance store volumes can specify mappings for `ephemeral0` and
    #   `ephemeral1`. The number of available instance store volumes depends
    #   on the instance type. After you connect to the instance, you must
    #   mount the volume.
    #
    #   Constraints: For M3 instances, you must specify instance store
    #   volumes in the block device mapping for the instance. When you
    #   launch an M3 instance, we ignore any instance store volumes
    #   specified in the block device mapping for the AMI.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ScheduledInstancesBlockDeviceMapping AWS API Documentation
    #
    class ScheduledInstancesBlockDeviceMapping < Struct.new(
      :device_name,
      :ebs,
      :no_device,
      :virtual_name)
      include Aws::Structure
    end

    # Describes an EBS volume for a Scheduled Instance.
    #
    # @note When making an API call, you may pass ScheduledInstancesEbs
    #   data as a hash:
    #
    #       {
    #         delete_on_termination: false,
    #         encrypted: false,
    #         iops: 1,
    #         snapshot_id: "SnapshotId",
    #         volume_size: 1,
    #         volume_type: "String",
    #       }
    #
    # @!attribute [rw] delete_on_termination
    #   Indicates whether the volume is deleted on instance termination.
    #   @return [Boolean]
    #
    # @!attribute [rw] encrypted
    #   Indicates whether the volume is encrypted. You can attached
    #   encrypted volumes only to instances that support them.
    #   @return [Boolean]
    #
    # @!attribute [rw] iops
    #   The number of I/O operations per second (IOPS) that the volume
    #   supports. For io1 volumes, this represents the number of IOPS that
    #   are provisioned for the volume. For `gp2` volumes, this represents
    #   the baseline performance of the volume and the rate at which the
    #   volume accumulates I/O credits for bursting. For more information
    #   about `gp2` baseline performance, I/O credits, and bursting, see
    #   [Amazon EBS Volume Types][1] in the *Amazon Elastic Compute Cloud
    #   User Guide*.
    #
    #   Constraint: Range is 100-20000 IOPS for `io1` volumes and 100-10000
    #   IOPS for `gp2` volumes.
    #
    #   Condition: This parameter is required for requests to create
    #   `io1`volumes; it is not used in requests to create `gp2`, `st1`,
    #   `sc1`, or `standard` volumes.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html
    #   @return [Integer]
    #
    # @!attribute [rw] snapshot_id
    #   The ID of the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] volume_size
    #   The size of the volume, in GiB.
    #
    #   Default: If you're creating the volume from a snapshot and don't
    #   specify a volume size, the default is the snapshot size.
    #   @return [Integer]
    #
    # @!attribute [rw] volume_type
    #   The volume type. `gp2` for General Purpose SSD, `io1` for
    #   Provisioned IOPS SSD, Throughput Optimized HDD for `st1`, Cold HDD
    #   for `sc1`, or `standard` for Magnetic.
    #
    #   Default: `gp2`
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ScheduledInstancesEbs AWS API Documentation
    #
    class ScheduledInstancesEbs < Struct.new(
      :delete_on_termination,
      :encrypted,
      :iops,
      :snapshot_id,
      :volume_size,
      :volume_type)
      include Aws::Structure
    end

    # Describes an IAM instance profile for a Scheduled Instance.
    #
    # @note When making an API call, you may pass ScheduledInstancesIamInstanceProfile
    #   data as a hash:
    #
    #       {
    #         arn: "String",
    #         name: "String",
    #       }
    #
    # @!attribute [rw] arn
    #   The Amazon Resource Name (ARN).
    #   @return [String]
    #
    # @!attribute [rw] name
    #   The name.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ScheduledInstancesIamInstanceProfile AWS API Documentation
    #
    class ScheduledInstancesIamInstanceProfile < Struct.new(
      :arn,
      :name)
      include Aws::Structure
    end

    # Describes an IPv6 address.
    #
    # @note When making an API call, you may pass ScheduledInstancesIpv6Address
    #   data as a hash:
    #
    #       {
    #         ipv_6_address: "Ipv6Address",
    #       }
    #
    # @!attribute [rw] ipv_6_address
    #   The IPv6 address.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ScheduledInstancesIpv6Address AWS API Documentation
    #
    class ScheduledInstancesIpv6Address < Struct.new(
      :ipv_6_address)
      include Aws::Structure
    end

    # Describes the launch specification for a Scheduled Instance.
    #
    # If you are launching the Scheduled Instance in EC2-VPC, you must
    # specify the ID of the subnet. You can specify the subnet using either
    # `SubnetId` or `NetworkInterface`.
    #
    # @note When making an API call, you may pass ScheduledInstancesLaunchSpecification
    #   data as a hash:
    #
    #       {
    #         block_device_mappings: [
    #           {
    #             device_name: "String",
    #             ebs: {
    #               delete_on_termination: false,
    #               encrypted: false,
    #               iops: 1,
    #               snapshot_id: "SnapshotId",
    #               volume_size: 1,
    #               volume_type: "String",
    #             },
    #             no_device: "String",
    #             virtual_name: "String",
    #           },
    #         ],
    #         ebs_optimized: false,
    #         iam_instance_profile: {
    #           arn: "String",
    #           name: "String",
    #         },
    #         image_id: "ImageId", # required
    #         instance_type: "String",
    #         kernel_id: "KernelId",
    #         key_name: "KeyPairName",
    #         monitoring: {
    #           enabled: false,
    #         },
    #         network_interfaces: [
    #           {
    #             associate_public_ip_address: false,
    #             delete_on_termination: false,
    #             description: "String",
    #             device_index: 1,
    #             groups: ["SecurityGroupId"],
    #             ipv_6_address_count: 1,
    #             ipv_6_addresses: [
    #               {
    #                 ipv_6_address: "Ipv6Address",
    #               },
    #             ],
    #             network_interface_id: "NetworkInterfaceId",
    #             private_ip_address: "String",
    #             private_ip_address_configs: [
    #               {
    #                 primary: false,
    #                 private_ip_address: "String",
    #               },
    #             ],
    #             secondary_private_ip_address_count: 1,
    #             subnet_id: "SubnetId",
    #           },
    #         ],
    #         placement: {
    #           availability_zone: "String",
    #           group_name: "PlacementGroupName",
    #         },
    #         ramdisk_id: "RamdiskId",
    #         security_group_ids: ["SecurityGroupId"],
    #         subnet_id: "SubnetId",
    #         user_data: "String",
    #       }
    #
    # @!attribute [rw] block_device_mappings
    #   The block device mapping entries.
    #   @return [Array<Types::ScheduledInstancesBlockDeviceMapping>]
    #
    # @!attribute [rw] ebs_optimized
    #   Indicates whether the instances are optimized for EBS I/O. This
    #   optimization provides dedicated throughput to Amazon EBS and an
    #   optimized configuration stack to provide optimal EBS I/O
    #   performance. This optimization isn't available with all instance
    #   types. Additional usage charges apply when using an EBS-optimized
    #   instance.
    #
    #   Default: `false`
    #   @return [Boolean]
    #
    # @!attribute [rw] iam_instance_profile
    #   The IAM instance profile.
    #   @return [Types::ScheduledInstancesIamInstanceProfile]
    #
    # @!attribute [rw] image_id
    #   The ID of the Amazon Machine Image (AMI).
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   The instance type.
    #   @return [String]
    #
    # @!attribute [rw] kernel_id
    #   The ID of the kernel.
    #   @return [String]
    #
    # @!attribute [rw] key_name
    #   The name of the key pair.
    #   @return [String]
    #
    # @!attribute [rw] monitoring
    #   Enable or disable monitoring for the instances.
    #   @return [Types::ScheduledInstancesMonitoring]
    #
    # @!attribute [rw] network_interfaces
    #   The network interfaces.
    #   @return [Array<Types::ScheduledInstancesNetworkInterface>]
    #
    # @!attribute [rw] placement
    #   The placement information.
    #   @return [Types::ScheduledInstancesPlacement]
    #
    # @!attribute [rw] ramdisk_id
    #   The ID of the RAM disk.
    #   @return [String]
    #
    # @!attribute [rw] security_group_ids
    #   The IDs of the security groups.
    #   @return [Array<String>]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet in which to launch the instances.
    #   @return [String]
    #
    # @!attribute [rw] user_data
    #   The base64-encoded MIME user data.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ScheduledInstancesLaunchSpecification AWS API Documentation
    #
    class ScheduledInstancesLaunchSpecification < Struct.new(
      :block_device_mappings,
      :ebs_optimized,
      :iam_instance_profile,
      :image_id,
      :instance_type,
      :kernel_id,
      :key_name,
      :monitoring,
      :network_interfaces,
      :placement,
      :ramdisk_id,
      :security_group_ids,
      :subnet_id,
      :user_data)
      include Aws::Structure
    end

    # Describes whether monitoring is enabled for a Scheduled Instance.
    #
    # @note When making an API call, you may pass ScheduledInstancesMonitoring
    #   data as a hash:
    #
    #       {
    #         enabled: false,
    #       }
    #
    # @!attribute [rw] enabled
    #   Indicates whether monitoring is enabled.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ScheduledInstancesMonitoring AWS API Documentation
    #
    class ScheduledInstancesMonitoring < Struct.new(
      :enabled)
      include Aws::Structure
    end

    # Describes a network interface for a Scheduled Instance.
    #
    # @note When making an API call, you may pass ScheduledInstancesNetworkInterface
    #   data as a hash:
    #
    #       {
    #         associate_public_ip_address: false,
    #         delete_on_termination: false,
    #         description: "String",
    #         device_index: 1,
    #         groups: ["SecurityGroupId"],
    #         ipv_6_address_count: 1,
    #         ipv_6_addresses: [
    #           {
    #             ipv_6_address: "Ipv6Address",
    #           },
    #         ],
    #         network_interface_id: "NetworkInterfaceId",
    #         private_ip_address: "String",
    #         private_ip_address_configs: [
    #           {
    #             primary: false,
    #             private_ip_address: "String",
    #           },
    #         ],
    #         secondary_private_ip_address_count: 1,
    #         subnet_id: "SubnetId",
    #       }
    #
    # @!attribute [rw] associate_public_ip_address
    #   Indicates whether to assign a public IPv4 address to instances
    #   launched in a VPC. The public IPv4 address can only be assigned to a
    #   network interface for eth0, and can only be assigned to a new
    #   network interface, not an existing one. You cannot specify more than
    #   one network interface in the request. If launching into a default
    #   subnet, the default value is `true`.
    #   @return [Boolean]
    #
    # @!attribute [rw] delete_on_termination
    #   Indicates whether to delete the interface when the instance is
    #   terminated.
    #   @return [Boolean]
    #
    # @!attribute [rw] description
    #   The description.
    #   @return [String]
    #
    # @!attribute [rw] device_index
    #   The index of the device for the network interface attachment.
    #   @return [Integer]
    #
    # @!attribute [rw] groups
    #   The IDs of the security groups.
    #   @return [Array<String>]
    #
    # @!attribute [rw] ipv_6_address_count
    #   The number of IPv6 addresses to assign to the network interface. The
    #   IPv6 addresses are automatically selected from the subnet range.
    #   @return [Integer]
    #
    # @!attribute [rw] ipv_6_addresses
    #   The specific IPv6 addresses from the subnet range.
    #   @return [Array<Types::ScheduledInstancesIpv6Address>]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_address
    #   The IPv4 address of the network interface within the subnet.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_address_configs
    #   The private IPv4 addresses.
    #   @return [Array<Types::ScheduledInstancesPrivateIpAddressConfig>]
    #
    # @!attribute [rw] secondary_private_ip_address_count
    #   The number of secondary private IPv4 addresses.
    #   @return [Integer]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ScheduledInstancesNetworkInterface AWS API Documentation
    #
    class ScheduledInstancesNetworkInterface < Struct.new(
      :associate_public_ip_address,
      :delete_on_termination,
      :description,
      :device_index,
      :groups,
      :ipv_6_address_count,
      :ipv_6_addresses,
      :network_interface_id,
      :private_ip_address,
      :private_ip_address_configs,
      :secondary_private_ip_address_count,
      :subnet_id)
      include Aws::Structure
    end

    # Describes the placement for a Scheduled Instance.
    #
    # @note When making an API call, you may pass ScheduledInstancesPlacement
    #   data as a hash:
    #
    #       {
    #         availability_zone: "String",
    #         group_name: "PlacementGroupName",
    #       }
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone.
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   The name of the placement group.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ScheduledInstancesPlacement AWS API Documentation
    #
    class ScheduledInstancesPlacement < Struct.new(
      :availability_zone,
      :group_name)
      include Aws::Structure
    end

    # Describes a private IPv4 address for a Scheduled Instance.
    #
    # @note When making an API call, you may pass ScheduledInstancesPrivateIpAddressConfig
    #   data as a hash:
    #
    #       {
    #         primary: false,
    #         private_ip_address: "String",
    #       }
    #
    # @!attribute [rw] primary
    #   Indicates whether this is a primary IPv4 address. Otherwise, this is
    #   a secondary IPv4 address.
    #   @return [Boolean]
    #
    # @!attribute [rw] private_ip_address
    #   The IPv4 address.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ScheduledInstancesPrivateIpAddressConfig AWS API Documentation
    #
    class ScheduledInstancesPrivateIpAddressConfig < Struct.new(
      :primary,
      :private_ip_address)
      include Aws::Structure
    end

    # @note When making an API call, you may pass SearchLocalGatewayRoutesRequest
    #   data as a hash:
    #
    #       {
    #         local_gateway_route_table_id: "LocalGatewayRoutetableId", # required
    #         filters: [ # required
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] local_gateway_route_table_id
    #   The ID of the local gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SearchLocalGatewayRoutesRequest AWS API Documentation
    #
    class SearchLocalGatewayRoutesRequest < Struct.new(
      :local_gateway_route_table_id,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] routes
    #   Information about the routes.
    #   @return [Array<Types::LocalGatewayRoute>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SearchLocalGatewayRoutesResult AWS API Documentation
    #
    class SearchLocalGatewayRoutesResult < Struct.new(
      :routes,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass SearchTransitGatewayMulticastGroupsRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_multicast_domain_id: "TransitGatewayMulticastDomainId",
    #         filters: [
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         next_token: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_multicast_domain_id
    #   The ID of the transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters. The possible values are:
    #
    #   * `group-ip-address` - The IP address of the transit gateway
    #     multicast group.
    #
    #   * `is-group-member` - The resource is a group member. Valid values
    #     are `true` \| `false`.
    #
    #   * `is-group-source` - The resource is a group source. Valid values
    #     are `true` \| `false`.
    #
    #   * `member-type` - The member type. Valid values are `igmp` \|
    #     `static`.
    #
    #   * `resource-id` - The ID of the resource.
    #
    #   * `resource-type` - The type of resource. Valid values are `vpc` \|
    #     `vpn` \| `direct-connect-gateway` \| `tgw-peering`.
    #
    #   * `source-type` - The source type. Valid values are `igmp` \|
    #     `static`.
    #
    #   * `state` - The state of the subnet association. Valid values are
    #     `associated` \| `associated` \| `disassociated` \|
    #     `disassociating`.
    #
    #   * `subnet-id` - The ID of the subnet.
    #
    #   * `transit-gateway-attachment-id` - The id of the transit gateway
    #     attachment.
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of results to return with a single call. To
    #   retrieve the remaining results, make another call with the returned
    #   `nextToken` value.
    #   @return [Integer]
    #
    # @!attribute [rw] next_token
    #   The token for the next page of results.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SearchTransitGatewayMulticastGroupsRequest AWS API Documentation
    #
    class SearchTransitGatewayMulticastGroupsRequest < Struct.new(
      :transit_gateway_multicast_domain_id,
      :filters,
      :max_results,
      :next_token,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] multicast_groups
    #   Information about the transit gateway multicast group.
    #   @return [Array<Types::TransitGatewayMulticastGroup>]
    #
    # @!attribute [rw] next_token
    #   The token to use to retrieve the next page of results. This value is
    #   `null` when there are no more results to return.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SearchTransitGatewayMulticastGroupsResult AWS API Documentation
    #
    class SearchTransitGatewayMulticastGroupsResult < Struct.new(
      :multicast_groups,
      :next_token)
      include Aws::Structure
    end

    # @note When making an API call, you may pass SearchTransitGatewayRoutesRequest
    #   data as a hash:
    #
    #       {
    #         transit_gateway_route_table_id: "TransitGatewayRouteTableId", # required
    #         filters: [ # required
    #           {
    #             name: "String",
    #             values: ["String"],
    #           },
    #         ],
    #         max_results: 1,
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the transit gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] filters
    #   One or more filters. The possible values are:
    #
    #   * `attachment.transit-gateway-attachment-id`- The id of the transit
    #     gateway attachment.
    #
    #   * `attachment.resource-id` - The resource id of the transit gateway
    #     attachment.
    #
    #   * `attachment.resource-type` - The attachment resource type (`vpc`
    #     \| `vpn`).
    #
    #   * `route-search.exact-match` - The exact match of the specified
    #     filter.
    #
    #   * `route-search.longest-prefix-match` - The longest prefix that
    #     matches the route.
    #
    #   * `route-search.subnet-of-match` - The routes with a subnet that
    #     match the specified CIDR filter.
    #
    #   * `route-search.supernet-of-match` - The routes with a CIDR that
    #     encompass the CIDR filter. For example, if you have 10.0.1.0/29
    #     and 10.0.1.0/31 routes in your route table and you specify
    #     supernet-of-match as 10.0.1.0/30, then the result returns
    #     10.0.1.0/29.
    #
    #   * `state` - The state of the route (`active` \| `blackhole`).
    #
    #   * `type` - The type of route (`propagated` \| `static`).
    #   @return [Array<Types::Filter>]
    #
    # @!attribute [rw] max_results
    #   The maximum number of routes to return.
    #   @return [Integer]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SearchTransitGatewayRoutesRequest AWS API Documentation
    #
    class SearchTransitGatewayRoutesRequest < Struct.new(
      :transit_gateway_route_table_id,
      :filters,
      :max_results,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] routes
    #   Information about the routes.
    #   @return [Array<Types::TransitGatewayRoute>]
    #
    # @!attribute [rw] additional_routes_available
    #   Indicates whether there are additional routes available.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SearchTransitGatewayRoutesResult AWS API Documentation
    #
    class SearchTransitGatewayRoutesResult < Struct.new(
      :routes,
      :additional_routes_available)
      include Aws::Structure
    end

    # Describes a security group
    #
    # @!attribute [rw] description
    #   A description of the security group.
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   The name of the security group.
    #   @return [String]
    #
    # @!attribute [rw] ip_permissions
    #   The inbound rules associated with the security group.
    #   @return [Array<Types::IpPermission>]
    #
    # @!attribute [rw] owner_id
    #   The AWS account ID of the owner of the security group.
    #   @return [String]
    #
    # @!attribute [rw] group_id
    #   The ID of the security group.
    #   @return [String]
    #
    # @!attribute [rw] ip_permissions_egress
    #   \[VPC only\] The outbound rules associated with the security group.
    #   @return [Array<Types::IpPermission>]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the security group.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] vpc_id
    #   \[VPC only\] The ID of the VPC for the security group.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SecurityGroup AWS API Documentation
    #
    class SecurityGroup < Struct.new(
      :description,
      :group_name,
      :ip_permissions,
      :owner_id,
      :group_id,
      :ip_permissions_egress,
      :tags,
      :vpc_id)
      include Aws::Structure
    end

    # Describes a security group.
    #
    # @!attribute [rw] group_id
    #   The ID of the security group.
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   The name of the security group.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SecurityGroupIdentifier AWS API Documentation
    #
    class SecurityGroupIdentifier < Struct.new(
      :group_id,
      :group_name)
      include Aws::Structure
    end

    # Describes a VPC with a security group that references your security
    # group.
    #
    # @!attribute [rw] group_id
    #   The ID of your security group.
    #   @return [String]
    #
    # @!attribute [rw] referencing_vpc_id
    #   The ID of the VPC with the referencing security group.
    #   @return [String]
    #
    # @!attribute [rw] vpc_peering_connection_id
    #   The ID of the VPC peering connection.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SecurityGroupReference AWS API Documentation
    #
    class SecurityGroupReference < Struct.new(
      :group_id,
      :referencing_vpc_id,
      :vpc_peering_connection_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass SendDiagnosticInterruptRequest
    #   data as a hash:
    #
    #       {
    #         instance_id: "InstanceId", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SendDiagnosticInterruptRequest AWS API Documentation
    #
    class SendDiagnosticInterruptRequest < Struct.new(
      :instance_id,
      :dry_run)
      include Aws::Structure
    end

    # Describes a service configuration for a VPC endpoint service.
    #
    # @!attribute [rw] service_type
    #   The type of service.
    #   @return [Array<Types::ServiceTypeDetail>]
    #
    # @!attribute [rw] service_id
    #   The ID of the service.
    #   @return [String]
    #
    # @!attribute [rw] service_name
    #   The name of the service.
    #   @return [String]
    #
    # @!attribute [rw] service_state
    #   The service state.
    #   @return [String]
    #
    # @!attribute [rw] availability_zones
    #   The Availability Zones in which the service is available.
    #   @return [Array<String>]
    #
    # @!attribute [rw] acceptance_required
    #   Indicates whether requests from other AWS accounts to create an
    #   endpoint to the service must first be accepted.
    #   @return [Boolean]
    #
    # @!attribute [rw] manages_vpc_endpoints
    #   Indicates whether the service manages its VPC endpoints. Management
    #   of the service VPC endpoints using the VPC endpoint API is
    #   restricted.
    #   @return [Boolean]
    #
    # @!attribute [rw] network_load_balancer_arns
    #   The Amazon Resource Names (ARNs) of the Network Load Balancers for
    #   the service.
    #   @return [Array<String>]
    #
    # @!attribute [rw] base_endpoint_dns_names
    #   The DNS names for the service.
    #   @return [Array<String>]
    #
    # @!attribute [rw] private_dns_name
    #   The private DNS name for the service.
    #   @return [String]
    #
    # @!attribute [rw] private_dns_name_configuration
    #   Information about the endpoint service private DNS name
    #   configuration.
    #   @return [Types::PrivateDnsNameConfiguration]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the service.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ServiceConfiguration AWS API Documentation
    #
    class ServiceConfiguration < Struct.new(
      :service_type,
      :service_id,
      :service_name,
      :service_state,
      :availability_zones,
      :acceptance_required,
      :manages_vpc_endpoints,
      :network_load_balancer_arns,
      :base_endpoint_dns_names,
      :private_dns_name,
      :private_dns_name_configuration,
      :tags)
      include Aws::Structure
    end

    # Describes a VPC endpoint service.
    #
    # @!attribute [rw] service_name
    #   The Amazon Resource Name (ARN) of the service.
    #   @return [String]
    #
    # @!attribute [rw] service_id
    #   The ID of the endpoint service.
    #   @return [String]
    #
    # @!attribute [rw] service_type
    #   The type of service.
    #   @return [Array<Types::ServiceTypeDetail>]
    #
    # @!attribute [rw] availability_zones
    #   The Availability Zones in which the service is available.
    #   @return [Array<String>]
    #
    # @!attribute [rw] owner
    #   The AWS account ID of the service owner.
    #   @return [String]
    #
    # @!attribute [rw] base_endpoint_dns_names
    #   The DNS names for the service.
    #   @return [Array<String>]
    #
    # @!attribute [rw] private_dns_name
    #   The private DNS name for the service.
    #   @return [String]
    #
    # @!attribute [rw] vpc_endpoint_policy_supported
    #   Indicates whether the service supports endpoint policies.
    #   @return [Boolean]
    #
    # @!attribute [rw] acceptance_required
    #   Indicates whether VPC endpoint connection requests to the service
    #   must be accepted by the service owner.
    #   @return [Boolean]
    #
    # @!attribute [rw] manages_vpc_endpoints
    #   Indicates whether the service manages its VPC endpoints. Management
    #   of the service VPC endpoints using the VPC endpoint API is
    #   restricted.
    #   @return [Boolean]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the service.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] private_dns_name_verification_state
    #   The verification state of the VPC endpoint service.
    #
    #   Consumers of the endpoint service cannot use the private name when
    #   the state is not `verified`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ServiceDetail AWS API Documentation
    #
    class ServiceDetail < Struct.new(
      :service_name,
      :service_id,
      :service_type,
      :availability_zones,
      :owner,
      :base_endpoint_dns_names,
      :private_dns_name,
      :vpc_endpoint_policy_supported,
      :acceptance_required,
      :manages_vpc_endpoints,
      :tags,
      :private_dns_name_verification_state)
      include Aws::Structure
    end

    # Describes the type of service for a VPC endpoint.
    #
    # @!attribute [rw] service_type
    #   The type of service.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ServiceTypeDetail AWS API Documentation
    #
    class ServiceTypeDetail < Struct.new(
      :service_type)
      include Aws::Structure
    end

    # Describes the time period for a Scheduled Instance to start its first
    # schedule. The time period must span less than one day.
    #
    # @note When making an API call, you may pass SlotDateTimeRangeRequest
    #   data as a hash:
    #
    #       {
    #         earliest_time: Time.now, # required
    #         latest_time: Time.now, # required
    #       }
    #
    # @!attribute [rw] earliest_time
    #   The earliest date and time, in UTC, for the Scheduled Instance to
    #   start.
    #   @return [Time]
    #
    # @!attribute [rw] latest_time
    #   The latest date and time, in UTC, for the Scheduled Instance to
    #   start. This value must be later than or equal to the earliest date
    #   and at most three months in the future.
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SlotDateTimeRangeRequest AWS API Documentation
    #
    class SlotDateTimeRangeRequest < Struct.new(
      :earliest_time,
      :latest_time)
      include Aws::Structure
    end

    # Describes the time period for a Scheduled Instance to start its first
    # schedule.
    #
    # @note When making an API call, you may pass SlotStartTimeRangeRequest
    #   data as a hash:
    #
    #       {
    #         earliest_time: Time.now,
    #         latest_time: Time.now,
    #       }
    #
    # @!attribute [rw] earliest_time
    #   The earliest date and time, in UTC, for the Scheduled Instance to
    #   start.
    #   @return [Time]
    #
    # @!attribute [rw] latest_time
    #   The latest date and time, in UTC, for the Scheduled Instance to
    #   start.
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SlotStartTimeRangeRequest AWS API Documentation
    #
    class SlotStartTimeRangeRequest < Struct.new(
      :earliest_time,
      :latest_time)
      include Aws::Structure
    end

    # Describes a snapshot.
    #
    # @!attribute [rw] data_encryption_key_id
    #   The data encryption key identifier for the snapshot. This value is a
    #   unique identifier that corresponds to the data encryption key that
    #   was used to encrypt the original volume or snapshot copy. Because
    #   data encryption keys are inherited by volumes created from
    #   snapshots, and vice versa, if snapshots share the same data
    #   encryption key identifier, then they belong to the same
    #   volume/snapshot lineage. This parameter is only returned by
    #   DescribeSnapshots.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   The description for the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] encrypted
    #   Indicates whether the snapshot is encrypted.
    #   @return [Boolean]
    #
    # @!attribute [rw] kms_key_id
    #   The Amazon Resource Name (ARN) of the AWS Key Management Service
    #   (AWS KMS) customer master key (CMK) that was used to protect the
    #   volume encryption key for the parent volume.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The AWS account ID of the EBS snapshot owner.
    #   @return [String]
    #
    # @!attribute [rw] progress
    #   The progress of the snapshot, as a percentage.
    #   @return [String]
    #
    # @!attribute [rw] snapshot_id
    #   The ID of the snapshot. Each snapshot receives a unique identifier
    #   when it is created.
    #   @return [String]
    #
    # @!attribute [rw] start_time
    #   The time stamp when the snapshot was initiated.
    #   @return [Time]
    #
    # @!attribute [rw] state
    #   The snapshot state.
    #   @return [String]
    #
    # @!attribute [rw] state_message
    #   Encrypted Amazon EBS snapshots are copied asynchronously. If a
    #   snapshot copy operation fails (for example, if the proper AWS Key
    #   Management Service (AWS KMS) permissions are not obtained) this
    #   field displays error state details to help you diagnose why the
    #   error occurred. This parameter is only returned by
    #   DescribeSnapshots.
    #   @return [String]
    #
    # @!attribute [rw] volume_id
    #   The ID of the volume that was used to create the snapshot. Snapshots
    #   created by the CopySnapshot action have an arbitrary volume ID that
    #   should not be used for any purpose.
    #   @return [String]
    #
    # @!attribute [rw] volume_size
    #   The size of the volume, in GiB.
    #   @return [Integer]
    #
    # @!attribute [rw] owner_alias
    #   Value from an Amazon-maintained list (`amazon` \| `self` \| `all` \|
    #   `aws-marketplace` \| `microsoft`) of snapshot owners. Not to be
    #   confused with the user-configured AWS account alias, which is set
    #   from the IAM console.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the snapshot.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Snapshot AWS API Documentation
    #
    class Snapshot < Struct.new(
      :data_encryption_key_id,
      :description,
      :encrypted,
      :kms_key_id,
      :owner_id,
      :progress,
      :snapshot_id,
      :start_time,
      :state,
      :state_message,
      :volume_id,
      :volume_size,
      :owner_alias,
      :tags)
      include Aws::Structure
    end

    # Describes the snapshot created from the imported disk.
    #
    # @!attribute [rw] description
    #   A description for the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] device_name
    #   The block device mapping for the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] disk_image_size
    #   The size of the disk in the snapshot, in GiB.
    #   @return [Float]
    #
    # @!attribute [rw] format
    #   The format of the disk image from which the snapshot is created.
    #   @return [String]
    #
    # @!attribute [rw] progress
    #   The percentage of progress for the task.
    #   @return [String]
    #
    # @!attribute [rw] snapshot_id
    #   The snapshot ID of the disk being imported.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   A brief status of the snapshot creation.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   A detailed status message for the snapshot creation.
    #   @return [String]
    #
    # @!attribute [rw] url
    #   The URL used to access the disk image.
    #   @return [String]
    #
    # @!attribute [rw] user_bucket
    #   The S3 bucket for the disk image.
    #   @return [Types::UserBucketDetails]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SnapshotDetail AWS API Documentation
    #
    class SnapshotDetail < Struct.new(
      :description,
      :device_name,
      :disk_image_size,
      :format,
      :progress,
      :snapshot_id,
      :status,
      :status_message,
      :url,
      :user_bucket)
      include Aws::Structure
    end

    # The disk container object for the import snapshot request.
    #
    # @note When making an API call, you may pass SnapshotDiskContainer
    #   data as a hash:
    #
    #       {
    #         description: "String",
    #         format: "String",
    #         url: "String",
    #         user_bucket: {
    #           s3_bucket: "String",
    #           s3_key: "String",
    #         },
    #       }
    #
    # @!attribute [rw] description
    #   The description of the disk image being imported.
    #   @return [String]
    #
    # @!attribute [rw] format
    #   The format of the disk image being imported.
    #
    #   Valid values: `VHD` \| `VMDK`
    #   @return [String]
    #
    # @!attribute [rw] url
    #   The URL to the Amazon S3-based disk image being imported. It can
    #   either be a https URL (https://..) or an Amazon S3 URL (s3://..).
    #   @return [String]
    #
    # @!attribute [rw] user_bucket
    #   The S3 bucket for the disk image.
    #   @return [Types::UserBucket]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SnapshotDiskContainer AWS API Documentation
    #
    class SnapshotDiskContainer < Struct.new(
      :description,
      :format,
      :url,
      :user_bucket)
      include Aws::Structure
    end

    # Information about a snapshot.
    #
    # @!attribute [rw] description
    #   Description specified by the CreateSnapshotRequest that has been
    #   applied to all snapshots.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   Tags associated with this snapshot.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] encrypted
    #   Indicates whether the snapshot is encrypted.
    #   @return [Boolean]
    #
    # @!attribute [rw] volume_id
    #   Source volume from which this snapshot was created.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   Current state of the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] volume_size
    #   Size of the volume from which this snapshot was created.
    #   @return [Integer]
    #
    # @!attribute [rw] start_time
    #   Time this snapshot was started. This is the same for all snapshots
    #   initiated by the same request.
    #   @return [Time]
    #
    # @!attribute [rw] progress
    #   Progress this snapshot has made towards completing.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   Account id used when creating this snapshot.
    #   @return [String]
    #
    # @!attribute [rw] snapshot_id
    #   Snapshot id that can be used to describe this snapshot.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SnapshotInfo AWS API Documentation
    #
    class SnapshotInfo < Struct.new(
      :description,
      :tags,
      :encrypted,
      :volume_id,
      :state,
      :volume_size,
      :start_time,
      :progress,
      :owner_id,
      :snapshot_id)
      include Aws::Structure
    end

    # Details about the import snapshot task.
    #
    # @!attribute [rw] description
    #   The description of the snapshot.
    #   @return [String]
    #
    # @!attribute [rw] disk_image_size
    #   The size of the disk in the snapshot, in GiB.
    #   @return [Float]
    #
    # @!attribute [rw] encrypted
    #   Indicates whether the snapshot is encrypted.
    #   @return [Boolean]
    #
    # @!attribute [rw] format
    #   The format of the disk image from which the snapshot is created.
    #   @return [String]
    #
    # @!attribute [rw] kms_key_id
    #   The identifier for the AWS Key Management Service (AWS KMS) customer
    #   master key (CMK) that was used to create the encrypted snapshot.
    #   @return [String]
    #
    # @!attribute [rw] progress
    #   The percentage of completion for the import snapshot task.
    #   @return [String]
    #
    # @!attribute [rw] snapshot_id
    #   The snapshot ID of the disk being imported.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   A brief status for the import snapshot task.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   A detailed status message for the import snapshot task.
    #   @return [String]
    #
    # @!attribute [rw] url
    #   The URL of the disk image from which the snapshot is created.
    #   @return [String]
    #
    # @!attribute [rw] user_bucket
    #   The S3 bucket for the disk image.
    #   @return [Types::UserBucketDetails]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SnapshotTaskDetail AWS API Documentation
    #
    class SnapshotTaskDetail < Struct.new(
      :description,
      :disk_image_size,
      :encrypted,
      :format,
      :kms_key_id,
      :progress,
      :snapshot_id,
      :status,
      :status_message,
      :url,
      :user_bucket)
      include Aws::Structure
    end

    # Describes the data feed for a Spot Instance.
    #
    # @!attribute [rw] bucket
    #   The Amazon S3 bucket where the Spot Instance data feed is located.
    #   @return [String]
    #
    # @!attribute [rw] fault
    #   The fault codes for the Spot Instance request, if any.
    #   @return [Types::SpotInstanceStateFault]
    #
    # @!attribute [rw] owner_id
    #   The AWS account ID of the account.
    #   @return [String]
    #
    # @!attribute [rw] prefix
    #   The prefix that is prepended to data feed files.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the Spot Instance data feed subscription.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SpotDatafeedSubscription AWS API Documentation
    #
    class SpotDatafeedSubscription < Struct.new(
      :bucket,
      :fault,
      :owner_id,
      :prefix,
      :state)
      include Aws::Structure
    end

    # Describes the launch specification for one or more Spot Instances. If
    # you include On-Demand capacity in your fleet request, you can't use
    # `SpotFleetLaunchSpecification`; you must use
    # [LaunchTemplateConfig][1].
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_LaunchTemplateConfig.html
    #
    # @note When making an API call, you may pass SpotFleetLaunchSpecification
    #   data as a hash:
    #
    #       {
    #         security_groups: [
    #           {
    #             group_name: "String",
    #             group_id: "String",
    #           },
    #         ],
    #         addressing_type: "String",
    #         block_device_mappings: [
    #           {
    #             device_name: "String",
    #             virtual_name: "String",
    #             ebs: {
    #               delete_on_termination: false,
    #               iops: 1,
    #               snapshot_id: "String",
    #               volume_size: 1,
    #               volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #               kms_key_id: "String",
    #               encrypted: false,
    #             },
    #             no_device: "String",
    #           },
    #         ],
    #         ebs_optimized: false,
    #         iam_instance_profile: {
    #           arn: "String",
    #           name: "String",
    #         },
    #         image_id: "String",
    #         instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #         kernel_id: "String",
    #         key_name: "String",
    #         monitoring: {
    #           enabled: false,
    #         },
    #         network_interfaces: [
    #           {
    #             associate_public_ip_address: false,
    #             delete_on_termination: false,
    #             description: "String",
    #             device_index: 1,
    #             groups: ["SecurityGroupId"],
    #             ipv_6_address_count: 1,
    #             ipv_6_addresses: [
    #               {
    #                 ipv_6_address: "String",
    #               },
    #             ],
    #             network_interface_id: "String",
    #             private_ip_address: "String",
    #             private_ip_addresses: [
    #               {
    #                 primary: false,
    #                 private_ip_address: "String",
    #               },
    #             ],
    #             secondary_private_ip_address_count: 1,
    #             subnet_id: "String",
    #             interface_type: "String",
    #           },
    #         ],
    #         placement: {
    #           availability_zone: "String",
    #           group_name: "String",
    #           tenancy: "default", # accepts default, dedicated, host
    #         },
    #         ramdisk_id: "String",
    #         spot_price: "String",
    #         subnet_id: "String",
    #         user_data: "String",
    #         weighted_capacity: 1.0,
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] security_groups
    #   One or more security groups. When requesting instances in a VPC, you
    #   must specify the IDs of the security groups. When requesting
    #   instances in EC2-Classic, you can specify the names or the IDs of
    #   the security groups.
    #   @return [Array<Types::GroupIdentifier>]
    #
    # @!attribute [rw] addressing_type
    #   Deprecated.
    #   @return [String]
    #
    # @!attribute [rw] block_device_mappings
    #   One or more block devices that are mapped to the Spot Instances. You
    #   can't specify both a snapshot ID and an encryption value. This is
    #   because only blank volumes can be encrypted on creation. If a
    #   snapshot is the basis for a volume, it is not blank and its
    #   encryption status is used for the volume encryption status.
    #   @return [Array<Types::BlockDeviceMapping>]
    #
    # @!attribute [rw] ebs_optimized
    #   Indicates whether the instances are optimized for EBS I/O. This
    #   optimization provides dedicated throughput to Amazon EBS and an
    #   optimized configuration stack to provide optimal EBS I/O
    #   performance. This optimization isn't available with all instance
    #   types. Additional usage charges apply when using an EBS Optimized
    #   instance.
    #
    #   Default: `false`
    #   @return [Boolean]
    #
    # @!attribute [rw] iam_instance_profile
    #   The IAM instance profile.
    #   @return [Types::IamInstanceProfileSpecification]
    #
    # @!attribute [rw] image_id
    #   The ID of the AMI.
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   The instance type.
    #   @return [String]
    #
    # @!attribute [rw] kernel_id
    #   The ID of the kernel.
    #   @return [String]
    #
    # @!attribute [rw] key_name
    #   The name of the key pair.
    #   @return [String]
    #
    # @!attribute [rw] monitoring
    #   Enable or disable monitoring for the instances.
    #   @return [Types::SpotFleetMonitoring]
    #
    # @!attribute [rw] network_interfaces
    #   One or more network interfaces. If you specify a network interface,
    #   you must specify subnet IDs and security group IDs using the network
    #   interface.
    #   @return [Array<Types::InstanceNetworkInterfaceSpecification>]
    #
    # @!attribute [rw] placement
    #   The placement information.
    #   @return [Types::SpotPlacement]
    #
    # @!attribute [rw] ramdisk_id
    #   The ID of the RAM disk. Some kernels require additional drivers at
    #   launch. Check the kernel requirements for information about whether
    #   you need to specify a RAM disk. To find kernel requirements, refer
    #   to the AWS Resource Center and search for the kernel ID.
    #   @return [String]
    #
    # @!attribute [rw] spot_price
    #   The maximum price per unit hour that you are willing to pay for a
    #   Spot Instance. If this value is not specified, the default is the
    #   Spot price specified for the fleet. To determine the Spot price per
    #   unit hour, divide the Spot price by the value of `WeightedCapacity`.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The IDs of the subnets in which to launch the instances. To specify
    #   multiple subnets, separate them using commas; for example,
    #   "subnet-1234abcdeexample1, subnet-0987cdef6example2".
    #   @return [String]
    #
    # @!attribute [rw] user_data
    #   The Base64-encoded user data that instances use when starting up.
    #   @return [String]
    #
    # @!attribute [rw] weighted_capacity
    #   The number of units provided by the specified instance type. These
    #   are the same units that you chose to set the target capacity in
    #   terms of instances, or a performance characteristic such as vCPUs,
    #   memory, or I/O.
    #
    #   If the target capacity divided by this value is not a whole number,
    #   Amazon EC2 rounds the number of instances to the next whole number.
    #   If this value is not specified, the default is 1.
    #   @return [Float]
    #
    # @!attribute [rw] tag_specifications
    #   The tags to apply during creation.
    #   @return [Array<Types::SpotFleetTagSpecification>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SpotFleetLaunchSpecification AWS API Documentation
    #
    class SpotFleetLaunchSpecification < Struct.new(
      :security_groups,
      :addressing_type,
      :block_device_mappings,
      :ebs_optimized,
      :iam_instance_profile,
      :image_id,
      :instance_type,
      :kernel_id,
      :key_name,
      :monitoring,
      :network_interfaces,
      :placement,
      :ramdisk_id,
      :spot_price,
      :subnet_id,
      :user_data,
      :weighted_capacity,
      :tag_specifications)
      include Aws::Structure
    end

    # Describes whether monitoring is enabled.
    #
    # @note When making an API call, you may pass SpotFleetMonitoring
    #   data as a hash:
    #
    #       {
    #         enabled: false,
    #       }
    #
    # @!attribute [rw] enabled
    #   Enables monitoring for the instance.
    #
    #   Default: `false`
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SpotFleetMonitoring AWS API Documentation
    #
    class SpotFleetMonitoring < Struct.new(
      :enabled)
      include Aws::Structure
    end

    # Describes a Spot Fleet request.
    #
    # @!attribute [rw] activity_status
    #   The progress of the Spot Fleet request. If there is an error, the
    #   status is `error`. After all requests are placed, the status is
    #   `pending_fulfillment`. If the size of the fleet is equal to or
    #   greater than its target capacity, the status is `fulfilled`. If the
    #   size of the fleet is decreased, the status is `pending_termination`
    #   while Spot Instances are terminating.
    #   @return [String]
    #
    # @!attribute [rw] create_time
    #   The creation date and time of the request.
    #   @return [Time]
    #
    # @!attribute [rw] spot_fleet_request_config
    #   The configuration of the Spot Fleet request.
    #   @return [Types::SpotFleetRequestConfigData]
    #
    # @!attribute [rw] spot_fleet_request_id
    #   The ID of the Spot Fleet request.
    #   @return [String]
    #
    # @!attribute [rw] spot_fleet_request_state
    #   The state of the Spot Fleet request.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags for a Spot Fleet resource.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SpotFleetRequestConfig AWS API Documentation
    #
    class SpotFleetRequestConfig < Struct.new(
      :activity_status,
      :create_time,
      :spot_fleet_request_config,
      :spot_fleet_request_id,
      :spot_fleet_request_state,
      :tags)
      include Aws::Structure
    end

    # Describes the configuration of a Spot Fleet request.
    #
    # @note When making an API call, you may pass SpotFleetRequestConfigData
    #   data as a hash:
    #
    #       {
    #         allocation_strategy: "lowestPrice", # accepts lowestPrice, diversified, capacityOptimized
    #         on_demand_allocation_strategy: "lowestPrice", # accepts lowestPrice, prioritized
    #         client_token: "String",
    #         excess_capacity_termination_policy: "noTermination", # accepts noTermination, default
    #         fulfilled_capacity: 1.0,
    #         on_demand_fulfilled_capacity: 1.0,
    #         iam_fleet_role: "String", # required
    #         launch_specifications: [
    #           {
    #             security_groups: [
    #               {
    #                 group_name: "String",
    #                 group_id: "String",
    #               },
    #             ],
    #             addressing_type: "String",
    #             block_device_mappings: [
    #               {
    #                 device_name: "String",
    #                 virtual_name: "String",
    #                 ebs: {
    #                   delete_on_termination: false,
    #                   iops: 1,
    #                   snapshot_id: "String",
    #                   volume_size: 1,
    #                   volume_type: "standard", # accepts standard, io1, gp2, sc1, st1
    #                   kms_key_id: "String",
    #                   encrypted: false,
    #                 },
    #                 no_device: "String",
    #               },
    #             ],
    #             ebs_optimized: false,
    #             iam_instance_profile: {
    #               arn: "String",
    #               name: "String",
    #             },
    #             image_id: "String",
    #             instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #             kernel_id: "String",
    #             key_name: "String",
    #             monitoring: {
    #               enabled: false,
    #             },
    #             network_interfaces: [
    #               {
    #                 associate_public_ip_address: false,
    #                 delete_on_termination: false,
    #                 description: "String",
    #                 device_index: 1,
    #                 groups: ["SecurityGroupId"],
    #                 ipv_6_address_count: 1,
    #                 ipv_6_addresses: [
    #                   {
    #                     ipv_6_address: "String",
    #                   },
    #                 ],
    #                 network_interface_id: "String",
    #                 private_ip_address: "String",
    #                 private_ip_addresses: [
    #                   {
    #                     primary: false,
    #                     private_ip_address: "String",
    #                   },
    #                 ],
    #                 secondary_private_ip_address_count: 1,
    #                 subnet_id: "String",
    #                 interface_type: "String",
    #               },
    #             ],
    #             placement: {
    #               availability_zone: "String",
    #               group_name: "String",
    #               tenancy: "default", # accepts default, dedicated, host
    #             },
    #             ramdisk_id: "String",
    #             spot_price: "String",
    #             subnet_id: "String",
    #             user_data: "String",
    #             weighted_capacity: 1.0,
    #             tag_specifications: [
    #               {
    #                 resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #                 tags: [
    #                   {
    #                     key: "String",
    #                     value: "String",
    #                   },
    #                 ],
    #               },
    #             ],
    #           },
    #         ],
    #         launch_template_configs: [
    #           {
    #             launch_template_specification: {
    #               launch_template_id: "String",
    #               launch_template_name: "LaunchTemplateName",
    #               version: "String",
    #             },
    #             overrides: [
    #               {
    #                 instance_type: "t1.micro", # accepts t1.micro, t2.nano, t2.micro, t2.small, t2.medium, t2.large, t2.xlarge, t2.2xlarge, t3.nano, t3.micro, t3.small, t3.medium, t3.large, t3.xlarge, t3.2xlarge, t3a.nano, t3a.micro, t3a.small, t3a.medium, t3a.large, t3a.xlarge, t3a.2xlarge, m1.small, m1.medium, m1.large, m1.xlarge, m3.medium, m3.large, m3.xlarge, m3.2xlarge, m4.large, m4.xlarge, m4.2xlarge, m4.4xlarge, m4.10xlarge, m4.16xlarge, m2.xlarge, m2.2xlarge, m2.4xlarge, cr1.8xlarge, r3.large, r3.xlarge, r3.2xlarge, r3.4xlarge, r3.8xlarge, r4.large, r4.xlarge, r4.2xlarge, r4.4xlarge, r4.8xlarge, r4.16xlarge, r5.large, r5.xlarge, r5.2xlarge, r5.4xlarge, r5.8xlarge, r5.12xlarge, r5.16xlarge, r5.24xlarge, r5.metal, r5a.large, r5a.xlarge, r5a.2xlarge, r5a.4xlarge, r5a.8xlarge, r5a.12xlarge, r5a.16xlarge, r5a.24xlarge, r5d.large, r5d.xlarge, r5d.2xlarge, r5d.4xlarge, r5d.8xlarge, r5d.12xlarge, r5d.16xlarge, r5d.24xlarge, r5d.metal, r5ad.large, r5ad.xlarge, r5ad.2xlarge, r5ad.4xlarge, r5ad.8xlarge, r5ad.12xlarge, r5ad.16xlarge, r5ad.24xlarge, x1.16xlarge, x1.32xlarge, x1e.xlarge, x1e.2xlarge, x1e.4xlarge, x1e.8xlarge, x1e.16xlarge, x1e.32xlarge, i2.xlarge, i2.2xlarge, i2.4xlarge, i2.8xlarge, i3.large, i3.xlarge, i3.2xlarge, i3.4xlarge, i3.8xlarge, i3.16xlarge, i3.metal, i3en.large, i3en.xlarge, i3en.2xlarge, i3en.3xlarge, i3en.6xlarge, i3en.12xlarge, i3en.24xlarge, i3en.metal, hi1.4xlarge, hs1.8xlarge, c1.medium, c1.xlarge, c3.large, c3.xlarge, c3.2xlarge, c3.4xlarge, c3.8xlarge, c4.large, c4.xlarge, c4.2xlarge, c4.4xlarge, c4.8xlarge, c5.large, c5.xlarge, c5.2xlarge, c5.4xlarge, c5.9xlarge, c5.12xlarge, c5.18xlarge, c5.24xlarge, c5.metal, c5a.large, c5a.xlarge, c5a.2xlarge, c5a.4xlarge, c5a.8xlarge, c5a.12xlarge, c5a.16xlarge, c5a.24xlarge, c5d.large, c5d.xlarge, c5d.2xlarge, c5d.4xlarge, c5d.9xlarge, c5d.12xlarge, c5d.18xlarge, c5d.24xlarge, c5d.metal, c5n.large, c5n.xlarge, c5n.2xlarge, c5n.4xlarge, c5n.9xlarge, c5n.18xlarge, cc1.4xlarge, cc2.8xlarge, g2.2xlarge, g2.8xlarge, g3.4xlarge, g3.8xlarge, g3.16xlarge, g3s.xlarge, g4dn.xlarge, g4dn.2xlarge, g4dn.4xlarge, g4dn.8xlarge, g4dn.12xlarge, g4dn.16xlarge, g4dn.metal, cg1.4xlarge, p2.xlarge, p2.8xlarge, p2.16xlarge, p3.2xlarge, p3.8xlarge, p3.16xlarge, p3dn.24xlarge, d2.xlarge, d2.2xlarge, d2.4xlarge, d2.8xlarge, f1.2xlarge, f1.4xlarge, f1.16xlarge, m5.large, m5.xlarge, m5.2xlarge, m5.4xlarge, m5.8xlarge, m5.12xlarge, m5.16xlarge, m5.24xlarge, m5.metal, m5a.large, m5a.xlarge, m5a.2xlarge, m5a.4xlarge, m5a.8xlarge, m5a.12xlarge, m5a.16xlarge, m5a.24xlarge, m5d.large, m5d.xlarge, m5d.2xlarge, m5d.4xlarge, m5d.8xlarge, m5d.12xlarge, m5d.16xlarge, m5d.24xlarge, m5d.metal, m5ad.large, m5ad.xlarge, m5ad.2xlarge, m5ad.4xlarge, m5ad.8xlarge, m5ad.12xlarge, m5ad.16xlarge, m5ad.24xlarge, h1.2xlarge, h1.4xlarge, h1.8xlarge, h1.16xlarge, z1d.large, z1d.xlarge, z1d.2xlarge, z1d.3xlarge, z1d.6xlarge, z1d.12xlarge, z1d.metal, u-6tb1.metal, u-9tb1.metal, u-12tb1.metal, u-18tb1.metal, u-24tb1.metal, a1.medium, a1.large, a1.xlarge, a1.2xlarge, a1.4xlarge, a1.metal, m5dn.large, m5dn.xlarge, m5dn.2xlarge, m5dn.4xlarge, m5dn.8xlarge, m5dn.12xlarge, m5dn.16xlarge, m5dn.24xlarge, m5n.large, m5n.xlarge, m5n.2xlarge, m5n.4xlarge, m5n.8xlarge, m5n.12xlarge, m5n.16xlarge, m5n.24xlarge, r5dn.large, r5dn.xlarge, r5dn.2xlarge, r5dn.4xlarge, r5dn.8xlarge, r5dn.12xlarge, r5dn.16xlarge, r5dn.24xlarge, r5n.large, r5n.xlarge, r5n.2xlarge, r5n.4xlarge, r5n.8xlarge, r5n.12xlarge, r5n.16xlarge, r5n.24xlarge, inf1.xlarge, inf1.2xlarge, inf1.6xlarge, inf1.24xlarge, m6g.metal, m6g.medium, m6g.large, m6g.xlarge, m6g.2xlarge, m6g.4xlarge, m6g.8xlarge, m6g.12xlarge, m6g.16xlarge
    #                 spot_price: "String",
    #                 subnet_id: "String",
    #                 availability_zone: "String",
    #                 weighted_capacity: 1.0,
    #                 priority: 1.0,
    #               },
    #             ],
    #           },
    #         ],
    #         spot_price: "String",
    #         target_capacity: 1, # required
    #         on_demand_target_capacity: 1,
    #         on_demand_max_total_price: "String",
    #         spot_max_total_price: "String",
    #         terminate_instances_with_expiration: false,
    #         type: "request", # accepts request, maintain, instant
    #         valid_from: Time.now,
    #         valid_until: Time.now,
    #         replace_unhealthy_instances: false,
    #         instance_interruption_behavior: "hibernate", # accepts hibernate, stop, terminate
    #         load_balancers_config: {
    #           classic_load_balancers_config: {
    #             classic_load_balancers: [
    #               {
    #                 name: "String",
    #               },
    #             ],
    #           },
    #           target_groups_config: {
    #             target_groups: [
    #               {
    #                 arn: "String",
    #               },
    #             ],
    #           },
    #         },
    #         instance_pools_to_use_count: 1,
    #         tag_specifications: [
    #           {
    #             resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #             tags: [
    #               {
    #                 key: "String",
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] allocation_strategy
    #   Indicates how to allocate the target Spot Instance capacity across
    #   the Spot Instance pools specified by the Spot Fleet request.
    #
    #   If the allocation strategy is `lowestPrice`, Spot Fleet launches
    #   instances from the Spot Instance pools with the lowest price. This
    #   is the default allocation strategy.
    #
    #   If the allocation strategy is `diversified`, Spot Fleet launches
    #   instances from all the Spot Instance pools that you specify.
    #
    #   If the allocation strategy is `capacityOptimized`, Spot Fleet
    #   launches instances from Spot Instance pools with optimal capacity
    #   for the number of instances that are launching.
    #   @return [String]
    #
    # @!attribute [rw] on_demand_allocation_strategy
    #   The order of the launch template overrides to use in fulfilling
    #   On-Demand capacity. If you specify `lowestPrice`, Spot Fleet uses
    #   price to determine the order, launching the lowest price first. If
    #   you specify `prioritized`, Spot Fleet uses the priority that you
    #   assign to each Spot Fleet launch template override, launching the
    #   highest priority first. If you do not specify a value, Spot Fleet
    #   defaults to `lowestPrice`.
    #   @return [String]
    #
    # @!attribute [rw] client_token
    #   A unique, case-sensitive identifier that you provide to ensure the
    #   idempotency of your listings. This helps to avoid duplicate
    #   listings. For more information, see [Ensuring Idempotency][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html
    #   @return [String]
    #
    # @!attribute [rw] excess_capacity_termination_policy
    #   Indicates whether running Spot Instances should be terminated if you
    #   decrease the target capacity of the Spot Fleet request below the
    #   current size of the Spot Fleet.
    #   @return [String]
    #
    # @!attribute [rw] fulfilled_capacity
    #   The number of units fulfilled by this request compared to the set
    #   target capacity. You cannot set this value.
    #   @return [Float]
    #
    # @!attribute [rw] on_demand_fulfilled_capacity
    #   The number of On-Demand units fulfilled by this request compared to
    #   the set target On-Demand capacity.
    #   @return [Float]
    #
    # @!attribute [rw] iam_fleet_role
    #   The Amazon Resource Name (ARN) of an AWS Identity and Access
    #   Management (IAM) role that grants the Spot Fleet the permission to
    #   request, launch, terminate, and tag instances on your behalf. For
    #   more information, see [Spot Fleet Prerequisites][1] in the *Amazon
    #   EC2 User Guide for Linux Instances*. Spot Fleet can terminate Spot
    #   Instances on your behalf when you cancel its Spot Fleet request
    #   using [CancelSpotFleetRequests][2] or when the Spot Fleet request
    #   expires, if you set `TerminateInstancesWithExpiration`.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-fleet-requests.html#spot-fleet-prerequisites
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CancelSpotFleetRequests
    #   @return [String]
    #
    # @!attribute [rw] launch_specifications
    #   The launch specifications for the Spot Fleet request. If you specify
    #   `LaunchSpecifications`, you can't specify `LaunchTemplateConfigs`.
    #   If you include On-Demand capacity in your request, you must use
    #   `LaunchTemplateConfigs`.
    #   @return [Array<Types::SpotFleetLaunchSpecification>]
    #
    # @!attribute [rw] launch_template_configs
    #   The launch template and overrides. If you specify
    #   `LaunchTemplateConfigs`, you can't specify `LaunchSpecifications`.
    #   If you include On-Demand capacity in your request, you must use
    #   `LaunchTemplateConfigs`.
    #   @return [Array<Types::LaunchTemplateConfig>]
    #
    # @!attribute [rw] spot_price
    #   The maximum price per unit hour that you are willing to pay for a
    #   Spot Instance. The default is the On-Demand price.
    #   @return [String]
    #
    # @!attribute [rw] target_capacity
    #   The number of units to request for the Spot Fleet. You can choose to
    #   set the target capacity in terms of instances or a performance
    #   characteristic that is important to your application workload, such
    #   as vCPUs, memory, or I/O. If the request type is `maintain`, you can
    #   specify a target capacity of 0 and add capacity later.
    #   @return [Integer]
    #
    # @!attribute [rw] on_demand_target_capacity
    #   The number of On-Demand units to request. You can choose to set the
    #   target capacity in terms of instances or a performance
    #   characteristic that is important to your application workload, such
    #   as vCPUs, memory, or I/O. If the request type is `maintain`, you can
    #   specify a target capacity of 0 and add capacity later.
    #   @return [Integer]
    #
    # @!attribute [rw] on_demand_max_total_price
    #   The maximum amount per hour for On-Demand Instances that you're
    #   willing to pay. You can use the `onDemandMaxTotalPrice` parameter,
    #   the `spotMaxTotalPrice` parameter, or both parameters to ensure that
    #   your fleet cost does not exceed your budget. If you set a maximum
    #   price per hour for the On-Demand Instances and Spot Instances in
    #   your request, Spot Fleet will launch instances until it reaches the
    #   maximum amount you're willing to pay. When the maximum amount
    #   you're willing to pay is reached, the fleet stops launching
    #   instances even if it hasn’t met the target capacity.
    #   @return [String]
    #
    # @!attribute [rw] spot_max_total_price
    #   The maximum amount per hour for Spot Instances that you're willing
    #   to pay. You can use the `spotdMaxTotalPrice` parameter, the
    #   `onDemandMaxTotalPrice` parameter, or both parameters to ensure that
    #   your fleet cost does not exceed your budget. If you set a maximum
    #   price per hour for the On-Demand Instances and Spot Instances in
    #   your request, Spot Fleet will launch instances until it reaches the
    #   maximum amount you're willing to pay. When the maximum amount
    #   you're willing to pay is reached, the fleet stops launching
    #   instances even if it hasn’t met the target capacity.
    #   @return [String]
    #
    # @!attribute [rw] terminate_instances_with_expiration
    #   Indicates whether running Spot Instances are terminated when the
    #   Spot Fleet request expires.
    #   @return [Boolean]
    #
    # @!attribute [rw] type
    #   The type of request. Indicates whether the Spot Fleet only requests
    #   the target capacity or also attempts to maintain it. When this value
    #   is `request`, the Spot Fleet only places the required requests. It
    #   does not attempt to replenish Spot Instances if capacity is
    #   diminished, nor does it submit requests in alternative Spot pools if
    #   capacity is not available. When this value is `maintain`, the Spot
    #   Fleet maintains the target capacity. The Spot Fleet places the
    #   required requests to meet capacity and automatically replenishes any
    #   interrupted instances. Default: `maintain`. `instant` is listed but
    #   is not used by Spot Fleet.
    #   @return [String]
    #
    # @!attribute [rw] valid_from
    #   The start date and time of the request, in UTC format
    #   (*YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z). By default, Amazon EC2 starts
    #   fulfilling the request immediately.
    #   @return [Time]
    #
    # @!attribute [rw] valid_until
    #   The end date and time of the request, in UTC format
    #   (*YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z). After the end date and time,
    #   no new Spot Instance requests are placed or able to fulfill the
    #   request. If no value is specified, the Spot Fleet request remains
    #   until you cancel it.
    #   @return [Time]
    #
    # @!attribute [rw] replace_unhealthy_instances
    #   Indicates whether Spot Fleet should replace unhealthy instances.
    #   @return [Boolean]
    #
    # @!attribute [rw] instance_interruption_behavior
    #   The behavior when a Spot Instance is interrupted. The default is
    #   `terminate`.
    #   @return [String]
    #
    # @!attribute [rw] load_balancers_config
    #   One or more Classic Load Balancers and target groups to attach to
    #   the Spot Fleet request. Spot Fleet registers the running Spot
    #   Instances with the specified Classic Load Balancers and target
    #   groups.
    #
    #   With Network Load Balancers, Spot Fleet cannot register instances
    #   that have the following instance types: C1, CC1, CC2, CG1, CG2, CR1,
    #   CS1, G1, G2, HI1, HS1, M1, M2, M3, and T1.
    #   @return [Types::LoadBalancersConfig]
    #
    # @!attribute [rw] instance_pools_to_use_count
    #   The number of Spot pools across which to allocate your target Spot
    #   capacity. Valid only when Spot **AllocationStrategy** is set to
    #   `lowest-price`. Spot Fleet selects the cheapest Spot pools and
    #   evenly allocates your target Spot capacity across the number of Spot
    #   pools that you specify.
    #   @return [Integer]
    #
    # @!attribute [rw] tag_specifications
    #   The key-value pair for tagging the Spot Fleet request on creation.
    #   The value for `ResourceType` must be `spot-fleet-request`, otherwise
    #   the Spot Fleet request fails. To tag instances at launch, specify
    #   the tags in the [launch template][1] (valid only if you use
    #   `LaunchTemplateConfigs`) or in the [ `SpotFleetTagSpecification`
    #   ][2] (valid only if you use `LaunchSpecifications`). For information
    #   about tagging after launch, see [Tagging Your Resources][3].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-launch-templates.html#create-launch-template
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_SpotFleetTagSpecification.html
    #   [3]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Using_Tags.html#tag-resources
    #   @return [Array<Types::TagSpecification>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SpotFleetRequestConfigData AWS API Documentation
    #
    class SpotFleetRequestConfigData < Struct.new(
      :allocation_strategy,
      :on_demand_allocation_strategy,
      :client_token,
      :excess_capacity_termination_policy,
      :fulfilled_capacity,
      :on_demand_fulfilled_capacity,
      :iam_fleet_role,
      :launch_specifications,
      :launch_template_configs,
      :spot_price,
      :target_capacity,
      :on_demand_target_capacity,
      :on_demand_max_total_price,
      :spot_max_total_price,
      :terminate_instances_with_expiration,
      :type,
      :valid_from,
      :valid_until,
      :replace_unhealthy_instances,
      :instance_interruption_behavior,
      :load_balancers_config,
      :instance_pools_to_use_count,
      :tag_specifications)
      include Aws::Structure
    end

    # The tags for a Spot Fleet resource.
    #
    # @note When making an API call, you may pass SpotFleetTagSpecification
    #   data as a hash:
    #
    #       {
    #         resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #         tags: [
    #           {
    #             key: "String",
    #             value: "String",
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] resource_type
    #   The type of resource. Currently, the only resource type that is
    #   supported is `instance`. To tag the Spot Fleet request on creation,
    #   use the `TagSpecifications` parameter in [
    #   `SpotFleetRequestConfigData` ][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_SpotFleetRequestConfigData.html
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SpotFleetTagSpecification AWS API Documentation
    #
    class SpotFleetTagSpecification < Struct.new(
      :resource_type,
      :tags)
      include Aws::Structure
    end

    # Describes a Spot Instance request.
    #
    # @!attribute [rw] actual_block_hourly_price
    #   If you specified a duration and your Spot Instance request was
    #   fulfilled, this is the fixed hourly price in effect for the Spot
    #   Instance while it runs.
    #   @return [String]
    #
    # @!attribute [rw] availability_zone_group
    #   The Availability Zone group. If you specify the same Availability
    #   Zone group for all Spot Instance requests, all Spot Instances are
    #   launched in the same Availability Zone.
    #   @return [String]
    #
    # @!attribute [rw] block_duration_minutes
    #   The duration for the Spot Instance, in minutes.
    #   @return [Integer]
    #
    # @!attribute [rw] create_time
    #   The date and time when the Spot Instance request was created, in UTC
    #   format (for example, *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z).
    #   @return [Time]
    #
    # @!attribute [rw] fault
    #   The fault codes for the Spot Instance request, if any.
    #   @return [Types::SpotInstanceStateFault]
    #
    # @!attribute [rw] instance_id
    #   The instance ID, if an instance has been launched to fulfill the
    #   Spot Instance request.
    #   @return [String]
    #
    # @!attribute [rw] launch_group
    #   The instance launch group. Launch groups are Spot Instances that
    #   launch together and terminate together.
    #   @return [String]
    #
    # @!attribute [rw] launch_specification
    #   Additional information for launching instances.
    #   @return [Types::LaunchSpecification]
    #
    # @!attribute [rw] launched_availability_zone
    #   The Availability Zone in which the request is launched.
    #   @return [String]
    #
    # @!attribute [rw] product_description
    #   The product description associated with the Spot Instance.
    #   @return [String]
    #
    # @!attribute [rw] spot_instance_request_id
    #   The ID of the Spot Instance request.
    #   @return [String]
    #
    # @!attribute [rw] spot_price
    #   The maximum price per hour that you are willing to pay for a Spot
    #   Instance.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the Spot Instance request. Spot status information
    #   helps track your Spot Instance requests. For more information, see
    #   [Spot Status][1] in the *Amazon EC2 User Guide for Linux Instances*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The status code and status message describing the Spot Instance
    #   request.
    #   @return [Types::SpotInstanceStatus]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the resource.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] type
    #   The Spot Instance request type.
    #   @return [String]
    #
    # @!attribute [rw] valid_from
    #   The start date of the request, in UTC format (for example,
    #   *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z). The request becomes active at
    #   this date and time.
    #   @return [Time]
    #
    # @!attribute [rw] valid_until
    #   The end date of the request, in UTC format (for example,
    #   *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z). If this is a one-time request,
    #   it remains active until all instances launch, the request is
    #   canceled, or this date is reached. If the request is persistent, it
    #   remains active until it is canceled or this date is reached. The
    #   default end date is 7 days from the current date.
    #   @return [Time]
    #
    # @!attribute [rw] instance_interruption_behavior
    #   The behavior when a Spot Instance is interrupted.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SpotInstanceRequest AWS API Documentation
    #
    class SpotInstanceRequest < Struct.new(
      :actual_block_hourly_price,
      :availability_zone_group,
      :block_duration_minutes,
      :create_time,
      :fault,
      :instance_id,
      :launch_group,
      :launch_specification,
      :launched_availability_zone,
      :product_description,
      :spot_instance_request_id,
      :spot_price,
      :state,
      :status,
      :tags,
      :type,
      :valid_from,
      :valid_until,
      :instance_interruption_behavior)
      include Aws::Structure
    end

    # Describes a Spot Instance state change.
    #
    # @!attribute [rw] code
    #   The reason code for the Spot Instance state change.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   The message for the Spot Instance state change.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SpotInstanceStateFault AWS API Documentation
    #
    class SpotInstanceStateFault < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # Describes the status of a Spot Instance request.
    #
    # @!attribute [rw] code
    #   The status code. For a list of status codes, see [Spot Status
    #   Codes][1] in the *Amazon EC2 User Guide for Linux Instances*.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html#spot-instance-bid-status-understand
    #   @return [String]
    #
    # @!attribute [rw] message
    #   The description for the status code.
    #   @return [String]
    #
    # @!attribute [rw] update_time
    #   The date and time of the most recent status update, in UTC format
    #   (for example, *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z).
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SpotInstanceStatus AWS API Documentation
    #
    class SpotInstanceStatus < Struct.new(
      :code,
      :message,
      :update_time)
      include Aws::Structure
    end

    # The options for Spot Instances.
    #
    # @note When making an API call, you may pass SpotMarketOptions
    #   data as a hash:
    #
    #       {
    #         max_price: "String",
    #         spot_instance_type: "one-time", # accepts one-time, persistent
    #         block_duration_minutes: 1,
    #         valid_until: Time.now,
    #         instance_interruption_behavior: "hibernate", # accepts hibernate, stop, terminate
    #       }
    #
    # @!attribute [rw] max_price
    #   The maximum hourly price you're willing to pay for the Spot
    #   Instances. The default is the On-Demand price.
    #   @return [String]
    #
    # @!attribute [rw] spot_instance_type
    #   The Spot Instance request type. For [RunInstances][1], persistent
    #   Spot Instance requests are only supported when
    #   **InstanceInterruptionBehavior** is set to either `hibernate` or
    #   `stop`.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_RunInstances
    #   @return [String]
    #
    # @!attribute [rw] block_duration_minutes
    #   The required duration for the Spot Instances (also known as Spot
    #   blocks), in minutes. This value must be a multiple of 60 (60, 120,
    #   180, 240, 300, or 360).
    #   @return [Integer]
    #
    # @!attribute [rw] valid_until
    #   The end date of the request. For a one-time request, the request
    #   remains active until all instances launch, the request is canceled,
    #   or this date is reached. If the request is persistent, it remains
    #   active until it is canceled or this date and time is reached. The
    #   default end date is 7 days from the current date.
    #   @return [Time]
    #
    # @!attribute [rw] instance_interruption_behavior
    #   The behavior when a Spot Instance is interrupted. The default is
    #   `terminate`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SpotMarketOptions AWS API Documentation
    #
    class SpotMarketOptions < Struct.new(
      :max_price,
      :spot_instance_type,
      :block_duration_minutes,
      :valid_until,
      :instance_interruption_behavior)
      include Aws::Structure
    end

    # Describes the configuration of Spot Instances in an EC2 Fleet.
    #
    # @!attribute [rw] allocation_strategy
    #   Indicates how to allocate the target Spot Instance capacity across
    #   the Spot Instance pools specified by the EC2 Fleet.
    #
    #   If the allocation strategy is `lowest-price`, EC2 Fleet launches
    #   instances from the Spot Instance pools with the lowest price. This
    #   is the default allocation strategy.
    #
    #   If the allocation strategy is `diversified`, EC2 Fleet launches
    #   instances from all of the Spot Instance pools that you specify.
    #
    #   If the allocation strategy is `capacity-optimized`, EC2 Fleet
    #   launches instances from Spot Instance pools with optimal capacity
    #   for the number of instances that are launching.
    #   @return [String]
    #
    # @!attribute [rw] instance_interruption_behavior
    #   The behavior when a Spot Instance is interrupted. The default is
    #   `terminate`.
    #   @return [String]
    #
    # @!attribute [rw] instance_pools_to_use_count
    #   The number of Spot pools across which to allocate your target Spot
    #   capacity. Valid only when **AllocationStrategy** is set to
    #   `lowest-price`. EC2 Fleet selects the cheapest Spot pools and evenly
    #   allocates your target Spot capacity across the number of Spot pools
    #   that you specify.
    #   @return [Integer]
    #
    # @!attribute [rw] single_instance_type
    #   Indicates that the fleet uses a single instance type to launch all
    #   Spot Instances in the fleet. Supported only for fleets of type
    #   `instant`.
    #   @return [Boolean]
    #
    # @!attribute [rw] single_availability_zone
    #   Indicates that the fleet launches all Spot Instances into a single
    #   Availability Zone. Supported only for fleets of type `instant`.
    #   @return [Boolean]
    #
    # @!attribute [rw] min_target_capacity
    #   The minimum target capacity for Spot Instances in the fleet. If the
    #   minimum target capacity is not reached, the fleet launches no
    #   instances.
    #   @return [Integer]
    #
    # @!attribute [rw] max_total_price
    #   The maximum amount per hour for Spot Instances that you're willing
    #   to pay.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SpotOptions AWS API Documentation
    #
    class SpotOptions < Struct.new(
      :allocation_strategy,
      :instance_interruption_behavior,
      :instance_pools_to_use_count,
      :single_instance_type,
      :single_availability_zone,
      :min_target_capacity,
      :max_total_price)
      include Aws::Structure
    end

    # Describes the configuration of Spot Instances in an EC2 Fleet request.
    #
    # @note When making an API call, you may pass SpotOptionsRequest
    #   data as a hash:
    #
    #       {
    #         allocation_strategy: "lowest-price", # accepts lowest-price, diversified, capacity-optimized
    #         instance_interruption_behavior: "hibernate", # accepts hibernate, stop, terminate
    #         instance_pools_to_use_count: 1,
    #         single_instance_type: false,
    #         single_availability_zone: false,
    #         min_target_capacity: 1,
    #         max_total_price: "String",
    #       }
    #
    # @!attribute [rw] allocation_strategy
    #   Indicates how to allocate the target Spot Instance capacity across
    #   the Spot Instance pools specified by the EC2 Fleet.
    #
    #   If the allocation strategy is `lowest-price`, EC2 Fleet launches
    #   instances from the Spot Instance pools with the lowest price. This
    #   is the default allocation strategy.
    #
    #   If the allocation strategy is `diversified`, EC2 Fleet launches
    #   instances from all of the Spot Instance pools that you specify.
    #
    #   If the allocation strategy is `capacity-optimized`, EC2 Fleet
    #   launches instances from Spot Instance pools with optimal capacity
    #   for the number of instances that are launching.
    #   @return [String]
    #
    # @!attribute [rw] instance_interruption_behavior
    #   The behavior when a Spot Instance is interrupted. The default is
    #   `terminate`.
    #   @return [String]
    #
    # @!attribute [rw] instance_pools_to_use_count
    #   The number of Spot pools across which to allocate your target Spot
    #   capacity. Valid only when Spot **AllocationStrategy** is set to
    #   `lowest-price`. EC2 Fleet selects the cheapest Spot pools and evenly
    #   allocates your target Spot capacity across the number of Spot pools
    #   that you specify.
    #   @return [Integer]
    #
    # @!attribute [rw] single_instance_type
    #   Indicates that the fleet uses a single instance type to launch all
    #   Spot Instances in the fleet. Supported only for fleets of type
    #   `instant`.
    #   @return [Boolean]
    #
    # @!attribute [rw] single_availability_zone
    #   Indicates that the fleet launches all Spot Instances into a single
    #   Availability Zone. Supported only for fleets of type `instant`.
    #   @return [Boolean]
    #
    # @!attribute [rw] min_target_capacity
    #   The minimum target capacity for Spot Instances in the fleet. If the
    #   minimum target capacity is not reached, the fleet launches no
    #   instances.
    #   @return [Integer]
    #
    # @!attribute [rw] max_total_price
    #   The maximum amount per hour for Spot Instances that you're willing
    #   to pay.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SpotOptionsRequest AWS API Documentation
    #
    class SpotOptionsRequest < Struct.new(
      :allocation_strategy,
      :instance_interruption_behavior,
      :instance_pools_to_use_count,
      :single_instance_type,
      :single_availability_zone,
      :min_target_capacity,
      :max_total_price)
      include Aws::Structure
    end

    # Describes Spot Instance placement.
    #
    # @note When making an API call, you may pass SpotPlacement
    #   data as a hash:
    #
    #       {
    #         availability_zone: "String",
    #         group_name: "String",
    #         tenancy: "default", # accepts default, dedicated, host
    #       }
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone.
    #
    #   \[Spot Fleet only\] To specify multiple Availability Zones, separate
    #   them using commas; for example, "us-west-2a, us-west-2b".
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   The name of the placement group.
    #   @return [String]
    #
    # @!attribute [rw] tenancy
    #   The tenancy of the instance (if the instance is running in a VPC).
    #   An instance with a tenancy of `dedicated` runs on single-tenant
    #   hardware. The `host` tenancy is not supported for Spot Instances.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SpotPlacement AWS API Documentation
    #
    class SpotPlacement < Struct.new(
      :availability_zone,
      :group_name,
      :tenancy)
      include Aws::Structure
    end

    # Describes the maximum price per hour that you are willing to pay for a
    # Spot Instance.
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone.
    #   @return [String]
    #
    # @!attribute [rw] instance_type
    #   The instance type.
    #   @return [String]
    #
    # @!attribute [rw] product_description
    #   A general description of the AMI.
    #   @return [String]
    #
    # @!attribute [rw] spot_price
    #   The maximum price per hour that you are willing to pay for a Spot
    #   Instance.
    #   @return [String]
    #
    # @!attribute [rw] timestamp
    #   The date and time the request was created, in UTC format (for
    #   example, *YYYY*-*MM*-*DD*T*HH*\:*MM*\:*SS*Z).
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SpotPrice AWS API Documentation
    #
    class SpotPrice < Struct.new(
      :availability_zone,
      :instance_type,
      :product_description,
      :spot_price,
      :timestamp)
      include Aws::Structure
    end

    # Describes a stale rule in a security group.
    #
    # @!attribute [rw] from_port
    #   The start of the port range for the TCP and UDP protocols, or an
    #   ICMP type number. A value of `-1` indicates all ICMP types.
    #   @return [Integer]
    #
    # @!attribute [rw] ip_protocol
    #   The IP protocol name (for `tcp`, `udp`, and `icmp`) or number (see
    #   [Protocol Numbers)][1].
    #
    #
    #
    #   [1]: http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml
    #   @return [String]
    #
    # @!attribute [rw] ip_ranges
    #   The IP ranges. Not applicable for stale security group rules.
    #   @return [Array<String>]
    #
    # @!attribute [rw] prefix_list_ids
    #   The prefix list IDs for an AWS service. Not applicable for stale
    #   security group rules.
    #   @return [Array<String>]
    #
    # @!attribute [rw] to_port
    #   The end of the port range for the TCP and UDP protocols, or an ICMP
    #   type number. A value of `-1` indicates all ICMP types.
    #   @return [Integer]
    #
    # @!attribute [rw] user_id_group_pairs
    #   The security group pairs. Returns the ID of the referenced security
    #   group and VPC, and the ID and status of the VPC peering connection.
    #   @return [Array<Types::UserIdGroupPair>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/StaleIpPermission AWS API Documentation
    #
    class StaleIpPermission < Struct.new(
      :from_port,
      :ip_protocol,
      :ip_ranges,
      :prefix_list_ids,
      :to_port,
      :user_id_group_pairs)
      include Aws::Structure
    end

    # Describes a stale security group (a security group that contains stale
    # rules).
    #
    # @!attribute [rw] description
    #   The description of the security group.
    #   @return [String]
    #
    # @!attribute [rw] group_id
    #   The ID of the security group.
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   The name of the security group.
    #   @return [String]
    #
    # @!attribute [rw] stale_ip_permissions
    #   Information about the stale inbound rules in the security group.
    #   @return [Array<Types::StaleIpPermission>]
    #
    # @!attribute [rw] stale_ip_permissions_egress
    #   Information about the stale outbound rules in the security group.
    #   @return [Array<Types::StaleIpPermission>]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC for the security group.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/StaleSecurityGroup AWS API Documentation
    #
    class StaleSecurityGroup < Struct.new(
      :description,
      :group_id,
      :group_name,
      :stale_ip_permissions,
      :stale_ip_permissions_egress,
      :vpc_id)
      include Aws::Structure
    end

    # @note When making an API call, you may pass StartInstancesRequest
    #   data as a hash:
    #
    #       {
    #         instance_ids: ["InstanceId"], # required
    #         additional_info: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] instance_ids
    #   The IDs of the instances.
    #   @return [Array<String>]
    #
    # @!attribute [rw] additional_info
    #   Reserved.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/StartInstancesRequest AWS API Documentation
    #
    class StartInstancesRequest < Struct.new(
      :instance_ids,
      :additional_info,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] starting_instances
    #   Information about the started instances.
    #   @return [Array<Types::InstanceStateChange>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/StartInstancesResult AWS API Documentation
    #
    class StartInstancesResult < Struct.new(
      :starting_instances)
      include Aws::Structure
    end

    # @note When making an API call, you may pass StartVpcEndpointServicePrivateDnsVerificationRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         service_id: "VpcEndpointServiceId", # required
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] service_id
    #   The ID of the endpoint service.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/StartVpcEndpointServicePrivateDnsVerificationRequest AWS API Documentation
    #
    class StartVpcEndpointServicePrivateDnsVerificationRequest < Struct.new(
      :dry_run,
      :service_id)
      include Aws::Structure
    end

    # @!attribute [rw] return_value
    #   Returns `true` if the request succeeds; otherwise, it returns an
    #   error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/StartVpcEndpointServicePrivateDnsVerificationResult AWS API Documentation
    #
    class StartVpcEndpointServicePrivateDnsVerificationResult < Struct.new(
      :return_value)
      include Aws::Structure
    end

    # Describes a state change.
    #
    # @!attribute [rw] code
    #   The reason code for the state change.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   The message for the state change.
    #
    #   * `Server.InsufficientInstanceCapacity`\: There was insufficient
    #     capacity available to satisfy the launch request.
    #
    #   * `Server.InternalError`\: An internal error caused the instance to
    #     terminate during launch.
    #
    #   * `Server.ScheduledStop`\: The instance was stopped due to a
    #     scheduled retirement.
    #
    #   * `Server.SpotInstanceShutdown`\: The instance was stopped because
    #     the number of Spot requests with a maximum price equal to or
    #     higher than the Spot price exceeded available capacity or because
    #     of an increase in the Spot price.
    #
    #   * `Server.SpotInstanceTermination`\: The instance was terminated
    #     because the number of Spot requests with a maximum price equal to
    #     or higher than the Spot price exceeded available capacity or
    #     because of an increase in the Spot price.
    #
    #   * `Client.InstanceInitiatedShutdown`\: The instance was shut down
    #     using the `shutdown -h` command from the instance.
    #
    #   * `Client.InstanceTerminated`\: The instance was terminated or
    #     rebooted during AMI creation.
    #
    #   * `Client.InternalError`\: A client error caused the instance to
    #     terminate during launch.
    #
    #   * `Client.InvalidSnapshot.NotFound`\: The specified snapshot was not
    #     found.
    #
    #   * `Client.UserInitiatedHibernate`\: Hibernation was initiated on the
    #     instance.
    #
    #   * `Client.UserInitiatedShutdown`\: The instance was shut down using
    #     the Amazon EC2 API.
    #
    #   * `Client.VolumeLimitExceeded`\: The limit on the number of EBS
    #     volumes or total storage was exceeded. Decrease usage or request
    #     an increase in your account limits.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/StateReason AWS API Documentation
    #
    class StateReason < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # @note When making an API call, you may pass StopInstancesRequest
    #   data as a hash:
    #
    #       {
    #         instance_ids: ["InstanceId"], # required
    #         hibernate: false,
    #         dry_run: false,
    #         force: false,
    #       }
    #
    # @!attribute [rw] instance_ids
    #   The IDs of the instances.
    #   @return [Array<String>]
    #
    # @!attribute [rw] hibernate
    #   Hibernates the instance if the instance was enabled for hibernation
    #   at launch. If the instance cannot hibernate successfully, a normal
    #   shutdown occurs. For more information, see [Hibernate Your
    #   Instance][1] in the *Amazon Elastic Compute Cloud User Guide*.
    #
    #   Default: `false`
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html
    #   @return [Boolean]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] force
    #   Forces the instances to stop. The instances do not have an
    #   opportunity to flush file system caches or file system metadata. If
    #   you use this option, you must perform file system check and repair
    #   procedures. This option is not recommended for Windows instances.
    #
    #   Default: `false`
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/StopInstancesRequest AWS API Documentation
    #
    class StopInstancesRequest < Struct.new(
      :instance_ids,
      :hibernate,
      :dry_run,
      :force)
      include Aws::Structure
    end

    # @!attribute [rw] stopping_instances
    #   Information about the stopped instances.
    #   @return [Array<Types::InstanceStateChange>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/StopInstancesResult AWS API Documentation
    #
    class StopInstancesResult < Struct.new(
      :stopping_instances)
      include Aws::Structure
    end

    # Describes the storage location for an instance store-backed AMI.
    #
    # @note When making an API call, you may pass Storage
    #   data as a hash:
    #
    #       {
    #         s3: {
    #           aws_access_key_id: "String",
    #           bucket: "String",
    #           prefix: "String",
    #           upload_policy: "data",
    #           upload_policy_signature: "String",
    #         },
    #       }
    #
    # @!attribute [rw] s3
    #   An Amazon S3 storage location.
    #   @return [Types::S3Storage]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Storage AWS API Documentation
    #
    class Storage < Struct.new(
      :s3)
      include Aws::Structure
    end

    # Describes a storage location in Amazon S3.
    #
    # @note When making an API call, you may pass StorageLocation
    #   data as a hash:
    #
    #       {
    #         bucket: "String",
    #         key: "String",
    #       }
    #
    # @!attribute [rw] bucket
    #   The name of the S3 bucket.
    #   @return [String]
    #
    # @!attribute [rw] key
    #   The key.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/StorageLocation AWS API Documentation
    #
    class StorageLocation < Struct.new(
      :bucket,
      :key)
      include Aws::Structure
    end

    # Describes a subnet.
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone of the subnet.
    #   @return [String]
    #
    # @!attribute [rw] availability_zone_id
    #   The AZ ID of the subnet.
    #   @return [String]
    #
    # @!attribute [rw] available_ip_address_count
    #   The number of unused private IPv4 addresses in the subnet. The IPv4
    #   addresses for any stopped instances are considered unavailable.
    #   @return [Integer]
    #
    # @!attribute [rw] cidr_block
    #   The IPv4 CIDR block assigned to the subnet.
    #   @return [String]
    #
    # @!attribute [rw] default_for_az
    #   Indicates whether this is the default subnet for the Availability
    #   Zone.
    #   @return [Boolean]
    #
    # @!attribute [rw] map_public_ip_on_launch
    #   Indicates whether instances launched in this subnet receive a public
    #   IPv4 address.
    #   @return [Boolean]
    #
    # @!attribute [rw] map_customer_owned_ip_on_launch
    #   Indicates whether a network interface created in this subnet
    #   (including a network interface created by RunInstances) receives a
    #   customer-owned IPv4 address.
    #   @return [Boolean]
    #
    # @!attribute [rw] customer_owned_ipv_4_pool
    #   The customer-owned IPv4 address pool associated with the subnet.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The current state of the subnet.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC the subnet is in.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account that owns the subnet.
    #   @return [String]
    #
    # @!attribute [rw] assign_ipv_6_address_on_creation
    #   Indicates whether a network interface created in this subnet
    #   (including a network interface created by RunInstances) receives an
    #   IPv6 address.
    #   @return [Boolean]
    #
    # @!attribute [rw] ipv_6_cidr_block_association_set
    #   Information about the IPv6 CIDR blocks associated with the subnet.
    #   @return [Array<Types::SubnetIpv6CidrBlockAssociation>]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the subnet.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] subnet_arn
    #   The Amazon Resource Name (ARN) of the subnet.
    #   @return [String]
    #
    # @!attribute [rw] outpost_arn
    #   The Amazon Resource Name (ARN) of the Outpost.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Subnet AWS API Documentation
    #
    class Subnet < Struct.new(
      :availability_zone,
      :availability_zone_id,
      :available_ip_address_count,
      :cidr_block,
      :default_for_az,
      :map_public_ip_on_launch,
      :map_customer_owned_ip_on_launch,
      :customer_owned_ipv_4_pool,
      :state,
      :subnet_id,
      :vpc_id,
      :owner_id,
      :assign_ipv_6_address_on_creation,
      :ipv_6_cidr_block_association_set,
      :tags,
      :subnet_arn,
      :outpost_arn)
      include Aws::Structure
    end

    # Describes the subnet association with the transit gateway multicast
    # domain.
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the subnet association.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SubnetAssociation AWS API Documentation
    #
    class SubnetAssociation < Struct.new(
      :subnet_id,
      :state)
      include Aws::Structure
    end

    # Describes the state of a CIDR block.
    #
    # @!attribute [rw] state
    #   The state of a CIDR block.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   A message about the status of the CIDR block, if applicable.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SubnetCidrBlockState AWS API Documentation
    #
    class SubnetCidrBlockState < Struct.new(
      :state,
      :status_message)
      include Aws::Structure
    end

    # Describes an IPv6 CIDR block associated with a subnet.
    #
    # @!attribute [rw] association_id
    #   The association ID for the CIDR block.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_cidr_block
    #   The IPv6 CIDR block.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_cidr_block_state
    #   Information about the state of the CIDR block.
    #   @return [Types::SubnetCidrBlockState]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SubnetIpv6CidrBlockAssociation AWS API Documentation
    #
    class SubnetIpv6CidrBlockAssociation < Struct.new(
      :association_id,
      :ipv_6_cidr_block,
      :ipv_6_cidr_block_state)
      include Aws::Structure
    end

    # Describes the burstable performance instance whose credit option for
    # CPU usage was successfully modified.
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SuccessfulInstanceCreditSpecificationItem AWS API Documentation
    #
    class SuccessfulInstanceCreditSpecificationItem < Struct.new(
      :instance_id)
      include Aws::Structure
    end

    # Describes a Reserved Instance whose queued purchase was successfully
    # deleted.
    #
    # @!attribute [rw] reserved_instances_id
    #   The ID of the Reserved Instance.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/SuccessfulQueuedPurchaseDeletion AWS API Documentation
    #
    class SuccessfulQueuedPurchaseDeletion < Struct.new(
      :reserved_instances_id)
      include Aws::Structure
    end

    # Describes a tag.
    #
    # @note When making an API call, you may pass Tag
    #   data as a hash:
    #
    #       {
    #         key: "String",
    #         value: "String",
    #       }
    #
    # @!attribute [rw] key
    #   The key of the tag.
    #
    #   Constraints: Tag keys are case-sensitive and accept a maximum of 127
    #   Unicode characters. May not begin with `aws:`.
    #   @return [String]
    #
    # @!attribute [rw] value
    #   The value of the tag.
    #
    #   Constraints: Tag values are case-sensitive and accept a maximum of
    #   255 Unicode characters.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Tag AWS API Documentation
    #
    class Tag < Struct.new(
      :key,
      :value)
      include Aws::Structure
    end

    # Describes a tag.
    #
    # @!attribute [rw] key
    #   The tag key.
    #   @return [String]
    #
    # @!attribute [rw] resource_id
    #   The ID of the resource.
    #   @return [String]
    #
    # @!attribute [rw] resource_type
    #   The resource type.
    #   @return [String]
    #
    # @!attribute [rw] value
    #   The tag value.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TagDescription AWS API Documentation
    #
    class TagDescription < Struct.new(
      :key,
      :resource_id,
      :resource_type,
      :value)
      include Aws::Structure
    end

    # The tags to apply to a resource when the resource is being created.
    #
    # @note When making an API call, you may pass TagSpecification
    #   data as a hash:
    #
    #       {
    #         resource_type: "client-vpn-endpoint", # accepts client-vpn-endpoint, customer-gateway, dedicated-host, dhcp-options, elastic-ip, fleet, fpga-image, host-reservation, image, instance, internet-gateway, key-pair, launch-template, natgateway, network-acl, network-interface, placement-group, reserved-instances, route-table, security-group, snapshot, spot-fleet-request, spot-instances-request, subnet, traffic-mirror-filter, traffic-mirror-session, traffic-mirror-target, transit-gateway, transit-gateway-attachment, transit-gateway-multicast-domain, transit-gateway-route-table, volume, vpc, vpc-peering-connection, vpn-connection, vpn-gateway, vpc-flow-log
    #         tags: [
    #           {
    #             key: "String",
    #             value: "String",
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] resource_type
    #   The type of resource to tag. Currently, the resource types that
    #   support tagging on creation are: `capacity-reservation` \|
    #   `client-vpn-endpoint` \| `dedicated-host` \| `fleet` \| `fpga-image`
    #   \| `instance` \| `ipv4pool-ec2` \| `ipv6pool-ec2` \| `key-pair` \|
    #   `launch-template` \| `natgateway` \| `spot-fleet-request` \|
    #   `placement-group` \| `snapshot` \| `traffic-mirror-filter` \|
    #   `traffic-mirror-session` \| `traffic-mirror-target` \|
    #   `transit-gateway` \| `transit-gateway-attachment` \|
    #   `transit-gateway-route-table` \| `vpc-endpoint` (for interface VPC
    #   endpoints)\| `vpc-endpoint-service` (for gateway VPC endpoints) \|
    #   `volume` \| `vpc-flow-log`.
    #
    #   To tag a resource after it has been created, see [CreateTags][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags to apply to the resource.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TagSpecification AWS API Documentation
    #
    class TagSpecification < Struct.new(
      :resource_type,
      :tags)
      include Aws::Structure
    end

    # The number of units to request. You can choose to set the target
    # capacity in terms of instances or a performance characteristic that is
    # important to your application workload, such as vCPUs, memory, or I/O.
    # If the request type is `maintain`, you can specify a target capacity
    # of 0 and add capacity later.
    #
    # You can use the On-Demand Instance `MaxTotalPrice` parameter, the Spot
    # Instance `MaxTotalPrice`, or both to ensure that your fleet cost does
    # not exceed your budget. If you set a maximum price per hour for the
    # On-Demand Instances and Spot Instances in your request, EC2 Fleet will
    # launch instances until it reaches the maximum amount that you're
    # willing to pay. When the maximum amount you're willing to pay is
    # reached, the fleet stops launching instances even if it hasn’t met the
    # target capacity. The `MaxTotalPrice` parameters are located in
    # [OnDemandOptions][1] and [SpotOptions][2]
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_OnDemandOptions.html
    # [2]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_SpotOptions
    #
    # @!attribute [rw] total_target_capacity
    #   The number of units to request, filled using
    #   `DefaultTargetCapacityType`.
    #   @return [Integer]
    #
    # @!attribute [rw] on_demand_target_capacity
    #   The number of On-Demand units to request. If you specify a target
    #   capacity for Spot units, you cannot specify a target capacity for
    #   On-Demand units.
    #   @return [Integer]
    #
    # @!attribute [rw] spot_target_capacity
    #   The maximum number of Spot units to launch. If you specify a target
    #   capacity for On-Demand units, you cannot specify a target capacity
    #   for Spot units.
    #   @return [Integer]
    #
    # @!attribute [rw] default_target_capacity_type
    #   The default `TotalTargetCapacity`, which is either `Spot` or
    #   `On-Demand`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TargetCapacitySpecification AWS API Documentation
    #
    class TargetCapacitySpecification < Struct.new(
      :total_target_capacity,
      :on_demand_target_capacity,
      :spot_target_capacity,
      :default_target_capacity_type)
      include Aws::Structure
    end

    # The number of units to request. You can choose to set the target
    # capacity as the number of instances. Or you can set the target
    # capacity to a performance characteristic that is important to your
    # application workload, such as vCPUs, memory, or I/O. If the request
    # type is `maintain`, you can specify a target capacity of 0 and add
    # capacity later.
    #
    # You can use the On-Demand Instance `MaxTotalPrice` parameter, the Spot
    # Instance `MaxTotalPrice` parameter, or both parameters to ensure that
    # your fleet cost does not exceed your budget. If you set a maximum
    # price per hour for the On-Demand Instances and Spot Instances in your
    # request, EC2 Fleet will launch instances until it reaches the maximum
    # amount that you're willing to pay. When the maximum amount you're
    # willing to pay is reached, the fleet stops launching instances even if
    # it hasn’t met the target capacity. The `MaxTotalPrice` parameters are
    # located in [OnDemandOptionsRequest][1] and [SpotOptionsRequest][2].
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_OnDemandOptionsRequest
    # [2]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_SpotOptionsRequest
    #
    # @note When making an API call, you may pass TargetCapacitySpecificationRequest
    #   data as a hash:
    #
    #       {
    #         total_target_capacity: 1, # required
    #         on_demand_target_capacity: 1,
    #         spot_target_capacity: 1,
    #         default_target_capacity_type: "spot", # accepts spot, on-demand
    #       }
    #
    # @!attribute [rw] total_target_capacity
    #   The number of units to request, filled using
    #   `DefaultTargetCapacityType`.
    #   @return [Integer]
    #
    # @!attribute [rw] on_demand_target_capacity
    #   The number of On-Demand units to request.
    #   @return [Integer]
    #
    # @!attribute [rw] spot_target_capacity
    #   The number of Spot units to request.
    #   @return [Integer]
    #
    # @!attribute [rw] default_target_capacity_type
    #   The default `TotalTargetCapacity`, which is either `Spot` or
    #   `On-Demand`.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TargetCapacitySpecificationRequest AWS API Documentation
    #
    class TargetCapacitySpecificationRequest < Struct.new(
      :total_target_capacity,
      :on_demand_target_capacity,
      :spot_target_capacity,
      :default_target_capacity_type)
      include Aws::Structure
    end

    # Information about the Convertible Reserved Instance offering.
    #
    # @!attribute [rw] instance_count
    #   The number of instances the Convertible Reserved Instance offering
    #   can be applied to. This parameter is reserved and cannot be
    #   specified in a request
    #   @return [Integer]
    #
    # @!attribute [rw] offering_id
    #   The ID of the Convertible Reserved Instance offering.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TargetConfiguration AWS API Documentation
    #
    class TargetConfiguration < Struct.new(
      :instance_count,
      :offering_id)
      include Aws::Structure
    end

    # Details about the target configuration.
    #
    # @note When making an API call, you may pass TargetConfigurationRequest
    #   data as a hash:
    #
    #       {
    #         instance_count: 1,
    #         offering_id: "ReservedInstancesOfferingId", # required
    #       }
    #
    # @!attribute [rw] instance_count
    #   The number of instances the Covertible Reserved Instance offering
    #   can be applied to. This parameter is reserved and cannot be
    #   specified in a request
    #   @return [Integer]
    #
    # @!attribute [rw] offering_id
    #   The Convertible Reserved Instance offering ID.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TargetConfigurationRequest AWS API Documentation
    #
    class TargetConfigurationRequest < Struct.new(
      :instance_count,
      :offering_id)
      include Aws::Structure
    end

    # Describes a load balancer target group.
    #
    # @note When making an API call, you may pass TargetGroup
    #   data as a hash:
    #
    #       {
    #         arn: "String",
    #       }
    #
    # @!attribute [rw] arn
    #   The Amazon Resource Name (ARN) of the target group.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TargetGroup AWS API Documentation
    #
    class TargetGroup < Struct.new(
      :arn)
      include Aws::Structure
    end

    # Describes the target groups to attach to a Spot Fleet. Spot Fleet
    # registers the running Spot Instances with these target groups.
    #
    # @note When making an API call, you may pass TargetGroupsConfig
    #   data as a hash:
    #
    #       {
    #         target_groups: [
    #           {
    #             arn: "String",
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] target_groups
    #   One or more target groups.
    #   @return [Array<Types::TargetGroup>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TargetGroupsConfig AWS API Documentation
    #
    class TargetGroupsConfig < Struct.new(
      :target_groups)
      include Aws::Structure
    end

    # Describes a target network associated with a Client VPN endpoint.
    #
    # @!attribute [rw] association_id
    #   The ID of the association.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC in which the target network (subnet) is located.
    #   @return [String]
    #
    # @!attribute [rw] target_network_id
    #   The ID of the subnet specified as the target network.
    #   @return [String]
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint with which the target network is
    #   associated.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The current state of the target network association.
    #   @return [Types::AssociationStatus]
    #
    # @!attribute [rw] security_groups
    #   The IDs of the security groups applied to the target network
    #   association.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TargetNetwork AWS API Documentation
    #
    class TargetNetwork < Struct.new(
      :association_id,
      :vpc_id,
      :target_network_id,
      :client_vpn_endpoint_id,
      :status,
      :security_groups)
      include Aws::Structure
    end

    # The total value of the new Convertible Reserved Instances.
    #
    # @!attribute [rw] reservation_value
    #   The total value of the Convertible Reserved Instances that make up
    #   the exchange. This is the sum of the list value, remaining upfront
    #   price, and additional upfront cost of the exchange.
    #   @return [Types::ReservationValue]
    #
    # @!attribute [rw] target_configuration
    #   The configuration of the Convertible Reserved Instances that make up
    #   the exchange.
    #   @return [Types::TargetConfiguration]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TargetReservationValue AWS API Documentation
    #
    class TargetReservationValue < Struct.new(
      :reservation_value,
      :target_configuration)
      include Aws::Structure
    end

    # @note When making an API call, you may pass TerminateClientVpnConnectionsRequest
    #   data as a hash:
    #
    #       {
    #         client_vpn_endpoint_id: "ClientVpnEndpointId", # required
    #         connection_id: "VpnConnectionId",
    #         username: "String",
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint to which the client is connected.
    #   @return [String]
    #
    # @!attribute [rw] connection_id
    #   The ID of the client connection to be terminated.
    #   @return [String]
    #
    # @!attribute [rw] username
    #   The name of the user who initiated the connection. Use this option
    #   to terminate all active connections for the specified user. This
    #   option can only be used if the user has established up to five
    #   connections.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TerminateClientVpnConnectionsRequest AWS API Documentation
    #
    class TerminateClientVpnConnectionsRequest < Struct.new(
      :client_vpn_endpoint_id,
      :connection_id,
      :username,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] client_vpn_endpoint_id
    #   The ID of the Client VPN endpoint.
    #   @return [String]
    #
    # @!attribute [rw] username
    #   The user who established the terminated client connections.
    #   @return [String]
    #
    # @!attribute [rw] connection_statuses
    #   The current state of the client connections.
    #   @return [Array<Types::TerminateConnectionStatus>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TerminateClientVpnConnectionsResult AWS API Documentation
    #
    class TerminateClientVpnConnectionsResult < Struct.new(
      :client_vpn_endpoint_id,
      :username,
      :connection_statuses)
      include Aws::Structure
    end

    # Information about a terminated Client VPN endpoint client connection.
    #
    # @!attribute [rw] connection_id
    #   The ID of the client connection.
    #   @return [String]
    #
    # @!attribute [rw] previous_status
    #   The state of the client connection.
    #   @return [Types::ClientVpnConnectionStatus]
    #
    # @!attribute [rw] current_status
    #   A message about the status of the client connection, if applicable.
    #   @return [Types::ClientVpnConnectionStatus]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TerminateConnectionStatus AWS API Documentation
    #
    class TerminateConnectionStatus < Struct.new(
      :connection_id,
      :previous_status,
      :current_status)
      include Aws::Structure
    end

    # @note When making an API call, you may pass TerminateInstancesRequest
    #   data as a hash:
    #
    #       {
    #         instance_ids: ["InstanceId"], # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] instance_ids
    #   The IDs of the instances.
    #
    #   Constraints: Up to 1000 instance IDs. We recommend breaking up this
    #   request into smaller batches.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TerminateInstancesRequest AWS API Documentation
    #
    class TerminateInstancesRequest < Struct.new(
      :instance_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] terminating_instances
    #   Information about the terminated instances.
    #   @return [Array<Types::InstanceStateChange>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TerminateInstancesResult AWS API Documentation
    #
    class TerminateInstancesResult < Struct.new(
      :terminating_instances)
      include Aws::Structure
    end

    # Describes the Traffic Mirror filter.
    #
    # @!attribute [rw] traffic_mirror_filter_id
    #   The ID of the Traffic Mirror filter.
    #   @return [String]
    #
    # @!attribute [rw] ingress_filter_rules
    #   Information about the ingress rules that are associated with the
    #   Traffic Mirror filter.
    #   @return [Array<Types::TrafficMirrorFilterRule>]
    #
    # @!attribute [rw] egress_filter_rules
    #   Information about the egress rules that are associated with the
    #   Traffic Mirror filter.
    #   @return [Array<Types::TrafficMirrorFilterRule>]
    #
    # @!attribute [rw] network_services
    #   The network service traffic that is associated with the Traffic
    #   Mirror filter.
    #   @return [Array<String>]
    #
    # @!attribute [rw] description
    #   The description of the Traffic Mirror filter.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags assigned to the Traffic Mirror filter.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TrafficMirrorFilter AWS API Documentation
    #
    class TrafficMirrorFilter < Struct.new(
      :traffic_mirror_filter_id,
      :ingress_filter_rules,
      :egress_filter_rules,
      :network_services,
      :description,
      :tags)
      include Aws::Structure
    end

    # Describes the Traffic Mirror rule.
    #
    # @!attribute [rw] traffic_mirror_filter_rule_id
    #   The ID of the Traffic Mirror rule.
    #   @return [String]
    #
    # @!attribute [rw] traffic_mirror_filter_id
    #   The ID of the Traffic Mirror filter that the rule is associated
    #   with.
    #   @return [String]
    #
    # @!attribute [rw] traffic_direction
    #   The traffic direction assigned to the Traffic Mirror rule.
    #   @return [String]
    #
    # @!attribute [rw] rule_number
    #   The rule number of the Traffic Mirror rule.
    #   @return [Integer]
    #
    # @!attribute [rw] rule_action
    #   The action assigned to the Traffic Mirror rule.
    #   @return [String]
    #
    # @!attribute [rw] protocol
    #   The protocol assigned to the Traffic Mirror rule.
    #   @return [Integer]
    #
    # @!attribute [rw] destination_port_range
    #   The destination port range assigned to the Traffic Mirror rule.
    #   @return [Types::TrafficMirrorPortRange]
    #
    # @!attribute [rw] source_port_range
    #   The source port range assigned to the Traffic Mirror rule.
    #   @return [Types::TrafficMirrorPortRange]
    #
    # @!attribute [rw] destination_cidr_block
    #   The destination CIDR block assigned to the Traffic Mirror rule.
    #   @return [String]
    #
    # @!attribute [rw] source_cidr_block
    #   The source CIDR block assigned to the Traffic Mirror rule.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   The description of the Traffic Mirror rule.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TrafficMirrorFilterRule AWS API Documentation
    #
    class TrafficMirrorFilterRule < Struct.new(
      :traffic_mirror_filter_rule_id,
      :traffic_mirror_filter_id,
      :traffic_direction,
      :rule_number,
      :rule_action,
      :protocol,
      :destination_port_range,
      :source_port_range,
      :destination_cidr_block,
      :source_cidr_block,
      :description)
      include Aws::Structure
    end

    # Describes the Traffic Mirror port range.
    #
    # @!attribute [rw] from_port
    #   The start of the Traffic Mirror port range. This applies to the TCP
    #   and UDP protocols.
    #   @return [Integer]
    #
    # @!attribute [rw] to_port
    #   The end of the Traffic Mirror port range. This applies to the TCP
    #   and UDP protocols.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TrafficMirrorPortRange AWS API Documentation
    #
    class TrafficMirrorPortRange < Struct.new(
      :from_port,
      :to_port)
      include Aws::Structure
    end

    # Information about the Traffic Mirror filter rule port range.
    #
    # @note When making an API call, you may pass TrafficMirrorPortRangeRequest
    #   data as a hash:
    #
    #       {
    #         from_port: 1,
    #         to_port: 1,
    #       }
    #
    # @!attribute [rw] from_port
    #   The first port in the Traffic Mirror port range. This applies to the
    #   TCP and UDP protocols.
    #   @return [Integer]
    #
    # @!attribute [rw] to_port
    #   The last port in the Traffic Mirror port range. This applies to the
    #   TCP and UDP protocols.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TrafficMirrorPortRangeRequest AWS API Documentation
    #
    class TrafficMirrorPortRangeRequest < Struct.new(
      :from_port,
      :to_port)
      include Aws::Structure
    end

    # Describes a Traffic Mirror session.
    #
    # @!attribute [rw] traffic_mirror_session_id
    #   The ID for the Traffic Mirror session.
    #   @return [String]
    #
    # @!attribute [rw] traffic_mirror_target_id
    #   The ID of the Traffic Mirror target.
    #   @return [String]
    #
    # @!attribute [rw] traffic_mirror_filter_id
    #   The ID of the Traffic Mirror filter.
    #   @return [String]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the Traffic Mirror session's network interface.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the account that owns the Traffic Mirror session.
    #   @return [String]
    #
    # @!attribute [rw] packet_length
    #   The number of bytes in each packet to mirror. These are the bytes
    #   after the VXLAN header. To mirror a subset, set this to the length
    #   (in bytes) to mirror. For example, if you set this value to 100,
    #   then the first 100 bytes that meet the filter criteria are copied to
    #   the target. Do not specify this parameter when you want to mirror
    #   the entire packet
    #   @return [Integer]
    #
    # @!attribute [rw] session_number
    #   The session number determines the order in which sessions are
    #   evaluated when an interface is used by multiple sessions. The first
    #   session with a matching filter is the one that mirrors the packets.
    #
    #   Valid values are 1-32766.
    #   @return [Integer]
    #
    # @!attribute [rw] virtual_network_id
    #   The virtual network ID associated with the Traffic Mirror session.
    #   @return [Integer]
    #
    # @!attribute [rw] description
    #   The description of the Traffic Mirror session.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags assigned to the Traffic Mirror session.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TrafficMirrorSession AWS API Documentation
    #
    class TrafficMirrorSession < Struct.new(
      :traffic_mirror_session_id,
      :traffic_mirror_target_id,
      :traffic_mirror_filter_id,
      :network_interface_id,
      :owner_id,
      :packet_length,
      :session_number,
      :virtual_network_id,
      :description,
      :tags)
      include Aws::Structure
    end

    # Describes a Traffic Mirror target.
    #
    # @!attribute [rw] traffic_mirror_target_id
    #   The ID of the Traffic Mirror target.
    #   @return [String]
    #
    # @!attribute [rw] network_interface_id
    #   The network interface ID that is attached to the target.
    #   @return [String]
    #
    # @!attribute [rw] network_load_balancer_arn
    #   The Amazon Resource Name (ARN) of the Network Load Balancer.
    #   @return [String]
    #
    # @!attribute [rw] type
    #   The type of Traffic Mirror target.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   Information about the Traffic Mirror target.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the account that owns the Traffic Mirror target.
    #   @return [String]
    #
    # @!attribute [rw] tags
    #   The tags assigned to the Traffic Mirror target.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TrafficMirrorTarget AWS API Documentation
    #
    class TrafficMirrorTarget < Struct.new(
      :traffic_mirror_target_id,
      :network_interface_id,
      :network_load_balancer_arn,
      :type,
      :description,
      :owner_id,
      :tags)
      include Aws::Structure
    end

    # Describes a transit gateway.
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_arn
    #   The Amazon Resource Name (ARN) of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account ID that owns the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   The description of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] creation_time
    #   The creation time.
    #   @return [Time]
    #
    # @!attribute [rw] options
    #   The transit gateway options.
    #   @return [Types::TransitGatewayOptions]
    #
    # @!attribute [rw] tags
    #   The tags for the transit gateway.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGateway AWS API Documentation
    #
    class TransitGateway < Struct.new(
      :transit_gateway_id,
      :transit_gateway_arn,
      :state,
      :owner_id,
      :description,
      :creation_time,
      :options,
      :tags)
      include Aws::Structure
    end

    # Describes an association between a resource attachment and a transit
    # gateway route table.
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the transit gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] resource_id
    #   The ID of the resource.
    #   @return [String]
    #
    # @!attribute [rw] resource_type
    #   The resource type.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the association.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayAssociation AWS API Documentation
    #
    class TransitGatewayAssociation < Struct.new(
      :transit_gateway_route_table_id,
      :transit_gateway_attachment_id,
      :resource_id,
      :resource_type,
      :state)
      include Aws::Structure
    end

    # Describes an attachment between a resource and a transit gateway.
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_owner_id
    #   The ID of the AWS account that owns the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] resource_owner_id
    #   The ID of the AWS account that owns the resource.
    #   @return [String]
    #
    # @!attribute [rw] resource_type
    #   The resource type.
    #   @return [String]
    #
    # @!attribute [rw] resource_id
    #   The ID of the resource.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The attachment state.
    #   @return [String]
    #
    # @!attribute [rw] association
    #   The association.
    #   @return [Types::TransitGatewayAttachmentAssociation]
    #
    # @!attribute [rw] creation_time
    #   The creation time.
    #   @return [Time]
    #
    # @!attribute [rw] tags
    #   The tags for the attachment.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayAttachment AWS API Documentation
    #
    class TransitGatewayAttachment < Struct.new(
      :transit_gateway_attachment_id,
      :transit_gateway_id,
      :transit_gateway_owner_id,
      :resource_owner_id,
      :resource_type,
      :resource_id,
      :state,
      :association,
      :creation_time,
      :tags)
      include Aws::Structure
    end

    # Describes an association.
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the route table for the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the association.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayAttachmentAssociation AWS API Documentation
    #
    class TransitGatewayAttachmentAssociation < Struct.new(
      :transit_gateway_route_table_id,
      :state)
      include Aws::Structure
    end

    # Describes a propagation route table.
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the propagation route table.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the propagation route table.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayAttachmentPropagation AWS API Documentation
    #
    class TransitGatewayAttachmentPropagation < Struct.new(
      :transit_gateway_route_table_id,
      :state)
      include Aws::Structure
    end

    # Describes the deregistered transit gateway multicast group members.
    #
    # @!attribute [rw] transit_gateway_multicast_domain_id
    #   The ID of the transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] deregistered_network_interface_ids
    #   The network interface IDs of the deregistered members.
    #   @return [Array<String>]
    #
    # @!attribute [rw] group_ip_address
    #   The IP address assigned to the transit gateway multicast group.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayMulticastDeregisteredGroupMembers AWS API Documentation
    #
    class TransitGatewayMulticastDeregisteredGroupMembers < Struct.new(
      :transit_gateway_multicast_domain_id,
      :deregistered_network_interface_ids,
      :group_ip_address)
      include Aws::Structure
    end

    # Describes the deregistered transit gateway multicast group sources.
    #
    # @!attribute [rw] transit_gateway_multicast_domain_id
    #   The ID of the transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] deregistered_network_interface_ids
    #   The network interface IDs of the non-registered members.
    #   @return [Array<String>]
    #
    # @!attribute [rw] group_ip_address
    #   The IP address assigned to the transit gateway multicast group.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayMulticastDeregisteredGroupSources AWS API Documentation
    #
    class TransitGatewayMulticastDeregisteredGroupSources < Struct.new(
      :transit_gateway_multicast_domain_id,
      :deregistered_network_interface_ids,
      :group_ip_address)
      include Aws::Structure
    end

    # Describes the transit gateway multicast domain.
    #
    # @!attribute [rw] transit_gateway_multicast_domain_id
    #   The ID of the transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] creation_time
    #   The time the transit gateway multicast domain was created.
    #   @return [Time]
    #
    # @!attribute [rw] tags
    #   The tags for the transit gateway multicast domain.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayMulticastDomain AWS API Documentation
    #
    class TransitGatewayMulticastDomain < Struct.new(
      :transit_gateway_multicast_domain_id,
      :transit_gateway_id,
      :state,
      :creation_time,
      :tags)
      include Aws::Structure
    end

    # Describes the resources associated with the transit gateway multicast
    # domain.
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the transit gateway attachment.
    #   @return [String]
    #
    # @!attribute [rw] resource_id
    #   The ID of the resource.
    #   @return [String]
    #
    # @!attribute [rw] resource_type
    #   The type of resource, for example a VPC attachment.
    #   @return [String]
    #
    # @!attribute [rw] subnet
    #   The subnet associated with the transit gateway multicast domain.
    #   @return [Types::SubnetAssociation]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayMulticastDomainAssociation AWS API Documentation
    #
    class TransitGatewayMulticastDomainAssociation < Struct.new(
      :transit_gateway_attachment_id,
      :resource_id,
      :resource_type,
      :subnet)
      include Aws::Structure
    end

    # Describes the multicast domain associations.
    #
    # @!attribute [rw] transit_gateway_multicast_domain_id
    #   The ID of the transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the transit gateway attachment.
    #   @return [String]
    #
    # @!attribute [rw] resource_id
    #   The ID of the resource.
    #   @return [String]
    #
    # @!attribute [rw] resource_type
    #   The type of resource, for example a VPC attachment.
    #   @return [String]
    #
    # @!attribute [rw] subnets
    #   The subnets associated with the multicast domain.
    #   @return [Array<Types::SubnetAssociation>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayMulticastDomainAssociations AWS API Documentation
    #
    class TransitGatewayMulticastDomainAssociations < Struct.new(
      :transit_gateway_multicast_domain_id,
      :transit_gateway_attachment_id,
      :resource_id,
      :resource_type,
      :subnets)
      include Aws::Structure
    end

    # Describes the transit gateway multicast group resources.
    #
    # @!attribute [rw] group_ip_address
    #   The IP address assigned to the transit gateway multicast group.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the transit gateway attachment.
    #   @return [String]
    #
    # @!attribute [rw] subnet_id
    #   The ID of the subnet.
    #   @return [String]
    #
    # @!attribute [rw] resource_id
    #   The ID of the resource.
    #   @return [String]
    #
    # @!attribute [rw] resource_type
    #   The type of resource, for example a VPC attachment.
    #   @return [String]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the transit gateway attachment.
    #   @return [String]
    #
    # @!attribute [rw] group_member
    #   Indicates that the resource is a transit gateway multicast group
    #   member.
    #   @return [Boolean]
    #
    # @!attribute [rw] group_source
    #   Indicates that the resource is a transit gateway multicast group
    #   member.
    #   @return [Boolean]
    #
    # @!attribute [rw] member_type
    #   The member type (for example, `static`).
    #   @return [String]
    #
    # @!attribute [rw] source_type
    #   The source type.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayMulticastGroup AWS API Documentation
    #
    class TransitGatewayMulticastGroup < Struct.new(
      :group_ip_address,
      :transit_gateway_attachment_id,
      :subnet_id,
      :resource_id,
      :resource_type,
      :network_interface_id,
      :group_member,
      :group_source,
      :member_type,
      :source_type)
      include Aws::Structure
    end

    # Describes the registered transit gateway multicast group members.
    #
    # @!attribute [rw] transit_gateway_multicast_domain_id
    #   The ID of the transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] registered_network_interface_ids
    #   The ID of the registered network interfaces.
    #   @return [Array<String>]
    #
    # @!attribute [rw] group_ip_address
    #   The IP address assigned to the transit gateway multicast group.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayMulticastRegisteredGroupMembers AWS API Documentation
    #
    class TransitGatewayMulticastRegisteredGroupMembers < Struct.new(
      :transit_gateway_multicast_domain_id,
      :registered_network_interface_ids,
      :group_ip_address)
      include Aws::Structure
    end

    # Describes the members registered with the transit gateway multicast
    # group.
    #
    # @!attribute [rw] transit_gateway_multicast_domain_id
    #   The ID of the transit gateway multicast domain.
    #   @return [String]
    #
    # @!attribute [rw] registered_network_interface_ids
    #   The IDs of the network interfaces members registered with the
    #   transit gateway multicast group.
    #   @return [Array<String>]
    #
    # @!attribute [rw] group_ip_address
    #   The IP address assigned to the transit gateway multicast group.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayMulticastRegisteredGroupSources AWS API Documentation
    #
    class TransitGatewayMulticastRegisteredGroupSources < Struct.new(
      :transit_gateway_multicast_domain_id,
      :registered_network_interface_ids,
      :group_ip_address)
      include Aws::Structure
    end

    # Describes the options for a transit gateway.
    #
    # @!attribute [rw] amazon_side_asn
    #   A private Autonomous System Number (ASN) for the Amazon side of a
    #   BGP session. The range is 64512 to 65534 for 16-bit ASNs and
    #   4200000000 to 4294967294 for 32-bit ASNs.
    #   @return [Integer]
    #
    # @!attribute [rw] auto_accept_shared_attachments
    #   Indicates whether attachment requests are automatically accepted.
    #   @return [String]
    #
    # @!attribute [rw] default_route_table_association
    #   Indicates whether resource attachments are automatically associated
    #   with the default association route table.
    #   @return [String]
    #
    # @!attribute [rw] association_default_route_table_id
    #   The ID of the default association route table.
    #   @return [String]
    #
    # @!attribute [rw] default_route_table_propagation
    #   Indicates whether resource attachments automatically propagate
    #   routes to the default propagation route table.
    #   @return [String]
    #
    # @!attribute [rw] propagation_default_route_table_id
    #   The ID of the default propagation route table.
    #   @return [String]
    #
    # @!attribute [rw] vpn_ecmp_support
    #   Indicates whether Equal Cost Multipath Protocol support is enabled.
    #   @return [String]
    #
    # @!attribute [rw] dns_support
    #   Indicates whether DNS support is enabled.
    #   @return [String]
    #
    # @!attribute [rw] multicast_support
    #   Indicates whether multicast is enabled on the transit gateway
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayOptions AWS API Documentation
    #
    class TransitGatewayOptions < Struct.new(
      :amazon_side_asn,
      :auto_accept_shared_attachments,
      :default_route_table_association,
      :association_default_route_table_id,
      :default_route_table_propagation,
      :propagation_default_route_table_id,
      :vpn_ecmp_support,
      :dns_support,
      :multicast_support)
      include Aws::Structure
    end

    # Describes the transit gateway peering attachment.
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the transit gateway peering attachment.
    #   @return [String]
    #
    # @!attribute [rw] requester_tgw_info
    #   Information about the requester transit gateway.
    #   @return [Types::PeeringTgwInfo]
    #
    # @!attribute [rw] accepter_tgw_info
    #   Information about the accepter transit gateway.
    #   @return [Types::PeeringTgwInfo]
    #
    # @!attribute [rw] status
    #   The status of the transit gateway peering attachment.
    #   @return [Types::PeeringAttachmentStatus]
    #
    # @!attribute [rw] state
    #   The state of the transit gateway peering attachment.
    #   @return [String]
    #
    # @!attribute [rw] creation_time
    #   The time the transit gateway peering attachment was created.
    #   @return [Time]
    #
    # @!attribute [rw] tags
    #   The tags for the transit gateway peering attachment.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayPeeringAttachment AWS API Documentation
    #
    class TransitGatewayPeeringAttachment < Struct.new(
      :transit_gateway_attachment_id,
      :requester_tgw_info,
      :accepter_tgw_info,
      :status,
      :state,
      :creation_time,
      :tags)
      include Aws::Structure
    end

    # Describes route propagation.
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] resource_id
    #   The ID of the resource.
    #   @return [String]
    #
    # @!attribute [rw] resource_type
    #   The resource type.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the transit gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayPropagation AWS API Documentation
    #
    class TransitGatewayPropagation < Struct.new(
      :transit_gateway_attachment_id,
      :resource_id,
      :resource_type,
      :transit_gateway_route_table_id,
      :state)
      include Aws::Structure
    end

    # Describes the options for a transit gateway.
    #
    # @note When making an API call, you may pass TransitGatewayRequestOptions
    #   data as a hash:
    #
    #       {
    #         amazon_side_asn: 1,
    #         auto_accept_shared_attachments: "enable", # accepts enable, disable
    #         default_route_table_association: "enable", # accepts enable, disable
    #         default_route_table_propagation: "enable", # accepts enable, disable
    #         vpn_ecmp_support: "enable", # accepts enable, disable
    #         dns_support: "enable", # accepts enable, disable
    #         multicast_support: "enable", # accepts enable, disable
    #       }
    #
    # @!attribute [rw] amazon_side_asn
    #   A private Autonomous System Number (ASN) for the Amazon side of a
    #   BGP session. The range is 64512 to 65534 for 16-bit ASNs and
    #   4200000000 to 4294967294 for 32-bit ASNs.
    #   @return [Integer]
    #
    # @!attribute [rw] auto_accept_shared_attachments
    #   Enable or disable automatic acceptance of attachment requests. The
    #   default is `disable`.
    #   @return [String]
    #
    # @!attribute [rw] default_route_table_association
    #   Enable or disable automatic association with the default association
    #   route table. The default is `enable`.
    #   @return [String]
    #
    # @!attribute [rw] default_route_table_propagation
    #   Enable or disable automatic propagation of routes to the default
    #   propagation route table. The default is `enable`.
    #   @return [String]
    #
    # @!attribute [rw] vpn_ecmp_support
    #   Enable or disable Equal Cost Multipath Protocol support.
    #   @return [String]
    #
    # @!attribute [rw] dns_support
    #   Enable or disable DNS support.
    #   @return [String]
    #
    # @!attribute [rw] multicast_support
    #   Indicates whether multicast is enabled on the transit gateway
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayRequestOptions AWS API Documentation
    #
    class TransitGatewayRequestOptions < Struct.new(
      :amazon_side_asn,
      :auto_accept_shared_attachments,
      :default_route_table_association,
      :default_route_table_propagation,
      :vpn_ecmp_support,
      :dns_support,
      :multicast_support)
      include Aws::Structure
    end

    # Describes a route for a transit gateway route table.
    #
    # @!attribute [rw] destination_cidr_block
    #   The CIDR block used for destination matches.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_attachments
    #   The attachments.
    #   @return [Array<Types::TransitGatewayRouteAttachment>]
    #
    # @!attribute [rw] type
    #   The route type.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the route.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayRoute AWS API Documentation
    #
    class TransitGatewayRoute < Struct.new(
      :destination_cidr_block,
      :transit_gateway_attachments,
      :type,
      :state)
      include Aws::Structure
    end

    # Describes a route attachment.
    #
    # @!attribute [rw] resource_id
    #   The ID of the resource.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] resource_type
    #   The resource type.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayRouteAttachment AWS API Documentation
    #
    class TransitGatewayRouteAttachment < Struct.new(
      :resource_id,
      :transit_gateway_attachment_id,
      :resource_type)
      include Aws::Structure
    end

    # Describes a transit gateway route table.
    #
    # @!attribute [rw] transit_gateway_route_table_id
    #   The ID of the transit gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the transit gateway route table.
    #   @return [String]
    #
    # @!attribute [rw] default_association_route_table
    #   Indicates whether this is the default association route table for
    #   the transit gateway.
    #   @return [Boolean]
    #
    # @!attribute [rw] default_propagation_route_table
    #   Indicates whether this is the default propagation route table for
    #   the transit gateway.
    #   @return [Boolean]
    #
    # @!attribute [rw] creation_time
    #   The creation time.
    #   @return [Time]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the route table.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayRouteTable AWS API Documentation
    #
    class TransitGatewayRouteTable < Struct.new(
      :transit_gateway_route_table_id,
      :transit_gateway_id,
      :state,
      :default_association_route_table,
      :default_propagation_route_table,
      :creation_time,
      :tags)
      include Aws::Structure
    end

    # Describes an association between a route table and a resource
    # attachment.
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] resource_id
    #   The ID of the resource.
    #   @return [String]
    #
    # @!attribute [rw] resource_type
    #   The resource type.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the association.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayRouteTableAssociation AWS API Documentation
    #
    class TransitGatewayRouteTableAssociation < Struct.new(
      :transit_gateway_attachment_id,
      :resource_id,
      :resource_type,
      :state)
      include Aws::Structure
    end

    # Describes a route table propagation.
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] resource_id
    #   The ID of the resource.
    #   @return [String]
    #
    # @!attribute [rw] resource_type
    #   The type of resource.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the resource.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayRouteTablePropagation AWS API Documentation
    #
    class TransitGatewayRouteTablePropagation < Struct.new(
      :transit_gateway_attachment_id,
      :resource_id,
      :resource_type,
      :state)
      include Aws::Structure
    end

    # Describes a VPC attachment.
    #
    # @!attribute [rw] transit_gateway_attachment_id
    #   The ID of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of the transit gateway.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] vpc_owner_id
    #   The ID of the AWS account that owns the VPC.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the VPC attachment.
    #   @return [String]
    #
    # @!attribute [rw] subnet_ids
    #   The IDs of the subnets.
    #   @return [Array<String>]
    #
    # @!attribute [rw] creation_time
    #   The creation time.
    #   @return [Time]
    #
    # @!attribute [rw] options
    #   The VPC attachment options.
    #   @return [Types::TransitGatewayVpcAttachmentOptions]
    #
    # @!attribute [rw] tags
    #   The tags for the VPC attachment.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayVpcAttachment AWS API Documentation
    #
    class TransitGatewayVpcAttachment < Struct.new(
      :transit_gateway_attachment_id,
      :transit_gateway_id,
      :vpc_id,
      :vpc_owner_id,
      :state,
      :subnet_ids,
      :creation_time,
      :options,
      :tags)
      include Aws::Structure
    end

    # Describes the VPC attachment options.
    #
    # @!attribute [rw] dns_support
    #   Indicates whether DNS support is enabled.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_support
    #   Indicates whether IPv6 support is disabled.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TransitGatewayVpcAttachmentOptions AWS API Documentation
    #
    class TransitGatewayVpcAttachmentOptions < Struct.new(
      :dns_support,
      :ipv_6_support)
      include Aws::Structure
    end

    # The VPN tunnel options.
    #
    # @!attribute [rw] outside_ip_address
    #   The external IP address of the VPN tunnel.
    #   @return [String]
    #
    # @!attribute [rw] tunnel_inside_cidr
    #   The range of inside IP addresses for the tunnel.
    #   @return [String]
    #
    # @!attribute [rw] pre_shared_key
    #   The pre-shared key (PSK) to establish initial authentication between
    #   the virtual private gateway and the customer gateway.
    #   @return [String]
    #
    # @!attribute [rw] phase_1_lifetime_seconds
    #   The lifetime for phase 1 of the IKE negotiation, in seconds.
    #   @return [Integer]
    #
    # @!attribute [rw] phase_2_lifetime_seconds
    #   The lifetime for phase 2 of the IKE negotiation, in seconds.
    #   @return [Integer]
    #
    # @!attribute [rw] rekey_margin_time_seconds
    #   The margin time, in seconds, before the phase 2 lifetime expires,
    #   during which the AWS side of the VPN connection performs an IKE
    #   rekey.
    #   @return [Integer]
    #
    # @!attribute [rw] rekey_fuzz_percentage
    #   The percentage of the rekey window determined by
    #   `RekeyMarginTimeSeconds` during which the rekey time is randomly
    #   selected.
    #   @return [Integer]
    #
    # @!attribute [rw] replay_window_size
    #   The number of packets in an IKE replay window.
    #   @return [Integer]
    #
    # @!attribute [rw] dpd_timeout_seconds
    #   The number of seconds after which a DPD timeout occurs.
    #   @return [Integer]
    #
    # @!attribute [rw] phase_1_encryption_algorithms
    #   The permitted encryption algorithms for the VPN tunnel for phase 1
    #   IKE negotiations.
    #   @return [Array<Types::Phase1EncryptionAlgorithmsListValue>]
    #
    # @!attribute [rw] phase_2_encryption_algorithms
    #   The permitted encryption algorithms for the VPN tunnel for phase 2
    #   IKE negotiations.
    #   @return [Array<Types::Phase2EncryptionAlgorithmsListValue>]
    #
    # @!attribute [rw] phase_1_integrity_algorithms
    #   The permitted integrity algorithms for the VPN tunnel for phase 1
    #   IKE negotiations.
    #   @return [Array<Types::Phase1IntegrityAlgorithmsListValue>]
    #
    # @!attribute [rw] phase_2_integrity_algorithms
    #   The permitted integrity algorithms for the VPN tunnel for phase 2
    #   IKE negotiations.
    #   @return [Array<Types::Phase2IntegrityAlgorithmsListValue>]
    #
    # @!attribute [rw] phase_1_dh_group_numbers
    #   The permitted Diffie-Hellman group numbers for the VPN tunnel for
    #   phase 1 IKE negotiations.
    #   @return [Array<Types::Phase1DHGroupNumbersListValue>]
    #
    # @!attribute [rw] phase_2_dh_group_numbers
    #   The permitted Diffie-Hellman group numbers for the VPN tunnel for
    #   phase 2 IKE negotiations.
    #   @return [Array<Types::Phase2DHGroupNumbersListValue>]
    #
    # @!attribute [rw] ike_versions
    #   The IKE versions that are permitted for the VPN tunnel.
    #   @return [Array<Types::IKEVersionsListValue>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/TunnelOption AWS API Documentation
    #
    class TunnelOption < Struct.new(
      :outside_ip_address,
      :tunnel_inside_cidr,
      :pre_shared_key,
      :phase_1_lifetime_seconds,
      :phase_2_lifetime_seconds,
      :rekey_margin_time_seconds,
      :rekey_fuzz_percentage,
      :replay_window_size,
      :dpd_timeout_seconds,
      :phase_1_encryption_algorithms,
      :phase_2_encryption_algorithms,
      :phase_1_integrity_algorithms,
      :phase_2_integrity_algorithms,
      :phase_1_dh_group_numbers,
      :phase_2_dh_group_numbers,
      :ike_versions)
      include Aws::Structure
    end

    # @note When making an API call, you may pass UnassignIpv6AddressesRequest
    #   data as a hash:
    #
    #       {
    #         ipv_6_addresses: ["String"], # required
    #         network_interface_id: "NetworkInterfaceId", # required
    #       }
    #
    # @!attribute [rw] ipv_6_addresses
    #   The IPv6 addresses to unassign from the network interface.
    #   @return [Array<String>]
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UnassignIpv6AddressesRequest AWS API Documentation
    #
    class UnassignIpv6AddressesRequest < Struct.new(
      :ipv_6_addresses,
      :network_interface_id)
      include Aws::Structure
    end

    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] unassigned_ipv_6_addresses
    #   The IPv6 addresses that have been unassigned from the network
    #   interface.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UnassignIpv6AddressesResult AWS API Documentation
    #
    class UnassignIpv6AddressesResult < Struct.new(
      :network_interface_id,
      :unassigned_ipv_6_addresses)
      include Aws::Structure
    end

    # Contains the parameters for UnassignPrivateIpAddresses.
    #
    # @note When making an API call, you may pass UnassignPrivateIpAddressesRequest
    #   data as a hash:
    #
    #       {
    #         network_interface_id: "NetworkInterfaceId", # required
    #         private_ip_addresses: ["String"], # required
    #       }
    #
    # @!attribute [rw] network_interface_id
    #   The ID of the network interface.
    #   @return [String]
    #
    # @!attribute [rw] private_ip_addresses
    #   The secondary private IP addresses to unassign from the network
    #   interface. You can specify this option multiple times to unassign
    #   more than one IP address.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UnassignPrivateIpAddressesRequest AWS API Documentation
    #
    class UnassignPrivateIpAddressesRequest < Struct.new(
      :network_interface_id,
      :private_ip_addresses)
      include Aws::Structure
    end

    # @note When making an API call, you may pass UnmonitorInstancesRequest
    #   data as a hash:
    #
    #       {
    #         instance_ids: ["InstanceId"], # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] instance_ids
    #   The IDs of the instances.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UnmonitorInstancesRequest AWS API Documentation
    #
    class UnmonitorInstancesRequest < Struct.new(
      :instance_ids,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] instance_monitorings
    #   The monitoring information.
    #   @return [Array<Types::InstanceMonitoring>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UnmonitorInstancesResult AWS API Documentation
    #
    class UnmonitorInstancesResult < Struct.new(
      :instance_monitorings)
      include Aws::Structure
    end

    # Describes the burstable performance instance whose credit option for
    # CPU usage was not modified.
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] error
    #   The applicable error for the burstable performance instance whose
    #   credit option for CPU usage was not modified.
    #   @return [Types::UnsuccessfulInstanceCreditSpecificationItemError]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UnsuccessfulInstanceCreditSpecificationItem AWS API Documentation
    #
    class UnsuccessfulInstanceCreditSpecificationItem < Struct.new(
      :instance_id,
      :error)
      include Aws::Structure
    end

    # Information about the error for the burstable performance instance
    # whose credit option for CPU usage was not modified.
    #
    # @!attribute [rw] code
    #   The error code.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   The applicable error message.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UnsuccessfulInstanceCreditSpecificationItemError AWS API Documentation
    #
    class UnsuccessfulInstanceCreditSpecificationItemError < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # Information about items that were not successfully processed in a
    # batch call.
    #
    # @!attribute [rw] error
    #   Information about the error.
    #   @return [Types::UnsuccessfulItemError]
    #
    # @!attribute [rw] resource_id
    #   The ID of the resource.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UnsuccessfulItem AWS API Documentation
    #
    class UnsuccessfulItem < Struct.new(
      :error,
      :resource_id)
      include Aws::Structure
    end

    # Information about the error that occurred. For more information about
    # errors, see [Error Codes][1].
    #
    #
    #
    # [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html
    #
    # @!attribute [rw] code
    #   The error code.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   The error message accompanying the error code.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UnsuccessfulItemError AWS API Documentation
    #
    class UnsuccessfulItemError < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # @note When making an API call, you may pass UpdateSecurityGroupRuleDescriptionsEgressRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         group_id: "SecurityGroupId",
    #         group_name: "SecurityGroupName",
    #         ip_permissions: [ # required
    #           {
    #             from_port: 1,
    #             ip_protocol: "String",
    #             ip_ranges: [
    #               {
    #                 cidr_ip: "String",
    #                 description: "String",
    #               },
    #             ],
    #             ipv_6_ranges: [
    #               {
    #                 cidr_ipv_6: "String",
    #                 description: "String",
    #               },
    #             ],
    #             prefix_list_ids: [
    #               {
    #                 description: "String",
    #                 prefix_list_id: "String",
    #               },
    #             ],
    #             to_port: 1,
    #             user_id_group_pairs: [
    #               {
    #                 description: "String",
    #                 group_id: "String",
    #                 group_name: "String",
    #                 peering_status: "String",
    #                 user_id: "String",
    #                 vpc_id: "String",
    #                 vpc_peering_connection_id: "String",
    #               },
    #             ],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] group_id
    #   The ID of the security group. You must specify either the security
    #   group ID or the security group name in the request. For security
    #   groups in a nondefault VPC, you must specify the security group ID.
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   \[Default VPC\] The name of the security group. You must specify
    #   either the security group ID or the security group name in the
    #   request.
    #   @return [String]
    #
    # @!attribute [rw] ip_permissions
    #   The IP permissions for the security group rule.
    #   @return [Array<Types::IpPermission>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UpdateSecurityGroupRuleDescriptionsEgressRequest AWS API Documentation
    #
    class UpdateSecurityGroupRuleDescriptionsEgressRequest < Struct.new(
      :dry_run,
      :group_id,
      :group_name,
      :ip_permissions)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, returns an error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UpdateSecurityGroupRuleDescriptionsEgressResult AWS API Documentation
    #
    class UpdateSecurityGroupRuleDescriptionsEgressResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # @note When making an API call, you may pass UpdateSecurityGroupRuleDescriptionsIngressRequest
    #   data as a hash:
    #
    #       {
    #         dry_run: false,
    #         group_id: "SecurityGroupId",
    #         group_name: "SecurityGroupName",
    #         ip_permissions: [ # required
    #           {
    #             from_port: 1,
    #             ip_protocol: "String",
    #             ip_ranges: [
    #               {
    #                 cidr_ip: "String",
    #                 description: "String",
    #               },
    #             ],
    #             ipv_6_ranges: [
    #               {
    #                 cidr_ipv_6: "String",
    #                 description: "String",
    #               },
    #             ],
    #             prefix_list_ids: [
    #               {
    #                 description: "String",
    #                 prefix_list_id: "String",
    #               },
    #             ],
    #             to_port: 1,
    #             user_id_group_pairs: [
    #               {
    #                 description: "String",
    #                 group_id: "String",
    #                 group_name: "String",
    #                 peering_status: "String",
    #                 user_id: "String",
    #                 vpc_id: "String",
    #                 vpc_peering_connection_id: "String",
    #               },
    #             ],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @!attribute [rw] group_id
    #   The ID of the security group. You must specify either the security
    #   group ID or the security group name in the request. For security
    #   groups in a nondefault VPC, you must specify the security group ID.
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   \[EC2-Classic, default VPC\] The name of the security group. You
    #   must specify either the security group ID or the security group name
    #   in the request.
    #   @return [String]
    #
    # @!attribute [rw] ip_permissions
    #   The IP permissions for the security group rule.
    #   @return [Array<Types::IpPermission>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UpdateSecurityGroupRuleDescriptionsIngressRequest AWS API Documentation
    #
    class UpdateSecurityGroupRuleDescriptionsIngressRequest < Struct.new(
      :dry_run,
      :group_id,
      :group_name,
      :ip_permissions)
      include Aws::Structure
    end

    # @!attribute [rw] return
    #   Returns `true` if the request succeeds; otherwise, returns an error.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UpdateSecurityGroupRuleDescriptionsIngressResult AWS API Documentation
    #
    class UpdateSecurityGroupRuleDescriptionsIngressResult < Struct.new(
      :return)
      include Aws::Structure
    end

    # Describes the S3 bucket for the disk image.
    #
    # @note When making an API call, you may pass UserBucket
    #   data as a hash:
    #
    #       {
    #         s3_bucket: "String",
    #         s3_key: "String",
    #       }
    #
    # @!attribute [rw] s3_bucket
    #   The name of the S3 bucket where the disk image is located.
    #   @return [String]
    #
    # @!attribute [rw] s3_key
    #   The file name of the disk image.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UserBucket AWS API Documentation
    #
    class UserBucket < Struct.new(
      :s3_bucket,
      :s3_key)
      include Aws::Structure
    end

    # Describes the S3 bucket for the disk image.
    #
    # @!attribute [rw] s3_bucket
    #   The S3 bucket from which the disk image was created.
    #   @return [String]
    #
    # @!attribute [rw] s3_key
    #   The file name of the disk image.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UserBucketDetails AWS API Documentation
    #
    class UserBucketDetails < Struct.new(
      :s3_bucket,
      :s3_key)
      include Aws::Structure
    end

    # Describes the user data for an instance.
    #
    # @note When making an API call, you may pass UserData
    #   data as a hash:
    #
    #       {
    #         data: "String",
    #       }
    #
    # @!attribute [rw] data
    #   The user data. If you are using an AWS SDK or command line tool,
    #   Base64-encoding is performed for you, and you can load the text from
    #   a file. Otherwise, you must provide Base64-encoded text.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UserData AWS API Documentation
    #
    class UserData < Struct.new(
      :data)
      include Aws::Structure
    end

    # Describes a security group and AWS account ID pair.
    #
    # @note When making an API call, you may pass UserIdGroupPair
    #   data as a hash:
    #
    #       {
    #         description: "String",
    #         group_id: "String",
    #         group_name: "String",
    #         peering_status: "String",
    #         user_id: "String",
    #         vpc_id: "String",
    #         vpc_peering_connection_id: "String",
    #       }
    #
    # @!attribute [rw] description
    #   A description for the security group rule that references this user
    #   ID group pair.
    #
    #   Constraints: Up to 255 characters in length. Allowed characters are
    #   a-z, A-Z, 0-9, spaces, and .\_-:/()#,@\[\]+=;\\\{\\}!$*
    #   @return [String]
    #
    # @!attribute [rw] group_id
    #   The ID of the security group.
    #   @return [String]
    #
    # @!attribute [rw] group_name
    #   The name of the security group. In a request, use this parameter for
    #   a security group in EC2-Classic or a default VPC only. For a
    #   security group in a nondefault VPC, use the security group ID.
    #
    #   For a referenced security group in another VPC, this value is not
    #   returned if the referenced security group is deleted.
    #   @return [String]
    #
    # @!attribute [rw] peering_status
    #   The status of a VPC peering connection, if applicable.
    #   @return [String]
    #
    # @!attribute [rw] user_id
    #   The ID of an AWS account.
    #
    #   For a referenced security group in another VPC, the account ID of
    #   the referenced security group is returned in the response. If the
    #   referenced security group is deleted, this value is not returned.
    #
    #   \[EC2-Classic\] Required when adding or removing rules that
    #   reference a security group in another AWS account.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC for the referenced security group, if applicable.
    #   @return [String]
    #
    # @!attribute [rw] vpc_peering_connection_id
    #   The ID of the VPC peering connection, if applicable.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/UserIdGroupPair AWS API Documentation
    #
    class UserIdGroupPair < Struct.new(
      :description,
      :group_id,
      :group_name,
      :peering_status,
      :user_id,
      :vpc_id,
      :vpc_peering_connection_id)
      include Aws::Structure
    end

    # Describes the vCPU configurations for the instance type.
    #
    # @!attribute [rw] default_v_cpus
    #   The default number of vCPUs for the instance type.
    #   @return [Integer]
    #
    # @!attribute [rw] default_cores
    #   The default number of cores for the instance type.
    #   @return [Integer]
    #
    # @!attribute [rw] default_threads_per_core
    #   The default number of threads per core for the instance type.
    #   @return [Integer]
    #
    # @!attribute [rw] valid_cores
    #   List of the valid number of cores that can be configured for the
    #   instance type.
    #   @return [Array<Integer>]
    #
    # @!attribute [rw] valid_threads_per_core
    #   List of the valid number of threads per core that can be configured
    #   for the instance type.
    #   @return [Array<Integer>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VCpuInfo AWS API Documentation
    #
    class VCpuInfo < Struct.new(
      :default_v_cpus,
      :default_cores,
      :default_threads_per_core,
      :valid_cores,
      :valid_threads_per_core)
      include Aws::Structure
    end

    # The error code and error message that is returned for a parameter or
    # parameter combination that is not valid when a new launch template or
    # new version of a launch template is created.
    #
    # @!attribute [rw] code
    #   The error code that indicates why the parameter or parameter
    #   combination is not valid. For more information about error codes,
    #   see [Error Codes][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html
    #   @return [String]
    #
    # @!attribute [rw] message
    #   The error message that describes why the parameter or parameter
    #   combination is not valid. For more information about error messages,
    #   see [Error Codes][1].
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html.html
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ValidationError AWS API Documentation
    #
    class ValidationError < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # The error codes and error messages that are returned for the
    # parameters or parameter combinations that are not valid when a new
    # launch template or new version of a launch template is created.
    #
    # @!attribute [rw] errors
    #   The error codes and error messages.
    #   @return [Array<Types::ValidationError>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/ValidationWarning AWS API Documentation
    #
    class ValidationWarning < Struct.new(
      :errors)
      include Aws::Structure
    end

    # Describes telemetry for a VPN tunnel.
    #
    # @!attribute [rw] accepted_route_count
    #   The number of accepted routes.
    #   @return [Integer]
    #
    # @!attribute [rw] last_status_change
    #   The date and time of the last change in status.
    #   @return [Time]
    #
    # @!attribute [rw] outside_ip_address
    #   The Internet-routable IP address of the virtual private gateway's
    #   outside interface.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The status of the VPN tunnel.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   If an error occurs, a description of the error.
    #   @return [String]
    #
    # @!attribute [rw] certificate_arn
    #   The Amazon Resource Name (ARN) of the VPN tunnel endpoint
    #   certificate.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VgwTelemetry AWS API Documentation
    #
    class VgwTelemetry < Struct.new(
      :accepted_route_count,
      :last_status_change,
      :outside_ip_address,
      :status,
      :status_message,
      :certificate_arn)
      include Aws::Structure
    end

    # Describes a volume.
    #
    # @!attribute [rw] attachments
    #   Information about the volume attachments.
    #   @return [Array<Types::VolumeAttachment>]
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone for the volume.
    #   @return [String]
    #
    # @!attribute [rw] create_time
    #   The time stamp when volume creation was initiated.
    #   @return [Time]
    #
    # @!attribute [rw] encrypted
    #   Indicates whether the volume is encrypted.
    #   @return [Boolean]
    #
    # @!attribute [rw] kms_key_id
    #   The Amazon Resource Name (ARN) of the AWS Key Management Service
    #   (AWS KMS) customer master key (CMK) that was used to protect the
    #   volume encryption key for the volume.
    #   @return [String]
    #
    # @!attribute [rw] outpost_arn
    #   The Amazon Resource Name (ARN) of the Outpost.
    #   @return [String]
    #
    # @!attribute [rw] size
    #   The size of the volume, in GiBs.
    #   @return [Integer]
    #
    # @!attribute [rw] snapshot_id
    #   The snapshot from which the volume was created, if applicable.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The volume state.
    #   @return [String]
    #
    # @!attribute [rw] volume_id
    #   The ID of the volume.
    #   @return [String]
    #
    # @!attribute [rw] iops
    #   The number of I/O operations per second (IOPS) that the volume
    #   supports. For Provisioned IOPS SSD volumes, this represents the
    #   number of IOPS that are provisioned for the volume. For General
    #   Purpose SSD volumes, this represents the baseline performance of the
    #   volume and the rate at which the volume accumulates I/O credits for
    #   bursting. For more information, see [Amazon EBS Volume Types][1] in
    #   the *Amazon Elastic Compute Cloud User Guide*.
    #
    #   Constraints: Range is 100-16,000 IOPS for `gp2` volumes and 100 to
    #   64,000IOPS for `io1` volumes, in most Regions. The maximum IOPS for
    #   `io1` of 64,000 is guaranteed only on [Nitro-based instances][2].
    #   Other instance families guarantee performance up to 32,000 IOPS.
    #
    #   Condition: This parameter is required for requests to create `io1`
    #   volumes; it is not used in requests to create `gp2`, `st1`, `sc1`,
    #   or `standard` volumes.
    #
    #
    #
    #   [1]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html
    #   [2]: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances
    #   @return [Integer]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the volume.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] volume_type
    #   The volume type. This can be `gp2` for General Purpose SSD, `io1`
    #   for Provisioned IOPS SSD, `st1` for Throughput Optimized HDD, `sc1`
    #   for Cold HDD, or `standard` for Magnetic volumes.
    #   @return [String]
    #
    # @!attribute [rw] fast_restored
    #   Indicates whether the volume was created using fast snapshot
    #   restore.
    #   @return [Boolean]
    #
    # @!attribute [rw] multi_attach_enabled
    #   Indicates whether Amazon EBS Multi-Attach is enabled.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Volume AWS API Documentation
    #
    class Volume < Struct.new(
      :attachments,
      :availability_zone,
      :create_time,
      :encrypted,
      :kms_key_id,
      :outpost_arn,
      :size,
      :snapshot_id,
      :state,
      :volume_id,
      :iops,
      :tags,
      :volume_type,
      :fast_restored,
      :multi_attach_enabled)
      include Aws::Structure
    end

    # Describes volume attachment details.
    #
    # @!attribute [rw] attach_time
    #   The time stamp when the attachment initiated.
    #   @return [Time]
    #
    # @!attribute [rw] device
    #   The device name.
    #   @return [String]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The attachment state of the volume.
    #   @return [String]
    #
    # @!attribute [rw] volume_id
    #   The ID of the volume.
    #   @return [String]
    #
    # @!attribute [rw] delete_on_termination
    #   Indicates whether the EBS volume is deleted on instance termination.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VolumeAttachment AWS API Documentation
    #
    class VolumeAttachment < Struct.new(
      :attach_time,
      :device,
      :instance_id,
      :state,
      :volume_id,
      :delete_on_termination)
      include Aws::Structure
    end

    # Describes an EBS volume.
    #
    # @note When making an API call, you may pass VolumeDetail
    #   data as a hash:
    #
    #       {
    #         size: 1, # required
    #       }
    #
    # @!attribute [rw] size
    #   The size of the volume, in GiB.
    #   @return [Integer]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VolumeDetail AWS API Documentation
    #
    class VolumeDetail < Struct.new(
      :size)
      include Aws::Structure
    end

    # Describes the modification status of an EBS volume.
    #
    # If the volume has never been modified, some element values will be
    # null.
    #
    # @!attribute [rw] volume_id
    #   The ID of the volume.
    #   @return [String]
    #
    # @!attribute [rw] modification_state
    #   The current modification state. The modification state is null for
    #   unmodified volumes.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   A status message about the modification progress or failure.
    #   @return [String]
    #
    # @!attribute [rw] target_size
    #   The target size of the volume, in GiB.
    #   @return [Integer]
    #
    # @!attribute [rw] target_iops
    #   The target IOPS rate of the volume.
    #   @return [Integer]
    #
    # @!attribute [rw] target_volume_type
    #   The target EBS volume type of the volume.
    #   @return [String]
    #
    # @!attribute [rw] original_size
    #   The original size of the volume.
    #   @return [Integer]
    #
    # @!attribute [rw] original_iops
    #   The original IOPS rate of the volume.
    #   @return [Integer]
    #
    # @!attribute [rw] original_volume_type
    #   The original EBS volume type of the volume.
    #   @return [String]
    #
    # @!attribute [rw] progress
    #   The modification progress, from 0 to 100 percent complete.
    #   @return [Integer]
    #
    # @!attribute [rw] start_time
    #   The modification start time.
    #   @return [Time]
    #
    # @!attribute [rw] end_time
    #   The modification completion or failure time.
    #   @return [Time]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VolumeModification AWS API Documentation
    #
    class VolumeModification < Struct.new(
      :volume_id,
      :modification_state,
      :status_message,
      :target_size,
      :target_iops,
      :target_volume_type,
      :original_size,
      :original_iops,
      :original_volume_type,
      :progress,
      :start_time,
      :end_time)
      include Aws::Structure
    end

    # Describes a volume status operation code.
    #
    # @!attribute [rw] code
    #   The code identifying the operation, for example, `enable-volume-io`.
    #   @return [String]
    #
    # @!attribute [rw] description
    #   A description of the operation.
    #   @return [String]
    #
    # @!attribute [rw] event_id
    #   The ID of the event associated with this operation.
    #   @return [String]
    #
    # @!attribute [rw] event_type
    #   The event type associated with this operation.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VolumeStatusAction AWS API Documentation
    #
    class VolumeStatusAction < Struct.new(
      :code,
      :description,
      :event_id,
      :event_type)
      include Aws::Structure
    end

    # Information about the instances to which the volume is attached.
    #
    # @!attribute [rw] io_performance
    #   The maximum IOPS supported by the attached instance.
    #   @return [String]
    #
    # @!attribute [rw] instance_id
    #   The ID of the attached instance.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VolumeStatusAttachmentStatus AWS API Documentation
    #
    class VolumeStatusAttachmentStatus < Struct.new(
      :io_performance,
      :instance_id)
      include Aws::Structure
    end

    # Describes a volume status.
    #
    # @!attribute [rw] name
    #   The name of the volume status.
    #   @return [String]
    #
    # @!attribute [rw] status
    #   The intended status of the volume status.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VolumeStatusDetails AWS API Documentation
    #
    class VolumeStatusDetails < Struct.new(
      :name,
      :status)
      include Aws::Structure
    end

    # Describes a volume status event.
    #
    # @!attribute [rw] description
    #   A description of the event.
    #   @return [String]
    #
    # @!attribute [rw] event_id
    #   The ID of this event.
    #   @return [String]
    #
    # @!attribute [rw] event_type
    #   The type of this event.
    #   @return [String]
    #
    # @!attribute [rw] not_after
    #   The latest end time of the event.
    #   @return [Time]
    #
    # @!attribute [rw] not_before
    #   The earliest start time of the event.
    #   @return [Time]
    #
    # @!attribute [rw] instance_id
    #   The ID of the instance associated with the event.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VolumeStatusEvent AWS API Documentation
    #
    class VolumeStatusEvent < Struct.new(
      :description,
      :event_id,
      :event_type,
      :not_after,
      :not_before,
      :instance_id)
      include Aws::Structure
    end

    # Describes the status of a volume.
    #
    # @!attribute [rw] details
    #   The details of the volume status.
    #   @return [Array<Types::VolumeStatusDetails>]
    #
    # @!attribute [rw] status
    #   The status of the volume.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VolumeStatusInfo AWS API Documentation
    #
    class VolumeStatusInfo < Struct.new(
      :details,
      :status)
      include Aws::Structure
    end

    # Describes the volume status.
    #
    # @!attribute [rw] actions
    #   The details of the operation.
    #   @return [Array<Types::VolumeStatusAction>]
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone of the volume.
    #   @return [String]
    #
    # @!attribute [rw] outpost_arn
    #   The Amazon Resource Name (ARN) of the Outpost.
    #   @return [String]
    #
    # @!attribute [rw] events
    #   A list of events associated with the volume.
    #   @return [Array<Types::VolumeStatusEvent>]
    #
    # @!attribute [rw] volume_id
    #   The volume ID.
    #   @return [String]
    #
    # @!attribute [rw] volume_status
    #   The volume status.
    #   @return [Types::VolumeStatusInfo]
    #
    # @!attribute [rw] attachment_statuses
    #   Information about the instances to which the volume is attached.
    #   @return [Array<Types::VolumeStatusAttachmentStatus>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VolumeStatusItem AWS API Documentation
    #
    class VolumeStatusItem < Struct.new(
      :actions,
      :availability_zone,
      :outpost_arn,
      :events,
      :volume_id,
      :volume_status,
      :attachment_statuses)
      include Aws::Structure
    end

    # Describes a VPC.
    #
    # @!attribute [rw] cidr_block
    #   The primary IPv4 CIDR block for the VPC.
    #   @return [String]
    #
    # @!attribute [rw] dhcp_options_id
    #   The ID of the set of DHCP options you've associated with the VPC
    #   (or `default` if the default options are associated with the VPC).
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The current state of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account that owns the VPC.
    #   @return [String]
    #
    # @!attribute [rw] instance_tenancy
    #   The allowed tenancy of instances launched into the VPC.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_cidr_block_association_set
    #   Information about the IPv6 CIDR blocks associated with the VPC.
    #   @return [Array<Types::VpcIpv6CidrBlockAssociation>]
    #
    # @!attribute [rw] cidr_block_association_set
    #   Information about the IPv4 CIDR blocks associated with the VPC.
    #   @return [Array<Types::VpcCidrBlockAssociation>]
    #
    # @!attribute [rw] is_default
    #   Indicates whether the VPC is the default VPC.
    #   @return [Boolean]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the VPC.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/Vpc AWS API Documentation
    #
    class Vpc < Struct.new(
      :cidr_block,
      :dhcp_options_id,
      :state,
      :vpc_id,
      :owner_id,
      :instance_tenancy,
      :ipv_6_cidr_block_association_set,
      :cidr_block_association_set,
      :is_default,
      :tags)
      include Aws::Structure
    end

    # Describes an attachment between a virtual private gateway and a VPC.
    #
    # @!attribute [rw] state
    #   The current state of the attachment.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpcAttachment AWS API Documentation
    #
    class VpcAttachment < Struct.new(
      :state,
      :vpc_id)
      include Aws::Structure
    end

    # Describes an IPv4 CIDR block associated with a VPC.
    #
    # @!attribute [rw] association_id
    #   The association ID for the IPv4 CIDR block.
    #   @return [String]
    #
    # @!attribute [rw] cidr_block
    #   The IPv4 CIDR block.
    #   @return [String]
    #
    # @!attribute [rw] cidr_block_state
    #   Information about the state of the CIDR block.
    #   @return [Types::VpcCidrBlockState]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpcCidrBlockAssociation AWS API Documentation
    #
    class VpcCidrBlockAssociation < Struct.new(
      :association_id,
      :cidr_block,
      :cidr_block_state)
      include Aws::Structure
    end

    # Describes the state of a CIDR block.
    #
    # @!attribute [rw] state
    #   The state of the CIDR block.
    #   @return [String]
    #
    # @!attribute [rw] status_message
    #   A message about the status of the CIDR block, if applicable.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpcCidrBlockState AWS API Documentation
    #
    class VpcCidrBlockState < Struct.new(
      :state,
      :status_message)
      include Aws::Structure
    end

    # Describes whether a VPC is enabled for ClassicLink.
    #
    # @!attribute [rw] classic_link_enabled
    #   Indicates whether the VPC is enabled for ClassicLink.
    #   @return [Boolean]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the VPC.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpcClassicLink AWS API Documentation
    #
    class VpcClassicLink < Struct.new(
      :classic_link_enabled,
      :tags,
      :vpc_id)
      include Aws::Structure
    end

    # Describes a VPC endpoint.
    #
    # @!attribute [rw] vpc_endpoint_id
    #   The ID of the VPC endpoint.
    #   @return [String]
    #
    # @!attribute [rw] vpc_endpoint_type
    #   The type of endpoint.
    #   @return [String]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC to which the endpoint is associated.
    #   @return [String]
    #
    # @!attribute [rw] service_name
    #   The name of the service to which the endpoint is associated.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The state of the VPC endpoint.
    #   @return [String]
    #
    # @!attribute [rw] policy_document
    #   The policy document associated with the endpoint, if applicable.
    #   @return [String]
    #
    # @!attribute [rw] route_table_ids
    #   (Gateway endpoint) One or more route tables associated with the
    #   endpoint.
    #   @return [Array<String>]
    #
    # @!attribute [rw] subnet_ids
    #   (Interface endpoint) One or more subnets in which the endpoint is
    #   located.
    #   @return [Array<String>]
    #
    # @!attribute [rw] groups
    #   (Interface endpoint) Information about the security groups that are
    #   associated with the network interface.
    #   @return [Array<Types::SecurityGroupIdentifier>]
    #
    # @!attribute [rw] private_dns_enabled
    #   (Interface endpoint) Indicates whether the VPC is associated with a
    #   private hosted zone.
    #   @return [Boolean]
    #
    # @!attribute [rw] requester_managed
    #   Indicates whether the VPC endpoint is being managed by its service.
    #   @return [Boolean]
    #
    # @!attribute [rw] network_interface_ids
    #   (Interface endpoint) One or more network interfaces for the
    #   endpoint.
    #   @return [Array<String>]
    #
    # @!attribute [rw] dns_entries
    #   (Interface endpoint) The DNS entries for the endpoint.
    #   @return [Array<Types::DnsEntry>]
    #
    # @!attribute [rw] creation_timestamp
    #   The date and time that the VPC endpoint was created.
    #   @return [Time]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the VPC endpoint.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] owner_id
    #   The ID of the AWS account that owns the VPC endpoint.
    #   @return [String]
    #
    # @!attribute [rw] last_error
    #   The last error that occurred for VPC endpoint.
    #   @return [Types::LastError]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpcEndpoint AWS API Documentation
    #
    class VpcEndpoint < Struct.new(
      :vpc_endpoint_id,
      :vpc_endpoint_type,
      :vpc_id,
      :service_name,
      :state,
      :policy_document,
      :route_table_ids,
      :subnet_ids,
      :groups,
      :private_dns_enabled,
      :requester_managed,
      :network_interface_ids,
      :dns_entries,
      :creation_timestamp,
      :tags,
      :owner_id,
      :last_error)
      include Aws::Structure
    end

    # Describes a VPC endpoint connection to a service.
    #
    # @!attribute [rw] service_id
    #   The ID of the service to which the endpoint is connected.
    #   @return [String]
    #
    # @!attribute [rw] vpc_endpoint_id
    #   The ID of the VPC endpoint.
    #   @return [String]
    #
    # @!attribute [rw] vpc_endpoint_owner
    #   The AWS account ID of the owner of the VPC endpoint.
    #   @return [String]
    #
    # @!attribute [rw] vpc_endpoint_state
    #   The state of the VPC endpoint.
    #   @return [String]
    #
    # @!attribute [rw] creation_timestamp
    #   The date and time that the VPC endpoint was created.
    #   @return [Time]
    #
    # @!attribute [rw] dns_entries
    #   The DNS entries for the VPC endpoint.
    #   @return [Array<Types::DnsEntry>]
    #
    # @!attribute [rw] network_load_balancer_arns
    #   The Amazon Resource Names (ARNs) of the network load balancers for
    #   the service.
    #   @return [Array<String>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpcEndpointConnection AWS API Documentation
    #
    class VpcEndpointConnection < Struct.new(
      :service_id,
      :vpc_endpoint_id,
      :vpc_endpoint_owner,
      :vpc_endpoint_state,
      :creation_timestamp,
      :dns_entries,
      :network_load_balancer_arns)
      include Aws::Structure
    end

    # Describes an IPv6 CIDR block associated with a VPC.
    #
    # @!attribute [rw] association_id
    #   The association ID for the IPv6 CIDR block.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_cidr_block
    #   The IPv6 CIDR block.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_cidr_block_state
    #   Information about the state of the CIDR block.
    #   @return [Types::VpcCidrBlockState]
    #
    # @!attribute [rw] network_border_group
    #   The name of the location from which we advertise the IPV6 CIDR
    #   block.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_pool
    #   The ID of the IPv6 address pool from which the IPv6 CIDR block is
    #   allocated.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpcIpv6CidrBlockAssociation AWS API Documentation
    #
    class VpcIpv6CidrBlockAssociation < Struct.new(
      :association_id,
      :ipv_6_cidr_block,
      :ipv_6_cidr_block_state,
      :network_border_group,
      :ipv_6_pool)
      include Aws::Structure
    end

    # Describes a VPC peering connection.
    #
    # @!attribute [rw] accepter_vpc_info
    #   Information about the accepter VPC. CIDR block information is only
    #   returned when describing an active VPC peering connection.
    #   @return [Types::VpcPeeringConnectionVpcInfo]
    #
    # @!attribute [rw] expiration_time
    #   The time that an unaccepted VPC peering connection will expire.
    #   @return [Time]
    #
    # @!attribute [rw] requester_vpc_info
    #   Information about the requester VPC. CIDR block information is only
    #   returned when describing an active VPC peering connection.
    #   @return [Types::VpcPeeringConnectionVpcInfo]
    #
    # @!attribute [rw] status
    #   The status of the VPC peering connection.
    #   @return [Types::VpcPeeringConnectionStateReason]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the resource.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] vpc_peering_connection_id
    #   The ID of the VPC peering connection.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpcPeeringConnection AWS API Documentation
    #
    class VpcPeeringConnection < Struct.new(
      :accepter_vpc_info,
      :expiration_time,
      :requester_vpc_info,
      :status,
      :tags,
      :vpc_peering_connection_id)
      include Aws::Structure
    end

    # Describes the VPC peering connection options.
    #
    # @!attribute [rw] allow_dns_resolution_from_remote_vpc
    #   Indicates whether a local VPC can resolve public DNS hostnames to
    #   private IP addresses when queried from instances in a peer VPC.
    #   @return [Boolean]
    #
    # @!attribute [rw] allow_egress_from_local_classic_link_to_remote_vpc
    #   Indicates whether a local ClassicLink connection can communicate
    #   with the peer VPC over the VPC peering connection.
    #   @return [Boolean]
    #
    # @!attribute [rw] allow_egress_from_local_vpc_to_remote_classic_link
    #   Indicates whether a local VPC can communicate with a ClassicLink
    #   connection in the peer VPC over the VPC peering connection.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpcPeeringConnectionOptionsDescription AWS API Documentation
    #
    class VpcPeeringConnectionOptionsDescription < Struct.new(
      :allow_dns_resolution_from_remote_vpc,
      :allow_egress_from_local_classic_link_to_remote_vpc,
      :allow_egress_from_local_vpc_to_remote_classic_link)
      include Aws::Structure
    end

    # Describes the status of a VPC peering connection.
    #
    # @!attribute [rw] code
    #   The status of the VPC peering connection.
    #   @return [String]
    #
    # @!attribute [rw] message
    #   A message that provides more information about the status, if
    #   applicable.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpcPeeringConnectionStateReason AWS API Documentation
    #
    class VpcPeeringConnectionStateReason < Struct.new(
      :code,
      :message)
      include Aws::Structure
    end

    # Describes a VPC in a VPC peering connection.
    #
    # @!attribute [rw] cidr_block
    #   The IPv4 CIDR block for the VPC.
    #   @return [String]
    #
    # @!attribute [rw] ipv_6_cidr_block_set
    #   The IPv6 CIDR block for the VPC.
    #   @return [Array<Types::Ipv6CidrBlock>]
    #
    # @!attribute [rw] cidr_block_set
    #   Information about the IPv4 CIDR blocks for the VPC.
    #   @return [Array<Types::CidrBlock>]
    #
    # @!attribute [rw] owner_id
    #   The AWS account ID of the VPC owner.
    #   @return [String]
    #
    # @!attribute [rw] peering_options
    #   Information about the VPC peering connection options for the
    #   accepter or requester VPC.
    #   @return [Types::VpcPeeringConnectionOptionsDescription]
    #
    # @!attribute [rw] vpc_id
    #   The ID of the VPC.
    #   @return [String]
    #
    # @!attribute [rw] region
    #   The Region in which the VPC is located.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpcPeeringConnectionVpcInfo AWS API Documentation
    #
    class VpcPeeringConnectionVpcInfo < Struct.new(
      :cidr_block,
      :ipv_6_cidr_block_set,
      :cidr_block_set,
      :owner_id,
      :peering_options,
      :vpc_id,
      :region)
      include Aws::Structure
    end

    # Describes a VPN connection.
    #
    # @!attribute [rw] customer_gateway_configuration
    #   The configuration information for the VPN connection's customer
    #   gateway (in the native XML format). This element is always present
    #   in the CreateVpnConnection response; however, it's present in the
    #   DescribeVpnConnections response only if the VPN connection is in the
    #   `pending` or `available` state.
    #   @return [String]
    #
    # @!attribute [rw] customer_gateway_id
    #   The ID of the customer gateway at your end of the VPN connection.
    #   @return [String]
    #
    # @!attribute [rw] category
    #   The category of the VPN connection. A value of `VPN` indicates an
    #   AWS VPN connection. A value of `VPN-Classic` indicates an AWS
    #   Classic VPN connection.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The current state of the VPN connection.
    #   @return [String]
    #
    # @!attribute [rw] type
    #   The type of VPN connection.
    #   @return [String]
    #
    # @!attribute [rw] vpn_connection_id
    #   The ID of the VPN connection.
    #   @return [String]
    #
    # @!attribute [rw] vpn_gateway_id
    #   The ID of the virtual private gateway at the AWS side of the VPN
    #   connection.
    #   @return [String]
    #
    # @!attribute [rw] transit_gateway_id
    #   The ID of the transit gateway associated with the VPN connection.
    #   @return [String]
    #
    # @!attribute [rw] options
    #   The VPN connection options.
    #   @return [Types::VpnConnectionOptions]
    #
    # @!attribute [rw] routes
    #   The static routes associated with the VPN connection.
    #   @return [Array<Types::VpnStaticRoute>]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the VPN connection.
    #   @return [Array<Types::Tag>]
    #
    # @!attribute [rw] vgw_telemetry
    #   Information about the VPN tunnel.
    #   @return [Array<Types::VgwTelemetry>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpnConnection AWS API Documentation
    #
    class VpnConnection < Struct.new(
      :customer_gateway_configuration,
      :customer_gateway_id,
      :category,
      :state,
      :type,
      :vpn_connection_id,
      :vpn_gateway_id,
      :transit_gateway_id,
      :options,
      :routes,
      :tags,
      :vgw_telemetry)
      include Aws::Structure
    end

    # Describes VPN connection options.
    #
    # @!attribute [rw] enable_acceleration
    #   Indicates whether acceleration is enabled for the VPN connection.
    #   @return [Boolean]
    #
    # @!attribute [rw] static_routes_only
    #   Indicates whether the VPN connection uses static routes only. Static
    #   routes must be used for devices that don't support BGP.
    #   @return [Boolean]
    #
    # @!attribute [rw] tunnel_options
    #   Indicates the VPN tunnel options.
    #   @return [Array<Types::TunnelOption>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpnConnectionOptions AWS API Documentation
    #
    class VpnConnectionOptions < Struct.new(
      :enable_acceleration,
      :static_routes_only,
      :tunnel_options)
      include Aws::Structure
    end

    # Describes VPN connection options.
    #
    # @note When making an API call, you may pass VpnConnectionOptionsSpecification
    #   data as a hash:
    #
    #       {
    #         enable_acceleration: false,
    #         static_routes_only: false,
    #         tunnel_options: [
    #           {
    #             tunnel_inside_cidr: "String",
    #             pre_shared_key: "String",
    #             phase_1_lifetime_seconds: 1,
    #             phase_2_lifetime_seconds: 1,
    #             rekey_margin_time_seconds: 1,
    #             rekey_fuzz_percentage: 1,
    #             replay_window_size: 1,
    #             dpd_timeout_seconds: 1,
    #             phase_1_encryption_algorithms: [
    #               {
    #                 value: "String",
    #               },
    #             ],
    #             phase_2_encryption_algorithms: [
    #               {
    #                 value: "String",
    #               },
    #             ],
    #             phase_1_integrity_algorithms: [
    #               {
    #                 value: "String",
    #               },
    #             ],
    #             phase_2_integrity_algorithms: [
    #               {
    #                 value: "String",
    #               },
    #             ],
    #             phase_1_dh_group_numbers: [
    #               {
    #                 value: 1,
    #               },
    #             ],
    #             phase_2_dh_group_numbers: [
    #               {
    #                 value: 1,
    #               },
    #             ],
    #             ike_versions: [
    #               {
    #                 value: "String",
    #               },
    #             ],
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] enable_acceleration
    #   Indicate whether to enable acceleration for the VPN connection.
    #
    #   Default: `false`
    #   @return [Boolean]
    #
    # @!attribute [rw] static_routes_only
    #   Indicate whether the VPN connection uses static routes only. If you
    #   are creating a VPN connection for a device that does not support
    #   BGP, you must specify `true`. Use CreateVpnConnectionRoute to create
    #   a static route.
    #
    #   Default: `false`
    #   @return [Boolean]
    #
    # @!attribute [rw] tunnel_options
    #   The tunnel options for the VPN connection.
    #   @return [Array<Types::VpnTunnelOptionsSpecification>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpnConnectionOptionsSpecification AWS API Documentation
    #
    class VpnConnectionOptionsSpecification < Struct.new(
      :enable_acceleration,
      :static_routes_only,
      :tunnel_options)
      include Aws::Structure
    end

    # Describes a virtual private gateway.
    #
    # @!attribute [rw] availability_zone
    #   The Availability Zone where the virtual private gateway was created,
    #   if applicable. This field may be empty or not returned.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The current state of the virtual private gateway.
    #   @return [String]
    #
    # @!attribute [rw] type
    #   The type of VPN connection the virtual private gateway supports.
    #   @return [String]
    #
    # @!attribute [rw] vpc_attachments
    #   Any VPCs attached to the virtual private gateway.
    #   @return [Array<Types::VpcAttachment>]
    #
    # @!attribute [rw] vpn_gateway_id
    #   The ID of the virtual private gateway.
    #   @return [String]
    #
    # @!attribute [rw] amazon_side_asn
    #   The private Autonomous System Number (ASN) for the Amazon side of a
    #   BGP session.
    #   @return [Integer]
    #
    # @!attribute [rw] tags
    #   Any tags assigned to the virtual private gateway.
    #   @return [Array<Types::Tag>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpnGateway AWS API Documentation
    #
    class VpnGateway < Struct.new(
      :availability_zone,
      :state,
      :type,
      :vpc_attachments,
      :vpn_gateway_id,
      :amazon_side_asn,
      :tags)
      include Aws::Structure
    end

    # Describes a static route for a VPN connection.
    #
    # @!attribute [rw] destination_cidr_block
    #   The CIDR block associated with the local subnet of the customer data
    #   center.
    #   @return [String]
    #
    # @!attribute [rw] source
    #   Indicates how the routes were provided.
    #   @return [String]
    #
    # @!attribute [rw] state
    #   The current state of the static route.
    #   @return [String]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpnStaticRoute AWS API Documentation
    #
    class VpnStaticRoute < Struct.new(
      :destination_cidr_block,
      :source,
      :state)
      include Aws::Structure
    end

    # The tunnel options for a single VPN tunnel.
    #
    # @note When making an API call, you may pass VpnTunnelOptionsSpecification
    #   data as a hash:
    #
    #       {
    #         tunnel_inside_cidr: "String",
    #         pre_shared_key: "String",
    #         phase_1_lifetime_seconds: 1,
    #         phase_2_lifetime_seconds: 1,
    #         rekey_margin_time_seconds: 1,
    #         rekey_fuzz_percentage: 1,
    #         replay_window_size: 1,
    #         dpd_timeout_seconds: 1,
    #         phase_1_encryption_algorithms: [
    #           {
    #             value: "String",
    #           },
    #         ],
    #         phase_2_encryption_algorithms: [
    #           {
    #             value: "String",
    #           },
    #         ],
    #         phase_1_integrity_algorithms: [
    #           {
    #             value: "String",
    #           },
    #         ],
    #         phase_2_integrity_algorithms: [
    #           {
    #             value: "String",
    #           },
    #         ],
    #         phase_1_dh_group_numbers: [
    #           {
    #             value: 1,
    #           },
    #         ],
    #         phase_2_dh_group_numbers: [
    #           {
    #             value: 1,
    #           },
    #         ],
    #         ike_versions: [
    #           {
    #             value: "String",
    #           },
    #         ],
    #       }
    #
    # @!attribute [rw] tunnel_inside_cidr
    #   The range of inside IP addresses for the tunnel. Any specified CIDR
    #   blocks must be unique across all VPN connections that use the same
    #   virtual private gateway.
    #
    #   Constraints: A size /30 CIDR block from the `169.254.0.0/16` range.
    #   The following CIDR blocks are reserved and cannot be used:
    #
    #   * `169.254.0.0/30`
    #
    #   * `169.254.1.0/30`
    #
    #   * `169.254.2.0/30`
    #
    #   * `169.254.3.0/30`
    #
    #   * `169.254.4.0/30`
    #
    #   * `169.254.5.0/30`
    #
    #   * `169.254.169.252/30`
    #   @return [String]
    #
    # @!attribute [rw] pre_shared_key
    #   The pre-shared key (PSK) to establish initial authentication between
    #   the virtual private gateway and customer gateway.
    #
    #   Constraints: Allowed characters are alphanumeric characters, periods
    #   (.), and underscores (\_). Must be between 8 and 64 characters in
    #   length and cannot start with zero (0).
    #   @return [String]
    #
    # @!attribute [rw] phase_1_lifetime_seconds
    #   The lifetime for phase 1 of the IKE negotiation, in seconds.
    #
    #   Constraints: A value between 900 and 28,800.
    #
    #   Default: `28800`
    #   @return [Integer]
    #
    # @!attribute [rw] phase_2_lifetime_seconds
    #   The lifetime for phase 2 of the IKE negotiation, in seconds.
    #
    #   Constraints: A value between 900 and 3,600. The value must be less
    #   than the value for `Phase1LifetimeSeconds`.
    #
    #   Default: `3600`
    #   @return [Integer]
    #
    # @!attribute [rw] rekey_margin_time_seconds
    #   The margin time, in seconds, before the phase 2 lifetime expires,
    #   during which the AWS side of the VPN connection performs an IKE
    #   rekey. The exact time of the rekey is randomly selected based on the
    #   value for `RekeyFuzzPercentage`.
    #
    #   Constraints: A value between 60 and half of `Phase2LifetimeSeconds`.
    #
    #   Default: `540`
    #   @return [Integer]
    #
    # @!attribute [rw] rekey_fuzz_percentage
    #   The percentage of the rekey window (determined by
    #   `RekeyMarginTimeSeconds`) during which the rekey time is randomly
    #   selected.
    #
    #   Constraints: A value between 0 and 100.
    #
    #   Default: `100`
    #   @return [Integer]
    #
    # @!attribute [rw] replay_window_size
    #   The number of packets in an IKE replay window.
    #
    #   Constraints: A value between 64 and 2048.
    #
    #   Default: `1024`
    #   @return [Integer]
    #
    # @!attribute [rw] dpd_timeout_seconds
    #   The number of seconds after which a DPD timeout occurs.
    #
    #   Constraints: A value between 0 and 30.
    #
    #   Default: `30`
    #   @return [Integer]
    #
    # @!attribute [rw] phase_1_encryption_algorithms
    #   One or more encryption algorithms that are permitted for the VPN
    #   tunnel for phase 1 IKE negotiations.
    #
    #   Valid values: `AES128` \| `AES256`
    #   @return [Array<Types::Phase1EncryptionAlgorithmsRequestListValue>]
    #
    # @!attribute [rw] phase_2_encryption_algorithms
    #   One or more encryption algorithms that are permitted for the VPN
    #   tunnel for phase 2 IKE negotiations.
    #
    #   Valid values: `AES128` \| `AES256`
    #   @return [Array<Types::Phase2EncryptionAlgorithmsRequestListValue>]
    #
    # @!attribute [rw] phase_1_integrity_algorithms
    #   One or more integrity algorithms that are permitted for the VPN
    #   tunnel for phase 1 IKE negotiations.
    #
    #   Valid values: `SHA1` \| `SHA2-256`
    #   @return [Array<Types::Phase1IntegrityAlgorithmsRequestListValue>]
    #
    # @!attribute [rw] phase_2_integrity_algorithms
    #   One or more integrity algorithms that are permitted for the VPN
    #   tunnel for phase 2 IKE negotiations.
    #
    #   Valid values: `SHA1` \| `SHA2-256`
    #   @return [Array<Types::Phase2IntegrityAlgorithmsRequestListValue>]
    #
    # @!attribute [rw] phase_1_dh_group_numbers
    #   One or more Diffie-Hellman group numbers that are permitted for the
    #   VPN tunnel for phase 1 IKE negotiations.
    #
    #   Valid values: `2` \| `14` \| `15` \| `16` \| `17` \| `18` \| `22` \|
    #   `23` \| `24`
    #   @return [Array<Types::Phase1DHGroupNumbersRequestListValue>]
    #
    # @!attribute [rw] phase_2_dh_group_numbers
    #   One or more Diffie-Hellman group numbers that are permitted for the
    #   VPN tunnel for phase 2 IKE negotiations.
    #
    #   Valid values: `2` \| `5` \| `14` \| `15` \| `16` \| `17` \| `18` \|
    #   `22` \| `23` \| `24`
    #   @return [Array<Types::Phase2DHGroupNumbersRequestListValue>]
    #
    # @!attribute [rw] ike_versions
    #   The IKE versions that are permitted for the VPN tunnel.
    #
    #   Valid values: `ikev1` \| `ikev2`
    #   @return [Array<Types::IKEVersionsRequestListValue>]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/VpnTunnelOptionsSpecification AWS API Documentation
    #
    class VpnTunnelOptionsSpecification < Struct.new(
      :tunnel_inside_cidr,
      :pre_shared_key,
      :phase_1_lifetime_seconds,
      :phase_2_lifetime_seconds,
      :rekey_margin_time_seconds,
      :rekey_fuzz_percentage,
      :replay_window_size,
      :dpd_timeout_seconds,
      :phase_1_encryption_algorithms,
      :phase_2_encryption_algorithms,
      :phase_1_integrity_algorithms,
      :phase_2_integrity_algorithms,
      :phase_1_dh_group_numbers,
      :phase_2_dh_group_numbers,
      :ike_versions)
      include Aws::Structure
    end

    # @note When making an API call, you may pass WithdrawByoipCidrRequest
    #   data as a hash:
    #
    #       {
    #         cidr: "String", # required
    #         dry_run: false,
    #       }
    #
    # @!attribute [rw] cidr
    #   The address range, in CIDR notation.
    #   @return [String]
    #
    # @!attribute [rw] dry_run
    #   Checks whether you have the required permissions for the action,
    #   without actually making the request, and provides an error response.
    #   If you have the required permissions, the error response is
    #   `DryRunOperation`. Otherwise, it is `UnauthorizedOperation`.
    #   @return [Boolean]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/WithdrawByoipCidrRequest AWS API Documentation
    #
    class WithdrawByoipCidrRequest < Struct.new(
      :cidr,
      :dry_run)
      include Aws::Structure
    end

    # @!attribute [rw] byoip_cidr
    #   Information about the address pool.
    #   @return [Types::ByoipCidr]
    #
    # @see http://docs.aws.amazon.com/goto/WebAPI/ec2-2016-11-15/WithdrawByoipCidrResult AWS API Documentation
    #
    class WithdrawByoipCidrResult < Struct.new(
      :byoip_cidr)
      include Aws::Structure
    end

  end
end
